
//-------------------------------------------------------------------------
//   Copyright 2002-2018 National Technology & Engineering Solutions of
//   Sandia, LLC (NTESS).  Under the terms of Contract DE-NA0003525 with
//   NTESS, the U.S. Government retains certain rights in this software.
//
//   This file is part of the Xyce(TM) Parallel Electrical Simulator.
//
//   Xyce(TM) is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   Xyce(TM) is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with Xyce(TM).
//   If not, see <http://www.gnu.org/licenses/>.
//-------------------------------------------------------------------------


//-------------------------------------------------------------------------
//
// Purpose        :
//
// Special Notes  : Generated from verilog file fbhhbt-2.1_nonoise_limited_inductors_typed.va with ADMS
//                  interface for Xyce 6.9.0
//                  DO NOT EDIT THIS FILE DIRECTLY!  It may be overwritten!
//
// Creator        : admsXml-2.3.6
//
// Creation Date  : Wed, 28 Mar 2018 12:13:39
//
//-------------------------------------------------------------------------
// Shut up clang's warnings about extraneous parentheses
#ifdef __clang__
#  pragma clang diagnostic ignored "-Wparentheses-equality"
#endif

#include <Xyce_config.h>
#include <N_DEV_ADMSHBT_X.h>


#include <N_DEV_Const.h>
#include <N_DEV_DeviceOptions.h>
#include <N_DEV_DeviceMaster.h>
#include <N_DEV_ExternData.h>
#include <N_DEV_SolverState.h>
#include <N_DEV_Message.h>

#include <N_LAS_Matrix.h>
#include <N_LAS_Vector.h>


#include <N_UTL_FeatureTest.h>
#if defined(HAVE_UNORDERED_MAP)
#include <unordered_map>
using std::unordered_map;
#elif defined(HAVE_TR1_UNORDERED_MAP)
#include <tr1/unordered_map>
using std::tr1::unordered_map;
#else
#error neither unordered_map or tr1/unordered_map found
#endif

namespace Xyce {
namespace Device {
namespace ADMSHBT_X {
JacobianStamp Instance::jacStamp;
IdVector Instance::nodeMap;
PairMap Instance::pairToJacStampMap;


//This is necessary because the IntPair usage can trip undefined references
const int Instance::admsNodeID_c;
const int Instance::admsNodeID_b;
const int Instance::admsNodeID_e;
const int Instance::admsNodeID_t;
const int Instance::admsNodeID_ei;
const int Instance::admsNodeID_bi;
const int Instance::admsNodeID_bii;
const int Instance::admsNodeID_ci;
const int Instance::admsNodeID_ti;
const int Instance::admsNodeID_ex;
const int Instance::admsNodeID_exx;
const int Instance::admsNodeID_cx;
const int Instance::admsNodeID_GND;
// Additional IDs for branch equations
const int Instance::admsBRA_ID_b_bi;
const int Instance::admsBRA_ID_e_ei;
const int Instance::admsBRA_ID_c_ci;


void
Traits::loadInstanceParameters(ParametricData<ADMSHBT_X::Instance> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have an instance parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSINSTTEMP", 0.0, &ADMSHBT_X::Instance::admsInstTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device instance temperature");
  p.addPar("TEMP", static_cast<double>(25.0), &ADMSHBT_X::Instance::Temp)
    .setUnit(U_DEGC)
    .setDescription("Device operating temperature")
    .setAutoConvertTemperature(false)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("N", static_cast<int>(1), &ADMSHBT_X::Instance::N)
    .setUnit(U_NONE)
    .setDescription("Number of emitter fingers");
  p.addPar("L", static_cast<double>(30*1.0e-6), &ADMSHBT_X::Instance::L)
    .setUnit(U_METER)
    .setDescription("Length of emitter fingers")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("W", static_cast<double>(3*1.0e-6), &ADMSHBT_X::Instance::W)
    .setUnit(U_METER)
    .setDescription("Width of emitter fingers")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;


}

void Traits::loadModelParameters(ParametricData<ADMSHBT_X::Model> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have a model parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSMODTEMP", 0.0, &ADMSHBT_X::Model::admsModTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device model temperature");
  p.addPar("MODE", static_cast<int>(1), &ADMSHBT_X::Model::Mode);
  p.addPar("NOISE", static_cast<int>(1), &ADMSHBT_X::Model::Noise);
  p.addPar("DEBUG", static_cast<int>(0), &ADMSHBT_X::Model::Debug);
  p.addPar("DEBUGPLUS", static_cast<int>(0), &ADMSHBT_X::Model::DebugPlus);
  p.addPar("TEMP", static_cast<double>(25.0), &ADMSHBT_X::Model::Temp)
    .setUnit(U_DEGC)
    .setDescription("Device operating temperature")
    .setAutoConvertTemperature(false)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RTH", static_cast<double>(0.1), &ADMSHBT_X::Model::Rth)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTH", static_cast<double>(700*1.0e-9), &ADMSHBT_X::Model::Cth)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("N", static_cast<int>(1), &ADMSHBT_X::Model::N)
    .setUnit(U_NONE)
    .setDescription("Number of emitter fingers");
  p.addPar("L", static_cast<double>(30*1.0e-6), &ADMSHBT_X::Model::L)
    .setUnit(U_METER)
    .setDescription("Length of emitter fingers")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("W", static_cast<double>(3*1.0e-6), &ADMSHBT_X::Model::W)
    .setUnit(U_METER)
    .setDescription("Width of emitter fingers")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JSF", static_cast<double>(20e-24), &ADMSHBT_X::Model::Jsf)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NF", static_cast<double>(1.0), &ADMSHBT_X::Model::nf)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VG", static_cast<double>(1.3), &ADMSHBT_X::Model::Vg)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JSE", static_cast<double>(0.0), &ADMSHBT_X::Model::Jse)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NE", static_cast<double>(0.0), &ADMSHBT_X::Model::ne)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBXX", static_cast<double>(1e6), &ADMSHBT_X::Model::Rbxx)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VGB", static_cast<double>(0.0), &ADMSHBT_X::Model::Vgb)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JSEE", static_cast<double>(0.0), &ADMSHBT_X::Model::Jsee)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NEE", static_cast<double>(0.0), &ADMSHBT_X::Model::nee)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBBXX", static_cast<double>(1e6), &ADMSHBT_X::Model::Rbbxx)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VGBB", static_cast<double>(0.0), &ADMSHBT_X::Model::Vgbb)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JSR", static_cast<double>(20e-18), &ADMSHBT_X::Model::Jsr)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NR", static_cast<double>(1.0), &ADMSHBT_X::Model::nr)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VGR", static_cast<double>(0.0), &ADMSHBT_X::Model::Vgr)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XCJC", static_cast<double>(0.5), &ADMSHBT_X::Model::XCjc)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JSC", static_cast<double>(0.0), &ADMSHBT_X::Model::Jsc)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NC", static_cast<double>(0.0), &ADMSHBT_X::Model::nc)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RCXX", static_cast<double>(1e6), &ADMSHBT_X::Model::Rcxx)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VGC", static_cast<double>(0.0), &ADMSHBT_X::Model::Vgc)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BF", static_cast<double>(100.0), &ADMSHBT_X::Model::Bf)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KBETA", static_cast<double>(0.0), &ADMSHBT_X::Model::kBeta)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BR", static_cast<double>(1.0), &ADMSHBT_X::Model::Br)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VAF", static_cast<double>(0.0), &ADMSHBT_X::Model::VAF)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VAR", static_cast<double>(0.0), &ADMSHBT_X::Model::VAR)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IKF", static_cast<double>(0.0), &ADMSHBT_X::Model::IKF)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IKR", static_cast<double>(0.0), &ADMSHBT_X::Model::IKR)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MC", static_cast<double>(0.0), &ADMSHBT_X::Model::Mc)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BVCEO", static_cast<double>(0.0), &ADMSHBT_X::Model::BVceo)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KC", static_cast<double>(0.0), &ADMSHBT_X::Model::kc)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BVEBO", static_cast<double>(0.0), &ADMSHBT_X::Model::BVebo)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TR", static_cast<double>(1*1.0e-15), &ADMSHBT_X::Model::Tr)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TRX", static_cast<double>(1*1.0e-15), &ADMSHBT_X::Model::Trx)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TF", static_cast<double>(1*1.0e-12), &ADMSHBT_X::Model::Tf)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TFT", static_cast<double>(0.0), &ADMSHBT_X::Model::Tft)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("THCS", static_cast<double>(0.0), &ADMSHBT_X::Model::Thcs)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AHC", static_cast<double>(0.0), &ADMSHBT_X::Model::Ahc)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJE", static_cast<double>(1*1.0e-15), &ADMSHBT_X::Model::Cje)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MJE", static_cast<double>(0.5), &ADMSHBT_X::Model::mje)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VJE", static_cast<double>(1.3), &ADMSHBT_X::Model::Vje)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJC", static_cast<double>(1*1.0e-15), &ADMSHBT_X::Model::Cjc)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MJC", static_cast<double>(0.5), &ADMSHBT_X::Model::mjc)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VJC", static_cast<double>(1.3), &ADMSHBT_X::Model::Vjc)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KJC", static_cast<double>(1.0), &ADMSHBT_X::Model::kjc)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CMIN", static_cast<double>(0.1*1.0e-15), &ADMSHBT_X::Model::Cmin)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("J0", static_cast<double>(1e-3), &ADMSHBT_X::Model::J0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XJ0", static_cast<double>(1.0), &ADMSHBT_X::Model::XJ0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RCI0", static_cast<double>(1e-3), &ADMSHBT_X::Model::Rci0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JK", static_cast<double>(4e-4), &ADMSHBT_X::Model::Jk)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RJK", static_cast<double>(1e-3), &ADMSHBT_X::Model::RJk)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VCES", static_cast<double>(1e-3), &ADMSHBT_X::Model::Vces)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RC", static_cast<double>(1.0), &ADMSHBT_X::Model::Rc)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RE", static_cast<double>(1.0), &ADMSHBT_X::Model::Re)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RB", static_cast<double>(1.0), &ADMSHBT_X::Model::Rb)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RB2", static_cast<double>(1.0), &ADMSHBT_X::Model::Rb2)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LC", static_cast<double>(0.0), &ADMSHBT_X::Model::Lc)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LE", static_cast<double>(0.0), &ADMSHBT_X::Model::Le)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LB", static_cast<double>(0.0), &ADMSHBT_X::Model::Lb)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CQ", static_cast<double>(0.0), &ADMSHBT_X::Model::Cq)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CPB", static_cast<double>(0.0), &ADMSHBT_X::Model::Cpb)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CPC", static_cast<double>(0.0), &ADMSHBT_X::Model::Cpc)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TNOM", static_cast<double>(20.0), &ADMSHBT_X::Model::Tnom)
    .setAutoConvertTemperature(false)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  //Hidden parameter dtype

}

//-----------------------------------------------------------------------------
// Function      : Instance::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::processParams()
{
  // set any non-constant parameter defaults

  // copy any model variables that have associated instance variables, but
  // are only given in the model card:
  if (!(given("Temp")))
  {
    Temp = model_.Temp;
  }
  if (!(given("N")))
  {
    N = model_.N;
  }
  if (!(given("L")))
  {
    L = model_.L;
  }
  if (!(given("W")))
  {
    W = model_.W;
  }



  // Set any parameters that were not given and whose defaults depend on other
  // parameters:


  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

  //    Parameter Temp : [ (-273.15),  (+inf) [
  if ( (!((Temp >=(-273.15)))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Temp value " << Temp << " out of range [ (-273.15),  (+inf) [";
  }

  //    Parameter N : ] 0,  (+inf) [
  if ( (!((N >0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter N value " << N << " out of range ] 0,  (+inf) [";
  }

  //    Parameter L : ] 0.0,  (+inf) [
  if ( (!((L >0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter L value " << L << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter W : ] 0.0,  (+inf) [
  if ( (!((W >0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter W value " << W << " out of range ] 0.0,  (+inf) [";
  }


  // this seems a little stupid, but verilog models that use $temperature
  // don't also use a defined parameter "Temp", and count on $temperature
  // to be the one the simulator wants:

  updateTemperature(admsInstTemp);

  // and of course, this routine is where we should put the initial_instance
  // stuff


  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::Instance
// Purpose       : "instance block" constructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------

Instance::Instance(
   const Configuration & configuration,
   const InstanceBlock & instance_block,
   Model &               model,
   const FactoryBlock &  factory_block)
  : DeviceInstance(instance_block, configuration.getInstanceParameters(), factory_block),
    model_(model),
    Temp(25.0),
    N(1),
    L(30*1.0e-6),
    W(3*1.0e-6),
    li_c(-1),
    li_b(-1),
    li_e(-1),
    li_t(-1),
    li_ei(-1),
    li_bi(-1),
    li_bii(-1),
    li_ci(-1),
    li_ti(-1),
    li_ex(-1),
    li_exx(-1),
    li_cx(-1),
    li_BRA_b_bi(-1),
    li_BRA_e_ei(-1),
    li_BRA_c_ci(-1),
    li_branch_ic(-1),
    li_branch_ib(-1),
    li_branch_ie(-1),
    li_branch_it(-1),
    f_bi_Equ_ti_Node_Ptr(0),
    f_ci_Equ_ti_Node_Ptr(0),
    f_bi_Equ_bi_Node_Ptr(0),
    f_bi_Equ_ci_Node_Ptr(0),
    f_ci_Equ_bi_Node_Ptr(0),
    f_ci_Equ_ci_Node_Ptr(0),
    f_bii_Equ_ti_Node_Ptr(0),
    f_bii_Equ_bii_Node_Ptr(0),
    f_bii_Equ_ci_Node_Ptr(0),
    f_ci_Equ_bii_Node_Ptr(0),
    f_bii_Equ_ei_Node_Ptr(0),
    f_ci_Equ_ei_Node_Ptr(0),
    f_ei_Equ_bii_Node_Ptr(0),
    f_ei_Equ_ci_Node_Ptr(0),
    f_ei_Equ_ti_Node_Ptr(0),
    f_ei_Equ_ei_Node_Ptr(0),
    f_ex_Equ_ti_Node_Ptr(0),
    f_ex_Equ_ex_Node_Ptr(0),
    f_ex_Equ_ei_Node_Ptr(0),
    f_ei_Equ_ex_Node_Ptr(0),
    f_exx_Equ_ti_Node_Ptr(0),
    f_exx_Equ_exx_Node_Ptr(0),
    f_exx_Equ_ei_Node_Ptr(0),
    f_ei_Equ_exx_Node_Ptr(0),
    f_cx_Equ_ti_Node_Ptr(0),
    f_cx_Equ_cx_Node_Ptr(0),
    f_cx_Equ_ci_Node_Ptr(0),
    f_ci_Equ_cx_Node_Ptr(0),
    f_bii_Equ_bi_Node_Ptr(0),
    f_bi_Equ_bii_Node_Ptr(0),
    f_ex_Equ_bii_Node_Ptr(0),
    f_bii_Equ_ex_Node_Ptr(0),
    f_exx_Equ_bii_Node_Ptr(0),
    f_bii_Equ_exx_Node_Ptr(0),
    f_cx_Equ_bii_Node_Ptr(0),
    f_bii_Equ_cx_Node_Ptr(0),
    f_b_Equ_b_Node_Ptr(0),
    f_c_Equ_c_Node_Ptr(0),
    f_b_Equ_c_Node_Ptr(0),
    f_c_Equ_b_Node_Ptr(0),
    f_ti_Equ_bi_Node_Ptr(0),
    f_ti_Equ_ci_Node_Ptr(0),
    f_ti_Equ_ei_Node_Ptr(0),
    f_ti_Equ_bii_Node_Ptr(0),
    f_ti_Equ_ti_Node_Ptr(0),
    f_t_Equ_t_Node_Ptr(0),
    f_t_Equ_ti_Node_Ptr(0),
    f_ti_Equ_t_Node_Ptr(0),
    f_c_Equ_BRA_c_ci_Var_Ptr(0),
    f_b_Equ_BRA_b_bi_Var_Ptr(0),
    f_e_Equ_BRA_e_ei_Var_Ptr(0),
    f_ei_Equ_BRA_e_ei_Var_Ptr(0),
    f_bi_Equ_BRA_b_bi_Var_Ptr(0),
    f_ci_Equ_BRA_c_ci_Var_Ptr(0),
    f_BRA_b_bi_Equ_b_Node_Ptr(0),
    f_BRA_b_bi_Equ_bi_Node_Ptr(0),
    f_BRA_b_bi_Equ_BRA_b_bi_Var_Ptr(0),
    f_BRA_e_ei_Equ_e_Node_Ptr(0),
    f_BRA_e_ei_Equ_ei_Node_Ptr(0),
    f_BRA_e_ei_Equ_BRA_e_ei_Var_Ptr(0),
    f_BRA_c_ci_Equ_c_Node_Ptr(0),
    f_BRA_c_ci_Equ_ci_Node_Ptr(0),
    f_BRA_c_ci_Equ_BRA_c_ci_Var_Ptr(0),
    q_bi_Equ_ti_Node_Ptr(0),
    q_ci_Equ_ti_Node_Ptr(0),
    q_bi_Equ_bi_Node_Ptr(0),
    q_bi_Equ_ci_Node_Ptr(0),
    q_ci_Equ_bi_Node_Ptr(0),
    q_ci_Equ_ci_Node_Ptr(0),
    q_bii_Equ_ti_Node_Ptr(0),
    q_bii_Equ_bii_Node_Ptr(0),
    q_bii_Equ_ci_Node_Ptr(0),
    q_ci_Equ_bii_Node_Ptr(0),
    q_bii_Equ_ei_Node_Ptr(0),
    q_ci_Equ_ei_Node_Ptr(0),
    q_ei_Equ_bii_Node_Ptr(0),
    q_ei_Equ_ci_Node_Ptr(0),
    q_ei_Equ_ti_Node_Ptr(0),
    q_ei_Equ_ei_Node_Ptr(0),
    q_ex_Equ_ti_Node_Ptr(0),
    q_ex_Equ_ex_Node_Ptr(0),
    q_ex_Equ_ei_Node_Ptr(0),
    q_ei_Equ_ex_Node_Ptr(0),
    q_exx_Equ_ti_Node_Ptr(0),
    q_exx_Equ_exx_Node_Ptr(0),
    q_exx_Equ_ei_Node_Ptr(0),
    q_ei_Equ_exx_Node_Ptr(0),
    q_cx_Equ_ti_Node_Ptr(0),
    q_cx_Equ_cx_Node_Ptr(0),
    q_cx_Equ_ci_Node_Ptr(0),
    q_ci_Equ_cx_Node_Ptr(0),
    q_bii_Equ_bi_Node_Ptr(0),
    q_bi_Equ_bii_Node_Ptr(0),
    q_ex_Equ_bii_Node_Ptr(0),
    q_bii_Equ_ex_Node_Ptr(0),
    q_exx_Equ_bii_Node_Ptr(0),
    q_bii_Equ_exx_Node_Ptr(0),
    q_cx_Equ_bii_Node_Ptr(0),
    q_bii_Equ_cx_Node_Ptr(0),
    q_b_Equ_b_Node_Ptr(0),
    q_c_Equ_c_Node_Ptr(0),
    q_b_Equ_c_Node_Ptr(0),
    q_c_Equ_b_Node_Ptr(0),
    q_ti_Equ_bi_Node_Ptr(0),
    q_ti_Equ_ci_Node_Ptr(0),
    q_ti_Equ_ei_Node_Ptr(0),
    q_ti_Equ_bii_Node_Ptr(0),
    q_ti_Equ_ti_Node_Ptr(0),
    q_t_Equ_t_Node_Ptr(0),
    q_t_Equ_ti_Node_Ptr(0),
    q_ti_Equ_t_Node_Ptr(0),
    q_c_Equ_BRA_c_ci_Var_Ptr(0),
    q_b_Equ_BRA_b_bi_Var_Ptr(0),
    q_e_Equ_BRA_e_ei_Var_Ptr(0),
    q_ei_Equ_BRA_e_ei_Var_Ptr(0),
    q_bi_Equ_BRA_b_bi_Var_Ptr(0),
    q_ci_Equ_BRA_c_ci_Var_Ptr(0),
    q_BRA_b_bi_Equ_b_Node_Ptr(0),
    q_BRA_b_bi_Equ_bi_Node_Ptr(0),
    q_BRA_b_bi_Equ_BRA_b_bi_Var_Ptr(0),
    q_BRA_e_ei_Equ_e_Node_Ptr(0),
    q_BRA_e_ei_Equ_ei_Node_Ptr(0),
    q_BRA_e_ei_Equ_BRA_e_ei_Var_Ptr(0),
    q_BRA_c_ci_Equ_c_Node_Ptr(0),
    q_BRA_c_ci_Equ_ci_Node_Ptr(0),
    q_BRA_c_ci_Equ_BRA_c_ci_Var_Ptr(0),
    A_bi_Equ_ti_NodeOffset(-1),
    A_ci_Equ_ti_NodeOffset(-1),
    A_bi_Equ_bi_NodeOffset(-1),
    A_bi_Equ_ci_NodeOffset(-1),
    A_ci_Equ_bi_NodeOffset(-1),
    A_ci_Equ_ci_NodeOffset(-1),
    A_bii_Equ_ti_NodeOffset(-1),
    A_bii_Equ_bii_NodeOffset(-1),
    A_bii_Equ_ci_NodeOffset(-1),
    A_ci_Equ_bii_NodeOffset(-1),
    A_bii_Equ_ei_NodeOffset(-1),
    A_ci_Equ_ei_NodeOffset(-1),
    A_ei_Equ_bii_NodeOffset(-1),
    A_ei_Equ_ci_NodeOffset(-1),
    A_ei_Equ_ti_NodeOffset(-1),
    A_ei_Equ_ei_NodeOffset(-1),
    A_ex_Equ_ti_NodeOffset(-1),
    A_ex_Equ_ex_NodeOffset(-1),
    A_ex_Equ_ei_NodeOffset(-1),
    A_ei_Equ_ex_NodeOffset(-1),
    A_exx_Equ_ti_NodeOffset(-1),
    A_exx_Equ_exx_NodeOffset(-1),
    A_exx_Equ_ei_NodeOffset(-1),
    A_ei_Equ_exx_NodeOffset(-1),
    A_cx_Equ_ti_NodeOffset(-1),
    A_cx_Equ_cx_NodeOffset(-1),
    A_cx_Equ_ci_NodeOffset(-1),
    A_ci_Equ_cx_NodeOffset(-1),
    A_bii_Equ_bi_NodeOffset(-1),
    A_bi_Equ_bii_NodeOffset(-1),
    A_ex_Equ_bii_NodeOffset(-1),
    A_bii_Equ_ex_NodeOffset(-1),
    A_exx_Equ_bii_NodeOffset(-1),
    A_bii_Equ_exx_NodeOffset(-1),
    A_cx_Equ_bii_NodeOffset(-1),
    A_bii_Equ_cx_NodeOffset(-1),
    A_b_Equ_b_NodeOffset(-1),
    A_c_Equ_c_NodeOffset(-1),
    A_b_Equ_c_NodeOffset(-1),
    A_c_Equ_b_NodeOffset(-1),
    A_ti_Equ_bi_NodeOffset(-1),
    A_ti_Equ_ci_NodeOffset(-1),
    A_ti_Equ_ei_NodeOffset(-1),
    A_ti_Equ_bii_NodeOffset(-1),
    A_ti_Equ_ti_NodeOffset(-1),
    A_t_Equ_t_NodeOffset(-1),
    A_t_Equ_ti_NodeOffset(-1),
    A_ti_Equ_t_NodeOffset(-1),
    A_c_Equ_BRA_c_ci_Var_Offset(-1),
    A_b_Equ_BRA_b_bi_Var_Offset(-1),
    A_e_Equ_BRA_e_ei_Var_Offset(-1),
    A_ei_Equ_BRA_e_ei_Var_Offset(-1),
    A_bi_Equ_BRA_b_bi_Var_Offset(-1),
    A_ci_Equ_BRA_c_ci_Var_Offset(-1),
    A_BRA_b_bi_Equ_b_Node_Offset(-1),
    A_BRA_b_bi_Equ_bi_Node_Offset(-1),
    A_BRA_b_bi_Equ_BRA_b_bi_Var_Offset(-1),
    A_BRA_e_ei_Equ_e_Node_Offset(-1),
    A_BRA_e_ei_Equ_ei_Node_Offset(-1),
    A_BRA_e_ei_Equ_BRA_e_ei_Var_Offset(-1),
    A_BRA_c_ci_Equ_c_Node_Offset(-1),
    A_BRA_c_ci_Equ_ci_Node_Offset(-1),
    A_BRA_c_ci_Equ_BRA_c_ci_Var_Offset(-1),
    admsTemperature(getDeviceOptions().temp.getImmutableValue<double>())

{
  numIntVars = 8 + 3;
  numExtVars = 4;


  // Right now, we only have store for limited probes...
  setNumStoreVars(3);

  // Do not allocate "branch" (lead current) vectors by default
  setNumBranchDataVars(0);
  numBranchDataVarsIfAllocated = 4;

  leadCurrentF.resize(4);
  leadCurrentQ.resize(4);
  
  // Set up jacobian stamp:
  // Create a vector of the non-zero elements of the stamp
  PairVector jacobianElements;
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_b));
  // Extra columns for dependence on branches
  jacobianElements.push_back(IntPair(admsNodeID_c,admsBRA_ID_c_ci));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_c));
  // Extra columns for dependence on branches
  jacobianElements.push_back(IntPair(admsNodeID_b,admsBRA_ID_b_bi));
  // Extra columns for dependence on branches
  jacobianElements.push_back(IntPair(admsNodeID_e,admsBRA_ID_e_ei));
  jacobianElements.push_back(IntPair(admsNodeID_t,admsNodeID_t));
  jacobianElements.push_back(IntPair(admsNodeID_t,admsNodeID_ti));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_bii));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_ti));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_ex));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_exx));
  // Extra columns for dependence on branches
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsBRA_ID_e_ei));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_ti));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_bii));
  // Extra columns for dependence on branches
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsBRA_ID_b_bi));
  jacobianElements.push_back(IntPair(admsNodeID_bii,admsNodeID_ti));
  jacobianElements.push_back(IntPair(admsNodeID_bii,admsNodeID_bii));
  jacobianElements.push_back(IntPair(admsNodeID_bii,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_bii,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_bii,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_bii,admsNodeID_ex));
  jacobianElements.push_back(IntPair(admsNodeID_bii,admsNodeID_exx));
  jacobianElements.push_back(IntPair(admsNodeID_bii,admsNodeID_cx));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_ti));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_bii));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_cx));
  // Extra columns for dependence on branches
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsBRA_ID_c_ci));
  jacobianElements.push_back(IntPair(admsNodeID_ti,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_ti,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_ti,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_ti,admsNodeID_bii));
  jacobianElements.push_back(IntPair(admsNodeID_ti,admsNodeID_ti));
  jacobianElements.push_back(IntPair(admsNodeID_ti,admsNodeID_t));
  jacobianElements.push_back(IntPair(admsNodeID_ex,admsNodeID_ti));
  jacobianElements.push_back(IntPair(admsNodeID_ex,admsNodeID_ex));
  jacobianElements.push_back(IntPair(admsNodeID_ex,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_ex,admsNodeID_bii));
  jacobianElements.push_back(IntPair(admsNodeID_exx,admsNodeID_ti));
  jacobianElements.push_back(IntPair(admsNodeID_exx,admsNodeID_exx));
  jacobianElements.push_back(IntPair(admsNodeID_exx,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_exx,admsNodeID_bii));
  jacobianElements.push_back(IntPair(admsNodeID_cx,admsNodeID_ti));
  jacobianElements.push_back(IntPair(admsNodeID_cx,admsNodeID_cx));
  jacobianElements.push_back(IntPair(admsNodeID_cx,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_cx,admsNodeID_bii));
  // Jacobian rows for branch equations
  jacobianElements.push_back(IntPair(admsBRA_ID_b_bi,admsNodeID_b));   // Branch eqn b,bi - node b
  jacobianElements.push_back(IntPair(admsBRA_ID_b_bi,admsNodeID_bi));   // Branch eqn b,bi - node bi
  jacobianElements.push_back(IntPair(admsBRA_ID_b_bi,admsBRA_ID_b_bi)); // Branch eqn b,bi - branch var b,bi
  jacobianElements.push_back(IntPair(admsBRA_ID_e_ei,admsNodeID_e));   // Branch eqn e,ei - node e
  jacobianElements.push_back(IntPair(admsBRA_ID_e_ei,admsNodeID_ei));   // Branch eqn e,ei - node ei
  jacobianElements.push_back(IntPair(admsBRA_ID_e_ei,admsBRA_ID_e_ei)); // Branch eqn e,ei - branch var e,ei
  jacobianElements.push_back(IntPair(admsBRA_ID_c_ci,admsNodeID_c));   // Branch eqn c,ci - node c
  jacobianElements.push_back(IntPair(admsBRA_ID_c_ci,admsNodeID_ci));   // Branch eqn c,ci - node ci
  jacobianElements.push_back(IntPair(admsBRA_ID_c_ci,admsBRA_ID_c_ci)); // Branch eqn c,ci - branch var c,ci

  

  setDefaultParams();
  setParams(instance_block.params);

  // Real bogosity here...
  if (!given("XYCEADMSINSTTEMP"))
    admsInstTemp=getDeviceOptions().temp.getImmutableValue<double>();

  //calculate any parameters specified as expressions
  updateDependentParameters();

  // calculate dependent (i.e. computed params) and check for errors.
  processParams();

  PairVector collapsedNodes;

  // Now generate the jacstamp from what we already have.
  // This jacstamp will have all the correct node mapping.  map will be the nodal mapping of original
  // node IDs to row/column ids in the reduced (non-sparse) representation of the jacobian.
  // (for devices that have no collapsibles, this will be static, so check that it hasn't already
  // been filled in)
  if (jacStamp.empty())
  {
    int originalSize = 12+3;
    computeJacStampAndMaps(jacobianElements,collapsedNodes,jacStamp,nodeMap,pairToJacStampMap,originalSize);
  }

}

//-----------------------------------------------------------------------------
// Function      : Instance::~Instance
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
Instance::~Instance()
{
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerLIDs
// Purpose       : function for registering, and setting up, local ID's.
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerLIDs( const LocalIdVector & intLIDVecRef,
                             const LocalIdVector & extLIDVecRef)
{
  AssertLIDs(intLIDVecRef.size() == numIntVars);
  AssertLIDs(extLIDVecRef.size() == numExtVars);

  LocalIdVector localLIDVec;
  
  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << std::endl << section_divider << std::endl
                 << "In ADMSHBT_X::Instance::register LIDs\n\n"
                 << "name             = " << getName() << std::endl
                 << "number of internal variables: " << numIntVars << std::endl
                 << "number of external variables: " << numExtVars << std::endl;
  }

  // copy over the global ID lists into a local array.
  // The end result of this is an array of LIDs corresponding to all the
  // nodes we actually have, in the order that topology thinks of them
  intLIDVec = intLIDVecRef;
  extLIDVec = extLIDVecRef;
  localLIDVec.resize(numExtVars+numIntVars);
  for (int localNodeIndex=0;localNodeIndex<numExtVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=extLIDVec[localNodeIndex];
  }
  for (int localNodeIndex=numExtVars;localNodeIndex<numExtVars+numIntVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=intLIDVec[localNodeIndex-numExtVars];
  }
    
  // Now pull the LIDs for each of our nodes out of the local array.
  // Use the node mapping created by createJacStampAndMaps to handle
  // all the node collapse complications.
  li_c = localLIDVec[nodeMap[admsNodeID_c]];
  li_b = localLIDVec[nodeMap[admsNodeID_b]];
  li_e = localLIDVec[nodeMap[admsNodeID_e]];
  li_t = localLIDVec[nodeMap[admsNodeID_t]];
  li_ei = localLIDVec[nodeMap[admsNodeID_ei]];
  li_bi = localLIDVec[nodeMap[admsNodeID_bi]];
  li_bii = localLIDVec[nodeMap[admsNodeID_bii]];
  li_ci = localLIDVec[nodeMap[admsNodeID_ci]];
  li_ti = localLIDVec[nodeMap[admsNodeID_ti]];
  li_ex = localLIDVec[nodeMap[admsNodeID_ex]];
  li_exx = localLIDVec[nodeMap[admsNodeID_exx]];
  li_cx = localLIDVec[nodeMap[admsNodeID_cx]];
  li_BRA_b_bi = localLIDVec[nodeMap[admsBRA_ID_b_bi]];
  li_BRA_e_ei = localLIDVec[nodeMap[admsBRA_ID_e_ei]];
  li_BRA_c_ci = localLIDVec[nodeMap[admsBRA_ID_c_ci]];


  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << "\nSolution and RHS variables:\n";
    Xyce::dout() << "\nli_c = " << li_c << std::endl;
    Xyce::dout() << "\nli_b = " << li_b << std::endl;
    Xyce::dout() << "\nli_e = " << li_e << std::endl;
    Xyce::dout() << "\nli_t = " << li_t << std::endl;
    Xyce::dout() << "\nli_ei = " << li_ei << std::endl;
    Xyce::dout() << "\nli_bi = " << li_bi << std::endl;
    Xyce::dout() << "\nli_bii = " << li_bii << std::endl;
    Xyce::dout() << "\nli_ci = " << li_ci << std::endl;
    Xyce::dout() << "\nli_ti = " << li_ti << std::endl;
    Xyce::dout() << "\nli_ex = " << li_ex << std::endl;
    Xyce::dout() << "\nli_exx = " << li_exx << std::endl;
    Xyce::dout() << "\nli_cx = " << li_cx << std::endl;
    Xyce::dout() << "\nli_BRA_b_bi = " << li_BRA_b_bi << std::endl;
    Xyce::dout() << "\nli_BRA_e_ei = " << li_BRA_e_ei << std::endl;
    Xyce::dout() << "\nli_BRA_c_ci = " << li_BRA_c_ci << std::endl;

    Xyce::dout() << "\nEnd of ADMSHBT_X::Instance::register LIDs\n";
    Xyce::dout() << section_divider << std::endl;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadNodeSymbols
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::loadNodeSymbols(Util::SymbolTable &symbol_table) const
{
  addInternalNode(symbol_table, li_ei, getName(), "ei");
  addInternalNode(symbol_table, li_bi, getName(), "bi");
  addInternalNode(symbol_table, li_bii, getName(), "bii");
  addInternalNode(symbol_table, li_ci, getName(), "ci");
  addInternalNode(symbol_table, li_ti, getName(), "ti");
  addInternalNode(symbol_table, li_ex, getName(), "ex");
  addInternalNode(symbol_table, li_exx, getName(), "exx");
  addInternalNode(symbol_table, li_cx, getName(), "cx");
  addInternalNode(symbol_table, li_BRA_b_bi, getName(), "b_bi_branch");
  addInternalNode(symbol_table, li_BRA_e_ei, getName(), "e_ei_branch");
  addInternalNode(symbol_table, li_BRA_c_ci, getName(), "c_ci_branch");

  if (loadLeadCurrent)
  {
    addBranchDataNode( symbol_table, li_branch_ic, getName(), "BRANCH_DC");
    addBranchDataNode( symbol_table, li_branch_ib, getName(), "BRANCH_DB");
    addBranchDataNode( symbol_table, li_branch_ie, getName(), "BRANCH_DE");
    addBranchDataNode( symbol_table, li_branch_it, getName(), "BRANCH_D4");
  }
}
 
//-----------------------------------------------------------------------------
// Function      : Instance::registerStoreLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerStoreLIDs( const LocalIdVector & stoLIDVecRef)
{
  AssertLIDs(stoLIDVecRef.size() == getNumStoreVars());

  int numSto = stoLIDVecRef.size();
  if (numSto > 0)
  {
    int i=0;
    stoLIDVec = stoLIDVecRef;

    li_store_admsProbeID_V_bi_ci = stoLIDVec[i++];
    li_store_admsProbeID_V_bii_ci = stoLIDVec[i++];
    li_store_admsProbeID_V_bii_ei = stoLIDVec[i++];
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerBranchDataLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : Eric Keiter, SNL
// Creation Date : 12/09/11
//-----------------------------------------------------------------------------
void Instance::registerBranchDataLIDs(const std::vector<int> & branchLIDVecRef)
{
  AssertLIDs(branchLIDVecRef.size() == getNumBranchDataVars());

  if (loadLeadCurrent)
  {    
    int i = 0;
    li_branch_ic = branchLIDVecRef[i++];
    li_branch_ib = branchLIDVecRef[i++];
    li_branch_ie = branchLIDVecRef[i++];
    li_branch_it = branchLIDVecRef[i++];
  }
}
  
//-----------------------------------------------------------------------------
// Function      : Instance::jacobianStamp
// Purpose       :
// Special Notes : In initial version, we won't support mapping away nodes
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
const JacobianStamp & Instance::jacobianStamp() const
{
  return jacStamp;
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerJacLIDs
// Purpose       : Create Offset variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerJacLIDs( const JacobianStamp & jacLIDVec)
{
  DeviceInstance::registerJacLIDs(jacLIDVec);  IntPair jacLoc;
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_c)];
  A_c_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_b)];
  A_c_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc=pairToJacStampMap[IntPair(admsNodeID_c,admsBRA_ID_c_ci)];
  A_c_Equ_BRA_c_ci_Var_Offset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_b)];
  A_b_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_c)];
  A_b_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc=pairToJacStampMap[IntPair(admsNodeID_b,admsBRA_ID_b_bi)];
  A_b_Equ_BRA_b_bi_Var_Offset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc=pairToJacStampMap[IntPair(admsNodeID_e,admsBRA_ID_e_ei)];
  A_e_Equ_BRA_e_ei_Var_Offset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_t,admsNodeID_t)];
  A_t_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_t,admsNodeID_ti)];
  A_t_Equ_ti_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_bii)];
  A_ei_Equ_bii_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_ci)];
  A_ei_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_ti)];
  A_ei_Equ_ti_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_ei)];
  A_ei_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_ex)];
  A_ei_Equ_ex_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_exx)];
  A_ei_Equ_exx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc=pairToJacStampMap[IntPair(admsNodeID_ei,admsBRA_ID_e_ei)];
  A_ei_Equ_BRA_e_ei_Var_Offset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_ti)];
  A_bi_Equ_ti_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_bi)];
  A_bi_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_ci)];
  A_bi_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_bii)];
  A_bi_Equ_bii_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc=pairToJacStampMap[IntPair(admsNodeID_bi,admsBRA_ID_b_bi)];
  A_bi_Equ_BRA_b_bi_Var_Offset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bii,admsNodeID_ti)];
  A_bii_Equ_ti_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bii,admsNodeID_bii)];
  A_bii_Equ_bii_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bii,admsNodeID_ci)];
  A_bii_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bii,admsNodeID_ei)];
  A_bii_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bii,admsNodeID_bi)];
  A_bii_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bii,admsNodeID_ex)];
  A_bii_Equ_ex_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bii,admsNodeID_exx)];
  A_bii_Equ_exx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bii,admsNodeID_cx)];
  A_bii_Equ_cx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_ti)];
  A_ci_Equ_ti_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_bi)];
  A_ci_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_ci)];
  A_ci_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_bii)];
  A_ci_Equ_bii_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_ei)];
  A_ci_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_cx)];
  A_ci_Equ_cx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc=pairToJacStampMap[IntPair(admsNodeID_ci,admsBRA_ID_c_ci)];
  A_ci_Equ_BRA_c_ci_Var_Offset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ti,admsNodeID_bi)];
  A_ti_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ti,admsNodeID_ci)];
  A_ti_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ti,admsNodeID_ei)];
  A_ti_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ti,admsNodeID_bii)];
  A_ti_Equ_bii_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ti,admsNodeID_ti)];
  A_ti_Equ_ti_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ti,admsNodeID_t)];
  A_ti_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ex,admsNodeID_ti)];
  A_ex_Equ_ti_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ex,admsNodeID_ex)];
  A_ex_Equ_ex_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ex,admsNodeID_ei)];
  A_ex_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ex,admsNodeID_bii)];
  A_ex_Equ_bii_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_exx,admsNodeID_ti)];
  A_exx_Equ_ti_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_exx,admsNodeID_exx)];
  A_exx_Equ_exx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_exx,admsNodeID_ei)];
  A_exx_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_exx,admsNodeID_bii)];
  A_exx_Equ_bii_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_cx,admsNodeID_ti)];
  A_cx_Equ_ti_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_cx,admsNodeID_cx)];
  A_cx_Equ_cx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_cx,admsNodeID_ci)];
  A_cx_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_cx,admsNodeID_bii)];
  A_cx_Equ_bii_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsBRA_ID_b_bi,admsNodeID_b)];
  A_BRA_b_bi_Equ_b_Node_Offset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsBRA_ID_b_bi,admsNodeID_bi)];
  A_BRA_b_bi_Equ_bi_Node_Offset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsBRA_ID_b_bi,admsBRA_ID_b_bi)];
  A_BRA_b_bi_Equ_BRA_b_bi_Var_Offset=jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsBRA_ID_e_ei,admsNodeID_e)];
  A_BRA_e_ei_Equ_e_Node_Offset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsBRA_ID_e_ei,admsNodeID_ei)];
  A_BRA_e_ei_Equ_ei_Node_Offset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsBRA_ID_e_ei,admsBRA_ID_e_ei)];
  A_BRA_e_ei_Equ_BRA_e_ei_Var_Offset=jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsBRA_ID_c_ci,admsNodeID_c)];
  A_BRA_c_ci_Equ_c_Node_Offset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsBRA_ID_c_ci,admsNodeID_ci)];
  A_BRA_c_ci_Equ_ci_Node_Offset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsBRA_ID_c_ci,admsBRA_ID_c_ci)];
  A_BRA_c_ci_Equ_BRA_c_ci_Var_Offset=jacLIDVec[jacLoc.first][jacLoc.second];


}

//-----------------------------------------------------------------------------
// Function      : Instance::setupPointers
// Purpose       : Create pointer variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupPointers( )
{

  Linear::Matrix * dFdxMatPtr = extData.dFdxMatrixPtr;
  Linear::Matrix * dQdxMatPtr = extData.dQdxMatrixPtr;
  f_c_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c,li_c);
  q_c_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c,li_c);
  f_c_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c,li_b);
  q_c_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c,li_b);
  f_c_Equ_BRA_c_ci_Var_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c,li_BRA_c_ci);
  q_c_Equ_BRA_c_ci_Var_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c,li_BRA_c_ci);
  f_b_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_b);
  q_b_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_b);
  f_b_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_c);
  q_b_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_c);
  f_b_Equ_BRA_b_bi_Var_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_BRA_b_bi);
  q_b_Equ_BRA_b_bi_Var_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_BRA_b_bi);
  f_e_Equ_BRA_e_ei_Var_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e,li_BRA_e_ei);
  q_e_Equ_BRA_e_ei_Var_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e,li_BRA_e_ei);
  f_t_Equ_t_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_t,li_t);
  q_t_Equ_t_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_t,li_t);
  f_t_Equ_ti_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_t,li_ti);
  q_t_Equ_ti_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_t,li_ti);
  f_ei_Equ_bii_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ei,li_bii);
  q_ei_Equ_bii_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ei,li_bii);
  f_ei_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ei,li_ci);
  q_ei_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ei,li_ci);
  f_ei_Equ_ti_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ei,li_ti);
  q_ei_Equ_ti_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ei,li_ti);
  f_ei_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ei,li_ei);
  q_ei_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ei,li_ei);
  f_ei_Equ_ex_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ei,li_ex);
  q_ei_Equ_ex_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ei,li_ex);
  f_ei_Equ_exx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ei,li_exx);
  q_ei_Equ_exx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ei,li_exx);
  f_ei_Equ_BRA_e_ei_Var_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ei,li_BRA_e_ei);
  q_ei_Equ_BRA_e_ei_Var_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ei,li_BRA_e_ei);
  f_bi_Equ_ti_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bi,li_ti);
  q_bi_Equ_ti_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bi,li_ti);
  f_bi_Equ_bi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bi,li_bi);
  q_bi_Equ_bi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bi,li_bi);
  f_bi_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bi,li_ci);
  q_bi_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bi,li_ci);
  f_bi_Equ_bii_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bi,li_bii);
  q_bi_Equ_bii_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bi,li_bii);
  f_bi_Equ_BRA_b_bi_Var_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bi,li_BRA_b_bi);
  q_bi_Equ_BRA_b_bi_Var_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bi,li_BRA_b_bi);
  f_bii_Equ_ti_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bii,li_ti);
  q_bii_Equ_ti_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bii,li_ti);
  f_bii_Equ_bii_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bii,li_bii);
  q_bii_Equ_bii_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bii,li_bii);
  f_bii_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bii,li_ci);
  q_bii_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bii,li_ci);
  f_bii_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bii,li_ei);
  q_bii_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bii,li_ei);
  f_bii_Equ_bi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bii,li_bi);
  q_bii_Equ_bi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bii,li_bi);
  f_bii_Equ_ex_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bii,li_ex);
  q_bii_Equ_ex_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bii,li_ex);
  f_bii_Equ_exx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bii,li_exx);
  q_bii_Equ_exx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bii,li_exx);
  f_bii_Equ_cx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bii,li_cx);
  q_bii_Equ_cx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bii,li_cx);
  f_ci_Equ_ti_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ci,li_ti);
  q_ci_Equ_ti_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ci,li_ti);
  f_ci_Equ_bi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ci,li_bi);
  q_ci_Equ_bi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ci,li_bi);
  f_ci_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ci,li_ci);
  q_ci_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ci,li_ci);
  f_ci_Equ_bii_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ci,li_bii);
  q_ci_Equ_bii_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ci,li_bii);
  f_ci_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ci,li_ei);
  q_ci_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ci,li_ei);
  f_ci_Equ_cx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ci,li_cx);
  q_ci_Equ_cx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ci,li_cx);
  f_ci_Equ_BRA_c_ci_Var_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ci,li_BRA_c_ci);
  q_ci_Equ_BRA_c_ci_Var_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ci,li_BRA_c_ci);
  f_ti_Equ_bi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ti,li_bi);
  q_ti_Equ_bi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ti,li_bi);
  f_ti_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ti,li_ci);
  q_ti_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ti,li_ci);
  f_ti_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ti,li_ei);
  q_ti_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ti,li_ei);
  f_ti_Equ_bii_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ti,li_bii);
  q_ti_Equ_bii_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ti,li_bii);
  f_ti_Equ_ti_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ti,li_ti);
  q_ti_Equ_ti_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ti,li_ti);
  f_ti_Equ_t_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ti,li_t);
  q_ti_Equ_t_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ti,li_t);
  f_ex_Equ_ti_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ex,li_ti);
  q_ex_Equ_ti_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ex,li_ti);
  f_ex_Equ_ex_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ex,li_ex);
  q_ex_Equ_ex_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ex,li_ex);
  f_ex_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ex,li_ei);
  q_ex_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ex,li_ei);
  f_ex_Equ_bii_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ex,li_bii);
  q_ex_Equ_bii_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ex,li_bii);
  f_exx_Equ_ti_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_exx,li_ti);
  q_exx_Equ_ti_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_exx,li_ti);
  f_exx_Equ_exx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_exx,li_exx);
  q_exx_Equ_exx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_exx,li_exx);
  f_exx_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_exx,li_ei);
  q_exx_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_exx,li_ei);
  f_exx_Equ_bii_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_exx,li_bii);
  q_exx_Equ_bii_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_exx,li_bii);
  f_cx_Equ_ti_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_cx,li_ti);
  q_cx_Equ_ti_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_cx,li_ti);
  f_cx_Equ_cx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_cx,li_cx);
  q_cx_Equ_cx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_cx,li_cx);
  f_cx_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_cx,li_ci);
  q_cx_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_cx,li_ci);
  f_cx_Equ_bii_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_cx,li_bii);
  q_cx_Equ_bii_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_cx,li_bii);
  f_BRA_b_bi_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_BRA_b_bi,li_b);
  q_BRA_b_bi_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_BRA_b_bi,li_b);
  f_BRA_b_bi_Equ_bi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_BRA_b_bi,li_bi);
  q_BRA_b_bi_Equ_bi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_BRA_b_bi,li_bi);
  f_BRA_b_bi_Equ_BRA_b_bi_Var_Ptr=dFdxMatPtr->returnRawEntryPointer(li_BRA_b_bi,li_BRA_b_bi);
  q_BRA_b_bi_Equ_BRA_b_bi_Var_Ptr=dQdxMatPtr->returnRawEntryPointer(li_BRA_b_bi,li_BRA_b_bi);
  f_BRA_e_ei_Equ_e_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_BRA_e_ei,li_e);
  q_BRA_e_ei_Equ_e_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_BRA_e_ei,li_e);
  f_BRA_e_ei_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_BRA_e_ei,li_ei);
  q_BRA_e_ei_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_BRA_e_ei,li_ei);
  f_BRA_e_ei_Equ_BRA_e_ei_Var_Ptr=dFdxMatPtr->returnRawEntryPointer(li_BRA_e_ei,li_BRA_e_ei);
  q_BRA_e_ei_Equ_BRA_e_ei_Var_Ptr=dQdxMatPtr->returnRawEntryPointer(li_BRA_e_ei,li_BRA_e_ei);
  f_BRA_c_ci_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_BRA_c_ci,li_c);
  q_BRA_c_ci_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_BRA_c_ci,li_c);
  f_BRA_c_ci_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_BRA_c_ci,li_ci);
  q_BRA_c_ci_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_BRA_c_ci,li_ci);
  f_BRA_c_ci_Equ_BRA_c_ci_Var_Ptr=dFdxMatPtr->returnRawEntryPointer(li_BRA_c_ci,li_BRA_c_ci);
  q_BRA_c_ci_Equ_BRA_c_ci_Var_Ptr=dQdxMatPtr->returnRawEntryPointer(li_BRA_c_ci,li_BRA_c_ci);


}

// RHS load functions

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEFVector
// Purpose       : load F vector (static contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEFVector()
{

  bool bsuccess=true;
  (*extData.daeFVectorPtr)[li_c] += staticContributions[admsNodeID_c].val();
  (*extData.daeFVectorPtr)[li_b] += staticContributions[admsNodeID_b].val();
  (*extData.daeFVectorPtr)[li_e] += staticContributions[admsNodeID_e].val();
  (*extData.daeFVectorPtr)[li_t] += staticContributions[admsNodeID_t].val();
  (*extData.daeFVectorPtr)[li_ei] += staticContributions[admsNodeID_ei].val();
  (*extData.daeFVectorPtr)[li_bi] += staticContributions[admsNodeID_bi].val();
  (*extData.daeFVectorPtr)[li_bii] += staticContributions[admsNodeID_bii].val();
  (*extData.daeFVectorPtr)[li_ci] += staticContributions[admsNodeID_ci].val();
  (*extData.daeFVectorPtr)[li_ti] += staticContributions[admsNodeID_ti].val();
  (*extData.daeFVectorPtr)[li_ex] += staticContributions[admsNodeID_ex].val();
  (*extData.daeFVectorPtr)[li_exx] += staticContributions[admsNodeID_exx].val();
  (*extData.daeFVectorPtr)[li_cx] += staticContributions[admsNodeID_cx].val();

  (*extData.daeFVectorPtr)[li_BRA_b_bi] += staticContributions[admsBRA_ID_b_bi].val();
  (*extData.daeFVectorPtr)[li_BRA_e_ei] += staticContributions[admsBRA_ID_e_ei].val();
  (*extData.daeFVectorPtr)[li_BRA_c_ci] += staticContributions[admsBRA_ID_c_ci].val();
  if (getDeviceOptions().voltageLimiterFlag && !origFlag)
  {
    double *dFdxdVp = extData.dFdxdVpVectorRawPtr;
    dFdxdVp[li_c] += Jdxp_static[admsNodeID_c];
    dFdxdVp[li_b] += Jdxp_static[admsNodeID_b];
    dFdxdVp[li_e] += Jdxp_static[admsNodeID_e];
    dFdxdVp[li_t] += Jdxp_static[admsNodeID_t];
    dFdxdVp[li_ei] += Jdxp_static[admsNodeID_ei];
    dFdxdVp[li_bi] += Jdxp_static[admsNodeID_bi];
    dFdxdVp[li_bii] += Jdxp_static[admsNodeID_bii];
    dFdxdVp[li_ci] += Jdxp_static[admsNodeID_ci];
    dFdxdVp[li_ti] += Jdxp_static[admsNodeID_ti];
    dFdxdVp[li_ex] += Jdxp_static[admsNodeID_ex];
    dFdxdVp[li_exx] += Jdxp_static[admsNodeID_exx];
    dFdxdVp[li_cx] += Jdxp_static[admsNodeID_cx];

    dFdxdVp[li_BRA_b_bi] += Jdxp_static[admsBRA_ID_b_bi];
    dFdxdVp[li_BRA_e_ei] += Jdxp_static[admsBRA_ID_e_ei];
    dFdxdVp[li_BRA_c_ci] += Jdxp_static[admsBRA_ID_c_ci];

  }

  if (loadLeadCurrent)
  {
    double * leadF = extData.nextLeadCurrFCompRawPtr;

    leadF[li_branch_ic] = leadCurrentF[admsNodeID_c];
    leadF[li_branch_ib] = leadCurrentF[admsNodeID_b];
    leadF[li_branch_ie] = leadCurrentF[admsNodeID_e];
    leadF[li_branch_it] = leadCurrentF[admsNodeID_t];

    // here we have to do special things for BJTs, MOSFETs and 2-terminal
    // devices for power computation.
    
    double * solVec = extData.nextSolVectorRawPtr;
    double * junctionV = extData.nextJunctionVCompRawPtr;
    junctionV[li_branch_ic] = solVec[li_c] - solVec[li_e];
    junctionV[li_branch_ib] = solVec[li_b] - solVec[li_e];
          
  }  
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEQVector
// Purpose       : load Q vector (dynamic contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEQVector()
{
  (*extData.daeQVectorPtr)[li_c] += dynamicContributions[admsNodeID_c].val();
  (*extData.daeQVectorPtr)[li_b] += dynamicContributions[admsNodeID_b].val();
  (*extData.daeQVectorPtr)[li_e] += dynamicContributions[admsNodeID_e].val();
  (*extData.daeQVectorPtr)[li_t] += dynamicContributions[admsNodeID_t].val();
  (*extData.daeQVectorPtr)[li_ei] += dynamicContributions[admsNodeID_ei].val();
  (*extData.daeQVectorPtr)[li_bi] += dynamicContributions[admsNodeID_bi].val();
  (*extData.daeQVectorPtr)[li_bii] += dynamicContributions[admsNodeID_bii].val();
  (*extData.daeQVectorPtr)[li_ci] += dynamicContributions[admsNodeID_ci].val();
  (*extData.daeQVectorPtr)[li_ti] += dynamicContributions[admsNodeID_ti].val();
  (*extData.daeQVectorPtr)[li_ex] += dynamicContributions[admsNodeID_ex].val();
  (*extData.daeQVectorPtr)[li_exx] += dynamicContributions[admsNodeID_exx].val();
  (*extData.daeQVectorPtr)[li_cx] += dynamicContributions[admsNodeID_cx].val();

  (*extData.daeQVectorPtr)[li_BRA_b_bi] += dynamicContributions[admsBRA_ID_b_bi].val();
  (*extData.daeQVectorPtr)[li_BRA_e_ei] += dynamicContributions[admsBRA_ID_e_ei].val();
  (*extData.daeQVectorPtr)[li_BRA_c_ci] += dynamicContributions[admsBRA_ID_c_ci].val();
  if (getDeviceOptions().voltageLimiterFlag && !origFlag)
  {
    double *dQdxdVp = extData.dQdxdVpVectorRawPtr;
    dQdxdVp[li_c] += Jdxp_dynamic[admsNodeID_c];
    dQdxdVp[li_b] += Jdxp_dynamic[admsNodeID_b];
    dQdxdVp[li_e] += Jdxp_dynamic[admsNodeID_e];
    dQdxdVp[li_t] += Jdxp_dynamic[admsNodeID_t];
    dQdxdVp[li_ei] += Jdxp_dynamic[admsNodeID_ei];
    dQdxdVp[li_bi] += Jdxp_dynamic[admsNodeID_bi];
    dQdxdVp[li_bii] += Jdxp_dynamic[admsNodeID_bii];
    dQdxdVp[li_ci] += Jdxp_dynamic[admsNodeID_ci];
    dQdxdVp[li_ti] += Jdxp_dynamic[admsNodeID_ti];
    dQdxdVp[li_ex] += Jdxp_dynamic[admsNodeID_ex];
    dQdxdVp[li_exx] += Jdxp_dynamic[admsNodeID_exx];
    dQdxdVp[li_cx] += Jdxp_dynamic[admsNodeID_cx];

    dQdxdVp[li_BRA_b_bi] += Jdxp_dynamic[admsBRA_ID_b_bi];
    dQdxdVp[li_BRA_e_ei] += Jdxp_dynamic[admsBRA_ID_e_ei];
    dQdxdVp[li_BRA_c_ci] += Jdxp_dynamic[admsBRA_ID_c_ci];
  }

  if (loadLeadCurrent)
  {
    double * leadQ = extData.nextLeadCurrQCompRawPtr;

    leadQ[li_branch_ic] = leadCurrentQ[admsNodeID_c];
    leadQ[li_branch_ib] = leadCurrentQ[admsNodeID_b];
    leadQ[li_branch_ie] = leadCurrentQ[admsNodeID_e];
    leadQ[li_branch_it] = leadCurrentQ[admsNodeID_t];
  }  
  return true;
}


//-----------------------------------------------------------------------------
// Function      : Instance::updatePrimaryState
// Purpose       :
// Special Notes : In this initial implementation, does little more than
//                 call updateIntermediateVars()
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updatePrimaryState()
{
  bool bsuccess = true;

  bsuccess = updateIntermediateVars();

  // if old DAE were implemented, we'd save dynamic contributions as state
  // here.

  double * stoVec = extData.nextStoVectorRawPtr;
  // Also need to save limited voltage drops
  // This formulation assumes that we have *always* written the
  // limited voltages back into the probeVars[] array.

  stoVec[li_store_admsProbeID_V_bi_ci] = probeVars[admsProbeID_V_bi_ci].val();
  stoVec[li_store_admsProbeID_V_bii_ci] = probeVars[admsProbeID_V_bii_ci].val();
  stoVec[li_store_admsProbeID_V_bii_ei] = probeVars[admsProbeID_V_bii_ei].val();

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateSecondaryState
// Purpose       :
// Special Notes : In this initial implementation, does nothing
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateSecondaryState()
{
  bool bsuccess = true;

  // were old DAE implemented, we'd pull dynamic contribution derivatives
  // out of state.

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateIntermediateVars
// Purpose       : update intermediate variables for one HBT_X instance
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateIntermediateVars()
{

  bool bsuccess=true;
  Linear::Vector * solVectorPtr = extData.nextSolVectorPtr;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << std::endl << subsection_divider << std::endl;
    Xyce::dout() << "  In ADMSHBT_X::Instance::updateIntermediateVars\n\n";
    Xyce::dout() << "  name = " << getName() << std::endl;
  }

  // Local variables
  AdmsFadType qbe;
  AdmsFadType qbtf;
  AdmsFadType xtff;
  AdmsFadType Wh;
  AdmsFadType Ih;
  double AHC;
  double RCIO;
  double InvVpt;
  double Vlim;
  AdmsFadType qb2;
  AdmsFadType qbtra;
  AdmsFadType qbtr;
  AdmsFadType qb1;
  AdmsFadType qb2med;
  AdmsFadType xix;
  double I00;
  AdmsFadType Ipdiss;
  AdmsFadType Icdx;
  AdmsFadType Ibdxx;
  AdmsFadType Ibdx;
  AdmsFadType Ib1;
  AdmsFadType Ib0;
  AdmsFadType EdBeta;
  AdmsFadType mm;
  double Vbclin;
  double epsi;
  AdmsFadType Ibx;
  AdmsFadType Ib2;
  AdmsFadType Ic1;
  AdmsFadType Ic1r;
  AdmsFadType Ic0;
  AdmsFadType qb;
  AdmsFadType q2;
  AdmsFadType q1;
  AdmsFadType Ic1ra;
  AdmsFadType Ic0a;
  double TWO_Q;
  double FOUR_K;
  double Area;
  AdmsFadType Tex;
  AdmsFadType TjK;
  AdmsFadType Tj;
  AdmsFadType Texi;
  AdmsFadType vcei;
  AdmsFadType vxxe;
  AdmsFadType vxc;
  AdmsFadType vxe;
  AdmsFadType vbei;
  AdmsFadType vbci;
  AdmsFadType vbcx;
  double tVCrit;
  // temporary variables for limiting
  double vbei_orig,vbei_limited,vbei_old;
  double vbci_orig,vbci_limited,vbci_old;
  double vbcx_orig,vbcx_limited,vbcx_old;


  // set the sizes of the Fad arrays:

  if (probeVars.size() != (19))
  {
    probeVars.resize(19);
    staticContributions.resize(12+3);
    dynamicContributions.resize(12+3);
    probeDiffs.resize(19,0.0);
    Jdxp_static.resize(12+3);
    Jdxp_dynamic.resize(12+3);
  }

  
  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 12+3 ; ++i)
  {
    staticContributions[i]=0;
    dynamicContributions[i]=0;
    Jdxp_static[i]=0;
    Jdxp_dynamic[i]=0;
  }

  for (int i=0; i < 19 ; ++i)
  {
    probeDiffs[i] = 0.0;
  }
  // extract solution variables and set as Fad independent variables.
  probeVars[admsProbeID_V_t_ti] = (*solVectorPtr)[li_t] - (*solVectorPtr)[li_ti];
  probeVars[admsProbeID_V_t_ti].diff(admsProbeID_V_t_ti,19);
  probeVars[admsProbeID_V_b_c] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_c];
  probeVars[admsProbeID_V_b_c].diff(admsProbeID_V_b_c,19);
  probeVars[admsProbeID_V_c_GND] = (*solVectorPtr)[li_c];
  probeVars[admsProbeID_V_c_GND].diff(admsProbeID_V_c_GND,19);
  probeVars[admsProbeID_V_b_GND] = (*solVectorPtr)[li_b];
  probeVars[admsProbeID_V_b_GND].diff(admsProbeID_V_b_GND,19);
  probeVars[admsProbeID_V_cx_bii] = (*solVectorPtr)[li_cx] - (*solVectorPtr)[li_bii];
  probeVars[admsProbeID_V_cx_bii].diff(admsProbeID_V_cx_bii,19);
  probeVars[admsProbeID_V_exx_bii] = (*solVectorPtr)[li_exx] - (*solVectorPtr)[li_bii];
  probeVars[admsProbeID_V_exx_bii].diff(admsProbeID_V_exx_bii,19);
  probeVars[admsProbeID_V_ex_bii] = (*solVectorPtr)[li_ex] - (*solVectorPtr)[li_bii];
  probeVars[admsProbeID_V_ex_bii].diff(admsProbeID_V_ex_bii,19);
  probeVars[admsProbeID_V_bii_bi] = (*solVectorPtr)[li_bii] - (*solVectorPtr)[li_bi];
  probeVars[admsProbeID_V_bii_bi].diff(admsProbeID_V_bii_bi,19);
  probeVars[admsProbeID_I_c_ci] = (*solVectorPtr)[li_BRA_c_ci];
  probeVars[admsProbeID_I_c_ci].diff(admsProbeID_I_c_ci,19);
  probeVars[admsProbeID_I_e_ei] = (*solVectorPtr)[li_BRA_e_ei];
  probeVars[admsProbeID_I_e_ei].diff(admsProbeID_I_e_ei,19);
  probeVars[admsProbeID_I_b_bi] = (*solVectorPtr)[li_BRA_b_bi];
  probeVars[admsProbeID_I_b_bi].diff(admsProbeID_I_b_bi,19);
  probeVars[admsProbeID_V_ti_GND] = (*solVectorPtr)[li_ti];
  probeVars[admsProbeID_V_ti_GND].diff(admsProbeID_V_ti_GND,19);
  probeVars[admsProbeID_V_ci_ei] = (*solVectorPtr)[li_ci] - (*solVectorPtr)[li_ei];
  probeVars[admsProbeID_V_ci_ei].diff(admsProbeID_V_ci_ei,19);
  probeVars[admsProbeID_V_exx_ei] = (*solVectorPtr)[li_exx] - (*solVectorPtr)[li_ei];
  probeVars[admsProbeID_V_exx_ei].diff(admsProbeID_V_exx_ei,19);
  probeVars[admsProbeID_V_cx_ci] = (*solVectorPtr)[li_cx] - (*solVectorPtr)[li_ci];
  probeVars[admsProbeID_V_cx_ci].diff(admsProbeID_V_cx_ci,19);
  probeVars[admsProbeID_V_ex_ei] = (*solVectorPtr)[li_ex] - (*solVectorPtr)[li_ei];
  probeVars[admsProbeID_V_ex_ei].diff(admsProbeID_V_ex_ei,19);
  probeVars[admsProbeID_V_bii_ei] = (*solVectorPtr)[li_bii] - (*solVectorPtr)[li_ei];
  probeVars[admsProbeID_V_bii_ei].diff(admsProbeID_V_bii_ei,19);
  probeVars[admsProbeID_V_bii_ci] = (*solVectorPtr)[li_bii] - (*solVectorPtr)[li_ci];
  probeVars[admsProbeID_V_bii_ci].diff(admsProbeID_V_bii_ci,19);
  probeVars[admsProbeID_V_bi_ci] = (*solVectorPtr)[li_bi] - (*solVectorPtr)[li_ci];
  probeVars[admsProbeID_V_bi_ci].diff(admsProbeID_V_bi_ci,19);


  // pre-multiply any "typed" probes (i.e. those limited with "typedpnjlim")
  probeVars[admsProbeID_V_bii_ei] *= (model_.dtype);
  probeVars[admsProbeID_V_bii_ci] *= (model_.dtype);
  probeVars[admsProbeID_V_bi_ci] *= (model_.dtype);

  // Copy probes into limiting vars

  vbei_orig = vbei_limited = probeVars[admsProbeID_V_bii_ei].val();
  probeDiffs[admsProbeID_V_bii_ei] = 0.0;
  vbci_orig = vbci_limited = probeVars[admsProbeID_V_bii_ci].val();
  probeDiffs[admsProbeID_V_bii_ci] = 0.0;
  vbcx_orig = vbcx_limited = probeVars[admsProbeID_V_bi_ci].val();
  probeDiffs[admsProbeID_V_bi_ci] = 0.0;

  origFlag = true;

  //Manually moved from below
  tVCrit = (adms_vt_nom*log((adms_vt_nom/(1.41421356237309504880*(((((model_.Jsf)*L)*W)*N)*1e12)))));
  if (getSolverState().newtonIter == 0)
  {

    if (getSolverState().initJctFlag_ && getDeviceOptions().voltageLimiterFlag)
    {
      // manually inserted code:
      if (getSolverState().inputOPFlag)
      {
        Linear::Vector * flagSolVectorPtr = (extData.flagSolVectorPtr);
        if ((*flagSolVectorPtr)[li_e] == 0 ||
            (*flagSolVectorPtr)[li_ei] == 0 ||
            (*flagSolVectorPtr)[li_ex] == 0 ||
            (*flagSolVectorPtr)[li_exx] == 0 ||
            (*flagSolVectorPtr)[li_b] == 0 ||
            (*flagSolVectorPtr)[li_bi] == 0 ||
            (*flagSolVectorPtr)[li_bii] == 0 ||
            (*flagSolVectorPtr)[li_c] == 0 ||
            (*flagSolVectorPtr)[li_ci] == 0 ||
            (*flagSolVectorPtr)[li_cx] == 0 ||
            (*flagSolVectorPtr)[li_t] == 0 ||
            (*flagSolVectorPtr)[li_ti] == 0 )
        {
          vbcx_limited = vbci_limited = 0;
          vbei_limited = tVCrit;
          origFlag = false;
        }
      }
      else
      {
        vbcx_limited = vbci_limited = 0;
        vbei_limited = tVCrit;
        origFlag = false;
        if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
        {
          Xyce::dout() << " Setting device initial condition to Base-Emitter drop=tVCri (" << tVCrit << ")" << std::endl;
        }
      }
    }
    // end manually inserted code

    if (!(getSolverState().dcopFlag)||(getSolverState().locaEnabledFlag && getSolverState().dcopFlag))
    {
      vbei_old = ((*extData.currStoVectorPtr))[li_store_admsProbeID_V_bii_ei];
      vbci_old = ((*extData.currStoVectorPtr))[li_store_admsProbeID_V_bii_ci];
      vbcx_old = ((*extData.currStoVectorPtr))[li_store_admsProbeID_V_bi_ci];
    }
    else
    {
      vbei_old = vbei_limited;
      vbci_old = vbci_limited;
      vbcx_old = vbcx_limited;
    }
  }
  else
  {
    vbei_old = ((*extData.nextStoVectorPtr))[li_store_admsProbeID_V_bii_ei];
    vbci_old = ((*extData.nextStoVectorPtr))[li_store_admsProbeID_V_bii_ci];
    vbcx_old = ((*extData.nextStoVectorPtr))[li_store_admsProbeID_V_bi_ci];
  }
  // -- code converted from analog/code block
  // Manually moved to above
  //tVCrit = (adms_vt_nom*log((adms_vt_nom/(1.41421356237309504880*(((((model_.Jsf)*L)*W)*N)*1e12)))));


  //vbcx = ($limit(V(bi,ci),"typedpnjlim",$vt(),tVCrit,dtype));
  if (getDeviceOptions().voltageLimiterFlag)
  {
    int icheck=0;
    vbcx_limited = devSupport.pnjlim(vbcx_limited,vbcx_old,adms_vt_nom,tVCrit,&icheck);
    if (icheck == 1)
      origFlag = false;
    if (!origFlag)
    {
      probeDiffs[admsProbeID_V_bi_ci] = vbcx_limited - vbcx_orig;
      probeVars[admsProbeID_V_bi_ci] += probeDiffs[admsProbeID_V_bi_ci];
    }
  }
  vbcx = probeVars[admsProbeID_V_bi_ci];



  //vbci = ($limit(V(bii,ci),"typedpnjlim",$vt(),tVCrit,dtype));
  if (getDeviceOptions().voltageLimiterFlag)
  {
    int icheck=0;
    vbci_limited = devSupport.pnjlim(vbci_limited,vbci_old,adms_vt_nom,tVCrit,&icheck);
    if (icheck == 1)
      origFlag = false;
    if (!origFlag)
    {
      probeDiffs[admsProbeID_V_bii_ci] = vbci_limited - vbci_orig;
      probeVars[admsProbeID_V_bii_ci] += probeDiffs[admsProbeID_V_bii_ci];
    }
  }
  vbci = probeVars[admsProbeID_V_bii_ci];



  //vbei = ($limit(V(bii,ei),"typedpnjlim",$vt(),tVCrit,dtype));
  if (getDeviceOptions().voltageLimiterFlag)
  {
    int icheck=0;
    vbei_limited = devSupport.pnjlim(vbei_limited,vbei_old,adms_vt_nom,tVCrit,&icheck);
    if (icheck == 1)
      origFlag = false;
    if (!origFlag)
    {
      probeDiffs[admsProbeID_V_bii_ei] = vbei_limited - vbei_orig;
      probeVars[admsProbeID_V_bii_ei] += probeDiffs[admsProbeID_V_bii_ei];
    }
  }
  vbei = probeVars[admsProbeID_V_bii_ei];

  vxe = ((model_.dtype)*(probeVars[admsProbeID_V_ex_ei]));
  vxc = ((model_.dtype)*(probeVars[admsProbeID_V_cx_ci]));
  vxxe = ((model_.dtype)*(probeVars[admsProbeID_V_exx_ei]));
  vcei = ((model_.dtype)*(probeVars[admsProbeID_V_ci_ei]));
  Texi = (probeVars[admsProbeID_V_ti_GND]);
  Tj = (Texi+Temp);
  TjK = (Tj+273.15);
  Tex = (Tj-(model_.Tnom));
  Area = (((L*W)*1.0e12)*N);
  FOUR_K = (4*1.3806226e-23);
  TWO_Q = (2*1.6021918e-19);
  Ic0a = AnalogFunctions::diode<AdmsFadType>(vbei,(model_.Jsf),(model_.Vg),(model_.nf),Area,Tj,(model_.Tnom));
  Ic1ra = AnalogFunctions::diode<AdmsFadType>(vbci,((model_.XCjc)*(model_.Jsr)),(model_.Vgr),(model_.nr),Area,Tj,(model_.Tnom));
  if ((((model_.VAF)>0.0)&&((model_.VAR)>0.0)))
  {
    q1 = ((1.0+((AnalogFunctions::charge<AdmsFadType>(vbei,1.0,(model_.Vje),(model_.mje),1.0)-AnalogFunctions::charge<double>(0.0,1.0,(model_.Vje),(model_.mje),1.0))/(model_.VAR)))+((AnalogFunctions::charge<AdmsFadType>(vbci,1.0,(model_.Vjc),(model_.mjc),1.0)-AnalogFunctions::charge<double>(0.0,1.0,(model_.Vjc),(model_.mjc),1.0))/(model_.VAF)));
  }
  else
  {
    if ((((model_.VAF)>0.0)&&((model_.VAR)==0.0)))
    {
      q1 = (1.0+((AnalogFunctions::charge<AdmsFadType>(vbci,1.0,(model_.Vjc),(model_.mjc),1.0)-AnalogFunctions::charge<AdmsFadType>(0.0,1.0,(model_.Vjc),(model_.mjc),1.0))/(model_.VAF)));
    }
    else
    {
      if ((((model_.VAF)==0.0)&&((model_.VAR)>0.0)))
      {
        q1 = (1.0+((AnalogFunctions::charge<AdmsFadType>(vbei,1.0,(model_.Vje),(model_.mje),1.0)-AnalogFunctions::charge<AdmsFadType>(0.0,1.0,(model_.Vje),(model_.mje),1.0))/(model_.VAR)));
      }
      else
      {
        q1 = 1.0;
      }
    }
  }
  if ((((model_.IKF)>0.0)&&((model_.IKR)>0.0)))
  {
    q2 = ((Ic0a/(Area*(model_.IKF)))+(Ic1ra/(Area*(model_.IKR))));
  }
  else
  {
    if ((((model_.IKF)>0.0)&&((model_.IKR)==0.0)))
    {
      q2 = (Ic0a/(Area*(model_.IKF)));
    }
    else
    {
      if ((((model_.IKF)==0.0)&&((model_.IKR)>0.0)))
      {
        q2 = (Ic1ra/(Area*(model_.IKR)));
      }
      else
      {
        q2 = 0.0;
      }
    }
  }
  qb = ((q1+sqrt(((q1*q1)+(4.0*q2))))/2.0);
  Ic0 = (Ic0a/qb);
  Ic1r = (Ic1ra/qb);
  Ic1 = (Ic0-Ic1r);
  Ib2 = (AnalogFunctions::diode<AdmsFadType>(vbci,((model_.XCjc)*(model_.Jsr)),(model_.Vgr),(model_.nr),Area,Tj,(model_.Tnom))/(model_.Br));
  Ibx = (AnalogFunctions::diode<AdmsFadType>(vbcx,((1.0-(model_.XCjc))*(model_.Jsr)),(model_.Vgr),(model_.nr),Area,Tj,(model_.Tnom))/(model_.Br));
  epsi = 1.0e-6;
  Vbclin = ((model_.BVceo)*pow((1.0-epsi),(1/(model_.Mc))));
  mm = AnalogFunctions::MM<AdmsFadType>(vbci,(model_.BVceo),(model_.Mc),Vbclin,(model_.Bf),(model_.kc));
  if ((mm>1.0))
  {
    if (((model_.kBeta)>0.0))
    {
      if ((((model_.Bf)-((model_.kBeta)*Tex))>1e-6))
      {
        EdBeta = (((1/((model_.Bf)-((model_.kBeta)*Tex)))-((model_.kc)*(mm-1)))/(((model_.kc)*(mm-1))+1));
      }
      else
      {
        EdBeta = ((1e6-((model_.kc)*(mm-1)))/(((model_.kc)*(mm-1))+1));
      }
    }
    else
    {
      EdBeta = (((1/(model_.Bf))-((model_.kc)*(mm-1)))/(((model_.kc)*(mm-1))+1));
    }
  }
  else
  {
    if (((model_.kBeta)>0.0))
    {
      if ((((model_.Bf)-((model_.kBeta)*Tex))>1e-6))
      {
        EdBeta = (1/((model_.Bf)-((model_.kBeta)*Tex)));
      }
      else
      {
        EdBeta = 1e6;
      }
    }
    else
    {
      EdBeta = (1/(model_.Bf));
    }
  }
  Ib0 = (Ic0a*EdBeta);
  if (((model_.BVebo)>0))
  {
    Ib1 = (Ib0-AnalogFunctions::diode<AdmsFadType>(((-(model_.BVebo))-vbei),(model_.Jsf),0.0,1.0,Area,0.0,0.0));
  }
  else
  {
    Ib1 = Ib0;
  }
  if ((((model_.Jse)>0.0)&&((model_.ne)>0)))
  {
    Ibdx = AnalogFunctions::diode<AdmsFadType>(vxe,(model_.Jse),(model_.Vgb),(model_.ne),Area,Tj,(model_.Tnom));
  }
  else
  {
    Ibdx = (vxe*1e-12);
  }
  if ((((model_.Jsee)>0.0)&&((model_.nee)>0)))
  {
    Ibdxx = AnalogFunctions::diode<AdmsFadType>(vxxe,(model_.Jsee),(model_.Vgbb),(model_.nee),Area,Tj,(model_.Tnom));
  }
  else
  {
    Ibdxx = (vxxe*1e-12);
  }
  if ((((model_.Jsc)>0.0)&&((model_.nc)>0)))
  {
    Icdx = AnalogFunctions::diode<AdmsFadType>(vxc,(model_.Jsc),(model_.Vgc),(model_.nc),Area,Tj,(model_.Tnom));
  }
  else
  {
    Icdx = (vxc*1e-12);
  }
  Ipdiss = ((((Ic1*vcei)+(Ib1*vbei))+(Ib2*vbci))+(Ibx*vbcx));
  if ((Ipdiss<0.0))
  {
    Ipdiss = 0;
  }
  I00 = ((model_.J0)*Area);
  if ((((model_.XCjc)<1.0)&&((model_.XCjc)>0.0)))
  {
    if ((((model_.J0)<=0.0)||(Ic0<0.0)))
    {
      qb2med = (((model_.XCjc)*AnalogFunctions::charge<AdmsFadType>(vbci,((model_.Cjc)-(model_.Cmin)),(model_.Vjc),(model_.mjc),Area))+((((model_.XCjc)*Area)*(model_.Cmin))*vbci));
    }
    else
    {
      xix = (Ic0/I00);
      qb2med = ((((model_.XCjc)*(1.0-tanh(xix)))*(AnalogFunctions::charge<AdmsFadType>(vbci,((model_.Cjc)-(model_.Cmin)),(model_.Vjc),(model_.mjc),Area)+((((1.0-(model_.XJ0))*Area)*(model_.Cmin))*vbci)))+(((((model_.XJ0)*(model_.XCjc))*Area)*(model_.Cmin))*vbci));
    }
  }
  else
  {
    if ((((model_.J0)<0.0)||(Ic0<0.0)))
    {
      qb2med = (AnalogFunctions::charge<AdmsFadType>(vbci,((model_.Cjc)-(model_.Cmin)),(model_.Vjc),(model_.mjc),Area)+((Area*(model_.Cmin))*vbci));
    }
    else
    {
      xix = (Ic0/I00);
      qb2med = (((1.0-tanh(xix))*(AnalogFunctions::charge<AdmsFadType>(vbci,((model_.Cjc)-(model_.Cmin)),(model_.Vjc),(model_.mjc),Area)+((((1.0-(model_.XJ0))*Area)*(model_.Cmin))*vbci)))+((((model_.XJ0)*Area)*(model_.Cmin))*vbci));
    }
  }
  if ((((model_.XCjc)<1.0)&&((model_.XCjc)>0.0)))
  {
    qb1 = (((1.0-(model_.XCjc))*AnalogFunctions::charge<AdmsFadType>(vbcx,((model_.Cjc)-(model_.Cmin)),(model_.Vjc),(model_.mjc),Area))+((((1.0-(model_.XCjc))*Area)*(model_.Cmin))*vbcx));
  }
  else
  {
    qb1 = 0.0;
  }
  qbtr = ((model_.Tr)*Ic1r);
  qbtra = ((model_.Trx)*Ibx);
  qb2 = (qb2med+qbtr);
  if ((((model_.Jk)>0.0)&&((model_.Rci0)>0.0)))
  {
    if (((model_.RJk)>0.0))
    {
      Vlim = (((model_.Jk)*(model_.Rci0))/(1.0-((model_.Rci0)/(model_.RJk))));
      InvVpt = ((1.0-((model_.Rci0)/(model_.RJk)))/((model_.Jk)*(model_.RJk)));
    }
    else
    {
      Vlim = (((model_.Jk)*(model_.Rci0))/1.016);
      InvVpt = 0.0;
    }
  }
  if ((((((model_.Thcs)>0.0)&&((model_.Ahc)>0.0))&&((model_.Jk)>0.0))&&(Ic0>0.0)))
  {
    RCIO = ((model_.Rci0)/Area);
    AHC = (Area*(model_.Ahc));
    if ((((model_.Rci0)<(model_.RJk))||((model_.RJk)<=0.0)))
    {
      Ih = (1.0-(AnalogFunctions::ICK<AdmsFadType>(vcei,RCIO,Vlim,InvVpt,(model_.Vces))/Ic0));
    }
    else
    {
      Ih = (1.0-(AnalogFunctions::Vceff<AdmsFadType>(vcei,(model_.Vces))/(RCIO*Ic0)));
    }
    Wh = ((Ih+sqrt(((Ih*Ih)+AHC)))/(1.0+sqrt((1.0+AHC))));
    xtff = (((model_.Thcs)*Ic0)*(Wh*Wh));
  }
  else
  {
    xtff = 0;
  }
  qbtf = (((model_.Tf)+((model_.Tft)*Tex))*Ic0);
  qbe = ((xtff+qbtf)+AnalogFunctions::charge<AdmsFadType>(vbei,(model_.Cje),(model_.Vje),(model_.mje),Area));
  // I(bi,ci) <+ ((dtype*Ibx))
  {
    AdmsFadType contribTemp;
    contribTemp= ((model_.dtype)*Ibx);
    staticContributions[admsNodeID_bi] += contribTemp;
    staticContributions[admsNodeID_ci] -= contribTemp;

    Jdxp_static[admsNodeID_bi] += contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci);
    Jdxp_static[admsNodeID_ci] -= contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci);
  }
  // I(bi,ci) <+ ((dtype*ddt((qb1+qbtra))))
  {
    AdmsFadType contribTemp;
    contribTemp= ((model_.dtype)*((qb1+qbtra)));
    dynamicContributions[admsNodeID_bi] += contribTemp;
    dynamicContributions[admsNodeID_ci] -= contribTemp;

    Jdxp_dynamic[admsNodeID_bi] += contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci);
    Jdxp_dynamic[admsNodeID_ci] -= contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci);
  }
  // I(bii,ci) <+ ((dtype*Ib2))
  {
    AdmsFadType contribTemp;
    contribTemp= ((model_.dtype)*Ib2);
    staticContributions[admsNodeID_bii] += contribTemp;
    staticContributions[admsNodeID_ci] -= contribTemp;

    Jdxp_static[admsNodeID_bii] += contribTemp.dx(admsProbeID_V_bii_ci)*probeDiffs[admsProbeID_V_bii_ci]*probeVars[admsProbeID_V_bii_ci].dx(admsProbeID_V_bii_ci);
    Jdxp_static[admsNodeID_ci] -= contribTemp.dx(admsProbeID_V_bii_ci)*probeDiffs[admsProbeID_V_bii_ci]*probeVars[admsProbeID_V_bii_ci].dx(admsProbeID_V_bii_ci);
  }
  // I(bii,ci) <+ ((dtype*ddt(qb2)))
  {
    AdmsFadType contribTemp;
    contribTemp= ((model_.dtype)*(qb2));
    dynamicContributions[admsNodeID_bii] += contribTemp;
    dynamicContributions[admsNodeID_ci] -= contribTemp;

    Jdxp_dynamic[admsNodeID_bii] += contribTemp.dx(admsProbeID_V_bii_ci)*probeDiffs[admsProbeID_V_bii_ci]*probeVars[admsProbeID_V_bii_ci].dx(admsProbeID_V_bii_ci)+contribTemp.dx(admsProbeID_V_bii_ei)*probeDiffs[admsProbeID_V_bii_ei]*probeVars[admsProbeID_V_bii_ei].dx(admsProbeID_V_bii_ei);
    Jdxp_dynamic[admsNodeID_ci] -= contribTemp.dx(admsProbeID_V_bii_ci)*probeDiffs[admsProbeID_V_bii_ci]*probeVars[admsProbeID_V_bii_ci].dx(admsProbeID_V_bii_ci)+contribTemp.dx(admsProbeID_V_bii_ei)*probeDiffs[admsProbeID_V_bii_ei]*probeVars[admsProbeID_V_bii_ei].dx(admsProbeID_V_bii_ei);
  }
  // I(bii,ei) <+ ((dtype*Ib1))
  {
    AdmsFadType contribTemp;
    contribTemp= ((model_.dtype)*Ib1);
    staticContributions[admsNodeID_bii] += contribTemp;
    staticContributions[admsNodeID_ei] -= contribTemp;

    Jdxp_static[admsNodeID_bii] += contribTemp.dx(admsProbeID_V_bii_ci)*probeDiffs[admsProbeID_V_bii_ci]*probeVars[admsProbeID_V_bii_ci].dx(admsProbeID_V_bii_ci)+contribTemp.dx(admsProbeID_V_bii_ei)*probeDiffs[admsProbeID_V_bii_ei]*probeVars[admsProbeID_V_bii_ei].dx(admsProbeID_V_bii_ei);
    Jdxp_static[admsNodeID_ei] -= contribTemp.dx(admsProbeID_V_bii_ci)*probeDiffs[admsProbeID_V_bii_ci]*probeVars[admsProbeID_V_bii_ci].dx(admsProbeID_V_bii_ci)+contribTemp.dx(admsProbeID_V_bii_ei)*probeDiffs[admsProbeID_V_bii_ei]*probeVars[admsProbeID_V_bii_ei].dx(admsProbeID_V_bii_ei);
  }
  // I(bii,ei) <+ ((dtype*ddt(qbe)))
  {
    AdmsFadType contribTemp;
    contribTemp= ((model_.dtype)*(qbe));
    dynamicContributions[admsNodeID_bii] += contribTemp;
    dynamicContributions[admsNodeID_ei] -= contribTemp;

    Jdxp_dynamic[admsNodeID_bii] += contribTemp.dx(admsProbeID_V_bii_ci)*probeDiffs[admsProbeID_V_bii_ci]*probeVars[admsProbeID_V_bii_ci].dx(admsProbeID_V_bii_ci)+contribTemp.dx(admsProbeID_V_bii_ei)*probeDiffs[admsProbeID_V_bii_ei]*probeVars[admsProbeID_V_bii_ei].dx(admsProbeID_V_bii_ei);
    Jdxp_dynamic[admsNodeID_ei] -= contribTemp.dx(admsProbeID_V_bii_ci)*probeDiffs[admsProbeID_V_bii_ci]*probeVars[admsProbeID_V_bii_ci].dx(admsProbeID_V_bii_ci)+contribTemp.dx(admsProbeID_V_bii_ei)*probeDiffs[admsProbeID_V_bii_ei]*probeVars[admsProbeID_V_bii_ei].dx(admsProbeID_V_bii_ei);
  }
  // I(ci,ei) <+ ((dtype*Ic1))
  {
    AdmsFadType contribTemp;
    contribTemp= ((model_.dtype)*Ic1);
    staticContributions[admsNodeID_ci] += contribTemp;
    staticContributions[admsNodeID_ei] -= contribTemp;

    Jdxp_static[admsNodeID_ci] += contribTemp.dx(admsProbeID_V_bii_ci)*probeDiffs[admsProbeID_V_bii_ci]*probeVars[admsProbeID_V_bii_ci].dx(admsProbeID_V_bii_ci)+contribTemp.dx(admsProbeID_V_bii_ei)*probeDiffs[admsProbeID_V_bii_ei]*probeVars[admsProbeID_V_bii_ei].dx(admsProbeID_V_bii_ei);
    Jdxp_static[admsNodeID_ei] -= contribTemp.dx(admsProbeID_V_bii_ci)*probeDiffs[admsProbeID_V_bii_ci]*probeVars[admsProbeID_V_bii_ci].dx(admsProbeID_V_bii_ci)+contribTemp.dx(admsProbeID_V_bii_ei)*probeDiffs[admsProbeID_V_bii_ei]*probeVars[admsProbeID_V_bii_ei].dx(admsProbeID_V_bii_ei);
  }
  // I(ex,ei) <+ ((dtype*Ibdx))
  staticContributions[admsNodeID_ex] += ((model_.dtype)*Ibdx);
  staticContributions[admsNodeID_ei] -= ((model_.dtype)*Ibdx);
  // I(exx,ei) <+ ((dtype*Ibdxx))
  staticContributions[admsNodeID_exx] += ((model_.dtype)*Ibdxx);
  staticContributions[admsNodeID_ei] -= ((model_.dtype)*Ibdxx);
  // I(cx,ci) <+ ((dtype*Icdx))
  staticContributions[admsNodeID_cx] += ((model_.dtype)*Icdx);
  staticContributions[admsNodeID_ci] -= ((model_.dtype)*Icdx);
  // V(b,bi) <+ ((I(b,bi)*(Rb/N)))
  staticContributions[admsBRA_ID_b_bi] += ((probeVars[admsProbeID_I_b_bi])*((model_.Rb)/N));
  // V(b,bi) <+ (ddt((I(b,bi)*Lb)))
  dynamicContributions[admsBRA_ID_b_bi] += (((probeVars[admsProbeID_I_b_bi])*(model_.Lb)));
  // V(e,ei) <+ ((I(e,ei)*(Re/N)))
  staticContributions[admsBRA_ID_e_ei] += ((probeVars[admsProbeID_I_e_ei])*((model_.Re)/N));
  // V(e,ei) <+ (ddt((I(e,ei)*Le)))
  dynamicContributions[admsBRA_ID_e_ei] += (((probeVars[admsProbeID_I_e_ei])*(model_.Le)));
  // V(c,ci) <+ ((I(c,ci)*(Rc/N)))
  staticContributions[admsBRA_ID_c_ci] += ((probeVars[admsProbeID_I_c_ci])*((model_.Rc)/N));
  // V(c,ci) <+ (ddt((I(c,ci)*Lc)))
  dynamicContributions[admsBRA_ID_c_ci] += (((probeVars[admsProbeID_I_c_ci])*(model_.Lc)));
  // I(bii,bi) <+ ((V(bii,bi)/(Rb2/N)))
  staticContributions[admsNodeID_bii] += ((probeVars[admsProbeID_V_bii_bi])/((model_.Rb2)/N));
  staticContributions[admsNodeID_bi] -= ((probeVars[admsProbeID_V_bii_bi])/((model_.Rb2)/N));
  if ((((model_.Jse)>0.0)&&((model_.ne)>0)))
  {
    // I(ex,bii) <+ ((V(ex,bii)/(Rbxx/N)))
    staticContributions[admsNodeID_ex] += ((probeVars[admsProbeID_V_ex_bii])/((model_.Rbxx)/N));
    staticContributions[admsNodeID_bii] -= ((probeVars[admsProbeID_V_ex_bii])/((model_.Rbxx)/N));
  }
  else
  {
    // I(ex,bii) <+ ((V(ex,bii)*1e-12))
    staticContributions[admsNodeID_ex] += ((probeVars[admsProbeID_V_ex_bii])*1e-12);
    staticContributions[admsNodeID_bii] -= ((probeVars[admsProbeID_V_ex_bii])*1e-12);
  }
  if ((((model_.Jsee)>0.0)&&((model_.nee)>0)))
  {
    // I(exx,bii) <+ ((V(exx,bii)/(Rbbxx/N)))
    staticContributions[admsNodeID_exx] += ((probeVars[admsProbeID_V_exx_bii])/((model_.Rbbxx)/N));
    staticContributions[admsNodeID_bii] -= ((probeVars[admsProbeID_V_exx_bii])/((model_.Rbbxx)/N));
  }
  else
  {
    // I(exx,bii) <+ ((V(exx,bii)*1e-12))
    staticContributions[admsNodeID_exx] += ((probeVars[admsProbeID_V_exx_bii])*1e-12);
    staticContributions[admsNodeID_bii] -= ((probeVars[admsProbeID_V_exx_bii])*1e-12);
  }
  if ((((model_.Jsc)>0.0)&&((model_.nc)>0)))
  {
    // I(cx,bii) <+ ((V(cx,bii)/(Rcxx/N)))
    staticContributions[admsNodeID_cx] += ((probeVars[admsProbeID_V_cx_bii])/((model_.Rcxx)/N));
    staticContributions[admsNodeID_bii] -= ((probeVars[admsProbeID_V_cx_bii])/((model_.Rcxx)/N));
  }
  else
  {
    // I(cx,bii) <+ ((V(cx,bii)*1e-12))
    staticContributions[admsNodeID_cx] += ((probeVars[admsProbeID_V_cx_bii])*1e-12);
    staticContributions[admsNodeID_bii] -= ((probeVars[admsProbeID_V_cx_bii])*1e-12);
  }
  // I(b,GND) <+ (ddt((Cpb*V(b,GND))))
  dynamicContributions[admsNodeID_b] += (((model_.Cpb)*(probeVars[admsProbeID_V_b_GND])));
  // I(c,GND) <+ (ddt((Cpc*V(c,GND))))
  dynamicContributions[admsNodeID_c] += (((model_.Cpc)*(probeVars[admsProbeID_V_c_GND])));
  // I(b,c) <+ (ddt((Cq*V(b,c))))
  dynamicContributions[admsNodeID_b] += (((model_.Cq)*(probeVars[admsProbeID_V_b_c])));
  dynamicContributions[admsNodeID_c] -= (((model_.Cq)*(probeVars[admsProbeID_V_b_c])));
  // I(ti,GND) <+ ((-Ipdiss))
  {
    AdmsFadType contribTemp;
    contribTemp= (-Ipdiss);
    staticContributions[admsNodeID_ti] += contribTemp;

    Jdxp_static[admsNodeID_ti] += contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bii_ci)*probeDiffs[admsProbeID_V_bii_ci]*probeVars[admsProbeID_V_bii_ci].dx(admsProbeID_V_bii_ci)+contribTemp.dx(admsProbeID_V_bii_ei)*probeDiffs[admsProbeID_V_bii_ei]*probeVars[admsProbeID_V_bii_ei].dx(admsProbeID_V_bii_ei);
  }
  if (((model_.Rth)>0))
  {
    // I(t,ti) <+ ((V(t,ti)/Rth))
    staticContributions[admsNodeID_t] += ((probeVars[admsProbeID_V_t_ti])/(model_.Rth));
    staticContributions[admsNodeID_ti] -= ((probeVars[admsProbeID_V_t_ti])/(model_.Rth));
    // I(t,ti) <+ ((Cth*ddt(V(t,ti))))
    dynamicContributions[admsNodeID_t] += ((model_.Cth)*((probeVars[admsProbeID_V_t_ti])));
    dynamicContributions[admsNodeID_ti] -= ((model_.Cth)*((probeVars[admsProbeID_V_t_ti])));
  }
  else
  {
    // I(t,ti) <+ ((V(t,ti)*1e3))
    staticContributions[admsNodeID_t] += ((probeVars[admsProbeID_V_t_ti])*1e3);
    staticContributions[admsNodeID_ti] -= ((probeVars[admsProbeID_V_t_ti])*1e3);
  }

  // Additional term resulting from contributions into V(b,bi)
  staticContributions[admsNodeID_b] += probeVars[admsProbeID_I_b_bi];
  staticContributions[admsNodeID_bi] -= probeVars[admsProbeID_I_b_bi];

  // Additional term resulting from contributions into V(e,ei)
  staticContributions[admsNodeID_e] += probeVars[admsProbeID_I_e_ei];
  staticContributions[admsNodeID_ei] -= probeVars[admsProbeID_I_e_ei];

  // Additional term resulting from contributions into V(c,ci)
  staticContributions[admsNodeID_c] += probeVars[admsProbeID_I_c_ci];
  staticContributions[admsNodeID_ci] -= probeVars[admsProbeID_I_c_ci];
  // Final term for branch equation admsBRA_ID_b_bi 
  staticContributions[admsBRA_ID_b_bi] -= (*solVectorPtr)[li_b]-(*solVectorPtr)[li_bi];
  // Final term for branch equation admsBRA_ID_e_ei 
  staticContributions[admsBRA_ID_e_ei] -= (*solVectorPtr)[li_e]-(*solVectorPtr)[li_ei];
  // Final term for branch equation admsBRA_ID_c_ci 
  staticContributions[admsBRA_ID_c_ci] -= (*solVectorPtr)[li_c]-(*solVectorPtr)[li_ci];


  // -- endcode converted from analog/code block
  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << " probeVars[admsProbeID_V_t_ti] =  "
                 <<probeVars[admsProbeID_V_t_ti].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_c] =  "
                 <<probeVars[admsProbeID_V_b_c].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_c_GND] =  "
                 <<probeVars[admsProbeID_V_c_GND].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_GND] =  "
                 <<probeVars[admsProbeID_V_b_GND].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_cx_bii] =  "
                 <<probeVars[admsProbeID_V_cx_bii].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_exx_bii] =  "
                 <<probeVars[admsProbeID_V_exx_bii].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_ex_bii] =  "
                 <<probeVars[admsProbeID_V_ex_bii].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bii_bi] =  "
                 <<probeVars[admsProbeID_V_bii_bi].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_I_c_ci] =  "
                 <<probeVars[admsProbeID_I_c_ci].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_I_e_ei] =  "
                 <<probeVars[admsProbeID_I_e_ei].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_I_b_bi] =  "
                 <<probeVars[admsProbeID_I_b_bi].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_ti_GND] =  "
                 <<probeVars[admsProbeID_V_ti_GND].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_ci_ei] =  "
                 <<probeVars[admsProbeID_V_ci_ei].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_exx_ei] =  "
                 <<probeVars[admsProbeID_V_exx_ei].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_cx_ci] =  "
                 <<probeVars[admsProbeID_V_cx_ci].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_ex_ei] =  "
                 <<probeVars[admsProbeID_V_ex_ei].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bii_ei] =  "
                 <<probeVars[admsProbeID_V_bii_ei].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bii_ci] =  "
                 <<probeVars[admsProbeID_V_bii_ci].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bi_ci] =  "
                 <<probeVars[admsProbeID_V_bi_ci].val() << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_c] =  "
                 <<staticContributions[admsNodeID_c].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_t_ti) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_t_ti) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_c_GND) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_c_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b_GND) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_b_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_cx_bii) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_cx_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_exx_bii) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_exx_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_ex_bii) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_ex_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bii_bi) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_bii_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_I_c_ci) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_I_c_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_I_e_ei) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_I_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_I_b_bi) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_I_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_ti_GND) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_ti_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_exx_ei) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_exx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_ex_ei) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_ex_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bii_ei) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_bii_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bii_ci) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_bii_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_c] =  "
                 <<dynamicContributions[admsNodeID_c].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_t_ti) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_t_ti) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_c_GND) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_c_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_GND) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_cx_bii) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_cx_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_exx_bii) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_exx_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_ex_bii) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_ex_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bii_bi) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bii_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_I_c_ci) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_I_c_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_I_e_ei) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_I_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_I_b_bi) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_I_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_ti_GND) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_ti_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_exx_ei) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_exx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_ex_ei) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_ex_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bii_ei) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bii_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bii_ci) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bii_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_c] =  "
                 <<Jdxp_static[admsNodeID_c] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_c] =  "
                 <<Jdxp_dynamic[admsNodeID_c] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_b] =  "
                 <<staticContributions[admsNodeID_b].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_t_ti) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_t_ti) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_c_GND) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_c_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_GND) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_cx_bii) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_cx_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_exx_bii) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_exx_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_ex_bii) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_ex_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bii_bi) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_bii_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_I_c_ci) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_I_c_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_I_e_ei) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_I_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_I_b_bi) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_I_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_ti_GND) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_ti_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_exx_ei) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_exx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_ex_ei) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_ex_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bii_ei) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_bii_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bii_ci) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_bii_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_b] =  "
                 <<dynamicContributions[admsNodeID_b].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_t_ti) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_t_ti) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c_GND) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_GND) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_cx_bii) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_cx_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_exx_bii) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_exx_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_ex_bii) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_ex_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bii_bi) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bii_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_I_c_ci) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_I_c_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_I_e_ei) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_I_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_I_b_bi) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_I_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_ti_GND) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_ti_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_exx_ei) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_exx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_ex_ei) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_ex_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bii_ei) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bii_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bii_ci) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bii_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_b] =  "
                 <<Jdxp_static[admsNodeID_b] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_b] =  "
                 <<Jdxp_dynamic[admsNodeID_b] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_e] =  "
                 <<staticContributions[admsNodeID_e].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_t_ti) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_t_ti) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_c_GND) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_c_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b_GND) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_b_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_cx_bii) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_cx_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_exx_bii) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_exx_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_ex_bii) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_ex_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bii_bi) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_bii_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_I_c_ci) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_I_c_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_I_e_ei) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_I_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_I_b_bi) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_I_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_ti_GND) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_ti_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_exx_ei) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_exx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_ex_ei) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_ex_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bii_ei) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_bii_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bii_ci) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_bii_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_e] =  "
                 <<dynamicContributions[admsNodeID_e].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_t_ti) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_t_ti) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_c_GND) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_c_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_GND) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_cx_bii) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_cx_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_exx_bii) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_exx_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ex_bii) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ex_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bii_bi) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bii_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_I_c_ci) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_I_c_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_I_e_ei) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_I_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_I_b_bi) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_I_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ti_GND) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ti_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_exx_ei) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_exx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ex_ei) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ex_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bii_ei) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bii_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bii_ci) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bii_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_e] =  "
                 <<Jdxp_static[admsNodeID_e] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_e] =  "
                 <<Jdxp_dynamic[admsNodeID_e] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_t] =  "
                 <<staticContributions[admsNodeID_t].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_t_ti) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_t_ti) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_c_GND) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_c_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_b_GND) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_b_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_cx_bii) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_cx_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_exx_bii) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_exx_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_ex_bii) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_ex_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_bii_bi) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_bii_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_I_c_ci) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_I_c_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_I_e_ei) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_I_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_I_b_bi) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_I_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_ti_GND) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_ti_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_exx_ei) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_exx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_ex_ei) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_ex_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_bii_ei) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_bii_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_bii_ci) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_bii_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_t] =  "
                 <<dynamicContributions[admsNodeID_t].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_t_ti) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_t_ti) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_c_GND) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_c_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_b_GND) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_b_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_cx_bii) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_cx_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_exx_bii) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_exx_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_ex_bii) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_ex_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_bii_bi) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_bii_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_I_c_ci) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_I_c_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_I_e_ei) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_I_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_I_b_bi) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_I_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_ti_GND) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_ti_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_exx_ei) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_exx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_ex_ei) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_ex_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_bii_ei) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_bii_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_bii_ci) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_bii_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_t] =  "
                 <<Jdxp_static[admsNodeID_t] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_t] =  "
                 <<Jdxp_dynamic[admsNodeID_t] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_ei] =  "
                 <<staticContributions[admsNodeID_ei].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_t_ti) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_t_ti) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_c_GND) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_c_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_GND) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_cx_bii) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_cx_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_exx_bii) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_exx_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_ex_bii) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_ex_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bii_bi) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_bii_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_I_c_ci) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_I_c_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_I_e_ei) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_I_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_I_b_bi) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_I_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_ti_GND) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_ti_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_exx_ei) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_exx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_ex_ei) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_ex_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bii_ei) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_bii_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bii_ci) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_bii_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_ei] =  "
                 <<dynamicContributions[admsNodeID_ei].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_t_ti) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_t_ti) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_c_GND) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_c_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_GND) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_cx_bii) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_cx_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_exx_bii) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_exx_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ex_bii) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ex_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bii_bi) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bii_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_I_c_ci) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_I_c_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_I_e_ei) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_I_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_I_b_bi) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_I_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ti_GND) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ti_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_exx_ei) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_exx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ex_ei) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ex_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bii_ei) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bii_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bii_ci) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bii_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_ei] =  "
                 <<Jdxp_static[admsNodeID_ei] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_ei] =  "
                 <<Jdxp_dynamic[admsNodeID_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_bi] =  "
                 <<staticContributions[admsNodeID_bi].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_t_ti) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_t_ti) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_c_GND) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_c_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_GND) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_cx_bii) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_cx_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_exx_bii) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_exx_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_ex_bii) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_ex_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bii_bi) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_bii_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_I_c_ci) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_I_c_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_I_e_ei) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_I_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_I_b_bi) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_I_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_ti_GND) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_ti_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_exx_ei) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_exx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_ex_ei) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_ex_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bii_ei) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_bii_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bii_ci) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_bii_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_bi] =  "
                 <<dynamicContributions[admsNodeID_bi].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_t_ti) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_t_ti) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_c_GND) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_c_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_GND) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_cx_bii) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_cx_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_exx_bii) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_exx_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ex_bii) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ex_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bii_bi) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bii_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_I_c_ci) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_I_c_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_I_e_ei) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_I_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_I_b_bi) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_I_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ti_GND) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ti_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_exx_ei) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_exx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ex_ei) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ex_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bii_ei) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bii_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bii_ci) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bii_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_bi] =  "
                 <<Jdxp_static[admsNodeID_bi] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_bi] =  "
                 <<Jdxp_dynamic[admsNodeID_bi] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_bii] =  "
                 <<staticContributions[admsNodeID_bii].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bii].dx(admsProbeID_V_t_ti) =  " <<staticContributions[admsNodeID_bii].dx(admsProbeID_V_t_ti) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bii].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_bii].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bii].dx(admsProbeID_V_c_GND) =  " <<staticContributions[admsNodeID_bii].dx(admsProbeID_V_c_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bii].dx(admsProbeID_V_b_GND) =  " <<staticContributions[admsNodeID_bii].dx(admsProbeID_V_b_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bii].dx(admsProbeID_V_cx_bii) =  " <<staticContributions[admsNodeID_bii].dx(admsProbeID_V_cx_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bii].dx(admsProbeID_V_exx_bii) =  " <<staticContributions[admsNodeID_bii].dx(admsProbeID_V_exx_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bii].dx(admsProbeID_V_ex_bii) =  " <<staticContributions[admsNodeID_bii].dx(admsProbeID_V_ex_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bii].dx(admsProbeID_V_bii_bi) =  " <<staticContributions[admsNodeID_bii].dx(admsProbeID_V_bii_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bii].dx(admsProbeID_I_c_ci) =  " <<staticContributions[admsNodeID_bii].dx(admsProbeID_I_c_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bii].dx(admsProbeID_I_e_ei) =  " <<staticContributions[admsNodeID_bii].dx(admsProbeID_I_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bii].dx(admsProbeID_I_b_bi) =  " <<staticContributions[admsNodeID_bii].dx(admsProbeID_I_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bii].dx(admsProbeID_V_ti_GND) =  " <<staticContributions[admsNodeID_bii].dx(admsProbeID_V_ti_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bii].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_bii].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bii].dx(admsProbeID_V_exx_ei) =  " <<staticContributions[admsNodeID_bii].dx(admsProbeID_V_exx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bii].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_bii].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bii].dx(admsProbeID_V_ex_ei) =  " <<staticContributions[admsNodeID_bii].dx(admsProbeID_V_ex_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bii].dx(admsProbeID_V_bii_ei) =  " <<staticContributions[admsNodeID_bii].dx(admsProbeID_V_bii_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bii].dx(admsProbeID_V_bii_ci) =  " <<staticContributions[admsNodeID_bii].dx(admsProbeID_V_bii_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bii].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_bii].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_bii] =  "
                 <<dynamicContributions[admsNodeID_bii].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_t_ti) =  " <<dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_t_ti) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_c_GND) =  " <<dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_c_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_b_GND) =  " <<dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_b_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_cx_bii) =  " <<dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_cx_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_exx_bii) =  " <<dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_exx_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_ex_bii) =  " <<dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_ex_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_bii_bi) =  " <<dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_bii_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bii].dx(admsProbeID_I_c_ci) =  " <<dynamicContributions[admsNodeID_bii].dx(admsProbeID_I_c_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bii].dx(admsProbeID_I_e_ei) =  " <<dynamicContributions[admsNodeID_bii].dx(admsProbeID_I_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bii].dx(admsProbeID_I_b_bi) =  " <<dynamicContributions[admsNodeID_bii].dx(admsProbeID_I_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_ti_GND) =  " <<dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_ti_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_exx_ei) =  " <<dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_exx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_ex_ei) =  " <<dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_ex_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_bii_ei) =  " <<dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_bii_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_bii_ci) =  " <<dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_bii_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_bii] =  "
                 <<Jdxp_static[admsNodeID_bii] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_bii] =  "
                 <<Jdxp_dynamic[admsNodeID_bii] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_ci] =  "
                 <<staticContributions[admsNodeID_ci].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_t_ti) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_t_ti) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_c_GND) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_c_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_GND) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_cx_bii) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_cx_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_exx_bii) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_exx_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_ex_bii) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_ex_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bii_bi) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_bii_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_I_c_ci) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_I_c_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_I_e_ei) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_I_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_I_b_bi) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_I_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_ti_GND) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_ti_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_exx_ei) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_exx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_ex_ei) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_ex_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bii_ei) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_bii_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bii_ci) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_bii_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_ci] =  "
                 <<dynamicContributions[admsNodeID_ci].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_t_ti) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_t_ti) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_c_GND) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_c_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_GND) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_cx_bii) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_cx_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_exx_bii) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_exx_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ex_bii) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ex_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bii_bi) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bii_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_I_c_ci) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_I_c_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_I_e_ei) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_I_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_I_b_bi) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_I_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ti_GND) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ti_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_exx_ei) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_exx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ex_ei) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ex_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bii_ei) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bii_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bii_ci) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bii_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_ci] =  "
                 <<Jdxp_static[admsNodeID_ci] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_ci] =  "
                 <<Jdxp_dynamic[admsNodeID_ci] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_ti] =  "
                 <<staticContributions[admsNodeID_ti].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ti].dx(admsProbeID_V_t_ti) =  " <<staticContributions[admsNodeID_ti].dx(admsProbeID_V_t_ti) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ti].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_ti].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ti].dx(admsProbeID_V_c_GND) =  " <<staticContributions[admsNodeID_ti].dx(admsProbeID_V_c_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ti].dx(admsProbeID_V_b_GND) =  " <<staticContributions[admsNodeID_ti].dx(admsProbeID_V_b_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ti].dx(admsProbeID_V_cx_bii) =  " <<staticContributions[admsNodeID_ti].dx(admsProbeID_V_cx_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ti].dx(admsProbeID_V_exx_bii) =  " <<staticContributions[admsNodeID_ti].dx(admsProbeID_V_exx_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ti].dx(admsProbeID_V_ex_bii) =  " <<staticContributions[admsNodeID_ti].dx(admsProbeID_V_ex_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ti].dx(admsProbeID_V_bii_bi) =  " <<staticContributions[admsNodeID_ti].dx(admsProbeID_V_bii_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ti].dx(admsProbeID_I_c_ci) =  " <<staticContributions[admsNodeID_ti].dx(admsProbeID_I_c_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ti].dx(admsProbeID_I_e_ei) =  " <<staticContributions[admsNodeID_ti].dx(admsProbeID_I_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ti].dx(admsProbeID_I_b_bi) =  " <<staticContributions[admsNodeID_ti].dx(admsProbeID_I_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ti].dx(admsProbeID_V_ti_GND) =  " <<staticContributions[admsNodeID_ti].dx(admsProbeID_V_ti_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ti].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_ti].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ti].dx(admsProbeID_V_exx_ei) =  " <<staticContributions[admsNodeID_ti].dx(admsProbeID_V_exx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ti].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_ti].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ti].dx(admsProbeID_V_ex_ei) =  " <<staticContributions[admsNodeID_ti].dx(admsProbeID_V_ex_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ti].dx(admsProbeID_V_bii_ei) =  " <<staticContributions[admsNodeID_ti].dx(admsProbeID_V_bii_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ti].dx(admsProbeID_V_bii_ci) =  " <<staticContributions[admsNodeID_ti].dx(admsProbeID_V_bii_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ti].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_ti].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_ti] =  "
                 <<dynamicContributions[admsNodeID_ti].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_t_ti) =  " <<dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_t_ti) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_c_GND) =  " <<dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_c_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_b_GND) =  " <<dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_b_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_cx_bii) =  " <<dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_cx_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_exx_bii) =  " <<dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_exx_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_ex_bii) =  " <<dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_ex_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_bii_bi) =  " <<dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_bii_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ti].dx(admsProbeID_I_c_ci) =  " <<dynamicContributions[admsNodeID_ti].dx(admsProbeID_I_c_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ti].dx(admsProbeID_I_e_ei) =  " <<dynamicContributions[admsNodeID_ti].dx(admsProbeID_I_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ti].dx(admsProbeID_I_b_bi) =  " <<dynamicContributions[admsNodeID_ti].dx(admsProbeID_I_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_ti_GND) =  " <<dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_ti_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_exx_ei) =  " <<dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_exx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_ex_ei) =  " <<dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_ex_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_bii_ei) =  " <<dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_bii_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_bii_ci) =  " <<dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_bii_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_ti] =  "
                 <<Jdxp_static[admsNodeID_ti] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_ti] =  "
                 <<Jdxp_dynamic[admsNodeID_ti] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_ex] =  "
                 <<staticContributions[admsNodeID_ex].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ex].dx(admsProbeID_V_t_ti) =  " <<staticContributions[admsNodeID_ex].dx(admsProbeID_V_t_ti) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ex].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_ex].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ex].dx(admsProbeID_V_c_GND) =  " <<staticContributions[admsNodeID_ex].dx(admsProbeID_V_c_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ex].dx(admsProbeID_V_b_GND) =  " <<staticContributions[admsNodeID_ex].dx(admsProbeID_V_b_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ex].dx(admsProbeID_V_cx_bii) =  " <<staticContributions[admsNodeID_ex].dx(admsProbeID_V_cx_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ex].dx(admsProbeID_V_exx_bii) =  " <<staticContributions[admsNodeID_ex].dx(admsProbeID_V_exx_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ex].dx(admsProbeID_V_ex_bii) =  " <<staticContributions[admsNodeID_ex].dx(admsProbeID_V_ex_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ex].dx(admsProbeID_V_bii_bi) =  " <<staticContributions[admsNodeID_ex].dx(admsProbeID_V_bii_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ex].dx(admsProbeID_I_c_ci) =  " <<staticContributions[admsNodeID_ex].dx(admsProbeID_I_c_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ex].dx(admsProbeID_I_e_ei) =  " <<staticContributions[admsNodeID_ex].dx(admsProbeID_I_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ex].dx(admsProbeID_I_b_bi) =  " <<staticContributions[admsNodeID_ex].dx(admsProbeID_I_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ex].dx(admsProbeID_V_ti_GND) =  " <<staticContributions[admsNodeID_ex].dx(admsProbeID_V_ti_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ex].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_ex].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ex].dx(admsProbeID_V_exx_ei) =  " <<staticContributions[admsNodeID_ex].dx(admsProbeID_V_exx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ex].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_ex].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ex].dx(admsProbeID_V_ex_ei) =  " <<staticContributions[admsNodeID_ex].dx(admsProbeID_V_ex_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ex].dx(admsProbeID_V_bii_ei) =  " <<staticContributions[admsNodeID_ex].dx(admsProbeID_V_bii_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ex].dx(admsProbeID_V_bii_ci) =  " <<staticContributions[admsNodeID_ex].dx(admsProbeID_V_bii_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ex].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_ex].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_ex] =  "
                 <<dynamicContributions[admsNodeID_ex].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_t_ti) =  " <<dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_t_ti) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_c_GND) =  " <<dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_c_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_b_GND) =  " <<dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_b_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_cx_bii) =  " <<dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_cx_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_exx_bii) =  " <<dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_exx_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_ex_bii) =  " <<dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_ex_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_bii_bi) =  " <<dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_bii_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ex].dx(admsProbeID_I_c_ci) =  " <<dynamicContributions[admsNodeID_ex].dx(admsProbeID_I_c_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ex].dx(admsProbeID_I_e_ei) =  " <<dynamicContributions[admsNodeID_ex].dx(admsProbeID_I_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ex].dx(admsProbeID_I_b_bi) =  " <<dynamicContributions[admsNodeID_ex].dx(admsProbeID_I_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_ti_GND) =  " <<dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_ti_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_exx_ei) =  " <<dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_exx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_ex_ei) =  " <<dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_ex_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_bii_ei) =  " <<dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_bii_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_bii_ci) =  " <<dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_bii_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_ex].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_ex] =  "
                 <<Jdxp_static[admsNodeID_ex] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_ex] =  "
                 <<Jdxp_dynamic[admsNodeID_ex] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_exx] =  "
                 <<staticContributions[admsNodeID_exx].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_exx].dx(admsProbeID_V_t_ti) =  " <<staticContributions[admsNodeID_exx].dx(admsProbeID_V_t_ti) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_exx].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_exx].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_exx].dx(admsProbeID_V_c_GND) =  " <<staticContributions[admsNodeID_exx].dx(admsProbeID_V_c_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_exx].dx(admsProbeID_V_b_GND) =  " <<staticContributions[admsNodeID_exx].dx(admsProbeID_V_b_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_exx].dx(admsProbeID_V_cx_bii) =  " <<staticContributions[admsNodeID_exx].dx(admsProbeID_V_cx_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_exx].dx(admsProbeID_V_exx_bii) =  " <<staticContributions[admsNodeID_exx].dx(admsProbeID_V_exx_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_exx].dx(admsProbeID_V_ex_bii) =  " <<staticContributions[admsNodeID_exx].dx(admsProbeID_V_ex_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_exx].dx(admsProbeID_V_bii_bi) =  " <<staticContributions[admsNodeID_exx].dx(admsProbeID_V_bii_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_exx].dx(admsProbeID_I_c_ci) =  " <<staticContributions[admsNodeID_exx].dx(admsProbeID_I_c_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_exx].dx(admsProbeID_I_e_ei) =  " <<staticContributions[admsNodeID_exx].dx(admsProbeID_I_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_exx].dx(admsProbeID_I_b_bi) =  " <<staticContributions[admsNodeID_exx].dx(admsProbeID_I_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_exx].dx(admsProbeID_V_ti_GND) =  " <<staticContributions[admsNodeID_exx].dx(admsProbeID_V_ti_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_exx].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_exx].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_exx].dx(admsProbeID_V_exx_ei) =  " <<staticContributions[admsNodeID_exx].dx(admsProbeID_V_exx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_exx].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_exx].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_exx].dx(admsProbeID_V_ex_ei) =  " <<staticContributions[admsNodeID_exx].dx(admsProbeID_V_ex_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_exx].dx(admsProbeID_V_bii_ei) =  " <<staticContributions[admsNodeID_exx].dx(admsProbeID_V_bii_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_exx].dx(admsProbeID_V_bii_ci) =  " <<staticContributions[admsNodeID_exx].dx(admsProbeID_V_bii_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_exx].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_exx].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_exx] =  "
                 <<dynamicContributions[admsNodeID_exx].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_t_ti) =  " <<dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_t_ti) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_c_GND) =  " <<dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_c_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_b_GND) =  " <<dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_b_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_cx_bii) =  " <<dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_cx_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_exx_bii) =  " <<dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_exx_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_ex_bii) =  " <<dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_ex_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_bii_bi) =  " <<dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_bii_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_exx].dx(admsProbeID_I_c_ci) =  " <<dynamicContributions[admsNodeID_exx].dx(admsProbeID_I_c_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_exx].dx(admsProbeID_I_e_ei) =  " <<dynamicContributions[admsNodeID_exx].dx(admsProbeID_I_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_exx].dx(admsProbeID_I_b_bi) =  " <<dynamicContributions[admsNodeID_exx].dx(admsProbeID_I_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_ti_GND) =  " <<dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_ti_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_exx_ei) =  " <<dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_exx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_ex_ei) =  " <<dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_ex_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_bii_ei) =  " <<dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_bii_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_bii_ci) =  " <<dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_bii_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_exx].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_exx] =  "
                 <<Jdxp_static[admsNodeID_exx] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_exx] =  "
                 <<Jdxp_dynamic[admsNodeID_exx] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_cx] =  "
                 <<staticContributions[admsNodeID_cx].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_t_ti) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_t_ti) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_c_GND) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_c_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_b_GND) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_b_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_cx_bii) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_cx_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_exx_bii) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_exx_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_ex_bii) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_ex_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_bii_bi) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_bii_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_I_c_ci) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_I_c_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_I_e_ei) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_I_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_I_b_bi) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_I_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_ti_GND) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_ti_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_exx_ei) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_exx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_ex_ei) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_ex_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_bii_ei) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_bii_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_bii_ci) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_bii_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_cx] =  "
                 <<dynamicContributions[admsNodeID_cx].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_t_ti) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_t_ti) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_c_GND) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_c_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_b_GND) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_b_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_cx_bii) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_cx_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_exx_bii) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_exx_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_ex_bii) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_ex_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bii_bi) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bii_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_I_c_ci) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_I_c_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_I_e_ei) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_I_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_I_b_bi) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_I_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_ti_GND) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_ti_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_exx_ei) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_exx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_ex_ei) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_ex_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bii_ei) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bii_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bii_ci) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bii_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_cx] =  "
                 <<Jdxp_static[admsNodeID_cx] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_cx] =  "
                 <<Jdxp_dynamic[admsNodeID_cx] << std::endl;
    Xyce::dout() << " staticContributions[admsBRA_ID_b_bi] =  "
                 <<staticContributions[admsBRA_ID_b_bi].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_t_ti) =  " <<staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_t_ti) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_c_GND) =  " <<staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_c_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_b_GND) =  " <<staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_b_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_cx_bii) =  " <<staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_cx_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_exx_bii) =  " <<staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_exx_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_ex_bii) =  " <<staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_ex_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_bii_bi) =  " <<staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_bii_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_I_c_ci) =  " <<staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_I_c_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_I_e_ei) =  " <<staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_I_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_I_b_bi) =  " <<staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_I_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_ti_GND) =  " <<staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_ti_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_exx_ei) =  " <<staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_exx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_ex_ei) =  " <<staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_ex_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_bii_ei) =  " <<staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_bii_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_bii_ci) =  " <<staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_bii_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << " dynamicContributions[admsBRA_ID_b_bi] =  "
                 <<dynamicContributions[admsBRA_ID_b_bi].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_t_ti) =  " <<dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_t_ti) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_c_GND) =  " <<dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_c_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_b_GND) =  " <<dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_b_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_cx_bii) =  " <<dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_cx_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_exx_bii) =  " <<dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_exx_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_ex_bii) =  " <<dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_ex_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_bii_bi) =  " <<dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_bii_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_I_c_ci) =  " <<dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_I_c_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_I_e_ei) =  " <<dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_I_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_I_b_bi) =  " <<dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_I_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_ti_GND) =  " <<dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_ti_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_exx_ei) =  " <<dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_exx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_ex_ei) =  " <<dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_ex_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_bii_ei) =  " <<dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_bii_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_bii_ci) =  " <<dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_bii_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << " staticContributions[admsBRA_ID_e_ei] =  "
                 <<staticContributions[admsBRA_ID_e_ei].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_t_ti) =  " <<staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_t_ti) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_c_GND) =  " <<staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_c_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_b_GND) =  " <<staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_b_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_cx_bii) =  " <<staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_cx_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_exx_bii) =  " <<staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_exx_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_ex_bii) =  " <<staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_ex_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_bii_bi) =  " <<staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_bii_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_I_c_ci) =  " <<staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_I_c_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_I_e_ei) =  " <<staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_I_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_I_b_bi) =  " <<staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_I_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_ti_GND) =  " <<staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_ti_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_exx_ei) =  " <<staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_exx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_ex_ei) =  " <<staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_ex_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_bii_ei) =  " <<staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_bii_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_bii_ci) =  " <<staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_bii_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << " dynamicContributions[admsBRA_ID_e_ei] =  "
                 <<dynamicContributions[admsBRA_ID_e_ei].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_t_ti) =  " <<dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_t_ti) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_c_GND) =  " <<dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_c_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_b_GND) =  " <<dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_b_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_cx_bii) =  " <<dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_cx_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_exx_bii) =  " <<dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_exx_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_ex_bii) =  " <<dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_ex_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_bii_bi) =  " <<dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_bii_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_I_c_ci) =  " <<dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_I_c_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_I_e_ei) =  " <<dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_I_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_I_b_bi) =  " <<dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_I_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_ti_GND) =  " <<dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_ti_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_exx_ei) =  " <<dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_exx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_ex_ei) =  " <<dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_ex_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_bii_ei) =  " <<dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_bii_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_bii_ci) =  " <<dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_bii_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << " staticContributions[admsBRA_ID_c_ci] =  "
                 <<staticContributions[admsBRA_ID_c_ci].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_t_ti) =  " <<staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_t_ti) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_c_GND) =  " <<staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_c_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_b_GND) =  " <<staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_b_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_cx_bii) =  " <<staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_cx_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_exx_bii) =  " <<staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_exx_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_ex_bii) =  " <<staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_ex_bii) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_bii_bi) =  " <<staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_bii_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_I_c_ci) =  " <<staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_I_c_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_I_e_ei) =  " <<staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_I_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_I_b_bi) =  " <<staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_I_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_ti_GND) =  " <<staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_ti_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_exx_ei) =  " <<staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_exx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_ex_ei) =  " <<staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_ex_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_bii_ei) =  " <<staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_bii_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_bii_ci) =  " <<staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_bii_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << " dynamicContributions[admsBRA_ID_c_ci] =  "
                 <<dynamicContributions[admsBRA_ID_c_ci].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_t_ti) =  " <<dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_t_ti) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_c_GND) =  " <<dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_c_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_b_GND) =  " <<dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_b_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_cx_bii) =  " <<dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_cx_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_exx_bii) =  " <<dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_exx_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_ex_bii) =  " <<dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_ex_bii) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_bii_bi) =  " <<dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_bii_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_I_c_ci) =  " <<dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_I_c_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_I_e_ei) =  " <<dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_I_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_I_b_bi) =  " <<dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_I_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_ti_GND) =  " <<dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_ti_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_exx_ei) =  " <<dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_exx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_ex_ei) =  " <<dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_ex_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_bii_ei) =  " <<dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_bii_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_bii_ci) =  " <<dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_bii_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_V_bi_ci) << std::endl;

    if (!origFlag)
      Xyce::dout() << "This step was limited by this device." << std::endl;
  }


  if (loadLeadCurrent)
  {
    // If needed, we must now copy all the data from staticContributions
    // and dynamicContributionsinto the lead current F vector
    // Must make sure all collapsed node contributions get summed into the
    // external nodes properly.
    for ( int unmappedNode=0; unmappedNode < 4 ; unmappedNode++)
    {
      leadCurrentF[unmappedNode] = 0.0;
      leadCurrentQ[unmappedNode] = 0.0;
    }
    for ( int unmappedNode=0; unmappedNode < 12; unmappedNode++)
    {
      if (nodeMap[unmappedNode] < 4 && nodeMap[unmappedNode] != -1 )
      {
        leadCurrentF[nodeMap[unmappedNode]] += staticContributions[unmappedNode].val();
        leadCurrentQ[nodeMap[unmappedNode]] += dynamicContributions[unmappedNode].val();
      }
    }
  }  
  return true;
}
  

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdFdx
// Purpose       :
// Special Notes : Load the dFdx ("static jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdFdx()
{
  bool bsuccess = true;
  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*f_bi_Equ_ti_Node_Ptr) +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_V_ti_GND);
  (*f_ci_Equ_ti_Node_Ptr) +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_ti_GND);
  (*f_bi_Equ_bi_Node_Ptr) +=  -staticContributions[admsNodeID_bi].dx(admsProbeID_V_bii_bi) +staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci);
  (*f_bi_Equ_ci_Node_Ptr) +=  -staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci);
  (*f_ci_Equ_bi_Node_Ptr) +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci);
  (*f_ci_Equ_ci_Node_Ptr) +=  -staticContributions[admsNodeID_ci].dx(admsProbeID_V_cx_ci) -staticContributions[admsNodeID_ci].dx(admsProbeID_V_bii_ci) -staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci);
  (*f_bii_Equ_ti_Node_Ptr) +=  +staticContributions[admsNodeID_bii].dx(admsProbeID_V_ti_GND);
  (*f_bii_Equ_bii_Node_Ptr) +=  -staticContributions[admsNodeID_bii].dx(admsProbeID_V_cx_bii) -staticContributions[admsNodeID_bii].dx(admsProbeID_V_exx_bii) -staticContributions[admsNodeID_bii].dx(admsProbeID_V_ex_bii) +staticContributions[admsNodeID_bii].dx(admsProbeID_V_bii_bi) +staticContributions[admsNodeID_bii].dx(admsProbeID_V_bii_ei) +staticContributions[admsNodeID_bii].dx(admsProbeID_V_bii_ci);
  (*f_bii_Equ_ci_Node_Ptr) +=  -staticContributions[admsNodeID_bii].dx(admsProbeID_V_bii_ci);
  (*f_ci_Equ_bii_Node_Ptr) +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_bii_ei) +staticContributions[admsNodeID_ci].dx(admsProbeID_V_bii_ci);
  (*f_bii_Equ_ei_Node_Ptr) +=  -staticContributions[admsNodeID_bii].dx(admsProbeID_V_bii_ei);
  (*f_ci_Equ_ei_Node_Ptr) +=  -staticContributions[admsNodeID_ci].dx(admsProbeID_V_bii_ei);
  (*f_ei_Equ_bii_Node_Ptr) +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_bii_ei) +staticContributions[admsNodeID_ei].dx(admsProbeID_V_bii_ci);
  (*f_ei_Equ_ci_Node_Ptr) +=  -staticContributions[admsNodeID_ei].dx(admsProbeID_V_bii_ci);
  (*f_ei_Equ_ti_Node_Ptr) +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_ti_GND);
  (*f_ei_Equ_ei_Node_Ptr) +=  -staticContributions[admsNodeID_ei].dx(admsProbeID_V_exx_ei) -staticContributions[admsNodeID_ei].dx(admsProbeID_V_ex_ei) -staticContributions[admsNodeID_ei].dx(admsProbeID_V_bii_ei);
  (*f_ex_Equ_ti_Node_Ptr) +=  +staticContributions[admsNodeID_ex].dx(admsProbeID_V_ti_GND);
  (*f_ex_Equ_ex_Node_Ptr) +=  +staticContributions[admsNodeID_ex].dx(admsProbeID_V_ex_bii) +staticContributions[admsNodeID_ex].dx(admsProbeID_V_ex_ei);
  (*f_ex_Equ_ei_Node_Ptr) +=  -staticContributions[admsNodeID_ex].dx(admsProbeID_V_ex_ei);
  (*f_ei_Equ_ex_Node_Ptr) +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_ex_ei);
  (*f_exx_Equ_ti_Node_Ptr) +=  +staticContributions[admsNodeID_exx].dx(admsProbeID_V_ti_GND);
  (*f_exx_Equ_exx_Node_Ptr) +=  +staticContributions[admsNodeID_exx].dx(admsProbeID_V_exx_bii) +staticContributions[admsNodeID_exx].dx(admsProbeID_V_exx_ei);
  (*f_exx_Equ_ei_Node_Ptr) +=  -staticContributions[admsNodeID_exx].dx(admsProbeID_V_exx_ei);
  (*f_ei_Equ_exx_Node_Ptr) +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_exx_ei);
  (*f_cx_Equ_ti_Node_Ptr) +=  +staticContributions[admsNodeID_cx].dx(admsProbeID_V_ti_GND);
  (*f_cx_Equ_cx_Node_Ptr) +=  +staticContributions[admsNodeID_cx].dx(admsProbeID_V_cx_bii) +staticContributions[admsNodeID_cx].dx(admsProbeID_V_cx_ci);
  (*f_cx_Equ_ci_Node_Ptr) +=  -staticContributions[admsNodeID_cx].dx(admsProbeID_V_cx_ci);
  (*f_ci_Equ_cx_Node_Ptr) +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_cx_ci);
  (*f_bii_Equ_bi_Node_Ptr) +=  -staticContributions[admsNodeID_bii].dx(admsProbeID_V_bii_bi);
  (*f_bi_Equ_bii_Node_Ptr) +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_V_bii_bi);
  (*f_ex_Equ_bii_Node_Ptr) +=  -staticContributions[admsNodeID_ex].dx(admsProbeID_V_ex_bii);
  (*f_bii_Equ_ex_Node_Ptr) +=  +staticContributions[admsNodeID_bii].dx(admsProbeID_V_ex_bii);
  (*f_exx_Equ_bii_Node_Ptr) +=  -staticContributions[admsNodeID_exx].dx(admsProbeID_V_exx_bii);
  (*f_bii_Equ_exx_Node_Ptr) +=  +staticContributions[admsNodeID_bii].dx(admsProbeID_V_exx_bii);
  (*f_cx_Equ_bii_Node_Ptr) +=  -staticContributions[admsNodeID_cx].dx(admsProbeID_V_cx_bii);
  (*f_bii_Equ_cx_Node_Ptr) +=  +staticContributions[admsNodeID_bii].dx(admsProbeID_V_cx_bii);
  (*f_ti_Equ_bi_Node_Ptr) +=  +staticContributions[admsNodeID_ti].dx(admsProbeID_V_bi_ci);
  (*f_ti_Equ_ci_Node_Ptr) +=  -staticContributions[admsNodeID_ti].dx(admsProbeID_V_bii_ci) +staticContributions[admsNodeID_ti].dx(admsProbeID_V_ci_ei) -staticContributions[admsNodeID_ti].dx(admsProbeID_V_bi_ci);
  (*f_ti_Equ_ei_Node_Ptr) +=  -staticContributions[admsNodeID_ti].dx(admsProbeID_V_bii_ei) -staticContributions[admsNodeID_ti].dx(admsProbeID_V_ci_ei);
  (*f_ti_Equ_bii_Node_Ptr) +=  +staticContributions[admsNodeID_ti].dx(admsProbeID_V_bii_ei) +staticContributions[admsNodeID_ti].dx(admsProbeID_V_bii_ci);
  (*f_ti_Equ_ti_Node_Ptr) +=  -staticContributions[admsNodeID_ti].dx(admsProbeID_V_t_ti) +staticContributions[admsNodeID_ti].dx(admsProbeID_V_ti_GND);
  (*f_t_Equ_t_Node_Ptr) +=  +staticContributions[admsNodeID_t].dx(admsProbeID_V_t_ti);
  (*f_t_Equ_ti_Node_Ptr) +=  -staticContributions[admsNodeID_t].dx(admsProbeID_V_t_ti);
  (*f_ti_Equ_t_Node_Ptr) +=  +staticContributions[admsNodeID_ti].dx(admsProbeID_V_t_ti);
  (*f_c_Equ_BRA_c_ci_Var_Ptr) += staticContributions[admsNodeID_c].dx(admsProbeID_I_c_ci);
  (*f_b_Equ_BRA_b_bi_Var_Ptr) += staticContributions[admsNodeID_b].dx(admsProbeID_I_b_bi);
  (*f_e_Equ_BRA_e_ei_Var_Ptr) += staticContributions[admsNodeID_e].dx(admsProbeID_I_e_ei);
  (*f_ei_Equ_BRA_e_ei_Var_Ptr) += staticContributions[admsNodeID_ei].dx(admsProbeID_I_e_ei);
  (*f_bi_Equ_BRA_b_bi_Var_Ptr) += staticContributions[admsNodeID_bi].dx(admsProbeID_I_b_bi);
  (*f_ci_Equ_BRA_c_ci_Var_Ptr) += staticContributions[admsNodeID_ci].dx(admsProbeID_I_c_ci);
  // there also need to be extra loads for branch b,bi
  // Load for branch b,bi equ var b
  (*f_BRA_b_bi_Equ_b_Node_Ptr) +=  -1;
  // Load for branch b,bi equ var bi
  (*f_BRA_b_bi_Equ_bi_Node_Ptr) +=  +1;
  //load for branch b,bi equ branch b,bi var
  (*f_BRA_b_bi_Equ_BRA_b_bi_Var_Ptr) += staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_I_b_bi);
  // there also need to be extra loads for branch e,ei
  // Load for branch e,ei equ var e
  (*f_BRA_e_ei_Equ_e_Node_Ptr) +=  -1;
  // Load for branch e,ei equ var ei
  (*f_BRA_e_ei_Equ_ei_Node_Ptr) +=  +1;
  //load for branch e,ei equ branch e,ei var
  (*f_BRA_e_ei_Equ_BRA_e_ei_Var_Ptr) += staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_I_e_ei);
  // there also need to be extra loads for branch c,ci
  // Load for branch c,ci equ var c
  (*f_BRA_c_ci_Equ_c_Node_Ptr) +=  -1;
  // Load for branch c,ci equ var ci
  (*f_BRA_c_ci_Equ_ci_Node_Ptr) +=  +1;
  //load for branch c,ci equ branch c,ci var
  (*f_BRA_c_ci_Equ_BRA_c_ci_Var_Ptr) += staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_I_c_ci);

#else
  //use the offsets instead of pointers
  dFdx[li_bi][A_bi_Equ_ti_NodeOffset] +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_V_ti_GND);
  dFdx[li_ci][A_ci_Equ_ti_NodeOffset] +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_ti_GND);
  dFdx[li_bi][A_bi_Equ_bi_NodeOffset] +=  -staticContributions[admsNodeID_bi].dx(admsProbeID_V_bii_bi) +staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci);
  dFdx[li_bi][A_bi_Equ_ci_NodeOffset] +=  -staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci);
  dFdx[li_ci][A_ci_Equ_bi_NodeOffset] +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci);
  dFdx[li_ci][A_ci_Equ_ci_NodeOffset] +=  -staticContributions[admsNodeID_ci].dx(admsProbeID_V_cx_ci) -staticContributions[admsNodeID_ci].dx(admsProbeID_V_bii_ci) -staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci);
  dFdx[li_bii][A_bii_Equ_ti_NodeOffset] +=  +staticContributions[admsNodeID_bii].dx(admsProbeID_V_ti_GND);
  dFdx[li_bii][A_bii_Equ_bii_NodeOffset] +=  -staticContributions[admsNodeID_bii].dx(admsProbeID_V_cx_bii) -staticContributions[admsNodeID_bii].dx(admsProbeID_V_exx_bii) -staticContributions[admsNodeID_bii].dx(admsProbeID_V_ex_bii) +staticContributions[admsNodeID_bii].dx(admsProbeID_V_bii_bi) +staticContributions[admsNodeID_bii].dx(admsProbeID_V_bii_ei) +staticContributions[admsNodeID_bii].dx(admsProbeID_V_bii_ci);
  dFdx[li_bii][A_bii_Equ_ci_NodeOffset] +=  -staticContributions[admsNodeID_bii].dx(admsProbeID_V_bii_ci);
  dFdx[li_ci][A_ci_Equ_bii_NodeOffset] +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_bii_ei) +staticContributions[admsNodeID_ci].dx(admsProbeID_V_bii_ci);
  dFdx[li_bii][A_bii_Equ_ei_NodeOffset] +=  -staticContributions[admsNodeID_bii].dx(admsProbeID_V_bii_ei);
  dFdx[li_ci][A_ci_Equ_ei_NodeOffset] +=  -staticContributions[admsNodeID_ci].dx(admsProbeID_V_bii_ei);
  dFdx[li_ei][A_ei_Equ_bii_NodeOffset] +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_bii_ei) +staticContributions[admsNodeID_ei].dx(admsProbeID_V_bii_ci);
  dFdx[li_ei][A_ei_Equ_ci_NodeOffset] +=  -staticContributions[admsNodeID_ei].dx(admsProbeID_V_bii_ci);
  dFdx[li_ei][A_ei_Equ_ti_NodeOffset] +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_ti_GND);
  dFdx[li_ei][A_ei_Equ_ei_NodeOffset] +=  -staticContributions[admsNodeID_ei].dx(admsProbeID_V_exx_ei) -staticContributions[admsNodeID_ei].dx(admsProbeID_V_ex_ei) -staticContributions[admsNodeID_ei].dx(admsProbeID_V_bii_ei);
  dFdx[li_ex][A_ex_Equ_ti_NodeOffset] +=  +staticContributions[admsNodeID_ex].dx(admsProbeID_V_ti_GND);
  dFdx[li_ex][A_ex_Equ_ex_NodeOffset] +=  +staticContributions[admsNodeID_ex].dx(admsProbeID_V_ex_bii) +staticContributions[admsNodeID_ex].dx(admsProbeID_V_ex_ei);
  dFdx[li_ex][A_ex_Equ_ei_NodeOffset] +=  -staticContributions[admsNodeID_ex].dx(admsProbeID_V_ex_ei);
  dFdx[li_ei][A_ei_Equ_ex_NodeOffset] +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_ex_ei);
  dFdx[li_exx][A_exx_Equ_ti_NodeOffset] +=  +staticContributions[admsNodeID_exx].dx(admsProbeID_V_ti_GND);
  dFdx[li_exx][A_exx_Equ_exx_NodeOffset] +=  +staticContributions[admsNodeID_exx].dx(admsProbeID_V_exx_bii) +staticContributions[admsNodeID_exx].dx(admsProbeID_V_exx_ei);
  dFdx[li_exx][A_exx_Equ_ei_NodeOffset] +=  -staticContributions[admsNodeID_exx].dx(admsProbeID_V_exx_ei);
  dFdx[li_ei][A_ei_Equ_exx_NodeOffset] +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_exx_ei);
  dFdx[li_cx][A_cx_Equ_ti_NodeOffset] +=  +staticContributions[admsNodeID_cx].dx(admsProbeID_V_ti_GND);
  dFdx[li_cx][A_cx_Equ_cx_NodeOffset] +=  +staticContributions[admsNodeID_cx].dx(admsProbeID_V_cx_bii) +staticContributions[admsNodeID_cx].dx(admsProbeID_V_cx_ci);
  dFdx[li_cx][A_cx_Equ_ci_NodeOffset] +=  -staticContributions[admsNodeID_cx].dx(admsProbeID_V_cx_ci);
  dFdx[li_ci][A_ci_Equ_cx_NodeOffset] +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_cx_ci);
  dFdx[li_bii][A_bii_Equ_bi_NodeOffset] +=  -staticContributions[admsNodeID_bii].dx(admsProbeID_V_bii_bi);
  dFdx[li_bi][A_bi_Equ_bii_NodeOffset] +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_V_bii_bi);
  dFdx[li_ex][A_ex_Equ_bii_NodeOffset] +=  -staticContributions[admsNodeID_ex].dx(admsProbeID_V_ex_bii);
  dFdx[li_bii][A_bii_Equ_ex_NodeOffset] +=  +staticContributions[admsNodeID_bii].dx(admsProbeID_V_ex_bii);
  dFdx[li_exx][A_exx_Equ_bii_NodeOffset] +=  -staticContributions[admsNodeID_exx].dx(admsProbeID_V_exx_bii);
  dFdx[li_bii][A_bii_Equ_exx_NodeOffset] +=  +staticContributions[admsNodeID_bii].dx(admsProbeID_V_exx_bii);
  dFdx[li_cx][A_cx_Equ_bii_NodeOffset] +=  -staticContributions[admsNodeID_cx].dx(admsProbeID_V_cx_bii);
  dFdx[li_bii][A_bii_Equ_cx_NodeOffset] +=  +staticContributions[admsNodeID_bii].dx(admsProbeID_V_cx_bii);
  dFdx[li_ti][A_ti_Equ_bi_NodeOffset] +=  +staticContributions[admsNodeID_ti].dx(admsProbeID_V_bi_ci);
  dFdx[li_ti][A_ti_Equ_ci_NodeOffset] +=  -staticContributions[admsNodeID_ti].dx(admsProbeID_V_bii_ci) +staticContributions[admsNodeID_ti].dx(admsProbeID_V_ci_ei) -staticContributions[admsNodeID_ti].dx(admsProbeID_V_bi_ci);
  dFdx[li_ti][A_ti_Equ_ei_NodeOffset] +=  -staticContributions[admsNodeID_ti].dx(admsProbeID_V_bii_ei) -staticContributions[admsNodeID_ti].dx(admsProbeID_V_ci_ei);
  dFdx[li_ti][A_ti_Equ_bii_NodeOffset] +=  +staticContributions[admsNodeID_ti].dx(admsProbeID_V_bii_ei) +staticContributions[admsNodeID_ti].dx(admsProbeID_V_bii_ci);
  dFdx[li_ti][A_ti_Equ_ti_NodeOffset] +=  -staticContributions[admsNodeID_ti].dx(admsProbeID_V_t_ti) +staticContributions[admsNodeID_ti].dx(admsProbeID_V_ti_GND);
  dFdx[li_t][A_t_Equ_t_NodeOffset] +=  +staticContributions[admsNodeID_t].dx(admsProbeID_V_t_ti);
  dFdx[li_t][A_t_Equ_ti_NodeOffset] +=  -staticContributions[admsNodeID_t].dx(admsProbeID_V_t_ti);
  dFdx[li_ti][A_ti_Equ_t_NodeOffset] +=  +staticContributions[admsNodeID_ti].dx(admsProbeID_V_t_ti);
  dFdx[li_c][A_c_Equ_BRA_c_ci_Var_Offset] += staticContributions[admsNodeID_c].dx(admsProbeID_I_c_ci);
  dFdx[li_b][A_b_Equ_BRA_b_bi_Var_Offset] += staticContributions[admsNodeID_b].dx(admsProbeID_I_b_bi);
  dFdx[li_e][A_e_Equ_BRA_e_ei_Var_Offset] += staticContributions[admsNodeID_e].dx(admsProbeID_I_e_ei);
  dFdx[li_ei][A_ei_Equ_BRA_e_ei_Var_Offset] += staticContributions[admsNodeID_ei].dx(admsProbeID_I_e_ei);
  dFdx[li_bi][A_bi_Equ_BRA_b_bi_Var_Offset] += staticContributions[admsNodeID_bi].dx(admsProbeID_I_b_bi);
  dFdx[li_ci][A_ci_Equ_BRA_c_ci_Var_Offset] += staticContributions[admsNodeID_ci].dx(admsProbeID_I_c_ci);
  // there also need to be extra loads for branch b,bi
  // Load for branch b,bi equ var b
  dFdx[li_BRA_b_bi][A_BRA_b_bi_Equ_b_Node_Offset] +=  -1;
  // Load for branch b,bi equ var bi
  dFdx[li_BRA_b_bi][A_BRA_b_bi_Equ_bi_Node_Offset] +=  +1;
  //load for branch b,bi equ branch b,bi var
  dFdx[li_BRA_b_bi][A_BRA_b_bi_Equ_BRA_b_bi_Var_Offset] += staticContributions[admsBRA_ID_b_bi].dx(admsProbeID_I_b_bi);
  // there also need to be extra loads for branch e,ei
  // Load for branch e,ei equ var e
  dFdx[li_BRA_e_ei][A_BRA_e_ei_Equ_e_Node_Offset] +=  -1;
  // Load for branch e,ei equ var ei
  dFdx[li_BRA_e_ei][A_BRA_e_ei_Equ_ei_Node_Offset] +=  +1;
  //load for branch e,ei equ branch e,ei var
  dFdx[li_BRA_e_ei][A_BRA_e_ei_Equ_BRA_e_ei_Var_Offset] += staticContributions[admsBRA_ID_e_ei].dx(admsProbeID_I_e_ei);
  // there also need to be extra loads for branch c,ci
  // Load for branch c,ci equ var c
  dFdx[li_BRA_c_ci][A_BRA_c_ci_Equ_c_Node_Offset] +=  -1;
  // Load for branch c,ci equ var ci
  dFdx[li_BRA_c_ci][A_BRA_c_ci_Equ_ci_Node_Offset] +=  +1;
  //load for branch c,ci equ branch c,ci var
  dFdx[li_BRA_c_ci][A_BRA_c_ci_Equ_BRA_c_ci_Var_Offset] += staticContributions[admsBRA_ID_c_ci].dx(admsProbeID_I_c_ci);

#endif
  
  return bsuccess;
}


//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdQdx
// Purpose       :
// Special Notes : Load the dQdx ("dynamic jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdQdx()
{
  bool bsuccess = true;
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*q_bi_Equ_ti_Node_Ptr) +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ti_GND);
  (*q_ci_Equ_ti_Node_Ptr) +=  +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ti_GND);
  (*q_bi_Equ_bi_Node_Ptr) +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci);
  (*q_bi_Equ_ci_Node_Ptr) +=  -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci);
  (*q_ci_Equ_bi_Node_Ptr) +=  +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci);
  (*q_ci_Equ_ci_Node_Ptr) +=  -dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bii_ci) -dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci);
  (*q_bii_Equ_ti_Node_Ptr) +=  +dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_ti_GND);
  (*q_bii_Equ_bii_Node_Ptr) +=  +dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_bii_ei) +dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_bii_ci);
  (*q_bii_Equ_ci_Node_Ptr) +=  +dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_ci_ei) -dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_bii_ci);
  (*q_ci_Equ_bii_Node_Ptr) +=  +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bii_ei) +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bii_ci);
  (*q_bii_Equ_ei_Node_Ptr) +=  -dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_ci_ei) -dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_bii_ei);
  (*q_ci_Equ_ei_Node_Ptr) +=  -dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bii_ei);
  (*q_ei_Equ_bii_Node_Ptr) +=  +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bii_ei) +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bii_ci);
  (*q_ei_Equ_ci_Node_Ptr) +=  -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bii_ci) +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei);
  (*q_ei_Equ_ti_Node_Ptr) +=  +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ti_GND);
  (*q_ei_Equ_ei_Node_Ptr) +=  -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bii_ei) -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei);
  (*q_b_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_GND);
  (*q_c_Equ_c_Node_Ptr) +=  -dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_c].dx(admsProbeID_V_c_GND);
  (*q_b_Equ_c_Node_Ptr) +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c);
  (*q_c_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c);
  (*q_ti_Equ_ti_Node_Ptr) +=  -dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_t_ti);
  (*q_t_Equ_t_Node_Ptr) +=  +dynamicContributions[admsNodeID_t].dx(admsProbeID_V_t_ti);
  (*q_t_Equ_ti_Node_Ptr) +=  -dynamicContributions[admsNodeID_t].dx(admsProbeID_V_t_ti);
  (*q_ti_Equ_t_Node_Ptr) +=  +dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_t_ti);
  (*q_c_Equ_BRA_c_ci_Var_Ptr) += dynamicContributions[admsNodeID_c].dx(admsProbeID_I_c_ci);
  (*q_b_Equ_BRA_b_bi_Var_Ptr) += dynamicContributions[admsNodeID_b].dx(admsProbeID_I_b_bi);
  (*q_e_Equ_BRA_e_ei_Var_Ptr) += dynamicContributions[admsNodeID_e].dx(admsProbeID_I_e_ei);
  (*q_ei_Equ_BRA_e_ei_Var_Ptr) += dynamicContributions[admsNodeID_ei].dx(admsProbeID_I_e_ei);
  (*q_bi_Equ_BRA_b_bi_Var_Ptr) += dynamicContributions[admsNodeID_bi].dx(admsProbeID_I_b_bi);
  (*q_ci_Equ_BRA_c_ci_Var_Ptr) += dynamicContributions[admsNodeID_ci].dx(admsProbeID_I_c_ci);
  // there also need to be extra loads for branch b,bi
  // Load for branch b,bi equ var b
  // Load for branch b,bi equ var bi
  //load for branch b,bi equ branch b,bi var
  (*q_BRA_b_bi_Equ_BRA_b_bi_Var_Ptr) += dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_I_b_bi);
  // there also need to be extra loads for branch e,ei
  // Load for branch e,ei equ var e
  // Load for branch e,ei equ var ei
  //load for branch e,ei equ branch e,ei var
  (*q_BRA_e_ei_Equ_BRA_e_ei_Var_Ptr) += dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_I_e_ei);
  // there also need to be extra loads for branch c,ci
  // Load for branch c,ci equ var c
  // Load for branch c,ci equ var ci
  //load for branch c,ci equ branch c,ci var
  (*q_BRA_c_ci_Equ_BRA_c_ci_Var_Ptr) += dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_I_c_ci);

#else
  //use the offsets instead of pointers
  dQdx[li_bi][A_bi_Equ_ti_NodeOffset] +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ti_GND);
  dQdx[li_ci][A_ci_Equ_ti_NodeOffset] +=  +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ti_GND);
  dQdx[li_bi][A_bi_Equ_bi_NodeOffset] +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci);
  dQdx[li_bi][A_bi_Equ_ci_NodeOffset] +=  -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci);
  dQdx[li_ci][A_ci_Equ_bi_NodeOffset] +=  +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci);
  dQdx[li_ci][A_ci_Equ_ci_NodeOffset] +=  -dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bii_ci) -dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci);
  dQdx[li_bii][A_bii_Equ_ti_NodeOffset] +=  +dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_ti_GND);
  dQdx[li_bii][A_bii_Equ_bii_NodeOffset] +=  +dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_bii_ei) +dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_bii_ci);
  dQdx[li_bii][A_bii_Equ_ci_NodeOffset] +=  +dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_ci_ei) -dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_bii_ci);
  dQdx[li_ci][A_ci_Equ_bii_NodeOffset] +=  +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bii_ei) +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bii_ci);
  dQdx[li_bii][A_bii_Equ_ei_NodeOffset] +=  -dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_ci_ei) -dynamicContributions[admsNodeID_bii].dx(admsProbeID_V_bii_ei);
  dQdx[li_ci][A_ci_Equ_ei_NodeOffset] +=  -dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bii_ei);
  dQdx[li_ei][A_ei_Equ_bii_NodeOffset] +=  +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bii_ei) +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bii_ci);
  dQdx[li_ei][A_ei_Equ_ci_NodeOffset] +=  -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bii_ci) +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei);
  dQdx[li_ei][A_ei_Equ_ti_NodeOffset] +=  +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ti_GND);
  dQdx[li_ei][A_ei_Equ_ei_NodeOffset] +=  -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bii_ei) -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei);
  dQdx[li_b][A_b_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_GND);
  dQdx[li_c][A_c_Equ_c_NodeOffset] +=  -dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_c].dx(admsProbeID_V_c_GND);
  dQdx[li_b][A_b_Equ_c_NodeOffset] +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c);
  dQdx[li_c][A_c_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c);
  dQdx[li_ti][A_ti_Equ_ti_NodeOffset] +=  -dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_t_ti);
  dQdx[li_t][A_t_Equ_t_NodeOffset] +=  +dynamicContributions[admsNodeID_t].dx(admsProbeID_V_t_ti);
  dQdx[li_t][A_t_Equ_ti_NodeOffset] +=  -dynamicContributions[admsNodeID_t].dx(admsProbeID_V_t_ti);
  dQdx[li_ti][A_ti_Equ_t_NodeOffset] +=  +dynamicContributions[admsNodeID_ti].dx(admsProbeID_V_t_ti);
  dQdx[li_c][A_c_Equ_BRA_c_ci_Var_Offset] += dynamicContributions[admsNodeID_c].dx(admsProbeID_I_c_ci);
  dQdx[li_b][A_b_Equ_BRA_b_bi_Var_Offset] += dynamicContributions[admsNodeID_b].dx(admsProbeID_I_b_bi);
  dQdx[li_e][A_e_Equ_BRA_e_ei_Var_Offset] += dynamicContributions[admsNodeID_e].dx(admsProbeID_I_e_ei);
  dQdx[li_ei][A_ei_Equ_BRA_e_ei_Var_Offset] += dynamicContributions[admsNodeID_ei].dx(admsProbeID_I_e_ei);
  dQdx[li_bi][A_bi_Equ_BRA_b_bi_Var_Offset] += dynamicContributions[admsNodeID_bi].dx(admsProbeID_I_b_bi);
  dQdx[li_ci][A_ci_Equ_BRA_c_ci_Var_Offset] += dynamicContributions[admsNodeID_ci].dx(admsProbeID_I_c_ci);
  // there also need to be extra loads for branch b,bi
  // Load for branch b,bi equ var b
  // Load for branch b,bi equ var bi
  //load for branch b,bi equ branch b,bi var
  dQdx[li_BRA_b_bi][A_BRA_b_bi_Equ_BRA_b_bi_Var_Offset] += dynamicContributions[admsBRA_ID_b_bi].dx(admsProbeID_I_b_bi);
  // there also need to be extra loads for branch e,ei
  // Load for branch e,ei equ var e
  // Load for branch e,ei equ var ei
  //load for branch e,ei equ branch e,ei var
  dQdx[li_BRA_e_ei][A_BRA_e_ei_Equ_BRA_e_ei_Var_Offset] += dynamicContributions[admsBRA_ID_e_ei].dx(admsProbeID_I_e_ei);
  // there also need to be extra loads for branch c,ci
  // Load for branch c,ci equ var c
  // Load for branch c,ci equ var ci
  //load for branch c,ci equ branch c,ci var
  dQdx[li_BRA_c_ci][A_BRA_c_ci_Equ_BRA_c_ci_Var_Offset] += dynamicContributions[admsBRA_ID_c_ci].dx(admsProbeID_I_c_ci);

  
#endif
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateTemperature
// Purpose       : Set temperature and update any parameters that depend on it
// Special Notes : In Xyce ADMS, we'll simply copy the temperature, which is
//                 in Kelvin, to our "admsTemperature" variable, which needs
//                 to be in Celsius.
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateTemperature(const double & temperatureTemp)
{

  admsTemperature = temperatureTemp;
  adms_vt_nom = adms_vt(temperatureTemp);

  return true;
}

// Class Model
//-----------------------------------------------------------------------------
// Function      : Model::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Model::processParams()
{

  // Set any non-constant parameter defaults:
  // Set any parameters that were not given and whose defaults depend on other
  // parameters:

  // set internal model type based on model card type
  if (getType() == "pnp" || getType() == "PNP")
    dtype = -1;



  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

  //    Parameter Mode : [ 0, 4 ]
  if ( (!((Mode >=0 && Mode <=4 ))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Mode value " << Mode << " out of range [ 0, 4 ]";
  }

  //    Parameter Noise : [ 0, 4 ]
  if ( (!((Noise >=0 && Noise <=4 ))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Noise value " << Noise << " out of range [ 0, 4 ]";
  }

  //    Parameter Debug : [ 0,  (+inf) [
  if ( (!((Debug >=0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Debug value " << Debug << " out of range [ 0,  (+inf) [";
  }

  //    Parameter DebugPlus : [ 0,  (+inf) [
  if ( (!((DebugPlus >=0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter DebugPlus value " << DebugPlus << " out of range [ 0,  (+inf) [";
  }

  //    Parameter Temp : [ (-273.15),  (+inf) [
  if ( (!((Temp >=(-273.15)))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Temp value " << Temp << " out of range [ (-273.15),  (+inf) [";
  }

  //    Parameter Rth : [ 0.0,  (+inf) [
  if ( (!((Rth >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Rth value " << Rth << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter Cth : [ 0.0,  (+inf) [
  if ( (!((Cth >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Cth value " << Cth << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter N : ] 0,  (+inf) [
  if ( (!((N >0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter N value " << N << " out of range ] 0,  (+inf) [";
  }

  //    Parameter L : ] 0.0,  (+inf) [
  if ( (!((L >0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter L value " << L << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter W : ] 0.0,  (+inf) [
  if ( (!((W >0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter W value " << W << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter Jsf : [ 0.0,  (+inf) [
  if ( (!((Jsf >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Jsf value " << Jsf << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter nf : [ 0.0,  (+inf) [
  if ( (!((nf >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter nf value " << nf << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter Vg : [ (-2.0),  (+inf) [
  if ( (!((Vg >=(-2.0)))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Vg value " << Vg << " out of range [ (-2.0),  (+inf) [";
  }

  //    Parameter Jse : [ 0.0,  (+inf) [
  if ( (!((Jse >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Jse value " << Jse << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter ne : [ 0.0,  (+inf) [
  if ( (!((ne >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter ne value " << ne << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter Rbxx : ] 0.0,  (+inf) [
  if ( (!((Rbxx >0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Rbxx value " << Rbxx << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter Vgb : [ 0.0,  (+inf) [
  if ( (!((Vgb >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Vgb value " << Vgb << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter Jsee : [ 0.0,  (+inf) [
  if ( (!((Jsee >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Jsee value " << Jsee << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter nee : [ 0.0,  (+inf) [
  if ( (!((nee >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter nee value " << nee << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter Rbbxx : ] 0.0,  (+inf) [
  if ( (!((Rbbxx >0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Rbbxx value " << Rbbxx << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter Vgbb : [ 0.0,  (+inf) [
  if ( (!((Vgbb >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Vgbb value " << Vgbb << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter Jsr : [ 0.0,  (+inf) [
  if ( (!((Jsr >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Jsr value " << Jsr << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter nr : [ 0.0,  (+inf) [
  if ( (!((nr >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter nr value " << nr << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter Vgr : [ 0.0,  (+inf) [
  if ( (!((Vgr >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Vgr value " << Vgr << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter XCjc : [ 0.0, 1.0 [
  if ( (!((XCjc >=0.0 && XCjc <1.0 ))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter XCjc value " << XCjc << " out of range [ 0.0, 1.0 [";
  }

  //    Parameter Jsc : [ 0.0,  (+inf) [
  if ( (!((Jsc >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Jsc value " << Jsc << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter nc : [ 0.0,  (+inf) [
  if ( (!((nc >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter nc value " << nc << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter Rcxx : ] 0.0,  (+inf) [
  if ( (!((Rcxx >0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Rcxx value " << Rcxx << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter Vgc : [ 0.0,  (+inf) [
  if ( (!((Vgc >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Vgc value " << Vgc << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter Bf : [ 0.0,  (+inf) [
  if ( (!((Bf >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Bf value " << Bf << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter kBeta : [ 0.0,  (+inf) [
  if ( (!((kBeta >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter kBeta value " << kBeta << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter Br : [ 0.0,  (+inf) [
  if ( (!((Br >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Br value " << Br << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter VAF : [ 0.0,  (+inf) [
  if ( (!((VAF >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter VAF value " << VAF << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter VAR : [ 0.0,  (+inf) [
  if ( (!((VAR >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter VAR value " << VAR << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter IKF : [ 0.0,  (+inf) [
  if ( (!((IKF >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter IKF value " << IKF << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter IKR : [ 0.0,  (+inf) [
  if ( (!((IKR >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter IKR value " << IKR << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter Mc : [ 0.0,  (+inf) [
  if ( (!((Mc >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Mc value " << Mc << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter BVceo : [ 0.0,  (+inf) [
  if ( (!((BVceo >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter BVceo value " << BVceo << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter kc : [ 0.0,  (+inf) [
  if ( (!((kc >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter kc value " << kc << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter BVebo : [ 0.0,  (+inf) [
  if ( (!((BVebo >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter BVebo value " << BVebo << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter Tr : [ 0.0,  (+inf) [
  if ( (!((Tr >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Tr value " << Tr << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter Trx : [ 0.0,  (+inf) [
  if ( (!((Trx >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Trx value " << Trx << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter Tf : [ 0.0,  (+inf) [
  if ( (!((Tf >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Tf value " << Tf << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter Tft : [ 0.0,  (+inf) [
  if ( (!((Tft >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Tft value " << Tft << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter Thcs : [ 0.0,  (+inf) [
  if ( (!((Thcs >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Thcs value " << Thcs << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter Ahc : [ 0.0,  (+inf) [
  if ( (!((Ahc >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Ahc value " << Ahc << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter Cje : [ 0.0,  (+inf) [
  if ( (!((Cje >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Cje value " << Cje << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter mje : [ 0.0, 1 [
  if ( (!((mje >=0.0 && mje <1 ))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter mje value " << mje << " out of range [ 0.0, 1 [";
  }

  //    Parameter Vje : [ 0.0,  (+inf) [
  if ( (!((Vje >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Vje value " << Vje << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter Cjc : [ 0.0,  (+inf) [
  if ( (!((Cjc >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Cjc value " << Cjc << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter mjc : [ 0.0,  (+inf) [
  if ( (!((mjc >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter mjc value " << mjc << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter Vjc : [ 0.0,  (+inf) [
  if ( (!((Vjc >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Vjc value " << Vjc << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter kjc :  ] (-inf)  (+inf) [

  //    Parameter Cmin : [ 0.0,  (+inf) [
  if ( (!((Cmin >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Cmin value " << Cmin << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter J0 : [ 0.0,  (+inf) [
  if ( (!((J0 >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter J0 value " << J0 << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter XJ0 : [ 0.0, 1.0 ]
  if ( (!((XJ0 >=0.0 && XJ0 <=1.0 ))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter XJ0 value " << XJ0 << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter Rci0 : ] 0.0,  (+inf) [
  if ( (!((Rci0 >0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Rci0 value " << Rci0 << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter Jk : [ 0.0,  (+inf) [
  if ( (!((Jk >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Jk value " << Jk << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter RJk : [ 0.0,  (+inf) [
  if ( (!((RJk >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter RJk value " << RJk << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter Vces : [ 0.0,  (+inf) [
  if ( (!((Vces >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Vces value " << Vces << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter Rc : ] 0.0,  (+inf) [
  if ( (!((Rc >0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Rc value " << Rc << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter Re : ] 0.0,  (+inf) [
  if ( (!((Re >0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Re value " << Re << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter Rb : ] 0.0,  (+inf) [
  if ( (!((Rb >0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Rb value " << Rb << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter Rb2 : ] 0.0,  (+inf) [
  if ( (!((Rb2 >0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Rb2 value " << Rb2 << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter Lc : [ 0.0,  (+inf) [
  if ( (!((Lc >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Lc value " << Lc << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter Le : [ 0.0,  (+inf) [
  if ( (!((Le >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Le value " << Le << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter Lb : [ 0.0,  (+inf) [
  if ( (!((Lb >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Lb value " << Lb << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter Cq : [ 0.0,  (+inf) [
  if ( (!((Cq >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Cq value " << Cq << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter Cpb : [ 0.0,  (+inf) [
  if ( (!((Cpb >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Cpb value " << Cpb << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter Cpc : [ 0.0,  (+inf) [
  if ( (!((Cpc >=0.0))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Cpc value " << Cpc << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter Tnom : [ (-273.15),  (+inf) [
  if ( (!((Tnom >=(-273.15)))) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter Tnom value " << Tnom << " out of range [ (-273.15),  (+inf) [";
  }

  //    Parameter dtype : [ (-1), 1 ][ 0, 0 ]
  if ( (!((dtype >=(-1) && dtype <=1 )) || (dtype >=0 && dtype <=0 )) )
  {
    UserError0(*this) << "ADMSHBT_X: Parameter dtype value " << dtype << " out of range [ (-1), 1 ] or in excluded range [ 0, 0 ]";
  }

  // and of course, this routine is where we should put the initial_model
  // stuff


  return true;
}
//----------------------------------------------------------------------------
// Function      : Model::processInstanceParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//----------------------------------------------------------------------------
bool Model::processInstanceParams()
{

  std::vector<Instance*>::iterator iter;
  std::vector<Instance*>::iterator first = instanceContainer.begin();
  std::vector<Instance*>::iterator last  = instanceContainer.end();

  for (iter=first; iter!=last; ++iter)
  {
    (*iter)->processParams();
  }

  return true;
}

//-----------------------------------------------------------------------------
// Function      : Model::Model
// Purpose       : model block constructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::Model(
   const Configuration & configuration,
   const ModelBlock &    model_block,
   const FactoryBlock &  factory_block)
  : DeviceModel(model_block, configuration.getModelParameters(), factory_block),
    Mode(1),
    Noise(1),
    Debug(0),
    DebugPlus(0),
    Temp(25.0),
    Rth(0.1),
    Cth(700*1.0e-9),
    N(1),
    L(30*1.0e-6),
    W(3*1.0e-6),
    Jsf(20e-24),
    nf(1.0),
    Vg(1.3),
    Jse(0.0),
    ne(0.0),
    Rbxx(1e6),
    Vgb(0.0),
    Jsee(0.0),
    nee(0.0),
    Rbbxx(1e6),
    Vgbb(0.0),
    Jsr(20e-18),
    nr(1.0),
    Vgr(0.0),
    XCjc(0.5),
    Jsc(0.0),
    nc(0.0),
    Rcxx(1e6),
    Vgc(0.0),
    Bf(100.0),
    kBeta(0.0),
    Br(1.0),
    VAF(0.0),
    VAR(0.0),
    IKF(0.0),
    IKR(0.0),
    Mc(0.0),
    BVceo(0.0),
    kc(0.0),
    BVebo(0.0),
    Tr(1*1.0e-15),
    Trx(1*1.0e-15),
    Tf(1*1.0e-12),
    Tft(0.0),
    Thcs(0.0),
    Ahc(0.0),
    Cje(1*1.0e-15),
    mje(0.5),
    Vje(1.3),
    Cjc(1*1.0e-15),
    mjc(0.5),
    Vjc(1.3),
    kjc(1.0),
    Cmin(0.1*1.0e-15),
    J0(1e-3),
    XJ0(1.0),
    Rci0(1e-3),
    Jk(4e-4),
    RJk(1e-3),
    Vces(1e-3),
    Rc(1.0),
    Re(1.0),
    Rb(1.0),
    Rb2(1.0),
    Lc(0.0),
    Le(0.0),
    Lb(0.0),
    Cq(0.0),
    Cpb(0.0),
    Cpc(0.0),
    Tnom(20.0),
    dtype(1)
{
  // Set params to constant default values (from parTable):
  setDefaultParams();

  // Set params according to .model line and constant defaults from metadata:
  setModParams(model_block.params);

  if (!given("XYCEADMSMODTEMP"))
    admsModTemp=getDeviceOptions().temp.getImmutableValue<double>();

  // Calculate any parameters specified as expressions:

  updateDependentParameters();

  // calculate dependent (ie computed) params and check for errors:
  processParams();
}

//-----------------------------------------------------------------------------
// Function      : Model::~Model
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::~Model()
{
  std::vector<Instance*>::iterator iterI;
  std::vector<Instance*>::iterator firstI = instanceContainer.begin ();
  std::vector<Instance*>::iterator lastI  = instanceContainer.end ();

  // loop over instances:
  for (iterI = firstI; iterI != lastI; ++iterI)
  {
    delete (*iterI);
  }
}

//-----------------------------------------------------------------------------
// Function      : Model::printOutInstances
// Purpose       : debugging tool.
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
std::ostream &Model::printOutInstances(std::ostream &os) const
{
  std::vector<Instance*>::const_iterator iter;
  std::vector<Instance*>::const_iterator first = instanceContainer.begin();
  std::vector<Instance*>::const_iterator last  = instanceContainer.end();

  int i;
  os << std::endl;
  os << "    name     model name  Parameters" << std::endl;
  for (i=0, iter=first; iter!=last; ++iter, ++i)
  {
    os << "  " << i << ": " << (*iter)->getName() << "      ";
    os << getName();

    os << std::endl;
    os << "TEMP  =  " << (*iter)->Temp << std::endl;
    os << "N  =  " << (*iter)->N << std::endl;
    os << "L  =  " << (*iter)->L << std::endl;
    os << "W  =  " << (*iter)->W << std::endl;
    os << std::endl;
  }

  os << std::endl;

  return os;
}

//-----------------------------------------------------------------------------
// Function      : Model::forEachInstance
// Purpose       : 
// Special Notes :
// Scope         : public
// Creator       : David Baur
// Creation Date : 2/4/2014
//-----------------------------------------------------------------------------
/// Apply a device instance "op" to all instances associated with this
/// model
/// 
/// @param[in] op Operator to apply to all instances.
/// 
/// 
void Model::forEachInstance(DeviceInstanceOp &op) const /* override */ 
{
  for (std::vector<Instance *>::const_iterator it = instanceContainer.begin(); it != instanceContainer.end(); ++it)
    op(*it);
}

Device *Traits::factory(const Configuration &configuration, const FactoryBlock &factory_block)
{
  return new DeviceMaster<Traits>(configuration, factory_block, factory_block.solverState_, factory_block.deviceOptions_);
}

void registerDevice()
{
  Config<Traits>::addConfiguration()
    .registerDevice("q", 23)
    .registerModelType("npn", 23)
    .registerModelType("pnp", 23);
}



#ifdef Xyce_ADMS_SENSITIVITIES
//-----------------------------------------------------------------------------
// Function      : evaluateInitialInstance
// Purpose       : Evaluate the statements in the initial_instance block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
void evaluateInitialInstance(
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_Temp,
   bool instancePar_given_Temp,
   AdmsSensFadType & instancePar_L,
   bool instancePar_given_L,
   AdmsSensFadType & instancePar_W,
   bool instancePar_given_W,
   // non-reals(including hidden)
   int instancePar_N,
   bool instancePar_given_N,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_Temp,
   bool modelPar_given_Temp,
   AdmsSensFadType & modelPar_Rth,
   bool modelPar_given_Rth,
   AdmsSensFadType & modelPar_Cth,
   bool modelPar_given_Cth,
   AdmsSensFadType & modelPar_L,
   bool modelPar_given_L,
   AdmsSensFadType & modelPar_W,
   bool modelPar_given_W,
   AdmsSensFadType & modelPar_Jsf,
   bool modelPar_given_Jsf,
   AdmsSensFadType & modelPar_nf,
   bool modelPar_given_nf,
   AdmsSensFadType & modelPar_Vg,
   bool modelPar_given_Vg,
   AdmsSensFadType & modelPar_Jse,
   bool modelPar_given_Jse,
   AdmsSensFadType & modelPar_ne,
   bool modelPar_given_ne,
   AdmsSensFadType & modelPar_Rbxx,
   bool modelPar_given_Rbxx,
   AdmsSensFadType & modelPar_Vgb,
   bool modelPar_given_Vgb,
   AdmsSensFadType & modelPar_Jsee,
   bool modelPar_given_Jsee,
   AdmsSensFadType & modelPar_nee,
   bool modelPar_given_nee,
   AdmsSensFadType & modelPar_Rbbxx,
   bool modelPar_given_Rbbxx,
   AdmsSensFadType & modelPar_Vgbb,
   bool modelPar_given_Vgbb,
   AdmsSensFadType & modelPar_Jsr,
   bool modelPar_given_Jsr,
   AdmsSensFadType & modelPar_nr,
   bool modelPar_given_nr,
   AdmsSensFadType & modelPar_Vgr,
   bool modelPar_given_Vgr,
   AdmsSensFadType & modelPar_XCjc,
   bool modelPar_given_XCjc,
   AdmsSensFadType & modelPar_Jsc,
   bool modelPar_given_Jsc,
   AdmsSensFadType & modelPar_nc,
   bool modelPar_given_nc,
   AdmsSensFadType & modelPar_Rcxx,
   bool modelPar_given_Rcxx,
   AdmsSensFadType & modelPar_Vgc,
   bool modelPar_given_Vgc,
   AdmsSensFadType & modelPar_Bf,
   bool modelPar_given_Bf,
   AdmsSensFadType & modelPar_kBeta,
   bool modelPar_given_kBeta,
   AdmsSensFadType & modelPar_Br,
   bool modelPar_given_Br,
   AdmsSensFadType & modelPar_VAF,
   bool modelPar_given_VAF,
   AdmsSensFadType & modelPar_VAR,
   bool modelPar_given_VAR,
   AdmsSensFadType & modelPar_IKF,
   bool modelPar_given_IKF,
   AdmsSensFadType & modelPar_IKR,
   bool modelPar_given_IKR,
   AdmsSensFadType & modelPar_Mc,
   bool modelPar_given_Mc,
   AdmsSensFadType & modelPar_BVceo,
   bool modelPar_given_BVceo,
   AdmsSensFadType & modelPar_kc,
   bool modelPar_given_kc,
   AdmsSensFadType & modelPar_BVebo,
   bool modelPar_given_BVebo,
   AdmsSensFadType & modelPar_Tr,
   bool modelPar_given_Tr,
   AdmsSensFadType & modelPar_Trx,
   bool modelPar_given_Trx,
   AdmsSensFadType & modelPar_Tf,
   bool modelPar_given_Tf,
   AdmsSensFadType & modelPar_Tft,
   bool modelPar_given_Tft,
   AdmsSensFadType & modelPar_Thcs,
   bool modelPar_given_Thcs,
   AdmsSensFadType & modelPar_Ahc,
   bool modelPar_given_Ahc,
   AdmsSensFadType & modelPar_Cje,
   bool modelPar_given_Cje,
   AdmsSensFadType & modelPar_mje,
   bool modelPar_given_mje,
   AdmsSensFadType & modelPar_Vje,
   bool modelPar_given_Vje,
   AdmsSensFadType & modelPar_Cjc,
   bool modelPar_given_Cjc,
   AdmsSensFadType & modelPar_mjc,
   bool modelPar_given_mjc,
   AdmsSensFadType & modelPar_Vjc,
   bool modelPar_given_Vjc,
   AdmsSensFadType & modelPar_kjc,
   bool modelPar_given_kjc,
   AdmsSensFadType & modelPar_Cmin,
   bool modelPar_given_Cmin,
   AdmsSensFadType & modelPar_J0,
   bool modelPar_given_J0,
   AdmsSensFadType & modelPar_XJ0,
   bool modelPar_given_XJ0,
   AdmsSensFadType & modelPar_Rci0,
   bool modelPar_given_Rci0,
   AdmsSensFadType & modelPar_Jk,
   bool modelPar_given_Jk,
   AdmsSensFadType & modelPar_RJk,
   bool modelPar_given_RJk,
   AdmsSensFadType & modelPar_Vces,
   bool modelPar_given_Vces,
   AdmsSensFadType & modelPar_Rc,
   bool modelPar_given_Rc,
   AdmsSensFadType & modelPar_Re,
   bool modelPar_given_Re,
   AdmsSensFadType & modelPar_Rb,
   bool modelPar_given_Rb,
   AdmsSensFadType & modelPar_Rb2,
   bool modelPar_given_Rb2,
   AdmsSensFadType & modelPar_Lc,
   bool modelPar_given_Lc,
   AdmsSensFadType & modelPar_Le,
   bool modelPar_given_Le,
   AdmsSensFadType & modelPar_Lb,
   bool modelPar_given_Lb,
   AdmsSensFadType & modelPar_Cq,
   bool modelPar_given_Cq,
   AdmsSensFadType & modelPar_Cpb,
   bool modelPar_given_Cpb,
   AdmsSensFadType & modelPar_Cpc,
   bool modelPar_given_Cpc,
   AdmsSensFadType & modelPar_Tnom,
   bool modelPar_given_Tnom,
   // non-reals (including hidden)
   int modelPar_Mode,
   bool modelPar_given_Mode,
   int modelPar_Noise,
   bool modelPar_given_Noise,
   int modelPar_Debug,
   bool modelPar_given_Debug,
   int modelPar_DebugPlus,
   bool modelPar_given_DebugPlus,
   int modelPar_N,
   bool modelPar_given_N,
   int modelPar_dtype,
   double admsTemperature, double adms_vt_nom, double gmin, const Instance & theInstance)
{
}



//-----------------------------------------------------------------------------
// Function      : evaluateInitialModel
// Purpose       : Evaluate the statements in the initial_model block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
void evaluateInitialModel(
   // model parameters
   // reals
   AdmsSensFadType & modelPar_Temp,
   bool modelPar_given_Temp,
   AdmsSensFadType & modelPar_Rth,
   bool modelPar_given_Rth,
   AdmsSensFadType & modelPar_Cth,
   bool modelPar_given_Cth,
   AdmsSensFadType & modelPar_L,
   bool modelPar_given_L,
   AdmsSensFadType & modelPar_W,
   bool modelPar_given_W,
   AdmsSensFadType & modelPar_Jsf,
   bool modelPar_given_Jsf,
   AdmsSensFadType & modelPar_nf,
   bool modelPar_given_nf,
   AdmsSensFadType & modelPar_Vg,
   bool modelPar_given_Vg,
   AdmsSensFadType & modelPar_Jse,
   bool modelPar_given_Jse,
   AdmsSensFadType & modelPar_ne,
   bool modelPar_given_ne,
   AdmsSensFadType & modelPar_Rbxx,
   bool modelPar_given_Rbxx,
   AdmsSensFadType & modelPar_Vgb,
   bool modelPar_given_Vgb,
   AdmsSensFadType & modelPar_Jsee,
   bool modelPar_given_Jsee,
   AdmsSensFadType & modelPar_nee,
   bool modelPar_given_nee,
   AdmsSensFadType & modelPar_Rbbxx,
   bool modelPar_given_Rbbxx,
   AdmsSensFadType & modelPar_Vgbb,
   bool modelPar_given_Vgbb,
   AdmsSensFadType & modelPar_Jsr,
   bool modelPar_given_Jsr,
   AdmsSensFadType & modelPar_nr,
   bool modelPar_given_nr,
   AdmsSensFadType & modelPar_Vgr,
   bool modelPar_given_Vgr,
   AdmsSensFadType & modelPar_XCjc,
   bool modelPar_given_XCjc,
   AdmsSensFadType & modelPar_Jsc,
   bool modelPar_given_Jsc,
   AdmsSensFadType & modelPar_nc,
   bool modelPar_given_nc,
   AdmsSensFadType & modelPar_Rcxx,
   bool modelPar_given_Rcxx,
   AdmsSensFadType & modelPar_Vgc,
   bool modelPar_given_Vgc,
   AdmsSensFadType & modelPar_Bf,
   bool modelPar_given_Bf,
   AdmsSensFadType & modelPar_kBeta,
   bool modelPar_given_kBeta,
   AdmsSensFadType & modelPar_Br,
   bool modelPar_given_Br,
   AdmsSensFadType & modelPar_VAF,
   bool modelPar_given_VAF,
   AdmsSensFadType & modelPar_VAR,
   bool modelPar_given_VAR,
   AdmsSensFadType & modelPar_IKF,
   bool modelPar_given_IKF,
   AdmsSensFadType & modelPar_IKR,
   bool modelPar_given_IKR,
   AdmsSensFadType & modelPar_Mc,
   bool modelPar_given_Mc,
   AdmsSensFadType & modelPar_BVceo,
   bool modelPar_given_BVceo,
   AdmsSensFadType & modelPar_kc,
   bool modelPar_given_kc,
   AdmsSensFadType & modelPar_BVebo,
   bool modelPar_given_BVebo,
   AdmsSensFadType & modelPar_Tr,
   bool modelPar_given_Tr,
   AdmsSensFadType & modelPar_Trx,
   bool modelPar_given_Trx,
   AdmsSensFadType & modelPar_Tf,
   bool modelPar_given_Tf,
   AdmsSensFadType & modelPar_Tft,
   bool modelPar_given_Tft,
   AdmsSensFadType & modelPar_Thcs,
   bool modelPar_given_Thcs,
   AdmsSensFadType & modelPar_Ahc,
   bool modelPar_given_Ahc,
   AdmsSensFadType & modelPar_Cje,
   bool modelPar_given_Cje,
   AdmsSensFadType & modelPar_mje,
   bool modelPar_given_mje,
   AdmsSensFadType & modelPar_Vje,
   bool modelPar_given_Vje,
   AdmsSensFadType & modelPar_Cjc,
   bool modelPar_given_Cjc,
   AdmsSensFadType & modelPar_mjc,
   bool modelPar_given_mjc,
   AdmsSensFadType & modelPar_Vjc,
   bool modelPar_given_Vjc,
   AdmsSensFadType & modelPar_kjc,
   bool modelPar_given_kjc,
   AdmsSensFadType & modelPar_Cmin,
   bool modelPar_given_Cmin,
   AdmsSensFadType & modelPar_J0,
   bool modelPar_given_J0,
   AdmsSensFadType & modelPar_XJ0,
   bool modelPar_given_XJ0,
   AdmsSensFadType & modelPar_Rci0,
   bool modelPar_given_Rci0,
   AdmsSensFadType & modelPar_Jk,
   bool modelPar_given_Jk,
   AdmsSensFadType & modelPar_RJk,
   bool modelPar_given_RJk,
   AdmsSensFadType & modelPar_Vces,
   bool modelPar_given_Vces,
   AdmsSensFadType & modelPar_Rc,
   bool modelPar_given_Rc,
   AdmsSensFadType & modelPar_Re,
   bool modelPar_given_Re,
   AdmsSensFadType & modelPar_Rb,
   bool modelPar_given_Rb,
   AdmsSensFadType & modelPar_Rb2,
   bool modelPar_given_Rb2,
   AdmsSensFadType & modelPar_Lc,
   bool modelPar_given_Lc,
   AdmsSensFadType & modelPar_Le,
   bool modelPar_given_Le,
   AdmsSensFadType & modelPar_Lb,
   bool modelPar_given_Lb,
   AdmsSensFadType & modelPar_Cq,
   bool modelPar_given_Cq,
   AdmsSensFadType & modelPar_Cpb,
   bool modelPar_given_Cpb,
   AdmsSensFadType & modelPar_Cpc,
   bool modelPar_given_Cpc,
   AdmsSensFadType & modelPar_Tnom,
   bool modelPar_given_Tnom,
   // non-reals (including hidden)
   int modelPar_Mode,
   bool modelPar_given_Mode,
   int modelPar_Noise,
   bool modelPar_given_Noise,
   int modelPar_Debug,
   bool modelPar_given_Debug,
   int modelPar_DebugPlus,
   bool modelPar_given_DebugPlus,
   int modelPar_N,
   bool modelPar_given_N,
   int modelPar_dtype,
   double admsTemperature, double gmin, const Instance & theInstance)
{
}



//-----------------------------------------------------------------------------
// Function      : evaluateModelEquations
// Purpose       : Evaluate the main module block.  Similar to
//                 updateIntermediateVars, but takes all instance and model
//                 parameters and variables as arguments instead of using
//                 the ones stored in the objects.
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
void evaluateModelEquations(
   std::vector <double> & probeVars,
   // probe constants
   const int admsProbeID_V_t_ti,
   const int admsProbeID_V_b_c,
   const int admsProbeID_V_c_GND,
   const int admsProbeID_V_b_GND,
   const int admsProbeID_V_cx_bii,
   const int admsProbeID_V_exx_bii,
   const int admsProbeID_V_ex_bii,
   const int admsProbeID_V_bii_bi,
   const int admsProbeID_I_c_ci,
   const int admsProbeID_I_e_ei,
   const int admsProbeID_I_b_bi,
   const int admsProbeID_V_ti_GND,
   const int admsProbeID_V_ci_ei,
   const int admsProbeID_V_exx_ei,
   const int admsProbeID_V_cx_ci,
   const int admsProbeID_V_ex_ei,
   const int admsProbeID_V_bii_ei,
   const int admsProbeID_V_bii_ci,
   const int admsProbeID_V_bi_ci,
   // node constants
   const int admsNodeID_c,
   const int admsNodeID_b,
   const int admsNodeID_e,
   const int admsNodeID_t,
   const int admsNodeID_ei,
   const int admsNodeID_bi,
   const int admsNodeID_bii,
   const int admsNodeID_ci,
   const int admsNodeID_ti,
   const int admsNodeID_ex,
   const int admsNodeID_exx,
   const int admsNodeID_cx,
   const int admsBRA_ID_b_bi,
   const int admsBRA_ID_e_ei,
   const int admsBRA_ID_c_ci,
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_Temp,
   bool instancePar_given_Temp,
   AdmsSensFadType & instancePar_L,
   bool instancePar_given_L,
   AdmsSensFadType & instancePar_W,
   bool instancePar_given_W,
   // non-reals(including hidden)
   int instancePar_N,
   bool instancePar_given_N,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_Temp,
   bool modelPar_given_Temp,
   AdmsSensFadType & modelPar_Rth,
   bool modelPar_given_Rth,
   AdmsSensFadType & modelPar_Cth,
   bool modelPar_given_Cth,
   AdmsSensFadType & modelPar_L,
   bool modelPar_given_L,
   AdmsSensFadType & modelPar_W,
   bool modelPar_given_W,
   AdmsSensFadType & modelPar_Jsf,
   bool modelPar_given_Jsf,
   AdmsSensFadType & modelPar_nf,
   bool modelPar_given_nf,
   AdmsSensFadType & modelPar_Vg,
   bool modelPar_given_Vg,
   AdmsSensFadType & modelPar_Jse,
   bool modelPar_given_Jse,
   AdmsSensFadType & modelPar_ne,
   bool modelPar_given_ne,
   AdmsSensFadType & modelPar_Rbxx,
   bool modelPar_given_Rbxx,
   AdmsSensFadType & modelPar_Vgb,
   bool modelPar_given_Vgb,
   AdmsSensFadType & modelPar_Jsee,
   bool modelPar_given_Jsee,
   AdmsSensFadType & modelPar_nee,
   bool modelPar_given_nee,
   AdmsSensFadType & modelPar_Rbbxx,
   bool modelPar_given_Rbbxx,
   AdmsSensFadType & modelPar_Vgbb,
   bool modelPar_given_Vgbb,
   AdmsSensFadType & modelPar_Jsr,
   bool modelPar_given_Jsr,
   AdmsSensFadType & modelPar_nr,
   bool modelPar_given_nr,
   AdmsSensFadType & modelPar_Vgr,
   bool modelPar_given_Vgr,
   AdmsSensFadType & modelPar_XCjc,
   bool modelPar_given_XCjc,
   AdmsSensFadType & modelPar_Jsc,
   bool modelPar_given_Jsc,
   AdmsSensFadType & modelPar_nc,
   bool modelPar_given_nc,
   AdmsSensFadType & modelPar_Rcxx,
   bool modelPar_given_Rcxx,
   AdmsSensFadType & modelPar_Vgc,
   bool modelPar_given_Vgc,
   AdmsSensFadType & modelPar_Bf,
   bool modelPar_given_Bf,
   AdmsSensFadType & modelPar_kBeta,
   bool modelPar_given_kBeta,
   AdmsSensFadType & modelPar_Br,
   bool modelPar_given_Br,
   AdmsSensFadType & modelPar_VAF,
   bool modelPar_given_VAF,
   AdmsSensFadType & modelPar_VAR,
   bool modelPar_given_VAR,
   AdmsSensFadType & modelPar_IKF,
   bool modelPar_given_IKF,
   AdmsSensFadType & modelPar_IKR,
   bool modelPar_given_IKR,
   AdmsSensFadType & modelPar_Mc,
   bool modelPar_given_Mc,
   AdmsSensFadType & modelPar_BVceo,
   bool modelPar_given_BVceo,
   AdmsSensFadType & modelPar_kc,
   bool modelPar_given_kc,
   AdmsSensFadType & modelPar_BVebo,
   bool modelPar_given_BVebo,
   AdmsSensFadType & modelPar_Tr,
   bool modelPar_given_Tr,
   AdmsSensFadType & modelPar_Trx,
   bool modelPar_given_Trx,
   AdmsSensFadType & modelPar_Tf,
   bool modelPar_given_Tf,
   AdmsSensFadType & modelPar_Tft,
   bool modelPar_given_Tft,
   AdmsSensFadType & modelPar_Thcs,
   bool modelPar_given_Thcs,
   AdmsSensFadType & modelPar_Ahc,
   bool modelPar_given_Ahc,
   AdmsSensFadType & modelPar_Cje,
   bool modelPar_given_Cje,
   AdmsSensFadType & modelPar_mje,
   bool modelPar_given_mje,
   AdmsSensFadType & modelPar_Vje,
   bool modelPar_given_Vje,
   AdmsSensFadType & modelPar_Cjc,
   bool modelPar_given_Cjc,
   AdmsSensFadType & modelPar_mjc,
   bool modelPar_given_mjc,
   AdmsSensFadType & modelPar_Vjc,
   bool modelPar_given_Vjc,
   AdmsSensFadType & modelPar_kjc,
   bool modelPar_given_kjc,
   AdmsSensFadType & modelPar_Cmin,
   bool modelPar_given_Cmin,
   AdmsSensFadType & modelPar_J0,
   bool modelPar_given_J0,
   AdmsSensFadType & modelPar_XJ0,
   bool modelPar_given_XJ0,
   AdmsSensFadType & modelPar_Rci0,
   bool modelPar_given_Rci0,
   AdmsSensFadType & modelPar_Jk,
   bool modelPar_given_Jk,
   AdmsSensFadType & modelPar_RJk,
   bool modelPar_given_RJk,
   AdmsSensFadType & modelPar_Vces,
   bool modelPar_given_Vces,
   AdmsSensFadType & modelPar_Rc,
   bool modelPar_given_Rc,
   AdmsSensFadType & modelPar_Re,
   bool modelPar_given_Re,
   AdmsSensFadType & modelPar_Rb,
   bool modelPar_given_Rb,
   AdmsSensFadType & modelPar_Rb2,
   bool modelPar_given_Rb2,
   AdmsSensFadType & modelPar_Lc,
   bool modelPar_given_Lc,
   AdmsSensFadType & modelPar_Le,
   bool modelPar_given_Le,
   AdmsSensFadType & modelPar_Lb,
   bool modelPar_given_Lb,
   AdmsSensFadType & modelPar_Cq,
   bool modelPar_given_Cq,
   AdmsSensFadType & modelPar_Cpb,
   bool modelPar_given_Cpb,
   AdmsSensFadType & modelPar_Cpc,
   bool modelPar_given_Cpc,
   AdmsSensFadType & modelPar_Tnom,
   bool modelPar_given_Tnom,
   // non-reals (including hidden)
   int modelPar_Mode,
   bool modelPar_given_Mode,
   int modelPar_Noise,
   bool modelPar_given_Noise,
   int modelPar_Debug,
   bool modelPar_given_Debug,
   int modelPar_DebugPlus,
   bool modelPar_given_DebugPlus,
   int modelPar_N,
   bool modelPar_given_N,
   int modelPar_dtype,
   // basic variables
   double admsTemperature, double adms_vt_nom, double gmin, std::vector <AdmsSensFadType> & staticContributions, std::vector <AdmsSensFadType> & dynamicContributions, const Instance & theInstance)
{

  // Local variables
  AdmsSensFadType qbe;
  AdmsSensFadType qbtf;
  AdmsSensFadType xtff;
  AdmsSensFadType Wh;
  AdmsSensFadType Ih;
  AdmsSensFadType AHC;
  AdmsSensFadType RCIO;
  AdmsSensFadType InvVpt;
  AdmsSensFadType Vlim;
  AdmsSensFadType qb2;
  AdmsSensFadType qbtra;
  AdmsSensFadType qbtr;
  AdmsSensFadType qb1;
  AdmsSensFadType qb2med;
  AdmsSensFadType xix;
  AdmsSensFadType I00;
  AdmsSensFadType Ipdiss;
  AdmsSensFadType Icdx;
  AdmsSensFadType Ibdxx;
  AdmsSensFadType Ibdx;
  AdmsSensFadType Ib1;
  AdmsSensFadType Ib0;
  AdmsSensFadType EdBeta;
  AdmsSensFadType mm;
  AdmsSensFadType Vbclin;
  double epsi;
  AdmsSensFadType Ibx;
  AdmsSensFadType Ib2;
  AdmsSensFadType Ic1;
  AdmsSensFadType Ic1r;
  AdmsSensFadType Ic0;
  AdmsSensFadType qb;
  AdmsSensFadType q2;
  AdmsSensFadType q1;
  AdmsSensFadType Ic1ra;
  AdmsSensFadType Ic0a;
  double TWO_Q;
  double FOUR_K;
  AdmsSensFadType Area;
  AdmsSensFadType Tex;
  AdmsSensFadType TjK;
  AdmsSensFadType Tj;
  double Texi;
  AdmsSensFadType vcei;
  AdmsSensFadType vxxe;
  AdmsSensFadType vxc;
  AdmsSensFadType vxe;
  AdmsSensFadType vbei;
  AdmsSensFadType vbci;
  AdmsSensFadType vbcx;
  AdmsSensFadType tVCrit;


  // -- code converted from analog/code block
  tVCrit = (adms_vt_nom*log((adms_vt_nom/(1.41421356237309504880*((((modelPar_Jsf*instancePar_L)*instancePar_W)*instancePar_N)*1e12)))));
  vbcx = probeVars[admsProbeID_V_bi_ci];

  vbci = probeVars[admsProbeID_V_bii_ci];

  vbei = probeVars[admsProbeID_V_bii_ei];

  vxe = (modelPar_dtype*(probeVars[admsProbeID_V_ex_ei]));
  vxc = (modelPar_dtype*(probeVars[admsProbeID_V_cx_ci]));
  vxxe = (modelPar_dtype*(probeVars[admsProbeID_V_exx_ei]));
  vcei = (modelPar_dtype*(probeVars[admsProbeID_V_ci_ei]));
  Texi = (probeVars[admsProbeID_V_ti_GND]);
  Tj = (Texi+instancePar_Temp);
  TjK = (Tj+273.15);
  Tex = (Tj-modelPar_Tnom);
  Area = (((instancePar_L*instancePar_W)*1.0e12)*instancePar_N);
  FOUR_K = (4*1.3806226e-23);
  TWO_Q = (2*1.6021918e-19);
  Ic0a = AnalogFunctions::diode<AdmsSensFadType>(vbei,modelPar_Jsf,modelPar_Vg,modelPar_nf,Area,Tj,modelPar_Tnom);
  Ic1ra = AnalogFunctions::diode<AdmsSensFadType>(vbci,(modelPar_XCjc*modelPar_Jsr),modelPar_Vgr,modelPar_nr,Area,Tj,modelPar_Tnom);
  if (((modelPar_VAF>0.0)&&(modelPar_VAR>0.0)))
  {
    q1 = ((1.0+((AnalogFunctions::charge<AdmsSensFadType>(vbei,1.0,modelPar_Vje,modelPar_mje,1.0)-AnalogFunctions::charge<AdmsSensFadType>(0.0,1.0,modelPar_Vje,modelPar_mje,1.0))/modelPar_VAR))+((AnalogFunctions::charge<AdmsSensFadType>(vbci,1.0,modelPar_Vjc,modelPar_mjc,1.0)-AnalogFunctions::charge<AdmsSensFadType>(0.0,1.0,modelPar_Vjc,modelPar_mjc,1.0))/modelPar_VAF));
  }
  else
  {
    if (((modelPar_VAF>0.0)&&(modelPar_VAR==0.0)))
    {
      q1 = (1.0+((AnalogFunctions::charge<AdmsSensFadType>(vbci,1.0,modelPar_Vjc,modelPar_mjc,1.0)-AnalogFunctions::charge<AdmsSensFadType>(0.0,1.0,modelPar_Vjc,modelPar_mjc,1.0))/modelPar_VAF));
    }
    else
    {
      if (((modelPar_VAF==0.0)&&(modelPar_VAR>0.0)))
      {
        q1 = (1.0+((AnalogFunctions::charge<AdmsSensFadType>(vbei,1.0,modelPar_Vje,modelPar_mje,1.0)-AnalogFunctions::charge<AdmsSensFadType>(0.0,1.0,modelPar_Vje,modelPar_mje,1.0))/modelPar_VAR));
      }
      else
      {
        q1 = 1.0;
      }
    }
  }
  if (((modelPar_IKF>0.0)&&(modelPar_IKR>0.0)))
  {
    q2 = ((Ic0a/(Area*modelPar_IKF))+(Ic1ra/(Area*modelPar_IKR)));
  }
  else
  {
    if (((modelPar_IKF>0.0)&&(modelPar_IKR==0.0)))
    {
      q2 = (Ic0a/(Area*modelPar_IKF));
    }
    else
    {
      if (((modelPar_IKF==0.0)&&(modelPar_IKR>0.0)))
      {
        q2 = (Ic1ra/(Area*modelPar_IKR));
      }
      else
      {
        q2 = 0.0;
      }
    }
  }
  qb = ((q1+sqrt(((q1*q1)+(4.0*q2))))/2.0);
  Ic0 = (Ic0a/qb);
  Ic1r = (Ic1ra/qb);
  Ic1 = (Ic0-Ic1r);
  Ib2 = (AnalogFunctions::diode<AdmsSensFadType>(vbci,(modelPar_XCjc*modelPar_Jsr),modelPar_Vgr,modelPar_nr,Area,Tj,modelPar_Tnom)/modelPar_Br);
  Ibx = (AnalogFunctions::diode<AdmsSensFadType>(vbcx,((1.0-modelPar_XCjc)*modelPar_Jsr),modelPar_Vgr,modelPar_nr,Area,Tj,modelPar_Tnom)/modelPar_Br);
  epsi = 1.0e-6;
  Vbclin = (modelPar_BVceo*pow((1.0-epsi),(1/modelPar_Mc)));
  mm = AnalogFunctions::MM<AdmsSensFadType>(vbci,modelPar_BVceo,modelPar_Mc,Vbclin,modelPar_Bf,modelPar_kc);
  if ((mm>1.0))
  {
    if ((modelPar_kBeta>0.0))
    {
      if (((modelPar_Bf-(modelPar_kBeta*Tex))>1e-6))
      {
        EdBeta = (((1/(modelPar_Bf-(modelPar_kBeta*Tex)))-(modelPar_kc*(mm-1)))/((modelPar_kc*(mm-1))+1));
      }
      else
      {
        EdBeta = ((1e6-(modelPar_kc*(mm-1)))/((modelPar_kc*(mm-1))+1));
      }
    }
    else
    {
      EdBeta = (((1/modelPar_Bf)-(modelPar_kc*(mm-1)))/((modelPar_kc*(mm-1))+1));
    }
  }
  else
  {
    if ((modelPar_kBeta>0.0))
    {
      if (((modelPar_Bf-(modelPar_kBeta*Tex))>1e-6))
      {
        EdBeta = (1/(modelPar_Bf-(modelPar_kBeta*Tex)));
      }
      else
      {
        EdBeta = 1e6;
      }
    }
    else
    {
      EdBeta = (1/modelPar_Bf);
    }
  }
  Ib0 = (Ic0a*EdBeta);
  if ((modelPar_BVebo>0))
  {
    Ib1 = (Ib0-AnalogFunctions::diode<AdmsSensFadType>(((-modelPar_BVebo)-vbei),modelPar_Jsf,0.0,1.0,Area,0.0,0.0));
  }
  else
  {
    Ib1 = Ib0;
  }
  if (((modelPar_Jse>0.0)&&(modelPar_ne>0)))
  {
    Ibdx = AnalogFunctions::diode<AdmsSensFadType>(vxe,modelPar_Jse,modelPar_Vgb,modelPar_ne,Area,Tj,modelPar_Tnom);
  }
  else
  {
    Ibdx = (vxe*1e-12);
  }
  if (((modelPar_Jsee>0.0)&&(modelPar_nee>0)))
  {
    Ibdxx = AnalogFunctions::diode<AdmsSensFadType>(vxxe,modelPar_Jsee,modelPar_Vgbb,modelPar_nee,Area,Tj,modelPar_Tnom);
  }
  else
  {
    Ibdxx = (vxxe*1e-12);
  }
  if (((modelPar_Jsc>0.0)&&(modelPar_nc>0)))
  {
    Icdx = AnalogFunctions::diode<AdmsSensFadType>(vxc,modelPar_Jsc,modelPar_Vgc,modelPar_nc,Area,Tj,modelPar_Tnom);
  }
  else
  {
    Icdx = (vxc*1e-12);
  }
  Ipdiss = ((((Ic1*vcei)+(Ib1*vbei))+(Ib2*vbci))+(Ibx*vbcx));
  if ((Ipdiss<0.0))
  {
    Ipdiss = 0;
  }
  I00 = (modelPar_J0*Area);
  if (((modelPar_XCjc<1.0)&&(modelPar_XCjc>0.0)))
  {
    if (((modelPar_J0<=0.0)||(Ic0<0.0)))
    {
      qb2med = ((modelPar_XCjc*AnalogFunctions::charge<AdmsSensFadType>(vbci,(modelPar_Cjc-modelPar_Cmin),modelPar_Vjc,modelPar_mjc,Area))+(((modelPar_XCjc*Area)*modelPar_Cmin)*vbci));
    }
    else
    {
      xix = (Ic0/I00);
      qb2med = (((modelPar_XCjc*(1.0-tanh(xix)))*(AnalogFunctions::charge<AdmsSensFadType>(vbci,(modelPar_Cjc-modelPar_Cmin),modelPar_Vjc,modelPar_mjc,Area)+((((1.0-modelPar_XJ0)*Area)*modelPar_Cmin)*vbci)))+((((modelPar_XJ0*modelPar_XCjc)*Area)*modelPar_Cmin)*vbci));
    }
  }
  else
  {
    if (((modelPar_J0<0.0)||(Ic0<0.0)))
    {
      qb2med = (AnalogFunctions::charge<AdmsSensFadType>(vbci,(modelPar_Cjc-modelPar_Cmin),modelPar_Vjc,modelPar_mjc,Area)+((Area*modelPar_Cmin)*vbci));
    }
    else
    {
      xix = (Ic0/I00);
      qb2med = (((1.0-tanh(xix))*(AnalogFunctions::charge<AdmsSensFadType>(vbci,(modelPar_Cjc-modelPar_Cmin),modelPar_Vjc,modelPar_mjc,Area)+((((1.0-modelPar_XJ0)*Area)*modelPar_Cmin)*vbci)))+(((modelPar_XJ0*Area)*modelPar_Cmin)*vbci));
    }
  }
  if (((modelPar_XCjc<1.0)&&(modelPar_XCjc>0.0)))
  {
    qb1 = (((1.0-modelPar_XCjc)*AnalogFunctions::charge<AdmsSensFadType>(vbcx,(modelPar_Cjc-modelPar_Cmin),modelPar_Vjc,modelPar_mjc,Area))+((((1.0-modelPar_XCjc)*Area)*modelPar_Cmin)*vbcx));
  }
  else
  {
    qb1 = 0.0;
  }
  qbtr = (modelPar_Tr*Ic1r);
  qbtra = (modelPar_Trx*Ibx);
  qb2 = (qb2med+qbtr);
  if (((modelPar_Jk>0.0)&&(modelPar_Rci0>0.0)))
  {
    if ((modelPar_RJk>0.0))
    {
      Vlim = ((modelPar_Jk*modelPar_Rci0)/(1.0-(modelPar_Rci0/modelPar_RJk)));
      InvVpt = ((1.0-(modelPar_Rci0/modelPar_RJk))/(modelPar_Jk*modelPar_RJk));
    }
    else
    {
      Vlim = ((modelPar_Jk*modelPar_Rci0)/1.016);
      InvVpt = 0.0;
    }
  }
  if (((((modelPar_Thcs>0.0)&&(modelPar_Ahc>0.0))&&(modelPar_Jk>0.0))&&(Ic0>0.0)))
  {
    RCIO = (modelPar_Rci0/Area);
    AHC = (Area*modelPar_Ahc);
    if (((modelPar_Rci0<modelPar_RJk)||(modelPar_RJk<=0.0)))
    {
      Ih = (1.0-(AnalogFunctions::ICK<AdmsSensFadType>(vcei,RCIO,Vlim,InvVpt,modelPar_Vces)/Ic0));
    }
    else
    {
      Ih = (1.0-(AnalogFunctions::Vceff<AdmsSensFadType>(vcei,modelPar_Vces)/(RCIO*Ic0)));
    }
    Wh = ((Ih+sqrt(((Ih*Ih)+AHC)))/(1.0+sqrt((1.0+AHC))));
    xtff = ((modelPar_Thcs*Ic0)*(Wh*Wh));
  }
  else
  {
    xtff = 0;
  }
  qbtf = ((modelPar_Tf+(modelPar_Tft*Tex))*Ic0);
  qbe = ((xtff+qbtf)+AnalogFunctions::charge<AdmsSensFadType>(vbei,modelPar_Cje,modelPar_Vje,modelPar_mje,Area));
  // I(bi,ci) <+ ((dtype*Ibx))
  staticContributions[admsNodeID_bi] += (modelPar_dtype*Ibx);
  staticContributions[admsNodeID_ci] -= (modelPar_dtype*Ibx);
  // I(bi,ci) <+ ((dtype*ddt((qb1+qbtra))))
  dynamicContributions[admsNodeID_bi] += (modelPar_dtype*((qb1+qbtra)));
  dynamicContributions[admsNodeID_ci] -= (modelPar_dtype*((qb1+qbtra)));
  // I(bii,ci) <+ ((dtype*Ib2))
  staticContributions[admsNodeID_bii] += (modelPar_dtype*Ib2);
  staticContributions[admsNodeID_ci] -= (modelPar_dtype*Ib2);
  // I(bii,ci) <+ ((dtype*ddt(qb2)))
  dynamicContributions[admsNodeID_bii] += (modelPar_dtype*(qb2));
  dynamicContributions[admsNodeID_ci] -= (modelPar_dtype*(qb2));
  // I(bii,ei) <+ ((dtype*Ib1))
  staticContributions[admsNodeID_bii] += (modelPar_dtype*Ib1);
  staticContributions[admsNodeID_ei] -= (modelPar_dtype*Ib1);
  // I(bii,ei) <+ ((dtype*ddt(qbe)))
  dynamicContributions[admsNodeID_bii] += (modelPar_dtype*(qbe));
  dynamicContributions[admsNodeID_ei] -= (modelPar_dtype*(qbe));
  // I(ci,ei) <+ ((dtype*Ic1))
  staticContributions[admsNodeID_ci] += (modelPar_dtype*Ic1);
  staticContributions[admsNodeID_ei] -= (modelPar_dtype*Ic1);
  // I(ex,ei) <+ ((dtype*Ibdx))
  staticContributions[admsNodeID_ex] += (modelPar_dtype*Ibdx);
  staticContributions[admsNodeID_ei] -= (modelPar_dtype*Ibdx);
  // I(exx,ei) <+ ((dtype*Ibdxx))
  staticContributions[admsNodeID_exx] += (modelPar_dtype*Ibdxx);
  staticContributions[admsNodeID_ei] -= (modelPar_dtype*Ibdxx);
  // I(cx,ci) <+ ((dtype*Icdx))
  staticContributions[admsNodeID_cx] += (modelPar_dtype*Icdx);
  staticContributions[admsNodeID_ci] -= (modelPar_dtype*Icdx);
  // V(b,bi) <+ ((I(b,bi)*(Rb/N)))
  staticContributions[admsBRA_ID_b_bi] += ((probeVars[admsProbeID_I_b_bi])*(modelPar_Rb/instancePar_N));
  // V(b,bi) <+ (ddt((I(b,bi)*Lb)))
  dynamicContributions[admsBRA_ID_b_bi] += (((probeVars[admsProbeID_I_b_bi])*modelPar_Lb));
  // V(e,ei) <+ ((I(e,ei)*(Re/N)))
  staticContributions[admsBRA_ID_e_ei] += ((probeVars[admsProbeID_I_e_ei])*(modelPar_Re/instancePar_N));
  // V(e,ei) <+ (ddt((I(e,ei)*Le)))
  dynamicContributions[admsBRA_ID_e_ei] += (((probeVars[admsProbeID_I_e_ei])*modelPar_Le));
  // V(c,ci) <+ ((I(c,ci)*(Rc/N)))
  staticContributions[admsBRA_ID_c_ci] += ((probeVars[admsProbeID_I_c_ci])*(modelPar_Rc/instancePar_N));
  // V(c,ci) <+ (ddt((I(c,ci)*Lc)))
  dynamicContributions[admsBRA_ID_c_ci] += (((probeVars[admsProbeID_I_c_ci])*modelPar_Lc));
  // I(bii,bi) <+ ((V(bii,bi)/(Rb2/N)))
  staticContributions[admsNodeID_bii] += ((probeVars[admsProbeID_V_bii_bi])/(modelPar_Rb2/instancePar_N));
  staticContributions[admsNodeID_bi] -= ((probeVars[admsProbeID_V_bii_bi])/(modelPar_Rb2/instancePar_N));
  if (((modelPar_Jse>0.0)&&(modelPar_ne>0)))
  {
    // I(ex,bii) <+ ((V(ex,bii)/(Rbxx/N)))
    staticContributions[admsNodeID_ex] += ((probeVars[admsProbeID_V_ex_bii])/(modelPar_Rbxx/instancePar_N));
    staticContributions[admsNodeID_bii] -= ((probeVars[admsProbeID_V_ex_bii])/(modelPar_Rbxx/instancePar_N));
  }
  else
  {
    // I(ex,bii) <+ ((V(ex,bii)*1e-12))
    staticContributions[admsNodeID_ex] += ((probeVars[admsProbeID_V_ex_bii])*1e-12);
    staticContributions[admsNodeID_bii] -= ((probeVars[admsProbeID_V_ex_bii])*1e-12);
  }
  if (((modelPar_Jsee>0.0)&&(modelPar_nee>0)))
  {
    // I(exx,bii) <+ ((V(exx,bii)/(Rbbxx/N)))
    staticContributions[admsNodeID_exx] += ((probeVars[admsProbeID_V_exx_bii])/(modelPar_Rbbxx/instancePar_N));
    staticContributions[admsNodeID_bii] -= ((probeVars[admsProbeID_V_exx_bii])/(modelPar_Rbbxx/instancePar_N));
  }
  else
  {
    // I(exx,bii) <+ ((V(exx,bii)*1e-12))
    staticContributions[admsNodeID_exx] += ((probeVars[admsProbeID_V_exx_bii])*1e-12);
    staticContributions[admsNodeID_bii] -= ((probeVars[admsProbeID_V_exx_bii])*1e-12);
  }
  if (((modelPar_Jsc>0.0)&&(modelPar_nc>0)))
  {
    // I(cx,bii) <+ ((V(cx,bii)/(Rcxx/N)))
    staticContributions[admsNodeID_cx] += ((probeVars[admsProbeID_V_cx_bii])/(modelPar_Rcxx/instancePar_N));
    staticContributions[admsNodeID_bii] -= ((probeVars[admsProbeID_V_cx_bii])/(modelPar_Rcxx/instancePar_N));
  }
  else
  {
    // I(cx,bii) <+ ((V(cx,bii)*1e-12))
    staticContributions[admsNodeID_cx] += ((probeVars[admsProbeID_V_cx_bii])*1e-12);
    staticContributions[admsNodeID_bii] -= ((probeVars[admsProbeID_V_cx_bii])*1e-12);
  }
  // I(b,GND) <+ (ddt((Cpb*V(b,GND))))
  dynamicContributions[admsNodeID_b] += ((modelPar_Cpb*(probeVars[admsProbeID_V_b_GND])));
  // I(c,GND) <+ (ddt((Cpc*V(c,GND))))
  dynamicContributions[admsNodeID_c] += ((modelPar_Cpc*(probeVars[admsProbeID_V_c_GND])));
  // I(b,c) <+ (ddt((Cq*V(b,c))))
  dynamicContributions[admsNodeID_b] += ((modelPar_Cq*(probeVars[admsProbeID_V_b_c])));
  dynamicContributions[admsNodeID_c] -= ((modelPar_Cq*(probeVars[admsProbeID_V_b_c])));
  // I(ti,GND) <+ ((-Ipdiss))
  staticContributions[admsNodeID_ti] += (-Ipdiss);
  if ((modelPar_Rth>0))
  {
    // I(t,ti) <+ ((V(t,ti)/Rth))
    staticContributions[admsNodeID_t] += ((probeVars[admsProbeID_V_t_ti])/modelPar_Rth);
    staticContributions[admsNodeID_ti] -= ((probeVars[admsProbeID_V_t_ti])/modelPar_Rth);
    // I(t,ti) <+ ((Cth*ddt(V(t,ti))))
    dynamicContributions[admsNodeID_t] += (modelPar_Cth*((probeVars[admsProbeID_V_t_ti])));
    dynamicContributions[admsNodeID_ti] -= (modelPar_Cth*((probeVars[admsProbeID_V_t_ti])));
  }
  else
  {
    // I(t,ti) <+ ((V(t,ti)*1e3))
    staticContributions[admsNodeID_t] += ((probeVars[admsProbeID_V_t_ti])*1e3);
    staticContributions[admsNodeID_ti] -= ((probeVars[admsProbeID_V_t_ti])*1e3);
  }
}



//-----------------------------------------------------------------------------
// Function      : InstanceSensitivity::operator()
// Purpose       : return sensitivity for a single instance parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
/// Compute sensitivity of a device instance's outputs to a specified instance
/// parameter
/// 
/// 
/// @param[in] entity  The device entity that owns the parameter 
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
/// 
/// 
void InstanceSensitivity::operator()
  (
     const ParameterBase &entity,
     const std::string &name,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
   ) const
{
  const ParameterBase * e1 = &entity;
  const Instance & in = *(dynamic_cast<const Instance *> (e1));
  const Model & mod =in.model_;

  dfdp.resize(12+3);
  dqdp.resize(12+3);
  Findices.resize(12+3);
  Qindices.resize(12+3);

  std::vector <double> probeVars(19);
  std::vector <AdmsSensFadType> staticContributions(12+3);
  std::vector <AdmsSensFadType> dynamicContributions(12+3);


  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 12+3 ; ++i)
  {
    staticContributions[i]=0;
    dynamicContributions[i]=0;
  }

  // Copy out all the model parameters (doubles) into FAD types
  //reals
  AdmsSensFadType modelPar_Temp=mod.Temp;
  bool modelPar_given_Temp=mod.given("Temp");
  AdmsSensFadType modelPar_Rth=mod.Rth;
  bool modelPar_given_Rth=mod.given("Rth");
  AdmsSensFadType modelPar_Cth=mod.Cth;
  bool modelPar_given_Cth=mod.given("Cth");
  AdmsSensFadType modelPar_L=mod.L;
  bool modelPar_given_L=mod.given("L");
  AdmsSensFadType modelPar_W=mod.W;
  bool modelPar_given_W=mod.given("W");
  AdmsSensFadType modelPar_Jsf=mod.Jsf;
  bool modelPar_given_Jsf=mod.given("Jsf");
  AdmsSensFadType modelPar_nf=mod.nf;
  bool modelPar_given_nf=mod.given("nf");
  AdmsSensFadType modelPar_Vg=mod.Vg;
  bool modelPar_given_Vg=mod.given("Vg");
  AdmsSensFadType modelPar_Jse=mod.Jse;
  bool modelPar_given_Jse=mod.given("Jse");
  AdmsSensFadType modelPar_ne=mod.ne;
  bool modelPar_given_ne=mod.given("ne");
  AdmsSensFadType modelPar_Rbxx=mod.Rbxx;
  bool modelPar_given_Rbxx=mod.given("Rbxx");
  AdmsSensFadType modelPar_Vgb=mod.Vgb;
  bool modelPar_given_Vgb=mod.given("Vgb");
  AdmsSensFadType modelPar_Jsee=mod.Jsee;
  bool modelPar_given_Jsee=mod.given("Jsee");
  AdmsSensFadType modelPar_nee=mod.nee;
  bool modelPar_given_nee=mod.given("nee");
  AdmsSensFadType modelPar_Rbbxx=mod.Rbbxx;
  bool modelPar_given_Rbbxx=mod.given("Rbbxx");
  AdmsSensFadType modelPar_Vgbb=mod.Vgbb;
  bool modelPar_given_Vgbb=mod.given("Vgbb");
  AdmsSensFadType modelPar_Jsr=mod.Jsr;
  bool modelPar_given_Jsr=mod.given("Jsr");
  AdmsSensFadType modelPar_nr=mod.nr;
  bool modelPar_given_nr=mod.given("nr");
  AdmsSensFadType modelPar_Vgr=mod.Vgr;
  bool modelPar_given_Vgr=mod.given("Vgr");
  AdmsSensFadType modelPar_XCjc=mod.XCjc;
  bool modelPar_given_XCjc=mod.given("XCjc");
  AdmsSensFadType modelPar_Jsc=mod.Jsc;
  bool modelPar_given_Jsc=mod.given("Jsc");
  AdmsSensFadType modelPar_nc=mod.nc;
  bool modelPar_given_nc=mod.given("nc");
  AdmsSensFadType modelPar_Rcxx=mod.Rcxx;
  bool modelPar_given_Rcxx=mod.given("Rcxx");
  AdmsSensFadType modelPar_Vgc=mod.Vgc;
  bool modelPar_given_Vgc=mod.given("Vgc");
  AdmsSensFadType modelPar_Bf=mod.Bf;
  bool modelPar_given_Bf=mod.given("Bf");
  AdmsSensFadType modelPar_kBeta=mod.kBeta;
  bool modelPar_given_kBeta=mod.given("kBeta");
  AdmsSensFadType modelPar_Br=mod.Br;
  bool modelPar_given_Br=mod.given("Br");
  AdmsSensFadType modelPar_VAF=mod.VAF;
  bool modelPar_given_VAF=mod.given("VAF");
  AdmsSensFadType modelPar_VAR=mod.VAR;
  bool modelPar_given_VAR=mod.given("VAR");
  AdmsSensFadType modelPar_IKF=mod.IKF;
  bool modelPar_given_IKF=mod.given("IKF");
  AdmsSensFadType modelPar_IKR=mod.IKR;
  bool modelPar_given_IKR=mod.given("IKR");
  AdmsSensFadType modelPar_Mc=mod.Mc;
  bool modelPar_given_Mc=mod.given("Mc");
  AdmsSensFadType modelPar_BVceo=mod.BVceo;
  bool modelPar_given_BVceo=mod.given("BVceo");
  AdmsSensFadType modelPar_kc=mod.kc;
  bool modelPar_given_kc=mod.given("kc");
  AdmsSensFadType modelPar_BVebo=mod.BVebo;
  bool modelPar_given_BVebo=mod.given("BVebo");
  AdmsSensFadType modelPar_Tr=mod.Tr;
  bool modelPar_given_Tr=mod.given("Tr");
  AdmsSensFadType modelPar_Trx=mod.Trx;
  bool modelPar_given_Trx=mod.given("Trx");
  AdmsSensFadType modelPar_Tf=mod.Tf;
  bool modelPar_given_Tf=mod.given("Tf");
  AdmsSensFadType modelPar_Tft=mod.Tft;
  bool modelPar_given_Tft=mod.given("Tft");
  AdmsSensFadType modelPar_Thcs=mod.Thcs;
  bool modelPar_given_Thcs=mod.given("Thcs");
  AdmsSensFadType modelPar_Ahc=mod.Ahc;
  bool modelPar_given_Ahc=mod.given("Ahc");
  AdmsSensFadType modelPar_Cje=mod.Cje;
  bool modelPar_given_Cje=mod.given("Cje");
  AdmsSensFadType modelPar_mje=mod.mje;
  bool modelPar_given_mje=mod.given("mje");
  AdmsSensFadType modelPar_Vje=mod.Vje;
  bool modelPar_given_Vje=mod.given("Vje");
  AdmsSensFadType modelPar_Cjc=mod.Cjc;
  bool modelPar_given_Cjc=mod.given("Cjc");
  AdmsSensFadType modelPar_mjc=mod.mjc;
  bool modelPar_given_mjc=mod.given("mjc");
  AdmsSensFadType modelPar_Vjc=mod.Vjc;
  bool modelPar_given_Vjc=mod.given("Vjc");
  AdmsSensFadType modelPar_kjc=mod.kjc;
  bool modelPar_given_kjc=mod.given("kjc");
  AdmsSensFadType modelPar_Cmin=mod.Cmin;
  bool modelPar_given_Cmin=mod.given("Cmin");
  AdmsSensFadType modelPar_J0=mod.J0;
  bool modelPar_given_J0=mod.given("J0");
  AdmsSensFadType modelPar_XJ0=mod.XJ0;
  bool modelPar_given_XJ0=mod.given("XJ0");
  AdmsSensFadType modelPar_Rci0=mod.Rci0;
  bool modelPar_given_Rci0=mod.given("Rci0");
  AdmsSensFadType modelPar_Jk=mod.Jk;
  bool modelPar_given_Jk=mod.given("Jk");
  AdmsSensFadType modelPar_RJk=mod.RJk;
  bool modelPar_given_RJk=mod.given("RJk");
  AdmsSensFadType modelPar_Vces=mod.Vces;
  bool modelPar_given_Vces=mod.given("Vces");
  AdmsSensFadType modelPar_Rc=mod.Rc;
  bool modelPar_given_Rc=mod.given("Rc");
  AdmsSensFadType modelPar_Re=mod.Re;
  bool modelPar_given_Re=mod.given("Re");
  AdmsSensFadType modelPar_Rb=mod.Rb;
  bool modelPar_given_Rb=mod.given("Rb");
  AdmsSensFadType modelPar_Rb2=mod.Rb2;
  bool modelPar_given_Rb2=mod.given("Rb2");
  AdmsSensFadType modelPar_Lc=mod.Lc;
  bool modelPar_given_Lc=mod.given("Lc");
  AdmsSensFadType modelPar_Le=mod.Le;
  bool modelPar_given_Le=mod.given("Le");
  AdmsSensFadType modelPar_Lb=mod.Lb;
  bool modelPar_given_Lb=mod.given("Lb");
  AdmsSensFadType modelPar_Cq=mod.Cq;
  bool modelPar_given_Cq=mod.given("Cq");
  AdmsSensFadType modelPar_Cpb=mod.Cpb;
  bool modelPar_given_Cpb=mod.given("Cpb");
  AdmsSensFadType modelPar_Cpc=mod.Cpc;
  bool modelPar_given_Cpc=mod.given("Cpc");
  AdmsSensFadType modelPar_Tnom=mod.Tnom;
  bool modelPar_given_Tnom=mod.given("Tnom");


  // hidden reals


  // non-reals (including hiddens)
  int modelPar_Mode=mod.Mode;
  bool modelPar_given_Mode=mod.given("Mode");
  int modelPar_Noise=mod.Noise;
  bool modelPar_given_Noise=mod.given("Noise");
  int modelPar_Debug=mod.Debug;
  bool modelPar_given_Debug=mod.given("Debug");
  int modelPar_DebugPlus=mod.DebugPlus;
  bool modelPar_given_DebugPlus=mod.given("DebugPlus");
  int modelPar_N=mod.N;
  bool modelPar_given_N=mod.given("N");
  int modelPar_dtype=mod.dtype;



  // Copy out all the instance parameters (doubles) into FAD types
  // Keep a map so we can set the right one to the independent variable
  // We do this solely to avoid a big ugly "if/else" block just to find the
  // one parameter we're doing sensitivities on.
  unordered_map <std::string,AdmsSensFadType*,HashNoCase,EqualNoCase> inParamMap;

  // reals
  AdmsSensFadType instancePar_Temp=in.Temp;
  bool instancePar_given_Temp=in.given("Temp");
  inParamMap["Temp"] = &instancePar_Temp;
  AdmsSensFadType instancePar_L=in.L;
  bool instancePar_given_L=in.given("L");
  inParamMap["L"] = &instancePar_L;
  AdmsSensFadType instancePar_W=in.W;
  bool instancePar_given_W=in.given("W");
  inParamMap["W"] = &instancePar_W;


  // Copy all the real hidden instance params into fad types



  // Copy all the non-real instance params into vars of their appropriate type:
  int instancePar_N=in.N;
  bool instancePar_given_N=in.given("N");


  // Set the one parameter whose name was passed in to be the independent
  // variable for Sacado purposes.  Since we stored variable pointers, this
  // makes sure that that ONE variable gets set right.
  // FIXME: make this check the name first, otherwise segfault on invalid name!
  inParamMap[name]->diff(0,1);

  //make local copies of all instance vars
  //reals


  //non-reals


  //make local copies of all model vars
  //reals


  // non-reals



  Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

  // extract solution variables and set as Fad independent variables.
  probeVars[in.admsProbeID_V_t_ti] = (*solVectorPtr)[in.li_t]- (*solVectorPtr)[in.li_ti];
  probeVars[in.admsProbeID_V_b_c] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_c];
  probeVars[in.admsProbeID_V_c_GND] = (*solVectorPtr)[in.li_c];
  probeVars[in.admsProbeID_V_b_GND] = (*solVectorPtr)[in.li_b];
  probeVars[in.admsProbeID_V_cx_bii] = (*solVectorPtr)[in.li_cx]- (*solVectorPtr)[in.li_bii];
  probeVars[in.admsProbeID_V_exx_bii] = (*solVectorPtr)[in.li_exx]- (*solVectorPtr)[in.li_bii];
  probeVars[in.admsProbeID_V_ex_bii] = (*solVectorPtr)[in.li_ex]- (*solVectorPtr)[in.li_bii];
  probeVars[in.admsProbeID_V_bii_bi] = (*solVectorPtr)[in.li_bii]- (*solVectorPtr)[in.li_bi];

  probeVars[in.admsProbeID_I_c_ci] = (*solVectorPtr)[in.li_BRA_c_ci];
  probeVars[in.admsProbeID_I_e_ei] = (*solVectorPtr)[in.li_BRA_e_ei];
  probeVars[in.admsProbeID_I_b_bi] = (*solVectorPtr)[in.li_BRA_b_bi];probeVars[in.admsProbeID_V_ti_GND] = (*solVectorPtr)[in.li_ti];
  probeVars[in.admsProbeID_V_ci_ei] = (*solVectorPtr)[in.li_ci]- (*solVectorPtr)[in.li_ei];
  probeVars[in.admsProbeID_V_exx_ei] = (*solVectorPtr)[in.li_exx]- (*solVectorPtr)[in.li_ei];
  probeVars[in.admsProbeID_V_cx_ci] = (*solVectorPtr)[in.li_cx]- (*solVectorPtr)[in.li_ci];
  probeVars[in.admsProbeID_V_ex_ei] = (*solVectorPtr)[in.li_ex]- (*solVectorPtr)[in.li_ei];
  probeVars[in.admsProbeID_V_bii_ei] = (*solVectorPtr)[in.li_bii]- (*solVectorPtr)[in.li_ei];
  probeVars[in.admsProbeID_V_bii_ci] = (*solVectorPtr)[in.li_bii]- (*solVectorPtr)[in.li_ci];
  probeVars[in.admsProbeID_V_bi_ci] = (*solVectorPtr)[in.li_bi]- (*solVectorPtr)[in.li_ci];


  // pre-multiply any "typed" probes (i.e. those limited with "typedpnjlim")
    
  probeVars[in.admsProbeID_V_bii_ei] *= modelPar_dtype;
  probeVars[in.admsProbeID_V_bii_ci] *= modelPar_dtype;
  probeVars[in.admsProbeID_V_bi_ci] *= modelPar_dtype;



  // Now call  the function that does the heavy lifting.
  evaluateModelEquations(
     probeVars,
     // probe constants
     in.admsProbeID_V_t_ti,
     in.admsProbeID_V_b_c,
     in.admsProbeID_V_c_GND,
     in.admsProbeID_V_b_GND,
     in.admsProbeID_V_cx_bii,
     in.admsProbeID_V_exx_bii,
     in.admsProbeID_V_ex_bii,
     in.admsProbeID_V_bii_bi,
     in.admsProbeID_I_c_ci,
     in.admsProbeID_I_e_ei,
     in.admsProbeID_I_b_bi,
     in.admsProbeID_V_ti_GND,
     in.admsProbeID_V_ci_ei,
     in.admsProbeID_V_exx_ei,
     in.admsProbeID_V_cx_ci,
     in.admsProbeID_V_ex_ei,
     in.admsProbeID_V_bii_ei,
     in.admsProbeID_V_bii_ci,
     in.admsProbeID_V_bi_ci,

     // node constants
     in.admsNodeID_c,
     in.admsNodeID_b,
     in.admsNodeID_e,
     in.admsNodeID_t,
     in.admsNodeID_ei,
     in.admsNodeID_bi,
     in.admsNodeID_bii,
     in.admsNodeID_ci,
     in.admsNodeID_ti,
     in.admsNodeID_ex,
     in.admsNodeID_exx,
     in.admsNodeID_cx,
     in.admsBRA_ID_b_bi,
     in.admsBRA_ID_e_ei,
     in.admsBRA_ID_c_ci,
     // instance parameters
     // reals
     instancePar_Temp,
     instancePar_given_Temp,
     instancePar_L,
     instancePar_given_L,
     instancePar_W,
     instancePar_given_W,
     // non-reals(including hidden)
     instancePar_N,
     instancePar_given_N,
     // model parameters
     // reals
     modelPar_Temp,
     modelPar_given_Temp,
     modelPar_Rth,
     modelPar_given_Rth,
     modelPar_Cth,
     modelPar_given_Cth,
     modelPar_L,
     modelPar_given_L,
     modelPar_W,
     modelPar_given_W,
     modelPar_Jsf,
     modelPar_given_Jsf,
     modelPar_nf,
     modelPar_given_nf,
     modelPar_Vg,
     modelPar_given_Vg,
     modelPar_Jse,
     modelPar_given_Jse,
     modelPar_ne,
     modelPar_given_ne,
     modelPar_Rbxx,
     modelPar_given_Rbxx,
     modelPar_Vgb,
     modelPar_given_Vgb,
     modelPar_Jsee,
     modelPar_given_Jsee,
     modelPar_nee,
     modelPar_given_nee,
     modelPar_Rbbxx,
     modelPar_given_Rbbxx,
     modelPar_Vgbb,
     modelPar_given_Vgbb,
     modelPar_Jsr,
     modelPar_given_Jsr,
     modelPar_nr,
     modelPar_given_nr,
     modelPar_Vgr,
     modelPar_given_Vgr,
     modelPar_XCjc,
     modelPar_given_XCjc,
     modelPar_Jsc,
     modelPar_given_Jsc,
     modelPar_nc,
     modelPar_given_nc,
     modelPar_Rcxx,
     modelPar_given_Rcxx,
     modelPar_Vgc,
     modelPar_given_Vgc,
     modelPar_Bf,
     modelPar_given_Bf,
     modelPar_kBeta,
     modelPar_given_kBeta,
     modelPar_Br,
     modelPar_given_Br,
     modelPar_VAF,
     modelPar_given_VAF,
     modelPar_VAR,
     modelPar_given_VAR,
     modelPar_IKF,
     modelPar_given_IKF,
     modelPar_IKR,
     modelPar_given_IKR,
     modelPar_Mc,
     modelPar_given_Mc,
     modelPar_BVceo,
     modelPar_given_BVceo,
     modelPar_kc,
     modelPar_given_kc,
     modelPar_BVebo,
     modelPar_given_BVebo,
     modelPar_Tr,
     modelPar_given_Tr,
     modelPar_Trx,
     modelPar_given_Trx,
     modelPar_Tf,
     modelPar_given_Tf,
     modelPar_Tft,
     modelPar_given_Tft,
     modelPar_Thcs,
     modelPar_given_Thcs,
     modelPar_Ahc,
     modelPar_given_Ahc,
     modelPar_Cje,
     modelPar_given_Cje,
     modelPar_mje,
     modelPar_given_mje,
     modelPar_Vje,
     modelPar_given_Vje,
     modelPar_Cjc,
     modelPar_given_Cjc,
     modelPar_mjc,
     modelPar_given_mjc,
     modelPar_Vjc,
     modelPar_given_Vjc,
     modelPar_kjc,
     modelPar_given_kjc,
     modelPar_Cmin,
     modelPar_given_Cmin,
     modelPar_J0,
     modelPar_given_J0,
     modelPar_XJ0,
     modelPar_given_XJ0,
     modelPar_Rci0,
     modelPar_given_Rci0,
     modelPar_Jk,
     modelPar_given_Jk,
     modelPar_RJk,
     modelPar_given_RJk,
     modelPar_Vces,
     modelPar_given_Vces,
     modelPar_Rc,
     modelPar_given_Rc,
     modelPar_Re,
     modelPar_given_Re,
     modelPar_Rb,
     modelPar_given_Rb,
     modelPar_Rb2,
     modelPar_given_Rb2,
     modelPar_Lc,
     modelPar_given_Lc,
     modelPar_Le,
     modelPar_given_Le,
     modelPar_Lb,
     modelPar_given_Lb,
     modelPar_Cq,
     modelPar_given_Cq,
     modelPar_Cpb,
     modelPar_given_Cpb,
     modelPar_Cpc,
     modelPar_given_Cpc,
     modelPar_Tnom,
     modelPar_given_Tnom,
     // non-reals (including hidden)
     modelPar_Mode,
     modelPar_given_Mode,
     modelPar_Noise,
     modelPar_given_Noise,
     modelPar_Debug,
     modelPar_given_Debug,
     modelPar_DebugPlus,
     modelPar_given_DebugPlus,
     modelPar_N,
     modelPar_given_N,
     modelPar_dtype,
     in.admsTemperature,
     in.adms_vt_nom,
     in.getDeviceOptions().gmin,
     staticContributions,
     dynamicContributions,
     in);


  // We now have the F and Q vector stuff, populate the dependencies:

  dfdp[in.admsNodeID_c] += staticContributions[in.admsNodeID_c].dx(0);
  dqdp[in.admsNodeID_c] += dynamicContributions[in.admsNodeID_c].dx(0);
  Findices[in.admsNodeID_c] = in.li_c;
  Qindices[in.admsNodeID_c] = in.li_c;
  dfdp[in.admsNodeID_b] += staticContributions[in.admsNodeID_b].dx(0);
  dqdp[in.admsNodeID_b] += dynamicContributions[in.admsNodeID_b].dx(0);
  Findices[in.admsNodeID_b] = in.li_b;
  Qindices[in.admsNodeID_b] = in.li_b;
  dfdp[in.admsNodeID_e] += staticContributions[in.admsNodeID_e].dx(0);
  dqdp[in.admsNodeID_e] += dynamicContributions[in.admsNodeID_e].dx(0);
  Findices[in.admsNodeID_e] = in.li_e;
  Qindices[in.admsNodeID_e] = in.li_e;
  dfdp[in.admsNodeID_t] += staticContributions[in.admsNodeID_t].dx(0);
  dqdp[in.admsNodeID_t] += dynamicContributions[in.admsNodeID_t].dx(0);
  Findices[in.admsNodeID_t] = in.li_t;
  Qindices[in.admsNodeID_t] = in.li_t;
  dfdp[in.admsNodeID_ei] += staticContributions[in.admsNodeID_ei].dx(0);
  dqdp[in.admsNodeID_ei] += dynamicContributions[in.admsNodeID_ei].dx(0);
  Findices[in.admsNodeID_ei] = in.li_ei;
  Qindices[in.admsNodeID_ei] = in.li_ei;
  dfdp[in.admsNodeID_bi] += staticContributions[in.admsNodeID_bi].dx(0);
  dqdp[in.admsNodeID_bi] += dynamicContributions[in.admsNodeID_bi].dx(0);
  Findices[in.admsNodeID_bi] = in.li_bi;
  Qindices[in.admsNodeID_bi] = in.li_bi;
  dfdp[in.admsNodeID_bii] += staticContributions[in.admsNodeID_bii].dx(0);
  dqdp[in.admsNodeID_bii] += dynamicContributions[in.admsNodeID_bii].dx(0);
  Findices[in.admsNodeID_bii] = in.li_bii;
  Qindices[in.admsNodeID_bii] = in.li_bii;
  dfdp[in.admsNodeID_ci] += staticContributions[in.admsNodeID_ci].dx(0);
  dqdp[in.admsNodeID_ci] += dynamicContributions[in.admsNodeID_ci].dx(0);
  Findices[in.admsNodeID_ci] = in.li_ci;
  Qindices[in.admsNodeID_ci] = in.li_ci;
  dfdp[in.admsNodeID_ti] += staticContributions[in.admsNodeID_ti].dx(0);
  dqdp[in.admsNodeID_ti] += dynamicContributions[in.admsNodeID_ti].dx(0);
  Findices[in.admsNodeID_ti] = in.li_ti;
  Qindices[in.admsNodeID_ti] = in.li_ti;
  dfdp[in.admsNodeID_ex] += staticContributions[in.admsNodeID_ex].dx(0);
  dqdp[in.admsNodeID_ex] += dynamicContributions[in.admsNodeID_ex].dx(0);
  Findices[in.admsNodeID_ex] = in.li_ex;
  Qindices[in.admsNodeID_ex] = in.li_ex;
  dfdp[in.admsNodeID_exx] += staticContributions[in.admsNodeID_exx].dx(0);
  dqdp[in.admsNodeID_exx] += dynamicContributions[in.admsNodeID_exx].dx(0);
  Findices[in.admsNodeID_exx] = in.li_exx;
  Qindices[in.admsNodeID_exx] = in.li_exx;
  dfdp[in.admsNodeID_cx] += staticContributions[in.admsNodeID_cx].dx(0);
  dqdp[in.admsNodeID_cx] += dynamicContributions[in.admsNodeID_cx].dx(0);
  Findices[in.admsNodeID_cx] = in.li_cx;
  Qindices[in.admsNodeID_cx] = in.li_cx;
  dfdp[in.admsBRA_ID_b_bi] += staticContributions[in.admsBRA_ID_b_bi].dx(0);
  dqdp[in.admsBRA_ID_b_bi] += dynamicContributions[in.admsBRA_ID_b_bi].dx(0);
  Findices[in.admsBRA_ID_b_bi] = in.li_BRA_b_bi;
  Qindices[in.admsBRA_ID_b_bi] = in.li_BRA_b_bi;
  dfdp[in.admsBRA_ID_e_ei] += staticContributions[in.admsBRA_ID_e_ei].dx(0);
  dqdp[in.admsBRA_ID_e_ei] += dynamicContributions[in.admsBRA_ID_e_ei].dx(0);
  Findices[in.admsBRA_ID_e_ei] = in.li_BRA_e_ei;
  Qindices[in.admsBRA_ID_e_ei] = in.li_BRA_e_ei;
  dfdp[in.admsBRA_ID_c_ci] += staticContributions[in.admsBRA_ID_c_ci].dx(0);
  dqdp[in.admsBRA_ID_c_ci] += dynamicContributions[in.admsBRA_ID_c_ci].dx(0);
  Findices[in.admsBRA_ID_c_ci] = in.li_BRA_c_ci;
  Qindices[in.admsBRA_ID_c_ci] = in.li_BRA_c_ci;


}

//-----------------------------------------------------------------------------
// Function      : ModelSensitivity::operator()
// Purpose       : return sensitivity for a single model parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
/// Compute sensitivity to a specified model
/// parameter of all device instances of that model's outputs
/// 
/// 
/// @param[in] entity  The device entity that owns the parameter 
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
/// 
/// 
void ModelSensitivity::operator()
  (
     const ParameterBase &entity,
     const std::string &name,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
   ) const
{
  const ParameterBase * e1 = &entity;
  const Model & mod = *(dynamic_cast<const Model *> (e1));
  int sizeInstance = mod.instanceContainer.size();

  dfdp.resize((12+3)*sizeInstance);
  dqdp.resize((12+3)*sizeInstance);
  Findices.resize((12+3)*sizeInstance);
  Qindices.resize((12+3)*sizeInstance);

  std::vector <double> probeVars(19);
  std::vector <AdmsSensFadType> staticContributions(12+3);
  std::vector <AdmsSensFadType> dynamicContributions(12+3);


  // Copy out all the model parameters (doubles) into FAD types
  // Keep a map so we can set the right one to the independent variable
  // We do this solely to avoid a big ugly "if/else" block just to find the
  // one parameter we're doing sensitivities on.
  unordered_map <std::string,AdmsSensFadType*,HashNoCase,EqualNoCase> modParamMap;

  // reals
  AdmsSensFadType modelPar_Temp=mod.Temp;
  bool modelPar_given_Temp=mod.given("Temp");
  modParamMap["Temp"] = &modelPar_Temp;
  AdmsSensFadType modelPar_Rth=mod.Rth;
  bool modelPar_given_Rth=mod.given("Rth");
  modParamMap["Rth"] = &modelPar_Rth;
  AdmsSensFadType modelPar_Cth=mod.Cth;
  bool modelPar_given_Cth=mod.given("Cth");
  modParamMap["Cth"] = &modelPar_Cth;
  AdmsSensFadType modelPar_L=mod.L;
  bool modelPar_given_L=mod.given("L");
  modParamMap["L"] = &modelPar_L;
  AdmsSensFadType modelPar_W=mod.W;
  bool modelPar_given_W=mod.given("W");
  modParamMap["W"] = &modelPar_W;
  AdmsSensFadType modelPar_Jsf=mod.Jsf;
  bool modelPar_given_Jsf=mod.given("Jsf");
  modParamMap["Jsf"] = &modelPar_Jsf;
  AdmsSensFadType modelPar_nf=mod.nf;
  bool modelPar_given_nf=mod.given("nf");
  modParamMap["nf"] = &modelPar_nf;
  AdmsSensFadType modelPar_Vg=mod.Vg;
  bool modelPar_given_Vg=mod.given("Vg");
  modParamMap["Vg"] = &modelPar_Vg;
  AdmsSensFadType modelPar_Jse=mod.Jse;
  bool modelPar_given_Jse=mod.given("Jse");
  modParamMap["Jse"] = &modelPar_Jse;
  AdmsSensFadType modelPar_ne=mod.ne;
  bool modelPar_given_ne=mod.given("ne");
  modParamMap["ne"] = &modelPar_ne;
  AdmsSensFadType modelPar_Rbxx=mod.Rbxx;
  bool modelPar_given_Rbxx=mod.given("Rbxx");
  modParamMap["Rbxx"] = &modelPar_Rbxx;
  AdmsSensFadType modelPar_Vgb=mod.Vgb;
  bool modelPar_given_Vgb=mod.given("Vgb");
  modParamMap["Vgb"] = &modelPar_Vgb;
  AdmsSensFadType modelPar_Jsee=mod.Jsee;
  bool modelPar_given_Jsee=mod.given("Jsee");
  modParamMap["Jsee"] = &modelPar_Jsee;
  AdmsSensFadType modelPar_nee=mod.nee;
  bool modelPar_given_nee=mod.given("nee");
  modParamMap["nee"] = &modelPar_nee;
  AdmsSensFadType modelPar_Rbbxx=mod.Rbbxx;
  bool modelPar_given_Rbbxx=mod.given("Rbbxx");
  modParamMap["Rbbxx"] = &modelPar_Rbbxx;
  AdmsSensFadType modelPar_Vgbb=mod.Vgbb;
  bool modelPar_given_Vgbb=mod.given("Vgbb");
  modParamMap["Vgbb"] = &modelPar_Vgbb;
  AdmsSensFadType modelPar_Jsr=mod.Jsr;
  bool modelPar_given_Jsr=mod.given("Jsr");
  modParamMap["Jsr"] = &modelPar_Jsr;
  AdmsSensFadType modelPar_nr=mod.nr;
  bool modelPar_given_nr=mod.given("nr");
  modParamMap["nr"] = &modelPar_nr;
  AdmsSensFadType modelPar_Vgr=mod.Vgr;
  bool modelPar_given_Vgr=mod.given("Vgr");
  modParamMap["Vgr"] = &modelPar_Vgr;
  AdmsSensFadType modelPar_XCjc=mod.XCjc;
  bool modelPar_given_XCjc=mod.given("XCjc");
  modParamMap["XCjc"] = &modelPar_XCjc;
  AdmsSensFadType modelPar_Jsc=mod.Jsc;
  bool modelPar_given_Jsc=mod.given("Jsc");
  modParamMap["Jsc"] = &modelPar_Jsc;
  AdmsSensFadType modelPar_nc=mod.nc;
  bool modelPar_given_nc=mod.given("nc");
  modParamMap["nc"] = &modelPar_nc;
  AdmsSensFadType modelPar_Rcxx=mod.Rcxx;
  bool modelPar_given_Rcxx=mod.given("Rcxx");
  modParamMap["Rcxx"] = &modelPar_Rcxx;
  AdmsSensFadType modelPar_Vgc=mod.Vgc;
  bool modelPar_given_Vgc=mod.given("Vgc");
  modParamMap["Vgc"] = &modelPar_Vgc;
  AdmsSensFadType modelPar_Bf=mod.Bf;
  bool modelPar_given_Bf=mod.given("Bf");
  modParamMap["Bf"] = &modelPar_Bf;
  AdmsSensFadType modelPar_kBeta=mod.kBeta;
  bool modelPar_given_kBeta=mod.given("kBeta");
  modParamMap["kBeta"] = &modelPar_kBeta;
  AdmsSensFadType modelPar_Br=mod.Br;
  bool modelPar_given_Br=mod.given("Br");
  modParamMap["Br"] = &modelPar_Br;
  AdmsSensFadType modelPar_VAF=mod.VAF;
  bool modelPar_given_VAF=mod.given("VAF");
  modParamMap["VAF"] = &modelPar_VAF;
  AdmsSensFadType modelPar_VAR=mod.VAR;
  bool modelPar_given_VAR=mod.given("VAR");
  modParamMap["VAR"] = &modelPar_VAR;
  AdmsSensFadType modelPar_IKF=mod.IKF;
  bool modelPar_given_IKF=mod.given("IKF");
  modParamMap["IKF"] = &modelPar_IKF;
  AdmsSensFadType modelPar_IKR=mod.IKR;
  bool modelPar_given_IKR=mod.given("IKR");
  modParamMap["IKR"] = &modelPar_IKR;
  AdmsSensFadType modelPar_Mc=mod.Mc;
  bool modelPar_given_Mc=mod.given("Mc");
  modParamMap["Mc"] = &modelPar_Mc;
  AdmsSensFadType modelPar_BVceo=mod.BVceo;
  bool modelPar_given_BVceo=mod.given("BVceo");
  modParamMap["BVceo"] = &modelPar_BVceo;
  AdmsSensFadType modelPar_kc=mod.kc;
  bool modelPar_given_kc=mod.given("kc");
  modParamMap["kc"] = &modelPar_kc;
  AdmsSensFadType modelPar_BVebo=mod.BVebo;
  bool modelPar_given_BVebo=mod.given("BVebo");
  modParamMap["BVebo"] = &modelPar_BVebo;
  AdmsSensFadType modelPar_Tr=mod.Tr;
  bool modelPar_given_Tr=mod.given("Tr");
  modParamMap["Tr"] = &modelPar_Tr;
  AdmsSensFadType modelPar_Trx=mod.Trx;
  bool modelPar_given_Trx=mod.given("Trx");
  modParamMap["Trx"] = &modelPar_Trx;
  AdmsSensFadType modelPar_Tf=mod.Tf;
  bool modelPar_given_Tf=mod.given("Tf");
  modParamMap["Tf"] = &modelPar_Tf;
  AdmsSensFadType modelPar_Tft=mod.Tft;
  bool modelPar_given_Tft=mod.given("Tft");
  modParamMap["Tft"] = &modelPar_Tft;
  AdmsSensFadType modelPar_Thcs=mod.Thcs;
  bool modelPar_given_Thcs=mod.given("Thcs");
  modParamMap["Thcs"] = &modelPar_Thcs;
  AdmsSensFadType modelPar_Ahc=mod.Ahc;
  bool modelPar_given_Ahc=mod.given("Ahc");
  modParamMap["Ahc"] = &modelPar_Ahc;
  AdmsSensFadType modelPar_Cje=mod.Cje;
  bool modelPar_given_Cje=mod.given("Cje");
  modParamMap["Cje"] = &modelPar_Cje;
  AdmsSensFadType modelPar_mje=mod.mje;
  bool modelPar_given_mje=mod.given("mje");
  modParamMap["mje"] = &modelPar_mje;
  AdmsSensFadType modelPar_Vje=mod.Vje;
  bool modelPar_given_Vje=mod.given("Vje");
  modParamMap["Vje"] = &modelPar_Vje;
  AdmsSensFadType modelPar_Cjc=mod.Cjc;
  bool modelPar_given_Cjc=mod.given("Cjc");
  modParamMap["Cjc"] = &modelPar_Cjc;
  AdmsSensFadType modelPar_mjc=mod.mjc;
  bool modelPar_given_mjc=mod.given("mjc");
  modParamMap["mjc"] = &modelPar_mjc;
  AdmsSensFadType modelPar_Vjc=mod.Vjc;
  bool modelPar_given_Vjc=mod.given("Vjc");
  modParamMap["Vjc"] = &modelPar_Vjc;
  AdmsSensFadType modelPar_kjc=mod.kjc;
  bool modelPar_given_kjc=mod.given("kjc");
  modParamMap["kjc"] = &modelPar_kjc;
  AdmsSensFadType modelPar_Cmin=mod.Cmin;
  bool modelPar_given_Cmin=mod.given("Cmin");
  modParamMap["Cmin"] = &modelPar_Cmin;
  AdmsSensFadType modelPar_J0=mod.J0;
  bool modelPar_given_J0=mod.given("J0");
  modParamMap["J0"] = &modelPar_J0;
  AdmsSensFadType modelPar_XJ0=mod.XJ0;
  bool modelPar_given_XJ0=mod.given("XJ0");
  modParamMap["XJ0"] = &modelPar_XJ0;
  AdmsSensFadType modelPar_Rci0=mod.Rci0;
  bool modelPar_given_Rci0=mod.given("Rci0");
  modParamMap["Rci0"] = &modelPar_Rci0;
  AdmsSensFadType modelPar_Jk=mod.Jk;
  bool modelPar_given_Jk=mod.given("Jk");
  modParamMap["Jk"] = &modelPar_Jk;
  AdmsSensFadType modelPar_RJk=mod.RJk;
  bool modelPar_given_RJk=mod.given("RJk");
  modParamMap["RJk"] = &modelPar_RJk;
  AdmsSensFadType modelPar_Vces=mod.Vces;
  bool modelPar_given_Vces=mod.given("Vces");
  modParamMap["Vces"] = &modelPar_Vces;
  AdmsSensFadType modelPar_Rc=mod.Rc;
  bool modelPar_given_Rc=mod.given("Rc");
  modParamMap["Rc"] = &modelPar_Rc;
  AdmsSensFadType modelPar_Re=mod.Re;
  bool modelPar_given_Re=mod.given("Re");
  modParamMap["Re"] = &modelPar_Re;
  AdmsSensFadType modelPar_Rb=mod.Rb;
  bool modelPar_given_Rb=mod.given("Rb");
  modParamMap["Rb"] = &modelPar_Rb;
  AdmsSensFadType modelPar_Rb2=mod.Rb2;
  bool modelPar_given_Rb2=mod.given("Rb2");
  modParamMap["Rb2"] = &modelPar_Rb2;
  AdmsSensFadType modelPar_Lc=mod.Lc;
  bool modelPar_given_Lc=mod.given("Lc");
  modParamMap["Lc"] = &modelPar_Lc;
  AdmsSensFadType modelPar_Le=mod.Le;
  bool modelPar_given_Le=mod.given("Le");
  modParamMap["Le"] = &modelPar_Le;
  AdmsSensFadType modelPar_Lb=mod.Lb;
  bool modelPar_given_Lb=mod.given("Lb");
  modParamMap["Lb"] = &modelPar_Lb;
  AdmsSensFadType modelPar_Cq=mod.Cq;
  bool modelPar_given_Cq=mod.given("Cq");
  modParamMap["Cq"] = &modelPar_Cq;
  AdmsSensFadType modelPar_Cpb=mod.Cpb;
  bool modelPar_given_Cpb=mod.given("Cpb");
  modParamMap["Cpb"] = &modelPar_Cpb;
  AdmsSensFadType modelPar_Cpc=mod.Cpc;
  bool modelPar_given_Cpc=mod.given("Cpc");
  modParamMap["Cpc"] = &modelPar_Cpc;
  AdmsSensFadType modelPar_Tnom=mod.Tnom;
  bool modelPar_given_Tnom=mod.given("Tnom");
  modParamMap["Tnom"] = &modelPar_Tnom;


  // hidden reals


  // non-reals (including hiddens)
  int modelPar_Mode=mod.Mode;
  bool modelPar_given_Mode=mod.given("Mode");
  int modelPar_Noise=mod.Noise;
  bool modelPar_given_Noise=mod.given("Noise");
  int modelPar_Debug=mod.Debug;
  bool modelPar_given_Debug=mod.given("Debug");
  int modelPar_DebugPlus=mod.DebugPlus;
  bool modelPar_given_DebugPlus=mod.given("DebugPlus");
  int modelPar_N=mod.N;
  bool modelPar_given_N=mod.given("N");
  int modelPar_dtype=mod.dtype;


  // Set the one parameter whose name was passed in to be the independent
  // variable for Sacado purposes.  Since we stored variable pointers, this
  // makes sure that that ONE variable gets set right.
  // FIXME: make this check name for presence first!  Segfault on invalid.
  modParamMap[name]->diff(0,1);

  //make local copies of all model vars
  //reals


  // non-reals



  // Now loop over all instances and do the deed
  int inst=0;
  for (std::vector<Instance*>::const_iterator in_it=mod.instanceContainer.begin(); in_it != mod.instanceContainer.end(); ++in_it,++inst)
  {

    Instance & in=*(*in_it);
    // initialize contributions to zero (automatically sets derivatives to zero)
    for (int i=0; i < 12+3 ; ++i)
    {
      staticContributions[i]=0;
      dynamicContributions[i]=0;
    }



    // Copy out all the instance parameters (doubles) into FAD types
    // reals
    AdmsSensFadType instancePar_Temp=in.Temp;
    bool instancePar_given_Temp=in.given("Temp");
    AdmsSensFadType instancePar_L=in.L;
    bool instancePar_given_L=in.given("L");
    AdmsSensFadType instancePar_W=in.W;
    bool instancePar_given_W=in.given("W");


    // real hidden instance


    // Copy all the non-real instance params into vars of their appropriate type:
    int instancePar_N=in.N;
    bool instancePar_given_N=in.given("N");




    // If there are any instance parameters that were not given, and have
    // corresponding model params, copy the model param into the instance.
    // This was already done by the instance constructor, but we do it again
    // because now we're propagating derivatives, and the user could be trying
    // to get sensitivity to the model parameter.
    if (!(in.given("Temp")))
    {
      instancePar_Temp = modelPar_Temp;
    }
    if (!(in.given("N")))
    {
      instancePar_N = modelPar_N;
    }
    if (!(in.given("L")))
    {
      instancePar_L = modelPar_L;
    }
    if (!(in.given("W")))
    {
      instancePar_W = modelPar_W;
    }


    //make local copies of all instance vars
    //reals
  
  
    //non-reals
  
  
  
    Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

    // extract solution variables and set as Fad independent variables.
    probeVars[in.admsProbeID_V_t_ti] = (*solVectorPtr)[in.li_t] - (*solVectorPtr)[in.li_ti];
    probeVars[in.admsProbeID_V_b_c] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_c];
    probeVars[in.admsProbeID_V_c_GND] = (*solVectorPtr)[in.li_c];
    probeVars[in.admsProbeID_V_b_GND] = (*solVectorPtr)[in.li_b];
    probeVars[in.admsProbeID_V_cx_bii] = (*solVectorPtr)[in.li_cx] - (*solVectorPtr)[in.li_bii];
    probeVars[in.admsProbeID_V_exx_bii] = (*solVectorPtr)[in.li_exx] - (*solVectorPtr)[in.li_bii];
    probeVars[in.admsProbeID_V_ex_bii] = (*solVectorPtr)[in.li_ex] - (*solVectorPtr)[in.li_bii];
    probeVars[in.admsProbeID_V_bii_bi] = (*solVectorPtr)[in.li_bii] - (*solVectorPtr)[in.li_bi];
    probeVars[in.admsProbeID_I_c_ci] = (*solVectorPtr)[in.li_BRA_c_ci];
    probeVars[in.admsProbeID_I_e_ei] = (*solVectorPtr)[in.li_BRA_e_ei];
    probeVars[in.admsProbeID_I_b_bi] = (*solVectorPtr)[in.li_BRA_b_bi];
    probeVars[in.admsProbeID_V_ti_GND] = (*solVectorPtr)[in.li_ti];
    probeVars[in.admsProbeID_V_ci_ei] = (*solVectorPtr)[in.li_ci] - (*solVectorPtr)[in.li_ei];
    probeVars[in.admsProbeID_V_exx_ei] = (*solVectorPtr)[in.li_exx] - (*solVectorPtr)[in.li_ei];
    probeVars[in.admsProbeID_V_cx_ci] = (*solVectorPtr)[in.li_cx] - (*solVectorPtr)[in.li_ci];
    probeVars[in.admsProbeID_V_ex_ei] = (*solVectorPtr)[in.li_ex] - (*solVectorPtr)[in.li_ei];
    probeVars[in.admsProbeID_V_bii_ei] = (*solVectorPtr)[in.li_bii] - (*solVectorPtr)[in.li_ei];
    probeVars[in.admsProbeID_V_bii_ci] = (*solVectorPtr)[in.li_bii] - (*solVectorPtr)[in.li_ci];
    probeVars[in.admsProbeID_V_bi_ci] = (*solVectorPtr)[in.li_bi] - (*solVectorPtr)[in.li_ci];

    
    // pre-multiply any "typed" probes (i.e. those limited with "typedpnjlim")
    probeVars[in.admsProbeID_V_bii_ei] *= modelPar_dtype;
    probeVars[in.admsProbeID_V_bii_ci] *= modelPar_dtype;
    probeVars[in.admsProbeID_V_bi_ci] *= modelPar_dtype;




    // Now call  the function that does the heavy lifting.

    evaluateModelEquations(
       probeVars,
       // probe constants
       in.admsProbeID_V_t_ti,
       in.admsProbeID_V_b_c,
       in.admsProbeID_V_c_GND,
       in.admsProbeID_V_b_GND,
       in.admsProbeID_V_cx_bii,
       in.admsProbeID_V_exx_bii,
       in.admsProbeID_V_ex_bii,
       in.admsProbeID_V_bii_bi,
       in.admsProbeID_I_c_ci,
       in.admsProbeID_I_e_ei,
       in.admsProbeID_I_b_bi,
       in.admsProbeID_V_ti_GND,
       in.admsProbeID_V_ci_ei,
       in.admsProbeID_V_exx_ei,
       in.admsProbeID_V_cx_ci,
       in.admsProbeID_V_ex_ei,
       in.admsProbeID_V_bii_ei,
       in.admsProbeID_V_bii_ci,
       in.admsProbeID_V_bi_ci,

       // node constants
       in.admsNodeID_c,
       in.admsNodeID_b,
       in.admsNodeID_e,
       in.admsNodeID_t,
       in.admsNodeID_ei,
       in.admsNodeID_bi,
       in.admsNodeID_bii,
       in.admsNodeID_ci,
       in.admsNodeID_ti,
       in.admsNodeID_ex,
       in.admsNodeID_exx,
       in.admsNodeID_cx,
       in.admsBRA_ID_b_bi,
       in.admsBRA_ID_e_ei,
       in.admsBRA_ID_c_ci,
       // instance parameters
       // reals
       instancePar_Temp,
       instancePar_given_Temp,
       instancePar_L,
       instancePar_given_L,
       instancePar_W,
       instancePar_given_W,
       // non-reals(including hidden)
       instancePar_N,
       instancePar_given_N,
       // model parameters
       // reals
       modelPar_Temp,
       modelPar_given_Temp,
       modelPar_Rth,
       modelPar_given_Rth,
       modelPar_Cth,
       modelPar_given_Cth,
       modelPar_L,
       modelPar_given_L,
       modelPar_W,
       modelPar_given_W,
       modelPar_Jsf,
       modelPar_given_Jsf,
       modelPar_nf,
       modelPar_given_nf,
       modelPar_Vg,
       modelPar_given_Vg,
       modelPar_Jse,
       modelPar_given_Jse,
       modelPar_ne,
       modelPar_given_ne,
       modelPar_Rbxx,
       modelPar_given_Rbxx,
       modelPar_Vgb,
       modelPar_given_Vgb,
       modelPar_Jsee,
       modelPar_given_Jsee,
       modelPar_nee,
       modelPar_given_nee,
       modelPar_Rbbxx,
       modelPar_given_Rbbxx,
       modelPar_Vgbb,
       modelPar_given_Vgbb,
       modelPar_Jsr,
       modelPar_given_Jsr,
       modelPar_nr,
       modelPar_given_nr,
       modelPar_Vgr,
       modelPar_given_Vgr,
       modelPar_XCjc,
       modelPar_given_XCjc,
       modelPar_Jsc,
       modelPar_given_Jsc,
       modelPar_nc,
       modelPar_given_nc,
       modelPar_Rcxx,
       modelPar_given_Rcxx,
       modelPar_Vgc,
       modelPar_given_Vgc,
       modelPar_Bf,
       modelPar_given_Bf,
       modelPar_kBeta,
       modelPar_given_kBeta,
       modelPar_Br,
       modelPar_given_Br,
       modelPar_VAF,
       modelPar_given_VAF,
       modelPar_VAR,
       modelPar_given_VAR,
       modelPar_IKF,
       modelPar_given_IKF,
       modelPar_IKR,
       modelPar_given_IKR,
       modelPar_Mc,
       modelPar_given_Mc,
       modelPar_BVceo,
       modelPar_given_BVceo,
       modelPar_kc,
       modelPar_given_kc,
       modelPar_BVebo,
       modelPar_given_BVebo,
       modelPar_Tr,
       modelPar_given_Tr,
       modelPar_Trx,
       modelPar_given_Trx,
       modelPar_Tf,
       modelPar_given_Tf,
       modelPar_Tft,
       modelPar_given_Tft,
       modelPar_Thcs,
       modelPar_given_Thcs,
       modelPar_Ahc,
       modelPar_given_Ahc,
       modelPar_Cje,
       modelPar_given_Cje,
       modelPar_mje,
       modelPar_given_mje,
       modelPar_Vje,
       modelPar_given_Vje,
       modelPar_Cjc,
       modelPar_given_Cjc,
       modelPar_mjc,
       modelPar_given_mjc,
       modelPar_Vjc,
       modelPar_given_Vjc,
       modelPar_kjc,
       modelPar_given_kjc,
       modelPar_Cmin,
       modelPar_given_Cmin,
       modelPar_J0,
       modelPar_given_J0,
       modelPar_XJ0,
       modelPar_given_XJ0,
       modelPar_Rci0,
       modelPar_given_Rci0,
       modelPar_Jk,
       modelPar_given_Jk,
       modelPar_RJk,
       modelPar_given_RJk,
       modelPar_Vces,
       modelPar_given_Vces,
       modelPar_Rc,
       modelPar_given_Rc,
       modelPar_Re,
       modelPar_given_Re,
       modelPar_Rb,
       modelPar_given_Rb,
       modelPar_Rb2,
       modelPar_given_Rb2,
       modelPar_Lc,
       modelPar_given_Lc,
       modelPar_Le,
       modelPar_given_Le,
       modelPar_Lb,
       modelPar_given_Lb,
       modelPar_Cq,
       modelPar_given_Cq,
       modelPar_Cpb,
       modelPar_given_Cpb,
       modelPar_Cpc,
       modelPar_given_Cpc,
       modelPar_Tnom,
       modelPar_given_Tnom,
       // non-reals (including hidden)
       modelPar_Mode,
       modelPar_given_Mode,
       modelPar_Noise,
       modelPar_given_Noise,
       modelPar_Debug,
       modelPar_given_Debug,
       modelPar_DebugPlus,
       modelPar_given_DebugPlus,
       modelPar_N,
       modelPar_given_N,
       modelPar_dtype,
       in.admsTemperature,
       in.adms_vt_nom,
       in.getDeviceOptions().gmin,
       staticContributions,
       dynamicContributions,
       in);

  
    // We now have the F and Q vector stuff, populate the dependencies:
  
    dfdp[in.admsNodeID_c+inst*(12+3)] += staticContributions[in.admsNodeID_c].dx(0);
    dqdp[in.admsNodeID_c+inst*(12+3)] += dynamicContributions[in.admsNodeID_c].dx(0);
    Findices[in.admsNodeID_c+inst*(12+3)] = in.li_c;
    Qindices[in.admsNodeID_c+inst*(12+3)] = in.li_c;
    dfdp[in.admsNodeID_b+inst*(12+3)] += staticContributions[in.admsNodeID_b].dx(0);
    dqdp[in.admsNodeID_b+inst*(12+3)] += dynamicContributions[in.admsNodeID_b].dx(0);
    Findices[in.admsNodeID_b+inst*(12+3)] = in.li_b;
    Qindices[in.admsNodeID_b+inst*(12+3)] = in.li_b;
    dfdp[in.admsNodeID_e+inst*(12+3)] += staticContributions[in.admsNodeID_e].dx(0);
    dqdp[in.admsNodeID_e+inst*(12+3)] += dynamicContributions[in.admsNodeID_e].dx(0);
    Findices[in.admsNodeID_e+inst*(12+3)] = in.li_e;
    Qindices[in.admsNodeID_e+inst*(12+3)] = in.li_e;
    dfdp[in.admsNodeID_t+inst*(12+3)] += staticContributions[in.admsNodeID_t].dx(0);
    dqdp[in.admsNodeID_t+inst*(12+3)] += dynamicContributions[in.admsNodeID_t].dx(0);
    Findices[in.admsNodeID_t+inst*(12+3)] = in.li_t;
    Qindices[in.admsNodeID_t+inst*(12+3)] = in.li_t;
    dfdp[in.admsNodeID_ei+inst*(12+3)] += staticContributions[in.admsNodeID_ei].dx(0);
    dqdp[in.admsNodeID_ei+inst*(12+3)] += dynamicContributions[in.admsNodeID_ei].dx(0);
    Findices[in.admsNodeID_ei+inst*(12+3)] = in.li_ei;
    Qindices[in.admsNodeID_ei+inst*(12+3)] = in.li_ei;
    dfdp[in.admsNodeID_bi+inst*(12+3)] += staticContributions[in.admsNodeID_bi].dx(0);
    dqdp[in.admsNodeID_bi+inst*(12+3)] += dynamicContributions[in.admsNodeID_bi].dx(0);
    Findices[in.admsNodeID_bi+inst*(12+3)] = in.li_bi;
    Qindices[in.admsNodeID_bi+inst*(12+3)] = in.li_bi;
    dfdp[in.admsNodeID_bii+inst*(12+3)] += staticContributions[in.admsNodeID_bii].dx(0);
    dqdp[in.admsNodeID_bii+inst*(12+3)] += dynamicContributions[in.admsNodeID_bii].dx(0);
    Findices[in.admsNodeID_bii+inst*(12+3)] = in.li_bii;
    Qindices[in.admsNodeID_bii+inst*(12+3)] = in.li_bii;
    dfdp[in.admsNodeID_ci+inst*(12+3)] += staticContributions[in.admsNodeID_ci].dx(0);
    dqdp[in.admsNodeID_ci+inst*(12+3)] += dynamicContributions[in.admsNodeID_ci].dx(0);
    Findices[in.admsNodeID_ci+inst*(12+3)] = in.li_ci;
    Qindices[in.admsNodeID_ci+inst*(12+3)] = in.li_ci;
    dfdp[in.admsNodeID_ti+inst*(12+3)] += staticContributions[in.admsNodeID_ti].dx(0);
    dqdp[in.admsNodeID_ti+inst*(12+3)] += dynamicContributions[in.admsNodeID_ti].dx(0);
    Findices[in.admsNodeID_ti+inst*(12+3)] = in.li_ti;
    Qindices[in.admsNodeID_ti+inst*(12+3)] = in.li_ti;
    dfdp[in.admsNodeID_ex+inst*(12+3)] += staticContributions[in.admsNodeID_ex].dx(0);
    dqdp[in.admsNodeID_ex+inst*(12+3)] += dynamicContributions[in.admsNodeID_ex].dx(0);
    Findices[in.admsNodeID_ex+inst*(12+3)] = in.li_ex;
    Qindices[in.admsNodeID_ex+inst*(12+3)] = in.li_ex;
    dfdp[in.admsNodeID_exx+inst*(12+3)] += staticContributions[in.admsNodeID_exx].dx(0);
    dqdp[in.admsNodeID_exx+inst*(12+3)] += dynamicContributions[in.admsNodeID_exx].dx(0);
    Findices[in.admsNodeID_exx+inst*(12+3)] = in.li_exx;
    Qindices[in.admsNodeID_exx+inst*(12+3)] = in.li_exx;
    dfdp[in.admsNodeID_cx+inst*(12+3)] += staticContributions[in.admsNodeID_cx].dx(0);
    dqdp[in.admsNodeID_cx+inst*(12+3)] += dynamicContributions[in.admsNodeID_cx].dx(0);
    Findices[in.admsNodeID_cx+inst*(12+3)] = in.li_cx;
    Qindices[in.admsNodeID_cx+inst*(12+3)] = in.li_cx;
    dfdp[in.admsBRA_ID_b_bi+inst*(12+3)] += staticContributions[in.admsBRA_ID_b_bi].dx(0);
    dqdp[in.admsBRA_ID_b_bi+inst*(12+3)] += dynamicContributions[in.admsBRA_ID_b_bi].dx(0);
    Findices[in.admsBRA_ID_b_bi+inst*(12+3)] = in.li_BRA_b_bi;
    Qindices[in.admsBRA_ID_b_bi+inst*(12+3)] = in.li_BRA_b_bi;
    dfdp[in.admsBRA_ID_e_ei+inst*(12+3)] += staticContributions[in.admsBRA_ID_e_ei].dx(0);
    dqdp[in.admsBRA_ID_e_ei+inst*(12+3)] += dynamicContributions[in.admsBRA_ID_e_ei].dx(0);
    Findices[in.admsBRA_ID_e_ei+inst*(12+3)] = in.li_BRA_e_ei;
    Qindices[in.admsBRA_ID_e_ei+inst*(12+3)] = in.li_BRA_e_ei;
    dfdp[in.admsBRA_ID_c_ci+inst*(12+3)] += staticContributions[in.admsBRA_ID_c_ci].dx(0);
    dqdp[in.admsBRA_ID_c_ci+inst*(12+3)] += dynamicContributions[in.admsBRA_ID_c_ci].dx(0);
    Findices[in.admsBRA_ID_c_ci+inst*(12+3)] = in.li_BRA_c_ci;
    Qindices[in.admsBRA_ID_c_ci+inst*(12+3)] = in.li_BRA_c_ci;
  }

}

#endif // Xyce_ADMS_SENSITIVITIES

} // namespace ADMSHBT_X
} // namespace Device
} // namespace Xyce
