
//-------------------------------------------------------------------------
//   Copyright 2002-2018 National Technology & Engineering Solutions of
//   Sandia, LLC (NTESS).  Under the terms of Contract DE-NA0003525 with
//   NTESS, the U.S. Government retains certain rights in this software.
//
//   This file is part of the Xyce(TM) Parallel Electrical Simulator.
//
//   Xyce(TM) is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   Xyce(TM) is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with Xyce(TM).
//   If not, see <http://www.gnu.org/licenses/>.
//-------------------------------------------------------------------------


//-------------------------------------------------------------------------
//
// Purpose        :
//
// Special Notes  : Generated from verilog file hicumL0V1p32.va with ADMS
//                  interface for Xyce 6.9.0
//                  DO NOT EDIT THIS FILE DIRECTLY!  It may be overwritten!
//
// Creator        : admsXml-2.3.6
//
// Creation Date  : Wed, 28 Mar 2018 12:13:39
//
//-------------------------------------------------------------------------
// Shut up clang's warnings about extraneous parentheses
#ifdef __clang__
#  pragma clang diagnostic ignored "-Wparentheses-equality"
#endif

#include <Xyce_config.h>
#include <N_DEV_ADMShic0_full.h>


#include <N_DEV_Const.h>
#include <N_DEV_DeviceOptions.h>
#include <N_DEV_DeviceMaster.h>
#include <N_DEV_ExternData.h>
#include <N_DEV_SolverState.h>
#include <N_DEV_Message.h>

#include <N_LAS_Matrix.h>
#include <N_LAS_Vector.h>

#include <N_ANP_NoiseData.h>

#include <N_UTL_FeatureTest.h>
#if defined(HAVE_UNORDERED_MAP)
#include <unordered_map>
using std::unordered_map;
#elif defined(HAVE_TR1_UNORDERED_MAP)
#include <tr1/unordered_map>
using std::tr1::unordered_map;
#else
#error neither unordered_map or tr1/unordered_map found
#endif

namespace Xyce {
namespace Device {
namespace ADMShic0_full {


//This is necessary because the IntPair usage can trip undefined references
const int Instance::admsNodeID_c;
const int Instance::admsNodeID_b;
const int Instance::admsNodeID_e;
const int Instance::admsNodeID_s;
const int Instance::admsNodeID_tnode;
const int Instance::admsNodeID_ci;
const int Instance::admsNodeID_bi;
const int Instance::admsNodeID_ei;
const int Instance::admsNodeID_xf1;
const int Instance::admsNodeID_xf2;
const int Instance::admsNodeID_xf;
const int Instance::admsNodeID_GND;
// Additional IDs for branch equations


void
Traits::loadInstanceParameters(ParametricData<ADMShic0_full::Instance> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have an instance parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSINSTTEMP", 0.0, &ADMShic0_full::Instance::admsInstTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device instance temperature");
  p.addPar("DT", static_cast<double>(0.0), &ADMShic0_full::Instance::dt)
    .setDescription("Temperature change for particular transistor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;


}

void Traits::loadModelParameters(ParametricData<ADMShic0_full::Model> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have a model parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSMODTEMP", 0.0, &ADMShic0_full::Model::admsModTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device model temperature");
  p.addPar("IS", static_cast<double>(1.0e-16), &ADMShic0_full::Model::is)
    .setDescription("(Modified) saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IT_MOD", static_cast<int>(0), &ADMShic0_full::Model::it_mod)
    .setDescription("Flag for using third order solution for transfer current");
  p.addPar("MCF", static_cast<double>(1.00), &ADMShic0_full::Model::mcf)
    .setDescription("Non-ideality coefficient of forward collector current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MCR", static_cast<double>(1.00), &ADMShic0_full::Model::mcr)
    .setDescription("Non-ideality coefficient of reverse collector current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VEF", static_cast<double>(1.0e6), &ADMShic0_full::Model::vef)
    .setDescription("forward Early voltage (normalization volt.)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VER", static_cast<double>(1.0e6), &ADMShic0_full::Model::ver)
    .setDescription("reverse Early voltage (normalization volt.)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AVER", static_cast<double>(0.0), &ADMShic0_full::Model::aver)
    .setDescription("bias dependence for reverse Early voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IQF", static_cast<double>(1.0e6), &ADMShic0_full::Model::iqf)
    .setDescription("forward d.c. high-injection toll-off current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FIQF", static_cast<double>(0), &ADMShic0_full::Model::fiqf)
    .setDescription("flag for turning on base related critical current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IQR", static_cast<double>(1.0e6), &ADMShic0_full::Model::iqr)
    .setDescription("inverse d.c. high-injection roll-off current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IQFH", static_cast<double>(1.0e6), &ADMShic0_full::Model::iqfh)
    .setDescription("high-injection correction current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TFH", static_cast<double>(0.0), &ADMShic0_full::Model::tfh)
    .setDescription("high-injection correction factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AHQ", static_cast<double>(0), &ADMShic0_full::Model::ahq)
    .setDescription("Smoothing factor for the d.c. injection width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBES", static_cast<double>(1e-18), &ADMShic0_full::Model::ibes)
    .setDescription("BE saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MBE", static_cast<double>(1.0), &ADMShic0_full::Model::mbe)
    .setDescription("BE non-ideality factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IRES", static_cast<double>(0.0), &ADMShic0_full::Model::ires)
    .setDescription("BE recombination saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MRE", static_cast<double>(2.0), &ADMShic0_full::Model::mre)
    .setDescription("BE recombination non-ideality factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBCS", static_cast<double>(0.0), &ADMShic0_full::Model::ibcs)
    .setDescription("BC saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MBC", static_cast<double>(1.0), &ADMShic0_full::Model::mbc)
    .setDescription("BC non-ideality factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJE0", static_cast<double>(1.0e-20), &ADMShic0_full::Model::cje0)
    .setDescription("Zero-bias BE depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VDE", static_cast<double>(0.9), &ADMShic0_full::Model::vde)
    .setDescription("BE built-in voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZE", static_cast<double>(0.5), &ADMShic0_full::Model::ze)
    .setDescription("BE exponent factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AJE", static_cast<double>(2.5), &ADMShic0_full::Model::aje)
    .setDescription("Ratio of maximum to zero-bias value")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VDEDC", static_cast<double>(0.9), &ADMShic0_full::Model::vdedc)
    .setDescription("BE charge built-in voltage for d.c. transfer current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZEDC", static_cast<double>(0.5), &ADMShic0_full::Model::zedc)
    .setDescription("charge BE exponent factor for d.c. transfer current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AJEDC", static_cast<double>(2.5), &ADMShic0_full::Model::ajedc)
    .setDescription("BE capacitance ratio Ratio maximum to zero-bias value for d.c. transfer current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("T0", static_cast<double>(0.0), &ADMShic0_full::Model::t0)
    .setDescription("low current transit time at Vbici=0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DT0H", static_cast<double>(0.0), &ADMShic0_full::Model::dt0h)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TBVL", static_cast<double>(0.0), &ADMShic0_full::Model::tbvl)
    .setDescription("SCR width modulation contribution")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TEF0", static_cast<double>(0.0), &ADMShic0_full::Model::tef0)
    .setDescription("Storage time in neutral emitter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("GTE", static_cast<double>(1.0), &ADMShic0_full::Model::gte)
    .setDescription("Exponent factor for emmiter transit time")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("THCS", static_cast<double>(0.0), &ADMShic0_full::Model::thcs)
    .setDescription("Saturation time at high current densities")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AHC", static_cast<double>(0.1), &ADMShic0_full::Model::ahc)
    .setDescription("Smoothing facor for current dependence")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TR", static_cast<double>(0.0), &ADMShic0_full::Model::tr)
    .setDescription("Storage time at inverse operation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RCI0", static_cast<double>(150), &ADMShic0_full::Model::rci0)
    .setDescription("Low-field collector resistance under emitter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VLIM", static_cast<double>(0.5), &ADMShic0_full::Model::vlim)
    .setDescription("Voltage dividing ohmic and satur.region")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VPT", static_cast<double>(100), &ADMShic0_full::Model::vpt)
    .setDescription("Punch-through voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VCES", static_cast<double>(0.1), &ADMShic0_full::Model::vces)
    .setDescription("Saturation voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJCI0", static_cast<double>(1.0e-20), &ADMShic0_full::Model::cjci0)
    .setDescription("Total zero-bias BC depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VDCI", static_cast<double>(0.7), &ADMShic0_full::Model::vdci)
    .setDescription("BC built-in voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZCI", static_cast<double>(0.333), &ADMShic0_full::Model::zci)
    .setDescription("BC exponent factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VPTCI", static_cast<double>(100), &ADMShic0_full::Model::vptci)
    .setDescription("Punch-through voltage of BC junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJCX0", static_cast<double>(1.0e-20), &ADMShic0_full::Model::cjcx0)
    .setDescription("Zero-bias external BC depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VDCX", static_cast<double>(0.7), &ADMShic0_full::Model::vdcx)
    .setDescription("External BC built-in voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZCX", static_cast<double>(0.333), &ADMShic0_full::Model::zcx)
    .setDescription("External BC exponent factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VPTCX", static_cast<double>(100), &ADMShic0_full::Model::vptcx)
    .setDescription("Punch-through voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FBC", static_cast<double>(1.0), &ADMShic0_full::Model::fbc)
    .setDescription("Split factor = Cjci0/Cjc0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBI0", static_cast<double>(0.0), &ADMShic0_full::Model::rbi0)
    .setDescription("Internal base resistance at zero-bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VR0E", static_cast<double>(2.5), &ADMShic0_full::Model::vr0e)
    .setDescription("forward Early voltage (normalization volt.)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VR0C", static_cast<double>(1.0e6), &ADMShic0_full::Model::vr0c)
    .setDescription("forward Early voltage (normalization volt.)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FGEO", static_cast<double>(0.656), &ADMShic0_full::Model::fgeo)
    .setDescription("Geometry factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBX", static_cast<double>(0.0), &ADMShic0_full::Model::rbx)
    .setDescription("External base series resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RCX", static_cast<double>(0.0), &ADMShic0_full::Model::rcx)
    .setDescription("Emitter series resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RE", static_cast<double>(0.0), &ADMShic0_full::Model::re)
    .setDescription("External collector series resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ITSS", static_cast<double>(0.0), &ADMShic0_full::Model::itss)
    .setDescription("Substrate transistor transfer saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MSF", static_cast<double>(1.0), &ADMShic0_full::Model::msf)
    .setDescription("Substrate transistor transfer current non-ideality factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ISCS", static_cast<double>(0.0), &ADMShic0_full::Model::iscs)
    .setDescription("SC saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MSC", static_cast<double>(1.0), &ADMShic0_full::Model::msc)
    .setDescription("SC non-ideality factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJS0", static_cast<double>(1.0e-20), &ADMShic0_full::Model::cjs0)
    .setDescription("Zero-bias SC depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VDS", static_cast<double>(0.3), &ADMShic0_full::Model::vds)
    .setDescription("SC built-in voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZS", static_cast<double>(0.3), &ADMShic0_full::Model::zs)
    .setDescription("External SC exponent factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VPTS", static_cast<double>(100), &ADMShic0_full::Model::vpts)
    .setDescription("SC punch-through voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBCPAR", static_cast<double>(0.0), &ADMShic0_full::Model::cbcpar)
    .setDescription("Collector-base isolation (overlap) capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBEPAR", static_cast<double>(0.0), &ADMShic0_full::Model::cbepar)
    .setDescription("Emitter-base oxide capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EAVL", static_cast<double>(0.0), &ADMShic0_full::Model::eavl)
    .setDescription("Exponent factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KAVL", static_cast<double>(0.0), &ADMShic0_full::Model::kavl)
    .setDescription("Prefactor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KF", static_cast<double>(0.0), &ADMShic0_full::Model::kf)
    .setDescription("flicker noise coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AF", static_cast<double>(2.0), &ADMShic0_full::Model::af)
    .setDescription("flicker noise exponent factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALQF", static_cast<double>(0.167), &ADMShic0_full::Model::alqf)
    .setDescription("Factor for additional delay time of minority charge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALIT", static_cast<double>(0.333), &ADMShic0_full::Model::alit)
    .setDescription("Factor for additional delay time of transfer current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FLNQS", static_cast<int>(0), &ADMShic0_full::Model::flnqs)
    .setDescription("Flag for turning on and off of vertical NQS effect");
  p.addPar("VGB", static_cast<double>(1.2), &ADMShic0_full::Model::vgb)
    .setDescription("Bandgap-voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VGE", static_cast<double>(1.17), &ADMShic0_full::Model::vge)
    .setDescription("Effective emitter bandgap-voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VGC", static_cast<double>(1.17), &ADMShic0_full::Model::vgc)
    .setDescription("Effective collector bandgap-voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VGS", static_cast<double>(1.17), &ADMShic0_full::Model::vgs)
    .setDescription("Effective substrate bandgap-voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("F1VG", static_cast<double>((-1.02377e-4)), &ADMShic0_full::Model::f1vg)
    .setDescription("Coefficient K1 in T-dependent bandgap equation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("F2VG", static_cast<double>(4.3215e-4), &ADMShic0_full::Model::f2vg)
    .setDescription("Coefficient K2 in T-dependent bandgap equation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALT0", static_cast<double>(0.0), &ADMShic0_full::Model::alt0)
    .setDescription("Frist-order TC of tf0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KT0", static_cast<double>(0.0), &ADMShic0_full::Model::kt0)
    .setDescription("Second-order TC of tf0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZETACT", static_cast<double>(3.0), &ADMShic0_full::Model::zetact)
    .setDescription("Exponent coefficient in transfer current temperature dependence")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZETABET", static_cast<double>(3.5), &ADMShic0_full::Model::zetabet)
    .setDescription("Exponent coefficient in BE junction current temperature dependence")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZETACI", static_cast<double>(0.0), &ADMShic0_full::Model::zetaci)
    .setDescription("TC of epi-collector diffusivity")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALVS", static_cast<double>(0.0), &ADMShic0_full::Model::alvs)
    .setDescription("Relative TC of satur.drift velocity")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALCES", static_cast<double>(0.0), &ADMShic0_full::Model::alces)
    .setDescription("Relative TC of vces")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZETARBI", static_cast<double>(0.0), &ADMShic0_full::Model::zetarbi)
    .setDescription("TC of internal base resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZETARBX", static_cast<double>(0.0), &ADMShic0_full::Model::zetarbx)
    .setDescription("TC of external base resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZETARCX", static_cast<double>(0.0), &ADMShic0_full::Model::zetarcx)
    .setDescription("TC of external collector resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZETARE", static_cast<double>(0.0), &ADMShic0_full::Model::zetare)
    .setDescription("TC of emitter resistances")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZETAIQF", static_cast<double>(0.0), &ADMShic0_full::Model::zetaiqf)
    .setDescription("TC of iqf")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALKAV", static_cast<double>(0.0), &ADMShic0_full::Model::alkav)
    .setDescription("TC of avalanche prefactor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALEAV", static_cast<double>(0.0), &ADMShic0_full::Model::aleav)
    .setDescription("TC of avalanche exponential factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZETARTH", static_cast<double>(0.0), &ADMShic0_full::Model::zetarth)
    .setDescription("Exponent factor for temperature dependent thermal resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TEF_TEMP", static_cast<int>(1), &ADMShic0_full::Model::tef_temp)
    .setDescription("Flag for turning temperature dependence of tef0 on and off");
  p.addPar("ZETAVER", static_cast<double>((-1.0)), &ADMShic0_full::Model::zetaver)
    .setDescription("TC of Reverse Early voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZETAVGBE", static_cast<double>(1.0), &ADMShic0_full::Model::zetavgbe)
    .setDescription("TC of AVER")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DVGBE", static_cast<double>(0.0), &ADMShic0_full::Model::dvgbe)
    .setDescription("Bandgap difference between base and BE-junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALIQFH", static_cast<double>(0), &ADMShic0_full::Model::aliqfh)
    .setDescription("Frist-order TC of iqfh")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KIQFH", static_cast<double>(0), &ADMShic0_full::Model::kiqfh)
    .setDescription("Second-order TC of iqfh")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FLSH", static_cast<int>(0), &ADMShic0_full::Model::flsh)
    .setDescription("Flag for self-heating calculation");
  p.addPar("RTH", static_cast<double>(0.0), &ADMShic0_full::Model::rth)
    .setDescription("Thermal resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTH", static_cast<double>(0.0), &ADMShic0_full::Model::cth)
    .setDescription("Thermal capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TYPE", static_cast<int>(1), &ADMShic0_full::Model::type)
    .setDescription("For transistor type NPN(+1) or PNP (-1)");
  p.addPar("TNOM", static_cast<double>(27), &ADMShic0_full::Model::tnom)
    .setDescription("Temperature for which parameters are valid")
    .setAutoConvertTemperature(false)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;

}

//-----------------------------------------------------------------------------
// Function      : Instance::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::processParams()
{
  // set any non-constant parameter defaults

  // copy any model variables that have associated instance variables, but
  // are only given in the model card:



  // Set any parameters that were not given and whose defaults depend on other
  // parameters:


  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:


  // this seems a little stupid, but verilog models that use $temperature
  // don't also use a defined parameter "Temp", and count on $temperature
  // to be the one the simulator wants:

  updateTemperature(admsInstTemp);

  // and of course, this routine is where we should put the initial_instance
  // stuff


  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::Instance
// Purpose       : "instance block" constructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------

Instance::Instance(
   const Configuration & configuration,
   const InstanceBlock & instance_block,
   Model &               model,
   const FactoryBlock &  factory_block)
  : DeviceInstance(instance_block, configuration.getInstanceParameters(), factory_block),
    model_(model),
    dt(0.0),
    qjci(0.0),
    qjei(0.0),
    it(0.0),
    ijbc(0.0),
    iavl(0.0),
    ijsc(0.0),
    Ibici(0.0),
    ijbe(0.0),
    li_c(-1),
    li_b(-1),
    li_e(-1),
    li_s(-1),
    li_tnode(-1),
    li_ci(-1),
    li_bi(-1),
    li_ei(-1),
    li_xf1(-1),
    li_xf2(-1),
    li_xf(-1),
    li_branch_ic(-1),
    li_branch_ib(-1),
    li_branch_ie(-1),
    li_branch_is(-1),
    li_branch_itnode(-1),
    f_bi_Equ_bi_Node_Ptr(0),
    f_bi_Equ_ei_Node_Ptr(0),
    f_ei_Equ_bi_Node_Ptr(0),
    f_ei_Equ_ei_Node_Ptr(0),
    f_bi_Equ_ci_Node_Ptr(0),
    f_ci_Equ_bi_Node_Ptr(0),
    f_ci_Equ_ci_Node_Ptr(0),
    f_ci_Equ_ei_Node_Ptr(0),
    f_ei_Equ_ci_Node_Ptr(0),
    f_b_Equ_s_Node_Ptr(0),
    f_b_Equ_ci_Node_Ptr(0),
    f_s_Equ_s_Node_Ptr(0),
    f_s_Equ_ci_Node_Ptr(0),
    f_b_Equ_b_Node_Ptr(0),
    f_s_Equ_b_Node_Ptr(0),
    f_b_Equ_tnode_Node_Ptr(0),
    f_s_Equ_tnode_Node_Ptr(0),
    f_s_Equ_bi_Node_Ptr(0),
    f_s_Equ_ei_Node_Ptr(0),
    f_ci_Equ_s_Node_Ptr(0),
    f_ci_Equ_tnode_Node_Ptr(0),
    f_ci_Equ_b_Node_Ptr(0),
    f_b_Equ_bi_Node_Ptr(0),
    f_b_Equ_e_Node_Ptr(0),
    f_e_Equ_b_Node_Ptr(0),
    f_e_Equ_e_Node_Ptr(0),
    f_ei_Equ_tnode_Node_Ptr(0),
    f_e_Equ_tnode_Node_Ptr(0),
    f_ei_Equ_e_Node_Ptr(0),
    f_e_Equ_ei_Node_Ptr(0),
    f_c_Equ_tnode_Node_Ptr(0),
    f_ci_Equ_c_Node_Ptr(0),
    f_c_Equ_ci_Node_Ptr(0),
    f_c_Equ_c_Node_Ptr(0),
    f_bi_Equ_b_Node_Ptr(0),
    f_b_Equ_ei_Node_Ptr(0),
    f_bi_Equ_tnode_Node_Ptr(0),
    f_bi_Equ_xf_Node_Ptr(0),
    f_ei_Equ_xf_Node_Ptr(0),
    f_ei_Equ_b_Node_Ptr(0),
    f_ci_Equ_xf2_Node_Ptr(0),
    f_ei_Equ_xf2_Node_Ptr(0),
    f_tnode_Equ_tnode_Node_Ptr(0),
    f_tnode_Equ_ci_Node_Ptr(0),
    f_tnode_Equ_ei_Node_Ptr(0),
    f_tnode_Equ_b_Node_Ptr(0),
    f_tnode_Equ_bi_Node_Ptr(0),
    f_tnode_Equ_s_Node_Ptr(0),
    f_tnode_Equ_e_Node_Ptr(0),
    f_tnode_Equ_c_Node_Ptr(0),
    f_xf1_Equ_ci_Node_Ptr(0),
    f_xf1_Equ_ei_Node_Ptr(0),
    f_xf1_Equ_b_Node_Ptr(0),
    f_xf1_Equ_bi_Node_Ptr(0),
    f_xf1_Equ_tnode_Node_Ptr(0),
    f_xf1_Equ_xf2_Node_Ptr(0),
    f_xf1_Equ_xf1_Node_Ptr(0),
    f_xf2_Equ_bi_Node_Ptr(0),
    f_xf2_Equ_ei_Node_Ptr(0),
    f_xf2_Equ_ci_Node_Ptr(0),
    f_xf2_Equ_b_Node_Ptr(0),
    f_xf2_Equ_tnode_Node_Ptr(0),
    f_xf2_Equ_xf1_Node_Ptr(0),
    f_xf2_Equ_xf2_Node_Ptr(0),
    f_xf_Equ_ci_Node_Ptr(0),
    f_xf_Equ_ei_Node_Ptr(0),
    f_xf_Equ_bi_Node_Ptr(0),
    f_xf_Equ_b_Node_Ptr(0),
    f_xf_Equ_tnode_Node_Ptr(0),
    f_xf_Equ_xf_Node_Ptr(0),
    q_bi_Equ_bi_Node_Ptr(0),
    q_bi_Equ_ei_Node_Ptr(0),
    q_ei_Equ_bi_Node_Ptr(0),
    q_ei_Equ_ei_Node_Ptr(0),
    q_bi_Equ_ci_Node_Ptr(0),
    q_ci_Equ_bi_Node_Ptr(0),
    q_ci_Equ_ci_Node_Ptr(0),
    q_ci_Equ_ei_Node_Ptr(0),
    q_ei_Equ_ci_Node_Ptr(0),
    q_b_Equ_s_Node_Ptr(0),
    q_b_Equ_ci_Node_Ptr(0),
    q_s_Equ_s_Node_Ptr(0),
    q_s_Equ_ci_Node_Ptr(0),
    q_b_Equ_b_Node_Ptr(0),
    q_s_Equ_b_Node_Ptr(0),
    q_b_Equ_tnode_Node_Ptr(0),
    q_s_Equ_tnode_Node_Ptr(0),
    q_s_Equ_bi_Node_Ptr(0),
    q_s_Equ_ei_Node_Ptr(0),
    q_ci_Equ_s_Node_Ptr(0),
    q_ci_Equ_tnode_Node_Ptr(0),
    q_ci_Equ_b_Node_Ptr(0),
    q_b_Equ_bi_Node_Ptr(0),
    q_b_Equ_e_Node_Ptr(0),
    q_e_Equ_b_Node_Ptr(0),
    q_e_Equ_e_Node_Ptr(0),
    q_ei_Equ_tnode_Node_Ptr(0),
    q_e_Equ_tnode_Node_Ptr(0),
    q_ei_Equ_e_Node_Ptr(0),
    q_e_Equ_ei_Node_Ptr(0),
    q_c_Equ_tnode_Node_Ptr(0),
    q_ci_Equ_c_Node_Ptr(0),
    q_c_Equ_ci_Node_Ptr(0),
    q_c_Equ_c_Node_Ptr(0),
    q_bi_Equ_b_Node_Ptr(0),
    q_b_Equ_ei_Node_Ptr(0),
    q_bi_Equ_tnode_Node_Ptr(0),
    q_bi_Equ_xf_Node_Ptr(0),
    q_ei_Equ_xf_Node_Ptr(0),
    q_ei_Equ_b_Node_Ptr(0),
    q_ci_Equ_xf2_Node_Ptr(0),
    q_ei_Equ_xf2_Node_Ptr(0),
    q_tnode_Equ_tnode_Node_Ptr(0),
    q_tnode_Equ_ci_Node_Ptr(0),
    q_tnode_Equ_ei_Node_Ptr(0),
    q_tnode_Equ_b_Node_Ptr(0),
    q_tnode_Equ_bi_Node_Ptr(0),
    q_tnode_Equ_s_Node_Ptr(0),
    q_tnode_Equ_e_Node_Ptr(0),
    q_tnode_Equ_c_Node_Ptr(0),
    q_xf1_Equ_ci_Node_Ptr(0),
    q_xf1_Equ_ei_Node_Ptr(0),
    q_xf1_Equ_b_Node_Ptr(0),
    q_xf1_Equ_bi_Node_Ptr(0),
    q_xf1_Equ_tnode_Node_Ptr(0),
    q_xf1_Equ_xf2_Node_Ptr(0),
    q_xf1_Equ_xf1_Node_Ptr(0),
    q_xf2_Equ_bi_Node_Ptr(0),
    q_xf2_Equ_ei_Node_Ptr(0),
    q_xf2_Equ_ci_Node_Ptr(0),
    q_xf2_Equ_b_Node_Ptr(0),
    q_xf2_Equ_tnode_Node_Ptr(0),
    q_xf2_Equ_xf1_Node_Ptr(0),
    q_xf2_Equ_xf2_Node_Ptr(0),
    q_xf_Equ_ci_Node_Ptr(0),
    q_xf_Equ_ei_Node_Ptr(0),
    q_xf_Equ_bi_Node_Ptr(0),
    q_xf_Equ_b_Node_Ptr(0),
    q_xf_Equ_tnode_Node_Ptr(0),
    q_xf_Equ_xf_Node_Ptr(0),
    A_bi_Equ_bi_NodeOffset(-1),
    A_bi_Equ_ei_NodeOffset(-1),
    A_ei_Equ_bi_NodeOffset(-1),
    A_ei_Equ_ei_NodeOffset(-1),
    A_bi_Equ_ci_NodeOffset(-1),
    A_ci_Equ_bi_NodeOffset(-1),
    A_ci_Equ_ci_NodeOffset(-1),
    A_ci_Equ_ei_NodeOffset(-1),
    A_ei_Equ_ci_NodeOffset(-1),
    A_b_Equ_s_NodeOffset(-1),
    A_b_Equ_ci_NodeOffset(-1),
    A_s_Equ_s_NodeOffset(-1),
    A_s_Equ_ci_NodeOffset(-1),
    A_b_Equ_b_NodeOffset(-1),
    A_s_Equ_b_NodeOffset(-1),
    A_b_Equ_tnode_NodeOffset(-1),
    A_s_Equ_tnode_NodeOffset(-1),
    A_s_Equ_bi_NodeOffset(-1),
    A_s_Equ_ei_NodeOffset(-1),
    A_ci_Equ_s_NodeOffset(-1),
    A_ci_Equ_tnode_NodeOffset(-1),
    A_ci_Equ_b_NodeOffset(-1),
    A_b_Equ_bi_NodeOffset(-1),
    A_b_Equ_e_NodeOffset(-1),
    A_e_Equ_b_NodeOffset(-1),
    A_e_Equ_e_NodeOffset(-1),
    A_ei_Equ_tnode_NodeOffset(-1),
    A_e_Equ_tnode_NodeOffset(-1),
    A_ei_Equ_e_NodeOffset(-1),
    A_e_Equ_ei_NodeOffset(-1),
    A_c_Equ_tnode_NodeOffset(-1),
    A_ci_Equ_c_NodeOffset(-1),
    A_c_Equ_ci_NodeOffset(-1),
    A_c_Equ_c_NodeOffset(-1),
    A_bi_Equ_b_NodeOffset(-1),
    A_b_Equ_ei_NodeOffset(-1),
    A_bi_Equ_tnode_NodeOffset(-1),
    A_bi_Equ_xf_NodeOffset(-1),
    A_ei_Equ_xf_NodeOffset(-1),
    A_ei_Equ_b_NodeOffset(-1),
    A_ci_Equ_xf2_NodeOffset(-1),
    A_ei_Equ_xf2_NodeOffset(-1),
    A_tnode_Equ_tnode_NodeOffset(-1),
    A_tnode_Equ_ci_NodeOffset(-1),
    A_tnode_Equ_ei_NodeOffset(-1),
    A_tnode_Equ_b_NodeOffset(-1),
    A_tnode_Equ_bi_NodeOffset(-1),
    A_tnode_Equ_s_NodeOffset(-1),
    A_tnode_Equ_e_NodeOffset(-1),
    A_tnode_Equ_c_NodeOffset(-1),
    A_xf1_Equ_ci_NodeOffset(-1),
    A_xf1_Equ_ei_NodeOffset(-1),
    A_xf1_Equ_b_NodeOffset(-1),
    A_xf1_Equ_bi_NodeOffset(-1),
    A_xf1_Equ_tnode_NodeOffset(-1),
    A_xf1_Equ_xf2_NodeOffset(-1),
    A_xf1_Equ_xf1_NodeOffset(-1),
    A_xf2_Equ_bi_NodeOffset(-1),
    A_xf2_Equ_ei_NodeOffset(-1),
    A_xf2_Equ_ci_NodeOffset(-1),
    A_xf2_Equ_b_NodeOffset(-1),
    A_xf2_Equ_tnode_NodeOffset(-1),
    A_xf2_Equ_xf1_NodeOffset(-1),
    A_xf2_Equ_xf2_NodeOffset(-1),
    A_xf_Equ_ci_NodeOffset(-1),
    A_xf_Equ_ei_NodeOffset(-1),
    A_xf_Equ_bi_NodeOffset(-1),
    A_xf_Equ_b_NodeOffset(-1),
    A_xf_Equ_tnode_NodeOffset(-1),
    A_xf_Equ_xf_NodeOffset(-1),
    admsTemperature(getDeviceOptions().temp.getImmutableValue<double>())

{
  numIntVars = 6 + 0;
  numExtVars = 5;


  // Right now, we only have store for limited probes...
  setNumStoreVars(0);

  // Do not allocate "branch" (lead current) vectors by default
  setNumBranchDataVars(0);
  numBranchDataVarsIfAllocated = 5;

  leadCurrentF.resize(5);
  leadCurrentQ.resize(5);
  
  // Set up jacobian stamp:
  // Create a vector of the non-zero elements of the stamp
  PairVector jacobianElements;
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_tnode));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_tnode));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_tnode));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_tnode));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_tnode,admsNodeID_tnode));
  jacobianElements.push_back(IntPair(admsNodeID_tnode,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_tnode,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_tnode,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_tnode,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_tnode,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_tnode,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_tnode,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_tnode));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_xf2));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_tnode));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_xf));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_tnode));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_xf));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_xf2));
  jacobianElements.push_back(IntPair(admsNodeID_xf1,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_xf1,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_xf1,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_xf1,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_xf1,admsNodeID_tnode));
  jacobianElements.push_back(IntPair(admsNodeID_xf1,admsNodeID_xf2));
  jacobianElements.push_back(IntPair(admsNodeID_xf1,admsNodeID_xf1));
  jacobianElements.push_back(IntPair(admsNodeID_xf2,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_xf2,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_xf2,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_xf2,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_xf2,admsNodeID_tnode));
  jacobianElements.push_back(IntPair(admsNodeID_xf2,admsNodeID_xf1));
  jacobianElements.push_back(IntPair(admsNodeID_xf2,admsNodeID_xf2));
  jacobianElements.push_back(IntPair(admsNodeID_xf,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_xf,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_xf,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_xf,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_xf,admsNodeID_tnode));
  jacobianElements.push_back(IntPair(admsNodeID_xf,admsNodeID_xf));

  

  setDefaultParams();
  setParams(instance_block.params);

  // Real bogosity here...
  if (!given("XYCEADMSINSTTEMP"))
    admsInstTemp=getDeviceOptions().temp.getImmutableValue<double>();

  //calculate any parameters specified as expressions
  updateDependentParameters();

  // calculate dependent (i.e. computed params) and check for errors.
  processParams();

  PairVector collapsedNodes;
  collapseNodes();

  if (collapseNode_ci)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_ci,admsNodeID_c));
  }
  if (collapseNode_bi)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_bi,admsNodeID_b));
  }
  if (collapseNode_ei)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_ei,admsNodeID_e));
  }

  // Now generate the jacstamp from what we already have.
  // This jacstamp will have all the correct node mapping.  map will be the nodal mapping of original
  // node IDs to row/column ids in the reduced (non-sparse) representation of the jacobian.
  // (for devices that have no collapsibles, this will be static, so check that it hasn't already
  // been filled in)
  if (jacStamp.empty())
  {
    int originalSize = 11+0;
    computeJacStampAndMaps(jacobianElements,collapsedNodes,jacStamp,nodeMap,pairToJacStampMap,originalSize);
  }

}

//-----------------------------------------------------------------------------
// Function      : Instance::collapseNodes
// Purpose       : function to handle collapsing of nodes
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::collapseNodes()
{
  collapseNode_ci = false;
  collapseNode_bi = false;
  collapseNode_ei = false;
  if (!(((model_.re)>=0.001)))
  {

    collapseNode_ei = true;

  }

  if (!(((model_.rcx)>=0.001)))
  {

    collapseNode_ci = true;

  }

  if (!((((model_.rbi0)>=0.001)||((model_.rbx)>=0.001))))
  {

    collapseNode_bi = true;

  }


  if (collapseNode_ci)
  {
    numIntVars--;
  }
  if (collapseNode_bi)
  {
    numIntVars--;
  }
  if (collapseNode_ei)
  {
    numIntVars--;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::~Instance
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
Instance::~Instance()
{
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerLIDs
// Purpose       : function for registering, and setting up, local ID's.
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerLIDs( const LocalIdVector & intLIDVecRef,
                             const LocalIdVector & extLIDVecRef)
{
  AssertLIDs(intLIDVecRef.size() == numIntVars);
  AssertLIDs(extLIDVecRef.size() == numExtVars);

  LocalIdVector localLIDVec;
  
  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << std::endl << section_divider << std::endl
                 << "In ADMShic0_full::Instance::register LIDs\n\n"
                 << "name             = " << getName() << std::endl
                 << "number of internal variables: " << numIntVars << std::endl
                 << "number of external variables: " << numExtVars << std::endl;
  }

  // copy over the global ID lists into a local array.
  // The end result of this is an array of LIDs corresponding to all the
  // nodes we actually have, in the order that topology thinks of them
  intLIDVec = intLIDVecRef;
  extLIDVec = extLIDVecRef;
  localLIDVec.resize(numExtVars+numIntVars);
  for (int localNodeIndex=0;localNodeIndex<numExtVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=extLIDVec[localNodeIndex];
  }
  for (int localNodeIndex=numExtVars;localNodeIndex<numExtVars+numIntVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=intLIDVec[localNodeIndex-numExtVars];
  }
    
  // Now pull the LIDs for each of our nodes out of the local array.
  // Use the node mapping created by createJacStampAndMaps to handle
  // all the node collapse complications.
  li_c = localLIDVec[nodeMap[admsNodeID_c]];
  li_b = localLIDVec[nodeMap[admsNodeID_b]];
  li_e = localLIDVec[nodeMap[admsNodeID_e]];
  li_s = localLIDVec[nodeMap[admsNodeID_s]];
  li_tnode = localLIDVec[nodeMap[admsNodeID_tnode]];
  li_ci = localLIDVec[nodeMap[admsNodeID_ci]];
  li_bi = localLIDVec[nodeMap[admsNodeID_bi]];
  li_ei = localLIDVec[nodeMap[admsNodeID_ei]];
  li_xf1 = localLIDVec[nodeMap[admsNodeID_xf1]];
  li_xf2 = localLIDVec[nodeMap[admsNodeID_xf2]];
  li_xf = localLIDVec[nodeMap[admsNodeID_xf]];


  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << "\nSolution and RHS variables:\n";
    Xyce::dout() << "\nli_c = " << li_c << std::endl;
    Xyce::dout() << "\nli_b = " << li_b << std::endl;
    Xyce::dout() << "\nli_e = " << li_e << std::endl;
    Xyce::dout() << "\nli_s = " << li_s << std::endl;
    Xyce::dout() << "\nli_tnode = " << li_tnode << std::endl;
    Xyce::dout() << "\nli_ci = " << li_ci << std::endl;
    Xyce::dout() << "\nli_bi = " << li_bi << std::endl;
    Xyce::dout() << "\nli_ei = " << li_ei << std::endl;
    Xyce::dout() << "\nli_xf1 = " << li_xf1 << std::endl;
    Xyce::dout() << "\nli_xf2 = " << li_xf2 << std::endl;
    Xyce::dout() << "\nli_xf = " << li_xf << std::endl;

    Xyce::dout() << "\nEnd of ADMShic0_full::Instance::register LIDs\n";
    Xyce::dout() << section_divider << std::endl;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadNodeSymbols
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::loadNodeSymbols(Util::SymbolTable &symbol_table) const
{
  if (!collapseNode_ci)
  {
    addInternalNode(symbol_table, li_ci, getName(), "ci");
  }
  if (!collapseNode_bi)
  {
    addInternalNode(symbol_table, li_bi, getName(), "bi");
  }
  if (!collapseNode_ei)
  {
    addInternalNode(symbol_table, li_ei, getName(), "ei");
  }
  addInternalNode(symbol_table, li_xf1, getName(), "xf1");
  addInternalNode(symbol_table, li_xf2, getName(), "xf2");
  addInternalNode(symbol_table, li_xf, getName(), "xf");

  if (loadLeadCurrent)
  {
    addBranchDataNode( symbol_table, li_branch_ic, getName(), "BRANCH_DC");
    addBranchDataNode( symbol_table, li_branch_ib, getName(), "BRANCH_DB");
    addBranchDataNode( symbol_table, li_branch_ie, getName(), "BRANCH_DE");
    addBranchDataNode( symbol_table, li_branch_is, getName(), "BRANCH_D4");
    addBranchDataNode( symbol_table, li_branch_itnode, getName(), "BRANCH_D5");
  }
}
 
//-----------------------------------------------------------------------------
// Function      : Instance::registerStoreLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerStoreLIDs( const LocalIdVector & stoLIDVecRef)
{
  AssertLIDs(stoLIDVecRef.size() == getNumStoreVars());
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerBranchDataLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : Eric Keiter, SNL
// Creation Date : 12/09/11
//-----------------------------------------------------------------------------
void Instance::registerBranchDataLIDs(const std::vector<int> & branchLIDVecRef)
{
  AssertLIDs(branchLIDVecRef.size() == getNumBranchDataVars());

  if (loadLeadCurrent)
  {    
    int i = 0;
    li_branch_ic = branchLIDVecRef[i++];
    li_branch_ib = branchLIDVecRef[i++];
    li_branch_ie = branchLIDVecRef[i++];
    li_branch_is = branchLIDVecRef[i++];
    li_branch_itnode = branchLIDVecRef[i++];
  }
}
  
//-----------------------------------------------------------------------------
// Function      : Instance::jacobianStamp
// Purpose       :
// Special Notes : In initial version, we won't support mapping away nodes
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
const JacobianStamp & Instance::jacobianStamp() const
{
  return jacStamp;
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerJacLIDs
// Purpose       : Create Offset variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerJacLIDs( const JacobianStamp & jacLIDVec)
{
  DeviceInstance::registerJacLIDs(jacLIDVec);  IntPair jacLoc;
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_tnode)];
  A_c_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_ci)];
  A_c_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_c)];
  A_c_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_s)];
  A_b_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_ci)];
  A_b_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_b)];
  A_b_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_tnode)];
  A_b_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_bi)];
  A_b_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_e)];
  A_b_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_ei)];
  A_b_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_b)];
  A_e_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_e)];
  A_e_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_tnode)];
  A_e_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_ei)];
  A_e_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_s)];
  A_s_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_ci)];
  A_s_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_b)];
  A_s_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_tnode)];
  A_s_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_bi)];
  A_s_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_ei)];
  A_s_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_tnode,admsNodeID_tnode)];
  A_tnode_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_tnode,admsNodeID_ci)];
  A_tnode_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_tnode,admsNodeID_ei)];
  A_tnode_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_tnode,admsNodeID_b)];
  A_tnode_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_tnode,admsNodeID_bi)];
  A_tnode_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_tnode,admsNodeID_s)];
  A_tnode_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_tnode,admsNodeID_e)];
  A_tnode_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_tnode,admsNodeID_c)];
  A_tnode_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_bi)];
  A_ci_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_ci)];
  A_ci_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_ei)];
  A_ci_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_s)];
  A_ci_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_tnode)];
  A_ci_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_b)];
  A_ci_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_c)];
  A_ci_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_xf2)];
  A_ci_Equ_xf2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_bi)];
  A_bi_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_ei)];
  A_bi_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_ci)];
  A_bi_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_b)];
  A_bi_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_tnode)];
  A_bi_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_xf)];
  A_bi_Equ_xf_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_bi)];
  A_ei_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_ei)];
  A_ei_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_ci)];
  A_ei_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_tnode)];
  A_ei_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_e)];
  A_ei_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_xf)];
  A_ei_Equ_xf_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_b)];
  A_ei_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_xf2)];
  A_ei_Equ_xf2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf1,admsNodeID_ci)];
  A_xf1_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf1,admsNodeID_ei)];
  A_xf1_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf1,admsNodeID_b)];
  A_xf1_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf1,admsNodeID_bi)];
  A_xf1_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf1,admsNodeID_tnode)];
  A_xf1_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf1,admsNodeID_xf2)];
  A_xf1_Equ_xf2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf1,admsNodeID_xf1)];
  A_xf1_Equ_xf1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf2,admsNodeID_bi)];
  A_xf2_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf2,admsNodeID_ei)];
  A_xf2_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf2,admsNodeID_ci)];
  A_xf2_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf2,admsNodeID_b)];
  A_xf2_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf2,admsNodeID_tnode)];
  A_xf2_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf2,admsNodeID_xf1)];
  A_xf2_Equ_xf1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf2,admsNodeID_xf2)];
  A_xf2_Equ_xf2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf,admsNodeID_ci)];
  A_xf_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf,admsNodeID_ei)];
  A_xf_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf,admsNodeID_bi)];
  A_xf_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf,admsNodeID_b)];
  A_xf_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf,admsNodeID_tnode)];
  A_xf_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf,admsNodeID_xf)];
  A_xf_Equ_xf_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];


}

//-----------------------------------------------------------------------------
// Function      : Instance::setupPointers
// Purpose       : Create pointer variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupPointers( )
{

  Linear::Matrix * dFdxMatPtr = extData.dFdxMatrixPtr;
  Linear::Matrix * dQdxMatPtr = extData.dQdxMatrixPtr;
  f_c_Equ_tnode_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c,li_tnode);
  q_c_Equ_tnode_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c,li_tnode);
  f_c_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c,li_ci);
  q_c_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c,li_ci);
  f_c_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c,li_c);
  q_c_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c,li_c);
  f_b_Equ_s_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_s);
  q_b_Equ_s_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_s);
  f_b_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_ci);
  q_b_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_ci);
  f_b_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_b);
  q_b_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_b);
  f_b_Equ_tnode_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_tnode);
  q_b_Equ_tnode_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_tnode);
  f_b_Equ_bi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_bi);
  q_b_Equ_bi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_bi);
  f_b_Equ_e_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_e);
  q_b_Equ_e_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_e);
  f_b_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_ei);
  q_b_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_ei);
  f_e_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e,li_b);
  q_e_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e,li_b);
  f_e_Equ_e_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e,li_e);
  q_e_Equ_e_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e,li_e);
  f_e_Equ_tnode_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e,li_tnode);
  q_e_Equ_tnode_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e,li_tnode);
  f_e_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e,li_ei);
  q_e_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e,li_ei);
  f_s_Equ_s_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_s);
  q_s_Equ_s_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_s);
  f_s_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_ci);
  q_s_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_ci);
  f_s_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_b);
  q_s_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_b);
  f_s_Equ_tnode_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_tnode);
  q_s_Equ_tnode_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_tnode);
  f_s_Equ_bi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_bi);
  q_s_Equ_bi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_bi);
  f_s_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_ei);
  q_s_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_ei);
  f_tnode_Equ_tnode_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_tnode,li_tnode);
  q_tnode_Equ_tnode_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_tnode,li_tnode);
  f_tnode_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_tnode,li_ci);
  q_tnode_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_tnode,li_ci);
  f_tnode_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_tnode,li_ei);
  q_tnode_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_tnode,li_ei);
  f_tnode_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_tnode,li_b);
  q_tnode_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_tnode,li_b);
  f_tnode_Equ_bi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_tnode,li_bi);
  q_tnode_Equ_bi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_tnode,li_bi);
  f_tnode_Equ_s_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_tnode,li_s);
  q_tnode_Equ_s_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_tnode,li_s);
  f_tnode_Equ_e_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_tnode,li_e);
  q_tnode_Equ_e_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_tnode,li_e);
  f_tnode_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_tnode,li_c);
  q_tnode_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_tnode,li_c);
  f_ci_Equ_bi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ci,li_bi);
  q_ci_Equ_bi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ci,li_bi);
  f_ci_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ci,li_ci);
  q_ci_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ci,li_ci);
  f_ci_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ci,li_ei);
  q_ci_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ci,li_ei);
  f_ci_Equ_s_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ci,li_s);
  q_ci_Equ_s_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ci,li_s);
  f_ci_Equ_tnode_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ci,li_tnode);
  q_ci_Equ_tnode_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ci,li_tnode);
  f_ci_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ci,li_b);
  q_ci_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ci,li_b);
  f_ci_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ci,li_c);
  q_ci_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ci,li_c);
  f_ci_Equ_xf2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ci,li_xf2);
  q_ci_Equ_xf2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ci,li_xf2);
  f_bi_Equ_bi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bi,li_bi);
  q_bi_Equ_bi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bi,li_bi);
  f_bi_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bi,li_ei);
  q_bi_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bi,li_ei);
  f_bi_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bi,li_ci);
  q_bi_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bi,li_ci);
  f_bi_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bi,li_b);
  q_bi_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bi,li_b);
  f_bi_Equ_tnode_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bi,li_tnode);
  q_bi_Equ_tnode_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bi,li_tnode);
  f_bi_Equ_xf_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bi,li_xf);
  q_bi_Equ_xf_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bi,li_xf);
  f_ei_Equ_bi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ei,li_bi);
  q_ei_Equ_bi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ei,li_bi);
  f_ei_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ei,li_ei);
  q_ei_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ei,li_ei);
  f_ei_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ei,li_ci);
  q_ei_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ei,li_ci);
  f_ei_Equ_tnode_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ei,li_tnode);
  q_ei_Equ_tnode_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ei,li_tnode);
  f_ei_Equ_e_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ei,li_e);
  q_ei_Equ_e_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ei,li_e);
  f_ei_Equ_xf_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ei,li_xf);
  q_ei_Equ_xf_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ei,li_xf);
  f_ei_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ei,li_b);
  q_ei_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ei,li_b);
  f_ei_Equ_xf2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ei,li_xf2);
  q_ei_Equ_xf2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ei,li_xf2);
  f_xf1_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_xf1,li_ci);
  q_xf1_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_xf1,li_ci);
  f_xf1_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_xf1,li_ei);
  q_xf1_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_xf1,li_ei);
  f_xf1_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_xf1,li_b);
  q_xf1_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_xf1,li_b);
  f_xf1_Equ_bi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_xf1,li_bi);
  q_xf1_Equ_bi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_xf1,li_bi);
  f_xf1_Equ_tnode_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_xf1,li_tnode);
  q_xf1_Equ_tnode_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_xf1,li_tnode);
  f_xf1_Equ_xf2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_xf1,li_xf2);
  q_xf1_Equ_xf2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_xf1,li_xf2);
  f_xf1_Equ_xf1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_xf1,li_xf1);
  q_xf1_Equ_xf1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_xf1,li_xf1);
  f_xf2_Equ_bi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_xf2,li_bi);
  q_xf2_Equ_bi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_xf2,li_bi);
  f_xf2_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_xf2,li_ei);
  q_xf2_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_xf2,li_ei);
  f_xf2_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_xf2,li_ci);
  q_xf2_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_xf2,li_ci);
  f_xf2_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_xf2,li_b);
  q_xf2_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_xf2,li_b);
  f_xf2_Equ_tnode_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_xf2,li_tnode);
  q_xf2_Equ_tnode_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_xf2,li_tnode);
  f_xf2_Equ_xf1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_xf2,li_xf1);
  q_xf2_Equ_xf1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_xf2,li_xf1);
  f_xf2_Equ_xf2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_xf2,li_xf2);
  q_xf2_Equ_xf2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_xf2,li_xf2);
  f_xf_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_xf,li_ci);
  q_xf_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_xf,li_ci);
  f_xf_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_xf,li_ei);
  q_xf_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_xf,li_ei);
  f_xf_Equ_bi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_xf,li_bi);
  q_xf_Equ_bi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_xf,li_bi);
  f_xf_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_xf,li_b);
  q_xf_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_xf,li_b);
  f_xf_Equ_tnode_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_xf,li_tnode);
  q_xf_Equ_tnode_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_xf,li_tnode);
  f_xf_Equ_xf_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_xf,li_xf);
  q_xf_Equ_xf_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_xf,li_xf);


}

// RHS load functions

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEFVector
// Purpose       : load F vector (static contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEFVector()
{

  bool bsuccess=true;
  (*extData.daeFVectorPtr)[li_c] += staticContributions[admsNodeID_c].val();
  (*extData.daeFVectorPtr)[li_b] += staticContributions[admsNodeID_b].val();
  (*extData.daeFVectorPtr)[li_e] += staticContributions[admsNodeID_e].val();
  (*extData.daeFVectorPtr)[li_s] += staticContributions[admsNodeID_s].val();
  (*extData.daeFVectorPtr)[li_tnode] += staticContributions[admsNodeID_tnode].val();
  (*extData.daeFVectorPtr)[li_ci] += staticContributions[admsNodeID_ci].val();
  (*extData.daeFVectorPtr)[li_bi] += staticContributions[admsNodeID_bi].val();
  (*extData.daeFVectorPtr)[li_ei] += staticContributions[admsNodeID_ei].val();
  (*extData.daeFVectorPtr)[li_xf1] += staticContributions[admsNodeID_xf1].val();
  (*extData.daeFVectorPtr)[li_xf2] += staticContributions[admsNodeID_xf2].val();
  (*extData.daeFVectorPtr)[li_xf] += staticContributions[admsNodeID_xf].val();


  if (loadLeadCurrent)
  {
    double * leadF = extData.nextLeadCurrFCompRawPtr;

    leadF[li_branch_ic] = leadCurrentF[admsNodeID_c];
    leadF[li_branch_ib] = leadCurrentF[admsNodeID_b];
    leadF[li_branch_ie] = leadCurrentF[admsNodeID_e];
    leadF[li_branch_is] = leadCurrentF[admsNodeID_s];
    leadF[li_branch_itnode] = leadCurrentF[admsNodeID_tnode];

    // here we have to do special things for BJTs, MOSFETs and 2-terminal
    // devices for power computation.
    
    double * solVec = extData.nextSolVectorRawPtr;
    double * junctionV = extData.nextJunctionVCompRawPtr;
    junctionV[li_branch_ic] = solVec[li_c] - solVec[li_e];
    junctionV[li_branch_ib] = solVec[li_b] - solVec[li_e];
          
  }  
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEQVector
// Purpose       : load Q vector (dynamic contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEQVector()
{
  (*extData.daeQVectorPtr)[li_c] += dynamicContributions[admsNodeID_c].val();
  (*extData.daeQVectorPtr)[li_b] += dynamicContributions[admsNodeID_b].val();
  (*extData.daeQVectorPtr)[li_e] += dynamicContributions[admsNodeID_e].val();
  (*extData.daeQVectorPtr)[li_s] += dynamicContributions[admsNodeID_s].val();
  (*extData.daeQVectorPtr)[li_tnode] += dynamicContributions[admsNodeID_tnode].val();
  (*extData.daeQVectorPtr)[li_ci] += dynamicContributions[admsNodeID_ci].val();
  (*extData.daeQVectorPtr)[li_bi] += dynamicContributions[admsNodeID_bi].val();
  (*extData.daeQVectorPtr)[li_ei] += dynamicContributions[admsNodeID_ei].val();
  (*extData.daeQVectorPtr)[li_xf1] += dynamicContributions[admsNodeID_xf1].val();
  (*extData.daeQVectorPtr)[li_xf2] += dynamicContributions[admsNodeID_xf2].val();
  (*extData.daeQVectorPtr)[li_xf] += dynamicContributions[admsNodeID_xf].val();


  if (loadLeadCurrent)
  {
    double * leadQ = extData.nextLeadCurrQCompRawPtr;

    leadQ[li_branch_ic] = leadCurrentQ[admsNodeID_c];
    leadQ[li_branch_ib] = leadCurrentQ[admsNodeID_b];
    leadQ[li_branch_ie] = leadCurrentQ[admsNodeID_e];
    leadQ[li_branch_is] = leadCurrentQ[admsNodeID_s];
    leadQ[li_branch_itnode] = leadCurrentQ[admsNodeID_tnode];
  }  
  return true;
}


//-----------------------------------------------------------------------------
// Function      : Instance::updatePrimaryState
// Purpose       :
// Special Notes : In this initial implementation, does little more than
//                 call updateIntermediateVars()
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updatePrimaryState()
{
  bool bsuccess = true;

  bsuccess = updateIntermediateVars();

  // if old DAE were implemented, we'd save dynamic contributions as state
  // here.


  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateSecondaryState
// Purpose       :
// Special Notes : In this initial implementation, does nothing
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateSecondaryState()
{
  bool bsuccess = true;

  // were old DAE implemented, we'd pull dynamic contribution derivatives
  // out of state.

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateIntermediateVars
// Purpose       : update intermediate variables for one hic0_full instance
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateIntermediateVars()
{

  bool bsuccess=true;
  Linear::Vector * solVectorPtr = extData.nextSolVectorPtr;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << std::endl << subsection_divider << std::endl;
    Xyce::dout() << "  In ADMShic0_full::Instance::updateIntermediateVars\n\n";
    Xyce::dout() << "  name = " << getName() << std::endl;
  }

  // Local variables
  AdmsFadType flicker_Pwr;
  double twoq;
  AdmsFadType fourkt;
  AdmsFadType it_wop;
  AdmsFadType Qbiei;
  AdmsFadType Qbici;
  AdmsFadType Qbe;
  AdmsFadType Qbci;
  AdmsFadType Qxf;
  AdmsFadType Ixf;
  AdmsFadType fact;
  AdmsFadType Vxf;
  AdmsFadType Qxf2;
  AdmsFadType Qxf1;
  AdmsFadType Ixf2;
  AdmsFadType Ixf1;
  AdmsFadType Vxf2;
  AdmsFadType Vxf1;
  AdmsFadType Qdeix;
  AdmsFadType Itxf;
  AdmsFadType pterm;
  AdmsFadType qjs;
  AdmsFadType HSI_Tsu;
  AdmsFadType HSb;
  AdmsFadType HSa;
  AdmsFadType HSUM;
  AdmsFadType rb;
  AdmsFadType eta;
  AdmsFadType rbi;
  AdmsFadType fQz;
  AdmsFadType Qz_nom;
  AdmsFadType a_iavl;
  AdmsFadType lncc;
  AdmsFadType v_bord;
  AdmsFadType ibi;
  AdmsFadType ire;
  AdmsFadType ibe;
  AdmsFadType le;
  AdmsFadType DIOY;
  AdmsFadType qr;
  AdmsFadType tf;
  AdmsFadType qf;
  AdmsFadType dqef;
  AdmsFadType dtef;
  AdmsFadType dtfh;
  AdmsFadType dqfh;
  AdmsFadType tww;
  AdmsFadType w;
  AdmsFadType s3;
  AdmsFadType qf0;
  AdmsFadType itr;
  AdmsFadType itf;
  AdmsFadType qpt;
  AdmsFadType qm;
  AdmsFadType q_p3;
  AdmsFadType tmp2;
  AdmsFadType tmp3;
  AdmsFadType p2_u;
  AdmsFadType p2_v;
  AdmsFadType p2_D;
  AdmsFadType p2_q;
  AdmsFadType p2_p;
  AdmsFadType tmp;
  AdmsFadType p2_c;
  AdmsFadType p2_b;
  AdmsFadType p2_a;
  double o3;
  AdmsFadType wdc;
  AdmsFadType aa;
  AdmsFadType a2;
  AdmsFadType a1;
  AdmsFadType diff_q;
  AdmsFadType qpt_h;
  AdmsFadType qpt_l;
  AdmsFadType qmh;
  AdmsFadType qml;
  AdmsFadType itri;
  AdmsFadType le2;
  AdmsFadType arg2;
  AdmsFadType itfi;
  AdmsFadType le1;
  AdmsFadType arg1;
  double ickr;
  AdmsFadType ickf;
  AdmsFadType denom_iqf;
  AdmsFadType tf0;
  AdmsFadType qj_2;
  AdmsFadType b_q;
  AdmsFadType qj;
  AdmsFadType qje;
  AdmsFadType h_vbe;
  AdmsFadType vj_z;
  AdmsFadType vjh;
  AdmsFadType cc;
  AdmsFadType ick;
  AdmsFadType vceff;
  AdmsFadType uvc;
  AdmsFadType vc;
  AdmsFadType cjcii;
  AdmsFadType dvj;
  AdmsFadType qjcii;
  AdmsFadType qjci_int;
  AdmsFadType qjcx;
  AdmsFadType qj3;
  AdmsFadType qj2;
  AdmsFadType qj1;
  AdmsFadType vdj2;
  AdmsFadType vdj1;
  double ezr;
  double ez;
  AdmsFadType vj4;
  AdmsFadType vj2;
  AdmsFadType vr;
  AdmsFadType vj1;
  AdmsFadType ee1;
  AdmsFadType ex1;
  AdmsFadType ve;
  AdmsFadType a;
  AdmsFadType cr;
  AdmsFadType cmax;
  AdmsFadType vf;
  AdmsFadType vp;
  double zr;
  AdmsFadType y;
  AdmsFadType x;
  AdmsFadType v_j;
  AdmsFadType xvf2;
  AdmsFadType xvf;
  AdmsFadType cjcx0_t_i;
  AdmsFadType qjcxi;
  AdmsFadType cjci0_t_ii;
  AdmsFadType cjcx0_t_ii;
  double ahq_t;
  AdmsFadType tfh_t;
  AdmsFadType iqfh_t;
  AdmsFadType ver_t;
  AdmsFadType aver_t;
  AdmsFadType rth_t;
  AdmsFadType kavl_t;
  AdmsFadType eavl_t;
  AdmsFadType re_t;
  AdmsFadType rbi0_t;
  AdmsFadType rcx_t;
  AdmsFadType rbx_t;
  AdmsFadType tef0_t;
  double dvg;
  double zetatef;
  AdmsFadType thcs_t;
  AdmsFadType t0_t;
  AdmsFadType vces_t;
  AdmsFadType vlim_t;
  AdmsFadType rci0_t;
  AdmsFadType iqf_t;
  AdmsFadType cjs0_t;
  AdmsFadType vds_t;
  AdmsFadType cjcx0_t;
  AdmsFadType vdcx_t;
  AdmsFadType cjci0_t;
  AdmsFadType vdci_t;
  AdmsFadType ajedc_t;
  AdmsFadType aje_t;
  AdmsFadType cje0_dc_t;
  AdmsFadType vdedc_t;
  double cje0_dc;
  AdmsFadType cje0_t;
  AdmsFadType vde_t;
  AdmsFadType vdjt;
  double vdj0;
  double arg;
  AdmsFadType iscs_t;
  AdmsFadType itss_t;
  AdmsFadType ibcs_t;
  AdmsFadType ires_t;
  AdmsFadType ibes_t;
  AdmsFadType is_t;
  double zetasct;
  double zetabci;
  double mg;
  double vgsc;
  double vgbc;
  double vgbe;
  double avs;
  AdmsFadType ln_qtt0;
  AdmsFadType qtt0;
  AdmsFadType dT;
  AdmsFadType VT;
  double vt0;
  AdmsFadType Tdev;
  double Tamb;
  double Tnom;
  AdmsFadType Vrth;
  AdmsFadType Vbe;
  AdmsFadType Vbbi;
  AdmsFadType Vcic;
  AdmsFadType Veie;
  AdmsFadType Vsci;
  AdmsFadType Vciei;
  AdmsFadType Vbiei;
  AdmsFadType Vbici;
  AdmsFadType Vbci;
  double HICUMtype;


  // set the sizes of the Fad arrays:

  if (probeVars.size() != (13))
  {
    probeVars.resize(13);
    staticContributions.resize(11+0);
    dynamicContributions.resize(11+0);
  }

  noiseContribsPower.resize(6);
  noiseContribsExponent.resize(6);
  
  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 11+0 ; ++i)
  {
    staticContributions[i]=0;
    dynamicContributions[i]=0;
  }

  // extract solution variables and set as Fad independent variables.
  probeVars[admsProbeID_V_xf_GND] = (*solVectorPtr)[li_xf];
  probeVars[admsProbeID_V_xf_GND].diff(admsProbeID_V_xf_GND,13);
  probeVars[admsProbeID_V_xf2_GND] = (*solVectorPtr)[li_xf2];
  probeVars[admsProbeID_V_xf2_GND].diff(admsProbeID_V_xf2_GND,13);
  probeVars[admsProbeID_V_xf1_GND] = (*solVectorPtr)[li_xf1];
  probeVars[admsProbeID_V_xf1_GND].diff(admsProbeID_V_xf1_GND,13);
  probeVars[admsProbeID_V_tnode_GND] = (*solVectorPtr)[li_tnode];
  probeVars[admsProbeID_V_tnode_GND].diff(admsProbeID_V_tnode_GND,13);
  probeVars[admsProbeID_V_b_e] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_e];
  probeVars[admsProbeID_V_b_e].diff(admsProbeID_V_b_e,13);
  probeVars[admsProbeID_V_b_bi] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_bi];
  probeVars[admsProbeID_V_b_bi].diff(admsProbeID_V_b_bi,13);
  probeVars[admsProbeID_V_ci_c] = (*solVectorPtr)[li_ci] - (*solVectorPtr)[li_c];
  probeVars[admsProbeID_V_ci_c].diff(admsProbeID_V_ci_c,13);
  probeVars[admsProbeID_V_ei_e] = (*solVectorPtr)[li_ei] - (*solVectorPtr)[li_e];
  probeVars[admsProbeID_V_ei_e].diff(admsProbeID_V_ei_e,13);
  probeVars[admsProbeID_V_s_ci] = (*solVectorPtr)[li_s] - (*solVectorPtr)[li_ci];
  probeVars[admsProbeID_V_s_ci].diff(admsProbeID_V_s_ci,13);
  probeVars[admsProbeID_V_ci_ei] = (*solVectorPtr)[li_ci] - (*solVectorPtr)[li_ei];
  probeVars[admsProbeID_V_ci_ei].diff(admsProbeID_V_ci_ei,13);
  probeVars[admsProbeID_V_bi_ei] = (*solVectorPtr)[li_bi] - (*solVectorPtr)[li_ei];
  probeVars[admsProbeID_V_bi_ei].diff(admsProbeID_V_bi_ei,13);
  probeVars[admsProbeID_V_bi_ci] = (*solVectorPtr)[li_bi] - (*solVectorPtr)[li_ci];
  probeVars[admsProbeID_V_bi_ci].diff(admsProbeID_V_bi_ci,13);
  probeVars[admsProbeID_V_b_ci] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_ci];
  probeVars[admsProbeID_V_b_ci].diff(admsProbeID_V_b_ci,13);
  // -- code converted from analog/code block
  HICUMtype = (model_.type);
  Vbci = (HICUMtype*(probeVars[admsProbeID_V_b_ci]));
  Vbici = (HICUMtype*(probeVars[admsProbeID_V_bi_ci]));
  Vbiei = (HICUMtype*(probeVars[admsProbeID_V_bi_ei]));
  Vciei = (HICUMtype*(probeVars[admsProbeID_V_ci_ei]));
  Vsci = (HICUMtype*(probeVars[admsProbeID_V_s_ci]));
  Veie = (probeVars[admsProbeID_V_ei_e]);
  Vcic = (probeVars[admsProbeID_V_ci_c]);
  Vbbi = (probeVars[admsProbeID_V_b_bi]);
  Vbe = (HICUMtype*(probeVars[admsProbeID_V_b_e]));
  Vrth = (probeVars[admsProbeID_V_tnode_GND]);
  Tnom = ((model_.tnom)+273.15);
  Tamb = admsTemperature;
  Tdev = ((Tamb+dt)+Vrth);
  if ((Tdev<((-100.00)+273.15)))
  {
    Tdev = ((-100.00)+273.15);
  }
  else
  {
    if ((Tdev>(326.85+273.15)))
    {
      Tdev = (326.85+273.15);
    }
  }
  vt0 = ((1.3806503e-23*Tnom)/1.6021766208e-19);
  VT = ((1.3806503e-23*Tdev)/1.6021766208e-19);
  dT = (Tdev-Tnom);
  qtt0 = (Tdev/Tnom);
  ln_qtt0 = log(qtt0);
  avs = ((model_.alvs)*Tnom);
  vgbe = (((model_.vgb)+(model_.vge))/2);
  vgbc = (((model_.vgb)+(model_.vgc))/2);
  vgsc = (((model_.vgs)+(model_.vgc))/2);
  mg = (3-((1.6021766208e-19*(model_.f1vg))/1.3806503e-23));
  zetabci = ((mg+1)-(model_.zetaci));
  zetasct = (mg-1.5);
  is_t = ((model_.is)*exp((((model_.zetact)*ln_qtt0)+(((model_.vgb)/VT)*(qtt0-1)))));
  ibes_t = ((model_.ibes)*exp((((model_.zetabet)*ln_qtt0)+(((model_.vge)/VT)*(qtt0-1)))));
  ires_t = ((model_.ires)*exp((((0.5*mg)*ln_qtt0)+(((0.5*vgbe)/VT)*(qtt0-1)))));
  ibcs_t = ((model_.ibcs)*exp(((zetabci*ln_qtt0)+(((model_.vgc)/VT)*(qtt0-1)))));
  itss_t = ((model_.itss)*exp(((zetasct*ln_qtt0)+(((model_.vgc)/VT)*(qtt0-1)))));
  iscs_t = ((model_.iscs)*exp(((zetasct*ln_qtt0)+(((model_.vgs)/VT)*(qtt0-1)))));
  arg = ((0.5*(model_.vde))/vt0);
  vdj0 = ((2*vt0)*log((exp(arg)-exp((-arg)))));
  vdjt = (((vdj0*qtt0)+(vgbe*(1-qtt0)))-((mg*VT)*ln_qtt0));
  vde_t = (vdjt+((2*VT)*log((0.5*(1+sqrt((1+(4*exp(((-vdjt)/VT))))))))));
  cje0_t = ((model_.cje0)*exp(((model_.ze)*log(((model_.vde)/vde_t)))));
  cje0_dc = (model_.cje0);
  arg = ((0.5*(model_.vdedc))/vt0);
  vdj0 = ((2*vt0)*log((exp(arg)-exp((-arg)))));
  vdjt = (((vdj0*qtt0)+(vgbe*(1-qtt0)))-((mg*VT)*ln_qtt0));
  vdedc_t = (vdjt+((2*VT)*log((0.5*(1+sqrt((1+(4*exp(((-vdjt)/VT))))))))));
  cje0_dc_t = (cje0_dc*exp(((model_.zedc)*log(((model_.vdedc)/vdedc_t)))));
  aje_t = (((model_.aje)*vde_t)/(model_.vde));
  ajedc_t = (((model_.ajedc)*vdedc_t)/(model_.vdedc));
  arg = ((0.5*(model_.vdci))/vt0);
  vdj0 = ((2*vt0)*log((exp(arg)-exp((-arg)))));
  vdjt = (((vdj0*qtt0)+(vgbc*(1-qtt0)))-((mg*VT)*ln_qtt0));
  vdci_t = (vdjt+((2*VT)*log((0.5*(1+sqrt((1+(4*exp(((-vdjt)/VT))))))))));
  cjci0_t = ((model_.cjci0)*exp(((model_.zci)*log(((model_.vdci)/vdci_t)))));
  arg = ((0.5*(model_.vdcx))/vt0);
  vdj0 = ((2*vt0)*log((exp(arg)-exp((-arg)))));
  vdjt = (((vdj0*qtt0)+(vgbc*(1-qtt0)))-((mg*VT)*ln_qtt0));
  vdcx_t = (vdjt+((2*VT)*log((0.5*(1+sqrt((1+(4*exp(((-vdjt)/VT))))))))));
  cjcx0_t = ((model_.cjcx0)*exp(((model_.zcx)*log(((model_.vdcx)/vdcx_t)))));
  arg = ((0.5*(model_.vds))/vt0);
  vdj0 = ((2*vt0)*log((exp(arg)-exp((-arg)))));
  vdjt = (((vdj0*qtt0)+(vgsc*(1-qtt0)))-((mg*VT)*ln_qtt0));
  vds_t = (vdjt+((2*VT)*log((0.5*(1+sqrt((1+(4*exp(((-vdjt)/VT))))))))));
  cjs0_t = ((model_.cjs0)*exp(((model_.zs)*log(((model_.vds)/vds_t)))));
  iqf_t = ((model_.iqf)*exp((((model_.zetaiqf)*ln_qtt0)-(((model_.dvgbe)/VT)*(qtt0-1)))));
  rci0_t = ((model_.rci0)*exp(((model_.zetaci)*ln_qtt0)));
  vlim_t = ((model_.vlim)*exp((((model_.zetaci)-avs)*ln_qtt0)));
  vces_t = ((model_.vces)*(1+((model_.alces)*dT)));
  t0_t = ((model_.t0)*((1+((model_.alt0)*dT))+(((model_.kt0)*dT)*dT)));
  thcs_t = ((model_.thcs)*exp((((model_.zetaci)-1)*ln_qtt0)));
  zetatef = (((model_.zetabet)-(model_.zetact))-0.5);
  dvg = ((model_.vgb)-(model_.vge));
  if (((model_.tef_temp)==1))
  {
    tef0_t = ((model_.tef0)*exp(((zetatef*ln_qtt0)-((dvg/VT)*(qtt0-1)))));
  }
  else
  {
    tef0_t = (model_.tef0);
  }
  rbx_t = ((model_.rbx)*exp(((model_.zetarbx)*ln_qtt0)));
  rcx_t = ((model_.rcx)*exp(((model_.zetarcx)*ln_qtt0)));
  rbi0_t = ((model_.rbi0)*exp(((model_.zetarbi)*ln_qtt0)));
  re_t = ((model_.re)*exp(((model_.zetare)*ln_qtt0)));
  eavl_t = ((model_.eavl)*exp(((model_.aleav)*dT)));
  kavl_t = ((model_.kavl)*exp(((model_.alkav)*dT)));
  if (((model_.zetarth)!=0))
  {
    rth_t = ((model_.rth)*exp(((model_.zetarth)*log((Tdev/Tnom)))));
  }
  else
  {
    rth_t = (model_.rth);
  }
  aver_t = ((model_.aver)*exp(((model_.zetaver)*ln_qtt0)));
  ver_t = ((model_.ver)/exp((((model_.dvgbe)/VT)*(exp(((model_.zetavgbe)*ln_qtt0))-1))));
  iqfh_t = ((model_.iqfh)*((1+((model_.aliqfh)*dT))+(((model_.kiqfh)*dT)*dT)));
  tfh_t = (((model_.tfh)*((1+((model_.aliqfh)*dT))+(((model_.kiqfh)*dT)*dT)))*exp(((((model_.vgb)-(model_.vge))/VT)*(qtt0-1))));
  ahq_t = (model_.ahq);
  if ((cjcx0_t==0))
  {
    cjci0_t_ii = (cjci0_t*(model_.fbc));
    qjcxi = 0;
    cjcx0_t_i = (cjci0_t*(1-(model_.fbc)));
    if (((model_.vptci)<1.0e2))
    {
      if ((cjcx0_t_i>0.0))
      {
        zr = ((model_.zci)/4.0);
        vp = ((model_.vptci)-vdci_t);
        vf = (vdci_t*(1.0-exp(((-log(static_cast<double>(2.4)))/(model_.zci)))));
        cmax = (2.4*cjcx0_t_i);
        cr = (cjcx0_t_i*exp((((model_.zci)-zr)*log((vdci_t/(model_.vptci))))));
        a = VT;
        ve = ((vf-Vbci)/a);
        if ((ve<=80.0))
        {
          ex1 = exp(ve);
          ee1 = (1.0+ex1);
          vj1 = (vf-(a*log(ee1)));
        }
        else
        {
          vj1 = Vbci;
        }
        a = ((0.1*vp)+(4.0*VT));
        vr = ((vp+vj1)/a);
        if ((vr<=80.0))
        {
          ex1 = exp(vr);
          ee1 = (1.0+ex1);
          vj2 = ((-vp)+(a*log(ee1)));
        }
        else
        {
          vj2 = vj1;
        }
        vj4 = (Vbci-vj1);
        ez = (1.0-(model_.zci));
        ezr = (1.0-zr);
        vdj1 = log((1.0-(vj1/vdci_t)));
        vdj2 = log((1.0-(vj2/vdci_t)));
        qj1 = ((cjcx0_t_i*(1.0-exp((vdj2*ez))))/ez);
        qj2 = ((cr*(1.0-exp((vdj1*ezr))))/ezr);
        qj3 = ((cr*(1.0-exp((vdj2*ezr))))/ezr);
        qjcx = ((((qj1+qj2)-qj3)*vdci_t)+(cmax*vj4));
      }
      else
      {
        qjcx = 0.0;
      }
    }
    else
    {
      if ((cjcx0_t_i>0.0))
      {
        vf = (vdci_t*(1.0-exp(((-log(static_cast<double>(2.4)))/(model_.zci)))));
        xvf = ((vf-Vbci)/VT);
        xvf2 = sqrt(((xvf*xvf)+1.921812));
        v_j = (vf-((VT*(xvf+xvf2))*0.5));
        x = (1.0-(model_.zci));
        y = (1.0-exp((x*log((1.0-(v_j/vdci_t))))));
        qjcx = ((((cjcx0_t_i*vdci_t)*y)/x)+((2.4*cjcx0_t_i)*(Vbci-v_j)));
      }
      else
      {
        qjcx = 0.00;
      }
    }
  }
  else
  {
    cjci0_t_ii = cjci0_t;
    cjcx0_t_ii = (cjcx0_t*(model_.fbc));
    if (((model_.vptcx)<1.0e2))
    {
      if ((cjcx0_t_ii>0.0))
      {
        zr = ((model_.zcx)/4.0);
        vp = ((model_.vptcx)-vdcx_t);
        vf = (vdcx_t*(1.0-exp(((-log(static_cast<double>(2.4)))/(model_.zcx)))));
        cmax = (2.4*cjcx0_t_ii);
        cr = (cjcx0_t_ii*exp((((model_.zcx)-zr)*log((vdcx_t/(model_.vptcx))))));
        a = VT;
        ve = ((vf-Vbici)/a);
        if ((ve<=80.0))
        {
          ex1 = exp(ve);
          ee1 = (1.0+ex1);
          vj1 = (vf-(a*log(ee1)));
        }
        else
        {
          vj1 = Vbici;
        }
        a = ((0.1*vp)+(4.0*VT));
        vr = ((vp+vj1)/a);
        if ((vr<=80.0))
        {
          ex1 = exp(vr);
          ee1 = (1.0+ex1);
          vj2 = ((-vp)+(a*log(ee1)));
        }
        else
        {
          vj2 = vj1;
        }
        vj4 = (Vbici-vj1);
        ez = (1.0-(model_.zcx));
        ezr = (1.0-zr);
        vdj1 = log((1.0-(vj1/vdcx_t)));
        vdj2 = log((1.0-(vj2/vdcx_t)));
        qj1 = ((cjcx0_t_ii*(1.0-exp((vdj2*ez))))/ez);
        qj2 = ((cr*(1.0-exp((vdj1*ezr))))/ezr);
        qj3 = ((cr*(1.0-exp((vdj2*ezr))))/ezr);
        qjcxi = ((((qj1+qj2)-qj3)*vdcx_t)+(cmax*vj4));
      }
      else
      {
        qjcxi = 0.0;
      }
    }
    else
    {
      if ((cjcx0_t_ii>0.0))
      {
        vf = (vdcx_t*(1.0-exp(((-log(static_cast<double>(2.4)))/(model_.zcx)))));
        xvf = ((vf-Vbici)/VT);
        xvf2 = sqrt(((xvf*xvf)+1.921812));
        v_j = (vf-((VT*(xvf+xvf2))*0.5));
        x = (1.0-(model_.zcx));
        y = (1.0-exp((x*log((1.0-(v_j/vdcx_t))))));
        qjcxi = ((((cjcx0_t_ii*vdcx_t)*y)/x)+((2.4*cjcx0_t_ii)*(Vbici-v_j)));
      }
      else
      {
        qjcxi = 0.00;
      }
    }
    cjcx0_t_i = (cjcx0_t*(1-(model_.fbc)));
    if (((model_.vptcx)<1.0e2))
    {
      if ((cjcx0_t_i>0.0))
      {
        zr = ((model_.zcx)/4.0);
        vp = ((model_.vptcx)-vdcx_t);
        vf = (vdcx_t*(1.0-exp(((-log(static_cast<double>(2.4)))/(model_.zcx)))));
        cmax = (2.4*cjcx0_t_i);
        cr = (cjcx0_t_i*exp((((model_.zcx)-zr)*log((vdcx_t/(model_.vptcx))))));
        a = VT;
        ve = ((vf-Vbci)/a);
        if ((ve<=80.0))
        {
          ex1 = exp(ve);
          ee1 = (1.0+ex1);
          vj1 = (vf-(a*log(ee1)));
        }
        else
        {
          vj1 = Vbci;
        }
        a = ((0.1*vp)+(4.0*VT));
        vr = ((vp+vj1)/a);
        if ((vr<=80.0))
        {
          ex1 = exp(vr);
          ee1 = (1.0+ex1);
          vj2 = ((-vp)+(a*log(ee1)));
        }
        else
        {
          vj2 = vj1;
        }
        vj4 = (Vbci-vj1);
        ez = (1.0-(model_.zcx));
        ezr = (1.0-zr);
        vdj1 = log((1.0-(vj1/vdcx_t)));
        vdj2 = log((1.0-(vj2/vdcx_t)));
        qj1 = ((cjcx0_t_i*(1.0-exp((vdj2*ez))))/ez);
        qj2 = ((cr*(1.0-exp((vdj1*ezr))))/ezr);
        qj3 = ((cr*(1.0-exp((vdj2*ezr))))/ezr);
        qjcx = ((((qj1+qj2)-qj3)*vdcx_t)+(cmax*vj4));
      }
      else
      {
        qjcx = 0.0;
      }
    }
    else
    {
      if ((cjcx0_t_i>0.0))
      {
        vf = (vdcx_t*(1.0-exp(((-log(static_cast<double>(2.4)))/(model_.zcx)))));
        xvf = ((vf-Vbci)/VT);
        xvf2 = sqrt(((xvf*xvf)+1.921812));
        v_j = (vf-((VT*(xvf+xvf2))*0.5));
        x = (1.0-(model_.zcx));
        y = (1.0-exp((x*log((1.0-(v_j/vdcx_t))))));
        qjcx = ((((cjcx0_t_i*vdcx_t)*y)/x)+((2.4*cjcx0_t_i)*(Vbci-v_j)));
      }
      else
      {
        qjcx = 0.00;
      }
    }
  }
  if (((model_.vptci)<1.0e2))
  {
    if ((cjci0_t_ii>0.0))
    {
      zr = ((model_.zci)/4.0);
      vp = ((model_.vptci)-vdci_t);
      vf = (vdci_t*(1.0-exp(((-log(static_cast<double>(2.4)))/(model_.zci)))));
      cmax = (2.4*cjci0_t_ii);
      cr = (cjci0_t_ii*exp((((model_.zci)-zr)*log((vdci_t/(model_.vptci))))));
      a = VT;
      ve = ((vf-Vbici)/a);
      if ((ve<=80.0))
      {
        ex1 = exp(ve);
        ee1 = (1.0+ex1);
        vj1 = (vf-(a*log(ee1)));
      }
      else
      {
        vj1 = Vbici;
      }
      a = ((0.1*vp)+(4.0*VT));
      vr = ((vp+vj1)/a);
      if ((vr<=80.0))
      {
        ex1 = exp(vr);
        ee1 = (1.0+ex1);
        vj2 = ((-vp)+(a*log(ee1)));
      }
      else
      {
        vj2 = vj1;
      }
      vj4 = (Vbici-vj1);
      ez = (1.0-(model_.zci));
      ezr = (1.0-zr);
      vdj1 = log((1.0-(vj1/vdci_t)));
      vdj2 = log((1.0-(vj2/vdci_t)));
      qj1 = ((cjci0_t_ii*(1.0-exp((vdj2*ez))))/ez);
      qj2 = ((cr*(1.0-exp((vdj1*ezr))))/ezr);
      qj3 = ((cr*(1.0-exp((vdj2*ezr))))/ezr);
      qjci = ((((qj1+qj2)-qj3)*vdci_t)+(cmax*vj4));
    }
    else
    {
      qjci = 0.0;
    }
  }
  else
  {
    if ((cjci0_t_ii>0.0))
    {
      vf = (vdci_t*(1.0-exp(((-log(static_cast<double>(2.4)))/(model_.zci)))));
      xvf = ((vf-Vbici)/VT);
      xvf2 = sqrt(((xvf*xvf)+1.921812));
      v_j = (vf-((VT*(xvf+xvf2))*0.5));
      x = (1.0-(model_.zci));
      y = (1.0-exp((x*log((1.0-(v_j/vdci_t))))));
      qjci = ((((cjci0_t_ii*vdci_t)*y)/x)+((2.4*cjci0_t_ii)*(Vbici-v_j)));
    }
    else
    {
      qjci = 0.00;
    }
  }
  qjci_int = qjci;
  qjcii = (qjci+qjcxi);
  if ((cjci0_t_ii>0.0))
  {
    vf = (vdci_t*(1.0-exp(((-log(static_cast<double>(2.4)))/(model_.zci)))));
    xvf = ((vf-Vbici)/VT);
    xvf2 = sqrt(((xvf*xvf)+1.921812));
    v_j = (vf-((VT*(xvf+xvf2))*0.5));
    dvj = ((0.5*(xvf+xvf2))/xvf2);
    cjcii = (((cjci0_t_ii*exp(((-(model_.zci))*log((1-(v_j/vdci_t))))))*dvj)+((2.4*cjci0_t_ii)*(1-dvj)));
  }
  else
  {
    cjcii = 0.0;
  }
  vc = (Vciei-vces_t);
  uvc = ((vc/VT)-1);
  vceff = (VT*(1+(0.5*(uvc+sqrt(((uvc*uvc)+1.921812))))));
  x = ((vceff-vlim_t)/(model_.vpt));
  ick = (((vceff*(1+(0.5*(x+sqrt(((x*x)+1e-3))))))/rci0_t)/sqrt((1+(((vceff*vceff)/vlim_t)/vlim_t))));
  if (((cjcii>0.0)&&(cjci0_t_ii>0.0)))
  {
    cc = (cjci0_t_ii/cjcii);
    qjci = (qjci/cjci0_t_ii);
  }
  else
  {
    cc = 1.0;
    qjci = 0;
  }
  if ((cje0_dc_t>0.0))
  {
    vf = (vdedc_t*(1.0-exp(((-log(ajedc_t))/(model_.zedc)))));
    xvf = ((vf-Vbiei)/VT);
    xvf2 = sqrt(((xvf*xvf)+1.921812));
    v_j = (vf-((VT*(xvf+xvf2))*0.5));
    x = (1.0-(model_.zedc));
    y = (1.0-exp((x*log((1.0-(v_j/vdedc_t))))));
    qjei = ((((cje0_dc_t*vdedc_t)*y)/x)+((ajedc_t*cje0_dc_t)*(Vbiei-v_j)));
  }
  else
  {
    qjei = 0.00;
  }
  if (((model_.aver)==0.0))
  {
    h_vbe = 1;
  }
  else
  {
    vjh = ((vdedc_t-Vbiei)/(2.0*VT));
    vjh = (vdedc_t-(((2.0*VT)*(vjh+sqrt(((vjh*vjh)+1.921812))))*0.5));
    vjh = ((vjh-VT)/VT);
    vjh = (VT*(1.0+((vjh+sqrt(((vjh*vjh)+1.921812)))*0.5)));
    vj_z = ((1.0-exp(((model_.zedc)*log((1.0-(vjh/vdedc_t))))))*aver_t);
    h_vbe = ((exp(vj_z)-1.0)/vj_z);
  }
  qje = ((h_vbe*qjei)/cje0_dc_t);
  qj = ((1+(qjci/(model_.vef)))+(qje/ver_t));
  b_q = ((20*qj)-1);
  qj_2 = (0.025*(1+((b_q+sqrt(((b_q*b_q)+1.921812)))/2)));
  tf0 = ((t0_t+((model_.dt0h)*(cc-1)))+((model_.tbvl)*((1/cc)-1)));
  if (((model_.fiqf)==1))
  {
    denom_iqf = ((model_.fiqf)*((tf0/t0_t)-1));
    ickf = (iqf_t/(1+denom_iqf));
  }
  else
  {
    ickf = iqf_t;
  }
  ickr = (model_.iqr);
  arg1 = (Vbiei/((model_.mcf)*VT));
  if ((arg1>80))
  {
    le1 = (1+(arg1-80));
    arg1 = 80;
  }
  else
  {
    le1 = 1;
  }
  le1 = (le1*limexp<AdmsFadType>(arg1));
  itfi = (is_t*le1);
  arg2 = (Vbici/((model_.mcr)*VT));
  if ((arg2>80))
  {
    le2 = (1+(arg2-80));
    arg2 = 80;
  }
  else
  {
    le2 = 1;
  }
  le2 = (le2*limexp<AdmsFadType>(arg2));
  itri = (is_t*le2);
  if (((model_.tfh)!=0))
  {
    qml = (((itfi/ickf)+(itri/ickr))+exp((0.6666*log(((itfi*(itfi/ick))*(tfh_t/iqfh_t))))));
    qmh = ((((itfi/ickf)+(itri/ickr))+(itfi/iqfh_t))+exp((0.6666*log(((itfi*(itfi/ick))*(tfh_t/iqfh_t))))));
  }
  else
  {
    qml = ((itfi/ickf)+(itri/ickr));
    qmh = (((itfi/ickf)+(itri/ickr))+(itfi/iqfh_t));
  }
  qpt_l = (qj_2+sqrt(((qj_2*qj_2)+qml)));
  qpt_h = (qj_2+sqrt(((qj_2*qj_2)+qmh)));
  diff_q = (qmh-qml);
  if ((fabs(diff_q)>1e-8))
  {
    a1 = (1-(((ick/(1+ahq_t))/itfi)*qpt_l));
    a2 = (1+(((ick/(1+ahq_t))/itfi)*(qpt_h-qpt_l)));
    aa = (a1/a2);
    wdc = ((sqrt(((aa*aa)+0.01))+aa)/(1+sqrt((1+0.01))));
  }
  else
  {
    wdc = 0;
  }
  if (((model_.it_mod)==0))
  {
    if (((model_.tfh)!=0))
    {
      qm = ((((itfi/ickf)+(itri/ickr))+(((itfi/iqfh_t)*wdc)*wdc))+exp((0.6666*log(((itfi*(itfi/ick))*(tfh_t/iqfh_t))))));
    }
    else
    {
      qm = (((itfi/ickf)+(itri/ickr))+(((itfi/iqfh_t)*wdc)*wdc));
    }
    qpt = (qj_2+sqrt(((qj_2*qj_2)+qm)));
  }
  else
  {
    o3 = (1.0/3);
    p2_a = ((-2)*qj_2);
    if ((((model_.iqf)==1.0e6)&&((model_.iqfh)==1.0e6)))
    {
      p2_b = 0;
    }
    else
    {
      p2_b = (-(((itfi/ickf)+(itri/ickr))+(((itfi/iqfh_t)*wdc)*wdc)));
    }
    p2_c = (((((-itfi)*itfi)/ick)*tfh_t)/iqfh_t);
    tmp = (p2_a*p2_a);
    p2_p = (p2_b-(tmp*o3));
    p2_q = (((((2*p2_a)*tmp)/27)-((p2_a*p2_b)*o3))+p2_c);
    p2_D = (((p2_q*p2_q)*0.25)+(((p2_p*p2_p)*p2_p)/27));
    if ((fabs(p2_D)<1e-10))
    {
      q_p3 = (((3*p2_q)/p2_p)-(p2_a*o3));
    }
    else
    {
      if ((p2_D>0))
      {
        tmp2 = ((-p2_q)*0.5);
        tmp3 = sqrt(p2_D);
        tmp = (tmp2+tmp3);
        if ((tmp>0))
        {
          p2_u = exp((o3*log(tmp)));
        }
        else
        {
          p2_u = (-exp((o3*log((-tmp)))));
        }
        tmp = (tmp2-tmp3);
        if ((tmp>0))
        {
          p2_v = exp((o3*log(tmp)));
        }
        else
        {
          p2_v = (-exp((o3*log((-tmp)))));
        }
        q_p3 = ((p2_u+p2_v)-(p2_a*o3));
      }
      else
      {
        tmp = (((-p2_q)*0.5)*sqrt(((-27.0)/((p2_p*p2_p)*p2_p))));
        tmp2 = (tmp*tmp);
        if ((tmp>=0))
        {
          tmp = ((3.14159265358979323846/2)-atan(sqrt((tmp2/(1-tmp2)))));
        }
        else
        {
          tmp = ((3.14159265358979323846/2)+atan(sqrt((tmp2/(1-tmp2)))));
        }
        tmp = ((sqrt((((-4)*p2_p)*o3))*cos((o3*tmp)))-(p2_a*o3));
        q_p3 = tmp;
      }
    }
    qpt = q_p3;
  }
  if ((qpt<=1e-20))
  {
    qpt = 1e-20;
  }
  itf = (itfi/qpt);
  itr = (itri/qpt);
  if ((itf<=1e-20))
  {
    itf = 1e-20;
  }
  it = (itf-itr);
  qf0 = (tf0*itf);
  a = (1-(ick/itf));
  s3 = sqrt(((a*a)+(model_.ahc)));
  w = ((a+s3)/(1+sqrt((1+(model_.ahc)))));
  tww = ((thcs_t*w)*w);
  dqfh = (tww*itf);
  dtfh = (tww*(1+(((2*ick)/itf)/s3)));
  dtef = (tef0_t*exp(((model_.gte)*log((itf/ick)))));
  dqef = ((dtef*itf)/((model_.gte)+1.0));
  qf = ((qf0+dqef)+dqfh);
  tf = ((tf0+dtfh)+dtef);
  qr = ((model_.tr)*itr);
  DIOY = (Vbiei/((model_.mbe)*VT));
  if (((model_.ibes)>0.0))
  {
    if ((DIOY>80))
    {
      le = (1+(DIOY-80));
      DIOY = 80;
    }
    else
    {
      le = 1;
    }
    le = (le*limexp<AdmsFadType>(DIOY));
    ibe = (ibes_t*(le-1.0));
    if ((DIOY<=(-14.0)))
    {
      ibe = (-ibes_t);
    }
  }
  else
  {
    ibe = 0.0;
  }
  DIOY = (Vbiei/((model_.mre)*VT));
  if (((model_.ires)>0.0))
  {
    if ((DIOY>80))
    {
      le = (1+(DIOY-80));
      DIOY = 80;
    }
    else
    {
      le = 1;
    }
    le = (le*limexp<AdmsFadType>(DIOY));
    ire = (ires_t*(le-1.0));
    if ((DIOY<=(-14.0)))
    {
      ire = (-ires_t);
    }
  }
  else
  {
    ire = 0.0;
  }
  ijbe = (ibe+ire);
  DIOY = (Vbici/((model_.mbc)*VT));
  if (((model_.ibcs)>0.0))
  {
    if ((DIOY>80))
    {
      le = (1+(DIOY-80));
      DIOY = 80;
    }
    else
    {
      le = 1;
    }
    le = (le*limexp<AdmsFadType>(DIOY));
    ijbc = (ibcs_t*(le-1.0));
    if ((DIOY<=(-14.0)))
    {
      ijbc = (-ibcs_t);
    }
  }
  else
  {
    ijbc = 0.0;
  }
  ibi = (ijbe+ijbc);
  if ((Vbici<0))
    //Begin block HICAVL
  {
    v_bord = (eavl_t*vdci_t);
    if (((vdci_t-Vbici)>v_bord))
    {
      a_iavl = ((kavl_t/vdci_t)*exp((-cc)));
      iavl = ((itf*a_iavl)*(v_bord+((1+cc)*((vdci_t-Vbici)-v_bord))));
    }
    else
    {
      lncc = log((1/cc));
      iavl = ((kavl_t*itf)*exp(((((-1)/(model_.zci))*lncc)-(eavl_t*exp((((1/(model_.zci))-1)*lncc))))));
    }
  }
  // End block HICAVL
  else
  {
    iavl = 0;
  }
  if ((cje0_t>0.0))
  {
    vf = (vde_t*(1.0-exp(((-log(aje_t))/(model_.ze)))));
    xvf = ((vf-Vbiei)/VT);
    xvf2 = sqrt(((xvf*xvf)+1.921812));
    v_j = (vf-((VT*(xvf+xvf2))*0.5));
    x = (1.0-(model_.ze));
    y = (1.0-exp((x*log((1.0-(v_j/vde_t))))));
    qjei = ((((cje0_t*vde_t)*y)/x)+((aje_t*cje0_t)*(Vbiei-v_j)));
  }
  else
  {
    qjei = 0.00;
  }
  qje = (qjei/cje0_t);
  if ((rbi0_t>0.0))
    //Begin block HICRBI
  {
    Qz_nom = ((((1+(qje/(model_.vr0e)))+(qjci/(model_.vr0c)))+(itf/ickf))+(itr/ickr));
    fQz = (0.5*(Qz_nom+sqrt(((Qz_nom*Qz_nom)+0.01))));
    rbi = (rbi0_t/fQz);
    if ((ibi>0.0))
    {
      eta = ((((model_.fgeo)*rbi)*ibi)/VT);
      if ((eta<1e-6))
      {
        rbi = (rbi*(1-(0.5*eta)));
      }
      else
      {
        rbi = ((rbi*log((eta+1)))/eta);
      }
    }
  }
  // End block HICRBI
  else
  {
    rbi = 0.0;
  }
  rb = (rbi+rbx_t);
  if (((model_.itss)>0.0))
    //Begin block Sub_Transfer
  {
    HSUM = ((model_.msf)*VT);
    HSa = limexp<AdmsFadType>((Vbci/HSUM));
    HSb = limexp<AdmsFadType>((Vsci/HSUM));
    HSI_Tsu = (itss_t*(HSa-HSb));
  }
  // End block Sub_Transfer
  else
  {
    HSI_Tsu = 0.0;
  }
  DIOY = (Vsci/((model_.msc)*VT));
  if (((model_.iscs)>0.0))
  {
    if ((DIOY>80))
    {
      le = (1+(DIOY-80));
      DIOY = 80;
    }
    else
    {
      le = 1;
    }
    le = (le*limexp<AdmsFadType>(DIOY));
    ijsc = (iscs_t*(le-1.0));
    if ((DIOY<=(-14.0)))
    {
      ijsc = (-iscs_t);
    }
  }
  else
  {
    ijsc = 0.0;
  }
  if (((model_.vpts)<1.0e2))
  {
    if ((cjs0_t>0.0))
    {
      zr = ((model_.zs)/4.0);
      vp = ((model_.vpts)-vds_t);
      vf = (vds_t*(1.0-exp(((-log(static_cast<double>(2.4)))/(model_.zs)))));
      cmax = (2.4*cjs0_t);
      cr = (cjs0_t*exp((((model_.zs)-zr)*log((vds_t/(model_.vpts))))));
      a = VT;
      ve = ((vf-Vsci)/a);
      if ((ve<=80.0))
      {
        ex1 = exp(ve);
        ee1 = (1.0+ex1);
        vj1 = (vf-(a*log(ee1)));
      }
      else
      {
        vj1 = Vsci;
      }
      a = ((0.1*vp)+(4.0*VT));
      vr = ((vp+vj1)/a);
      if ((vr<=80.0))
      {
        ex1 = exp(vr);
        ee1 = (1.0+ex1);
        vj2 = ((-vp)+(a*log(ee1)));
      }
      else
      {
        vj2 = vj1;
      }
      vj4 = (Vsci-vj1);
      ez = (1.0-(model_.zs));
      ezr = (1.0-zr);
      vdj1 = log((1.0-(vj1/vds_t)));
      vdj2 = log((1.0-(vj2/vds_t)));
      qj1 = ((cjs0_t*(1.0-exp((vdj2*ez))))/ez);
      qj2 = ((cr*(1.0-exp((vdj1*ezr))))/ezr);
      qj3 = ((cr*(1.0-exp((vdj2*ezr))))/ezr);
      qjs = ((((qj1+qj2)-qj3)*vds_t)+(cmax*vj4));
    }
    else
    {
      qjs = 0.0;
    }
  }
  else
  {
    if ((cjs0_t>0.0))
    {
      vf = (vds_t*(1.0-exp(((-log(static_cast<double>(2.4)))/(model_.zs)))));
      xvf = ((vf-Vsci)/VT);
      xvf2 = sqrt(((xvf*xvf)+1.921812));
      v_j = (vf-((VT*(xvf+xvf2))*0.5));
      x = (1.0-(model_.zs));
      y = (1.0-exp((x*log((1.0-(v_j/vds_t))))));
      qjs = ((((cjs0_t*vds_t)*y)/x)+((2.4*cjs0_t)*(Vsci-v_j)));
    }
    else
    {
      qjs = 0.00;
    }
  }
  pterm = 0;
  if ((((model_.flsh)==1)&&((model_.rth)>=0.001)))
  {
    pterm = ((it*Vciei)+(iavl*(vdci_t-Vbici)));
  }
  else
  {
    if ((((model_.flsh)==2)&&((model_.rth)>=0.001)))
    {
      pterm = (((((Vciei*it)+((vdci_t-Vbici)*iavl))+(ijbe*Vbiei))+(ijbc*Vbici))+(ijsc*Vsci));
      if ((rb>=0.001))
      {
        pterm = (pterm+((Vbbi*Vbbi)/rb));
      }
      if (((model_.re)>=0.001))
      {
        pterm = (pterm+((Veie*Veie)/re_t));
      }
      if (((model_.rcx)>=0.001))
      {
        pterm = (pterm+((Vcic*Vcic)/rcx_t));
      }
    }
  }
  Itxf = itf;
  Qdeix = qf;
  if ((((model_.flnqs)!=0)&&(tf!=0)))
  {
    Vxf1 = (probeVars[admsProbeID_V_xf1_GND]);
    Vxf2 = (probeVars[admsProbeID_V_xf2_GND]);
    Ixf1 = (((Vxf2-itf)/tf)*(model_.t0));
    Ixf2 = (((Vxf2-Vxf1)/tf)*(model_.t0));
    Qxf1 = (((model_.alit)*Vxf1)*(model_.t0));
    Qxf2 = ((((model_.alit)*Vxf2)/3)*(model_.t0));
    Itxf = Vxf2;
    Vxf = (probeVars[admsProbeID_V_xf_GND]);
    fact = ((model_.t0)/tf);
    Ixf = ((Vxf-qf)*fact);
    Qxf = (((model_.alqf)*Vxf)*(model_.t0));
    Qdeix = Vxf;
  }
  else
  {
    Ixf1 = (probeVars[admsProbeID_V_xf1_GND]);
    Ixf2 = (probeVars[admsProbeID_V_xf2_GND]);
    Qxf1 = 0;
    Qxf2 = 0;
    Ixf = (probeVars[admsProbeID_V_xf_GND]);
    Qxf = 0;
  }
  Ibici = (ijbc-iavl);
  Qbci = ((model_.cbcpar)*Vbci);
  Qbe = ((model_.cbepar)*Vbe);
  Qbici = (qjcii+qr);
  Qbiei = (qjei+Qdeix);
  ijsc = (HICUMtype*ijsc);
  qjs = (HICUMtype*qjs);
  qjcx = (HICUMtype*qjcx);
  Qbci = (HICUMtype*Qbci);
  Qbe = (HICUMtype*Qbe);
  Ibici = (HICUMtype*Ibici);
  Qbici = (HICUMtype*Qbici);
  ijbe = (HICUMtype*ijbe);
  Qbiei = (HICUMtype*Qbiei);
  it_wop = (HICUMtype*it);
  it = (HICUMtype*(Itxf-itr));
  iavl = (HICUMtype*iavl);
  // I(bi,ei) <+ (($simparam("gmin",1e-12)*V(bi,ei)))
  staticContributions[admsNodeID_bi] += (getDeviceOptions().gmin*(probeVars[admsProbeID_V_bi_ei]));
  staticContributions[admsNodeID_ei] -= (getDeviceOptions().gmin*(probeVars[admsProbeID_V_bi_ei]));
  // I(bi,ci) <+ (($simparam("gmin",1e-12)*V(bi,ci)))
  staticContributions[admsNodeID_bi] += (getDeviceOptions().gmin*(probeVars[admsProbeID_V_bi_ci]));
  staticContributions[admsNodeID_ci] -= (getDeviceOptions().gmin*(probeVars[admsProbeID_V_bi_ci]));
  // I(ci,ei) <+ (($simparam("gmin",1e-12)*V(ci,ei)))
  staticContributions[admsNodeID_ci] += (getDeviceOptions().gmin*(probeVars[admsProbeID_V_ci_ei]));
  staticContributions[admsNodeID_ei] -= (getDeviceOptions().gmin*(probeVars[admsProbeID_V_ci_ei]));
  // I(b,s) <+ ((HICUMtype*HSI_Tsu))
  staticContributions[admsNodeID_b] += (HICUMtype*HSI_Tsu);
  staticContributions[admsNodeID_s] -= (HICUMtype*HSI_Tsu);
  // I(s,ci) <+ (ijsc)
  staticContributions[admsNodeID_s] += ijsc;
  staticContributions[admsNodeID_ci] -= ijsc;
  // I(s,ci) <+ (ddt(qjs))
  dynamicContributions[admsNodeID_s] += (qjs);
  dynamicContributions[admsNodeID_ci] -= (qjs);
  // I(b,ci) <+ (ddt(qjcx))
  dynamicContributions[admsNodeID_b] += (qjcx);
  dynamicContributions[admsNodeID_ci] -= (qjcx);
  // I(b,ci) <+ (ddt(Qbci))
  dynamicContributions[admsNodeID_b] += (Qbci);
  dynamicContributions[admsNodeID_ci] -= (Qbci);
  // I(b,e) <+ (ddt(Qbe))
  dynamicContributions[admsNodeID_b] += (Qbe);
  dynamicContributions[admsNodeID_e] -= (Qbe);
  if (((model_.re)>=0.001))
  {
    // I(ei,e) <+ ((Veie/re_t))
    staticContributions[admsNodeID_ei] += (Veie/re_t);
    staticContributions[admsNodeID_e] -= (Veie/re_t);
  }
  else
  {
    // V(ei,e) <+ (0.0)
    // do nothing at all
  }
  if (((model_.rcx)>=0.001))
  {
    // I(ci,c) <+ ((Vcic/rcx_t))
    staticContributions[admsNodeID_ci] += (Vcic/rcx_t);
    staticContributions[admsNodeID_c] -= (Vcic/rcx_t);
  }
  else
  {
    // V(ci,c) <+ (0.0)
    // do nothing at all
  }
  if ((((model_.rbi0)>=0.001)||((model_.rbx)>=0.001)))
  {
    // I(b,bi) <+ ((Vbbi/rb))
    staticContributions[admsNodeID_b] += (Vbbi/rb);
    staticContributions[admsNodeID_bi] -= (Vbbi/rb);
  }
  else
  {
    // V(b,bi) <+ (0.0)
    // do nothing at all
  }
  // I(bi,ci) <+ (Ibici)
  staticContributions[admsNodeID_bi] += Ibici;
  staticContributions[admsNodeID_ci] -= Ibici;
  // I(bi,ci) <+ (ddt(Qbici))
  dynamicContributions[admsNodeID_bi] += (Qbici);
  dynamicContributions[admsNodeID_ci] -= (Qbici);
  // I(bi,ei) <+ (ijbe)
  staticContributions[admsNodeID_bi] += ijbe;
  staticContributions[admsNodeID_ei] -= ijbe;
  // I(bi,ei) <+ (ddt(Qbiei))
  dynamicContributions[admsNodeID_bi] += (Qbiei);
  dynamicContributions[admsNodeID_ei] -= (Qbiei);
  // I(ci,ei) <+ (it)
  staticContributions[admsNodeID_ci] += it;
  staticContributions[admsNodeID_ei] -= it;
  if ((((model_.flsh)==0)||((model_.rth)<0.001)))
  {
    // I(tnode,GND) <+ ((Vrth/0.001))
    staticContributions[admsNodeID_tnode] += (Vrth/0.001);
  }
  else
  {
    // I(tnode,GND) <+ (((Vrth/rth)-pterm))
    staticContributions[admsNodeID_tnode] += ((Vrth/(model_.rth))-pterm);
    // I(tnode,GND) <+ (ddt((cth*Vrth)))
    dynamicContributions[admsNodeID_tnode] += (((model_.cth)*Vrth));
  }
  // I(xf1,GND) <+ (Ixf1)
  staticContributions[admsNodeID_xf1] += Ixf1;
  // I(xf1,GND) <+ (ddt(Qxf1))
  dynamicContributions[admsNodeID_xf1] += (Qxf1);
  // I(xf2,GND) <+ (Ixf2)
  staticContributions[admsNodeID_xf2] += Ixf2;
  // I(xf2,GND) <+ (ddt(Qxf2))
  dynamicContributions[admsNodeID_xf2] += (Qxf2);
  // I(xf,GND) <+ (Ixf)
  staticContributions[admsNodeID_xf] += Ixf;
  // I(xf,GND) <+ (ddt(Qxf))
  dynamicContributions[admsNodeID_xf] += (Qxf);
  fourkt = ((4.0*1.3806503e-23)*Tdev);
  if ((((model_.rbx)>=0.001)||((model_.rbi0)>=0.001)))
  {
    // I(b,bi) <+ (white_noise((fourkt/rb)))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[0]= (fourkt.val()/rb.val());
    }
  }
  if (((model_.rcx)>=0.001))
  {
    // I(ci,c) <+ (white_noise((fourkt/rcx_t)))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[1]= (fourkt.val()/rcx_t.val());
    }
  }
  if (((model_.re)>=0.001))
  {
    // I(ei,e) <+ (white_noise((fourkt/re_t)))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[2]= (fourkt.val()/re_t.val());
    }
  }
  twoq = (2.0*1.6021766208e-19);
  // I(bi,ei) <+ (white_noise((twoq*ijbe)))
  if (getSolverState().noiseFlag)
  {
    noiseContribsPower[3]= (twoq*ijbe.val());
  }
  // I(ci,ei) <+ (white_noise((twoq*it)))
  if (getSolverState().noiseFlag)
  {
    noiseContribsPower[4]= (twoq*it.val());
  }
  flicker_Pwr = ((model_.kf)*pow(ijbe,(model_.af)));
  // I(bi,ei) <+ (flicker_noise(flicker_Pwr,1.0))
  if (getSolverState().noiseFlag)
  {
    noiseContribsPower[5]= flicker_Pwr.val();
    noiseContribsExponent[5]= 1.0;
  }


  // -- endcode converted from analog/code block
  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << " probeVars[admsProbeID_V_xf_GND] =  "
                 <<probeVars[admsProbeID_V_xf_GND].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_xf2_GND] =  "
                 <<probeVars[admsProbeID_V_xf2_GND].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_xf1_GND] =  "
                 <<probeVars[admsProbeID_V_xf1_GND].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_tnode_GND] =  "
                 <<probeVars[admsProbeID_V_tnode_GND].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_e] =  "
                 <<probeVars[admsProbeID_V_b_e].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_bi] =  "
                 <<probeVars[admsProbeID_V_b_bi].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_ci_c] =  "
                 <<probeVars[admsProbeID_V_ci_c].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_ei_e] =  "
                 <<probeVars[admsProbeID_V_ei_e].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_s_ci] =  "
                 <<probeVars[admsProbeID_V_s_ci].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_ci_ei] =  "
                 <<probeVars[admsProbeID_V_ci_ei].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bi_ei] =  "
                 <<probeVars[admsProbeID_V_bi_ei].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bi_ci] =  "
                 <<probeVars[admsProbeID_V_bi_ci].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_ci] =  "
                 <<probeVars[admsProbeID_V_b_ci].val() << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_c] =  "
                 <<staticContributions[admsNodeID_c].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_xf_GND) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_xf_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_xf2_GND) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_xf1_GND) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_tnode_GND) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_tnode_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b_bi) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_ci_c) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_ci_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_ei_e) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_ei_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_s_ci) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_s_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b_ci) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_b_ci) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_c] =  "
                 <<dynamicContributions[admsNodeID_c].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_xf_GND) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_xf_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_xf2_GND) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_xf1_GND) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_tnode_GND) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_tnode_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_bi) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_ci_c) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_ci_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_ei_e) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_ei_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_s_ci) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_s_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_ci) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_ci) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_b] =  "
                 <<staticContributions[admsNodeID_b].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_xf_GND) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_xf_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_xf2_GND) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_xf1_GND) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_tnode_GND) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_tnode_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_bi) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_ci_c) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_ci_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_ei_e) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_ei_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_s_ci) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_s_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_ci) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b_ci) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_b] =  "
                 <<dynamicContributions[admsNodeID_b].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_xf_GND) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_xf_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_xf2_GND) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_xf1_GND) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_tnode_GND) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_tnode_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_bi) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_ci_c) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_ci_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_ei_e) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_ei_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_ci) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_ci) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_ci) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_e] =  "
                 <<staticContributions[admsNodeID_e].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_xf_GND) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_xf_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_xf2_GND) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_xf1_GND) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_tnode_GND) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_tnode_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b_bi) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_ci_c) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_ci_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_ei_e) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_ei_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_s_ci) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_s_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b_ci) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_b_ci) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_e] =  "
                 <<dynamicContributions[admsNodeID_e].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_xf_GND) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_xf_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_xf2_GND) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_xf1_GND) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_tnode_GND) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_tnode_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_bi) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ci_c) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ci_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ei_e) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ei_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_s_ci) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_s_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_ci) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_ci) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_s] =  "
                 <<staticContributions[admsNodeID_s].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_xf_GND) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_xf_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_xf2_GND) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_xf1_GND) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_tnode_GND) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_tnode_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_bi) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_ci_c) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_ci_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_ei_e) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_ei_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_s_ci) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_s_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_ci) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_b_ci) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_s] =  "
                 <<dynamicContributions[admsNodeID_s].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_xf_GND) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_xf_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_xf2_GND) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_xf1_GND) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_tnode_GND) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_tnode_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_bi) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ci_c) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ci_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ei_e) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ei_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_ci) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_ci) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_ci) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_tnode] =  "
                 <<staticContributions[admsNodeID_tnode].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_xf_GND) =  " <<staticContributions[admsNodeID_tnode].dx(admsProbeID_V_xf_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_xf2_GND) =  " <<staticContributions[admsNodeID_tnode].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_xf1_GND) =  " <<staticContributions[admsNodeID_tnode].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_tnode_GND) =  " <<staticContributions[admsNodeID_tnode].dx(admsProbeID_V_tnode_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_tnode].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_b_bi) =  " <<staticContributions[admsNodeID_tnode].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_ci_c) =  " <<staticContributions[admsNodeID_tnode].dx(admsProbeID_V_ci_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_ei_e) =  " <<staticContributions[admsNodeID_tnode].dx(admsProbeID_V_ei_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_s_ci) =  " <<staticContributions[admsNodeID_tnode].dx(admsProbeID_V_s_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_tnode].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_tnode].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_tnode].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_b_ci) =  " <<staticContributions[admsNodeID_tnode].dx(admsProbeID_V_b_ci) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_tnode] =  "
                 <<dynamicContributions[admsNodeID_tnode].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_xf_GND) =  " <<dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_xf_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_xf2_GND) =  " <<dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_xf1_GND) =  " <<dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_tnode_GND) =  " <<dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_tnode_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_b_bi) =  " <<dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_ci_c) =  " <<dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_ci_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_ei_e) =  " <<dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_ei_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_s_ci) =  " <<dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_s_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_b_ci) =  " <<dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_b_ci) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_ci] =  "
                 <<staticContributions[admsNodeID_ci].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_xf_GND) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_xf_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_xf2_GND) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_xf1_GND) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_tnode_GND) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_tnode_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_bi) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_ci_c) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_ci_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_ei_e) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_ei_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_s_ci) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_s_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_ci) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_ci) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_ci] =  "
                 <<dynamicContributions[admsNodeID_ci].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_xf_GND) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_xf_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_xf2_GND) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_xf1_GND) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_tnode_GND) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_tnode_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_bi) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ci_c) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ci_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ei_e) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ei_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_s_ci) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_s_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_ci) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_ci) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_bi] =  "
                 <<staticContributions[admsNodeID_bi].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_xf_GND) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_xf_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_xf2_GND) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_xf1_GND) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_tnode_GND) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_tnode_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_bi) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_ci_c) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_ci_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_ei_e) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_ei_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_s_ci) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_s_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_ci) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_ci) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_bi] =  "
                 <<dynamicContributions[admsNodeID_bi].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_xf_GND) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_xf_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_xf2_GND) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_xf1_GND) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_tnode_GND) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_tnode_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_bi) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ci_c) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ci_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ei_e) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ei_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_s_ci) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_s_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_ci) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_ci) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_ei] =  "
                 <<staticContributions[admsNodeID_ei].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_xf_GND) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_xf_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_xf2_GND) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_xf1_GND) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_tnode_GND) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_tnode_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_bi) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_ci_c) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_ci_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_ei_e) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_ei_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_s_ci) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_s_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_ci) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_ci) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_ei] =  "
                 <<dynamicContributions[admsNodeID_ei].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_xf_GND) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_xf_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_xf2_GND) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_xf1_GND) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_tnode_GND) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_tnode_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_bi) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ci_c) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ci_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ei_e) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ei_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_s_ci) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_s_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_ci) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_ci) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_xf1] =  "
                 <<staticContributions[admsNodeID_xf1].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_xf_GND) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_xf_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_xf2_GND) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_xf1_GND) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_tnode_GND) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_tnode_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_b_bi) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_ci_c) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_ci_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_ei_e) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_ei_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_s_ci) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_s_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_b_ci) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_b_ci) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_xf1] =  "
                 <<dynamicContributions[admsNodeID_xf1].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_xf_GND) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_xf_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_xf2_GND) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_xf1_GND) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_tnode_GND) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_tnode_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_b_bi) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_ci_c) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_ci_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_ei_e) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_ei_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_s_ci) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_s_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_b_ci) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_b_ci) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_xf2] =  "
                 <<staticContributions[admsNodeID_xf2].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_xf_GND) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_xf_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_xf2_GND) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_xf1_GND) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_tnode_GND) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_tnode_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_b_bi) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_ci_c) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_ci_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_ei_e) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_ei_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_s_ci) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_s_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_b_ci) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_b_ci) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_xf2] =  "
                 <<dynamicContributions[admsNodeID_xf2].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_xf_GND) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_xf_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_xf2_GND) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_xf1_GND) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_tnode_GND) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_tnode_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_b_bi) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_ci_c) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_ci_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_ei_e) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_ei_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_s_ci) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_s_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_b_ci) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_b_ci) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_xf] =  "
                 <<staticContributions[admsNodeID_xf].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_xf_GND) =  " <<staticContributions[admsNodeID_xf].dx(admsProbeID_V_xf_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_xf2_GND) =  " <<staticContributions[admsNodeID_xf].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_xf1_GND) =  " <<staticContributions[admsNodeID_xf].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_tnode_GND) =  " <<staticContributions[admsNodeID_xf].dx(admsProbeID_V_tnode_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_xf].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_b_bi) =  " <<staticContributions[admsNodeID_xf].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_ci_c) =  " <<staticContributions[admsNodeID_xf].dx(admsProbeID_V_ci_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_ei_e) =  " <<staticContributions[admsNodeID_xf].dx(admsProbeID_V_ei_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_s_ci) =  " <<staticContributions[admsNodeID_xf].dx(admsProbeID_V_s_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_xf].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_xf].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_xf].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_b_ci) =  " <<staticContributions[admsNodeID_xf].dx(admsProbeID_V_b_ci) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_xf] =  "
                 <<dynamicContributions[admsNodeID_xf].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_xf_GND) =  " <<dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_xf_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_xf2_GND) =  " <<dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_xf1_GND) =  " <<dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_tnode_GND) =  " <<dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_tnode_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_b_bi) =  " <<dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_ci_c) =  " <<dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_ci_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_ei_e) =  " <<dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_ei_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_s_ci) =  " <<dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_s_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_b_ci) =  " <<dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_b_ci) << std::endl;

    if (!origFlag)
      Xyce::dout() << "This step was limited by this device." << std::endl;
  }


  if (loadLeadCurrent)
  {
    // If needed, we must now copy all the data from staticContributions
    // and dynamicContributionsinto the lead current F vector
    // Must make sure all collapsed node contributions get summed into the
    // external nodes properly.
    for ( int unmappedNode=0; unmappedNode < 5 ; unmappedNode++)
    {
      leadCurrentF[unmappedNode] = 0.0;
      leadCurrentQ[unmappedNode] = 0.0;
    }
    for ( int unmappedNode=0; unmappedNode < 11; unmappedNode++)
    {
      if (nodeMap[unmappedNode] < 5 && nodeMap[unmappedNode] != -1 )
      {
        leadCurrentF[nodeMap[unmappedNode]] += staticContributions[unmappedNode].val();
        leadCurrentQ[nodeMap[unmappedNode]] += dynamicContributions[unmappedNode].val();
      }
    }
  }  
  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::getNumNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
int Instance::getNumNoiseSources () const
{
  return 6;
}

//-----------------------------------------------------------------------------
// Function      : Instance::setupNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{
  int numSources=getNumNoiseSources();
  noiseData.numSources = numSources;
  noiseData.resize(numSources);

  noiseData.deviceName = getName().getEncodedName();
  std::string theNoiseName;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_b_bi");
  noiseData.noiseNames[0]=theNoiseName;
  noiseData.li_Pos[0]=li_b;
  noiseData.li_Neg[0]=li_bi;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_ci_c");
  noiseData.noiseNames[1]=theNoiseName;
  noiseData.li_Pos[1]=li_ci;
  noiseData.li_Neg[1]=li_c;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_ei_e");
  noiseData.noiseNames[2]=theNoiseName;
  noiseData.li_Pos[2]=li_ei;
  noiseData.li_Neg[2]=li_e;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_bi_ei");
  noiseData.noiseNames[3]=theNoiseName;
  noiseData.li_Pos[3]=li_bi;
  noiseData.li_Neg[3]=li_ei;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_ci_ei");
  noiseData.noiseNames[4]=theNoiseName;
  noiseData.li_Pos[4]=li_ci;
  noiseData.li_Neg[4]=li_ei;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_flicker_bi_ei");
  noiseData.noiseNames[5]=theNoiseName;
  noiseData.li_Pos[5]=li_bi;
  noiseData.li_Neg[5]=li_ei;


}
//-----------------------------------------------------------------------------
// Function      : Instance::getNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::getNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{noiseData.noiseDens[0] = noiseContribsPower[0];
  noiseData.lnNoiseDens[0] = std::log(std::max(noiseData.noiseDens[0],N_MINLOG));
  noiseData.noiseDens[1] = noiseContribsPower[1];
  noiseData.lnNoiseDens[1] = std::log(std::max(noiseData.noiseDens[1],N_MINLOG));
  noiseData.noiseDens[2] = noiseContribsPower[2];
  noiseData.lnNoiseDens[2] = std::log(std::max(noiseData.noiseDens[2],N_MINLOG));
  noiseData.noiseDens[3] = noiseContribsPower[3];
  noiseData.lnNoiseDens[3] = std::log(std::max(noiseData.noiseDens[3],N_MINLOG));
  noiseData.noiseDens[4] = noiseContribsPower[4];
  noiseData.lnNoiseDens[4] = std::log(std::max(noiseData.noiseDens[4],N_MINLOG));
  noiseData.noiseDens[5] = noiseContribsPower[5];

  noiseData.noiseDens[5] /= pow(noiseData.freq,noiseContribsExponent[5]);noiseData.lnNoiseDens[5] = std::log(std::max(noiseData.noiseDens[5],N_MINLOG));

}  

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdFdx
// Purpose       :
// Special Notes : Load the dFdx ("static jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdFdx()
{
  bool bsuccess = true;
  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*f_bi_Equ_bi_Node_Ptr) +=  -staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_bi) +staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei);
  (*f_bi_Equ_ei_Node_Ptr) +=  -staticContributions[admsNodeID_bi].dx(admsProbeID_V_ci_ei) -staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei);
  (*f_ei_Equ_bi_Node_Ptr) +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei);
  (*f_ei_Equ_ei_Node_Ptr) +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_ei_e) -staticContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei) -staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei);
  (*f_bi_Equ_ci_Node_Ptr) +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_V_ci_ei) -staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_ci) -staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci);
  (*f_ci_Equ_bi_Node_Ptr) +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei) +staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci);
  (*f_ci_Equ_ci_Node_Ptr) +=  -staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_ci) +staticContributions[admsNodeID_ci].dx(admsProbeID_V_ci_c) -staticContributions[admsNodeID_ci].dx(admsProbeID_V_s_ci) +staticContributions[admsNodeID_ci].dx(admsProbeID_V_ci_ei) -staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci);
  (*f_ci_Equ_ei_Node_Ptr) +=  -staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei) -staticContributions[admsNodeID_ci].dx(admsProbeID_V_ci_ei);
  (*f_ei_Equ_ci_Node_Ptr) +=  -staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci) -staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_ci) +staticContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei);
  (*f_b_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_s_ci);
  (*f_b_Equ_ci_Node_Ptr) +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_ci_ei) -staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_ci) -staticContributions[admsNodeID_b].dx(admsProbeID_V_b_ci) -staticContributions[admsNodeID_b].dx(admsProbeID_V_s_ci);
  (*f_s_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_s_ci);
  (*f_s_Equ_ci_Node_Ptr) +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_bi_ci) -staticContributions[admsNodeID_s].dx(admsProbeID_V_b_ci) -staticContributions[admsNodeID_s].dx(admsProbeID_V_s_ci);
  (*f_b_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_b_bi) +staticContributions[admsNodeID_b].dx(admsProbeID_V_b_ci);
  (*f_s_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_b_ci);
  (*f_b_Equ_tnode_Node_Ptr) +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_tnode_GND);
  (*f_s_Equ_tnode_Node_Ptr) +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_tnode_GND);
  (*f_s_Equ_bi_Node_Ptr) +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_s].dx(admsProbeID_V_bi_ei);
  (*f_s_Equ_ei_Node_Ptr) +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_bi_ei);
  (*f_ci_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_s_ci);
  (*f_ci_Equ_tnode_Node_Ptr) +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_tnode_GND);
  (*f_ci_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_ci);
  (*f_b_Equ_bi_Node_Ptr) +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b_bi) +staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_ei) +staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_ci);
  (*f_e_Equ_e_Node_Ptr) +=  -staticContributions[admsNodeID_e].dx(admsProbeID_V_ei_e);
  (*f_ei_Equ_tnode_Node_Ptr) +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_tnode_GND);
  (*f_e_Equ_tnode_Node_Ptr) +=  +staticContributions[admsNodeID_e].dx(admsProbeID_V_tnode_GND);
  (*f_ei_Equ_e_Node_Ptr) +=  -staticContributions[admsNodeID_ei].dx(admsProbeID_V_ei_e);
  (*f_e_Equ_ei_Node_Ptr) +=  +staticContributions[admsNodeID_e].dx(admsProbeID_V_ei_e);
  (*f_c_Equ_tnode_Node_Ptr) +=  +staticContributions[admsNodeID_c].dx(admsProbeID_V_tnode_GND);
  (*f_ci_Equ_c_Node_Ptr) +=  -staticContributions[admsNodeID_ci].dx(admsProbeID_V_ci_c);
  (*f_c_Equ_ci_Node_Ptr) +=  +staticContributions[admsNodeID_c].dx(admsProbeID_V_ci_c);
  (*f_c_Equ_c_Node_Ptr) +=  -staticContributions[admsNodeID_c].dx(admsProbeID_V_ci_c);
  (*f_bi_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_bi) +staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_ci);
  (*f_b_Equ_ei_Node_Ptr) +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_ei) -staticContributions[admsNodeID_b].dx(admsProbeID_V_ci_ei);
  (*f_bi_Equ_tnode_Node_Ptr) +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_V_tnode_GND);
  (*f_ei_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_ci);
  (*f_ci_Equ_xf2_Node_Ptr) +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_xf2_GND);
  (*f_ei_Equ_xf2_Node_Ptr) +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_xf2_GND);
  (*f_tnode_Equ_tnode_Node_Ptr) +=  +staticContributions[admsNodeID_tnode].dx(admsProbeID_V_tnode_GND);
  (*f_tnode_Equ_ci_Node_Ptr) +=  +staticContributions[admsNodeID_tnode].dx(admsProbeID_V_ci_c) -staticContributions[admsNodeID_tnode].dx(admsProbeID_V_s_ci) -staticContributions[admsNodeID_tnode].dx(admsProbeID_V_bi_ci) -staticContributions[admsNodeID_tnode].dx(admsProbeID_V_b_ci) +staticContributions[admsNodeID_tnode].dx(admsProbeID_V_ci_ei);
  (*f_tnode_Equ_ei_Node_Ptr) +=  +staticContributions[admsNodeID_tnode].dx(admsProbeID_V_ei_e) -staticContributions[admsNodeID_tnode].dx(admsProbeID_V_bi_ei) -staticContributions[admsNodeID_tnode].dx(admsProbeID_V_ci_ei);
  (*f_tnode_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_tnode].dx(admsProbeID_V_b_bi) +staticContributions[admsNodeID_tnode].dx(admsProbeID_V_b_ci);
  (*f_tnode_Equ_bi_Node_Ptr) +=  -staticContributions[admsNodeID_tnode].dx(admsProbeID_V_b_bi) +staticContributions[admsNodeID_tnode].dx(admsProbeID_V_bi_ei) +staticContributions[admsNodeID_tnode].dx(admsProbeID_V_bi_ci);
  (*f_tnode_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_tnode].dx(admsProbeID_V_s_ci);
  (*f_tnode_Equ_e_Node_Ptr) +=  -staticContributions[admsNodeID_tnode].dx(admsProbeID_V_ei_e);
  (*f_tnode_Equ_c_Node_Ptr) +=  -staticContributions[admsNodeID_tnode].dx(admsProbeID_V_ci_c);
  (*f_xf1_Equ_ci_Node_Ptr) +=  -staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ci) -staticContributions[admsNodeID_xf1].dx(admsProbeID_V_b_ci) +staticContributions[admsNodeID_xf1].dx(admsProbeID_V_ci_ei);
  (*f_xf1_Equ_ei_Node_Ptr) +=  -staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ei) -staticContributions[admsNodeID_xf1].dx(admsProbeID_V_ci_ei);
  (*f_xf1_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_xf1].dx(admsProbeID_V_b_ci);
  (*f_xf1_Equ_bi_Node_Ptr) +=  +staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ei) +staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ci);
  (*f_xf1_Equ_tnode_Node_Ptr) +=  +staticContributions[admsNodeID_xf1].dx(admsProbeID_V_tnode_GND);
  (*f_xf1_Equ_xf2_Node_Ptr) +=  +staticContributions[admsNodeID_xf1].dx(admsProbeID_V_xf2_GND);
  (*f_xf1_Equ_xf1_Node_Ptr) +=  +staticContributions[admsNodeID_xf1].dx(admsProbeID_V_xf1_GND);
  (*f_xf2_Equ_bi_Node_Ptr) +=  +staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ei);
  (*f_xf2_Equ_ei_Node_Ptr) +=  -staticContributions[admsNodeID_xf2].dx(admsProbeID_V_ci_ei) -staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ei);
  (*f_xf2_Equ_ci_Node_Ptr) +=  -staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ci) -staticContributions[admsNodeID_xf2].dx(admsProbeID_V_b_ci) +staticContributions[admsNodeID_xf2].dx(admsProbeID_V_ci_ei);
  (*f_xf2_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_xf2].dx(admsProbeID_V_b_ci);
  (*f_xf2_Equ_tnode_Node_Ptr) +=  +staticContributions[admsNodeID_xf2].dx(admsProbeID_V_tnode_GND);
  (*f_xf2_Equ_xf1_Node_Ptr) +=  +staticContributions[admsNodeID_xf2].dx(admsProbeID_V_xf1_GND);
  (*f_xf2_Equ_xf2_Node_Ptr) +=  +staticContributions[admsNodeID_xf2].dx(admsProbeID_V_xf2_GND);
  (*f_xf_Equ_ci_Node_Ptr) +=  -staticContributions[admsNodeID_xf].dx(admsProbeID_V_bi_ci) -staticContributions[admsNodeID_xf].dx(admsProbeID_V_b_ci) +staticContributions[admsNodeID_xf].dx(admsProbeID_V_ci_ei);
  (*f_xf_Equ_ei_Node_Ptr) +=  -staticContributions[admsNodeID_xf].dx(admsProbeID_V_bi_ei) -staticContributions[admsNodeID_xf].dx(admsProbeID_V_ci_ei);
  (*f_xf_Equ_bi_Node_Ptr) +=  +staticContributions[admsNodeID_xf].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_xf].dx(admsProbeID_V_bi_ei);
  (*f_xf_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_xf].dx(admsProbeID_V_b_ci);
  (*f_xf_Equ_tnode_Node_Ptr) +=  +staticContributions[admsNodeID_xf].dx(admsProbeID_V_tnode_GND);
  (*f_xf_Equ_xf_Node_Ptr) +=  +staticContributions[admsNodeID_xf].dx(admsProbeID_V_xf_GND);

#else
  //use the offsets instead of pointers
  dFdx[li_bi][A_bi_Equ_bi_NodeOffset] +=  -staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_bi) +staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei);
  dFdx[li_bi][A_bi_Equ_ei_NodeOffset] +=  -staticContributions[admsNodeID_bi].dx(admsProbeID_V_ci_ei) -staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei);
  dFdx[li_ei][A_ei_Equ_bi_NodeOffset] +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei);
  dFdx[li_ei][A_ei_Equ_ei_NodeOffset] +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_ei_e) -staticContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei) -staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei);
  dFdx[li_bi][A_bi_Equ_ci_NodeOffset] +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_V_ci_ei) -staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_ci) -staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci);
  dFdx[li_ci][A_ci_Equ_bi_NodeOffset] +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei) +staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci);
  dFdx[li_ci][A_ci_Equ_ci_NodeOffset] +=  -staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_ci) +staticContributions[admsNodeID_ci].dx(admsProbeID_V_ci_c) -staticContributions[admsNodeID_ci].dx(admsProbeID_V_s_ci) +staticContributions[admsNodeID_ci].dx(admsProbeID_V_ci_ei) -staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci);
  dFdx[li_ci][A_ci_Equ_ei_NodeOffset] +=  -staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei) -staticContributions[admsNodeID_ci].dx(admsProbeID_V_ci_ei);
  dFdx[li_ei][A_ei_Equ_ci_NodeOffset] +=  -staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci) -staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_ci) +staticContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei);
  dFdx[li_b][A_b_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_s_ci);
  dFdx[li_b][A_b_Equ_ci_NodeOffset] +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_ci_ei) -staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_ci) -staticContributions[admsNodeID_b].dx(admsProbeID_V_b_ci) -staticContributions[admsNodeID_b].dx(admsProbeID_V_s_ci);
  dFdx[li_s][A_s_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_s_ci);
  dFdx[li_s][A_s_Equ_ci_NodeOffset] +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_bi_ci) -staticContributions[admsNodeID_s].dx(admsProbeID_V_b_ci) -staticContributions[admsNodeID_s].dx(admsProbeID_V_s_ci);
  dFdx[li_b][A_b_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_b_bi) +staticContributions[admsNodeID_b].dx(admsProbeID_V_b_ci);
  dFdx[li_s][A_s_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_b_ci);
  dFdx[li_b][A_b_Equ_tnode_NodeOffset] +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_tnode_GND);
  dFdx[li_s][A_s_Equ_tnode_NodeOffset] +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_tnode_GND);
  dFdx[li_s][A_s_Equ_bi_NodeOffset] +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_s].dx(admsProbeID_V_bi_ei);
  dFdx[li_s][A_s_Equ_ei_NodeOffset] +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_bi_ei);
  dFdx[li_ci][A_ci_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_s_ci);
  dFdx[li_ci][A_ci_Equ_tnode_NodeOffset] +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_tnode_GND);
  dFdx[li_ci][A_ci_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_ci);
  dFdx[li_b][A_b_Equ_bi_NodeOffset] +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b_bi) +staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_ei) +staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_ci);
  dFdx[li_e][A_e_Equ_e_NodeOffset] +=  -staticContributions[admsNodeID_e].dx(admsProbeID_V_ei_e);
  dFdx[li_ei][A_ei_Equ_tnode_NodeOffset] +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_tnode_GND);
  dFdx[li_e][A_e_Equ_tnode_NodeOffset] +=  +staticContributions[admsNodeID_e].dx(admsProbeID_V_tnode_GND);
  dFdx[li_ei][A_ei_Equ_e_NodeOffset] +=  -staticContributions[admsNodeID_ei].dx(admsProbeID_V_ei_e);
  dFdx[li_e][A_e_Equ_ei_NodeOffset] +=  +staticContributions[admsNodeID_e].dx(admsProbeID_V_ei_e);
  dFdx[li_c][A_c_Equ_tnode_NodeOffset] +=  +staticContributions[admsNodeID_c].dx(admsProbeID_V_tnode_GND);
  dFdx[li_ci][A_ci_Equ_c_NodeOffset] +=  -staticContributions[admsNodeID_ci].dx(admsProbeID_V_ci_c);
  dFdx[li_c][A_c_Equ_ci_NodeOffset] +=  +staticContributions[admsNodeID_c].dx(admsProbeID_V_ci_c);
  dFdx[li_c][A_c_Equ_c_NodeOffset] +=  -staticContributions[admsNodeID_c].dx(admsProbeID_V_ci_c);
  dFdx[li_bi][A_bi_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_bi) +staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_ci);
  dFdx[li_b][A_b_Equ_ei_NodeOffset] +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_ei) -staticContributions[admsNodeID_b].dx(admsProbeID_V_ci_ei);
  dFdx[li_bi][A_bi_Equ_tnode_NodeOffset] +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_V_tnode_GND);
  dFdx[li_ei][A_ei_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_ci);
  dFdx[li_ci][A_ci_Equ_xf2_NodeOffset] +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_xf2_GND);
  dFdx[li_ei][A_ei_Equ_xf2_NodeOffset] +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_xf2_GND);
  dFdx[li_tnode][A_tnode_Equ_tnode_NodeOffset] +=  +staticContributions[admsNodeID_tnode].dx(admsProbeID_V_tnode_GND);
  dFdx[li_tnode][A_tnode_Equ_ci_NodeOffset] +=  +staticContributions[admsNodeID_tnode].dx(admsProbeID_V_ci_c) -staticContributions[admsNodeID_tnode].dx(admsProbeID_V_s_ci) -staticContributions[admsNodeID_tnode].dx(admsProbeID_V_bi_ci) -staticContributions[admsNodeID_tnode].dx(admsProbeID_V_b_ci) +staticContributions[admsNodeID_tnode].dx(admsProbeID_V_ci_ei);
  dFdx[li_tnode][A_tnode_Equ_ei_NodeOffset] +=  +staticContributions[admsNodeID_tnode].dx(admsProbeID_V_ei_e) -staticContributions[admsNodeID_tnode].dx(admsProbeID_V_bi_ei) -staticContributions[admsNodeID_tnode].dx(admsProbeID_V_ci_ei);
  dFdx[li_tnode][A_tnode_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_tnode].dx(admsProbeID_V_b_bi) +staticContributions[admsNodeID_tnode].dx(admsProbeID_V_b_ci);
  dFdx[li_tnode][A_tnode_Equ_bi_NodeOffset] +=  -staticContributions[admsNodeID_tnode].dx(admsProbeID_V_b_bi) +staticContributions[admsNodeID_tnode].dx(admsProbeID_V_bi_ei) +staticContributions[admsNodeID_tnode].dx(admsProbeID_V_bi_ci);
  dFdx[li_tnode][A_tnode_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_tnode].dx(admsProbeID_V_s_ci);
  dFdx[li_tnode][A_tnode_Equ_e_NodeOffset] +=  -staticContributions[admsNodeID_tnode].dx(admsProbeID_V_ei_e);
  dFdx[li_tnode][A_tnode_Equ_c_NodeOffset] +=  -staticContributions[admsNodeID_tnode].dx(admsProbeID_V_ci_c);
  dFdx[li_xf1][A_xf1_Equ_ci_NodeOffset] +=  -staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ci) -staticContributions[admsNodeID_xf1].dx(admsProbeID_V_b_ci) +staticContributions[admsNodeID_xf1].dx(admsProbeID_V_ci_ei);
  dFdx[li_xf1][A_xf1_Equ_ei_NodeOffset] +=  -staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ei) -staticContributions[admsNodeID_xf1].dx(admsProbeID_V_ci_ei);
  dFdx[li_xf1][A_xf1_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_xf1].dx(admsProbeID_V_b_ci);
  dFdx[li_xf1][A_xf1_Equ_bi_NodeOffset] +=  +staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ei) +staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ci);
  dFdx[li_xf1][A_xf1_Equ_tnode_NodeOffset] +=  +staticContributions[admsNodeID_xf1].dx(admsProbeID_V_tnode_GND);
  dFdx[li_xf1][A_xf1_Equ_xf2_NodeOffset] +=  +staticContributions[admsNodeID_xf1].dx(admsProbeID_V_xf2_GND);
  dFdx[li_xf1][A_xf1_Equ_xf1_NodeOffset] +=  +staticContributions[admsNodeID_xf1].dx(admsProbeID_V_xf1_GND);
  dFdx[li_xf2][A_xf2_Equ_bi_NodeOffset] +=  +staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ei);
  dFdx[li_xf2][A_xf2_Equ_ei_NodeOffset] +=  -staticContributions[admsNodeID_xf2].dx(admsProbeID_V_ci_ei) -staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ei);
  dFdx[li_xf2][A_xf2_Equ_ci_NodeOffset] +=  -staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ci) -staticContributions[admsNodeID_xf2].dx(admsProbeID_V_b_ci) +staticContributions[admsNodeID_xf2].dx(admsProbeID_V_ci_ei);
  dFdx[li_xf2][A_xf2_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_xf2].dx(admsProbeID_V_b_ci);
  dFdx[li_xf2][A_xf2_Equ_tnode_NodeOffset] +=  +staticContributions[admsNodeID_xf2].dx(admsProbeID_V_tnode_GND);
  dFdx[li_xf2][A_xf2_Equ_xf1_NodeOffset] +=  +staticContributions[admsNodeID_xf2].dx(admsProbeID_V_xf1_GND);
  dFdx[li_xf2][A_xf2_Equ_xf2_NodeOffset] +=  +staticContributions[admsNodeID_xf2].dx(admsProbeID_V_xf2_GND);
  dFdx[li_xf][A_xf_Equ_ci_NodeOffset] +=  -staticContributions[admsNodeID_xf].dx(admsProbeID_V_bi_ci) -staticContributions[admsNodeID_xf].dx(admsProbeID_V_b_ci) +staticContributions[admsNodeID_xf].dx(admsProbeID_V_ci_ei);
  dFdx[li_xf][A_xf_Equ_ei_NodeOffset] +=  -staticContributions[admsNodeID_xf].dx(admsProbeID_V_bi_ei) -staticContributions[admsNodeID_xf].dx(admsProbeID_V_ci_ei);
  dFdx[li_xf][A_xf_Equ_bi_NodeOffset] +=  +staticContributions[admsNodeID_xf].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_xf].dx(admsProbeID_V_bi_ei);
  dFdx[li_xf][A_xf_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_xf].dx(admsProbeID_V_b_ci);
  dFdx[li_xf][A_xf_Equ_tnode_NodeOffset] +=  +staticContributions[admsNodeID_xf].dx(admsProbeID_V_tnode_GND);
  dFdx[li_xf][A_xf_Equ_xf_NodeOffset] +=  +staticContributions[admsNodeID_xf].dx(admsProbeID_V_xf_GND);

#endif
  
  return bsuccess;
}


//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdQdx
// Purpose       :
// Special Notes : Load the dQdx ("dynamic jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdQdx()
{
  bool bsuccess = true;
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*q_bi_Equ_bi_Node_Ptr) +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci) +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei);
  (*q_bi_Equ_ei_Node_Ptr) +=  -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei) -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ci_ei);
  (*q_ei_Equ_bi_Node_Ptr) +=  +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei) +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci);
  (*q_ei_Equ_ei_Node_Ptr) +=  -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei) -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei);
  (*q_bi_Equ_ci_Node_Ptr) +=  -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci) -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_ci) +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ci_ei);
  (*q_ci_Equ_bi_Node_Ptr) +=  +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei) +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci);
  (*q_ci_Equ_ci_Node_Ptr) +=  +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ci_ei) -dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_s_ci) -dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci) -dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_ci);
  (*q_ci_Equ_ei_Node_Ptr) +=  -dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ci_ei) -dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei);
  (*q_ei_Equ_ci_Node_Ptr) +=  +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei) -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci) -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_ci);
  (*q_b_Equ_ci_Node_Ptr) +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_ci) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_ci);
  (*q_s_Equ_s_Node_Ptr) +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_ci);
  (*q_s_Equ_ci_Node_Ptr) +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ci_ei) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_ci) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bi_ci) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_ci);
  (*q_b_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_ci);
  (*q_s_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_ci);
  (*q_b_Equ_tnode_Node_Ptr) +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_tnode_GND);
  (*q_s_Equ_tnode_Node_Ptr) +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_tnode_GND);
  (*q_s_Equ_bi_Node_Ptr) +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bi_ei) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bi_ci);
  (*q_s_Equ_ei_Node_Ptr) +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ci_ei) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bi_ei);
  (*q_ci_Equ_s_Node_Ptr) +=  +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_s_ci);
  (*q_ci_Equ_tnode_Node_Ptr) +=  +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_tnode_GND);
  (*q_ci_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_ci);
  (*q_b_Equ_bi_Node_Ptr) +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_ci);
  (*q_b_Equ_e_Node_Ptr) +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e);
  (*q_e_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e);
  (*q_e_Equ_e_Node_Ptr) +=  -dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e);
  (*q_ei_Equ_tnode_Node_Ptr) +=  +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_tnode_GND);
  (*q_bi_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_ci);
  (*q_bi_Equ_tnode_Node_Ptr) +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_tnode_GND);
  (*q_bi_Equ_xf_Node_Ptr) +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_xf_GND);
  (*q_ei_Equ_xf_Node_Ptr) +=  +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_xf_GND);
  (*q_ei_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_ci);
  (*q_tnode_Equ_tnode_Node_Ptr) +=  +dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_tnode_GND);
  (*q_xf1_Equ_xf1_Node_Ptr) +=  +dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_xf1_GND);
  (*q_xf2_Equ_xf2_Node_Ptr) +=  +dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_xf2_GND);
  (*q_xf_Equ_xf_Node_Ptr) +=  +dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_xf_GND);

#else
  //use the offsets instead of pointers
  dQdx[li_bi][A_bi_Equ_bi_NodeOffset] +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci) +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei);
  dQdx[li_bi][A_bi_Equ_ei_NodeOffset] +=  -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei) -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ci_ei);
  dQdx[li_ei][A_ei_Equ_bi_NodeOffset] +=  +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei) +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci);
  dQdx[li_ei][A_ei_Equ_ei_NodeOffset] +=  -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei) -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei);
  dQdx[li_bi][A_bi_Equ_ci_NodeOffset] +=  -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci) -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_ci) +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ci_ei);
  dQdx[li_ci][A_ci_Equ_bi_NodeOffset] +=  +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei) +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci);
  dQdx[li_ci][A_ci_Equ_ci_NodeOffset] +=  +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ci_ei) -dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_s_ci) -dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci) -dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_ci);
  dQdx[li_ci][A_ci_Equ_ei_NodeOffset] +=  -dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ci_ei) -dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei);
  dQdx[li_ei][A_ei_Equ_ci_NodeOffset] +=  +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei) -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci) -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_ci);
  dQdx[li_b][A_b_Equ_ci_NodeOffset] +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_ci) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_ci);
  dQdx[li_s][A_s_Equ_s_NodeOffset] +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_ci);
  dQdx[li_s][A_s_Equ_ci_NodeOffset] +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ci_ei) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_ci) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bi_ci) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_ci);
  dQdx[li_b][A_b_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_ci);
  dQdx[li_s][A_s_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_ci);
  dQdx[li_b][A_b_Equ_tnode_NodeOffset] +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_tnode_GND);
  dQdx[li_s][A_s_Equ_tnode_NodeOffset] +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_tnode_GND);
  dQdx[li_s][A_s_Equ_bi_NodeOffset] +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bi_ei) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bi_ci);
  dQdx[li_s][A_s_Equ_ei_NodeOffset] +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ci_ei) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bi_ei);
  dQdx[li_ci][A_ci_Equ_s_NodeOffset] +=  +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_s_ci);
  dQdx[li_ci][A_ci_Equ_tnode_NodeOffset] +=  +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_tnode_GND);
  dQdx[li_ci][A_ci_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_ci);
  dQdx[li_b][A_b_Equ_bi_NodeOffset] +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_ci);
  dQdx[li_b][A_b_Equ_e_NodeOffset] +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e);
  dQdx[li_e][A_e_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e);
  dQdx[li_e][A_e_Equ_e_NodeOffset] +=  -dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e);
  dQdx[li_ei][A_ei_Equ_tnode_NodeOffset] +=  +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_tnode_GND);
  dQdx[li_bi][A_bi_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_ci);
  dQdx[li_bi][A_bi_Equ_tnode_NodeOffset] +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_tnode_GND);
  dQdx[li_bi][A_bi_Equ_xf_NodeOffset] +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_xf_GND);
  dQdx[li_ei][A_ei_Equ_xf_NodeOffset] +=  +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_xf_GND);
  dQdx[li_ei][A_ei_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_ci);
  dQdx[li_tnode][A_tnode_Equ_tnode_NodeOffset] +=  +dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_tnode_GND);
  dQdx[li_xf1][A_xf1_Equ_xf1_NodeOffset] +=  +dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_xf1_GND);
  dQdx[li_xf2][A_xf2_Equ_xf2_NodeOffset] +=  +dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_xf2_GND);
  dQdx[li_xf][A_xf_Equ_xf_NodeOffset] +=  +dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_xf_GND);

  
#endif
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateTemperature
// Purpose       : Set temperature and update any parameters that depend on it
// Special Notes : In Xyce ADMS, we'll simply copy the temperature, which is
//                 in Kelvin, to our "admsTemperature" variable, which needs
//                 to be in Celsius.
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateTemperature(const double & temperatureTemp)
{

  admsTemperature = temperatureTemp;
  adms_vt_nom = adms_vt(temperatureTemp);

  return true;
}

// Class Model
//-----------------------------------------------------------------------------
// Function      : Model::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Model::processParams()
{

  // Set any non-constant parameter defaults:
  // Set any parameters that were not given and whose defaults depend on other
  // parameters:

  // set internal model type based on model card type
  if (getType() == "pnp" || getType() == "PNP")
    type = -1;



  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

  //    Parameter is : [ 0, 1 ]
  if ( (!((is >=0 && is <=1 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter is value " << is << " out of range [ 0, 1 ]";
  }

  //    Parameter mcf : ] 0, 10 ]
  if ( (!((mcf >0 && mcf <=10 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter mcf value " << mcf << " out of range ] 0, 10 ]";
  }

  //    Parameter mcr : ] 0, 10 ]
  if ( (!((mcr >0 && mcr <=10 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter mcr value " << mcr << " out of range ] 0, 10 ]";
  }

  //    Parameter vef : ] 0, 1.0e6 ]
  if ( (!((vef >0 && vef <=1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter vef value " << vef << " out of range ] 0, 1.0e6 ]";
  }

  //    Parameter ver : ] 0, 1.0e6 ]
  if ( (!((ver >0 && ver <=1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter ver value " << ver << " out of range ] 0, 1.0e6 ]";
  }

  //    Parameter aver : [ 0, 100 ]
  if ( (!((aver >=0 && aver <=100 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter aver value " << aver << " out of range [ 0, 100 ]";
  }

  //    Parameter iqf : ] 0, 1.0e6 ]
  if ( (!((iqf >0 && iqf <=1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter iqf value " << iqf << " out of range ] 0, 1.0e6 ]";
  }

  //    Parameter fiqf : [ 0, 1 ]
  if ( (!((fiqf >=0 && fiqf <=1 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter fiqf value " << fiqf << " out of range [ 0, 1 ]";
  }

  //    Parameter iqr : ] 0, 1.0e6 ]
  if ( (!((iqr >0 && iqr <=1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter iqr value " << iqr << " out of range ] 0, 1.0e6 ]";
  }

  //    Parameter iqfh : ] 0, 1.0e6 ]
  if ( (!((iqfh >0 && iqfh <=1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter iqfh value " << iqfh << " out of range ] 0, 1.0e6 ]";
  }

  //    Parameter tfh : [ 0, 1.0e6 [
  if ( (!((tfh >=0 && tfh <1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter tfh value " << tfh << " out of range [ 0, 1.0e6 [";
  }

  //    Parameter ahq : [ (-0.9), 1.0e6 ]
  if ( (!((ahq >=(-0.9) && ahq <=1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter ahq value " << ahq << " out of range [ (-0.9), 1.0e6 ]";
  }

  //    Parameter ibes : [ 0, 1 ]
  if ( (!((ibes >=0 && ibes <=1 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter ibes value " << ibes << " out of range [ 0, 1 ]";
  }

  //    Parameter mbe : ] 0, 10 ]
  if ( (!((mbe >0 && mbe <=10 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter mbe value " << mbe << " out of range ] 0, 10 ]";
  }

  //    Parameter ires : [ 0, 1 ]
  if ( (!((ires >=0 && ires <=1 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter ires value " << ires << " out of range [ 0, 1 ]";
  }

  //    Parameter mre : ] 0, 10 ]
  if ( (!((mre >0 && mre <=10 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter mre value " << mre << " out of range ] 0, 10 ]";
  }

  //    Parameter ibcs : [ 0, 1 ]
  if ( (!((ibcs >=0 && ibcs <=1 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter ibcs value " << ibcs << " out of range [ 0, 1 ]";
  }

  //    Parameter mbc : ] 0, 10 ]
  if ( (!((mbc >0 && mbc <=10 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter mbc value " << mbc << " out of range ] 0, 10 ]";
  }

  //    Parameter cje0 : ] 0, 1.0e6 [
  if ( (!((cje0 >0 && cje0 <1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter cje0 value " << cje0 << " out of range ] 0, 1.0e6 [";
  }

  //    Parameter vde : ] 0, 10 ]
  if ( (!((vde >0 && vde <=10 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter vde value " << vde << " out of range ] 0, 10 ]";
  }

  //    Parameter ze : ] 0, 1 [
  if ( (!((ze >0 && ze <1 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter ze value " << ze << " out of range ] 0, 1 [";
  }

  //    Parameter aje : [ 1, 1.0e6 [
  if ( (!((aje >=1 && aje <1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter aje value " << aje << " out of range [ 1, 1.0e6 [";
  }

  //    Parameter vdedc : ] 0, 10 ]
  if ( (!((vdedc >0 && vdedc <=10 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter vdedc value " << vdedc << " out of range ] 0, 10 ]";
  }

  //    Parameter zedc : ] 0, 2 [
  if ( (!((zedc >0 && zedc <2 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter zedc value " << zedc << " out of range ] 0, 2 [";
  }

  //    Parameter ajedc : [ 1, 1.0e6 [
  if ( (!((ajedc >=1 && ajedc <1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter ajedc value " << ajedc << " out of range [ 1, 1.0e6 [";
  }

  //    Parameter t0 : [ 0, 1.0e6 [
  if ( (!((t0 >=0 && t0 <1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter t0 value " << t0 << " out of range [ 0, 1.0e6 [";
  }

  //    Parameter tbvl : [ 0, 1.0e6 [
  if ( (!((tbvl >=0 && tbvl <1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter tbvl value " << tbvl << " out of range [ 0, 1.0e6 [";
  }

  //    Parameter tef0 : [ 0, 1.0e6 [
  if ( (!((tef0 >=0 && tef0 <1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter tef0 value " << tef0 << " out of range [ 0, 1.0e6 [";
  }

  //    Parameter gte : ] 0, 20 ]
  if ( (!((gte >0 && gte <=20 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter gte value " << gte << " out of range ] 0, 20 ]";
  }

  //    Parameter thcs : [ 0, 1.0e6 [
  if ( (!((thcs >=0 && thcs <1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter thcs value " << thcs << " out of range [ 0, 1.0e6 [";
  }

  //    Parameter ahc : ] 0, 10 ]
  if ( (!((ahc >0 && ahc <=10 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter ahc value " << ahc << " out of range ] 0, 10 ]";
  }

  //    Parameter tr : [ 0, 1.0e6 [
  if ( (!((tr >=0 && tr <1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter tr value " << tr << " out of range [ 0, 1.0e6 [";
  }

  //    Parameter rci0 : ] 0, 1.0e6 [
  if ( (!((rci0 >0 && rci0 <1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter rci0 value " << rci0 << " out of range ] 0, 1.0e6 [";
  }

  //    Parameter vlim : ] 0, 10 ]
  if ( (!((vlim >0 && vlim <=10 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter vlim value " << vlim << " out of range ] 0, 10 ]";
  }

  //    Parameter vpt : ] 0, 100 ]
  if ( (!((vpt >0 && vpt <=100 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter vpt value " << vpt << " out of range ] 0, 100 ]";
  }

  //    Parameter vces : [ 0, 1 ]
  if ( (!((vces >=0 && vces <=1 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter vces value " << vces << " out of range [ 0, 1 ]";
  }

  //    Parameter cjci0 : ] 0, 1.0e6 [
  if ( (!((cjci0 >0 && cjci0 <1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter cjci0 value " << cjci0 << " out of range ] 0, 1.0e6 [";
  }

  //    Parameter vdci : ] 0, 10 ]
  if ( (!((vdci >0 && vdci <=10 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter vdci value " << vdci << " out of range ] 0, 10 ]";
  }

  //    Parameter zci : ] 0, 1 ]
  if ( (!((zci >0 && zci <=1 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter zci value " << zci << " out of range ] 0, 1 ]";
  }

  //    Parameter vptci : ] 0, 100 ]
  if ( (!((vptci >0 && vptci <=100 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter vptci value " << vptci << " out of range ] 0, 100 ]";
  }

  //    Parameter cjcx0 : [ 0, 1.0e6 [
  if ( (!((cjcx0 >=0 && cjcx0 <1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter cjcx0 value " << cjcx0 << " out of range [ 0, 1.0e6 [";
  }

  //    Parameter vdcx : ] 0, 10 ]
  if ( (!((vdcx >0 && vdcx <=10 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter vdcx value " << vdcx << " out of range ] 0, 10 ]";
  }

  //    Parameter zcx : ] 0, 1 ]
  if ( (!((zcx >0 && zcx <=1 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter zcx value " << zcx << " out of range ] 0, 1 ]";
  }

  //    Parameter vptcx : ] 0, 100 ]
  if ( (!((vptcx >0 && vptcx <=100 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter vptcx value " << vptcx << " out of range ] 0, 100 ]";
  }

  //    Parameter fbc : [ 0, 1 ]
  if ( (!((fbc >=0 && fbc <=1 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter fbc value " << fbc << " out of range [ 0, 1 ]";
  }

  //    Parameter rbi0 : [ 0, 1.0e6 [
  if ( (!((rbi0 >=0 && rbi0 <1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter rbi0 value " << rbi0 << " out of range [ 0, 1.0e6 [";
  }

  //    Parameter vr0e : ] 0, 1.0e6 ]
  if ( (!((vr0e >0 && vr0e <=1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter vr0e value " << vr0e << " out of range ] 0, 1.0e6 ]";
  }

  //    Parameter vr0c : ] 0, 1.0e6 ]
  if ( (!((vr0c >0 && vr0c <=1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter vr0c value " << vr0c << " out of range ] 0, 1.0e6 ]";
  }

  //    Parameter fgeo : [ 0, 1.0e6 ]
  if ( (!((fgeo >=0 && fgeo <=1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter fgeo value " << fgeo << " out of range [ 0, 1.0e6 ]";
  }

  //    Parameter rbx : [ 0, 1.0e6 [
  if ( (!((rbx >=0 && rbx <1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter rbx value " << rbx << " out of range [ 0, 1.0e6 [";
  }

  //    Parameter rcx : [ 0, 1.0e6 [
  if ( (!((rcx >=0 && rcx <1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter rcx value " << rcx << " out of range [ 0, 1.0e6 [";
  }

  //    Parameter re : [ 0, 1.0e6 [
  if ( (!((re >=0 && re <1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter re value " << re << " out of range [ 0, 1.0e6 [";
  }

  //    Parameter itss : [ 0, 1.0 ]
  if ( (!((itss >=0 && itss <=1.0 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter itss value " << itss << " out of range [ 0, 1.0 ]";
  }

  //    Parameter msf : ] 0, 10 ]
  if ( (!((msf >0 && msf <=10 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter msf value " << msf << " out of range ] 0, 10 ]";
  }

  //    Parameter iscs : [ 0, 1.0 ]
  if ( (!((iscs >=0 && iscs <=1.0 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter iscs value " << iscs << " out of range [ 0, 1.0 ]";
  }

  //    Parameter msc : ] 0, 10 ]
  if ( (!((msc >0 && msc <=10 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter msc value " << msc << " out of range ] 0, 10 ]";
  }

  //    Parameter cjs0 : [ 0, 1.0e6 [
  if ( (!((cjs0 >=0 && cjs0 <1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter cjs0 value " << cjs0 << " out of range [ 0, 1.0e6 [";
  }

  //    Parameter vds : ] 0, 10 ]
  if ( (!((vds >0 && vds <=10 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter vds value " << vds << " out of range ] 0, 10 ]";
  }

  //    Parameter zs : ] 0, 1 ]
  if ( (!((zs >0 && zs <=1 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter zs value " << zs << " out of range ] 0, 1 ]";
  }

  //    Parameter vpts : ] 0, 100 ]
  if ( (!((vpts >0 && vpts <=100 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter vpts value " << vpts << " out of range ] 0, 100 ]";
  }

  //    Parameter cbcpar : [ 0, 1.0e6 [
  if ( (!((cbcpar >=0 && cbcpar <1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter cbcpar value " << cbcpar << " out of range [ 0, 1.0e6 [";
  }

  //    Parameter cbepar : [ 0, 1.0e6 [
  if ( (!((cbepar >=0 && cbepar <1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter cbepar value " << cbepar << " out of range [ 0, 1.0e6 [";
  }

  //    Parameter eavl : [ 0,  (+inf) [
  if ( (!((eavl >=0))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter eavl value " << eavl << " out of range [ 0,  (+inf) [";
  }

  //    Parameter kavl : [ 0, 1.0e6 [
  if ( (!((kavl >=0 && kavl <1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter kavl value " << kavl << " out of range [ 0, 1.0e6 [";
  }

  //    Parameter kf : [ 0, 1.0e6 [
  if ( (!((kf >=0 && kf <1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter kf value " << kf << " out of range [ 0, 1.0e6 [";
  }

  //    Parameter af : ] 0, 10 ]
  if ( (!((af >0 && af <=10 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter af value " << af << " out of range ] 0, 10 ]";
  }

  //    Parameter alqf : ] 0, 1 ]
  if ( (!((alqf >0 && alqf <=1 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter alqf value " << alqf << " out of range ] 0, 1 ]";
  }

  //    Parameter alit : ] 0, 1 ]
  if ( (!((alit >0 && alit <=1 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter alit value " << alit << " out of range ] 0, 1 ]";
  }

  //    Parameter flnqs : [ 0, 1 ]
  if ( (!((flnqs >=0 && flnqs <=1 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter flnqs value " << flnqs << " out of range [ 0, 1 ]";
  }

  //    Parameter vgb : ] 0, 10 ]
  if ( (!((vgb >0 && vgb <=10 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter vgb value " << vgb << " out of range ] 0, 10 ]";
  }

  //    Parameter vge : ] 0, 10 ]
  if ( (!((vge >0 && vge <=10 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter vge value " << vge << " out of range ] 0, 10 ]";
  }

  //    Parameter vgc : ] 0, 10 ]
  if ( (!((vgc >0 && vgc <=10 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter vgc value " << vgc << " out of range ] 0, 10 ]";
  }

  //    Parameter vgs : ] 0, 10 ]
  if ( (!((vgs >0 && vgs <=10 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter vgs value " << vgs << " out of range ] 0, 10 ]";
  }

  //    Parameter flsh : [ 0, 2 ]
  if ( (!((flsh >=0 && flsh <=2 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter flsh value " << flsh << " out of range [ 0, 2 ]";
  }

  //    Parameter rth : [ 0, 1.0e6 [
  if ( (!((rth >=0 && rth <1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter rth value " << rth << " out of range [ 0, 1.0e6 [";
  }

  //    Parameter cth : [ 0, 1.0e6 [
  if ( (!((cth >=0 && cth <1.0e6 ))) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter cth value " << cth << " out of range [ 0, 1.0e6 [";
  }

  //    Parameter type : [ (-1), 1 ]] 0, 0 [
  if ( (!((type >=(-1) && type <=1 )) || (type >0 && type <0 )) )
  {
    UserError0(*this) << "ADMShic0_full: Parameter type value " << type << " out of range [ (-1), 1 ] or  ] 0, 0 [";
  }

  // and of course, this routine is where we should put the initial_model
  // stuff


  return true;
}
//----------------------------------------------------------------------------
// Function      : Model::processInstanceParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//----------------------------------------------------------------------------
bool Model::processInstanceParams()
{

  std::vector<Instance*>::iterator iter;
  std::vector<Instance*>::iterator first = instanceContainer.begin();
  std::vector<Instance*>::iterator last  = instanceContainer.end();

  for (iter=first; iter!=last; ++iter)
  {
    (*iter)->processParams();
  }

  return true;
}

//-----------------------------------------------------------------------------
// Function      : Model::Model
// Purpose       : model block constructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::Model(
   const Configuration & configuration,
   const ModelBlock &    model_block,
   const FactoryBlock &  factory_block)
  : DeviceModel(model_block, configuration.getModelParameters(), factory_block),
    is(1.0e-16),
    it_mod(0),
    mcf(1.00),
    mcr(1.00),
    vef(1.0e6),
    ver(1.0e6),
    aver(0.0),
    iqf(1.0e6),
    fiqf(0),
    iqr(1.0e6),
    iqfh(1.0e6),
    tfh(0.0),
    ahq(0),
    ibes(1e-18),
    mbe(1.0),
    ires(0.0),
    mre(2.0),
    ibcs(0.0),
    mbc(1.0),
    cje0(1.0e-20),
    vde(0.9),
    ze(0.5),
    aje(2.5),
    vdedc(0.9),
    zedc(0.5),
    ajedc(2.5),
    t0(0.0),
    dt0h(0.0),
    tbvl(0.0),
    tef0(0.0),
    gte(1.0),
    thcs(0.0),
    ahc(0.1),
    tr(0.0),
    rci0(150),
    vlim(0.5),
    vpt(100),
    vces(0.1),
    cjci0(1.0e-20),
    vdci(0.7),
    zci(0.333),
    vptci(100),
    cjcx0(1.0e-20),
    vdcx(0.7),
    zcx(0.333),
    vptcx(100),
    fbc(1.0),
    rbi0(0.0),
    vr0e(2.5),
    vr0c(1.0e6),
    fgeo(0.656),
    rbx(0.0),
    rcx(0.0),
    re(0.0),
    itss(0.0),
    msf(1.0),
    iscs(0.0),
    msc(1.0),
    cjs0(1.0e-20),
    vds(0.3),
    zs(0.3),
    vpts(100),
    cbcpar(0.0),
    cbepar(0.0),
    eavl(0.0),
    kavl(0.0),
    kf(0.0),
    af(2.0),
    alqf(0.167),
    alit(0.333),
    flnqs(0),
    vgb(1.2),
    vge(1.17),
    vgc(1.17),
    vgs(1.17),
    f1vg((-1.02377e-4)),
    f2vg(4.3215e-4),
    alt0(0.0),
    kt0(0.0),
    zetact(3.0),
    zetabet(3.5),
    zetaci(0.0),
    alvs(0.0),
    alces(0.0),
    zetarbi(0.0),
    zetarbx(0.0),
    zetarcx(0.0),
    zetare(0.0),
    zetaiqf(0.0),
    alkav(0.0),
    aleav(0.0),
    zetarth(0.0),
    tef_temp(1),
    zetaver((-1.0)),
    zetavgbe(1.0),
    dvgbe(0.0),
    aliqfh(0),
    kiqfh(0),
    flsh(0),
    rth(0.0),
    cth(0.0),
    type(1),
    tnom(27)
{
  // Set params to constant default values (from parTable):
  setDefaultParams();

  // Set params according to .model line and constant defaults from metadata:
  setModParams(model_block.params);

  if (!given("XYCEADMSMODTEMP"))
    admsModTemp=getDeviceOptions().temp.getImmutableValue<double>();

  // Calculate any parameters specified as expressions:

  updateDependentParameters();

  // calculate dependent (ie computed) params and check for errors:
  processParams();
}

//-----------------------------------------------------------------------------
// Function      : Model::~Model
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::~Model()
{
  std::vector<Instance*>::iterator iterI;
  std::vector<Instance*>::iterator firstI = instanceContainer.begin ();
  std::vector<Instance*>::iterator lastI  = instanceContainer.end ();

  // loop over instances:
  for (iterI = firstI; iterI != lastI; ++iterI)
  {
    delete (*iterI);
  }
}

//-----------------------------------------------------------------------------
// Function      : Model::printOutInstances
// Purpose       : debugging tool.
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
std::ostream &Model::printOutInstances(std::ostream &os) const
{
  std::vector<Instance*>::const_iterator iter;
  std::vector<Instance*>::const_iterator first = instanceContainer.begin();
  std::vector<Instance*>::const_iterator last  = instanceContainer.end();

  int i;
  os << std::endl;
  os << "    name     model name  Parameters" << std::endl;
  for (i=0, iter=first; iter!=last; ++iter, ++i)
  {
    os << "  " << i << ": " << (*iter)->getName() << "      ";
    os << getName();

    os << std::endl;
    os << "DT  =  " << (*iter)->dt << std::endl;
    os << std::endl;
  }

  os << std::endl;

  return os;
}

//-----------------------------------------------------------------------------
// Function      : Model::forEachInstance
// Purpose       : 
// Special Notes :
// Scope         : public
// Creator       : David Baur
// Creation Date : 2/4/2014
//-----------------------------------------------------------------------------
/// Apply a device instance "op" to all instances associated with this
/// model
/// 
/// @param[in] op Operator to apply to all instances.
/// 
/// 
void Model::forEachInstance(DeviceInstanceOp &op) const /* override */ 
{
  for (std::vector<Instance *>::const_iterator it = instanceContainer.begin(); it != instanceContainer.end(); ++it)
    op(*it);
}

Device *Traits::factory(const Configuration &configuration, const FactoryBlock &factory_block)
{
  return new DeviceMaster<Traits>(configuration, factory_block, factory_block.solverState_, factory_block.deviceOptions_);
}

void registerDevice()
{
  Config<Traits>::addConfiguration()
    .registerDevice("q", 230)
    .registerModelType("npn", 230)
    .registerModelType("pnp", 230);
}



#ifdef Xyce_ADMS_SENSITIVITIES
//-----------------------------------------------------------------------------
// Function      : evaluateInitialInstance
// Purpose       : Evaluate the statements in the initial_instance block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
void evaluateInitialInstance(
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_dt,
   bool instancePar_given_dt,
   // instance variables
   // reals
   AdmsSensFadType & instanceVar_qjci,
   AdmsSensFadType & instanceVar_qjei,
   AdmsSensFadType & instanceVar_it,
   AdmsSensFadType & instanceVar_ijbc,
   AdmsSensFadType & instanceVar_iavl,
   AdmsSensFadType & instanceVar_ijsc,
   AdmsSensFadType & instanceVar_Ibici,
   AdmsSensFadType & instanceVar_ijbe,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_is,
   bool modelPar_given_is,
   AdmsSensFadType & modelPar_mcf,
   bool modelPar_given_mcf,
   AdmsSensFadType & modelPar_mcr,
   bool modelPar_given_mcr,
   AdmsSensFadType & modelPar_vef,
   bool modelPar_given_vef,
   AdmsSensFadType & modelPar_ver,
   bool modelPar_given_ver,
   AdmsSensFadType & modelPar_aver,
   bool modelPar_given_aver,
   AdmsSensFadType & modelPar_iqf,
   bool modelPar_given_iqf,
   AdmsSensFadType & modelPar_fiqf,
   bool modelPar_given_fiqf,
   AdmsSensFadType & modelPar_iqr,
   bool modelPar_given_iqr,
   AdmsSensFadType & modelPar_iqfh,
   bool modelPar_given_iqfh,
   AdmsSensFadType & modelPar_tfh,
   bool modelPar_given_tfh,
   AdmsSensFadType & modelPar_ahq,
   bool modelPar_given_ahq,
   AdmsSensFadType & modelPar_ibes,
   bool modelPar_given_ibes,
   AdmsSensFadType & modelPar_mbe,
   bool modelPar_given_mbe,
   AdmsSensFadType & modelPar_ires,
   bool modelPar_given_ires,
   AdmsSensFadType & modelPar_mre,
   bool modelPar_given_mre,
   AdmsSensFadType & modelPar_ibcs,
   bool modelPar_given_ibcs,
   AdmsSensFadType & modelPar_mbc,
   bool modelPar_given_mbc,
   AdmsSensFadType & modelPar_cje0,
   bool modelPar_given_cje0,
   AdmsSensFadType & modelPar_vde,
   bool modelPar_given_vde,
   AdmsSensFadType & modelPar_ze,
   bool modelPar_given_ze,
   AdmsSensFadType & modelPar_aje,
   bool modelPar_given_aje,
   AdmsSensFadType & modelPar_vdedc,
   bool modelPar_given_vdedc,
   AdmsSensFadType & modelPar_zedc,
   bool modelPar_given_zedc,
   AdmsSensFadType & modelPar_ajedc,
   bool modelPar_given_ajedc,
   AdmsSensFadType & modelPar_t0,
   bool modelPar_given_t0,
   AdmsSensFadType & modelPar_dt0h,
   bool modelPar_given_dt0h,
   AdmsSensFadType & modelPar_tbvl,
   bool modelPar_given_tbvl,
   AdmsSensFadType & modelPar_tef0,
   bool modelPar_given_tef0,
   AdmsSensFadType & modelPar_gte,
   bool modelPar_given_gte,
   AdmsSensFadType & modelPar_thcs,
   bool modelPar_given_thcs,
   AdmsSensFadType & modelPar_ahc,
   bool modelPar_given_ahc,
   AdmsSensFadType & modelPar_tr,
   bool modelPar_given_tr,
   AdmsSensFadType & modelPar_rci0,
   bool modelPar_given_rci0,
   AdmsSensFadType & modelPar_vlim,
   bool modelPar_given_vlim,
   AdmsSensFadType & modelPar_vpt,
   bool modelPar_given_vpt,
   AdmsSensFadType & modelPar_vces,
   bool modelPar_given_vces,
   AdmsSensFadType & modelPar_cjci0,
   bool modelPar_given_cjci0,
   AdmsSensFadType & modelPar_vdci,
   bool modelPar_given_vdci,
   AdmsSensFadType & modelPar_zci,
   bool modelPar_given_zci,
   AdmsSensFadType & modelPar_vptci,
   bool modelPar_given_vptci,
   AdmsSensFadType & modelPar_cjcx0,
   bool modelPar_given_cjcx0,
   AdmsSensFadType & modelPar_vdcx,
   bool modelPar_given_vdcx,
   AdmsSensFadType & modelPar_zcx,
   bool modelPar_given_zcx,
   AdmsSensFadType & modelPar_vptcx,
   bool modelPar_given_vptcx,
   AdmsSensFadType & modelPar_fbc,
   bool modelPar_given_fbc,
   AdmsSensFadType & modelPar_rbi0,
   bool modelPar_given_rbi0,
   AdmsSensFadType & modelPar_vr0e,
   bool modelPar_given_vr0e,
   AdmsSensFadType & modelPar_vr0c,
   bool modelPar_given_vr0c,
   AdmsSensFadType & modelPar_fgeo,
   bool modelPar_given_fgeo,
   AdmsSensFadType & modelPar_rbx,
   bool modelPar_given_rbx,
   AdmsSensFadType & modelPar_rcx,
   bool modelPar_given_rcx,
   AdmsSensFadType & modelPar_re,
   bool modelPar_given_re,
   AdmsSensFadType & modelPar_itss,
   bool modelPar_given_itss,
   AdmsSensFadType & modelPar_msf,
   bool modelPar_given_msf,
   AdmsSensFadType & modelPar_iscs,
   bool modelPar_given_iscs,
   AdmsSensFadType & modelPar_msc,
   bool modelPar_given_msc,
   AdmsSensFadType & modelPar_cjs0,
   bool modelPar_given_cjs0,
   AdmsSensFadType & modelPar_vds,
   bool modelPar_given_vds,
   AdmsSensFadType & modelPar_zs,
   bool modelPar_given_zs,
   AdmsSensFadType & modelPar_vpts,
   bool modelPar_given_vpts,
   AdmsSensFadType & modelPar_cbcpar,
   bool modelPar_given_cbcpar,
   AdmsSensFadType & modelPar_cbepar,
   bool modelPar_given_cbepar,
   AdmsSensFadType & modelPar_eavl,
   bool modelPar_given_eavl,
   AdmsSensFadType & modelPar_kavl,
   bool modelPar_given_kavl,
   AdmsSensFadType & modelPar_kf,
   bool modelPar_given_kf,
   AdmsSensFadType & modelPar_af,
   bool modelPar_given_af,
   AdmsSensFadType & modelPar_alqf,
   bool modelPar_given_alqf,
   AdmsSensFadType & modelPar_alit,
   bool modelPar_given_alit,
   AdmsSensFadType & modelPar_vgb,
   bool modelPar_given_vgb,
   AdmsSensFadType & modelPar_vge,
   bool modelPar_given_vge,
   AdmsSensFadType & modelPar_vgc,
   bool modelPar_given_vgc,
   AdmsSensFadType & modelPar_vgs,
   bool modelPar_given_vgs,
   AdmsSensFadType & modelPar_f1vg,
   bool modelPar_given_f1vg,
   AdmsSensFadType & modelPar_f2vg,
   bool modelPar_given_f2vg,
   AdmsSensFadType & modelPar_alt0,
   bool modelPar_given_alt0,
   AdmsSensFadType & modelPar_kt0,
   bool modelPar_given_kt0,
   AdmsSensFadType & modelPar_zetact,
   bool modelPar_given_zetact,
   AdmsSensFadType & modelPar_zetabet,
   bool modelPar_given_zetabet,
   AdmsSensFadType & modelPar_zetaci,
   bool modelPar_given_zetaci,
   AdmsSensFadType & modelPar_alvs,
   bool modelPar_given_alvs,
   AdmsSensFadType & modelPar_alces,
   bool modelPar_given_alces,
   AdmsSensFadType & modelPar_zetarbi,
   bool modelPar_given_zetarbi,
   AdmsSensFadType & modelPar_zetarbx,
   bool modelPar_given_zetarbx,
   AdmsSensFadType & modelPar_zetarcx,
   bool modelPar_given_zetarcx,
   AdmsSensFadType & modelPar_zetare,
   bool modelPar_given_zetare,
   AdmsSensFadType & modelPar_zetaiqf,
   bool modelPar_given_zetaiqf,
   AdmsSensFadType & modelPar_alkav,
   bool modelPar_given_alkav,
   AdmsSensFadType & modelPar_aleav,
   bool modelPar_given_aleav,
   AdmsSensFadType & modelPar_zetarth,
   bool modelPar_given_zetarth,
   AdmsSensFadType & modelPar_zetaver,
   bool modelPar_given_zetaver,
   AdmsSensFadType & modelPar_zetavgbe,
   bool modelPar_given_zetavgbe,
   AdmsSensFadType & modelPar_dvgbe,
   bool modelPar_given_dvgbe,
   AdmsSensFadType & modelPar_aliqfh,
   bool modelPar_given_aliqfh,
   AdmsSensFadType & modelPar_kiqfh,
   bool modelPar_given_kiqfh,
   AdmsSensFadType & modelPar_rth,
   bool modelPar_given_rth,
   AdmsSensFadType & modelPar_cth,
   bool modelPar_given_cth,
   AdmsSensFadType & modelPar_tnom,
   bool modelPar_given_tnom,
   // non-reals (including hidden)
   int modelPar_it_mod,
   bool modelPar_given_it_mod,
   int modelPar_flnqs,
   bool modelPar_given_flnqs,
   int modelPar_tef_temp,
   bool modelPar_given_tef_temp,
   int modelPar_flsh,
   bool modelPar_given_flsh,
   int modelPar_type,
   bool modelPar_given_type,
   double admsTemperature, double adms_vt_nom, double gmin, const Instance & theInstance)
{
}



//-----------------------------------------------------------------------------
// Function      : evaluateInitialModel
// Purpose       : Evaluate the statements in the initial_model block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
void evaluateInitialModel(
   // model parameters
   // reals
   AdmsSensFadType & modelPar_is,
   bool modelPar_given_is,
   AdmsSensFadType & modelPar_mcf,
   bool modelPar_given_mcf,
   AdmsSensFadType & modelPar_mcr,
   bool modelPar_given_mcr,
   AdmsSensFadType & modelPar_vef,
   bool modelPar_given_vef,
   AdmsSensFadType & modelPar_ver,
   bool modelPar_given_ver,
   AdmsSensFadType & modelPar_aver,
   bool modelPar_given_aver,
   AdmsSensFadType & modelPar_iqf,
   bool modelPar_given_iqf,
   AdmsSensFadType & modelPar_fiqf,
   bool modelPar_given_fiqf,
   AdmsSensFadType & modelPar_iqr,
   bool modelPar_given_iqr,
   AdmsSensFadType & modelPar_iqfh,
   bool modelPar_given_iqfh,
   AdmsSensFadType & modelPar_tfh,
   bool modelPar_given_tfh,
   AdmsSensFadType & modelPar_ahq,
   bool modelPar_given_ahq,
   AdmsSensFadType & modelPar_ibes,
   bool modelPar_given_ibes,
   AdmsSensFadType & modelPar_mbe,
   bool modelPar_given_mbe,
   AdmsSensFadType & modelPar_ires,
   bool modelPar_given_ires,
   AdmsSensFadType & modelPar_mre,
   bool modelPar_given_mre,
   AdmsSensFadType & modelPar_ibcs,
   bool modelPar_given_ibcs,
   AdmsSensFadType & modelPar_mbc,
   bool modelPar_given_mbc,
   AdmsSensFadType & modelPar_cje0,
   bool modelPar_given_cje0,
   AdmsSensFadType & modelPar_vde,
   bool modelPar_given_vde,
   AdmsSensFadType & modelPar_ze,
   bool modelPar_given_ze,
   AdmsSensFadType & modelPar_aje,
   bool modelPar_given_aje,
   AdmsSensFadType & modelPar_vdedc,
   bool modelPar_given_vdedc,
   AdmsSensFadType & modelPar_zedc,
   bool modelPar_given_zedc,
   AdmsSensFadType & modelPar_ajedc,
   bool modelPar_given_ajedc,
   AdmsSensFadType & modelPar_t0,
   bool modelPar_given_t0,
   AdmsSensFadType & modelPar_dt0h,
   bool modelPar_given_dt0h,
   AdmsSensFadType & modelPar_tbvl,
   bool modelPar_given_tbvl,
   AdmsSensFadType & modelPar_tef0,
   bool modelPar_given_tef0,
   AdmsSensFadType & modelPar_gte,
   bool modelPar_given_gte,
   AdmsSensFadType & modelPar_thcs,
   bool modelPar_given_thcs,
   AdmsSensFadType & modelPar_ahc,
   bool modelPar_given_ahc,
   AdmsSensFadType & modelPar_tr,
   bool modelPar_given_tr,
   AdmsSensFadType & modelPar_rci0,
   bool modelPar_given_rci0,
   AdmsSensFadType & modelPar_vlim,
   bool modelPar_given_vlim,
   AdmsSensFadType & modelPar_vpt,
   bool modelPar_given_vpt,
   AdmsSensFadType & modelPar_vces,
   bool modelPar_given_vces,
   AdmsSensFadType & modelPar_cjci0,
   bool modelPar_given_cjci0,
   AdmsSensFadType & modelPar_vdci,
   bool modelPar_given_vdci,
   AdmsSensFadType & modelPar_zci,
   bool modelPar_given_zci,
   AdmsSensFadType & modelPar_vptci,
   bool modelPar_given_vptci,
   AdmsSensFadType & modelPar_cjcx0,
   bool modelPar_given_cjcx0,
   AdmsSensFadType & modelPar_vdcx,
   bool modelPar_given_vdcx,
   AdmsSensFadType & modelPar_zcx,
   bool modelPar_given_zcx,
   AdmsSensFadType & modelPar_vptcx,
   bool modelPar_given_vptcx,
   AdmsSensFadType & modelPar_fbc,
   bool modelPar_given_fbc,
   AdmsSensFadType & modelPar_rbi0,
   bool modelPar_given_rbi0,
   AdmsSensFadType & modelPar_vr0e,
   bool modelPar_given_vr0e,
   AdmsSensFadType & modelPar_vr0c,
   bool modelPar_given_vr0c,
   AdmsSensFadType & modelPar_fgeo,
   bool modelPar_given_fgeo,
   AdmsSensFadType & modelPar_rbx,
   bool modelPar_given_rbx,
   AdmsSensFadType & modelPar_rcx,
   bool modelPar_given_rcx,
   AdmsSensFadType & modelPar_re,
   bool modelPar_given_re,
   AdmsSensFadType & modelPar_itss,
   bool modelPar_given_itss,
   AdmsSensFadType & modelPar_msf,
   bool modelPar_given_msf,
   AdmsSensFadType & modelPar_iscs,
   bool modelPar_given_iscs,
   AdmsSensFadType & modelPar_msc,
   bool modelPar_given_msc,
   AdmsSensFadType & modelPar_cjs0,
   bool modelPar_given_cjs0,
   AdmsSensFadType & modelPar_vds,
   bool modelPar_given_vds,
   AdmsSensFadType & modelPar_zs,
   bool modelPar_given_zs,
   AdmsSensFadType & modelPar_vpts,
   bool modelPar_given_vpts,
   AdmsSensFadType & modelPar_cbcpar,
   bool modelPar_given_cbcpar,
   AdmsSensFadType & modelPar_cbepar,
   bool modelPar_given_cbepar,
   AdmsSensFadType & modelPar_eavl,
   bool modelPar_given_eavl,
   AdmsSensFadType & modelPar_kavl,
   bool modelPar_given_kavl,
   AdmsSensFadType & modelPar_kf,
   bool modelPar_given_kf,
   AdmsSensFadType & modelPar_af,
   bool modelPar_given_af,
   AdmsSensFadType & modelPar_alqf,
   bool modelPar_given_alqf,
   AdmsSensFadType & modelPar_alit,
   bool modelPar_given_alit,
   AdmsSensFadType & modelPar_vgb,
   bool modelPar_given_vgb,
   AdmsSensFadType & modelPar_vge,
   bool modelPar_given_vge,
   AdmsSensFadType & modelPar_vgc,
   bool modelPar_given_vgc,
   AdmsSensFadType & modelPar_vgs,
   bool modelPar_given_vgs,
   AdmsSensFadType & modelPar_f1vg,
   bool modelPar_given_f1vg,
   AdmsSensFadType & modelPar_f2vg,
   bool modelPar_given_f2vg,
   AdmsSensFadType & modelPar_alt0,
   bool modelPar_given_alt0,
   AdmsSensFadType & modelPar_kt0,
   bool modelPar_given_kt0,
   AdmsSensFadType & modelPar_zetact,
   bool modelPar_given_zetact,
   AdmsSensFadType & modelPar_zetabet,
   bool modelPar_given_zetabet,
   AdmsSensFadType & modelPar_zetaci,
   bool modelPar_given_zetaci,
   AdmsSensFadType & modelPar_alvs,
   bool modelPar_given_alvs,
   AdmsSensFadType & modelPar_alces,
   bool modelPar_given_alces,
   AdmsSensFadType & modelPar_zetarbi,
   bool modelPar_given_zetarbi,
   AdmsSensFadType & modelPar_zetarbx,
   bool modelPar_given_zetarbx,
   AdmsSensFadType & modelPar_zetarcx,
   bool modelPar_given_zetarcx,
   AdmsSensFadType & modelPar_zetare,
   bool modelPar_given_zetare,
   AdmsSensFadType & modelPar_zetaiqf,
   bool modelPar_given_zetaiqf,
   AdmsSensFadType & modelPar_alkav,
   bool modelPar_given_alkav,
   AdmsSensFadType & modelPar_aleav,
   bool modelPar_given_aleav,
   AdmsSensFadType & modelPar_zetarth,
   bool modelPar_given_zetarth,
   AdmsSensFadType & modelPar_zetaver,
   bool modelPar_given_zetaver,
   AdmsSensFadType & modelPar_zetavgbe,
   bool modelPar_given_zetavgbe,
   AdmsSensFadType & modelPar_dvgbe,
   bool modelPar_given_dvgbe,
   AdmsSensFadType & modelPar_aliqfh,
   bool modelPar_given_aliqfh,
   AdmsSensFadType & modelPar_kiqfh,
   bool modelPar_given_kiqfh,
   AdmsSensFadType & modelPar_rth,
   bool modelPar_given_rth,
   AdmsSensFadType & modelPar_cth,
   bool modelPar_given_cth,
   AdmsSensFadType & modelPar_tnom,
   bool modelPar_given_tnom,
   // non-reals (including hidden)
   int modelPar_it_mod,
   bool modelPar_given_it_mod,
   int modelPar_flnqs,
   bool modelPar_given_flnqs,
   int modelPar_tef_temp,
   bool modelPar_given_tef_temp,
   int modelPar_flsh,
   bool modelPar_given_flsh,
   int modelPar_type,
   bool modelPar_given_type,
   double admsTemperature, double gmin, const Instance & theInstance)
{
}



//-----------------------------------------------------------------------------
// Function      : evaluateModelEquations
// Purpose       : Evaluate the main module block.  Similar to
//                 updateIntermediateVars, but takes all instance and model
//                 parameters and variables as arguments instead of using
//                 the ones stored in the objects.
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
void evaluateModelEquations(
   std::vector <double> & probeVars,
   // probe constants
   const int admsProbeID_V_xf_GND,
   const int admsProbeID_V_xf2_GND,
   const int admsProbeID_V_xf1_GND,
   const int admsProbeID_V_tnode_GND,
   const int admsProbeID_V_b_e,
   const int admsProbeID_V_b_bi,
   const int admsProbeID_V_ci_c,
   const int admsProbeID_V_ei_e,
   const int admsProbeID_V_s_ci,
   const int admsProbeID_V_ci_ei,
   const int admsProbeID_V_bi_ei,
   const int admsProbeID_V_bi_ci,
   const int admsProbeID_V_b_ci,
   // node constants
   const int admsNodeID_c,
   const int admsNodeID_b,
   const int admsNodeID_e,
   const int admsNodeID_s,
   const int admsNodeID_tnode,
   const int admsNodeID_ci,
   const int admsNodeID_bi,
   const int admsNodeID_ei,
   const int admsNodeID_xf1,
   const int admsNodeID_xf2,
   const int admsNodeID_xf,
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_dt,
   bool instancePar_given_dt,
   // instance variables
   // reals
   AdmsSensFadType & instanceVar_qjci,
   AdmsSensFadType & instanceVar_qjei,
   AdmsSensFadType & instanceVar_it,
   AdmsSensFadType & instanceVar_ijbc,
   AdmsSensFadType & instanceVar_iavl,
   AdmsSensFadType & instanceVar_ijsc,
   AdmsSensFadType & instanceVar_Ibici,
   AdmsSensFadType & instanceVar_ijbe,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_is,
   bool modelPar_given_is,
   AdmsSensFadType & modelPar_mcf,
   bool modelPar_given_mcf,
   AdmsSensFadType & modelPar_mcr,
   bool modelPar_given_mcr,
   AdmsSensFadType & modelPar_vef,
   bool modelPar_given_vef,
   AdmsSensFadType & modelPar_ver,
   bool modelPar_given_ver,
   AdmsSensFadType & modelPar_aver,
   bool modelPar_given_aver,
   AdmsSensFadType & modelPar_iqf,
   bool modelPar_given_iqf,
   AdmsSensFadType & modelPar_fiqf,
   bool modelPar_given_fiqf,
   AdmsSensFadType & modelPar_iqr,
   bool modelPar_given_iqr,
   AdmsSensFadType & modelPar_iqfh,
   bool modelPar_given_iqfh,
   AdmsSensFadType & modelPar_tfh,
   bool modelPar_given_tfh,
   AdmsSensFadType & modelPar_ahq,
   bool modelPar_given_ahq,
   AdmsSensFadType & modelPar_ibes,
   bool modelPar_given_ibes,
   AdmsSensFadType & modelPar_mbe,
   bool modelPar_given_mbe,
   AdmsSensFadType & modelPar_ires,
   bool modelPar_given_ires,
   AdmsSensFadType & modelPar_mre,
   bool modelPar_given_mre,
   AdmsSensFadType & modelPar_ibcs,
   bool modelPar_given_ibcs,
   AdmsSensFadType & modelPar_mbc,
   bool modelPar_given_mbc,
   AdmsSensFadType & modelPar_cje0,
   bool modelPar_given_cje0,
   AdmsSensFadType & modelPar_vde,
   bool modelPar_given_vde,
   AdmsSensFadType & modelPar_ze,
   bool modelPar_given_ze,
   AdmsSensFadType & modelPar_aje,
   bool modelPar_given_aje,
   AdmsSensFadType & modelPar_vdedc,
   bool modelPar_given_vdedc,
   AdmsSensFadType & modelPar_zedc,
   bool modelPar_given_zedc,
   AdmsSensFadType & modelPar_ajedc,
   bool modelPar_given_ajedc,
   AdmsSensFadType & modelPar_t0,
   bool modelPar_given_t0,
   AdmsSensFadType & modelPar_dt0h,
   bool modelPar_given_dt0h,
   AdmsSensFadType & modelPar_tbvl,
   bool modelPar_given_tbvl,
   AdmsSensFadType & modelPar_tef0,
   bool modelPar_given_tef0,
   AdmsSensFadType & modelPar_gte,
   bool modelPar_given_gte,
   AdmsSensFadType & modelPar_thcs,
   bool modelPar_given_thcs,
   AdmsSensFadType & modelPar_ahc,
   bool modelPar_given_ahc,
   AdmsSensFadType & modelPar_tr,
   bool modelPar_given_tr,
   AdmsSensFadType & modelPar_rci0,
   bool modelPar_given_rci0,
   AdmsSensFadType & modelPar_vlim,
   bool modelPar_given_vlim,
   AdmsSensFadType & modelPar_vpt,
   bool modelPar_given_vpt,
   AdmsSensFadType & modelPar_vces,
   bool modelPar_given_vces,
   AdmsSensFadType & modelPar_cjci0,
   bool modelPar_given_cjci0,
   AdmsSensFadType & modelPar_vdci,
   bool modelPar_given_vdci,
   AdmsSensFadType & modelPar_zci,
   bool modelPar_given_zci,
   AdmsSensFadType & modelPar_vptci,
   bool modelPar_given_vptci,
   AdmsSensFadType & modelPar_cjcx0,
   bool modelPar_given_cjcx0,
   AdmsSensFadType & modelPar_vdcx,
   bool modelPar_given_vdcx,
   AdmsSensFadType & modelPar_zcx,
   bool modelPar_given_zcx,
   AdmsSensFadType & modelPar_vptcx,
   bool modelPar_given_vptcx,
   AdmsSensFadType & modelPar_fbc,
   bool modelPar_given_fbc,
   AdmsSensFadType & modelPar_rbi0,
   bool modelPar_given_rbi0,
   AdmsSensFadType & modelPar_vr0e,
   bool modelPar_given_vr0e,
   AdmsSensFadType & modelPar_vr0c,
   bool modelPar_given_vr0c,
   AdmsSensFadType & modelPar_fgeo,
   bool modelPar_given_fgeo,
   AdmsSensFadType & modelPar_rbx,
   bool modelPar_given_rbx,
   AdmsSensFadType & modelPar_rcx,
   bool modelPar_given_rcx,
   AdmsSensFadType & modelPar_re,
   bool modelPar_given_re,
   AdmsSensFadType & modelPar_itss,
   bool modelPar_given_itss,
   AdmsSensFadType & modelPar_msf,
   bool modelPar_given_msf,
   AdmsSensFadType & modelPar_iscs,
   bool modelPar_given_iscs,
   AdmsSensFadType & modelPar_msc,
   bool modelPar_given_msc,
   AdmsSensFadType & modelPar_cjs0,
   bool modelPar_given_cjs0,
   AdmsSensFadType & modelPar_vds,
   bool modelPar_given_vds,
   AdmsSensFadType & modelPar_zs,
   bool modelPar_given_zs,
   AdmsSensFadType & modelPar_vpts,
   bool modelPar_given_vpts,
   AdmsSensFadType & modelPar_cbcpar,
   bool modelPar_given_cbcpar,
   AdmsSensFadType & modelPar_cbepar,
   bool modelPar_given_cbepar,
   AdmsSensFadType & modelPar_eavl,
   bool modelPar_given_eavl,
   AdmsSensFadType & modelPar_kavl,
   bool modelPar_given_kavl,
   AdmsSensFadType & modelPar_kf,
   bool modelPar_given_kf,
   AdmsSensFadType & modelPar_af,
   bool modelPar_given_af,
   AdmsSensFadType & modelPar_alqf,
   bool modelPar_given_alqf,
   AdmsSensFadType & modelPar_alit,
   bool modelPar_given_alit,
   AdmsSensFadType & modelPar_vgb,
   bool modelPar_given_vgb,
   AdmsSensFadType & modelPar_vge,
   bool modelPar_given_vge,
   AdmsSensFadType & modelPar_vgc,
   bool modelPar_given_vgc,
   AdmsSensFadType & modelPar_vgs,
   bool modelPar_given_vgs,
   AdmsSensFadType & modelPar_f1vg,
   bool modelPar_given_f1vg,
   AdmsSensFadType & modelPar_f2vg,
   bool modelPar_given_f2vg,
   AdmsSensFadType & modelPar_alt0,
   bool modelPar_given_alt0,
   AdmsSensFadType & modelPar_kt0,
   bool modelPar_given_kt0,
   AdmsSensFadType & modelPar_zetact,
   bool modelPar_given_zetact,
   AdmsSensFadType & modelPar_zetabet,
   bool modelPar_given_zetabet,
   AdmsSensFadType & modelPar_zetaci,
   bool modelPar_given_zetaci,
   AdmsSensFadType & modelPar_alvs,
   bool modelPar_given_alvs,
   AdmsSensFadType & modelPar_alces,
   bool modelPar_given_alces,
   AdmsSensFadType & modelPar_zetarbi,
   bool modelPar_given_zetarbi,
   AdmsSensFadType & modelPar_zetarbx,
   bool modelPar_given_zetarbx,
   AdmsSensFadType & modelPar_zetarcx,
   bool modelPar_given_zetarcx,
   AdmsSensFadType & modelPar_zetare,
   bool modelPar_given_zetare,
   AdmsSensFadType & modelPar_zetaiqf,
   bool modelPar_given_zetaiqf,
   AdmsSensFadType & modelPar_alkav,
   bool modelPar_given_alkav,
   AdmsSensFadType & modelPar_aleav,
   bool modelPar_given_aleav,
   AdmsSensFadType & modelPar_zetarth,
   bool modelPar_given_zetarth,
   AdmsSensFadType & modelPar_zetaver,
   bool modelPar_given_zetaver,
   AdmsSensFadType & modelPar_zetavgbe,
   bool modelPar_given_zetavgbe,
   AdmsSensFadType & modelPar_dvgbe,
   bool modelPar_given_dvgbe,
   AdmsSensFadType & modelPar_aliqfh,
   bool modelPar_given_aliqfh,
   AdmsSensFadType & modelPar_kiqfh,
   bool modelPar_given_kiqfh,
   AdmsSensFadType & modelPar_rth,
   bool modelPar_given_rth,
   AdmsSensFadType & modelPar_cth,
   bool modelPar_given_cth,
   AdmsSensFadType & modelPar_tnom,
   bool modelPar_given_tnom,
   // non-reals (including hidden)
   int modelPar_it_mod,
   bool modelPar_given_it_mod,
   int modelPar_flnqs,
   bool modelPar_given_flnqs,
   int modelPar_tef_temp,
   bool modelPar_given_tef_temp,
   int modelPar_flsh,
   bool modelPar_given_flsh,
   int modelPar_type,
   bool modelPar_given_type,
   // basic variables
   double admsTemperature, double adms_vt_nom, double gmin, std::vector <AdmsSensFadType> & staticContributions, std::vector <AdmsSensFadType> & dynamicContributions, const Instance & theInstance)
{

  // Local variables
  AdmsSensFadType flicker_Pwr;
  double twoq;
  AdmsSensFadType fourkt;
  AdmsSensFadType it_wop;
  AdmsSensFadType Qbiei;
  AdmsSensFadType Qbici;
  AdmsSensFadType Qbe;
  AdmsSensFadType Qbci;
  AdmsSensFadType Qxf;
  AdmsSensFadType Ixf;
  AdmsSensFadType fact;
  double Vxf;
  AdmsSensFadType Qxf2;
  AdmsSensFadType Qxf1;
  AdmsSensFadType Ixf2;
  AdmsSensFadType Ixf1;
  double Vxf2;
  double Vxf1;
  AdmsSensFadType Qdeix;
  AdmsSensFadType Itxf;
  AdmsSensFadType pterm;
  AdmsSensFadType qjs;
  AdmsSensFadType HSI_Tsu;
  AdmsSensFadType HSb;
  AdmsSensFadType HSa;
  AdmsSensFadType HSUM;
  AdmsSensFadType rb;
  AdmsSensFadType eta;
  AdmsSensFadType rbi;
  AdmsSensFadType fQz;
  AdmsSensFadType Qz_nom;
  AdmsSensFadType a_iavl;
  AdmsSensFadType lncc;
  AdmsSensFadType v_bord;
  AdmsSensFadType ibi;
  AdmsSensFadType ire;
  AdmsSensFadType ibe;
  AdmsSensFadType le;
  AdmsSensFadType DIOY;
  AdmsSensFadType qr;
  AdmsSensFadType tf;
  AdmsSensFadType qf;
  AdmsSensFadType dqef;
  AdmsSensFadType dtef;
  AdmsSensFadType dtfh;
  AdmsSensFadType dqfh;
  AdmsSensFadType tww;
  AdmsSensFadType w;
  AdmsSensFadType s3;
  AdmsSensFadType qf0;
  AdmsSensFadType itr;
  AdmsSensFadType itf;
  AdmsSensFadType qpt;
  AdmsSensFadType qm;
  AdmsSensFadType q_p3;
  AdmsSensFadType tmp2;
  AdmsSensFadType tmp3;
  AdmsSensFadType p2_u;
  AdmsSensFadType p2_v;
  AdmsSensFadType p2_D;
  AdmsSensFadType p2_q;
  AdmsSensFadType p2_p;
  AdmsSensFadType tmp;
  AdmsSensFadType p2_c;
  AdmsSensFadType p2_b;
  AdmsSensFadType p2_a;
  double o3;
  AdmsSensFadType wdc;
  AdmsSensFadType aa;
  AdmsSensFadType a2;
  AdmsSensFadType a1;
  AdmsSensFadType diff_q;
  AdmsSensFadType qpt_h;
  AdmsSensFadType qpt_l;
  AdmsSensFadType qmh;
  AdmsSensFadType qml;
  AdmsSensFadType itri;
  AdmsSensFadType le2;
  AdmsSensFadType arg2;
  AdmsSensFadType itfi;
  AdmsSensFadType le1;
  AdmsSensFadType arg1;
  AdmsSensFadType ickr;
  AdmsSensFadType ickf;
  AdmsSensFadType denom_iqf;
  AdmsSensFadType tf0;
  AdmsSensFadType qj_2;
  AdmsSensFadType b_q;
  AdmsSensFadType qj;
  AdmsSensFadType qje;
  AdmsSensFadType h_vbe;
  AdmsSensFadType vj_z;
  AdmsSensFadType vjh;
  AdmsSensFadType cc;
  AdmsSensFadType ick;
  AdmsSensFadType vceff;
  AdmsSensFadType uvc;
  AdmsSensFadType vc;
  AdmsSensFadType cjcii;
  AdmsSensFadType dvj;
  AdmsSensFadType qjcii;
  AdmsSensFadType qjci_int;
  AdmsSensFadType qjcx;
  AdmsSensFadType qj3;
  AdmsSensFadType qj2;
  AdmsSensFadType qj1;
  AdmsSensFadType vdj2;
  AdmsSensFadType vdj1;
  AdmsSensFadType ezr;
  AdmsSensFadType ez;
  AdmsSensFadType vj4;
  AdmsSensFadType vj2;
  AdmsSensFadType vr;
  AdmsSensFadType vj1;
  AdmsSensFadType ee1;
  AdmsSensFadType ex1;
  AdmsSensFadType ve;
  AdmsSensFadType a;
  AdmsSensFadType cr;
  AdmsSensFadType cmax;
  AdmsSensFadType vf;
  AdmsSensFadType vp;
  AdmsSensFadType zr;
  AdmsSensFadType y;
  AdmsSensFadType x;
  AdmsSensFadType v_j;
  AdmsSensFadType xvf2;
  AdmsSensFadType xvf;
  AdmsSensFadType cjcx0_t_i;
  AdmsSensFadType qjcxi;
  AdmsSensFadType cjci0_t_ii;
  AdmsSensFadType cjcx0_t_ii;
  AdmsSensFadType ahq_t;
  AdmsSensFadType tfh_t;
  AdmsSensFadType iqfh_t;
  AdmsSensFadType ver_t;
  AdmsSensFadType aver_t;
  AdmsSensFadType rth_t;
  AdmsSensFadType kavl_t;
  AdmsSensFadType eavl_t;
  AdmsSensFadType re_t;
  AdmsSensFadType rbi0_t;
  AdmsSensFadType rcx_t;
  AdmsSensFadType rbx_t;
  AdmsSensFadType tef0_t;
  AdmsSensFadType dvg;
  AdmsSensFadType zetatef;
  AdmsSensFadType thcs_t;
  AdmsSensFadType t0_t;
  AdmsSensFadType vces_t;
  AdmsSensFadType vlim_t;
  AdmsSensFadType rci0_t;
  AdmsSensFadType iqf_t;
  AdmsSensFadType cjs0_t;
  AdmsSensFadType vds_t;
  AdmsSensFadType cjcx0_t;
  AdmsSensFadType vdcx_t;
  AdmsSensFadType cjci0_t;
  AdmsSensFadType vdci_t;
  AdmsSensFadType ajedc_t;
  AdmsSensFadType aje_t;
  AdmsSensFadType cje0_dc_t;
  AdmsSensFadType vdedc_t;
  AdmsSensFadType cje0_dc;
  AdmsSensFadType cje0_t;
  AdmsSensFadType vde_t;
  AdmsSensFadType vdjt;
  AdmsSensFadType vdj0;
  AdmsSensFadType arg;
  AdmsSensFadType iscs_t;
  AdmsSensFadType itss_t;
  AdmsSensFadType ibcs_t;
  AdmsSensFadType ires_t;
  AdmsSensFadType ibes_t;
  AdmsSensFadType is_t;
  AdmsSensFadType zetasct;
  AdmsSensFadType zetabci;
  AdmsSensFadType mg;
  AdmsSensFadType vgsc;
  AdmsSensFadType vgbc;
  AdmsSensFadType vgbe;
  AdmsSensFadType avs;
  AdmsSensFadType ln_qtt0;
  AdmsSensFadType qtt0;
  AdmsSensFadType dT;
  AdmsSensFadType VT;
  AdmsSensFadType vt0;
  AdmsSensFadType Tdev;
  double Tamb;
  AdmsSensFadType Tnom;
  double Vrth;
  AdmsSensFadType Vbe;
  double Vbbi;
  double Vcic;
  double Veie;
  AdmsSensFadType Vsci;
  AdmsSensFadType Vciei;
  AdmsSensFadType Vbiei;
  AdmsSensFadType Vbici;
  AdmsSensFadType Vbci;
  AdmsSensFadType HICUMtype;


  // -- code converted from analog/code block
  HICUMtype = modelPar_type;
  Vbci = (HICUMtype*(probeVars[admsProbeID_V_b_ci]));
  Vbici = (HICUMtype*(probeVars[admsProbeID_V_bi_ci]));
  Vbiei = (HICUMtype*(probeVars[admsProbeID_V_bi_ei]));
  Vciei = (HICUMtype*(probeVars[admsProbeID_V_ci_ei]));
  Vsci = (HICUMtype*(probeVars[admsProbeID_V_s_ci]));
  Veie = (probeVars[admsProbeID_V_ei_e]);
  Vcic = (probeVars[admsProbeID_V_ci_c]);
  Vbbi = (probeVars[admsProbeID_V_b_bi]);
  Vbe = (HICUMtype*(probeVars[admsProbeID_V_b_e]));
  Vrth = (probeVars[admsProbeID_V_tnode_GND]);
  Tnom = (modelPar_tnom+273.15);
  Tamb = admsTemperature;
  Tdev = ((Tamb+instancePar_dt)+Vrth);
  if ((Tdev<((-100.00)+273.15)))
  {
    Tdev = ((-100.00)+273.15);
  }
  else
  {
    if ((Tdev>(326.85+273.15)))
    {
      Tdev = (326.85+273.15);
    }
  }
  vt0 = ((1.3806503e-23*Tnom)/1.6021766208e-19);
  VT = ((1.3806503e-23*Tdev)/1.6021766208e-19);
  dT = (Tdev-Tnom);
  qtt0 = (Tdev/Tnom);
  ln_qtt0 = log(qtt0);
  avs = (modelPar_alvs*Tnom);
  vgbe = ((modelPar_vgb+modelPar_vge)/2);
  vgbc = ((modelPar_vgb+modelPar_vgc)/2);
  vgsc = ((modelPar_vgs+modelPar_vgc)/2);
  mg = (3-((1.6021766208e-19*modelPar_f1vg)/1.3806503e-23));
  zetabci = ((mg+1)-modelPar_zetaci);
  zetasct = (mg-1.5);
  is_t = (modelPar_is*exp(((modelPar_zetact*ln_qtt0)+((modelPar_vgb/VT)*(qtt0-1)))));
  ibes_t = (modelPar_ibes*exp(((modelPar_zetabet*ln_qtt0)+((modelPar_vge/VT)*(qtt0-1)))));
  ires_t = (modelPar_ires*exp((((0.5*mg)*ln_qtt0)+(((0.5*vgbe)/VT)*(qtt0-1)))));
  ibcs_t = (modelPar_ibcs*exp(((zetabci*ln_qtt0)+((modelPar_vgc/VT)*(qtt0-1)))));
  itss_t = (modelPar_itss*exp(((zetasct*ln_qtt0)+((modelPar_vgc/VT)*(qtt0-1)))));
  iscs_t = (modelPar_iscs*exp(((zetasct*ln_qtt0)+((modelPar_vgs/VT)*(qtt0-1)))));
  arg = ((0.5*modelPar_vde)/vt0);
  vdj0 = ((2*vt0)*log((exp(arg)-exp((-arg)))));
  vdjt = (((vdj0*qtt0)+(vgbe*(1-qtt0)))-((mg*VT)*ln_qtt0));
  vde_t = (vdjt+((2*VT)*log((0.5*(1+sqrt((1+(4*exp(((-vdjt)/VT))))))))));
  cje0_t = (modelPar_cje0*exp((modelPar_ze*log((modelPar_vde/vde_t)))));
  cje0_dc = modelPar_cje0;
  arg = ((0.5*modelPar_vdedc)/vt0);
  vdj0 = ((2*vt0)*log((exp(arg)-exp((-arg)))));
  vdjt = (((vdj0*qtt0)+(vgbe*(1-qtt0)))-((mg*VT)*ln_qtt0));
  vdedc_t = (vdjt+((2*VT)*log((0.5*(1+sqrt((1+(4*exp(((-vdjt)/VT))))))))));
  cje0_dc_t = (cje0_dc*exp((modelPar_zedc*log((modelPar_vdedc/vdedc_t)))));
  aje_t = ((modelPar_aje*vde_t)/modelPar_vde);
  ajedc_t = ((modelPar_ajedc*vdedc_t)/modelPar_vdedc);
  arg = ((0.5*modelPar_vdci)/vt0);
  vdj0 = ((2*vt0)*log((exp(arg)-exp((-arg)))));
  vdjt = (((vdj0*qtt0)+(vgbc*(1-qtt0)))-((mg*VT)*ln_qtt0));
  vdci_t = (vdjt+((2*VT)*log((0.5*(1+sqrt((1+(4*exp(((-vdjt)/VT))))))))));
  cjci0_t = (modelPar_cjci0*exp((modelPar_zci*log((modelPar_vdci/vdci_t)))));
  arg = ((0.5*modelPar_vdcx)/vt0);
  vdj0 = ((2*vt0)*log((exp(arg)-exp((-arg)))));
  vdjt = (((vdj0*qtt0)+(vgbc*(1-qtt0)))-((mg*VT)*ln_qtt0));
  vdcx_t = (vdjt+((2*VT)*log((0.5*(1+sqrt((1+(4*exp(((-vdjt)/VT))))))))));
  cjcx0_t = (modelPar_cjcx0*exp((modelPar_zcx*log((modelPar_vdcx/vdcx_t)))));
  arg = ((0.5*modelPar_vds)/vt0);
  vdj0 = ((2*vt0)*log((exp(arg)-exp((-arg)))));
  vdjt = (((vdj0*qtt0)+(vgsc*(1-qtt0)))-((mg*VT)*ln_qtt0));
  vds_t = (vdjt+((2*VT)*log((0.5*(1+sqrt((1+(4*exp(((-vdjt)/VT))))))))));
  cjs0_t = (modelPar_cjs0*exp((modelPar_zs*log((modelPar_vds/vds_t)))));
  iqf_t = (modelPar_iqf*exp(((modelPar_zetaiqf*ln_qtt0)-((modelPar_dvgbe/VT)*(qtt0-1)))));
  rci0_t = (modelPar_rci0*exp((modelPar_zetaci*ln_qtt0)));
  vlim_t = (modelPar_vlim*exp(((modelPar_zetaci-avs)*ln_qtt0)));
  vces_t = (modelPar_vces*(1+(modelPar_alces*dT)));
  t0_t = (modelPar_t0*((1+(modelPar_alt0*dT))+((modelPar_kt0*dT)*dT)));
  thcs_t = (modelPar_thcs*exp(((modelPar_zetaci-1)*ln_qtt0)));
  zetatef = ((modelPar_zetabet-modelPar_zetact)-0.5);
  dvg = (modelPar_vgb-modelPar_vge);
  if ((modelPar_tef_temp==1))
  {
    tef0_t = (modelPar_tef0*exp(((zetatef*ln_qtt0)-((dvg/VT)*(qtt0-1)))));
  }
  else
  {
    tef0_t = modelPar_tef0;
  }
  rbx_t = (modelPar_rbx*exp((modelPar_zetarbx*ln_qtt0)));
  rcx_t = (modelPar_rcx*exp((modelPar_zetarcx*ln_qtt0)));
  rbi0_t = (modelPar_rbi0*exp((modelPar_zetarbi*ln_qtt0)));
  re_t = (modelPar_re*exp((modelPar_zetare*ln_qtt0)));
  eavl_t = (modelPar_eavl*exp((modelPar_aleav*dT)));
  kavl_t = (modelPar_kavl*exp((modelPar_alkav*dT)));
  if ((modelPar_zetarth!=0))
  {
    rth_t = (modelPar_rth*exp((modelPar_zetarth*log((Tdev/Tnom)))));
  }
  else
  {
    rth_t = modelPar_rth;
  }
  aver_t = (modelPar_aver*exp((modelPar_zetaver*ln_qtt0)));
  ver_t = (modelPar_ver/exp(((modelPar_dvgbe/VT)*(exp((modelPar_zetavgbe*ln_qtt0))-1))));
  iqfh_t = (modelPar_iqfh*((1+(modelPar_aliqfh*dT))+((modelPar_kiqfh*dT)*dT)));
  tfh_t = ((modelPar_tfh*((1+(modelPar_aliqfh*dT))+((modelPar_kiqfh*dT)*dT)))*exp((((modelPar_vgb-modelPar_vge)/VT)*(qtt0-1))));
  ahq_t = modelPar_ahq;
  if ((cjcx0_t==0))
  {
    cjci0_t_ii = (cjci0_t*modelPar_fbc);
    qjcxi = 0;
    cjcx0_t_i = (cjci0_t*(1-modelPar_fbc));
    if ((modelPar_vptci<1.0e2))
    {
      if ((cjcx0_t_i>0.0))
      {
        zr = (modelPar_zci/4.0);
        vp = (modelPar_vptci-vdci_t);
        vf = (vdci_t*(1.0-exp(((-log(static_cast<double>(2.4)))/modelPar_zci))));
        cmax = (2.4*cjcx0_t_i);
        cr = (cjcx0_t_i*exp(((modelPar_zci-zr)*log((vdci_t/modelPar_vptci)))));
        a = VT;
        ve = ((vf-Vbci)/a);
        if ((ve<=80.0))
        {
          ex1 = exp(ve);
          ee1 = (1.0+ex1);
          vj1 = (vf-(a*log(ee1)));
        }
        else
        {
          vj1 = Vbci;
        }
        a = ((0.1*vp)+(4.0*VT));
        vr = ((vp+vj1)/a);
        if ((vr<=80.0))
        {
          ex1 = exp(vr);
          ee1 = (1.0+ex1);
          vj2 = ((-vp)+(a*log(ee1)));
        }
        else
        {
          vj2 = vj1;
        }
        vj4 = (Vbci-vj1);
        ez = (1.0-modelPar_zci);
        ezr = (1.0-zr);
        vdj1 = log((1.0-(vj1/vdci_t)));
        vdj2 = log((1.0-(vj2/vdci_t)));
        qj1 = ((cjcx0_t_i*(1.0-exp((vdj2*ez))))/ez);
        qj2 = ((cr*(1.0-exp((vdj1*ezr))))/ezr);
        qj3 = ((cr*(1.0-exp((vdj2*ezr))))/ezr);
        qjcx = ((((qj1+qj2)-qj3)*vdci_t)+(cmax*vj4));
      }
      else
      {
        qjcx = 0.0;
      }
    }
    else
    {
      if ((cjcx0_t_i>0.0))
      {
        vf = (vdci_t*(1.0-exp(((-log(static_cast<double>(2.4)))/modelPar_zci))));
        xvf = ((vf-Vbci)/VT);
        xvf2 = sqrt(((xvf*xvf)+1.921812));
        v_j = (vf-((VT*(xvf+xvf2))*0.5));
        x = (1.0-modelPar_zci);
        y = (1.0-exp((x*log((1.0-(v_j/vdci_t))))));
        qjcx = ((((cjcx0_t_i*vdci_t)*y)/x)+((2.4*cjcx0_t_i)*(Vbci-v_j)));
      }
      else
      {
        qjcx = 0.00;
      }
    }
  }
  else
  {
    cjci0_t_ii = cjci0_t;
    cjcx0_t_ii = (cjcx0_t*modelPar_fbc);
    if ((modelPar_vptcx<1.0e2))
    {
      if ((cjcx0_t_ii>0.0))
      {
        zr = (modelPar_zcx/4.0);
        vp = (modelPar_vptcx-vdcx_t);
        vf = (vdcx_t*(1.0-exp(((-log(static_cast<double>(2.4)))/modelPar_zcx))));
        cmax = (2.4*cjcx0_t_ii);
        cr = (cjcx0_t_ii*exp(((modelPar_zcx-zr)*log((vdcx_t/modelPar_vptcx)))));
        a = VT;
        ve = ((vf-Vbici)/a);
        if ((ve<=80.0))
        {
          ex1 = exp(ve);
          ee1 = (1.0+ex1);
          vj1 = (vf-(a*log(ee1)));
        }
        else
        {
          vj1 = Vbici;
        }
        a = ((0.1*vp)+(4.0*VT));
        vr = ((vp+vj1)/a);
        if ((vr<=80.0))
        {
          ex1 = exp(vr);
          ee1 = (1.0+ex1);
          vj2 = ((-vp)+(a*log(ee1)));
        }
        else
        {
          vj2 = vj1;
        }
        vj4 = (Vbici-vj1);
        ez = (1.0-modelPar_zcx);
        ezr = (1.0-zr);
        vdj1 = log((1.0-(vj1/vdcx_t)));
        vdj2 = log((1.0-(vj2/vdcx_t)));
        qj1 = ((cjcx0_t_ii*(1.0-exp((vdj2*ez))))/ez);
        qj2 = ((cr*(1.0-exp((vdj1*ezr))))/ezr);
        qj3 = ((cr*(1.0-exp((vdj2*ezr))))/ezr);
        qjcxi = ((((qj1+qj2)-qj3)*vdcx_t)+(cmax*vj4));
      }
      else
      {
        qjcxi = 0.0;
      }
    }
    else
    {
      if ((cjcx0_t_ii>0.0))
      {
        vf = (vdcx_t*(1.0-exp(((-log(static_cast<double>(2.4)))/modelPar_zcx))));
        xvf = ((vf-Vbici)/VT);
        xvf2 = sqrt(((xvf*xvf)+1.921812));
        v_j = (vf-((VT*(xvf+xvf2))*0.5));
        x = (1.0-modelPar_zcx);
        y = (1.0-exp((x*log((1.0-(v_j/vdcx_t))))));
        qjcxi = ((((cjcx0_t_ii*vdcx_t)*y)/x)+((2.4*cjcx0_t_ii)*(Vbici-v_j)));
      }
      else
      {
        qjcxi = 0.00;
      }
    }
    cjcx0_t_i = (cjcx0_t*(1-modelPar_fbc));
    if ((modelPar_vptcx<1.0e2))
    {
      if ((cjcx0_t_i>0.0))
      {
        zr = (modelPar_zcx/4.0);
        vp = (modelPar_vptcx-vdcx_t);
        vf = (vdcx_t*(1.0-exp(((-log(static_cast<double>(2.4)))/modelPar_zcx))));
        cmax = (2.4*cjcx0_t_i);
        cr = (cjcx0_t_i*exp(((modelPar_zcx-zr)*log((vdcx_t/modelPar_vptcx)))));
        a = VT;
        ve = ((vf-Vbci)/a);
        if ((ve<=80.0))
        {
          ex1 = exp(ve);
          ee1 = (1.0+ex1);
          vj1 = (vf-(a*log(ee1)));
        }
        else
        {
          vj1 = Vbci;
        }
        a = ((0.1*vp)+(4.0*VT));
        vr = ((vp+vj1)/a);
        if ((vr<=80.0))
        {
          ex1 = exp(vr);
          ee1 = (1.0+ex1);
          vj2 = ((-vp)+(a*log(ee1)));
        }
        else
        {
          vj2 = vj1;
        }
        vj4 = (Vbci-vj1);
        ez = (1.0-modelPar_zcx);
        ezr = (1.0-zr);
        vdj1 = log((1.0-(vj1/vdcx_t)));
        vdj2 = log((1.0-(vj2/vdcx_t)));
        qj1 = ((cjcx0_t_i*(1.0-exp((vdj2*ez))))/ez);
        qj2 = ((cr*(1.0-exp((vdj1*ezr))))/ezr);
        qj3 = ((cr*(1.0-exp((vdj2*ezr))))/ezr);
        qjcx = ((((qj1+qj2)-qj3)*vdcx_t)+(cmax*vj4));
      }
      else
      {
        qjcx = 0.0;
      }
    }
    else
    {
      if ((cjcx0_t_i>0.0))
      {
        vf = (vdcx_t*(1.0-exp(((-log(static_cast<double>(2.4)))/modelPar_zcx))));
        xvf = ((vf-Vbci)/VT);
        xvf2 = sqrt(((xvf*xvf)+1.921812));
        v_j = (vf-((VT*(xvf+xvf2))*0.5));
        x = (1.0-modelPar_zcx);
        y = (1.0-exp((x*log((1.0-(v_j/vdcx_t))))));
        qjcx = ((((cjcx0_t_i*vdcx_t)*y)/x)+((2.4*cjcx0_t_i)*(Vbci-v_j)));
      }
      else
      {
        qjcx = 0.00;
      }
    }
  }
  if ((modelPar_vptci<1.0e2))
  {
    if ((cjci0_t_ii>0.0))
    {
      zr = (modelPar_zci/4.0);
      vp = (modelPar_vptci-vdci_t);
      vf = (vdci_t*(1.0-exp(((-log(static_cast<double>(2.4)))/modelPar_zci))));
      cmax = (2.4*cjci0_t_ii);
      cr = (cjci0_t_ii*exp(((modelPar_zci-zr)*log((vdci_t/modelPar_vptci)))));
      a = VT;
      ve = ((vf-Vbici)/a);
      if ((ve<=80.0))
      {
        ex1 = exp(ve);
        ee1 = (1.0+ex1);
        vj1 = (vf-(a*log(ee1)));
      }
      else
      {
        vj1 = Vbici;
      }
      a = ((0.1*vp)+(4.0*VT));
      vr = ((vp+vj1)/a);
      if ((vr<=80.0))
      {
        ex1 = exp(vr);
        ee1 = (1.0+ex1);
        vj2 = ((-vp)+(a*log(ee1)));
      }
      else
      {
        vj2 = vj1;
      }
      vj4 = (Vbici-vj1);
      ez = (1.0-modelPar_zci);
      ezr = (1.0-zr);
      vdj1 = log((1.0-(vj1/vdci_t)));
      vdj2 = log((1.0-(vj2/vdci_t)));
      qj1 = ((cjci0_t_ii*(1.0-exp((vdj2*ez))))/ez);
      qj2 = ((cr*(1.0-exp((vdj1*ezr))))/ezr);
      qj3 = ((cr*(1.0-exp((vdj2*ezr))))/ezr);
      instanceVar_qjci = ((((qj1+qj2)-qj3)*vdci_t)+(cmax*vj4));
    }
    else
    {
      instanceVar_qjci = 0.0;
    }
  }
  else
  {
    if ((cjci0_t_ii>0.0))
    {
      vf = (vdci_t*(1.0-exp(((-log(static_cast<double>(2.4)))/modelPar_zci))));
      xvf = ((vf-Vbici)/VT);
      xvf2 = sqrt(((xvf*xvf)+1.921812));
      v_j = (vf-((VT*(xvf+xvf2))*0.5));
      x = (1.0-modelPar_zci);
      y = (1.0-exp((x*log((1.0-(v_j/vdci_t))))));
      instanceVar_qjci = ((((cjci0_t_ii*vdci_t)*y)/x)+((2.4*cjci0_t_ii)*(Vbici-v_j)));
    }
    else
    {
      instanceVar_qjci = 0.00;
    }
  }
  qjci_int = instanceVar_qjci;
  qjcii = (instanceVar_qjci+qjcxi);
  if ((cjci0_t_ii>0.0))
  {
    vf = (vdci_t*(1.0-exp(((-log(static_cast<double>(2.4)))/modelPar_zci))));
    xvf = ((vf-Vbici)/VT);
    xvf2 = sqrt(((xvf*xvf)+1.921812));
    v_j = (vf-((VT*(xvf+xvf2))*0.5));
    dvj = ((0.5*(xvf+xvf2))/xvf2);
    cjcii = (((cjci0_t_ii*exp(((-modelPar_zci)*log((1-(v_j/vdci_t))))))*dvj)+((2.4*cjci0_t_ii)*(1-dvj)));
  }
  else
  {
    cjcii = 0.0;
  }
  vc = (Vciei-vces_t);
  uvc = ((vc/VT)-1);
  vceff = (VT*(1+(0.5*(uvc+sqrt(((uvc*uvc)+1.921812))))));
  x = ((vceff-vlim_t)/modelPar_vpt);
  ick = (((vceff*(1+(0.5*(x+sqrt(((x*x)+1e-3))))))/rci0_t)/sqrt((1+(((vceff*vceff)/vlim_t)/vlim_t))));
  if (((cjcii>0.0)&&(cjci0_t_ii>0.0)))
  {
    cc = (cjci0_t_ii/cjcii);
    instanceVar_qjci = (instanceVar_qjci/cjci0_t_ii);
  }
  else
  {
    cc = 1.0;
    instanceVar_qjci = 0;
  }
  if ((cje0_dc_t>0.0))
  {
    vf = (vdedc_t*(1.0-exp(((-log(ajedc_t))/modelPar_zedc))));
    xvf = ((vf-Vbiei)/VT);
    xvf2 = sqrt(((xvf*xvf)+1.921812));
    v_j = (vf-((VT*(xvf+xvf2))*0.5));
    x = (1.0-modelPar_zedc);
    y = (1.0-exp((x*log((1.0-(v_j/vdedc_t))))));
    instanceVar_qjei = ((((cje0_dc_t*vdedc_t)*y)/x)+((ajedc_t*cje0_dc_t)*(Vbiei-v_j)));
  }
  else
  {
    instanceVar_qjei = 0.00;
  }
  if ((modelPar_aver==0.0))
  {
    h_vbe = 1;
  }
  else
  {
    vjh = ((vdedc_t-Vbiei)/(2.0*VT));
    vjh = (vdedc_t-(((2.0*VT)*(vjh+sqrt(((vjh*vjh)+1.921812))))*0.5));
    vjh = ((vjh-VT)/VT);
    vjh = (VT*(1.0+((vjh+sqrt(((vjh*vjh)+1.921812)))*0.5)));
    vj_z = ((1.0-exp((modelPar_zedc*log((1.0-(vjh/vdedc_t))))))*aver_t);
    h_vbe = ((exp(vj_z)-1.0)/vj_z);
  }
  qje = ((h_vbe*instanceVar_qjei)/cje0_dc_t);
  qj = ((1+(instanceVar_qjci/modelPar_vef))+(qje/ver_t));
  b_q = ((20*qj)-1);
  qj_2 = (0.025*(1+((b_q+sqrt(((b_q*b_q)+1.921812)))/2)));
  tf0 = ((t0_t+(modelPar_dt0h*(cc-1)))+(modelPar_tbvl*((1/cc)-1)));
  if ((modelPar_fiqf==1))
  {
    denom_iqf = (modelPar_fiqf*((tf0/t0_t)-1));
    ickf = (iqf_t/(1+denom_iqf));
  }
  else
  {
    ickf = iqf_t;
  }
  ickr = modelPar_iqr;
  arg1 = (Vbiei/(modelPar_mcf*VT));
  if ((arg1>80))
  {
    le1 = (1+(arg1-80));
    arg1 = 80;
  }
  else
  {
    le1 = 1;
  }
  le1 = (le1*limexp<AdmsSensFadType>(arg1));
  itfi = (is_t*le1);
  arg2 = (Vbici/(modelPar_mcr*VT));
  if ((arg2>80))
  {
    le2 = (1+(arg2-80));
    arg2 = 80;
  }
  else
  {
    le2 = 1;
  }
  le2 = (le2*limexp<AdmsSensFadType>(arg2));
  itri = (is_t*le2);
  if ((modelPar_tfh!=0))
  {
    qml = (((itfi/ickf)+(itri/ickr))+exp((0.6666*log(((itfi*(itfi/ick))*(tfh_t/iqfh_t))))));
    qmh = ((((itfi/ickf)+(itri/ickr))+(itfi/iqfh_t))+exp((0.6666*log(((itfi*(itfi/ick))*(tfh_t/iqfh_t))))));
  }
  else
  {
    qml = ((itfi/ickf)+(itri/ickr));
    qmh = (((itfi/ickf)+(itri/ickr))+(itfi/iqfh_t));
  }
  qpt_l = (qj_2+sqrt(((qj_2*qj_2)+qml)));
  qpt_h = (qj_2+sqrt(((qj_2*qj_2)+qmh)));
  diff_q = (qmh-qml);
  if ((fabs(diff_q)>1e-8))
  {
    a1 = (1-(((ick/(1+ahq_t))/itfi)*qpt_l));
    a2 = (1+(((ick/(1+ahq_t))/itfi)*(qpt_h-qpt_l)));
    aa = (a1/a2);
    wdc = ((sqrt(((aa*aa)+0.01))+aa)/(1+sqrt((1+0.01))));
  }
  else
  {
    wdc = 0;
  }
  if ((modelPar_it_mod==0))
  {
    if ((modelPar_tfh!=0))
    {
      qm = ((((itfi/ickf)+(itri/ickr))+(((itfi/iqfh_t)*wdc)*wdc))+exp((0.6666*log(((itfi*(itfi/ick))*(tfh_t/iqfh_t))))));
    }
    else
    {
      qm = (((itfi/ickf)+(itri/ickr))+(((itfi/iqfh_t)*wdc)*wdc));
    }
    qpt = (qj_2+sqrt(((qj_2*qj_2)+qm)));
  }
  else
  {
    o3 = (1.0/3);
    p2_a = ((-2)*qj_2);
    if (((modelPar_iqf==1.0e6)&&(modelPar_iqfh==1.0e6)))
    {
      p2_b = 0;
    }
    else
    {
      p2_b = (-(((itfi/ickf)+(itri/ickr))+(((itfi/iqfh_t)*wdc)*wdc)));
    }
    p2_c = (((((-itfi)*itfi)/ick)*tfh_t)/iqfh_t);
    tmp = (p2_a*p2_a);
    p2_p = (p2_b-(tmp*o3));
    p2_q = (((((2*p2_a)*tmp)/27)-((p2_a*p2_b)*o3))+p2_c);
    p2_D = (((p2_q*p2_q)*0.25)+(((p2_p*p2_p)*p2_p)/27));
    if ((fabs(p2_D)<1e-10))
    {
      q_p3 = (((3*p2_q)/p2_p)-(p2_a*o3));
    }
    else
    {
      if ((p2_D>0))
      {
        tmp2 = ((-p2_q)*0.5);
        tmp3 = sqrt(p2_D);
        tmp = (tmp2+tmp3);
        if ((tmp>0))
        {
          p2_u = exp((o3*log(tmp)));
        }
        else
        {
          p2_u = (-exp((o3*log((-tmp)))));
        }
        tmp = (tmp2-tmp3);
        if ((tmp>0))
        {
          p2_v = exp((o3*log(tmp)));
        }
        else
        {
          p2_v = (-exp((o3*log((-tmp)))));
        }
        q_p3 = ((p2_u+p2_v)-(p2_a*o3));
      }
      else
      {
        tmp = (((-p2_q)*0.5)*sqrt(((-27.0)/((p2_p*p2_p)*p2_p))));
        tmp2 = (tmp*tmp);
        if ((tmp>=0))
        {
          tmp = ((3.14159265358979323846/2)-atan(sqrt((tmp2/(1-tmp2)))));
        }
        else
        {
          tmp = ((3.14159265358979323846/2)+atan(sqrt((tmp2/(1-tmp2)))));
        }
        tmp = ((sqrt((((-4)*p2_p)*o3))*cos((o3*tmp)))-(p2_a*o3));
        q_p3 = tmp;
      }
    }
    qpt = q_p3;
  }
  if ((qpt<=1e-20))
  {
    qpt = 1e-20;
  }
  itf = (itfi/qpt);
  itr = (itri/qpt);
  if ((itf<=1e-20))
  {
    itf = 1e-20;
  }
  instanceVar_it = (itf-itr);
  qf0 = (tf0*itf);
  a = (1-(ick/itf));
  s3 = sqrt(((a*a)+modelPar_ahc));
  w = ((a+s3)/(1+sqrt((1+modelPar_ahc))));
  tww = ((thcs_t*w)*w);
  dqfh = (tww*itf);
  dtfh = (tww*(1+(((2*ick)/itf)/s3)));
  dtef = (tef0_t*exp((modelPar_gte*log((itf/ick)))));
  dqef = ((dtef*itf)/(modelPar_gte+1.0));
  qf = ((qf0+dqef)+dqfh);
  tf = ((tf0+dtfh)+dtef);
  qr = (modelPar_tr*itr);
  DIOY = (Vbiei/(modelPar_mbe*VT));
  if ((modelPar_ibes>0.0))
  {
    if ((DIOY>80))
    {
      le = (1+(DIOY-80));
      DIOY = 80;
    }
    else
    {
      le = 1;
    }
    le = (le*limexp<AdmsSensFadType>(DIOY));
    ibe = (ibes_t*(le-1.0));
    if ((DIOY<=(-14.0)))
    {
      ibe = (-ibes_t);
    }
  }
  else
  {
    ibe = 0.0;
  }
  DIOY = (Vbiei/(modelPar_mre*VT));
  if ((modelPar_ires>0.0))
  {
    if ((DIOY>80))
    {
      le = (1+(DIOY-80));
      DIOY = 80;
    }
    else
    {
      le = 1;
    }
    le = (le*limexp<AdmsSensFadType>(DIOY));
    ire = (ires_t*(le-1.0));
    if ((DIOY<=(-14.0)))
    {
      ire = (-ires_t);
    }
  }
  else
  {
    ire = 0.0;
  }
  instanceVar_ijbe = (ibe+ire);
  DIOY = (Vbici/(modelPar_mbc*VT));
  if ((modelPar_ibcs>0.0))
  {
    if ((DIOY>80))
    {
      le = (1+(DIOY-80));
      DIOY = 80;
    }
    else
    {
      le = 1;
    }
    le = (le*limexp<AdmsSensFadType>(DIOY));
    instanceVar_ijbc = (ibcs_t*(le-1.0));
    if ((DIOY<=(-14.0)))
    {
      instanceVar_ijbc = (-ibcs_t);
    }
  }
  else
  {
    instanceVar_ijbc = 0.0;
  }
  ibi = (instanceVar_ijbe+instanceVar_ijbc);
  if ((Vbici<0))
    //Begin block HICAVL
  {
    v_bord = (eavl_t*vdci_t);
    if (((vdci_t-Vbici)>v_bord))
    {
      a_iavl = ((kavl_t/vdci_t)*exp((-cc)));
      instanceVar_iavl = ((itf*a_iavl)*(v_bord+((1+cc)*((vdci_t-Vbici)-v_bord))));
    }
    else
    {
      lncc = log((1/cc));
      instanceVar_iavl = ((kavl_t*itf)*exp(((((-1)/modelPar_zci)*lncc)-(eavl_t*exp((((1/modelPar_zci)-1)*lncc))))));
    }
  }
  // End block HICAVL
  else
  {
    instanceVar_iavl = 0;
  }
  if ((cje0_t>0.0))
  {
    vf = (vde_t*(1.0-exp(((-log(aje_t))/modelPar_ze))));
    xvf = ((vf-Vbiei)/VT);
    xvf2 = sqrt(((xvf*xvf)+1.921812));
    v_j = (vf-((VT*(xvf+xvf2))*0.5));
    x = (1.0-modelPar_ze);
    y = (1.0-exp((x*log((1.0-(v_j/vde_t))))));
    instanceVar_qjei = ((((cje0_t*vde_t)*y)/x)+((aje_t*cje0_t)*(Vbiei-v_j)));
  }
  else
  {
    instanceVar_qjei = 0.00;
  }
  qje = (instanceVar_qjei/cje0_t);
  if ((rbi0_t>0.0))
    //Begin block HICRBI
  {
    Qz_nom = ((((1+(qje/modelPar_vr0e))+(instanceVar_qjci/modelPar_vr0c))+(itf/ickf))+(itr/ickr));
    fQz = (0.5*(Qz_nom+sqrt(((Qz_nom*Qz_nom)+0.01))));
    rbi = (rbi0_t/fQz);
    if ((ibi>0.0))
    {
      eta = (((modelPar_fgeo*rbi)*ibi)/VT);
      if ((eta<1e-6))
      {
        rbi = (rbi*(1-(0.5*eta)));
      }
      else
      {
        rbi = ((rbi*log((eta+1)))/eta);
      }
    }
  }
  // End block HICRBI
  else
  {
    rbi = 0.0;
  }
  rb = (rbi+rbx_t);
  if ((modelPar_itss>0.0))
    //Begin block Sub_Transfer
  {
    HSUM = (modelPar_msf*VT);
    HSa = limexp<AdmsSensFadType>((Vbci/HSUM));
    HSb = limexp<AdmsSensFadType>((Vsci/HSUM));
    HSI_Tsu = (itss_t*(HSa-HSb));
  }
  // End block Sub_Transfer
  else
  {
    HSI_Tsu = 0.0;
  }
  DIOY = (Vsci/(modelPar_msc*VT));
  if ((modelPar_iscs>0.0))
  {
    if ((DIOY>80))
    {
      le = (1+(DIOY-80));
      DIOY = 80;
    }
    else
    {
      le = 1;
    }
    le = (le*limexp<AdmsSensFadType>(DIOY));
    instanceVar_ijsc = (iscs_t*(le-1.0));
    if ((DIOY<=(-14.0)))
    {
      instanceVar_ijsc = (-iscs_t);
    }
  }
  else
  {
    instanceVar_ijsc = 0.0;
  }
  if ((modelPar_vpts<1.0e2))
  {
    if ((cjs0_t>0.0))
    {
      zr = (modelPar_zs/4.0);
      vp = (modelPar_vpts-vds_t);
      vf = (vds_t*(1.0-exp(((-log(static_cast<double>(2.4)))/modelPar_zs))));
      cmax = (2.4*cjs0_t);
      cr = (cjs0_t*exp(((modelPar_zs-zr)*log((vds_t/modelPar_vpts)))));
      a = VT;
      ve = ((vf-Vsci)/a);
      if ((ve<=80.0))
      {
        ex1 = exp(ve);
        ee1 = (1.0+ex1);
        vj1 = (vf-(a*log(ee1)));
      }
      else
      {
        vj1 = Vsci;
      }
      a = ((0.1*vp)+(4.0*VT));
      vr = ((vp+vj1)/a);
      if ((vr<=80.0))
      {
        ex1 = exp(vr);
        ee1 = (1.0+ex1);
        vj2 = ((-vp)+(a*log(ee1)));
      }
      else
      {
        vj2 = vj1;
      }
      vj4 = (Vsci-vj1);
      ez = (1.0-modelPar_zs);
      ezr = (1.0-zr);
      vdj1 = log((1.0-(vj1/vds_t)));
      vdj2 = log((1.0-(vj2/vds_t)));
      qj1 = ((cjs0_t*(1.0-exp((vdj2*ez))))/ez);
      qj2 = ((cr*(1.0-exp((vdj1*ezr))))/ezr);
      qj3 = ((cr*(1.0-exp((vdj2*ezr))))/ezr);
      qjs = ((((qj1+qj2)-qj3)*vds_t)+(cmax*vj4));
    }
    else
    {
      qjs = 0.0;
    }
  }
  else
  {
    if ((cjs0_t>0.0))
    {
      vf = (vds_t*(1.0-exp(((-log(static_cast<double>(2.4)))/modelPar_zs))));
      xvf = ((vf-Vsci)/VT);
      xvf2 = sqrt(((xvf*xvf)+1.921812));
      v_j = (vf-((VT*(xvf+xvf2))*0.5));
      x = (1.0-modelPar_zs);
      y = (1.0-exp((x*log((1.0-(v_j/vds_t))))));
      qjs = ((((cjs0_t*vds_t)*y)/x)+((2.4*cjs0_t)*(Vsci-v_j)));
    }
    else
    {
      qjs = 0.00;
    }
  }
  pterm = 0;
  if (((modelPar_flsh==1)&&(modelPar_rth>=0.001)))
  {
    pterm = ((instanceVar_it*Vciei)+(instanceVar_iavl*(vdci_t-Vbici)));
  }
  else
  {
    if (((modelPar_flsh==2)&&(modelPar_rth>=0.001)))
    {
      pterm = (((((Vciei*instanceVar_it)+((vdci_t-Vbici)*instanceVar_iavl))+(instanceVar_ijbe*Vbiei))+(instanceVar_ijbc*Vbici))+(instanceVar_ijsc*Vsci));
      if ((rb>=0.001))
      {
        pterm = (pterm+((Vbbi*Vbbi)/rb));
      }
      if ((modelPar_re>=0.001))
      {
        pterm = (pterm+((Veie*Veie)/re_t));
      }
      if ((modelPar_rcx>=0.001))
      {
        pterm = (pterm+((Vcic*Vcic)/rcx_t));
      }
    }
  }
  Itxf = itf;
  Qdeix = qf;
  if (((modelPar_flnqs!=0)&&(tf!=0)))
  {
    Vxf1 = (probeVars[admsProbeID_V_xf1_GND]);
    Vxf2 = (probeVars[admsProbeID_V_xf2_GND]);
    Ixf1 = (((Vxf2-itf)/tf)*modelPar_t0);
    Ixf2 = (((Vxf2-Vxf1)/tf)*modelPar_t0);
    Qxf1 = ((modelPar_alit*Vxf1)*modelPar_t0);
    Qxf2 = (((modelPar_alit*Vxf2)/3)*modelPar_t0);
    Itxf = Vxf2;
    Vxf = (probeVars[admsProbeID_V_xf_GND]);
    fact = (modelPar_t0/tf);
    Ixf = ((Vxf-qf)*fact);
    Qxf = ((modelPar_alqf*Vxf)*modelPar_t0);
    Qdeix = Vxf;
  }
  else
  {
    Ixf1 = (probeVars[admsProbeID_V_xf1_GND]);
    Ixf2 = (probeVars[admsProbeID_V_xf2_GND]);
    Qxf1 = 0;
    Qxf2 = 0;
    Ixf = (probeVars[admsProbeID_V_xf_GND]);
    Qxf = 0;
  }
  instanceVar_Ibici = (instanceVar_ijbc-instanceVar_iavl);
  Qbci = (modelPar_cbcpar*Vbci);
  Qbe = (modelPar_cbepar*Vbe);
  Qbici = (qjcii+qr);
  Qbiei = (instanceVar_qjei+Qdeix);
  instanceVar_ijsc = (HICUMtype*instanceVar_ijsc);
  qjs = (HICUMtype*qjs);
  qjcx = (HICUMtype*qjcx);
  Qbci = (HICUMtype*Qbci);
  Qbe = (HICUMtype*Qbe);
  instanceVar_Ibici = (HICUMtype*instanceVar_Ibici);
  Qbici = (HICUMtype*Qbici);
  instanceVar_ijbe = (HICUMtype*instanceVar_ijbe);
  Qbiei = (HICUMtype*Qbiei);
  it_wop = (HICUMtype*instanceVar_it);
  instanceVar_it = (HICUMtype*(Itxf-itr));
  instanceVar_iavl = (HICUMtype*instanceVar_iavl);
  // I(bi,ei) <+ (($simparam("gmin",1e-12)*V(bi,ei)))
  staticContributions[admsNodeID_bi] += (gmin*(probeVars[admsProbeID_V_bi_ei]));
  staticContributions[admsNodeID_ei] -= (gmin*(probeVars[admsProbeID_V_bi_ei]));
  // I(bi,ci) <+ (($simparam("gmin",1e-12)*V(bi,ci)))
  staticContributions[admsNodeID_bi] += (gmin*(probeVars[admsProbeID_V_bi_ci]));
  staticContributions[admsNodeID_ci] -= (gmin*(probeVars[admsProbeID_V_bi_ci]));
  // I(ci,ei) <+ (($simparam("gmin",1e-12)*V(ci,ei)))
  staticContributions[admsNodeID_ci] += (gmin*(probeVars[admsProbeID_V_ci_ei]));
  staticContributions[admsNodeID_ei] -= (gmin*(probeVars[admsProbeID_V_ci_ei]));
  // I(b,s) <+ ((HICUMtype*HSI_Tsu))
  staticContributions[admsNodeID_b] += (HICUMtype*HSI_Tsu);
  staticContributions[admsNodeID_s] -= (HICUMtype*HSI_Tsu);
  // I(s,ci) <+ (ijsc)
  staticContributions[admsNodeID_s] += instanceVar_ijsc;
  staticContributions[admsNodeID_ci] -= instanceVar_ijsc;
  // I(s,ci) <+ (ddt(qjs))
  dynamicContributions[admsNodeID_s] += (qjs);
  dynamicContributions[admsNodeID_ci] -= (qjs);
  // I(b,ci) <+ (ddt(qjcx))
  dynamicContributions[admsNodeID_b] += (qjcx);
  dynamicContributions[admsNodeID_ci] -= (qjcx);
  // I(b,ci) <+ (ddt(Qbci))
  dynamicContributions[admsNodeID_b] += (Qbci);
  dynamicContributions[admsNodeID_ci] -= (Qbci);
  // I(b,e) <+ (ddt(Qbe))
  dynamicContributions[admsNodeID_b] += (Qbe);
  dynamicContributions[admsNodeID_e] -= (Qbe);
  if ((modelPar_re>=0.001))
  {
    // I(ei,e) <+ ((Veie/re_t))
    staticContributions[admsNodeID_ei] += (Veie/re_t);
    staticContributions[admsNodeID_e] -= (Veie/re_t);
  }
  else
  {
    // V(ei,e) <+ (0.0)
    // do nothing at all
  }
  if ((modelPar_rcx>=0.001))
  {
    // I(ci,c) <+ ((Vcic/rcx_t))
    staticContributions[admsNodeID_ci] += (Vcic/rcx_t);
    staticContributions[admsNodeID_c] -= (Vcic/rcx_t);
  }
  else
  {
    // V(ci,c) <+ (0.0)
    // do nothing at all
  }
  if (((modelPar_rbi0>=0.001)||(modelPar_rbx>=0.001)))
  {
    // I(b,bi) <+ ((Vbbi/rb))
    staticContributions[admsNodeID_b] += (Vbbi/rb);
    staticContributions[admsNodeID_bi] -= (Vbbi/rb);
  }
  else
  {
    // V(b,bi) <+ (0.0)
    // do nothing at all
  }
  // I(bi,ci) <+ (Ibici)
  staticContributions[admsNodeID_bi] += instanceVar_Ibici;
  staticContributions[admsNodeID_ci] -= instanceVar_Ibici;
  // I(bi,ci) <+ (ddt(Qbici))
  dynamicContributions[admsNodeID_bi] += (Qbici);
  dynamicContributions[admsNodeID_ci] -= (Qbici);
  // I(bi,ei) <+ (ijbe)
  staticContributions[admsNodeID_bi] += instanceVar_ijbe;
  staticContributions[admsNodeID_ei] -= instanceVar_ijbe;
  // I(bi,ei) <+ (ddt(Qbiei))
  dynamicContributions[admsNodeID_bi] += (Qbiei);
  dynamicContributions[admsNodeID_ei] -= (Qbiei);
  // I(ci,ei) <+ (it)
  staticContributions[admsNodeID_ci] += instanceVar_it;
  staticContributions[admsNodeID_ei] -= instanceVar_it;
  if (((modelPar_flsh==0)||(modelPar_rth<0.001)))
  {
    // I(tnode,GND) <+ ((Vrth/0.001))
    staticContributions[admsNodeID_tnode] += (Vrth/0.001);
  }
  else
  {
    // I(tnode,GND) <+ (((Vrth/rth)-pterm))
    staticContributions[admsNodeID_tnode] += ((Vrth/modelPar_rth)-pterm);
    // I(tnode,GND) <+ (ddt((cth*Vrth)))
    dynamicContributions[admsNodeID_tnode] += ((modelPar_cth*Vrth));
  }
  // I(xf1,GND) <+ (Ixf1)
  staticContributions[admsNodeID_xf1] += Ixf1;
  // I(xf1,GND) <+ (ddt(Qxf1))
  dynamicContributions[admsNodeID_xf1] += (Qxf1);
  // I(xf2,GND) <+ (Ixf2)
  staticContributions[admsNodeID_xf2] += Ixf2;
  // I(xf2,GND) <+ (ddt(Qxf2))
  dynamicContributions[admsNodeID_xf2] += (Qxf2);
  // I(xf,GND) <+ (Ixf)
  staticContributions[admsNodeID_xf] += Ixf;
  // I(xf,GND) <+ (ddt(Qxf))
  dynamicContributions[admsNodeID_xf] += (Qxf);
  fourkt = ((4.0*1.3806503e-23)*Tdev);
  if (((modelPar_rbx>=0.001)||(modelPar_rbi0>=0.001)))
  {
    // I(b,bi) <+ (white_noise((fourkt/rb)))
  }
  if ((modelPar_rcx>=0.001))
  {
    // I(ci,c) <+ (white_noise((fourkt/rcx_t)))
  }
  if ((modelPar_re>=0.001))
  {
    // I(ei,e) <+ (white_noise((fourkt/re_t)))
  }
  twoq = (2.0*1.6021766208e-19);
  // I(bi,ei) <+ (white_noise((twoq*ijbe)))
  // I(ci,ei) <+ (white_noise((twoq*it)))
  flicker_Pwr = (modelPar_kf*pow(instanceVar_ijbe,modelPar_af));
  // I(bi,ei) <+ (flicker_noise(flicker_Pwr,1.0))
}



//-----------------------------------------------------------------------------
// Function      : InstanceSensitivity::operator()
// Purpose       : return sensitivity for a single instance parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
/// Compute sensitivity of a device instance's outputs to a specified instance
/// parameter
/// 
/// 
/// @param[in] entity  The device entity that owns the parameter 
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
/// 
/// 
void InstanceSensitivity::operator()
  (
     const ParameterBase &entity,
     const std::string &name,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
   ) const
{
  const ParameterBase * e1 = &entity;
  const Instance & in = *(dynamic_cast<const Instance *> (e1));
  const Model & mod =in.model_;

  dfdp.resize(11+0);
  dqdp.resize(11+0);
  Findices.resize(11+0);
  Qindices.resize(11+0);

  std::vector <double> probeVars(13);
  std::vector <AdmsSensFadType> staticContributions(11+0);
  std::vector <AdmsSensFadType> dynamicContributions(11+0);


  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 11+0 ; ++i)
  {
    staticContributions[i]=0;
    dynamicContributions[i]=0;
  }

  // Copy out all the model parameters (doubles) into FAD types
  //reals
  AdmsSensFadType modelPar_is=mod.is;
  bool modelPar_given_is=mod.given("is");
  AdmsSensFadType modelPar_mcf=mod.mcf;
  bool modelPar_given_mcf=mod.given("mcf");
  AdmsSensFadType modelPar_mcr=mod.mcr;
  bool modelPar_given_mcr=mod.given("mcr");
  AdmsSensFadType modelPar_vef=mod.vef;
  bool modelPar_given_vef=mod.given("vef");
  AdmsSensFadType modelPar_ver=mod.ver;
  bool modelPar_given_ver=mod.given("ver");
  AdmsSensFadType modelPar_aver=mod.aver;
  bool modelPar_given_aver=mod.given("aver");
  AdmsSensFadType modelPar_iqf=mod.iqf;
  bool modelPar_given_iqf=mod.given("iqf");
  AdmsSensFadType modelPar_fiqf=mod.fiqf;
  bool modelPar_given_fiqf=mod.given("fiqf");
  AdmsSensFadType modelPar_iqr=mod.iqr;
  bool modelPar_given_iqr=mod.given("iqr");
  AdmsSensFadType modelPar_iqfh=mod.iqfh;
  bool modelPar_given_iqfh=mod.given("iqfh");
  AdmsSensFadType modelPar_tfh=mod.tfh;
  bool modelPar_given_tfh=mod.given("tfh");
  AdmsSensFadType modelPar_ahq=mod.ahq;
  bool modelPar_given_ahq=mod.given("ahq");
  AdmsSensFadType modelPar_ibes=mod.ibes;
  bool modelPar_given_ibes=mod.given("ibes");
  AdmsSensFadType modelPar_mbe=mod.mbe;
  bool modelPar_given_mbe=mod.given("mbe");
  AdmsSensFadType modelPar_ires=mod.ires;
  bool modelPar_given_ires=mod.given("ires");
  AdmsSensFadType modelPar_mre=mod.mre;
  bool modelPar_given_mre=mod.given("mre");
  AdmsSensFadType modelPar_ibcs=mod.ibcs;
  bool modelPar_given_ibcs=mod.given("ibcs");
  AdmsSensFadType modelPar_mbc=mod.mbc;
  bool modelPar_given_mbc=mod.given("mbc");
  AdmsSensFadType modelPar_cje0=mod.cje0;
  bool modelPar_given_cje0=mod.given("cje0");
  AdmsSensFadType modelPar_vde=mod.vde;
  bool modelPar_given_vde=mod.given("vde");
  AdmsSensFadType modelPar_ze=mod.ze;
  bool modelPar_given_ze=mod.given("ze");
  AdmsSensFadType modelPar_aje=mod.aje;
  bool modelPar_given_aje=mod.given("aje");
  AdmsSensFadType modelPar_vdedc=mod.vdedc;
  bool modelPar_given_vdedc=mod.given("vdedc");
  AdmsSensFadType modelPar_zedc=mod.zedc;
  bool modelPar_given_zedc=mod.given("zedc");
  AdmsSensFadType modelPar_ajedc=mod.ajedc;
  bool modelPar_given_ajedc=mod.given("ajedc");
  AdmsSensFadType modelPar_t0=mod.t0;
  bool modelPar_given_t0=mod.given("t0");
  AdmsSensFadType modelPar_dt0h=mod.dt0h;
  bool modelPar_given_dt0h=mod.given("dt0h");
  AdmsSensFadType modelPar_tbvl=mod.tbvl;
  bool modelPar_given_tbvl=mod.given("tbvl");
  AdmsSensFadType modelPar_tef0=mod.tef0;
  bool modelPar_given_tef0=mod.given("tef0");
  AdmsSensFadType modelPar_gte=mod.gte;
  bool modelPar_given_gte=mod.given("gte");
  AdmsSensFadType modelPar_thcs=mod.thcs;
  bool modelPar_given_thcs=mod.given("thcs");
  AdmsSensFadType modelPar_ahc=mod.ahc;
  bool modelPar_given_ahc=mod.given("ahc");
  AdmsSensFadType modelPar_tr=mod.tr;
  bool modelPar_given_tr=mod.given("tr");
  AdmsSensFadType modelPar_rci0=mod.rci0;
  bool modelPar_given_rci0=mod.given("rci0");
  AdmsSensFadType modelPar_vlim=mod.vlim;
  bool modelPar_given_vlim=mod.given("vlim");
  AdmsSensFadType modelPar_vpt=mod.vpt;
  bool modelPar_given_vpt=mod.given("vpt");
  AdmsSensFadType modelPar_vces=mod.vces;
  bool modelPar_given_vces=mod.given("vces");
  AdmsSensFadType modelPar_cjci0=mod.cjci0;
  bool modelPar_given_cjci0=mod.given("cjci0");
  AdmsSensFadType modelPar_vdci=mod.vdci;
  bool modelPar_given_vdci=mod.given("vdci");
  AdmsSensFadType modelPar_zci=mod.zci;
  bool modelPar_given_zci=mod.given("zci");
  AdmsSensFadType modelPar_vptci=mod.vptci;
  bool modelPar_given_vptci=mod.given("vptci");
  AdmsSensFadType modelPar_cjcx0=mod.cjcx0;
  bool modelPar_given_cjcx0=mod.given("cjcx0");
  AdmsSensFadType modelPar_vdcx=mod.vdcx;
  bool modelPar_given_vdcx=mod.given("vdcx");
  AdmsSensFadType modelPar_zcx=mod.zcx;
  bool modelPar_given_zcx=mod.given("zcx");
  AdmsSensFadType modelPar_vptcx=mod.vptcx;
  bool modelPar_given_vptcx=mod.given("vptcx");
  AdmsSensFadType modelPar_fbc=mod.fbc;
  bool modelPar_given_fbc=mod.given("fbc");
  AdmsSensFadType modelPar_rbi0=mod.rbi0;
  bool modelPar_given_rbi0=mod.given("rbi0");
  AdmsSensFadType modelPar_vr0e=mod.vr0e;
  bool modelPar_given_vr0e=mod.given("vr0e");
  AdmsSensFadType modelPar_vr0c=mod.vr0c;
  bool modelPar_given_vr0c=mod.given("vr0c");
  AdmsSensFadType modelPar_fgeo=mod.fgeo;
  bool modelPar_given_fgeo=mod.given("fgeo");
  AdmsSensFadType modelPar_rbx=mod.rbx;
  bool modelPar_given_rbx=mod.given("rbx");
  AdmsSensFadType modelPar_rcx=mod.rcx;
  bool modelPar_given_rcx=mod.given("rcx");
  AdmsSensFadType modelPar_re=mod.re;
  bool modelPar_given_re=mod.given("re");
  AdmsSensFadType modelPar_itss=mod.itss;
  bool modelPar_given_itss=mod.given("itss");
  AdmsSensFadType modelPar_msf=mod.msf;
  bool modelPar_given_msf=mod.given("msf");
  AdmsSensFadType modelPar_iscs=mod.iscs;
  bool modelPar_given_iscs=mod.given("iscs");
  AdmsSensFadType modelPar_msc=mod.msc;
  bool modelPar_given_msc=mod.given("msc");
  AdmsSensFadType modelPar_cjs0=mod.cjs0;
  bool modelPar_given_cjs0=mod.given("cjs0");
  AdmsSensFadType modelPar_vds=mod.vds;
  bool modelPar_given_vds=mod.given("vds");
  AdmsSensFadType modelPar_zs=mod.zs;
  bool modelPar_given_zs=mod.given("zs");
  AdmsSensFadType modelPar_vpts=mod.vpts;
  bool modelPar_given_vpts=mod.given("vpts");
  AdmsSensFadType modelPar_cbcpar=mod.cbcpar;
  bool modelPar_given_cbcpar=mod.given("cbcpar");
  AdmsSensFadType modelPar_cbepar=mod.cbepar;
  bool modelPar_given_cbepar=mod.given("cbepar");
  AdmsSensFadType modelPar_eavl=mod.eavl;
  bool modelPar_given_eavl=mod.given("eavl");
  AdmsSensFadType modelPar_kavl=mod.kavl;
  bool modelPar_given_kavl=mod.given("kavl");
  AdmsSensFadType modelPar_kf=mod.kf;
  bool modelPar_given_kf=mod.given("kf");
  AdmsSensFadType modelPar_af=mod.af;
  bool modelPar_given_af=mod.given("af");
  AdmsSensFadType modelPar_alqf=mod.alqf;
  bool modelPar_given_alqf=mod.given("alqf");
  AdmsSensFadType modelPar_alit=mod.alit;
  bool modelPar_given_alit=mod.given("alit");
  AdmsSensFadType modelPar_vgb=mod.vgb;
  bool modelPar_given_vgb=mod.given("vgb");
  AdmsSensFadType modelPar_vge=mod.vge;
  bool modelPar_given_vge=mod.given("vge");
  AdmsSensFadType modelPar_vgc=mod.vgc;
  bool modelPar_given_vgc=mod.given("vgc");
  AdmsSensFadType modelPar_vgs=mod.vgs;
  bool modelPar_given_vgs=mod.given("vgs");
  AdmsSensFadType modelPar_f1vg=mod.f1vg;
  bool modelPar_given_f1vg=mod.given("f1vg");
  AdmsSensFadType modelPar_f2vg=mod.f2vg;
  bool modelPar_given_f2vg=mod.given("f2vg");
  AdmsSensFadType modelPar_alt0=mod.alt0;
  bool modelPar_given_alt0=mod.given("alt0");
  AdmsSensFadType modelPar_kt0=mod.kt0;
  bool modelPar_given_kt0=mod.given("kt0");
  AdmsSensFadType modelPar_zetact=mod.zetact;
  bool modelPar_given_zetact=mod.given("zetact");
  AdmsSensFadType modelPar_zetabet=mod.zetabet;
  bool modelPar_given_zetabet=mod.given("zetabet");
  AdmsSensFadType modelPar_zetaci=mod.zetaci;
  bool modelPar_given_zetaci=mod.given("zetaci");
  AdmsSensFadType modelPar_alvs=mod.alvs;
  bool modelPar_given_alvs=mod.given("alvs");
  AdmsSensFadType modelPar_alces=mod.alces;
  bool modelPar_given_alces=mod.given("alces");
  AdmsSensFadType modelPar_zetarbi=mod.zetarbi;
  bool modelPar_given_zetarbi=mod.given("zetarbi");
  AdmsSensFadType modelPar_zetarbx=mod.zetarbx;
  bool modelPar_given_zetarbx=mod.given("zetarbx");
  AdmsSensFadType modelPar_zetarcx=mod.zetarcx;
  bool modelPar_given_zetarcx=mod.given("zetarcx");
  AdmsSensFadType modelPar_zetare=mod.zetare;
  bool modelPar_given_zetare=mod.given("zetare");
  AdmsSensFadType modelPar_zetaiqf=mod.zetaiqf;
  bool modelPar_given_zetaiqf=mod.given("zetaiqf");
  AdmsSensFadType modelPar_alkav=mod.alkav;
  bool modelPar_given_alkav=mod.given("alkav");
  AdmsSensFadType modelPar_aleav=mod.aleav;
  bool modelPar_given_aleav=mod.given("aleav");
  AdmsSensFadType modelPar_zetarth=mod.zetarth;
  bool modelPar_given_zetarth=mod.given("zetarth");
  AdmsSensFadType modelPar_zetaver=mod.zetaver;
  bool modelPar_given_zetaver=mod.given("zetaver");
  AdmsSensFadType modelPar_zetavgbe=mod.zetavgbe;
  bool modelPar_given_zetavgbe=mod.given("zetavgbe");
  AdmsSensFadType modelPar_dvgbe=mod.dvgbe;
  bool modelPar_given_dvgbe=mod.given("dvgbe");
  AdmsSensFadType modelPar_aliqfh=mod.aliqfh;
  bool modelPar_given_aliqfh=mod.given("aliqfh");
  AdmsSensFadType modelPar_kiqfh=mod.kiqfh;
  bool modelPar_given_kiqfh=mod.given("kiqfh");
  AdmsSensFadType modelPar_rth=mod.rth;
  bool modelPar_given_rth=mod.given("rth");
  AdmsSensFadType modelPar_cth=mod.cth;
  bool modelPar_given_cth=mod.given("cth");
  AdmsSensFadType modelPar_tnom=mod.tnom;
  bool modelPar_given_tnom=mod.given("tnom");


  // hidden reals


  // non-reals (including hiddens)
  int modelPar_it_mod=mod.it_mod;
  bool modelPar_given_it_mod=mod.given("it_mod");
  int modelPar_flnqs=mod.flnqs;
  bool modelPar_given_flnqs=mod.given("flnqs");
  int modelPar_tef_temp=mod.tef_temp;
  bool modelPar_given_tef_temp=mod.given("tef_temp");
  int modelPar_flsh=mod.flsh;
  bool modelPar_given_flsh=mod.given("flsh");
  int modelPar_type=mod.type;
  bool modelPar_given_type=mod.given("type");



  // Copy out all the instance parameters (doubles) into FAD types
  // Keep a map so we can set the right one to the independent variable
  // We do this solely to avoid a big ugly "if/else" block just to find the
  // one parameter we're doing sensitivities on.
  unordered_map <std::string,AdmsSensFadType*,HashNoCase,EqualNoCase> inParamMap;

  // reals
  AdmsSensFadType instancePar_dt=in.dt;
  bool instancePar_given_dt=in.given("dt");
  inParamMap["dt"] = &instancePar_dt;


  // Copy all the real hidden instance params into fad types



  // Copy all the non-real instance params into vars of their appropriate type:


  // Set the one parameter whose name was passed in to be the independent
  // variable for Sacado purposes.  Since we stored variable pointers, this
  // makes sure that that ONE variable gets set right.
  // FIXME: make this check the name first, otherwise segfault on invalid name!
  inParamMap[name]->diff(0,1);

  //make local copies of all instance vars
  //reals
  AdmsSensFadType instanceVar_qjci=in.qjci;
  AdmsSensFadType instanceVar_qjei=in.qjei;
  AdmsSensFadType instanceVar_it=in.it;
  AdmsSensFadType instanceVar_ijbc=in.ijbc;
  AdmsSensFadType instanceVar_iavl=in.iavl;
  AdmsSensFadType instanceVar_ijsc=in.ijsc;
  AdmsSensFadType instanceVar_Ibici=in.Ibici;
  AdmsSensFadType instanceVar_ijbe=in.ijbe;


  //non-reals


  //make local copies of all model vars
  //reals


  // non-reals



  Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

  // extract solution variables and set as Fad independent variables.
  probeVars[in.admsProbeID_V_xf_GND] = (*solVectorPtr)[in.li_xf];
  probeVars[in.admsProbeID_V_xf2_GND] = (*solVectorPtr)[in.li_xf2];
  probeVars[in.admsProbeID_V_xf1_GND] = (*solVectorPtr)[in.li_xf1];
  probeVars[in.admsProbeID_V_tnode_GND] = (*solVectorPtr)[in.li_tnode];
  probeVars[in.admsProbeID_V_b_e] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_e];
  probeVars[in.admsProbeID_V_b_bi] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_bi];
  probeVars[in.admsProbeID_V_ci_c] = (*solVectorPtr)[in.li_ci]- (*solVectorPtr)[in.li_c];
  probeVars[in.admsProbeID_V_ei_e] = (*solVectorPtr)[in.li_ei]- (*solVectorPtr)[in.li_e];
  probeVars[in.admsProbeID_V_s_ci] = (*solVectorPtr)[in.li_s]- (*solVectorPtr)[in.li_ci];
  probeVars[in.admsProbeID_V_ci_ei] = (*solVectorPtr)[in.li_ci]- (*solVectorPtr)[in.li_ei];
  probeVars[in.admsProbeID_V_bi_ei] = (*solVectorPtr)[in.li_bi]- (*solVectorPtr)[in.li_ei];
  probeVars[in.admsProbeID_V_bi_ci] = (*solVectorPtr)[in.li_bi]- (*solVectorPtr)[in.li_ci];
  probeVars[in.admsProbeID_V_b_ci] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_ci];




  // Now call  the function that does the heavy lifting.
  evaluateModelEquations(
     probeVars,
     // probe constants
     in.admsProbeID_V_xf_GND,
     in.admsProbeID_V_xf2_GND,
     in.admsProbeID_V_xf1_GND,
     in.admsProbeID_V_tnode_GND,
     in.admsProbeID_V_b_e,
     in.admsProbeID_V_b_bi,
     in.admsProbeID_V_ci_c,
     in.admsProbeID_V_ei_e,
     in.admsProbeID_V_s_ci,
     in.admsProbeID_V_ci_ei,
     in.admsProbeID_V_bi_ei,
     in.admsProbeID_V_bi_ci,
     in.admsProbeID_V_b_ci,

     // node constants
     in.admsNodeID_c,
     in.admsNodeID_b,
     in.admsNodeID_e,
     in.admsNodeID_s,
     in.admsNodeID_tnode,
     in.admsNodeID_ci,
     in.admsNodeID_bi,
     in.admsNodeID_ei,
     in.admsNodeID_xf1,
     in.admsNodeID_xf2,
     in.admsNodeID_xf,
     // instance parameters
     // reals
     instancePar_dt,
     instancePar_given_dt,
     // instance variables
     // reals
     instanceVar_qjci,
     instanceVar_qjei,
     instanceVar_it,
     instanceVar_ijbc,
     instanceVar_iavl,
     instanceVar_ijsc,
     instanceVar_Ibici,
     instanceVar_ijbe,
     // model parameters
     // reals
     modelPar_is,
     modelPar_given_is,
     modelPar_mcf,
     modelPar_given_mcf,
     modelPar_mcr,
     modelPar_given_mcr,
     modelPar_vef,
     modelPar_given_vef,
     modelPar_ver,
     modelPar_given_ver,
     modelPar_aver,
     modelPar_given_aver,
     modelPar_iqf,
     modelPar_given_iqf,
     modelPar_fiqf,
     modelPar_given_fiqf,
     modelPar_iqr,
     modelPar_given_iqr,
     modelPar_iqfh,
     modelPar_given_iqfh,
     modelPar_tfh,
     modelPar_given_tfh,
     modelPar_ahq,
     modelPar_given_ahq,
     modelPar_ibes,
     modelPar_given_ibes,
     modelPar_mbe,
     modelPar_given_mbe,
     modelPar_ires,
     modelPar_given_ires,
     modelPar_mre,
     modelPar_given_mre,
     modelPar_ibcs,
     modelPar_given_ibcs,
     modelPar_mbc,
     modelPar_given_mbc,
     modelPar_cje0,
     modelPar_given_cje0,
     modelPar_vde,
     modelPar_given_vde,
     modelPar_ze,
     modelPar_given_ze,
     modelPar_aje,
     modelPar_given_aje,
     modelPar_vdedc,
     modelPar_given_vdedc,
     modelPar_zedc,
     modelPar_given_zedc,
     modelPar_ajedc,
     modelPar_given_ajedc,
     modelPar_t0,
     modelPar_given_t0,
     modelPar_dt0h,
     modelPar_given_dt0h,
     modelPar_tbvl,
     modelPar_given_tbvl,
     modelPar_tef0,
     modelPar_given_tef0,
     modelPar_gte,
     modelPar_given_gte,
     modelPar_thcs,
     modelPar_given_thcs,
     modelPar_ahc,
     modelPar_given_ahc,
     modelPar_tr,
     modelPar_given_tr,
     modelPar_rci0,
     modelPar_given_rci0,
     modelPar_vlim,
     modelPar_given_vlim,
     modelPar_vpt,
     modelPar_given_vpt,
     modelPar_vces,
     modelPar_given_vces,
     modelPar_cjci0,
     modelPar_given_cjci0,
     modelPar_vdci,
     modelPar_given_vdci,
     modelPar_zci,
     modelPar_given_zci,
     modelPar_vptci,
     modelPar_given_vptci,
     modelPar_cjcx0,
     modelPar_given_cjcx0,
     modelPar_vdcx,
     modelPar_given_vdcx,
     modelPar_zcx,
     modelPar_given_zcx,
     modelPar_vptcx,
     modelPar_given_vptcx,
     modelPar_fbc,
     modelPar_given_fbc,
     modelPar_rbi0,
     modelPar_given_rbi0,
     modelPar_vr0e,
     modelPar_given_vr0e,
     modelPar_vr0c,
     modelPar_given_vr0c,
     modelPar_fgeo,
     modelPar_given_fgeo,
     modelPar_rbx,
     modelPar_given_rbx,
     modelPar_rcx,
     modelPar_given_rcx,
     modelPar_re,
     modelPar_given_re,
     modelPar_itss,
     modelPar_given_itss,
     modelPar_msf,
     modelPar_given_msf,
     modelPar_iscs,
     modelPar_given_iscs,
     modelPar_msc,
     modelPar_given_msc,
     modelPar_cjs0,
     modelPar_given_cjs0,
     modelPar_vds,
     modelPar_given_vds,
     modelPar_zs,
     modelPar_given_zs,
     modelPar_vpts,
     modelPar_given_vpts,
     modelPar_cbcpar,
     modelPar_given_cbcpar,
     modelPar_cbepar,
     modelPar_given_cbepar,
     modelPar_eavl,
     modelPar_given_eavl,
     modelPar_kavl,
     modelPar_given_kavl,
     modelPar_kf,
     modelPar_given_kf,
     modelPar_af,
     modelPar_given_af,
     modelPar_alqf,
     modelPar_given_alqf,
     modelPar_alit,
     modelPar_given_alit,
     modelPar_vgb,
     modelPar_given_vgb,
     modelPar_vge,
     modelPar_given_vge,
     modelPar_vgc,
     modelPar_given_vgc,
     modelPar_vgs,
     modelPar_given_vgs,
     modelPar_f1vg,
     modelPar_given_f1vg,
     modelPar_f2vg,
     modelPar_given_f2vg,
     modelPar_alt0,
     modelPar_given_alt0,
     modelPar_kt0,
     modelPar_given_kt0,
     modelPar_zetact,
     modelPar_given_zetact,
     modelPar_zetabet,
     modelPar_given_zetabet,
     modelPar_zetaci,
     modelPar_given_zetaci,
     modelPar_alvs,
     modelPar_given_alvs,
     modelPar_alces,
     modelPar_given_alces,
     modelPar_zetarbi,
     modelPar_given_zetarbi,
     modelPar_zetarbx,
     modelPar_given_zetarbx,
     modelPar_zetarcx,
     modelPar_given_zetarcx,
     modelPar_zetare,
     modelPar_given_zetare,
     modelPar_zetaiqf,
     modelPar_given_zetaiqf,
     modelPar_alkav,
     modelPar_given_alkav,
     modelPar_aleav,
     modelPar_given_aleav,
     modelPar_zetarth,
     modelPar_given_zetarth,
     modelPar_zetaver,
     modelPar_given_zetaver,
     modelPar_zetavgbe,
     modelPar_given_zetavgbe,
     modelPar_dvgbe,
     modelPar_given_dvgbe,
     modelPar_aliqfh,
     modelPar_given_aliqfh,
     modelPar_kiqfh,
     modelPar_given_kiqfh,
     modelPar_rth,
     modelPar_given_rth,
     modelPar_cth,
     modelPar_given_cth,
     modelPar_tnom,
     modelPar_given_tnom,
     // non-reals (including hidden)
     modelPar_it_mod,
     modelPar_given_it_mod,
     modelPar_flnqs,
     modelPar_given_flnqs,
     modelPar_tef_temp,
     modelPar_given_tef_temp,
     modelPar_flsh,
     modelPar_given_flsh,
     modelPar_type,
     modelPar_given_type,
     in.admsTemperature,
     in.adms_vt_nom,
     in.getDeviceOptions().gmin,
     staticContributions,
     dynamicContributions,
     in);


  // We now have the F and Q vector stuff, populate the dependencies:

  dfdp[in.admsNodeID_c] += staticContributions[in.admsNodeID_c].dx(0);
  dqdp[in.admsNodeID_c] += dynamicContributions[in.admsNodeID_c].dx(0);
  Findices[in.admsNodeID_c] = in.li_c;
  Qindices[in.admsNodeID_c] = in.li_c;
  dfdp[in.admsNodeID_b] += staticContributions[in.admsNodeID_b].dx(0);
  dqdp[in.admsNodeID_b] += dynamicContributions[in.admsNodeID_b].dx(0);
  Findices[in.admsNodeID_b] = in.li_b;
  Qindices[in.admsNodeID_b] = in.li_b;
  dfdp[in.admsNodeID_e] += staticContributions[in.admsNodeID_e].dx(0);
  dqdp[in.admsNodeID_e] += dynamicContributions[in.admsNodeID_e].dx(0);
  Findices[in.admsNodeID_e] = in.li_e;
  Qindices[in.admsNodeID_e] = in.li_e;
  dfdp[in.admsNodeID_s] += staticContributions[in.admsNodeID_s].dx(0);
  dqdp[in.admsNodeID_s] += dynamicContributions[in.admsNodeID_s].dx(0);
  Findices[in.admsNodeID_s] = in.li_s;
  Qindices[in.admsNodeID_s] = in.li_s;
  dfdp[in.admsNodeID_tnode] += staticContributions[in.admsNodeID_tnode].dx(0);
  dqdp[in.admsNodeID_tnode] += dynamicContributions[in.admsNodeID_tnode].dx(0);
  Findices[in.admsNodeID_tnode] = in.li_tnode;
  Qindices[in.admsNodeID_tnode] = in.li_tnode;
  dfdp[in.admsNodeID_ci] += staticContributions[in.admsNodeID_ci].dx(0);
  dqdp[in.admsNodeID_ci] += dynamicContributions[in.admsNodeID_ci].dx(0);
  Findices[in.admsNodeID_ci] = in.li_ci;
  Qindices[in.admsNodeID_ci] = in.li_ci;
  dfdp[in.admsNodeID_bi] += staticContributions[in.admsNodeID_bi].dx(0);
  dqdp[in.admsNodeID_bi] += dynamicContributions[in.admsNodeID_bi].dx(0);
  Findices[in.admsNodeID_bi] = in.li_bi;
  Qindices[in.admsNodeID_bi] = in.li_bi;
  dfdp[in.admsNodeID_ei] += staticContributions[in.admsNodeID_ei].dx(0);
  dqdp[in.admsNodeID_ei] += dynamicContributions[in.admsNodeID_ei].dx(0);
  Findices[in.admsNodeID_ei] = in.li_ei;
  Qindices[in.admsNodeID_ei] = in.li_ei;
  dfdp[in.admsNodeID_xf1] += staticContributions[in.admsNodeID_xf1].dx(0);
  dqdp[in.admsNodeID_xf1] += dynamicContributions[in.admsNodeID_xf1].dx(0);
  Findices[in.admsNodeID_xf1] = in.li_xf1;
  Qindices[in.admsNodeID_xf1] = in.li_xf1;
  dfdp[in.admsNodeID_xf2] += staticContributions[in.admsNodeID_xf2].dx(0);
  dqdp[in.admsNodeID_xf2] += dynamicContributions[in.admsNodeID_xf2].dx(0);
  Findices[in.admsNodeID_xf2] = in.li_xf2;
  Qindices[in.admsNodeID_xf2] = in.li_xf2;
  dfdp[in.admsNodeID_xf] += staticContributions[in.admsNodeID_xf].dx(0);
  dqdp[in.admsNodeID_xf] += dynamicContributions[in.admsNodeID_xf].dx(0);
  Findices[in.admsNodeID_xf] = in.li_xf;
  Qindices[in.admsNodeID_xf] = in.li_xf;


}

//-----------------------------------------------------------------------------
// Function      : ModelSensitivity::operator()
// Purpose       : return sensitivity for a single model parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
/// Compute sensitivity to a specified model
/// parameter of all device instances of that model's outputs
/// 
/// 
/// @param[in] entity  The device entity that owns the parameter 
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
/// 
/// 
void ModelSensitivity::operator()
  (
     const ParameterBase &entity,
     const std::string &name,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
   ) const
{
  const ParameterBase * e1 = &entity;
  const Model & mod = *(dynamic_cast<const Model *> (e1));
  int sizeInstance = mod.instanceContainer.size();

  dfdp.resize((11+0)*sizeInstance);
  dqdp.resize((11+0)*sizeInstance);
  Findices.resize((11+0)*sizeInstance);
  Qindices.resize((11+0)*sizeInstance);

  std::vector <double> probeVars(13);
  std::vector <AdmsSensFadType> staticContributions(11+0);
  std::vector <AdmsSensFadType> dynamicContributions(11+0);


  // Copy out all the model parameters (doubles) into FAD types
  // Keep a map so we can set the right one to the independent variable
  // We do this solely to avoid a big ugly "if/else" block just to find the
  // one parameter we're doing sensitivities on.
  unordered_map <std::string,AdmsSensFadType*,HashNoCase,EqualNoCase> modParamMap;

  // reals
  AdmsSensFadType modelPar_is=mod.is;
  bool modelPar_given_is=mod.given("is");
  modParamMap["is"] = &modelPar_is;
  AdmsSensFadType modelPar_mcf=mod.mcf;
  bool modelPar_given_mcf=mod.given("mcf");
  modParamMap["mcf"] = &modelPar_mcf;
  AdmsSensFadType modelPar_mcr=mod.mcr;
  bool modelPar_given_mcr=mod.given("mcr");
  modParamMap["mcr"] = &modelPar_mcr;
  AdmsSensFadType modelPar_vef=mod.vef;
  bool modelPar_given_vef=mod.given("vef");
  modParamMap["vef"] = &modelPar_vef;
  AdmsSensFadType modelPar_ver=mod.ver;
  bool modelPar_given_ver=mod.given("ver");
  modParamMap["ver"] = &modelPar_ver;
  AdmsSensFadType modelPar_aver=mod.aver;
  bool modelPar_given_aver=mod.given("aver");
  modParamMap["aver"] = &modelPar_aver;
  AdmsSensFadType modelPar_iqf=mod.iqf;
  bool modelPar_given_iqf=mod.given("iqf");
  modParamMap["iqf"] = &modelPar_iqf;
  AdmsSensFadType modelPar_fiqf=mod.fiqf;
  bool modelPar_given_fiqf=mod.given("fiqf");
  modParamMap["fiqf"] = &modelPar_fiqf;
  AdmsSensFadType modelPar_iqr=mod.iqr;
  bool modelPar_given_iqr=mod.given("iqr");
  modParamMap["iqr"] = &modelPar_iqr;
  AdmsSensFadType modelPar_iqfh=mod.iqfh;
  bool modelPar_given_iqfh=mod.given("iqfh");
  modParamMap["iqfh"] = &modelPar_iqfh;
  AdmsSensFadType modelPar_tfh=mod.tfh;
  bool modelPar_given_tfh=mod.given("tfh");
  modParamMap["tfh"] = &modelPar_tfh;
  AdmsSensFadType modelPar_ahq=mod.ahq;
  bool modelPar_given_ahq=mod.given("ahq");
  modParamMap["ahq"] = &modelPar_ahq;
  AdmsSensFadType modelPar_ibes=mod.ibes;
  bool modelPar_given_ibes=mod.given("ibes");
  modParamMap["ibes"] = &modelPar_ibes;
  AdmsSensFadType modelPar_mbe=mod.mbe;
  bool modelPar_given_mbe=mod.given("mbe");
  modParamMap["mbe"] = &modelPar_mbe;
  AdmsSensFadType modelPar_ires=mod.ires;
  bool modelPar_given_ires=mod.given("ires");
  modParamMap["ires"] = &modelPar_ires;
  AdmsSensFadType modelPar_mre=mod.mre;
  bool modelPar_given_mre=mod.given("mre");
  modParamMap["mre"] = &modelPar_mre;
  AdmsSensFadType modelPar_ibcs=mod.ibcs;
  bool modelPar_given_ibcs=mod.given("ibcs");
  modParamMap["ibcs"] = &modelPar_ibcs;
  AdmsSensFadType modelPar_mbc=mod.mbc;
  bool modelPar_given_mbc=mod.given("mbc");
  modParamMap["mbc"] = &modelPar_mbc;
  AdmsSensFadType modelPar_cje0=mod.cje0;
  bool modelPar_given_cje0=mod.given("cje0");
  modParamMap["cje0"] = &modelPar_cje0;
  AdmsSensFadType modelPar_vde=mod.vde;
  bool modelPar_given_vde=mod.given("vde");
  modParamMap["vde"] = &modelPar_vde;
  AdmsSensFadType modelPar_ze=mod.ze;
  bool modelPar_given_ze=mod.given("ze");
  modParamMap["ze"] = &modelPar_ze;
  AdmsSensFadType modelPar_aje=mod.aje;
  bool modelPar_given_aje=mod.given("aje");
  modParamMap["aje"] = &modelPar_aje;
  AdmsSensFadType modelPar_vdedc=mod.vdedc;
  bool modelPar_given_vdedc=mod.given("vdedc");
  modParamMap["vdedc"] = &modelPar_vdedc;
  AdmsSensFadType modelPar_zedc=mod.zedc;
  bool modelPar_given_zedc=mod.given("zedc");
  modParamMap["zedc"] = &modelPar_zedc;
  AdmsSensFadType modelPar_ajedc=mod.ajedc;
  bool modelPar_given_ajedc=mod.given("ajedc");
  modParamMap["ajedc"] = &modelPar_ajedc;
  AdmsSensFadType modelPar_t0=mod.t0;
  bool modelPar_given_t0=mod.given("t0");
  modParamMap["t0"] = &modelPar_t0;
  AdmsSensFadType modelPar_dt0h=mod.dt0h;
  bool modelPar_given_dt0h=mod.given("dt0h");
  modParamMap["dt0h"] = &modelPar_dt0h;
  AdmsSensFadType modelPar_tbvl=mod.tbvl;
  bool modelPar_given_tbvl=mod.given("tbvl");
  modParamMap["tbvl"] = &modelPar_tbvl;
  AdmsSensFadType modelPar_tef0=mod.tef0;
  bool modelPar_given_tef0=mod.given("tef0");
  modParamMap["tef0"] = &modelPar_tef0;
  AdmsSensFadType modelPar_gte=mod.gte;
  bool modelPar_given_gte=mod.given("gte");
  modParamMap["gte"] = &modelPar_gte;
  AdmsSensFadType modelPar_thcs=mod.thcs;
  bool modelPar_given_thcs=mod.given("thcs");
  modParamMap["thcs"] = &modelPar_thcs;
  AdmsSensFadType modelPar_ahc=mod.ahc;
  bool modelPar_given_ahc=mod.given("ahc");
  modParamMap["ahc"] = &modelPar_ahc;
  AdmsSensFadType modelPar_tr=mod.tr;
  bool modelPar_given_tr=mod.given("tr");
  modParamMap["tr"] = &modelPar_tr;
  AdmsSensFadType modelPar_rci0=mod.rci0;
  bool modelPar_given_rci0=mod.given("rci0");
  modParamMap["rci0"] = &modelPar_rci0;
  AdmsSensFadType modelPar_vlim=mod.vlim;
  bool modelPar_given_vlim=mod.given("vlim");
  modParamMap["vlim"] = &modelPar_vlim;
  AdmsSensFadType modelPar_vpt=mod.vpt;
  bool modelPar_given_vpt=mod.given("vpt");
  modParamMap["vpt"] = &modelPar_vpt;
  AdmsSensFadType modelPar_vces=mod.vces;
  bool modelPar_given_vces=mod.given("vces");
  modParamMap["vces"] = &modelPar_vces;
  AdmsSensFadType modelPar_cjci0=mod.cjci0;
  bool modelPar_given_cjci0=mod.given("cjci0");
  modParamMap["cjci0"] = &modelPar_cjci0;
  AdmsSensFadType modelPar_vdci=mod.vdci;
  bool modelPar_given_vdci=mod.given("vdci");
  modParamMap["vdci"] = &modelPar_vdci;
  AdmsSensFadType modelPar_zci=mod.zci;
  bool modelPar_given_zci=mod.given("zci");
  modParamMap["zci"] = &modelPar_zci;
  AdmsSensFadType modelPar_vptci=mod.vptci;
  bool modelPar_given_vptci=mod.given("vptci");
  modParamMap["vptci"] = &modelPar_vptci;
  AdmsSensFadType modelPar_cjcx0=mod.cjcx0;
  bool modelPar_given_cjcx0=mod.given("cjcx0");
  modParamMap["cjcx0"] = &modelPar_cjcx0;
  AdmsSensFadType modelPar_vdcx=mod.vdcx;
  bool modelPar_given_vdcx=mod.given("vdcx");
  modParamMap["vdcx"] = &modelPar_vdcx;
  AdmsSensFadType modelPar_zcx=mod.zcx;
  bool modelPar_given_zcx=mod.given("zcx");
  modParamMap["zcx"] = &modelPar_zcx;
  AdmsSensFadType modelPar_vptcx=mod.vptcx;
  bool modelPar_given_vptcx=mod.given("vptcx");
  modParamMap["vptcx"] = &modelPar_vptcx;
  AdmsSensFadType modelPar_fbc=mod.fbc;
  bool modelPar_given_fbc=mod.given("fbc");
  modParamMap["fbc"] = &modelPar_fbc;
  AdmsSensFadType modelPar_rbi0=mod.rbi0;
  bool modelPar_given_rbi0=mod.given("rbi0");
  modParamMap["rbi0"] = &modelPar_rbi0;
  AdmsSensFadType modelPar_vr0e=mod.vr0e;
  bool modelPar_given_vr0e=mod.given("vr0e");
  modParamMap["vr0e"] = &modelPar_vr0e;
  AdmsSensFadType modelPar_vr0c=mod.vr0c;
  bool modelPar_given_vr0c=mod.given("vr0c");
  modParamMap["vr0c"] = &modelPar_vr0c;
  AdmsSensFadType modelPar_fgeo=mod.fgeo;
  bool modelPar_given_fgeo=mod.given("fgeo");
  modParamMap["fgeo"] = &modelPar_fgeo;
  AdmsSensFadType modelPar_rbx=mod.rbx;
  bool modelPar_given_rbx=mod.given("rbx");
  modParamMap["rbx"] = &modelPar_rbx;
  AdmsSensFadType modelPar_rcx=mod.rcx;
  bool modelPar_given_rcx=mod.given("rcx");
  modParamMap["rcx"] = &modelPar_rcx;
  AdmsSensFadType modelPar_re=mod.re;
  bool modelPar_given_re=mod.given("re");
  modParamMap["re"] = &modelPar_re;
  AdmsSensFadType modelPar_itss=mod.itss;
  bool modelPar_given_itss=mod.given("itss");
  modParamMap["itss"] = &modelPar_itss;
  AdmsSensFadType modelPar_msf=mod.msf;
  bool modelPar_given_msf=mod.given("msf");
  modParamMap["msf"] = &modelPar_msf;
  AdmsSensFadType modelPar_iscs=mod.iscs;
  bool modelPar_given_iscs=mod.given("iscs");
  modParamMap["iscs"] = &modelPar_iscs;
  AdmsSensFadType modelPar_msc=mod.msc;
  bool modelPar_given_msc=mod.given("msc");
  modParamMap["msc"] = &modelPar_msc;
  AdmsSensFadType modelPar_cjs0=mod.cjs0;
  bool modelPar_given_cjs0=mod.given("cjs0");
  modParamMap["cjs0"] = &modelPar_cjs0;
  AdmsSensFadType modelPar_vds=mod.vds;
  bool modelPar_given_vds=mod.given("vds");
  modParamMap["vds"] = &modelPar_vds;
  AdmsSensFadType modelPar_zs=mod.zs;
  bool modelPar_given_zs=mod.given("zs");
  modParamMap["zs"] = &modelPar_zs;
  AdmsSensFadType modelPar_vpts=mod.vpts;
  bool modelPar_given_vpts=mod.given("vpts");
  modParamMap["vpts"] = &modelPar_vpts;
  AdmsSensFadType modelPar_cbcpar=mod.cbcpar;
  bool modelPar_given_cbcpar=mod.given("cbcpar");
  modParamMap["cbcpar"] = &modelPar_cbcpar;
  AdmsSensFadType modelPar_cbepar=mod.cbepar;
  bool modelPar_given_cbepar=mod.given("cbepar");
  modParamMap["cbepar"] = &modelPar_cbepar;
  AdmsSensFadType modelPar_eavl=mod.eavl;
  bool modelPar_given_eavl=mod.given("eavl");
  modParamMap["eavl"] = &modelPar_eavl;
  AdmsSensFadType modelPar_kavl=mod.kavl;
  bool modelPar_given_kavl=mod.given("kavl");
  modParamMap["kavl"] = &modelPar_kavl;
  AdmsSensFadType modelPar_kf=mod.kf;
  bool modelPar_given_kf=mod.given("kf");
  modParamMap["kf"] = &modelPar_kf;
  AdmsSensFadType modelPar_af=mod.af;
  bool modelPar_given_af=mod.given("af");
  modParamMap["af"] = &modelPar_af;
  AdmsSensFadType modelPar_alqf=mod.alqf;
  bool modelPar_given_alqf=mod.given("alqf");
  modParamMap["alqf"] = &modelPar_alqf;
  AdmsSensFadType modelPar_alit=mod.alit;
  bool modelPar_given_alit=mod.given("alit");
  modParamMap["alit"] = &modelPar_alit;
  AdmsSensFadType modelPar_vgb=mod.vgb;
  bool modelPar_given_vgb=mod.given("vgb");
  modParamMap["vgb"] = &modelPar_vgb;
  AdmsSensFadType modelPar_vge=mod.vge;
  bool modelPar_given_vge=mod.given("vge");
  modParamMap["vge"] = &modelPar_vge;
  AdmsSensFadType modelPar_vgc=mod.vgc;
  bool modelPar_given_vgc=mod.given("vgc");
  modParamMap["vgc"] = &modelPar_vgc;
  AdmsSensFadType modelPar_vgs=mod.vgs;
  bool modelPar_given_vgs=mod.given("vgs");
  modParamMap["vgs"] = &modelPar_vgs;
  AdmsSensFadType modelPar_f1vg=mod.f1vg;
  bool modelPar_given_f1vg=mod.given("f1vg");
  modParamMap["f1vg"] = &modelPar_f1vg;
  AdmsSensFadType modelPar_f2vg=mod.f2vg;
  bool modelPar_given_f2vg=mod.given("f2vg");
  modParamMap["f2vg"] = &modelPar_f2vg;
  AdmsSensFadType modelPar_alt0=mod.alt0;
  bool modelPar_given_alt0=mod.given("alt0");
  modParamMap["alt0"] = &modelPar_alt0;
  AdmsSensFadType modelPar_kt0=mod.kt0;
  bool modelPar_given_kt0=mod.given("kt0");
  modParamMap["kt0"] = &modelPar_kt0;
  AdmsSensFadType modelPar_zetact=mod.zetact;
  bool modelPar_given_zetact=mod.given("zetact");
  modParamMap["zetact"] = &modelPar_zetact;
  AdmsSensFadType modelPar_zetabet=mod.zetabet;
  bool modelPar_given_zetabet=mod.given("zetabet");
  modParamMap["zetabet"] = &modelPar_zetabet;
  AdmsSensFadType modelPar_zetaci=mod.zetaci;
  bool modelPar_given_zetaci=mod.given("zetaci");
  modParamMap["zetaci"] = &modelPar_zetaci;
  AdmsSensFadType modelPar_alvs=mod.alvs;
  bool modelPar_given_alvs=mod.given("alvs");
  modParamMap["alvs"] = &modelPar_alvs;
  AdmsSensFadType modelPar_alces=mod.alces;
  bool modelPar_given_alces=mod.given("alces");
  modParamMap["alces"] = &modelPar_alces;
  AdmsSensFadType modelPar_zetarbi=mod.zetarbi;
  bool modelPar_given_zetarbi=mod.given("zetarbi");
  modParamMap["zetarbi"] = &modelPar_zetarbi;
  AdmsSensFadType modelPar_zetarbx=mod.zetarbx;
  bool modelPar_given_zetarbx=mod.given("zetarbx");
  modParamMap["zetarbx"] = &modelPar_zetarbx;
  AdmsSensFadType modelPar_zetarcx=mod.zetarcx;
  bool modelPar_given_zetarcx=mod.given("zetarcx");
  modParamMap["zetarcx"] = &modelPar_zetarcx;
  AdmsSensFadType modelPar_zetare=mod.zetare;
  bool modelPar_given_zetare=mod.given("zetare");
  modParamMap["zetare"] = &modelPar_zetare;
  AdmsSensFadType modelPar_zetaiqf=mod.zetaiqf;
  bool modelPar_given_zetaiqf=mod.given("zetaiqf");
  modParamMap["zetaiqf"] = &modelPar_zetaiqf;
  AdmsSensFadType modelPar_alkav=mod.alkav;
  bool modelPar_given_alkav=mod.given("alkav");
  modParamMap["alkav"] = &modelPar_alkav;
  AdmsSensFadType modelPar_aleav=mod.aleav;
  bool modelPar_given_aleav=mod.given("aleav");
  modParamMap["aleav"] = &modelPar_aleav;
  AdmsSensFadType modelPar_zetarth=mod.zetarth;
  bool modelPar_given_zetarth=mod.given("zetarth");
  modParamMap["zetarth"] = &modelPar_zetarth;
  AdmsSensFadType modelPar_zetaver=mod.zetaver;
  bool modelPar_given_zetaver=mod.given("zetaver");
  modParamMap["zetaver"] = &modelPar_zetaver;
  AdmsSensFadType modelPar_zetavgbe=mod.zetavgbe;
  bool modelPar_given_zetavgbe=mod.given("zetavgbe");
  modParamMap["zetavgbe"] = &modelPar_zetavgbe;
  AdmsSensFadType modelPar_dvgbe=mod.dvgbe;
  bool modelPar_given_dvgbe=mod.given("dvgbe");
  modParamMap["dvgbe"] = &modelPar_dvgbe;
  AdmsSensFadType modelPar_aliqfh=mod.aliqfh;
  bool modelPar_given_aliqfh=mod.given("aliqfh");
  modParamMap["aliqfh"] = &modelPar_aliqfh;
  AdmsSensFadType modelPar_kiqfh=mod.kiqfh;
  bool modelPar_given_kiqfh=mod.given("kiqfh");
  modParamMap["kiqfh"] = &modelPar_kiqfh;
  AdmsSensFadType modelPar_rth=mod.rth;
  bool modelPar_given_rth=mod.given("rth");
  modParamMap["rth"] = &modelPar_rth;
  AdmsSensFadType modelPar_cth=mod.cth;
  bool modelPar_given_cth=mod.given("cth");
  modParamMap["cth"] = &modelPar_cth;
  AdmsSensFadType modelPar_tnom=mod.tnom;
  bool modelPar_given_tnom=mod.given("tnom");
  modParamMap["tnom"] = &modelPar_tnom;


  // hidden reals


  // non-reals (including hiddens)
  int modelPar_it_mod=mod.it_mod;
  bool modelPar_given_it_mod=mod.given("it_mod");
  int modelPar_flnqs=mod.flnqs;
  bool modelPar_given_flnqs=mod.given("flnqs");
  int modelPar_tef_temp=mod.tef_temp;
  bool modelPar_given_tef_temp=mod.given("tef_temp");
  int modelPar_flsh=mod.flsh;
  bool modelPar_given_flsh=mod.given("flsh");
  int modelPar_type=mod.type;
  bool modelPar_given_type=mod.given("type");


  // Set the one parameter whose name was passed in to be the independent
  // variable for Sacado purposes.  Since we stored variable pointers, this
  // makes sure that that ONE variable gets set right.
  // FIXME: make this check name for presence first!  Segfault on invalid.
  modParamMap[name]->diff(0,1);

  //make local copies of all model vars
  //reals


  // non-reals



  // Now loop over all instances and do the deed
  int inst=0;
  for (std::vector<Instance*>::const_iterator in_it=mod.instanceContainer.begin(); in_it != mod.instanceContainer.end(); ++in_it,++inst)
  {

    Instance & in=*(*in_it);
    // initialize contributions to zero (automatically sets derivatives to zero)
    for (int i=0; i < 11+0 ; ++i)
    {
      staticContributions[i]=0;
      dynamicContributions[i]=0;
    }



    // Copy out all the instance parameters (doubles) into FAD types
    // reals
    AdmsSensFadType instancePar_dt=in.dt;
    bool instancePar_given_dt=in.given("dt");


    // real hidden instance


    // Copy all the non-real instance params into vars of their appropriate type:




    // If there are any instance parameters that were not given, and have
    // corresponding model params, copy the model param into the instance.
    // This was already done by the instance constructor, but we do it again
    // because now we're propagating derivatives, and the user could be trying
    // to get sensitivity to the model parameter.
  

    //make local copies of all instance vars
    //reals
    AdmsSensFadType instanceVar_qjci=in.qjci;
    AdmsSensFadType instanceVar_qjei=in.qjei;
    AdmsSensFadType instanceVar_it=in.it;
    AdmsSensFadType instanceVar_ijbc=in.ijbc;
    AdmsSensFadType instanceVar_iavl=in.iavl;
    AdmsSensFadType instanceVar_ijsc=in.ijsc;
    AdmsSensFadType instanceVar_Ibici=in.Ibici;
    AdmsSensFadType instanceVar_ijbe=in.ijbe;

  
    //non-reals
  
  
  
    Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

    // extract solution variables and set as Fad independent variables.
    probeVars[in.admsProbeID_V_xf_GND] = (*solVectorPtr)[in.li_xf];
    probeVars[in.admsProbeID_V_xf2_GND] = (*solVectorPtr)[in.li_xf2];
    probeVars[in.admsProbeID_V_xf1_GND] = (*solVectorPtr)[in.li_xf1];
    probeVars[in.admsProbeID_V_tnode_GND] = (*solVectorPtr)[in.li_tnode];
    probeVars[in.admsProbeID_V_b_e] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_e];
    probeVars[in.admsProbeID_V_b_bi] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_bi];
    probeVars[in.admsProbeID_V_ci_c] = (*solVectorPtr)[in.li_ci] - (*solVectorPtr)[in.li_c];
    probeVars[in.admsProbeID_V_ei_e] = (*solVectorPtr)[in.li_ei] - (*solVectorPtr)[in.li_e];
    probeVars[in.admsProbeID_V_s_ci] = (*solVectorPtr)[in.li_s] - (*solVectorPtr)[in.li_ci];
    probeVars[in.admsProbeID_V_ci_ei] = (*solVectorPtr)[in.li_ci] - (*solVectorPtr)[in.li_ei];
    probeVars[in.admsProbeID_V_bi_ei] = (*solVectorPtr)[in.li_bi] - (*solVectorPtr)[in.li_ei];
    probeVars[in.admsProbeID_V_bi_ci] = (*solVectorPtr)[in.li_bi] - (*solVectorPtr)[in.li_ci];
    probeVars[in.admsProbeID_V_b_ci] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_ci];




    // Now call  the function that does the heavy lifting.

    evaluateModelEquations(
       probeVars,
       // probe constants
       in.admsProbeID_V_xf_GND,
       in.admsProbeID_V_xf2_GND,
       in.admsProbeID_V_xf1_GND,
       in.admsProbeID_V_tnode_GND,
       in.admsProbeID_V_b_e,
       in.admsProbeID_V_b_bi,
       in.admsProbeID_V_ci_c,
       in.admsProbeID_V_ei_e,
       in.admsProbeID_V_s_ci,
       in.admsProbeID_V_ci_ei,
       in.admsProbeID_V_bi_ei,
       in.admsProbeID_V_bi_ci,
       in.admsProbeID_V_b_ci,

       // node constants
       in.admsNodeID_c,
       in.admsNodeID_b,
       in.admsNodeID_e,
       in.admsNodeID_s,
       in.admsNodeID_tnode,
       in.admsNodeID_ci,
       in.admsNodeID_bi,
       in.admsNodeID_ei,
       in.admsNodeID_xf1,
       in.admsNodeID_xf2,
       in.admsNodeID_xf,
       // instance parameters
       // reals
       instancePar_dt,
       instancePar_given_dt,
       // instance variables
       // reals
       instanceVar_qjci,
       instanceVar_qjei,
       instanceVar_it,
       instanceVar_ijbc,
       instanceVar_iavl,
       instanceVar_ijsc,
       instanceVar_Ibici,
       instanceVar_ijbe,
       // model parameters
       // reals
       modelPar_is,
       modelPar_given_is,
       modelPar_mcf,
       modelPar_given_mcf,
       modelPar_mcr,
       modelPar_given_mcr,
       modelPar_vef,
       modelPar_given_vef,
       modelPar_ver,
       modelPar_given_ver,
       modelPar_aver,
       modelPar_given_aver,
       modelPar_iqf,
       modelPar_given_iqf,
       modelPar_fiqf,
       modelPar_given_fiqf,
       modelPar_iqr,
       modelPar_given_iqr,
       modelPar_iqfh,
       modelPar_given_iqfh,
       modelPar_tfh,
       modelPar_given_tfh,
       modelPar_ahq,
       modelPar_given_ahq,
       modelPar_ibes,
       modelPar_given_ibes,
       modelPar_mbe,
       modelPar_given_mbe,
       modelPar_ires,
       modelPar_given_ires,
       modelPar_mre,
       modelPar_given_mre,
       modelPar_ibcs,
       modelPar_given_ibcs,
       modelPar_mbc,
       modelPar_given_mbc,
       modelPar_cje0,
       modelPar_given_cje0,
       modelPar_vde,
       modelPar_given_vde,
       modelPar_ze,
       modelPar_given_ze,
       modelPar_aje,
       modelPar_given_aje,
       modelPar_vdedc,
       modelPar_given_vdedc,
       modelPar_zedc,
       modelPar_given_zedc,
       modelPar_ajedc,
       modelPar_given_ajedc,
       modelPar_t0,
       modelPar_given_t0,
       modelPar_dt0h,
       modelPar_given_dt0h,
       modelPar_tbvl,
       modelPar_given_tbvl,
       modelPar_tef0,
       modelPar_given_tef0,
       modelPar_gte,
       modelPar_given_gte,
       modelPar_thcs,
       modelPar_given_thcs,
       modelPar_ahc,
       modelPar_given_ahc,
       modelPar_tr,
       modelPar_given_tr,
       modelPar_rci0,
       modelPar_given_rci0,
       modelPar_vlim,
       modelPar_given_vlim,
       modelPar_vpt,
       modelPar_given_vpt,
       modelPar_vces,
       modelPar_given_vces,
       modelPar_cjci0,
       modelPar_given_cjci0,
       modelPar_vdci,
       modelPar_given_vdci,
       modelPar_zci,
       modelPar_given_zci,
       modelPar_vptci,
       modelPar_given_vptci,
       modelPar_cjcx0,
       modelPar_given_cjcx0,
       modelPar_vdcx,
       modelPar_given_vdcx,
       modelPar_zcx,
       modelPar_given_zcx,
       modelPar_vptcx,
       modelPar_given_vptcx,
       modelPar_fbc,
       modelPar_given_fbc,
       modelPar_rbi0,
       modelPar_given_rbi0,
       modelPar_vr0e,
       modelPar_given_vr0e,
       modelPar_vr0c,
       modelPar_given_vr0c,
       modelPar_fgeo,
       modelPar_given_fgeo,
       modelPar_rbx,
       modelPar_given_rbx,
       modelPar_rcx,
       modelPar_given_rcx,
       modelPar_re,
       modelPar_given_re,
       modelPar_itss,
       modelPar_given_itss,
       modelPar_msf,
       modelPar_given_msf,
       modelPar_iscs,
       modelPar_given_iscs,
       modelPar_msc,
       modelPar_given_msc,
       modelPar_cjs0,
       modelPar_given_cjs0,
       modelPar_vds,
       modelPar_given_vds,
       modelPar_zs,
       modelPar_given_zs,
       modelPar_vpts,
       modelPar_given_vpts,
       modelPar_cbcpar,
       modelPar_given_cbcpar,
       modelPar_cbepar,
       modelPar_given_cbepar,
       modelPar_eavl,
       modelPar_given_eavl,
       modelPar_kavl,
       modelPar_given_kavl,
       modelPar_kf,
       modelPar_given_kf,
       modelPar_af,
       modelPar_given_af,
       modelPar_alqf,
       modelPar_given_alqf,
       modelPar_alit,
       modelPar_given_alit,
       modelPar_vgb,
       modelPar_given_vgb,
       modelPar_vge,
       modelPar_given_vge,
       modelPar_vgc,
       modelPar_given_vgc,
       modelPar_vgs,
       modelPar_given_vgs,
       modelPar_f1vg,
       modelPar_given_f1vg,
       modelPar_f2vg,
       modelPar_given_f2vg,
       modelPar_alt0,
       modelPar_given_alt0,
       modelPar_kt0,
       modelPar_given_kt0,
       modelPar_zetact,
       modelPar_given_zetact,
       modelPar_zetabet,
       modelPar_given_zetabet,
       modelPar_zetaci,
       modelPar_given_zetaci,
       modelPar_alvs,
       modelPar_given_alvs,
       modelPar_alces,
       modelPar_given_alces,
       modelPar_zetarbi,
       modelPar_given_zetarbi,
       modelPar_zetarbx,
       modelPar_given_zetarbx,
       modelPar_zetarcx,
       modelPar_given_zetarcx,
       modelPar_zetare,
       modelPar_given_zetare,
       modelPar_zetaiqf,
       modelPar_given_zetaiqf,
       modelPar_alkav,
       modelPar_given_alkav,
       modelPar_aleav,
       modelPar_given_aleav,
       modelPar_zetarth,
       modelPar_given_zetarth,
       modelPar_zetaver,
       modelPar_given_zetaver,
       modelPar_zetavgbe,
       modelPar_given_zetavgbe,
       modelPar_dvgbe,
       modelPar_given_dvgbe,
       modelPar_aliqfh,
       modelPar_given_aliqfh,
       modelPar_kiqfh,
       modelPar_given_kiqfh,
       modelPar_rth,
       modelPar_given_rth,
       modelPar_cth,
       modelPar_given_cth,
       modelPar_tnom,
       modelPar_given_tnom,
       // non-reals (including hidden)
       modelPar_it_mod,
       modelPar_given_it_mod,
       modelPar_flnqs,
       modelPar_given_flnqs,
       modelPar_tef_temp,
       modelPar_given_tef_temp,
       modelPar_flsh,
       modelPar_given_flsh,
       modelPar_type,
       modelPar_given_type,
       in.admsTemperature,
       in.adms_vt_nom,
       in.getDeviceOptions().gmin,
       staticContributions,
       dynamicContributions,
       in);

  
    // We now have the F and Q vector stuff, populate the dependencies:
  
    dfdp[in.admsNodeID_c+inst*(11+0)] += staticContributions[in.admsNodeID_c].dx(0);
    dqdp[in.admsNodeID_c+inst*(11+0)] += dynamicContributions[in.admsNodeID_c].dx(0);
    Findices[in.admsNodeID_c+inst*(11+0)] = in.li_c;
    Qindices[in.admsNodeID_c+inst*(11+0)] = in.li_c;
    dfdp[in.admsNodeID_b+inst*(11+0)] += staticContributions[in.admsNodeID_b].dx(0);
    dqdp[in.admsNodeID_b+inst*(11+0)] += dynamicContributions[in.admsNodeID_b].dx(0);
    Findices[in.admsNodeID_b+inst*(11+0)] = in.li_b;
    Qindices[in.admsNodeID_b+inst*(11+0)] = in.li_b;
    dfdp[in.admsNodeID_e+inst*(11+0)] += staticContributions[in.admsNodeID_e].dx(0);
    dqdp[in.admsNodeID_e+inst*(11+0)] += dynamicContributions[in.admsNodeID_e].dx(0);
    Findices[in.admsNodeID_e+inst*(11+0)] = in.li_e;
    Qindices[in.admsNodeID_e+inst*(11+0)] = in.li_e;
    dfdp[in.admsNodeID_s+inst*(11+0)] += staticContributions[in.admsNodeID_s].dx(0);
    dqdp[in.admsNodeID_s+inst*(11+0)] += dynamicContributions[in.admsNodeID_s].dx(0);
    Findices[in.admsNodeID_s+inst*(11+0)] = in.li_s;
    Qindices[in.admsNodeID_s+inst*(11+0)] = in.li_s;
    dfdp[in.admsNodeID_tnode+inst*(11+0)] += staticContributions[in.admsNodeID_tnode].dx(0);
    dqdp[in.admsNodeID_tnode+inst*(11+0)] += dynamicContributions[in.admsNodeID_tnode].dx(0);
    Findices[in.admsNodeID_tnode+inst*(11+0)] = in.li_tnode;
    Qindices[in.admsNodeID_tnode+inst*(11+0)] = in.li_tnode;
    dfdp[in.admsNodeID_ci+inst*(11+0)] += staticContributions[in.admsNodeID_ci].dx(0);
    dqdp[in.admsNodeID_ci+inst*(11+0)] += dynamicContributions[in.admsNodeID_ci].dx(0);
    Findices[in.admsNodeID_ci+inst*(11+0)] = in.li_ci;
    Qindices[in.admsNodeID_ci+inst*(11+0)] = in.li_ci;
    dfdp[in.admsNodeID_bi+inst*(11+0)] += staticContributions[in.admsNodeID_bi].dx(0);
    dqdp[in.admsNodeID_bi+inst*(11+0)] += dynamicContributions[in.admsNodeID_bi].dx(0);
    Findices[in.admsNodeID_bi+inst*(11+0)] = in.li_bi;
    Qindices[in.admsNodeID_bi+inst*(11+0)] = in.li_bi;
    dfdp[in.admsNodeID_ei+inst*(11+0)] += staticContributions[in.admsNodeID_ei].dx(0);
    dqdp[in.admsNodeID_ei+inst*(11+0)] += dynamicContributions[in.admsNodeID_ei].dx(0);
    Findices[in.admsNodeID_ei+inst*(11+0)] = in.li_ei;
    Qindices[in.admsNodeID_ei+inst*(11+0)] = in.li_ei;
    dfdp[in.admsNodeID_xf1+inst*(11+0)] += staticContributions[in.admsNodeID_xf1].dx(0);
    dqdp[in.admsNodeID_xf1+inst*(11+0)] += dynamicContributions[in.admsNodeID_xf1].dx(0);
    Findices[in.admsNodeID_xf1+inst*(11+0)] = in.li_xf1;
    Qindices[in.admsNodeID_xf1+inst*(11+0)] = in.li_xf1;
    dfdp[in.admsNodeID_xf2+inst*(11+0)] += staticContributions[in.admsNodeID_xf2].dx(0);
    dqdp[in.admsNodeID_xf2+inst*(11+0)] += dynamicContributions[in.admsNodeID_xf2].dx(0);
    Findices[in.admsNodeID_xf2+inst*(11+0)] = in.li_xf2;
    Qindices[in.admsNodeID_xf2+inst*(11+0)] = in.li_xf2;
    dfdp[in.admsNodeID_xf+inst*(11+0)] += staticContributions[in.admsNodeID_xf].dx(0);
    dqdp[in.admsNodeID_xf+inst*(11+0)] += dynamicContributions[in.admsNodeID_xf].dx(0);
    Findices[in.admsNodeID_xf+inst*(11+0)] = in.li_xf;
    Qindices[in.admsNodeID_xf+inst*(11+0)] = in.li_xf;
  }

}

#endif // Xyce_ADMS_SENSITIVITIES

} // namespace ADMShic0_full
} // namespace Device
} // namespace Xyce
