
//-------------------------------------------------------------------------
//   Copyright 2002-2018 National Technology & Engineering Solutions of
//   Sandia, LLC (NTESS).  Under the terms of Contract DE-NA0003525 with
//   NTESS, the U.S. Government retains certain rights in this software.
//
//   This file is part of the Xyce(TM) Parallel Electrical Simulator.
//
//   Xyce(TM) is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   Xyce(TM) is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with Xyce(TM).
//   If not, see <http://www.gnu.org/licenses/>.
//-------------------------------------------------------------------------


//-------------------------------------------------------------------------
//
// Purpose        :
//
// Special Notes  : Generated from verilog file vbic_1p3.va with ADMS
//                  interface for Xyce 6.9.0
//                  DO NOT EDIT THIS FILE DIRECTLY!  It may be overwritten!
//
// Creator        : admsXml-2.3.6
//
// Creation Date  : Wed, 28 Mar 2018 12:13:39
//
//-------------------------------------------------------------------------
// Shut up clang's warnings about extraneous parentheses
#ifdef __clang__
#  pragma clang diagnostic ignored "-Wparentheses-equality"
#endif

#include <Xyce_config.h>
#include <N_DEV_ADMSvbic13_4t.h>


#include <N_DEV_Const.h>
#include <N_DEV_DeviceOptions.h>
#include <N_DEV_DeviceMaster.h>
#include <N_DEV_ExternData.h>
#include <N_DEV_SolverState.h>
#include <N_DEV_Message.h>

#include <N_LAS_Matrix.h>
#include <N_LAS_Vector.h>

#include <N_ANP_NoiseData.h>

#include <N_UTL_FeatureTest.h>
#if defined(HAVE_UNORDERED_MAP)
#include <unordered_map>
using std::unordered_map;
#elif defined(HAVE_TR1_UNORDERED_MAP)
#include <tr1/unordered_map>
using std::tr1::unordered_map;
#else
#error neither unordered_map or tr1/unordered_map found
#endif

namespace Xyce {
namespace Device {
namespace ADMSvbic13_4t {
JacobianStamp Instance::jacStamp;
IdVector Instance::nodeMap;
PairMap Instance::pairToJacStampMap;


//This is necessary because the IntPair usage can trip undefined references
const int Instance::admsNodeID_c;
const int Instance::admsNodeID_b;
const int Instance::admsNodeID_e;
const int Instance::admsNodeID_s;
const int Instance::admsNodeID_dt;
const int Instance::admsNodeID_cx;
const int Instance::admsNodeID_ci;
const int Instance::admsNodeID_bx;
const int Instance::admsNodeID_bi;
const int Instance::admsNodeID_ei;
const int Instance::admsNodeID_bp;
const int Instance::admsNodeID_si;
const int Instance::admsNodeID_xf1;
const int Instance::admsNodeID_xf2;
const int Instance::admsNodeID_GND;
// Additional IDs for branch equations


void
Traits::loadInstanceParameters(ParametricData<ADMSvbic13_4t::Instance> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have an instance parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSINSTTEMP", 0.0, &ADMSvbic13_4t::Instance::admsInstTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device instance temperature");
  p.addPar("M", static_cast<double>(1.0), &ADMSvbic13_4t::Instance::m)
    .setUnit(U_UNKNOWN)
    .setDescription("multiplicity factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TRISE", static_cast<double>(0.0), &ADMSvbic13_4t::Instance::trise)
    .setUnit(U_DEGC)
    .setDescription("local temperature delta to ambient (before self-heating)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DTA", static_cast<double>(0.0), &ADMSvbic13_4t::Instance::trise)
    .setUnit(U_DEGC)
    .setDescription(" Alias for trise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DTEMP", static_cast<double>(0.0), &ADMSvbic13_4t::Instance::trise)
    .setUnit(U_DEGC)
    .setDescription(" Alias for trise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SW_NOISE", static_cast<int>(1), &ADMSvbic13_4t::Instance::sw_noise)
    .setUnit(U_UNKNOWN)
    .setDescription("switch for including noise:   0=no and 1=yes");
  p.addPar("SW_ET", static_cast<int>(1), &ADMSvbic13_4t::Instance::sw_et)
    .setUnit(U_UNKNOWN)
    .setDescription("switch for self-heating:      0=no and 1=yes");


}

void Traits::loadModelParameters(ParametricData<ADMSvbic13_4t::Model> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have a model parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSMODTEMP", 0.0, &ADMSvbic13_4t::Model::admsModTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device model temperature");
  p.addPar("NPN", static_cast<double>(0.0), &ADMSvbic13_4t::Model::npn)
    .setUnit(U_UNKNOWN)
    .setDescription("npn transistor type")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PNP", static_cast<double>(0.0), &ADMSvbic13_4t::Model::pnp)
    .setUnit(U_UNKNOWN)
    .setDescription("pnp transistor type")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TYPE", static_cast<int>((-1)), &ADMSvbic13_4t::Model::type)
    .setUnit(U_UNKNOWN)
    .setDescription("transistor type: -1=npn and +1=pnp (overriden by npn or pnp)");
  //Hidden parameter VBICtype
  p.addPar("SCALE", static_cast<double>(1.0), &ADMSvbic13_4t::Model::scale)
    .setUnit(U_UNKNOWN)
    .setDescription("scale  factor for instance geometries")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SHRINK", static_cast<double>(0.0), &ADMSvbic13_4t::Model::shrink)
    .setUnit(U_UNKNOWN)
    .setDescription("shrink percentage for instance geometries")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TMIN", static_cast<double>((-100.0)), &ADMSvbic13_4t::Model::tmin)
    .setUnit(U_DEGC)
    .setDescription("minimum ambient temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TMAX", static_cast<double>(500.0), &ADMSvbic13_4t::Model::tmax)
    .setUnit(U_DEGC)
    .setDescription("maximum ambient temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("GMIN", static_cast<double>(1.0e-12), &ADMSvbic13_4t::Model::gmin)
    .setUnit(U_OHMM1)
    .setDescription("minimum conductance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PNJMAXI", static_cast<double>(1.0), &ADMSvbic13_4t::Model::pnjmaxi)
    .setUnit(U_AMP)
    .setDescription("current at which to linearize diode currents")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MAXEXP", static_cast<double>(1.0e22), &ADMSvbic13_4t::Model::maxexp)
    .setUnit(U_UNKNOWN)
    .setDescription("argument at which to linearize general exponentials")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TNOM", static_cast<double>(27.0), &ADMSvbic13_4t::Model::tnom)
    .setUnit(U_DEGC)
    .setDescription("nominal (reference) temperature")
    .setAutoConvertTemperature(false)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TMINCLIP", static_cast<double>((-100.0)), &ADMSvbic13_4t::Model::tminclip)
    .setUnit(U_DEGC)
    .setDescription("clip minimum temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TMAXCLIP", static_cast<double>(500.0), &ADMSvbic13_4t::Model::tmaxclip)
    .setUnit(U_DEGC)
    .setDescription("clip maximum temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RCX", static_cast<double>(0.0), &ADMSvbic13_4t::Model::rcx)
    .setUnit(U_OHM)
    .setDescription("extrinsic collector resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RCI", static_cast<double>(0.0), &ADMSvbic13_4t::Model::rci)
    .setUnit(U_OHM)
    .setDescription("intrinsic collector resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VO", static_cast<double>(0.0), &ADMSvbic13_4t::Model::vo)
    .setUnit(U_VOLT)
    .setDescription("epi drift saturation voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("GAMM", static_cast<double>(0.0), &ADMSvbic13_4t::Model::gamm)
    .setUnit(U_UNKNOWN)
    .setDescription("epi doping parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("HRCF", static_cast<double>(0.0), &ADMSvbic13_4t::Model::hrcf)
    .setUnit(U_UNKNOWN)
    .setDescription("high current collector resistance factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBX", static_cast<double>(0.0), &ADMSvbic13_4t::Model::rbx)
    .setUnit(U_OHM)
    .setDescription("extrinsic base resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBI", static_cast<double>(0.0), &ADMSvbic13_4t::Model::rbi)
    .setUnit(U_OHM)
    .setDescription("intrinsic base resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RE", static_cast<double>(0.0), &ADMSvbic13_4t::Model::re)
    .setUnit(U_OHM)
    .setDescription("extrinsic emitter resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RS", static_cast<double>(0.0), &ADMSvbic13_4t::Model::rs)
    .setUnit(U_OHM)
    .setDescription("extrinsic substrate resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBP", static_cast<double>(0.0), &ADMSvbic13_4t::Model::rbp)
    .setUnit(U_OHM)
    .setDescription("parasitic transistor base resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IS", static_cast<double>(1.0e-16), &ADMSvbic13_4t::Model::is)
    .setUnit(U_AMP)
    .setDescription("transport saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ISRR", static_cast<double>(1.0), &ADMSvbic13_4t::Model::isrr)
    .setUnit(U_UNKNOWN)
    .setDescription("ratio of is(reverse) to is(forward)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NF", static_cast<double>(1.0), &ADMSvbic13_4t::Model::nf)
    .setUnit(U_UNKNOWN)
    .setDescription("fwd emission coefficient (ideality factor)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NR", static_cast<double>(1.0), &ADMSvbic13_4t::Model::nr)
    .setUnit(U_UNKNOWN)
    .setDescription("rev emission coefficient (ideality factor)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("QBM", static_cast<int>(0), &ADMSvbic13_4t::Model::qbm)
    .setUnit(U_UNKNOWN)
    .setDescription("base charge model selection switch: 0=GP and 1=SGP");
  p.addPar("ISP", static_cast<double>(0.0), &ADMSvbic13_4t::Model::isp)
    .setUnit(U_AMP)
    .setDescription("parasitic transport saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WSP", static_cast<double>(1.0), &ADMSvbic13_4t::Model::wsp)
    .setUnit(U_UNKNOWN)
    .setDescription("partitioning of Iccp between Vbep and Vbci")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NFP", static_cast<double>(1.0), &ADMSvbic13_4t::Model::nfp)
    .setUnit(U_UNKNOWN)
    .setDescription("parasitic emission coeff (ideality factor)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FC", static_cast<double>(0.9), &ADMSvbic13_4t::Model::fc)
    .setUnit(U_UNKNOWN)
    .setDescription("forward bias depletion capacitance limit")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBEO", static_cast<double>(0.0), &ADMSvbic13_4t::Model::cbeo)
    .setUnit(U_FARAD)
    .setDescription("extrinsic b-e overlap capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJE", static_cast<double>(0.0), &ADMSvbic13_4t::Model::cje)
    .setUnit(U_FARAD)
    .setDescription("zero-bias b-e depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PE", static_cast<double>(0.75), &ADMSvbic13_4t::Model::pe)
    .setUnit(U_VOLT)
    .setDescription("b-e built-in potential")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ME", static_cast<double>(0.33), &ADMSvbic13_4t::Model::me)
    .setUnit(U_UNKNOWN)
    .setDescription("b-e grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AJE", static_cast<double>((-0.5)), &ADMSvbic13_4t::Model::aje)
    .setUnit(U_UNKNOWN)
    .setDescription("b-e capacitance smoothing factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBCO", static_cast<double>(0.0), &ADMSvbic13_4t::Model::cbco)
    .setUnit(U_FARAD)
    .setDescription("extrinsic b-c overlap capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJC", static_cast<double>(0.0), &ADMSvbic13_4t::Model::cjc)
    .setUnit(U_FARAD)
    .setDescription("zero-bias b-c depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PC", static_cast<double>(0.75), &ADMSvbic13_4t::Model::pc)
    .setUnit(U_VOLT)
    .setDescription("b-c built-in potential")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MC", static_cast<double>(0.33), &ADMSvbic13_4t::Model::mc)
    .setUnit(U_UNKNOWN)
    .setDescription("b-c grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AJC", static_cast<double>((-0.5)), &ADMSvbic13_4t::Model::ajc)
    .setUnit(U_UNKNOWN)
    .setDescription("b-c capacitance smoothing factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VRT", static_cast<double>(0.0), &ADMSvbic13_4t::Model::vrt)
    .setUnit(U_VOLT)
    .setDescription("reach-through voltage for Cbc limiting")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ART", static_cast<double>(0.1), &ADMSvbic13_4t::Model::art)
    .setUnit(U_UNKNOWN)
    .setDescription("smoothing parameter for reach-through")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("QCO", static_cast<double>(0.0), &ADMSvbic13_4t::Model::qco)
    .setUnit(U_COULOMB)
    .setDescription("epi charge parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJEP", static_cast<double>(0.0), &ADMSvbic13_4t::Model::cjep)
    .setUnit(U_FARAD)
    .setDescription("zero-bias extrinsic b-c depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJCP", static_cast<double>(0.0), &ADMSvbic13_4t::Model::cjcp)
    .setUnit(U_FARAD)
    .setDescription("zero-bias extrinsic c-s depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PS", static_cast<double>(0.75), &ADMSvbic13_4t::Model::ps)
    .setUnit(U_VOLT)
    .setDescription("c-s built-in potential")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MS", static_cast<double>(0.33), &ADMSvbic13_4t::Model::ms)
    .setUnit(U_UNKNOWN)
    .setDescription("c-s grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AJS", static_cast<double>((-0.5)), &ADMSvbic13_4t::Model::ajs)
    .setUnit(U_UNKNOWN)
    .setDescription("c-s capacitance smoothing factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CCSO", static_cast<double>(0.0), &ADMSvbic13_4t::Model::ccso)
    .setUnit(U_FARAD)
    .setDescription("extrinsic c-s overlap capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBEI", static_cast<double>(1.0e-18), &ADMSvbic13_4t::Model::ibei)
    .setUnit(U_AMP)
    .setDescription("ideal b-e saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WBE", static_cast<double>(1.0), &ADMSvbic13_4t::Model::wbe)
    .setUnit(U_UNKNOWN)
    .setDescription("partitioning of Ibe/Ibex and Qbe/Qbex")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NEI", static_cast<double>(1.0), &ADMSvbic13_4t::Model::nei)
    .setUnit(U_UNKNOWN)
    .setDescription("ideal b-e emission coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("QNIBEIR", static_cast<double>(0.0), &ADMSvbic13_4t::Model::qnibeir)
    .setUnit(U_UNKNOWN)
    .setDescription("ideal b-e quasi-neutral base recombination parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBEN", static_cast<double>(0.0), &ADMSvbic13_4t::Model::iben)
    .setUnit(U_AMP)
    .setDescription("non-ideal b-e saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NEN", static_cast<double>(2.0), &ADMSvbic13_4t::Model::nen)
    .setUnit(U_UNKNOWN)
    .setDescription("non-ideal b-e emission coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBCI", static_cast<double>(1.0e-16), &ADMSvbic13_4t::Model::ibci)
    .setUnit(U_AMP)
    .setDescription("ideal b-c saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NCI", static_cast<double>(1.0), &ADMSvbic13_4t::Model::nci)
    .setUnit(U_UNKNOWN)
    .setDescription("ideal b-c emission coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBCN", static_cast<double>(0.0), &ADMSvbic13_4t::Model::ibcn)
    .setUnit(U_AMP)
    .setDescription("non-ideal b-c saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NCN", static_cast<double>(2.0), &ADMSvbic13_4t::Model::ncn)
    .setUnit(U_UNKNOWN)
    .setDescription("non-ideal b-c emission coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBEIP", static_cast<double>(0.0), &ADMSvbic13_4t::Model::ibeip)
    .setUnit(U_AMP)
    .setDescription("ideal parasitic b-e saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBENP", static_cast<double>(0.0), &ADMSvbic13_4t::Model::ibenp)
    .setUnit(U_AMP)
    .setDescription("non-ideal parasitic b-e saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBCIP", static_cast<double>(0.0), &ADMSvbic13_4t::Model::ibcip)
    .setUnit(U_AMP)
    .setDescription("ideal parasitic b-c saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NCIP", static_cast<double>(1.0), &ADMSvbic13_4t::Model::ncip)
    .setUnit(U_UNKNOWN)
    .setDescription("ideal parasitic b-c emission coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBCNP", static_cast<double>(0.0), &ADMSvbic13_4t::Model::ibcnp)
    .setUnit(U_AMP)
    .setDescription("non-ideal parasitic b-c saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NCNP", static_cast<double>(2.0), &ADMSvbic13_4t::Model::ncnp)
    .setUnit(U_UNKNOWN)
    .setDescription("non-ideal parasitic b-c emission coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VEF", static_cast<double>(0.0), &ADMSvbic13_4t::Model::vef)
    .setUnit(U_VOLT)
    .setDescription("forward Early voltage (zero=infinite)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VER", static_cast<double>(0.0), &ADMSvbic13_4t::Model::ver)
    .setUnit(U_VOLT)
    .setDescription("reverse Early voltage (zero=infinite)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IKF", static_cast<double>(0.0), &ADMSvbic13_4t::Model::ikf)
    .setUnit(U_AMP)
    .setDescription("forward knee current  (zero=infinite)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NKF", static_cast<double>(0.5), &ADMSvbic13_4t::Model::nkf)
    .setUnit(U_UNKNOWN)
    .setDescription("high current beta roll-off parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IKR", static_cast<double>(0.0), &ADMSvbic13_4t::Model::ikr)
    .setUnit(U_AMP)
    .setDescription("reverse knee current  (zero=infinite)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IKP", static_cast<double>(0.0), &ADMSvbic13_4t::Model::ikp)
    .setUnit(U_AMP)
    .setDescription("parasitic knee current  (zero=infinite)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TF", static_cast<double>(0.0), &ADMSvbic13_4t::Model::tf)
    .setUnit(U_SECOND)
    .setDescription("forward transit time")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("QTF", static_cast<double>(0.0), &ADMSvbic13_4t::Model::qtf)
    .setUnit(U_UNKNOWN)
    .setDescription("variation of tf with base-width modulation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XTF", static_cast<double>(0.0), &ADMSvbic13_4t::Model::xtf)
    .setUnit(U_UNKNOWN)
    .setDescription("tf bias dependence coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VTF", static_cast<double>(0.0), &ADMSvbic13_4t::Model::vtf)
    .setUnit(U_VOLT)
    .setDescription("tf coefficient of Vbci dependence")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ITF", static_cast<double>(0.0), &ADMSvbic13_4t::Model::itf)
    .setUnit(U_AMP)
    .setDescription("tf coefficient of Ic dependence")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TR", static_cast<double>(0.0), &ADMSvbic13_4t::Model::tr)
    .setUnit(U_SECOND)
    .setDescription("reverse transit time")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TD", static_cast<double>(0.0), &ADMSvbic13_4t::Model::td)
    .setUnit(U_SECOND)
    .setDescription("forward excess-phase delay time")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AVC1", static_cast<double>(0.0), &ADMSvbic13_4t::Model::avc1)
    .setUnit(U_VOLTM1)
    .setDescription("b-c   weak avalanche parameter 1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AVC2", static_cast<double>(0.0), &ADMSvbic13_4t::Model::avc2)
    .setUnit(U_UNKNOWN)
    .setDescription("b-c   weak avalanche parameter 2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AVCX1", static_cast<double>(0.0), &ADMSvbic13_4t::Model::avcx1)
    .setUnit(U_VOLTM1)
    .setDescription("bx-cx weak avalanche parameter 1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AVCX2", static_cast<double>(0.0), &ADMSvbic13_4t::Model::avcx2)
    .setUnit(U_UNKNOWN)
    .setDescription("bx-cx weak avalanche parameter 2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MCX", static_cast<double>(0.33), &ADMSvbic13_4t::Model::mcx)
    .setUnit(U_UNKNOWN)
    .setDescription("bx-cx grading coefficient for avalanche")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBBE", static_cast<double>(0.0), &ADMSvbic13_4t::Model::vbbe)
    .setUnit(U_VOLT)
    .setDescription("b-e   breakdown voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NBBE", static_cast<double>(1.0), &ADMSvbic13_4t::Model::nbbe)
    .setUnit(U_UNKNOWN)
    .setDescription("b-e   breakdown emission coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBBE", static_cast<double>(1.0e-06), &ADMSvbic13_4t::Model::ibbe)
    .setUnit(U_AMP)
    .setDescription("b-e   breakdown current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TVBBE1", static_cast<double>(0.0), &ADMSvbic13_4t::Model::tvbbe1)
    .setUnit(U_DEGCM1)
    .setDescription("linear temperature coefficient of vbbe")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TVBBE2", static_cast<double>(0.0), &ADMSvbic13_4t::Model::tvbbe2)
    .setUnit(U_UNKNOWN)
    .setDescription("quadratic temperature coefficient of vbbe")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TNBBE", static_cast<double>(0.0), &ADMSvbic13_4t::Model::tnbbe)
    .setUnit(U_DEGCM1)
    .setDescription("temperature coefficient of nbbe")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VPTE", static_cast<double>(0.0), &ADMSvbic13_4t::Model::vpte)
    .setUnit(U_VOLT)
    .setDescription("SiGe base current kink voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBK0", static_cast<double>(0.0), &ADMSvbic13_4t::Model::ibk0)
    .setUnit(U_AMP)
    .setDescription("SiGe base current kink current reference")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ABK", static_cast<double>(1.0), &ADMSvbic13_4t::Model::abk)
    .setUnit(U_UNKNOWN)
    .setDescription("SiGe base current kink exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BBK", static_cast<double>(0.0), &ADMSvbic13_4t::Model::bbk)
    .setUnit(U_AMP)
    .setDescription("SiGe base current kink current factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KFN", static_cast<double>(0.0), &ADMSvbic13_4t::Model::kfn)
    .setUnit(U_UNKNOWN)
    .setDescription("b-e flicker noise constant")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AFN", static_cast<double>(1.0), &ADMSvbic13_4t::Model::afn)
    .setUnit(U_UNKNOWN)
    .setDescription("b-e flicker noise current exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BFN", static_cast<double>(1.0), &ADMSvbic13_4t::Model::bfn)
    .setUnit(U_UNKNOWN)
    .setDescription("b-e flicker noise 1/f exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RTH", static_cast<double>(0.0), &ADMSvbic13_4t::Model::rth)
    .setUnit(U_UNKNOWN)
    .setDescription("thermal resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTH", static_cast<double>(0.0), &ADMSvbic13_4t::Model::cth)
    .setUnit(U_UNKNOWN)
    .setDescription("thermal capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XRE", static_cast<double>(0.0), &ADMSvbic13_4t::Model::xre)
    .setUnit(U_UNKNOWN)
    .setDescription("temperature exponent of re")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XRB", static_cast<double>(0.0), &ADMSvbic13_4t::Model::xrb)
    .setUnit(U_UNKNOWN)
    .setDescription("temperature exponent of rbx and rbi")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XRBI", static_cast<double>(0.0), &ADMSvbic13_4t::Model::xrbi)
    .setUnit(U_UNKNOWN)
    .setDescription("temperature exponent of rbi (overrides xrb)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XRBX", static_cast<double>(0.0), &ADMSvbic13_4t::Model::xrbx)
    .setUnit(U_UNKNOWN)
    .setDescription("temperature exponent of rbx (overrides xrb)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XRC", static_cast<double>(0.0), &ADMSvbic13_4t::Model::xrc)
    .setUnit(U_UNKNOWN)
    .setDescription("temperature exponent of rci and rcx and rbp")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XRCI", static_cast<double>(0.0), &ADMSvbic13_4t::Model::xrci)
    .setUnit(U_UNKNOWN)
    .setDescription("temperature exponent of rci (overrides xrc)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XRCX", static_cast<double>(0.0), &ADMSvbic13_4t::Model::xrcx)
    .setUnit(U_UNKNOWN)
    .setDescription("temperature exponent of rcx (overrides xrc)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XRBP", static_cast<double>(0.0), &ADMSvbic13_4t::Model::xrbp)
    .setUnit(U_UNKNOWN)
    .setDescription("temperature exponent of rbp (overrides xrc)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XRS", static_cast<double>(0.0), &ADMSvbic13_4t::Model::xrs)
    .setUnit(U_UNKNOWN)
    .setDescription("temperature exponent of rs")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XVO", static_cast<double>(0.0), &ADMSvbic13_4t::Model::xvo)
    .setUnit(U_UNKNOWN)
    .setDescription("temperature exponent of vo")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EA", static_cast<double>(1.12), &ADMSvbic13_4t::Model::ea)
    .setUnit(U_VOLT)
    .setDescription("activation energy for is")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EAIE", static_cast<double>(1.12), &ADMSvbic13_4t::Model::eaie)
    .setUnit(U_VOLT)
    .setDescription("activation energy for ibei")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EAIC", static_cast<double>(1.12), &ADMSvbic13_4t::Model::eaic)
    .setUnit(U_VOLT)
    .setDescription("activation energy for ibci and ibeip")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EAIS", static_cast<double>(1.12), &ADMSvbic13_4t::Model::eais)
    .setUnit(U_VOLT)
    .setDescription("activation energy for ibcip")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EANE", static_cast<double>(1.12), &ADMSvbic13_4t::Model::eane)
    .setUnit(U_VOLT)
    .setDescription("activation energy for iben")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EANC", static_cast<double>(1.12), &ADMSvbic13_4t::Model::eanc)
    .setUnit(U_VOLT)
    .setDescription("activation energy for ibcn and ibenp")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EANS", static_cast<double>(1.12), &ADMSvbic13_4t::Model::eans)
    .setUnit(U_VOLT)
    .setDescription("activation energy for ibcnp")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EAP", static_cast<double>(1.12), &ADMSvbic13_4t::Model::eap)
    .setUnit(U_VOLT)
    .setDescription("activation energy for isp")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DEAR", static_cast<double>(0.0), &ADMSvbic13_4t::Model::dear)
    .setUnit(U_VOLT)
    .setDescription("delta activation energy for isrr")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XIS", static_cast<double>(3.0), &ADMSvbic13_4t::Model::xis)
    .setUnit(U_UNKNOWN)
    .setDescription("temperature exponent of is")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XII", static_cast<double>(3.0), &ADMSvbic13_4t::Model::xii)
    .setUnit(U_UNKNOWN)
    .setDescription("temperature exponent of ibei, ibci, ibeip, ibcip")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XIN", static_cast<double>(3.0), &ADMSvbic13_4t::Model::xin)
    .setUnit(U_UNKNOWN)
    .setDescription("temperature exponent of iben, ibcn, ibenp, ibcnp")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XISR", static_cast<double>(0.0), &ADMSvbic13_4t::Model::xisr)
    .setUnit(U_UNKNOWN)
    .setDescription("temperature exponent for isrr")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XIKF", static_cast<double>(0.0), &ADMSvbic13_4t::Model::xikf)
    .setUnit(U_UNKNOWN)
    .setDescription("temperature exponent of ikf")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TAVC", static_cast<double>(0.0), &ADMSvbic13_4t::Model::tavc)
    .setUnit(U_DEGCM1)
    .setDescription("temperature exponent of avc2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TAVCX", static_cast<double>(0.0), &ADMSvbic13_4t::Model::tavcx)
    .setUnit(U_DEGCM1)
    .setDescription("temperature exponent of avcx2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TNF", static_cast<double>(0.0), &ADMSvbic13_4t::Model::tnf)
    .setUnit(U_DEGCM1)
    .setDescription("temperature exponent of nf and nr")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TCVEF", static_cast<double>(0.0), &ADMSvbic13_4t::Model::tcvef)
    .setUnit(U_DEGCM1)
    .setDescription("temperature exponent of vef")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TCVER", static_cast<double>(0.0), &ADMSvbic13_4t::Model::tcver)
    .setUnit(U_DEGCM1)
    .setDescription("temperature exponent of ver")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TCRTH", static_cast<double>(0.0), &ADMSvbic13_4t::Model::tcrth)
    .setUnit(U_DEGCM1)
    .setDescription("temperature exponent of rth")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;

}

//-----------------------------------------------------------------------------
// Function      : Instance::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::processParams()
{
  // set any non-constant parameter defaults

  // copy any model variables that have associated instance variables, but
  // are only given in the model card:



  // Set any parameters that were not given and whose defaults depend on other
  // parameters:


  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

  //    Parameter m : ] 0.0,  (+inf) [
  if ( (!((m >0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter m value " << m << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter sw_noise : [ 0, 1 ]
  if ( (!((sw_noise >=0 && sw_noise <=1 ))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter sw_noise value " << sw_noise << " out of range [ 0, 1 ]";
  }

  //    Parameter sw_et : [ 0, 1 ]
  if ( (!((sw_et >=0 && sw_et <=1 ))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter sw_et value " << sw_et << " out of range [ 0, 1 ]";
  }


  // this seems a little stupid, but verilog models that use $temperature
  // don't also use a defined parameter "Temp", and count on $temperature
  // to be the one the simulator wants:

  updateTemperature(admsInstTemp);

  // and of course, this routine is where we should put the initial_instance
  // stuff
  //Begin block initial_instance
  {
    mMod = m;
    tdevC = ((admsTemperature+trise)-273.15);
    if ((tdevC<(model_.tmin)))
    {
      std::cerr  << "WARNING: ambient temperature is lower than allowed minimum" <<  std::endl; 
    }
    if ((tdevC>(model_.tmax)))
    {
      std::cerr  << "WARNING: ambient temperature is higher than allowed maximum" <<  std::endl; 
    }
    if ((tdevC<((model_.tminclip)+1.0)))
    {
      tdevC = ((model_.tminclip)+exp(((tdevC-(model_.tminclip))-1.0)));
    }
    else
    {
      if ((tdevC>((model_.tmaxclip)-1.0)))
      {
        tdevC = ((model_.tmaxclip)-exp((((model_.tmaxclip)-tdevC)-1.0)));
      }
      else
      {
        tdevC = tdevC;
      }
    }
    tdevK = (tdevC+273.15);
    vtv = ((1.380662e-23*tdevK)/1.602189e-19);
    rT = (tdevK/(model_.tiniK));
    tVCrit = (adms_vt(admsTemperature)*log((adms_vt(admsTemperature)/(1.41421356237309504880*(model_.is)))));
    if (((model_.ibbe)>0.0))
    {
      maxvIbbe = (((model_.nbbe)*vtv.val())*log((exp(((-(model_.vbbe))/((model_.nbbe)*vtv.val())))+((model_.imaxMod)/(model_.ibbe)))));
    }
    else
    {
      maxvIbbe = 0.0;
    }
    is_t = (((model_.is)*pow(rT,((model_.xis)/(model_.nf))))*exp((((-(model_.ea))*(1.0-rT))/(vtv*(model_.nf)))));
    if ((is_t>0.0))
    {
      if ((((model_.ikf)>0.0)&&((model_.imaxMod)>(model_.ikf))))
      {
        maxvIfi = (((model_.nf)*vtv.val())*log((1.0+(pow(((0.5*(model_.imaxMod))*pow((4.0/(model_.ikf)),(model_.nkf))),(1.0/(1.0-(model_.nkf))))/is_t.val()))));
      }
      else
      {
        maxvIfi = (((model_.nf)*vtv.val())*log((1.0+((model_.imaxMod)/is_t.val()))));
      }
    }
    else
    {
      maxvIfi = 0.0;
    }
    isrr_t = (((model_.isrr)*pow(rT,((model_.xisr)/(model_.nr))))*exp((((-(model_.dear))*(1.0-rT))/(vtv*(model_.nr)))));
    if (((is_t>0.0)&&(isrr_t>0.0)))
    {
      if ((((model_.ikr)>0.0)&&((model_.imaxMod)>(model_.ikr))))
      {
        maxvIri = (((model_.nr)*vtv.val())*log((1.0+(pow(((0.5*(model_.imaxMod))*pow((4.0/(model_.ikr)),(model_.nkf))),(1.0/(1.0-(model_.nkf))))/(is_t.val()*isrr_t.val())))));
      }
      else
      {
        maxvIri = (((model_.nr)*vtv.val())*log((1.0+((model_.imaxMod)/(is_t.val()*isrr_t.val())))));
      }
    }
    else
    {
      maxvIri = 0.0;
    }
    isp_t = (((model_.isp)*pow(rT,((model_.xis)/(model_.nfp))))*exp((((-(model_.eap))*(1.0-rT))/(vtv*(model_.nfp)))));
    if ((isp_t>0.0))
    {
      if ((((model_.ikp)>0.0)&&((model_.imaxMod)>(model_.ikp))))
      {
        maxvIp = (((model_.nfp)*vtv.val())*log((1.0+((((model_.imaxMod)*(model_.imaxMod))*(model_.Iikp))/isp_t.val()))));
      }
      else
      {
        maxvIp = (((model_.nfp)*vtv.val())*log((1.0+((model_.imaxMod)/isp_t.val()))));
      }
    }
    else
    {
      maxvIp = 0.0;
    }
    ibei_t = (((model_.ibei)*pow(rT,((model_.xii)/(model_.nei))))*exp((((-(model_.eaie))*(1.0-rT))/(vtv*(model_.nei)))));
    if ((ibei_t>0.0))
    {
      maxvIbei = (((model_.nei)*vtv.val())*log((1.0+((model_.imaxMod)/ibei_t.val()))));
    }
    else
    {
      maxvIbei = 0.0;
    }
    iben_t = (((model_.iben)*pow(rT,((model_.xin)/(model_.nen))))*exp((((-(model_.eane))*(1.0-rT))/(vtv*(model_.nen)))));
    if ((iben_t>0.0))
    {
      maxvIben = (((model_.nen)*vtv.val())*log((1.0+((model_.imaxMod)/iben_t.val()))));
    }
    else
    {
      maxvIben = 0.0;
    }
    ibci_t = (((model_.ibci)*pow(rT,((model_.xii)/(model_.nci))))*exp((((-(model_.eaic))*(1.0-rT))/(vtv*(model_.nci)))));
    if ((ibci_t>0.0))
    {
      maxvIbci = (((model_.nci)*vtv.val())*log((1.0+((model_.imaxMod)/ibci_t.val()))));
    }
    else
    {
      maxvIbci = 0.0;
    }
    ibcn_t = (((model_.ibcn)*pow(rT,((model_.xin)/(model_.ncn))))*exp((((-(model_.eanc))*(1.0-rT))/(vtv*(model_.ncn)))));
    if ((ibcn_t>0.0))
    {
      maxvIbcn = (((model_.ncn)*vtv.val())*log((1.0+((model_.imaxMod)/ibcn_t.val()))));
    }
    else
    {
      maxvIbcn = 0.0;
    }
    ibeip_t = (((model_.ibeip)*pow(rT,((model_.xii)/(model_.nci))))*exp((((-(model_.eaic))*(1.0-rT))/(vtv*(model_.nci)))));
    if ((ibeip_t>0.0))
    {
      maxvIbeip = (((model_.nci)*vtv.val())*log((1.0+((model_.imaxMod)/ibeip_t.val()))));
    }
    else
    {
      maxvIbeip = 0.0;
    }
    ibenp_t = (((model_.ibenp)*pow(rT,((model_.xin)/(model_.ncn))))*exp((((-(model_.eanc))*(1.0-rT))/(vtv*(model_.ncn)))));
    if ((ibenp_t>0.0))
    {
      maxvIbenp = (((model_.ncn)*vtv.val())*log((1.0+((model_.imaxMod)/ibenp_t.val()))));
    }
    else
    {
      maxvIbenp = 0.0;
    }
    ibcip_t = (((model_.ibcip)*pow(rT,((model_.xii)/(model_.ncip))))*exp((((-(model_.eais))*(1.0-rT))/(vtv*(model_.ncip)))));
    if ((ibcip_t>0.0))
    {
      maxvIbcip = (((model_.ncip)*vtv.val())*log((1.0+((model_.imaxMod)/ibcip_t.val()))));
    }
    else
    {
      maxvIbcip = 0.0;
    }
    ibcnp_t = (((model_.ibcnp)*pow(rT,((model_.xin)/(model_.ncnp))))*exp((((-(model_.eans))*(1.0-rT))/(vtv*(model_.ncnp)))));
    if ((ibcnp_t>0.0))
    {
      maxvIbcnp = (((model_.ncnp)*vtv.val())*log((1.0+((model_.imaxMod)/ibcnp_t.val()))));
    }
    else
    {
      maxvIbcnp = 0.0;
    }
  }
  // End block initial_instance


  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::Instance
// Purpose       : "instance block" constructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------

Instance::Instance(
   const Configuration & configuration,
   const InstanceBlock & instance_block,
   Model &               model,
   const FactoryBlock &  factory_block)
  : DeviceInstance(instance_block, configuration.getInstanceParameters(), factory_block),
    model_(model),
    m(1.0),
    trise(0.0),
    sw_noise(1),
    sw_et(1),
    is_t(0.0),
    isrr_t(0.0),
    ibei_t(0.0),
    ibci_t(0.0),
    isp_t(0.0),
    iben_t(0.0),
    ibcn_t(0.0),
    ibeip_t(0.0),
    ibenp_t(0.0),
    ibcip_t(0.0),
    ibcnp_t(0.0),
    tdevC(0.0),
    tdevK(0.0),
    rT(0.0),
    Gcx(0.0),
    Gci(0.0),
    Gbx(0.0),
    Gbi(0.0),
    Ge(0.0),
    Gbp(0.0),
    Gs(0.0),
    maxvIfi(0.0),
    maxvIri(0.0),
    maxvIp(0.0),
    maxvIbbe(0.0),
    maxvIbei(0.0),
    maxvIben(0.0),
    maxvIbci(0.0),
    maxvIbcn(0.0),
    maxvIbeip(0.0),
    maxvIbenp(0.0),
    maxvIbcip(0.0),
    maxvIbcnp(0.0),
    vtv(0.0),
    Itzf(0.0),
    qb(0.0),
    Iccp(0.0),
    qbp(0.0),
    Ibe(0.0),
    Ibex(0.0),
    Ibep(0.0),
    Irci(0.0),
    Vrci(0.0),
    mMod(0.0),
    tVCrit(0.0),
    li_c(-1),
    li_b(-1),
    li_e(-1),
    li_s(-1),
    li_dt(-1),
    li_cx(-1),
    li_ci(-1),
    li_bx(-1),
    li_bi(-1),
    li_ei(-1),
    li_bp(-1),
    li_si(-1),
    li_xf1(-1),
    li_xf2(-1),
    li_branch_ic(-1),
    li_branch_ib(-1),
    li_branch_ie(-1),
    li_branch_is(-1),
    f_bi_Equ_bx_Node_Ptr(0),
    f_bi_Equ_bp_Node_Ptr(0),
    f_ei_Equ_bx_Node_Ptr(0),
    f_ei_Equ_bp_Node_Ptr(0),
    f_bi_Equ_si_Node_Ptr(0),
    f_ei_Equ_si_Node_Ptr(0),
    f_bi_Equ_bi_Node_Ptr(0),
    f_bi_Equ_ci_Node_Ptr(0),
    f_ei_Equ_bi_Node_Ptr(0),
    f_ei_Equ_ci_Node_Ptr(0),
    f_bi_Equ_ei_Node_Ptr(0),
    f_ei_Equ_ei_Node_Ptr(0),
    f_bi_Equ_dt_Node_Ptr(0),
    f_ei_Equ_dt_Node_Ptr(0),
    f_bx_Equ_bi_Node_Ptr(0),
    f_bx_Equ_ei_Node_Ptr(0),
    f_bx_Equ_ci_Node_Ptr(0),
    f_bx_Equ_bx_Node_Ptr(0),
    f_bx_Equ_bp_Node_Ptr(0),
    f_bx_Equ_si_Node_Ptr(0),
    f_bx_Equ_dt_Node_Ptr(0),
    f_ci_Equ_xf2_Node_Ptr(0),
    f_ei_Equ_xf2_Node_Ptr(0),
    f_ci_Equ_bi_Node_Ptr(0),
    f_ci_Equ_ei_Node_Ptr(0),
    f_ci_Equ_ci_Node_Ptr(0),
    f_ci_Equ_dt_Node_Ptr(0),
    f_bi_Equ_xf2_Node_Ptr(0),
    f_ci_Equ_bx_Node_Ptr(0),
    f_ci_Equ_bp_Node_Ptr(0),
    f_ci_Equ_si_Node_Ptr(0),
    f_cx_Equ_bi_Node_Ptr(0),
    f_cx_Equ_ci_Node_Ptr(0),
    f_bx_Equ_cx_Node_Ptr(0),
    f_cx_Equ_bx_Node_Ptr(0),
    f_cx_Equ_cx_Node_Ptr(0),
    f_cx_Equ_dt_Node_Ptr(0),
    f_bx_Equ_c_Node_Ptr(0),
    f_cx_Equ_c_Node_Ptr(0),
    f_bp_Equ_bi_Node_Ptr(0),
    f_bp_Equ_ei_Node_Ptr(0),
    f_bp_Equ_ci_Node_Ptr(0),
    f_bp_Equ_bx_Node_Ptr(0),
    f_bp_Equ_bp_Node_Ptr(0),
    f_bp_Equ_si_Node_Ptr(0),
    f_bp_Equ_dt_Node_Ptr(0),
    f_c_Equ_dt_Node_Ptr(0),
    f_c_Equ_c_Node_Ptr(0),
    f_c_Equ_cx_Node_Ptr(0),
    f_ci_Equ_cx_Node_Ptr(0),
    f_cx_Equ_ei_Node_Ptr(0),
    f_cx_Equ_bp_Node_Ptr(0),
    f_cx_Equ_si_Node_Ptr(0),
    f_b_Equ_dt_Node_Ptr(0),
    f_b_Equ_b_Node_Ptr(0),
    f_b_Equ_bx_Node_Ptr(0),
    f_bx_Equ_b_Node_Ptr(0),
    f_e_Equ_dt_Node_Ptr(0),
    f_e_Equ_e_Node_Ptr(0),
    f_e_Equ_ei_Node_Ptr(0),
    f_ei_Equ_e_Node_Ptr(0),
    f_bp_Equ_cx_Node_Ptr(0),
    f_si_Equ_bi_Node_Ptr(0),
    f_si_Equ_ei_Node_Ptr(0),
    f_si_Equ_ci_Node_Ptr(0),
    f_si_Equ_bx_Node_Ptr(0),
    f_si_Equ_bp_Node_Ptr(0),
    f_si_Equ_si_Node_Ptr(0),
    f_si_Equ_dt_Node_Ptr(0),
    f_s_Equ_dt_Node_Ptr(0),
    f_s_Equ_s_Node_Ptr(0),
    f_s_Equ_si_Node_Ptr(0),
    f_si_Equ_s_Node_Ptr(0),
    f_xf1_Equ_bi_Node_Ptr(0),
    f_xf1_Equ_ci_Node_Ptr(0),
    f_xf1_Equ_ei_Node_Ptr(0),
    f_xf1_Equ_dt_Node_Ptr(0),
    f_xf1_Equ_xf2_Node_Ptr(0),
    f_xf2_Equ_xf1_Node_Ptr(0),
    f_xf2_Equ_xf2_Node_Ptr(0),
    f_dt_Equ_dt_Node_Ptr(0),
    f_dt_Equ_bp_Node_Ptr(0),
    f_dt_Equ_cx_Node_Ptr(0),
    f_dt_Equ_e_Node_Ptr(0),
    f_dt_Equ_ei_Node_Ptr(0),
    f_dt_Equ_bx_Node_Ptr(0),
    f_dt_Equ_bi_Node_Ptr(0),
    f_dt_Equ_b_Node_Ptr(0),
    f_dt_Equ_ci_Node_Ptr(0),
    f_dt_Equ_c_Node_Ptr(0),
    f_dt_Equ_si_Node_Ptr(0),
    f_dt_Equ_s_Node_Ptr(0),
    f_dt_Equ_xf2_Node_Ptr(0),
    f_bi_Equ_cx_Node_Ptr(0),
    f_ei_Equ_cx_Node_Ptr(0),
    f_b_Equ_e_Node_Ptr(0),
    f_e_Equ_b_Node_Ptr(0),
    f_b_Equ_c_Node_Ptr(0),
    f_c_Equ_b_Node_Ptr(0),
    f_xf1_Equ_xf1_Node_Ptr(0),
    q_bi_Equ_bx_Node_Ptr(0),
    q_bi_Equ_bp_Node_Ptr(0),
    q_ei_Equ_bx_Node_Ptr(0),
    q_ei_Equ_bp_Node_Ptr(0),
    q_bi_Equ_si_Node_Ptr(0),
    q_ei_Equ_si_Node_Ptr(0),
    q_bi_Equ_bi_Node_Ptr(0),
    q_bi_Equ_ci_Node_Ptr(0),
    q_ei_Equ_bi_Node_Ptr(0),
    q_ei_Equ_ci_Node_Ptr(0),
    q_bi_Equ_ei_Node_Ptr(0),
    q_ei_Equ_ei_Node_Ptr(0),
    q_bi_Equ_dt_Node_Ptr(0),
    q_ei_Equ_dt_Node_Ptr(0),
    q_bx_Equ_bi_Node_Ptr(0),
    q_bx_Equ_ei_Node_Ptr(0),
    q_bx_Equ_ci_Node_Ptr(0),
    q_bx_Equ_bx_Node_Ptr(0),
    q_bx_Equ_bp_Node_Ptr(0),
    q_bx_Equ_si_Node_Ptr(0),
    q_bx_Equ_dt_Node_Ptr(0),
    q_ci_Equ_xf2_Node_Ptr(0),
    q_ei_Equ_xf2_Node_Ptr(0),
    q_ci_Equ_bi_Node_Ptr(0),
    q_ci_Equ_ei_Node_Ptr(0),
    q_ci_Equ_ci_Node_Ptr(0),
    q_ci_Equ_dt_Node_Ptr(0),
    q_bi_Equ_xf2_Node_Ptr(0),
    q_ci_Equ_bx_Node_Ptr(0),
    q_ci_Equ_bp_Node_Ptr(0),
    q_ci_Equ_si_Node_Ptr(0),
    q_cx_Equ_bi_Node_Ptr(0),
    q_cx_Equ_ci_Node_Ptr(0),
    q_bx_Equ_cx_Node_Ptr(0),
    q_cx_Equ_bx_Node_Ptr(0),
    q_cx_Equ_cx_Node_Ptr(0),
    q_cx_Equ_dt_Node_Ptr(0),
    q_bx_Equ_c_Node_Ptr(0),
    q_cx_Equ_c_Node_Ptr(0),
    q_bp_Equ_bi_Node_Ptr(0),
    q_bp_Equ_ei_Node_Ptr(0),
    q_bp_Equ_ci_Node_Ptr(0),
    q_bp_Equ_bx_Node_Ptr(0),
    q_bp_Equ_bp_Node_Ptr(0),
    q_bp_Equ_si_Node_Ptr(0),
    q_bp_Equ_dt_Node_Ptr(0),
    q_c_Equ_dt_Node_Ptr(0),
    q_c_Equ_c_Node_Ptr(0),
    q_c_Equ_cx_Node_Ptr(0),
    q_ci_Equ_cx_Node_Ptr(0),
    q_cx_Equ_ei_Node_Ptr(0),
    q_cx_Equ_bp_Node_Ptr(0),
    q_cx_Equ_si_Node_Ptr(0),
    q_b_Equ_dt_Node_Ptr(0),
    q_b_Equ_b_Node_Ptr(0),
    q_b_Equ_bx_Node_Ptr(0),
    q_bx_Equ_b_Node_Ptr(0),
    q_e_Equ_dt_Node_Ptr(0),
    q_e_Equ_e_Node_Ptr(0),
    q_e_Equ_ei_Node_Ptr(0),
    q_ei_Equ_e_Node_Ptr(0),
    q_bp_Equ_cx_Node_Ptr(0),
    q_si_Equ_bi_Node_Ptr(0),
    q_si_Equ_ei_Node_Ptr(0),
    q_si_Equ_ci_Node_Ptr(0),
    q_si_Equ_bx_Node_Ptr(0),
    q_si_Equ_bp_Node_Ptr(0),
    q_si_Equ_si_Node_Ptr(0),
    q_si_Equ_dt_Node_Ptr(0),
    q_s_Equ_dt_Node_Ptr(0),
    q_s_Equ_s_Node_Ptr(0),
    q_s_Equ_si_Node_Ptr(0),
    q_si_Equ_s_Node_Ptr(0),
    q_xf1_Equ_bi_Node_Ptr(0),
    q_xf1_Equ_ci_Node_Ptr(0),
    q_xf1_Equ_ei_Node_Ptr(0),
    q_xf1_Equ_dt_Node_Ptr(0),
    q_xf1_Equ_xf2_Node_Ptr(0),
    q_xf2_Equ_xf1_Node_Ptr(0),
    q_xf2_Equ_xf2_Node_Ptr(0),
    q_dt_Equ_dt_Node_Ptr(0),
    q_dt_Equ_bp_Node_Ptr(0),
    q_dt_Equ_cx_Node_Ptr(0),
    q_dt_Equ_e_Node_Ptr(0),
    q_dt_Equ_ei_Node_Ptr(0),
    q_dt_Equ_bx_Node_Ptr(0),
    q_dt_Equ_bi_Node_Ptr(0),
    q_dt_Equ_b_Node_Ptr(0),
    q_dt_Equ_ci_Node_Ptr(0),
    q_dt_Equ_c_Node_Ptr(0),
    q_dt_Equ_si_Node_Ptr(0),
    q_dt_Equ_s_Node_Ptr(0),
    q_dt_Equ_xf2_Node_Ptr(0),
    q_bi_Equ_cx_Node_Ptr(0),
    q_ei_Equ_cx_Node_Ptr(0),
    q_b_Equ_e_Node_Ptr(0),
    q_e_Equ_b_Node_Ptr(0),
    q_b_Equ_c_Node_Ptr(0),
    q_c_Equ_b_Node_Ptr(0),
    q_xf1_Equ_xf1_Node_Ptr(0),
    A_bi_Equ_bx_NodeOffset(-1),
    A_bi_Equ_bp_NodeOffset(-1),
    A_ei_Equ_bx_NodeOffset(-1),
    A_ei_Equ_bp_NodeOffset(-1),
    A_bi_Equ_si_NodeOffset(-1),
    A_ei_Equ_si_NodeOffset(-1),
    A_bi_Equ_bi_NodeOffset(-1),
    A_bi_Equ_ci_NodeOffset(-1),
    A_ei_Equ_bi_NodeOffset(-1),
    A_ei_Equ_ci_NodeOffset(-1),
    A_bi_Equ_ei_NodeOffset(-1),
    A_ei_Equ_ei_NodeOffset(-1),
    A_bi_Equ_dt_NodeOffset(-1),
    A_ei_Equ_dt_NodeOffset(-1),
    A_bx_Equ_bi_NodeOffset(-1),
    A_bx_Equ_ei_NodeOffset(-1),
    A_bx_Equ_ci_NodeOffset(-1),
    A_bx_Equ_bx_NodeOffset(-1),
    A_bx_Equ_bp_NodeOffset(-1),
    A_bx_Equ_si_NodeOffset(-1),
    A_bx_Equ_dt_NodeOffset(-1),
    A_ci_Equ_xf2_NodeOffset(-1),
    A_ei_Equ_xf2_NodeOffset(-1),
    A_ci_Equ_bi_NodeOffset(-1),
    A_ci_Equ_ei_NodeOffset(-1),
    A_ci_Equ_ci_NodeOffset(-1),
    A_ci_Equ_dt_NodeOffset(-1),
    A_bi_Equ_xf2_NodeOffset(-1),
    A_ci_Equ_bx_NodeOffset(-1),
    A_ci_Equ_bp_NodeOffset(-1),
    A_ci_Equ_si_NodeOffset(-1),
    A_cx_Equ_bi_NodeOffset(-1),
    A_cx_Equ_ci_NodeOffset(-1),
    A_bx_Equ_cx_NodeOffset(-1),
    A_cx_Equ_bx_NodeOffset(-1),
    A_cx_Equ_cx_NodeOffset(-1),
    A_cx_Equ_dt_NodeOffset(-1),
    A_bx_Equ_c_NodeOffset(-1),
    A_cx_Equ_c_NodeOffset(-1),
    A_bp_Equ_bi_NodeOffset(-1),
    A_bp_Equ_ei_NodeOffset(-1),
    A_bp_Equ_ci_NodeOffset(-1),
    A_bp_Equ_bx_NodeOffset(-1),
    A_bp_Equ_bp_NodeOffset(-1),
    A_bp_Equ_si_NodeOffset(-1),
    A_bp_Equ_dt_NodeOffset(-1),
    A_c_Equ_dt_NodeOffset(-1),
    A_c_Equ_c_NodeOffset(-1),
    A_c_Equ_cx_NodeOffset(-1),
    A_ci_Equ_cx_NodeOffset(-1),
    A_cx_Equ_ei_NodeOffset(-1),
    A_cx_Equ_bp_NodeOffset(-1),
    A_cx_Equ_si_NodeOffset(-1),
    A_b_Equ_dt_NodeOffset(-1),
    A_b_Equ_b_NodeOffset(-1),
    A_b_Equ_bx_NodeOffset(-1),
    A_bx_Equ_b_NodeOffset(-1),
    A_e_Equ_dt_NodeOffset(-1),
    A_e_Equ_e_NodeOffset(-1),
    A_e_Equ_ei_NodeOffset(-1),
    A_ei_Equ_e_NodeOffset(-1),
    A_bp_Equ_cx_NodeOffset(-1),
    A_si_Equ_bi_NodeOffset(-1),
    A_si_Equ_ei_NodeOffset(-1),
    A_si_Equ_ci_NodeOffset(-1),
    A_si_Equ_bx_NodeOffset(-1),
    A_si_Equ_bp_NodeOffset(-1),
    A_si_Equ_si_NodeOffset(-1),
    A_si_Equ_dt_NodeOffset(-1),
    A_s_Equ_dt_NodeOffset(-1),
    A_s_Equ_s_NodeOffset(-1),
    A_s_Equ_si_NodeOffset(-1),
    A_si_Equ_s_NodeOffset(-1),
    A_xf1_Equ_bi_NodeOffset(-1),
    A_xf1_Equ_ci_NodeOffset(-1),
    A_xf1_Equ_ei_NodeOffset(-1),
    A_xf1_Equ_dt_NodeOffset(-1),
    A_xf1_Equ_xf2_NodeOffset(-1),
    A_xf2_Equ_xf1_NodeOffset(-1),
    A_xf2_Equ_xf2_NodeOffset(-1),
    A_dt_Equ_dt_NodeOffset(-1),
    A_dt_Equ_bp_NodeOffset(-1),
    A_dt_Equ_cx_NodeOffset(-1),
    A_dt_Equ_e_NodeOffset(-1),
    A_dt_Equ_ei_NodeOffset(-1),
    A_dt_Equ_bx_NodeOffset(-1),
    A_dt_Equ_bi_NodeOffset(-1),
    A_dt_Equ_b_NodeOffset(-1),
    A_dt_Equ_ci_NodeOffset(-1),
    A_dt_Equ_c_NodeOffset(-1),
    A_dt_Equ_si_NodeOffset(-1),
    A_dt_Equ_s_NodeOffset(-1),
    A_dt_Equ_xf2_NodeOffset(-1),
    A_bi_Equ_cx_NodeOffset(-1),
    A_ei_Equ_cx_NodeOffset(-1),
    A_b_Equ_e_NodeOffset(-1),
    A_e_Equ_b_NodeOffset(-1),
    A_b_Equ_c_NodeOffset(-1),
    A_c_Equ_b_NodeOffset(-1),
    A_xf1_Equ_xf1_NodeOffset(-1),
    admsTemperature(getDeviceOptions().temp.getImmutableValue<double>()),
    dtExternalNodeMode(false),
    cxExternalNodeMode(false),
    ciExternalNodeMode(false),
    bxExternalNodeMode(false),
    biExternalNodeMode(false),
    eiExternalNodeMode(false)

{
  numIntVars = 10 + 0;
  numExtVars = 4;


  // Right now, we only have store for limited probes...
  setNumStoreVars(8);

  // Manually inserted code:  detect extra nodes given on instance line,
  // set external node mode for those normally-internal nodes.
  devConMap.resize(numExtVars);
  for (int j=0; j< numExtVars; j++)
    devConMap[j] = 1;

  if (instance_block.numExtVars > numExtVars)
  {
    devConMap.resize(instance_block.numExtVars);
    if (instance_block.numExtVars >= numExtVars+1)
    {
      dtExternalNodeMode=true;
      --numIntVars;
      devConMap[numExtVars] = 2;       
    }
    if (instance_block.numExtVars >= numExtVars+2)
    {
      cxExternalNodeMode=true;
      --numIntVars;
      devConMap[numExtVars+1] = 1;       
    }
    if (instance_block.numExtVars >= numExtVars+3)
    {
      ciExternalNodeMode=true;
      --numIntVars;
      devConMap[numExtVars+2] = 1;       
    }
    if (instance_block.numExtVars >= numExtVars+4)
    {
      bxExternalNodeMode=true;
      --numIntVars;
      devConMap[numExtVars+3] = 1;       
    }
    if (instance_block.numExtVars >= numExtVars+5)
    {
      biExternalNodeMode=true;
      --numIntVars;
      devConMap[numExtVars+4] = 1;       
    }
    if (instance_block.numExtVars >= numExtVars+6)
    {
      eiExternalNodeMode=true;
      --numIntVars;
      devConMap[numExtVars+5] = 1;       
    }
    numExtVars=instance_block.numExtVars;
  }
  // End manually inserted code
  
  // Do not allocate "branch" (lead current) vectors by default
  setNumBranchDataVars(0);
  numBranchDataVarsIfAllocated = 4;

  leadCurrentF.resize(4);
  leadCurrentQ.resize(4);
  
  // Set up jacobian stamp:
  // Create a vector of the non-zero elements of the stamp
  PairVector jacobianElements;
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_cx));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_bx));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_bp));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_cx));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_bx));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_xf2));
  jacobianElements.push_back(IntPair(admsNodeID_cx,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_cx,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_cx,admsNodeID_bx));
  jacobianElements.push_back(IntPair(admsNodeID_cx,admsNodeID_cx));
  jacobianElements.push_back(IntPair(admsNodeID_cx,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_cx,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_cx,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_cx,admsNodeID_bp));
  jacobianElements.push_back(IntPair(admsNodeID_cx,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_xf2));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_bx));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_bp));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_cx));
  jacobianElements.push_back(IntPair(admsNodeID_bx,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_bx,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_bx,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_bx,admsNodeID_bx));
  jacobianElements.push_back(IntPair(admsNodeID_bx,admsNodeID_bp));
  jacobianElements.push_back(IntPair(admsNodeID_bx,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_bx,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_bx,admsNodeID_cx));
  jacobianElements.push_back(IntPair(admsNodeID_bx,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_bx,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_bx));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_bp));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_xf2));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_cx));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_bx));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_bp));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_xf2));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_cx));
  jacobianElements.push_back(IntPair(admsNodeID_bp,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_bp,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_bp,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_bp,admsNodeID_bx));
  jacobianElements.push_back(IntPair(admsNodeID_bp,admsNodeID_bp));
  jacobianElements.push_back(IntPair(admsNodeID_bp,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_bp,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_bp,admsNodeID_cx));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_bx));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_bp));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_xf1,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_xf1,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_xf1,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_xf1,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_xf1,admsNodeID_xf2));
  jacobianElements.push_back(IntPair(admsNodeID_xf1,admsNodeID_xf1));
  jacobianElements.push_back(IntPair(admsNodeID_xf2,admsNodeID_xf1));
  jacobianElements.push_back(IntPair(admsNodeID_xf2,admsNodeID_xf2));

  

  setDefaultParams();
  setParams(instance_block.params);

  // Real bogosity here...
  if (!given("XYCEADMSINSTTEMP"))
    admsInstTemp=getDeviceOptions().temp.getImmutableValue<double>();

  //calculate any parameters specified as expressions
  updateDependentParameters();

  // calculate dependent (i.e. computed params) and check for errors.
  processParams();

  PairVector collapsedNodes;

  // Now generate the jacstamp from what we already have.
  // This jacstamp will have all the correct node mapping.  map will be the nodal mapping of original
  // node IDs to row/column ids in the reduced (non-sparse) representation of the jacobian.
  // (for devices that have no collapsibles, this will be static, so check that it hasn't already
  // been filled in)
  if (jacStamp.empty())
  {
    int originalSize = 14+0;
    computeJacStampAndMaps(jacobianElements,collapsedNodes,jacStamp,nodeMap,pairToJacStampMap,originalSize);
  }

}

//-----------------------------------------------------------------------------
// Function      : Instance::~Instance
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
Instance::~Instance()
{
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerLIDs
// Purpose       : function for registering, and setting up, local ID's.
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerLIDs( const LocalIdVector & intLIDVecRef,
                             const LocalIdVector & extLIDVecRef)
{
  AssertLIDs(intLIDVecRef.size() == numIntVars);
  AssertLIDs(extLIDVecRef.size() == numExtVars);

  LocalIdVector localLIDVec;
  
  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << std::endl << section_divider << std::endl
                 << "In ADMSvbic13_4t::Instance::register LIDs\n\n"
                 << "name             = " << getName() << std::endl
                 << "number of internal variables: " << numIntVars << std::endl
                 << "number of external variables: " << numExtVars << std::endl;
  }

  // copy over the global ID lists into a local array.
  // The end result of this is an array of LIDs corresponding to all the
  // nodes we actually have, in the order that topology thinks of them
  intLIDVec = intLIDVecRef;
  extLIDVec = extLIDVecRef;
  localLIDVec.resize(numExtVars+numIntVars);
  for (int localNodeIndex=0;localNodeIndex<numExtVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=extLIDVec[localNodeIndex];
  }
  for (int localNodeIndex=numExtVars;localNodeIndex<numExtVars+numIntVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=intLIDVec[localNodeIndex-numExtVars];
  }
    
  // Now pull the LIDs for each of our nodes out of the local array.
  // Use the node mapping created by createJacStampAndMaps to handle
  // all the node collapse complications.
  li_c = localLIDVec[nodeMap[admsNodeID_c]];
  li_b = localLIDVec[nodeMap[admsNodeID_b]];
  li_e = localLIDVec[nodeMap[admsNodeID_e]];
  li_s = localLIDVec[nodeMap[admsNodeID_s]];
  li_dt = localLIDVec[nodeMap[admsNodeID_dt]];
  li_cx = localLIDVec[nodeMap[admsNodeID_cx]];
  li_ci = localLIDVec[nodeMap[admsNodeID_ci]];
  li_bx = localLIDVec[nodeMap[admsNodeID_bx]];
  li_bi = localLIDVec[nodeMap[admsNodeID_bi]];
  li_ei = localLIDVec[nodeMap[admsNodeID_ei]];
  li_bp = localLIDVec[nodeMap[admsNodeID_bp]];
  li_si = localLIDVec[nodeMap[admsNodeID_si]];
  li_xf1 = localLIDVec[nodeMap[admsNodeID_xf1]];
  li_xf2 = localLIDVec[nodeMap[admsNodeID_xf2]];


  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << "\nSolution and RHS variables:\n";
    Xyce::dout() << "\nli_c = " << li_c << std::endl;
    Xyce::dout() << "\nli_b = " << li_b << std::endl;
    Xyce::dout() << "\nli_e = " << li_e << std::endl;
    Xyce::dout() << "\nli_s = " << li_s << std::endl;
    Xyce::dout() << "\nli_dt = " << li_dt << std::endl;
    Xyce::dout() << "\nli_cx = " << li_cx << std::endl;
    Xyce::dout() << "\nli_ci = " << li_ci << std::endl;
    Xyce::dout() << "\nli_bx = " << li_bx << std::endl;
    Xyce::dout() << "\nli_bi = " << li_bi << std::endl;
    Xyce::dout() << "\nli_ei = " << li_ei << std::endl;
    Xyce::dout() << "\nli_bp = " << li_bp << std::endl;
    Xyce::dout() << "\nli_si = " << li_si << std::endl;
    Xyce::dout() << "\nli_xf1 = " << li_xf1 << std::endl;
    Xyce::dout() << "\nli_xf2 = " << li_xf2 << std::endl;

    Xyce::dout() << "\nEnd of ADMSvbic13_4t::Instance::register LIDs\n";
    Xyce::dout() << section_divider << std::endl;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadNodeSymbols
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::loadNodeSymbols(Util::SymbolTable &symbol_table) const
{
  addInternalNode(symbol_table, li_dt, getName(), "dt");
  addInternalNode(symbol_table, li_cx, getName(), "cx");
  addInternalNode(symbol_table, li_ci, getName(), "ci");
  addInternalNode(symbol_table, li_bx, getName(), "bx");
  addInternalNode(symbol_table, li_bi, getName(), "bi");
  addInternalNode(symbol_table, li_ei, getName(), "ei");
  addInternalNode(symbol_table, li_bp, getName(), "bp");
  addInternalNode(symbol_table, li_si, getName(), "si");
  addInternalNode(symbol_table, li_xf1, getName(), "xf1");
  addInternalNode(symbol_table, li_xf2, getName(), "xf2");

  if (loadLeadCurrent)
  {
    addBranchDataNode( symbol_table, li_branch_ic, getName(), "BRANCH_DC");
    addBranchDataNode( symbol_table, li_branch_ib, getName(), "BRANCH_DB");
    addBranchDataNode( symbol_table, li_branch_ie, getName(), "BRANCH_DE");
    addBranchDataNode( symbol_table, li_branch_is, getName(), "BRANCH_D4");
  }
}
 
//-----------------------------------------------------------------------------
// Function      : Instance::registerStoreLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerStoreLIDs( const LocalIdVector & stoLIDVecRef)
{
  AssertLIDs(stoLIDVecRef.size() == getNumStoreVars());

  int numSto = stoLIDVecRef.size();
  if (numSto > 0)
  {
    int i=0;
    stoLIDVec = stoLIDVecRef;

    li_store_admsProbeID_Temp_dt_GND = stoLIDVec[i++];
    li_store_admsProbeID_V_bi_ei = stoLIDVec[i++];
    li_store_admsProbeID_V_bx_ei = stoLIDVec[i++];
    li_store_admsProbeID_V_bi_ci = stoLIDVec[i++];
    li_store_admsProbeID_V_bi_cx = stoLIDVec[i++];
    li_store_admsProbeID_V_bx_cx = stoLIDVec[i++];
    li_store_admsProbeID_V_bx_bp = stoLIDVec[i++];
    li_store_admsProbeID_V_b_e = stoLIDVec[i++];
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerBranchDataLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : Eric Keiter, SNL
// Creation Date : 12/09/11
//-----------------------------------------------------------------------------
void Instance::registerBranchDataLIDs(const std::vector<int> & branchLIDVecRef)
{
  AssertLIDs(branchLIDVecRef.size() == getNumBranchDataVars());

  if (loadLeadCurrent)
  {    
    int i = 0;
    li_branch_ic = branchLIDVecRef[i++];
    li_branch_ib = branchLIDVecRef[i++];
    li_branch_ie = branchLIDVecRef[i++];
    li_branch_is = branchLIDVecRef[i++];
  }
}
  
//-----------------------------------------------------------------------------
// Function      : Instance::jacobianStamp
// Purpose       :
// Special Notes : In initial version, we won't support mapping away nodes
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
const JacobianStamp & Instance::jacobianStamp() const
{
  return jacStamp;
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerJacLIDs
// Purpose       : Create Offset variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerJacLIDs( const JacobianStamp & jacLIDVec)
{
  DeviceInstance::registerJacLIDs(jacLIDVec);  IntPair jacLoc;
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_dt)];
  A_c_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_c)];
  A_c_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_cx)];
  A_c_Equ_cx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_b)];
  A_c_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_dt)];
  A_b_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_b)];
  A_b_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_bx)];
  A_b_Equ_bx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_e)];
  A_b_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_c)];
  A_b_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_dt)];
  A_e_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_e)];
  A_e_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_ei)];
  A_e_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_b)];
  A_e_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_dt)];
  A_s_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_s)];
  A_s_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_si)];
  A_s_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_dt)];
  A_dt_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_bp)];
  A_dt_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_cx)];
  A_dt_Equ_cx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_e)];
  A_dt_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_ei)];
  A_dt_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_bx)];
  A_dt_Equ_bx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_bi)];
  A_dt_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_b)];
  A_dt_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_ci)];
  A_dt_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_c)];
  A_dt_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_si)];
  A_dt_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_s)];
  A_dt_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_xf2)];
  A_dt_Equ_xf2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_cx,admsNodeID_bi)];
  A_cx_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_cx,admsNodeID_ci)];
  A_cx_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_cx,admsNodeID_bx)];
  A_cx_Equ_bx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_cx,admsNodeID_cx)];
  A_cx_Equ_cx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_cx,admsNodeID_dt)];
  A_cx_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_cx,admsNodeID_c)];
  A_cx_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_cx,admsNodeID_ei)];
  A_cx_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_cx,admsNodeID_bp)];
  A_cx_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_cx,admsNodeID_si)];
  A_cx_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_xf2)];
  A_ci_Equ_xf2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_bi)];
  A_ci_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_ei)];
  A_ci_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_ci)];
  A_ci_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_dt)];
  A_ci_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_bx)];
  A_ci_Equ_bx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_bp)];
  A_ci_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_si)];
  A_ci_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_cx)];
  A_ci_Equ_cx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bx,admsNodeID_bi)];
  A_bx_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bx,admsNodeID_ei)];
  A_bx_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bx,admsNodeID_ci)];
  A_bx_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bx,admsNodeID_bx)];
  A_bx_Equ_bx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bx,admsNodeID_bp)];
  A_bx_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bx,admsNodeID_si)];
  A_bx_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bx,admsNodeID_dt)];
  A_bx_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bx,admsNodeID_cx)];
  A_bx_Equ_cx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bx,admsNodeID_c)];
  A_bx_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bx,admsNodeID_b)];
  A_bx_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_bx)];
  A_bi_Equ_bx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_bp)];
  A_bi_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_si)];
  A_bi_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_bi)];
  A_bi_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_ci)];
  A_bi_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_ei)];
  A_bi_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_dt)];
  A_bi_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_xf2)];
  A_bi_Equ_xf2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_cx)];
  A_bi_Equ_cx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_bx)];
  A_ei_Equ_bx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_bp)];
  A_ei_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_si)];
  A_ei_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_bi)];
  A_ei_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_ci)];
  A_ei_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_ei)];
  A_ei_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_dt)];
  A_ei_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_xf2)];
  A_ei_Equ_xf2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_e)];
  A_ei_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_cx)];
  A_ei_Equ_cx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bp,admsNodeID_bi)];
  A_bp_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bp,admsNodeID_ei)];
  A_bp_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bp,admsNodeID_ci)];
  A_bp_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bp,admsNodeID_bx)];
  A_bp_Equ_bx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bp,admsNodeID_bp)];
  A_bp_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bp,admsNodeID_si)];
  A_bp_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bp,admsNodeID_dt)];
  A_bp_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bp,admsNodeID_cx)];
  A_bp_Equ_cx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_bi)];
  A_si_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_ei)];
  A_si_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_ci)];
  A_si_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_bx)];
  A_si_Equ_bx_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_bp)];
  A_si_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_si)];
  A_si_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_dt)];
  A_si_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_s)];
  A_si_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf1,admsNodeID_bi)];
  A_xf1_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf1,admsNodeID_ci)];
  A_xf1_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf1,admsNodeID_ei)];
  A_xf1_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf1,admsNodeID_dt)];
  A_xf1_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf1,admsNodeID_xf2)];
  A_xf1_Equ_xf2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf1,admsNodeID_xf1)];
  A_xf1_Equ_xf1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf2,admsNodeID_xf1)];
  A_xf2_Equ_xf1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf2,admsNodeID_xf2)];
  A_xf2_Equ_xf2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];


}

//-----------------------------------------------------------------------------
// Function      : Instance::setupPointers
// Purpose       : Create pointer variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupPointers( )
{

  Linear::Matrix * dFdxMatPtr = extData.dFdxMatrixPtr;
  Linear::Matrix * dQdxMatPtr = extData.dQdxMatrixPtr;
  f_c_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c,li_dt);
  q_c_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c,li_dt);
  f_c_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c,li_c);
  q_c_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c,li_c);
  f_c_Equ_cx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c,li_cx);
  q_c_Equ_cx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c,li_cx);
  f_c_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c,li_b);
  q_c_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c,li_b);
  f_b_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_dt);
  q_b_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_dt);
  f_b_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_b);
  q_b_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_b);
  f_b_Equ_bx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_bx);
  q_b_Equ_bx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_bx);
  f_b_Equ_e_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_e);
  q_b_Equ_e_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_e);
  f_b_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_c);
  q_b_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_c);
  f_e_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e,li_dt);
  q_e_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e,li_dt);
  f_e_Equ_e_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e,li_e);
  q_e_Equ_e_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e,li_e);
  f_e_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e,li_ei);
  q_e_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e,li_ei);
  f_e_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e,li_b);
  q_e_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e,li_b);
  f_s_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_dt);
  q_s_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_dt);
  f_s_Equ_s_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_s);
  q_s_Equ_s_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_s);
  f_s_Equ_si_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_si);
  q_s_Equ_si_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_si);
  f_dt_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_dt);
  q_dt_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_dt);
  f_dt_Equ_bp_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_bp);
  q_dt_Equ_bp_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_bp);
  f_dt_Equ_cx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_cx);
  q_dt_Equ_cx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_cx);
  f_dt_Equ_e_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_e);
  q_dt_Equ_e_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_e);
  f_dt_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_ei);
  q_dt_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_ei);
  f_dt_Equ_bx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_bx);
  q_dt_Equ_bx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_bx);
  f_dt_Equ_bi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_bi);
  q_dt_Equ_bi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_bi);
  f_dt_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_b);
  q_dt_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_b);
  f_dt_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_ci);
  q_dt_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_ci);
  f_dt_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_c);
  q_dt_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_c);
  f_dt_Equ_si_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_si);
  q_dt_Equ_si_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_si);
  f_dt_Equ_s_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_s);
  q_dt_Equ_s_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_s);
  f_dt_Equ_xf2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_dt,li_xf2);
  q_dt_Equ_xf2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_dt,li_xf2);
  f_cx_Equ_bi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_cx,li_bi);
  q_cx_Equ_bi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_cx,li_bi);
  f_cx_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_cx,li_ci);
  q_cx_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_cx,li_ci);
  f_cx_Equ_bx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_cx,li_bx);
  q_cx_Equ_bx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_cx,li_bx);
  f_cx_Equ_cx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_cx,li_cx);
  q_cx_Equ_cx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_cx,li_cx);
  f_cx_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_cx,li_dt);
  q_cx_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_cx,li_dt);
  f_cx_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_cx,li_c);
  q_cx_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_cx,li_c);
  f_cx_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_cx,li_ei);
  q_cx_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_cx,li_ei);
  f_cx_Equ_bp_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_cx,li_bp);
  q_cx_Equ_bp_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_cx,li_bp);
  f_cx_Equ_si_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_cx,li_si);
  q_cx_Equ_si_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_cx,li_si);
  f_ci_Equ_xf2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ci,li_xf2);
  q_ci_Equ_xf2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ci,li_xf2);
  f_ci_Equ_bi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ci,li_bi);
  q_ci_Equ_bi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ci,li_bi);
  f_ci_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ci,li_ei);
  q_ci_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ci,li_ei);
  f_ci_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ci,li_ci);
  q_ci_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ci,li_ci);
  f_ci_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ci,li_dt);
  q_ci_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ci,li_dt);
  f_ci_Equ_bx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ci,li_bx);
  q_ci_Equ_bx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ci,li_bx);
  f_ci_Equ_bp_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ci,li_bp);
  q_ci_Equ_bp_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ci,li_bp);
  f_ci_Equ_si_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ci,li_si);
  q_ci_Equ_si_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ci,li_si);
  f_ci_Equ_cx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ci,li_cx);
  q_ci_Equ_cx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ci,li_cx);
  f_bx_Equ_bi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bx,li_bi);
  q_bx_Equ_bi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bx,li_bi);
  f_bx_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bx,li_ei);
  q_bx_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bx,li_ei);
  f_bx_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bx,li_ci);
  q_bx_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bx,li_ci);
  f_bx_Equ_bx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bx,li_bx);
  q_bx_Equ_bx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bx,li_bx);
  f_bx_Equ_bp_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bx,li_bp);
  q_bx_Equ_bp_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bx,li_bp);
  f_bx_Equ_si_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bx,li_si);
  q_bx_Equ_si_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bx,li_si);
  f_bx_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bx,li_dt);
  q_bx_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bx,li_dt);
  f_bx_Equ_cx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bx,li_cx);
  q_bx_Equ_cx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bx,li_cx);
  f_bx_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bx,li_c);
  q_bx_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bx,li_c);
  f_bx_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bx,li_b);
  q_bx_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bx,li_b);
  f_bi_Equ_bx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bi,li_bx);
  q_bi_Equ_bx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bi,li_bx);
  f_bi_Equ_bp_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bi,li_bp);
  q_bi_Equ_bp_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bi,li_bp);
  f_bi_Equ_si_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bi,li_si);
  q_bi_Equ_si_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bi,li_si);
  f_bi_Equ_bi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bi,li_bi);
  q_bi_Equ_bi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bi,li_bi);
  f_bi_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bi,li_ci);
  q_bi_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bi,li_ci);
  f_bi_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bi,li_ei);
  q_bi_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bi,li_ei);
  f_bi_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bi,li_dt);
  q_bi_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bi,li_dt);
  f_bi_Equ_xf2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bi,li_xf2);
  q_bi_Equ_xf2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bi,li_xf2);
  f_bi_Equ_cx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bi,li_cx);
  q_bi_Equ_cx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bi,li_cx);
  f_ei_Equ_bx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ei,li_bx);
  q_ei_Equ_bx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ei,li_bx);
  f_ei_Equ_bp_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ei,li_bp);
  q_ei_Equ_bp_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ei,li_bp);
  f_ei_Equ_si_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ei,li_si);
  q_ei_Equ_si_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ei,li_si);
  f_ei_Equ_bi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ei,li_bi);
  q_ei_Equ_bi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ei,li_bi);
  f_ei_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ei,li_ci);
  q_ei_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ei,li_ci);
  f_ei_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ei,li_ei);
  q_ei_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ei,li_ei);
  f_ei_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ei,li_dt);
  q_ei_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ei,li_dt);
  f_ei_Equ_xf2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ei,li_xf2);
  q_ei_Equ_xf2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ei,li_xf2);
  f_ei_Equ_e_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ei,li_e);
  q_ei_Equ_e_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ei,li_e);
  f_ei_Equ_cx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_ei,li_cx);
  q_ei_Equ_cx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_ei,li_cx);
  f_bp_Equ_bi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bp,li_bi);
  q_bp_Equ_bi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bp,li_bi);
  f_bp_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bp,li_ei);
  q_bp_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bp,li_ei);
  f_bp_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bp,li_ci);
  q_bp_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bp,li_ci);
  f_bp_Equ_bx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bp,li_bx);
  q_bp_Equ_bx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bp,li_bx);
  f_bp_Equ_bp_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bp,li_bp);
  q_bp_Equ_bp_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bp,li_bp);
  f_bp_Equ_si_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bp,li_si);
  q_bp_Equ_si_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bp,li_si);
  f_bp_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bp,li_dt);
  q_bp_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bp,li_dt);
  f_bp_Equ_cx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_bp,li_cx);
  q_bp_Equ_cx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_bp,li_cx);
  f_si_Equ_bi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_si,li_bi);
  q_si_Equ_bi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_si,li_bi);
  f_si_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_si,li_ei);
  q_si_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_si,li_ei);
  f_si_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_si,li_ci);
  q_si_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_si,li_ci);
  f_si_Equ_bx_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_si,li_bx);
  q_si_Equ_bx_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_si,li_bx);
  f_si_Equ_bp_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_si,li_bp);
  q_si_Equ_bp_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_si,li_bp);
  f_si_Equ_si_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_si,li_si);
  q_si_Equ_si_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_si,li_si);
  f_si_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_si,li_dt);
  q_si_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_si,li_dt);
  f_si_Equ_s_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_si,li_s);
  q_si_Equ_s_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_si,li_s);
  f_xf1_Equ_bi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_xf1,li_bi);
  q_xf1_Equ_bi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_xf1,li_bi);
  f_xf1_Equ_ci_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_xf1,li_ci);
  q_xf1_Equ_ci_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_xf1,li_ci);
  f_xf1_Equ_ei_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_xf1,li_ei);
  q_xf1_Equ_ei_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_xf1,li_ei);
  f_xf1_Equ_dt_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_xf1,li_dt);
  q_xf1_Equ_dt_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_xf1,li_dt);
  f_xf1_Equ_xf2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_xf1,li_xf2);
  q_xf1_Equ_xf2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_xf1,li_xf2);
  f_xf1_Equ_xf1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_xf1,li_xf1);
  q_xf1_Equ_xf1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_xf1,li_xf1);
  f_xf2_Equ_xf1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_xf2,li_xf1);
  q_xf2_Equ_xf1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_xf2,li_xf1);
  f_xf2_Equ_xf2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_xf2,li_xf2);
  q_xf2_Equ_xf2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_xf2,li_xf2);


}

// RHS load functions

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEFVector
// Purpose       : load F vector (static contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEFVector()
{

  bool bsuccess=true;
  (*extData.daeFVectorPtr)[li_c] += staticContributions[admsNodeID_c].val();
  (*extData.daeFVectorPtr)[li_b] += staticContributions[admsNodeID_b].val();
  (*extData.daeFVectorPtr)[li_e] += staticContributions[admsNodeID_e].val();
  (*extData.daeFVectorPtr)[li_s] += staticContributions[admsNodeID_s].val();
  (*extData.daeFVectorPtr)[li_dt] += staticContributions[admsNodeID_dt].val();
  (*extData.daeFVectorPtr)[li_cx] += staticContributions[admsNodeID_cx].val();
  (*extData.daeFVectorPtr)[li_ci] += staticContributions[admsNodeID_ci].val();
  (*extData.daeFVectorPtr)[li_bx] += staticContributions[admsNodeID_bx].val();
  (*extData.daeFVectorPtr)[li_bi] += staticContributions[admsNodeID_bi].val();
  (*extData.daeFVectorPtr)[li_ei] += staticContributions[admsNodeID_ei].val();
  (*extData.daeFVectorPtr)[li_bp] += staticContributions[admsNodeID_bp].val();
  (*extData.daeFVectorPtr)[li_si] += staticContributions[admsNodeID_si].val();
  (*extData.daeFVectorPtr)[li_xf1] += staticContributions[admsNodeID_xf1].val();
  (*extData.daeFVectorPtr)[li_xf2] += staticContributions[admsNodeID_xf2].val();

  if (getDeviceOptions().voltageLimiterFlag && !origFlag)
  {
    double *dFdxdVp = extData.dFdxdVpVectorRawPtr;
    dFdxdVp[li_c] += Jdxp_static[admsNodeID_c];
    dFdxdVp[li_b] += Jdxp_static[admsNodeID_b];
    dFdxdVp[li_e] += Jdxp_static[admsNodeID_e];
    dFdxdVp[li_s] += Jdxp_static[admsNodeID_s];
    dFdxdVp[li_dt] += Jdxp_static[admsNodeID_dt];
    dFdxdVp[li_cx] += Jdxp_static[admsNodeID_cx];
    dFdxdVp[li_ci] += Jdxp_static[admsNodeID_ci];
    dFdxdVp[li_bx] += Jdxp_static[admsNodeID_bx];
    dFdxdVp[li_bi] += Jdxp_static[admsNodeID_bi];
    dFdxdVp[li_ei] += Jdxp_static[admsNodeID_ei];
    dFdxdVp[li_bp] += Jdxp_static[admsNodeID_bp];
    dFdxdVp[li_si] += Jdxp_static[admsNodeID_si];
    dFdxdVp[li_xf1] += Jdxp_static[admsNodeID_xf1];
    dFdxdVp[li_xf2] += Jdxp_static[admsNodeID_xf2];


  }

  if (loadLeadCurrent)
  {
    double * leadF = extData.nextLeadCurrFCompRawPtr;

    leadF[li_branch_ic] = leadCurrentF[admsNodeID_c];
    leadF[li_branch_ib] = leadCurrentF[admsNodeID_b];
    leadF[li_branch_ie] = leadCurrentF[admsNodeID_e];
    leadF[li_branch_is] = leadCurrentF[admsNodeID_s];

    // here we have to do special things for BJTs, MOSFETs and 2-terminal
    // devices for power computation.
    
    double * solVec = extData.nextSolVectorRawPtr;
    double * junctionV = extData.nextJunctionVCompRawPtr;
    junctionV[li_branch_ic] = solVec[li_c] - solVec[li_e];
    junctionV[li_branch_ib] = solVec[li_b] - solVec[li_e];
          
  }  
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEQVector
// Purpose       : load Q vector (dynamic contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEQVector()
{
  (*extData.daeQVectorPtr)[li_c] += dynamicContributions[admsNodeID_c].val();
  (*extData.daeQVectorPtr)[li_b] += dynamicContributions[admsNodeID_b].val();
  (*extData.daeQVectorPtr)[li_e] += dynamicContributions[admsNodeID_e].val();
  (*extData.daeQVectorPtr)[li_s] += dynamicContributions[admsNodeID_s].val();
  (*extData.daeQVectorPtr)[li_dt] += dynamicContributions[admsNodeID_dt].val();
  (*extData.daeQVectorPtr)[li_cx] += dynamicContributions[admsNodeID_cx].val();
  (*extData.daeQVectorPtr)[li_ci] += dynamicContributions[admsNodeID_ci].val();
  (*extData.daeQVectorPtr)[li_bx] += dynamicContributions[admsNodeID_bx].val();
  (*extData.daeQVectorPtr)[li_bi] += dynamicContributions[admsNodeID_bi].val();
  (*extData.daeQVectorPtr)[li_ei] += dynamicContributions[admsNodeID_ei].val();
  (*extData.daeQVectorPtr)[li_bp] += dynamicContributions[admsNodeID_bp].val();
  (*extData.daeQVectorPtr)[li_si] += dynamicContributions[admsNodeID_si].val();
  (*extData.daeQVectorPtr)[li_xf1] += dynamicContributions[admsNodeID_xf1].val();
  (*extData.daeQVectorPtr)[li_xf2] += dynamicContributions[admsNodeID_xf2].val();

  if (getDeviceOptions().voltageLimiterFlag && !origFlag)
  {
    double *dQdxdVp = extData.dQdxdVpVectorRawPtr;
    dQdxdVp[li_c] += Jdxp_dynamic[admsNodeID_c];
    dQdxdVp[li_b] += Jdxp_dynamic[admsNodeID_b];
    dQdxdVp[li_e] += Jdxp_dynamic[admsNodeID_e];
    dQdxdVp[li_s] += Jdxp_dynamic[admsNodeID_s];
    dQdxdVp[li_dt] += Jdxp_dynamic[admsNodeID_dt];
    dQdxdVp[li_cx] += Jdxp_dynamic[admsNodeID_cx];
    dQdxdVp[li_ci] += Jdxp_dynamic[admsNodeID_ci];
    dQdxdVp[li_bx] += Jdxp_dynamic[admsNodeID_bx];
    dQdxdVp[li_bi] += Jdxp_dynamic[admsNodeID_bi];
    dQdxdVp[li_ei] += Jdxp_dynamic[admsNodeID_ei];
    dQdxdVp[li_bp] += Jdxp_dynamic[admsNodeID_bp];
    dQdxdVp[li_si] += Jdxp_dynamic[admsNodeID_si];
    dQdxdVp[li_xf1] += Jdxp_dynamic[admsNodeID_xf1];
    dQdxdVp[li_xf2] += Jdxp_dynamic[admsNodeID_xf2];

  }

  if (loadLeadCurrent)
  {
    double * leadQ = extData.nextLeadCurrQCompRawPtr;

    leadQ[li_branch_ic] = leadCurrentQ[admsNodeID_c];
    leadQ[li_branch_ib] = leadCurrentQ[admsNodeID_b];
    leadQ[li_branch_ie] = leadCurrentQ[admsNodeID_e];
    leadQ[li_branch_is] = leadCurrentQ[admsNodeID_s];
  }  
  return true;
}


//-----------------------------------------------------------------------------
// Function      : Instance::updatePrimaryState
// Purpose       :
// Special Notes : In this initial implementation, does little more than
//                 call updateIntermediateVars()
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updatePrimaryState()
{
  bool bsuccess = true;

  bsuccess = updateIntermediateVars();

  // if old DAE were implemented, we'd save dynamic contributions as state
  // here.

  double * stoVec = extData.nextStoVectorRawPtr;
  // Also need to save limited voltage drops
  // This formulation assumes that we have *always* written the
  // limited voltages back into the probeVars[] array.

  stoVec[li_store_admsProbeID_Temp_dt_GND] = probeVars[admsProbeID_Temp_dt_GND].val();
  stoVec[li_store_admsProbeID_V_bi_ei] = probeVars[admsProbeID_V_bi_ei].val();
  stoVec[li_store_admsProbeID_V_bx_ei] = probeVars[admsProbeID_V_bx_ei].val();
  stoVec[li_store_admsProbeID_V_bi_ci] = probeVars[admsProbeID_V_bi_ci].val();
  stoVec[li_store_admsProbeID_V_bi_cx] = probeVars[admsProbeID_V_bi_cx].val();
  stoVec[li_store_admsProbeID_V_bx_cx] = probeVars[admsProbeID_V_bx_cx].val();
  stoVec[li_store_admsProbeID_V_bx_bp] = probeVars[admsProbeID_V_bx_bp].val();
  stoVec[li_store_admsProbeID_V_b_e] = probeVars[admsProbeID_V_b_e].val();

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateSecondaryState
// Purpose       :
// Special Notes : In this initial implementation, does nothing
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateSecondaryState()
{
  bool bsuccess = true;

  // were old DAE implemented, we'd pull dynamic contribution derivatives
  // out of state.

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateIntermediateVars
// Purpose       : update intermediate variables for one vbic13_4t instance
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateIntermediateVars()
{

  bool bsuccess=true;
  Linear::Vector * solVectorPtr = extData.nextSolVectorPtr;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << std::endl << subsection_divider << std::endl;
    Xyce::dout() << "  In ADMSvbic13_4t::Instance::updateIntermediateVars\n\n";
    Xyce::dout() << "  name = " << getName() << std::endl;
  }

  // Local variables
  AdmsFadType qdbcp;
  AdmsFadType qdbex;
  AdmsFadType qdbep;
  AdmsFadType sgIf;
  AdmsFadType rIf;
  AdmsFadType mIf;
  AdmsFadType tff;
  AdmsFadType Qbe;
  AdmsFadType Qbex;
  AdmsFadType Qbc;
  AdmsFadType Qbcx;
  AdmsFadType Qbep;
  AdmsFadType Qbcp;
  AdmsFadType Qbeo;
  AdmsFadType Qbco;
  AdmsFadType Qcth;
  AdmsFadType Qxf1;
  AdmsFadType Qxf2;
  AdmsFadType dt_et;
  AdmsFadType dT;
  AdmsFadType ikf_t;
  AdmsFadType rcx_t;
  AdmsFadType rci_t;
  AdmsFadType rbx_t;
  AdmsFadType rbi_t;
  AdmsFadType re_t;
  AdmsFadType rs_t;
  AdmsFadType rbp_t;
  AdmsFadType rth_t;
  AdmsFadType nf_t;
  AdmsFadType nr_t;
  AdmsFadType avc2_t;
  AdmsFadType avcx2_t;
  AdmsFadType vbbe_t;
  AdmsFadType nbbe_t;
  AdmsFadType pe_t;
  AdmsFadType pc_t;
  AdmsFadType ps_t;
  AdmsFadType cje_t;
  AdmsFadType cjc_t;
  AdmsFadType cjep_t;
  AdmsFadType cjcp_t;
  AdmsFadType gamm_t;
  AdmsFadType vo_t;
  AdmsFadType ebbe_t;
  AdmsFadType vef_t;
  AdmsFadType ver_t;
  AdmsFadType Gth;
  AdmsFadType Ivef;
  AdmsFadType Iver;
  AdmsFadType Iikf;
  AdmsFadType Ivo;
  AdmsFadType Vbei;
  AdmsFadType Vbex;
  AdmsFadType Vbci;
  AdmsFadType Vbcx;
  AdmsFadType Vbxcx;
  AdmsFadType Vcei;
  AdmsFadType Vbep;
  AdmsFadType Vbe;
  AdmsFadType Vbc;
  AdmsFadType Vrcx;
  AdmsFadType Vrbx;
  AdmsFadType Vrbi;
  AdmsFadType Vre;
  AdmsFadType Vrbp;
  AdmsFadType Vbcp;
  AdmsFadType Vcep;
  AdmsFadType Vrs;
  AdmsFadType Vxf1;
  AdmsFadType Vxf2;
  AdmsFadType qdbe;
  AdmsFadType qdbc;
  AdmsFadType afac;
  AdmsFadType expi;
  AdmsFadType Ifi;
  AdmsFadType Iri;
  AdmsFadType q1z;
  AdmsFadType q1;
  AdmsFadType q2;
  AdmsFadType arg;
  AdmsFadType Itzr;
  AdmsFadType Itxf;
  AdmsFadType expx;
  AdmsFadType Ifp;
  AdmsFadType q2p;
  AdmsFadType Irp;
  AdmsFadType expn;
  AdmsFadType Bvbe;
  AdmsFadType Ibcj;
  AdmsFadType Kbci;
  AdmsFadType Kbcx;
  AdmsFadType Ircx;
  AdmsFadType rKp1;
  AdmsFadType Iohm;
  AdmsFadType derf;
  AdmsFadType Irbx;
  AdmsFadType Irbi;
  AdmsFadType Ire;
  AdmsFadType Irbp;
  AdmsFadType Irs;
  AdmsFadType avalf;
  AdmsFadType Igc;
  AdmsFadType Igcx;
  AdmsFadType VcbFac;
  AdmsFadType Iibk;
  AdmsFadType Ibk;
  AdmsFadType Ibc;
  AdmsFadType Ibcp;
  AdmsFadType power;
  AdmsFadType Ith;
  AdmsFadType Irth;
  AdmsFadType Ixf1;
  AdmsFadType Ixf2;
  // temporary variables for limiting
  double Vbe_orig,Vbe_limited,Vbe_old;
  double Vbep_orig,Vbep_limited,Vbep_old;
  double Vbxcx_orig,Vbxcx_limited,Vbxcx_old;
  double Vbcx_orig,Vbcx_limited,Vbcx_old;
  double Vbci_orig,Vbci_limited,Vbci_old;
  double Vbex_orig,Vbex_limited,Vbex_old;
  double Vbei_orig,Vbei_limited,Vbei_old;
  double dt_et_orig,dt_et_limited,dt_et_old;


  // set the sizes of the Fad arrays:

  if (probeVars.size() != (21))
  {
    probeVars.resize(21);
    staticContributions.resize(14+0);
    dynamicContributions.resize(14+0);
    probeDiffs.resize(21,0.0);
    Jdxp_static.resize(14+0);
    Jdxp_dynamic.resize(14+0);
  }

  noiseContribsPower.resize(15);
  noiseContribsExponent.resize(15);
  
  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 14+0 ; ++i)
  {
    staticContributions[i]=0;
    dynamicContributions[i]=0;
    Jdxp_static[i]=0;
    Jdxp_dynamic[i]=0;
  }

  for (int i=0; i < 21 ; ++i)
  {
    probeDiffs[i] = 0.0;
  }
  // extract solution variables and set as Fad independent variables.
  probeVars[admsProbeID_V_xf2_GND] = (*solVectorPtr)[li_xf2];
  probeVars[admsProbeID_V_xf2_GND].diff(admsProbeID_V_xf2_GND,21);
  probeVars[admsProbeID_V_xf1_GND] = (*solVectorPtr)[li_xf1];
  probeVars[admsProbeID_V_xf1_GND].diff(admsProbeID_V_xf1_GND,21);
  probeVars[admsProbeID_V_s_si] = (*solVectorPtr)[li_s] - (*solVectorPtr)[li_si];
  probeVars[admsProbeID_V_s_si].diff(admsProbeID_V_s_si,21);
  probeVars[admsProbeID_V_bx_si] = (*solVectorPtr)[li_bx] - (*solVectorPtr)[li_si];
  probeVars[admsProbeID_V_bx_si].diff(admsProbeID_V_bx_si,21);
  probeVars[admsProbeID_V_si_bp] = (*solVectorPtr)[li_si] - (*solVectorPtr)[li_bp];
  probeVars[admsProbeID_V_si_bp].diff(admsProbeID_V_si_bp,21);
  probeVars[admsProbeID_V_bp_cx] = (*solVectorPtr)[li_bp] - (*solVectorPtr)[li_cx];
  probeVars[admsProbeID_V_bp_cx].diff(admsProbeID_V_bp_cx,21);
  probeVars[admsProbeID_V_e_ei] = (*solVectorPtr)[li_e] - (*solVectorPtr)[li_ei];
  probeVars[admsProbeID_V_e_ei].diff(admsProbeID_V_e_ei,21);
  probeVars[admsProbeID_V_bx_bi] = (*solVectorPtr)[li_bx] - (*solVectorPtr)[li_bi];
  probeVars[admsProbeID_V_bx_bi].diff(admsProbeID_V_bx_bi,21);
  probeVars[admsProbeID_V_b_bx] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_bx];
  probeVars[admsProbeID_V_b_bx].diff(admsProbeID_V_b_bx,21);
  probeVars[admsProbeID_V_cx_ci] = (*solVectorPtr)[li_cx] - (*solVectorPtr)[li_ci];
  probeVars[admsProbeID_V_cx_ci].diff(admsProbeID_V_cx_ci,21);
  probeVars[admsProbeID_V_c_cx] = (*solVectorPtr)[li_c] - (*solVectorPtr)[li_cx];
  probeVars[admsProbeID_V_c_cx].diff(admsProbeID_V_c_cx,21);
  probeVars[admsProbeID_V_b_c] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_c];
  probeVars[admsProbeID_V_b_c].diff(admsProbeID_V_b_c,21);
  probeVars[admsProbeID_V_b_e] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_e];
  probeVars[admsProbeID_V_b_e].diff(admsProbeID_V_b_e,21);
  probeVars[admsProbeID_V_bx_bp] = (*solVectorPtr)[li_bx] - (*solVectorPtr)[li_bp];
  probeVars[admsProbeID_V_bx_bp].diff(admsProbeID_V_bx_bp,21);
  probeVars[admsProbeID_V_ci_ei] = (*solVectorPtr)[li_ci] - (*solVectorPtr)[li_ei];
  probeVars[admsProbeID_V_ci_ei].diff(admsProbeID_V_ci_ei,21);
  probeVars[admsProbeID_V_bx_cx] = (*solVectorPtr)[li_bx] - (*solVectorPtr)[li_cx];
  probeVars[admsProbeID_V_bx_cx].diff(admsProbeID_V_bx_cx,21);
  probeVars[admsProbeID_V_bi_cx] = (*solVectorPtr)[li_bi] - (*solVectorPtr)[li_cx];
  probeVars[admsProbeID_V_bi_cx].diff(admsProbeID_V_bi_cx,21);
  probeVars[admsProbeID_V_bi_ci] = (*solVectorPtr)[li_bi] - (*solVectorPtr)[li_ci];
  probeVars[admsProbeID_V_bi_ci].diff(admsProbeID_V_bi_ci,21);
  probeVars[admsProbeID_V_bx_ei] = (*solVectorPtr)[li_bx] - (*solVectorPtr)[li_ei];
  probeVars[admsProbeID_V_bx_ei].diff(admsProbeID_V_bx_ei,21);
  probeVars[admsProbeID_V_bi_ei] = (*solVectorPtr)[li_bi] - (*solVectorPtr)[li_ei];
  probeVars[admsProbeID_V_bi_ei].diff(admsProbeID_V_bi_ei,21);
  probeVars[admsProbeID_Temp_dt_GND] = (*solVectorPtr)[li_dt];
  probeVars[admsProbeID_Temp_dt_GND].diff(admsProbeID_Temp_dt_GND,21);


  // pre-multiply any "typed" probes (i.e. those limited with "typedpnjlim")
  probeVars[admsProbeID_V_bx_bp] *= (model_.VBICtype);
  probeVars[admsProbeID_V_bx_cx] *= (model_.VBICtype);
  probeVars[admsProbeID_V_bi_cx] *= (model_.VBICtype);
  probeVars[admsProbeID_V_bi_ci] *= (model_.VBICtype);
  probeVars[admsProbeID_V_bx_ei] *= (model_.VBICtype);
  probeVars[admsProbeID_V_bi_ei] *= (model_.VBICtype);

  // Copy probes into limiting vars

  Vbe_orig = Vbe_limited = probeVars[admsProbeID_V_b_e].val();
  probeDiffs[admsProbeID_V_b_e] = 0.0;
  Vbep_orig = Vbep_limited = probeVars[admsProbeID_V_bx_bp].val();
  probeDiffs[admsProbeID_V_bx_bp] = 0.0;
  Vbxcx_orig = Vbxcx_limited = probeVars[admsProbeID_V_bx_cx].val();
  probeDiffs[admsProbeID_V_bx_cx] = 0.0;
  Vbcx_orig = Vbcx_limited = probeVars[admsProbeID_V_bi_cx].val();
  probeDiffs[admsProbeID_V_bi_cx] = 0.0;
  Vbci_orig = Vbci_limited = probeVars[admsProbeID_V_bi_ci].val();
  probeDiffs[admsProbeID_V_bi_ci] = 0.0;
  Vbex_orig = Vbex_limited = probeVars[admsProbeID_V_bx_ei].val();
  probeDiffs[admsProbeID_V_bx_ei] = 0.0;
  Vbei_orig = Vbei_limited = probeVars[admsProbeID_V_bi_ei].val();
  probeDiffs[admsProbeID_V_bi_ei] = 0.0;
  dt_et_orig = dt_et_limited = probeVars[admsProbeID_Temp_dt_GND].val();
  probeDiffs[admsProbeID_Temp_dt_GND] = 0.0;

  origFlag = true;

  if (getSolverState().newtonIter == 0)
  {

    if (!(getSolverState().dcopFlag)||(getSolverState().locaEnabledFlag && getSolverState().dcopFlag))
    {
      Vbe_old = ((*extData.currStoVectorPtr))[li_store_admsProbeID_V_b_e];
      Vbep_old = ((*extData.currStoVectorPtr))[li_store_admsProbeID_V_bx_bp];
      Vbxcx_old = ((*extData.currStoVectorPtr))[li_store_admsProbeID_V_bx_cx];
      Vbcx_old = ((*extData.currStoVectorPtr))[li_store_admsProbeID_V_bi_cx];
      Vbci_old = ((*extData.currStoVectorPtr))[li_store_admsProbeID_V_bi_ci];
      Vbex_old = ((*extData.currStoVectorPtr))[li_store_admsProbeID_V_bx_ei];
      Vbei_old = ((*extData.currStoVectorPtr))[li_store_admsProbeID_V_bi_ei];
      dt_et_old = ((*extData.currStoVectorPtr))[li_store_admsProbeID_Temp_dt_GND];
    }
    else
    {
      Vbe_old = Vbe_limited;
      Vbep_old = Vbep_limited;
      Vbxcx_old = Vbxcx_limited;
      Vbcx_old = Vbcx_limited;
      Vbci_old = Vbci_limited;
      Vbex_old = Vbex_limited;
      Vbei_old = Vbei_limited;
      dt_et_old = dt_et_limited;
    }
  }
  else
  {
    Vbe_old = ((*extData.nextStoVectorPtr))[li_store_admsProbeID_V_b_e];
    Vbep_old = ((*extData.nextStoVectorPtr))[li_store_admsProbeID_V_bx_bp];
    Vbxcx_old = ((*extData.nextStoVectorPtr))[li_store_admsProbeID_V_bx_cx];
    Vbcx_old = ((*extData.nextStoVectorPtr))[li_store_admsProbeID_V_bi_cx];
    Vbci_old = ((*extData.nextStoVectorPtr))[li_store_admsProbeID_V_bi_ci];
    Vbex_old = ((*extData.nextStoVectorPtr))[li_store_admsProbeID_V_bx_ei];
    Vbei_old = ((*extData.nextStoVectorPtr))[li_store_admsProbeID_V_bi_ei];
    dt_et_old = ((*extData.nextStoVectorPtr))[li_store_admsProbeID_Temp_dt_GND];
  }
  // -- code converted from analog/code block

  // Manually inserted code for voltage drop initialization
  if (getSolverState().newtonIter == 0 && getSolverState().initJctFlag_ && getDeviceOptions().voltageLimiterFlag)
  {
    Vbci_limited = Vbcx_limited = Vbxcx_limited = Vbep_limited = 0;
    Vbe_limited = Vbei_limited = Vbex_limited = tVCrit;
    dt_et_limited = 0;
    origFlag = false;
  }        
          
  //Begin block evaluateStatic
  {


    //dt_et = ($limit(Temp(dt,GND),"limRTH"));
    if (getDeviceOptions().voltageLimiterFlag)
    {
      int icheck=0;
      dt_et_limited = AnalogFunctions::limRTH(dt_et_limited,dt_et_old);
      if (dt_et_limited != dt_et_orig)
      {
        icheck=1;
      }
      if (icheck == 1)
        origFlag = false;
      if (!origFlag)
      {
        probeDiffs[admsProbeID_Temp_dt_GND] = dt_et_limited - dt_et_orig;
        probeVars[admsProbeID_Temp_dt_GND] += probeDiffs[admsProbeID_Temp_dt_GND];
      }
    }
    dt_et = probeVars[admsProbeID_Temp_dt_GND];

    tdevC = (((admsTemperature+trise)+dt_et)-273.15);
    if ((tdevC<((model_.tminclip)+1.0)))
    {
      tdevC = ((model_.tminclip)+exp(((tdevC-(model_.tminclip))-1.0)));
    }
    else
    {
      if ((tdevC>((model_.tmaxclip)-1.0)))
      {
        tdevC = ((model_.tmaxclip)-exp((((model_.tmaxclip)-tdevC)-1.0)));
      }
      else
      {
        tdevC = tdevC;
      }
    }
    tdevK = (tdevC+273.15);
    vtv = ((1.380662e-23*tdevK)/1.602189e-19);
    rT = (tdevK/(model_.tiniK));
    dT = (tdevK-(model_.tiniK));
    ikf_t = ((model_.ikf)*pow(rT,(model_.xikf)));
    if ((model_.given("xrcx")))
    {
      rcx_t = ((model_.rcx)*pow(rT,(model_.xrcx)));
    }
    else
    {
      rcx_t = ((model_.rcx)*pow(rT,(model_.xrc)));
    }
    if ((model_.given("xrci")))
    {
      rci_t = ((model_.rci)*pow(rT,(model_.xrci)));
    }
    else
    {
      rci_t = ((model_.rci)*pow(rT,(model_.xrc)));
    }
    if ((model_.given("xrbx")))
    {
      rbx_t = ((model_.rbx)*pow(rT,(model_.xrbx)));
    }
    else
    {
      rbx_t = ((model_.rbx)*pow(rT,(model_.xrb)));
    }
    if ((model_.given("xrbi")))
    {
      rbi_t = ((model_.rbi)*pow(rT,(model_.xrbi)));
    }
    else
    {
      rbi_t = ((model_.rbi)*pow(rT,(model_.xrb)));
    }
    re_t = ((model_.re)*pow(rT,(model_.xre)));
    rs_t = ((model_.rs)*pow(rT,(model_.xrs)));
    if ((model_.given("xrbp")))
    {
      rbp_t = ((model_.rbp)*pow(rT,(model_.xrbp)));
    }
    else
    {
      rbp_t = ((model_.rbp)*pow(rT,(model_.xrc)));
    }
    rth_t = ((model_.rth)*(1.0+(dT*(model_.tcrth))));
    is_t = (((model_.is)*pow(rT,((model_.xis)/(model_.nf))))*exp((((-(model_.ea))*(1.0-rT))/(vtv*(model_.nf)))));
    isrr_t = (((model_.isrr)*pow(rT,((model_.xisr)/(model_.nr))))*exp((((-(model_.dear))*(1.0-rT))/(vtv*(model_.nr)))));
    isp_t = (((model_.isp)*pow(rT,((model_.xis)/(model_.nfp))))*exp((((-(model_.eap))*(1.0-rT))/(vtv*(model_.nfp)))));
    ibei_t = (((model_.ibei)*pow(rT,((model_.xii)/(model_.nei))))*exp((((-(model_.eaie))*(1.0-rT))/(vtv*(model_.nei)))));
    iben_t = (((model_.iben)*pow(rT,((model_.xin)/(model_.nen))))*exp((((-(model_.eane))*(1.0-rT))/(vtv*(model_.nen)))));
    ibci_t = (((model_.ibci)*pow(rT,((model_.xii)/(model_.nci))))*exp((((-(model_.eaic))*(1.0-rT))/(vtv*(model_.nci)))));
    ibcn_t = (((model_.ibcn)*pow(rT,((model_.xin)/(model_.ncn))))*exp((((-(model_.eanc))*(1.0-rT))/(vtv*(model_.ncn)))));
    ibeip_t = (((model_.ibeip)*pow(rT,((model_.xii)/(model_.nci))))*exp((((-(model_.eaic))*(1.0-rT))/(vtv*(model_.nci)))));
    ibenp_t = (((model_.ibenp)*pow(rT,((model_.xin)/(model_.ncn))))*exp((((-(model_.eanc))*(1.0-rT))/(vtv*(model_.ncn)))));
    ibcip_t = (((model_.ibcip)*pow(rT,((model_.xii)/(model_.ncip))))*exp((((-(model_.eais))*(1.0-rT))/(vtv*(model_.ncip)))));
    ibcnp_t = (((model_.ibcnp)*pow(rT,((model_.xin)/(model_.ncnp))))*exp((((-(model_.eans))*(1.0-rT))/(vtv*(model_.ncnp)))));
    nf_t = ((model_.nf)*(1.0+(dT*(model_.tnf))));
    nr_t = ((model_.nr)*(1.0+(dT*(model_.tnf))));
    avc2_t = ((model_.avc2)*(1.0+(dT*(model_.tavc))));
    avcx2_t = ((model_.avcx2)*(1.0+(dT*(model_.tavcx))));
    vbbe_t = ((model_.vbbe)*(1.0+(dT*((model_.tvbbe1)+(dT*(model_.tvbbe2))))));
    nbbe_t = ((model_.nbbe)*(1.0+(dT*(model_.tnbbe))));
    //Begin block pePsibiBlock
    {
      //Block-local variables for block pePsibiBlock
      AdmsFadType psiio;
      AdmsFadType psiin;
      //End of Block-local variables
      psiio = ((2.0*(vtv/rT))*log((exp((((0.5*(model_.pe))*rT)/vtv))-exp(((((-0.5)*(model_.pe))*rT)/vtv)))));
      psiin = (((psiio*rT)-((3.0*vtv)*log(rT)))-((model_.eaie)*(rT-1.0)));
      pe_t = (psiin+((2.0*vtv)*log((0.5*(1.0+sqrt((1.0+(4.0*exp(((-psiin)/vtv))))))))));
    }
    // End block pePsibiBlock
    //Begin block pcPsibiBlock
    {
      //Block-local variables for block pcPsibiBlock
      AdmsFadType psiio;
      AdmsFadType psiin;
      //End of Block-local variables
      psiio = ((2.0*(vtv/rT))*log((exp((((0.5*(model_.pc))*rT)/vtv))-exp(((((-0.5)*(model_.pc))*rT)/vtv)))));
      psiin = (((psiio*rT)-((3.0*vtv)*log(rT)))-((model_.eaic)*(rT-1.0)));
      pc_t = (psiin+((2.0*vtv)*log((0.5*(1.0+sqrt((1.0+(4.0*exp(((-psiin)/vtv))))))))));
    }
    // End block pcPsibiBlock
    //Begin block psPsibiBlock
    {
      //Block-local variables for block psPsibiBlock
      AdmsFadType psiio;
      AdmsFadType psiin;
      //End of Block-local variables
      psiio = ((2.0*(vtv/rT))*log((exp((((0.5*(model_.ps))*rT)/vtv))-exp(((((-0.5)*(model_.ps))*rT)/vtv)))));
      psiin = (((psiio*rT)-((3.0*vtv)*log(rT)))-((model_.eais)*(rT-1.0)));
      ps_t = (psiin+((2.0*vtv)*log((0.5*(1.0+sqrt((1.0+(4.0*exp(((-psiin)/vtv))))))))));
    }
    // End block psPsibiBlock
    cje_t = ((model_.cje)*pow(((model_.pe)/pe_t),(model_.me)));
    cjc_t = ((model_.cjc)*pow(((model_.pc)/pc_t),(model_.mc)));
    cjep_t = ((model_.cjep)*pow(((model_.pc)/pc_t),(model_.mc)));
    cjcp_t = ((model_.cjcp)*pow(((model_.ps)/ps_t),(model_.ms)));
    gamm_t = (((model_.gamm)*pow(rT,(model_.xis)))*exp((((-(model_.ea))*(1.0-rT))/vtv)));
    vo_t = ((model_.vo)*pow(rT,(model_.xvo)));
    ebbe_t = exp(((-vbbe_t)/(nbbe_t*vtv)));
    vef_t = ((model_.vef)*(1.0+(dT*(model_.tcvef))));
    ver_t = ((model_.ver)*(1.0+(dT*(model_.tcver))));
    Gcx = adms_ternary_op<AdmsFadType>((rcx_t>1.0e-3),(1.0/rcx_t),1.0e3);
    Gci = adms_ternary_op<AdmsFadType>((rci_t>1.0e-3),(1.0/rci_t),1.0e3);
    Gbx = adms_ternary_op<AdmsFadType>((rbx_t>1.0e-3),(1.0/rbx_t),1.0e3);
    Gbi = adms_ternary_op<AdmsFadType>((rbi_t>1.0e-3),(1.0/rbi_t),1.0e3);
    Ge = adms_ternary_op<AdmsFadType>((re_t>1.0e-3),(1.0/re_t),1.0e3);
    Gbp = adms_ternary_op<AdmsFadType>((rbp_t>1.0e-3),(1.0/rbp_t),1.0e3);
    Gs = adms_ternary_op<AdmsFadType>((rs_t>1.0e-3),(1.0/rs_t),1.0e3);
    Gth = adms_ternary_op<AdmsFadType>((rth_t>1.0e-3),(1.0/rth_t),1.0e3);
    Ivef = adms_ternary_op<AdmsFadType>((vef_t>0.0),(1.0/vef_t),0.0);
    Iver = adms_ternary_op<AdmsFadType>((ver_t>0.0),(1.0/ver_t),0.0);
    Iikf = adms_ternary_op<AdmsFadType>((ikf_t>0.0),(1.0/ikf_t),0.0);
    Ivo = adms_ternary_op<AdmsFadType>((vo_t>0.0),(1.0/vo_t),0.0);


    //Vbei = ($limit(V(bi,ei),"typedpnjlim_new",$vt(),tVCrit,VBICtype));
    if (getDeviceOptions().voltageLimiterFlag)
    {
      int icheck=0;
      Vbei_limited = devSupport.pnjlim_new(Vbei_limited,Vbei_old,adms_vt_nom,tVCrit,&icheck);
      if (icheck == 1)
        origFlag = false;
      if (!origFlag)
      {
        probeDiffs[admsProbeID_V_bi_ei] = Vbei_limited - Vbei_orig;
        probeVars[admsProbeID_V_bi_ei] += probeDiffs[admsProbeID_V_bi_ei];
      }
    }
    Vbei = probeVars[admsProbeID_V_bi_ei];



    //Vbex = ($limit(V(bx,ei),"typedpnjlim_new",$vt(),tVCrit,VBICtype));
    if (getDeviceOptions().voltageLimiterFlag)
    {
      int icheck=0;
      Vbex_limited = devSupport.pnjlim_new(Vbex_limited,Vbex_old,adms_vt_nom,tVCrit,&icheck);
      if (icheck == 1)
        origFlag = false;
      if (!origFlag)
      {
        probeDiffs[admsProbeID_V_bx_ei] = Vbex_limited - Vbex_orig;
        probeVars[admsProbeID_V_bx_ei] += probeDiffs[admsProbeID_V_bx_ei];
      }
    }
    Vbex = probeVars[admsProbeID_V_bx_ei];



    //Vbci = ($limit(V(bi,ci),"typedpnjlim_new",$vt(),tVCrit,VBICtype));
    if (getDeviceOptions().voltageLimiterFlag)
    {
      int icheck=0;
      Vbci_limited = devSupport.pnjlim_new(Vbci_limited,Vbci_old,adms_vt_nom,tVCrit,&icheck);
      if (icheck == 1)
        origFlag = false;
      if (!origFlag)
      {
        probeDiffs[admsProbeID_V_bi_ci] = Vbci_limited - Vbci_orig;
        probeVars[admsProbeID_V_bi_ci] += probeDiffs[admsProbeID_V_bi_ci];
      }
    }
    Vbci = probeVars[admsProbeID_V_bi_ci];



    //Vbcx = ($limit(V(bi,cx),"typedpnjlim_new",$vt(),tVCrit,VBICtype));
    if (getDeviceOptions().voltageLimiterFlag)
    {
      int icheck=0;
      Vbcx_limited = devSupport.pnjlim_new(Vbcx_limited,Vbcx_old,adms_vt_nom,tVCrit,&icheck);
      if (icheck == 1)
        origFlag = false;
      if (!origFlag)
      {
        probeDiffs[admsProbeID_V_bi_cx] = Vbcx_limited - Vbcx_orig;
        probeVars[admsProbeID_V_bi_cx] += probeDiffs[admsProbeID_V_bi_cx];
      }
    }
    Vbcx = probeVars[admsProbeID_V_bi_cx];



    //Vbxcx = ($limit(V(bx,cx),"typedpnjlim_new",$vt(),tVCrit,VBICtype));
    if (getDeviceOptions().voltageLimiterFlag)
    {
      int icheck=0;
      Vbxcx_limited = devSupport.pnjlim_new(Vbxcx_limited,Vbxcx_old,adms_vt_nom,tVCrit,&icheck);
      if (icheck == 1)
        origFlag = false;
      if (!origFlag)
      {
        probeDiffs[admsProbeID_V_bx_cx] = Vbxcx_limited - Vbxcx_orig;
        probeVars[admsProbeID_V_bx_cx] += probeDiffs[admsProbeID_V_bx_cx];
      }
    }
    Vbxcx = probeVars[admsProbeID_V_bx_cx];

    Vcei = ((model_.VBICtype)*(probeVars[admsProbeID_V_ci_ei]));


    //Vbep = ($limit(V(bx,bp),"typedpnjlim_new",$vt(),tVCrit,VBICtype));
    if (getDeviceOptions().voltageLimiterFlag)
    {
      int icheck=0;
      Vbep_limited = devSupport.pnjlim_new(Vbep_limited,Vbep_old,adms_vt_nom,tVCrit,&icheck);
      if (icheck == 1)
        origFlag = false;
      if (!origFlag)
      {
        probeDiffs[admsProbeID_V_bx_bp] = Vbep_limited - Vbep_orig;
        probeVars[admsProbeID_V_bx_bp] += probeDiffs[admsProbeID_V_bx_bp];
      }
    }
    Vbep = probeVars[admsProbeID_V_bx_bp];



    //Vbe = ($limit(V(b,e),"dummy",$vt(),tVCrit));
    if (getDeviceOptions().voltageLimiterFlag)
    {
      int icheck=0;
      // dummy limiting for initialization purposes
      if (icheck == 1)
        origFlag = false;
      if (!origFlag)
      {
        probeDiffs[admsProbeID_V_b_e] = Vbe_limited - Vbe_orig;
        probeVars[admsProbeID_V_b_e] += probeDiffs[admsProbeID_V_b_e];
      }
    }
    Vbe = probeVars[admsProbeID_V_b_e];

    Vbc = (probeVars[admsProbeID_V_b_c]);
    Vrcx = (probeVars[admsProbeID_V_c_cx]);
    Vrci = ((model_.VBICtype)*(probeVars[admsProbeID_V_cx_ci]));
    Vrbx = (probeVars[admsProbeID_V_b_bx]);
    Vrbi = (probeVars[admsProbeID_V_bx_bi]);
    Vre = (probeVars[admsProbeID_V_e_ei]);
    Vrbp = (probeVars[admsProbeID_V_bp_cx]);
    Vbcp = ((model_.VBICtype)*(probeVars[admsProbeID_V_si_bp]));
    Vcep = ((model_.VBICtype)*(probeVars[admsProbeID_V_bx_si]));
    Vrs = (probeVars[admsProbeID_V_s_si]);
    Vxf1 = (probeVars[admsProbeID_V_xf1_GND]);
    Vxf2 = (probeVars[admsProbeID_V_xf2_GND]);
    //Begin block qdbeBlock
    {
      //Block-local variables for block qdbeBlock
      AdmsFadType dv0;
      AdmsFadType dvh;
      double pwq;
      AdmsFadType qlo;
      AdmsFadType qhi;
      AdmsFadType mv0;
      AdmsFadType vl0;
      AdmsFadType q0;
      AdmsFadType dv;
      AdmsFadType mv;
      AdmsFadType vl;
      //End of Block-local variables
      dv0 = ((-pe_t)*(model_.fc));
      if (((model_.aje)<=0.0))
      {
        dvh = (Vbei+dv0);
        if ((dvh>0.0))
        {
          pwq = pow((1.0-(model_.fc)),(-(model_.me)));
          qlo = ((pe_t*(1.0-(pwq*(1.0-(model_.fc)))))/(1.0-(model_.me)));
          qhi = ((dvh*(1.0+(((0.5*(model_.me))*dvh)/(pe_t*(1.0-(model_.fc))))))*pwq);
        }
        else
        {
          qlo = ((pe_t*(1.0-pow((1.0-(Vbei/pe_t)),(1.0-(model_.me)))))/(1.0-(model_.me)));
          qhi = 0.0;
        }
        qdbe = (qlo+qhi);
      }
      else
      {
        mv0 = sqrt(((dv0*dv0)+((4.0*(model_.aje))*(model_.aje))));
        vl0 = ((-0.5)*(dv0+mv0));
        q0 = (((-pe_t)*pow((1.0-(vl0/pe_t)),(1.0-(model_.me))))/(1.0-(model_.me)));
        dv = (Vbei+dv0);
        mv = sqrt(((dv*dv)+((4.0*(model_.aje))*(model_.aje))));
        vl = ((0.5*(dv-mv))-dv0);
        qlo = (((-pe_t)*pow((1.0-(vl/pe_t)),(1.0-(model_.me))))/(1.0-(model_.me)));
        qdbe = ((qlo+((pow((1.0-(model_.fc)),(-(model_.me)))*((Vbei-vl)+vl0))*(1.0+(((0.5*(model_.me))*((Vbei-vl)+vl0))/(pe_t*(1.0-(model_.fc)))))))-q0);
      }
    }
    // End block qdbeBlock
    //Begin block qdbcBlock
    {
      //Block-local variables for block qdbcBlock
      AdmsFadType dv0;
      AdmsFadType dvh;
      double pwq;
      AdmsFadType qlo;
      AdmsFadType qhi;
      AdmsFadType vn0;
      AdmsFadType vnl0;
      AdmsFadType vl0;
      AdmsFadType qlo0;
      AdmsFadType vn;
      AdmsFadType vnl;
      AdmsFadType vl;
      AdmsFadType sel;
      AdmsFadType crt;
      AdmsFadType cmx;
      AdmsFadType cl;
      AdmsFadType ql;
      AdmsFadType mv0;
      AdmsFadType q0;
      AdmsFadType dv;
      AdmsFadType mv;
      //End of Block-local variables
      dv0 = ((-pc_t)*(model_.fc));
      if (((model_.ajc)<=0.0))
      {
        dvh = (Vbci+dv0);
        if ((dvh>0.0))
        {
          pwq = pow((1.0-(model_.fc)),((-1.0)-(model_.mc)));
          qlo = ((pc_t*(1.0-((pwq*(1.0-(model_.fc)))*(1.0-(model_.fc)))))/(1.0-(model_.mc)));
          qhi = ((dvh*((1.0-(model_.fc))+(((0.5*(model_.mc))*dvh)/pc_t)))*pwq);
        }
        else
        {
          if ((((model_.vrt)>0.0)&&(Vbci<(-(model_.vrt)))))
          {
            qlo = ((pc_t*(1.0-(pow((1.0+((model_.vrt)/pc_t)),(1.0-(model_.mc)))*(1.0-(((1.0-(model_.mc))*(Vbci+(model_.vrt)))/(pc_t+(model_.vrt)))))))/(1.0-(model_.mc)));
          }
          else
          {
            qlo = ((pc_t*(1.0-pow((1.0-(Vbci/pc_t)),(1.0-(model_.mc)))))/(1.0-(model_.mc)));
          }
          qhi = 0.0;
        }
        qdbc = (qlo+qhi);
      }
      else
      {
        if ((((model_.vrt)>0.0)&&((model_.art)>0.0)))
        {
          vn0 = (((model_.vrt)+dv0)/((model_.vrt)-dv0));
          vnl0 = ((2.0*vn0)/(sqrt((((vn0-1.0)*(vn0-1))+((4*(model_.ajc))*(model_.ajc))))+sqrt((((vn0+1.0)*(vn0+1))+((4*(model_.art))*(model_.art))))));
          vl0 = (0.5*(((vnl0*((model_.vrt)-dv0))-(model_.vrt))-dv0));
          qlo0 = ((pc_t*(1.0-pow((1.0-(vl0/pc_t)),(1.0-(model_.mc)))))/(1.0-(model_.mc)));
          vn = ((((2*Vbci)+(model_.vrt))+dv0)/((model_.vrt)-dv0));
          vnl = ((2.0*vn)/(sqrt((((vn-1.0)*(vn-1))+((4*(model_.ajc))*(model_.ajc))))+sqrt((((vn+1.0)*(vn+1))+((4*(model_.art))*(model_.art))))));
          vl = (0.5*(((vnl*((model_.vrt)-dv0))-(model_.vrt))-dv0));
          qlo = ((pc_t*(1.0-pow((1.0-(vl/pc_t)),(1.0-(model_.mc)))))/(1.0-(model_.mc)));
          sel = (0.5*(vnl+1.0));
          crt = pow((1.0+((model_.vrt)/pc_t)),(-(model_.mc)));
          cmx = pow((1.0+(dv0/pc_t)),(-(model_.mc)));
          cl = (((1.0-sel)*crt)+(sel*cmx));
          ql = (((Vbci-vl)+vl0)*cl);
          qdbc = ((ql+qlo)-qlo0);
        }
        else
        {
          mv0 = sqrt(((dv0*dv0)+((4*(model_.ajc))*(model_.ajc))));
          vl0 = ((-0.5)*(dv0+mv0));
          q0 = (((-pc_t)*pow((1.0-(vl0/pc_t)),(1.0-(model_.mc))))/(1.0-(model_.mc)));
          dv = (Vbci+dv0);
          mv = sqrt(((dv*dv)+((4*(model_.ajc))*(model_.ajc))));
          vl = ((0.5*(dv-mv))-dv0);
          qlo = (((-pc_t)*pow((1.0-(vl/pc_t)),(1.0-(model_.mc))))/(1.0-(model_.mc)));
          qdbc = ((qlo+(pow((1.0-(model_.fc)),(-(model_.mc)))*((Vbci-vl)+vl0)))-q0);
        }
      }
    }
    // End block qdbcBlock
    afac = (1.0/(nf_t*vtv));
    if ((Vbei<maxvIfi))
    {
      expi = exp((Vbei*afac));
    }
    else
    {
      expi = (exp((maxvIfi*afac))*(1.0+((Vbei-maxvIfi)*afac)));
    }
    Ifi = (is_t*(expi-1.0));
    afac = (1.0/(nr_t*vtv));
    if ((Vbci<maxvIri))
    {
      expi = exp((Vbci*afac));
    }
    else
    {
      expi = (exp((maxvIri*afac))*(1.0+((Vbci-maxvIri)*afac)));
    }
    Iri = ((is_t*isrr_t)*(expi-1.0));
    q1z = (((1.0+(qdbe*Iver))+(qdbc*Ivef))-1.0e-4);
    q1 = ((0.5*(sqrt(((q1z*q1z)+1.0e-8))+q1z))+1.0e-4);
    q2 = ((Ifi*Iikf)+(Iri*(model_.Iikr)));
    if (((model_.qbm)<0.5))
    {
      arg = (pow(q1,(1.0/(model_.nkf)))+(4.0*q2));
      if ((arg>1.0e-8))
      {
        qb = (0.5*(q1+pow(arg,(model_.nkf))));
      }
      else
      {
        qb = (0.5*(q1+pow(1.0e-8,(model_.nkf))));
      }
    }
    else
    {
      arg = (1.0+(4.0*q2));
      if ((arg>1.0e-8))
      {
        qb = ((0.5*q1)*(1.0+pow(arg,(model_.nkf))));
      }
      else
      {
        qb = ((0.5*q1)*(1.0+pow(1.0e-8,(model_.nkf))));
      }
    }
    Itzr = (Iri/qb);
    Itzf = (Ifi/qb);
    Itxf = Vxf2;
    if (((model_.isp)>0.0))
    {
      afac = (1.0/((model_.nfp)*vtv));
      if ((Vbep<maxvIp))
      {
        expi = exp((Vbep*afac));
      }
      else
      {
        expi = (exp((maxvIp*afac))*(1.0+((Vbep-maxvIp)*afac)));
      }
      if ((Vbci<maxvIp))
      {
        expx = exp((Vbci*afac));
      }
      else
      {
        expx = (exp((maxvIp*afac))*(1.0+((Vbci-maxvIp)*afac)));
      }
      Ifp = (isp_t*((((model_.wsp)*expi)+((1.0-(model_.wsp))*expx))-1.0));
      q2p = (Ifp*(model_.Iikp));
      arg = (1.0+(4.0*q2p));
      if ((arg>1.0e-8))
      {
        qbp = (0.5*(1.0+sqrt(arg)));
      }
      else
      {
        qbp = (0.5*(1.0+sqrt(static_cast<double>(1.0e-8))));
      }
      if ((Vbcp<maxvIp))
      {
        expi = exp((Vbcp*afac));
      }
      else
      {
        expi = (exp((maxvIp*afac))*(1.0+((Vbcp-maxvIp)*afac)));
      }
      Irp = (isp_t*(expi-1.0));
      Iccp = ((Ifp-Irp)/qbp);
    }
    else
    {
      Ifp = 0.0;
      qbp = 1.0;
      Iccp = 0.0;
    }
    if (((model_.wbe)==1.0))
    {
      afac = (1.0/((model_.nei)*vtv));
      if ((Vbei<maxvIbei))
      {
        expi = exp((Vbei*afac));
      }
      else
      {
        expi = (exp((maxvIbei*afac))*(1.0+((Vbei-maxvIbei)*afac)));
      }
      afac = (1.0/((model_.nen)*vtv));
      if ((Vbei<maxvIben))
      {
        expn = exp((Vbei*afac));
      }
      else
      {
        expn = (exp((maxvIben*afac))*(1.0+((Vbei-maxvIben)*afac)));
      }
      if (((model_.qnibeir)>0.0))
      {
        Ibe = (((ibei_t*(1.0+((model_.qnibeir)*(q1-1.0))))*(expi-1.0))+(iben_t*(expn-1.0)));
      }
      else
      {
        Ibe = ((ibei_t*(expi-1.0))+(iben_t*(expn-1.0)));
      }
      if (((model_.vbbe)>0.0))
      {
        Bvbe = ((-vbbe_t)-Vbei);
        afac = (1.0/(nbbe_t*vtv));
        if ((Bvbe<maxvIbbe))
        {
          expx = exp((Bvbe*afac));
        }
        else
        {
          expx = (exp((maxvIbbe*afac))*(1.0+((Bvbe-maxvIbbe)*afac)));
        }
        Ibe = (Ibe-((model_.ibbe)*(expx-ebbe_t)));
      }
      Ibex = 0.0;
    }
    else
    {
      if (((model_.wbe)==0.0))
      {
        Ibe = 0.0;
        afac = (1.0/((model_.nei)*vtv));
        if ((Vbex<maxvIbei))
        {
          expi = exp((Vbex*afac));
        }
        else
        {
          expi = (exp((maxvIbei*afac))*(1.0+((Vbex-maxvIbei)*afac)));
        }
        afac = (1.0/((model_.nen)*vtv));
        if ((Vbex<maxvIben))
        {
          expn = exp((Vbex*afac));
        }
        else
        {
          expn = (exp((maxvIben*afac))*(1.0+((Vbex-maxvIben)*afac)));
        }
        Ibex = ((ibei_t*(expi-1.0))+(iben_t*(expn-1.0)));
        if (((model_.vbbe)>0.0))
        {
          Bvbe = ((-vbbe_t)-Vbei);
          afac = (1.0/(nbbe_t*vtv));
          if ((Bvbe<maxvIbbe))
          {
            expx = exp((Bvbe*afac));
          }
          else
          {
            expx = (exp((maxvIbbe*afac))*(1.0+((Bvbe-maxvIbbe)*afac)));
          }
          Ibex = (Ibex-((model_.ibbe)*(expx-ebbe_t)));
        }
      }
      else
      {
        afac = (1.0/((model_.nei)*vtv));
        if ((Vbei<maxvIbei))
        {
          expi = exp((Vbei*afac));
        }
        else
        {
          expi = (exp((maxvIbei*afac))*(1.0+((Vbei-maxvIbei)*afac)));
        }
        afac = (1.0/((model_.nen)*vtv));
        if ((Vbei<maxvIben))
        {
          expn = exp((Vbei*afac));
        }
        else
        {
          expn = (exp((maxvIben*afac))*(1.0+((Vbei-maxvIben)*afac)));
        }
        if (((model_.qnibeir)>0.0))
        {
          Ibe = ((model_.wbe)*(((ibei_t*(1.0+((model_.qnibeir)*(q1-1.0))))*(expi-1.0))+(iben_t*(expn-1.0))));
        }
        else
        {
          Ibe = ((model_.wbe)*((ibei_t*(expi-1.0))+(iben_t*(expn-1.0))));
        }
        if (((model_.vbbe)>0.0))
        {
          Bvbe = ((-vbbe_t)-Vbei);
          afac = (1.0/(nbbe_t*vtv));
          if ((Bvbe<maxvIbbe))
          {
            expx = exp((Bvbe*afac));
          }
          else
          {
            expx = (exp((maxvIbbe*afac))*(1.0+((Bvbe-maxvIbbe)*afac)));
          }
          Ibe = (Ibe-(((model_.wbe)*(model_.ibbe))*(expx-ebbe_t)));
        }
        afac = (1.0/((model_.nei)*vtv));
        if ((Vbex<maxvIbei))
        {
          expi = exp((Vbex*afac));
        }
        else
        {
          expi = (exp((maxvIbei*afac))*(1.0+((Vbex-maxvIbei)*afac)));
        }
        afac = (1.0/((model_.nen)*vtv));
        if ((Vbex<maxvIben))
        {
          expn = exp((Vbex*afac));
        }
        else
        {
          expn = (exp((maxvIben*afac))*(1.0+((Vbex-maxvIben)*afac)));
        }
        Ibex = ((1.0-(model_.wbe))*((ibei_t*(expi-1.0))+(iben_t*(expn-1.0))));
        if (((model_.vbbe)>0.0))
        {
          Bvbe = ((-vbbe_t)-Vbei);
          afac = (1.0/(nbbe_t*vtv));
          if ((Bvbe<maxvIbbe))
          {
            expx = exp((Bvbe*afac));
          }
          else
          {
            expx = (exp((maxvIbbe*afac))*(1.0+((Bvbe-maxvIbbe)*afac)));
          }
          Ibex = (Ibex-(((1.0-(model_.wbe))*(model_.ibbe))*(expx-ebbe_t)));
        }
      }
    }
    afac = (1.0/((model_.nci)*vtv));
    if ((Vbci<maxvIbci))
    {
      expi = exp((Vbci*afac));
    }
    else
    {
      expi = (exp((maxvIbci*afac))*(1.0+((Vbci-maxvIbci)*afac)));
    }
    afac = (1.0/((model_.ncn)*vtv));
    if ((Vbci<maxvIbcn))
    {
      expn = exp((Vbci*afac));
    }
    else
    {
      expn = (exp((maxvIbcn*afac))*(1.0+((Vbci-maxvIbcn)*afac)));
    }
    Ibcj = ((ibci_t*(expi-1.0))+(ibcn_t*(expn-1.0)));
    if ((((model_.ibeip)>0.0)||((model_.ibenp)>0.0)))
    {
      afac = (1.0/((model_.nci)*vtv));
      if ((Vbep<maxvIbeip))
      {
        expi = exp((Vbep*afac));
      }
      else
      {
        expi = (exp((maxvIbeip*afac))*(1.0+((Vbep-maxvIbeip)*afac)));
      }
      afac = (1.0/((model_.ncn)*vtv));
      if ((Vbep<maxvIbenp))
      {
        expn = exp((Vbep*afac));
      }
      else
      {
        expn = (exp((maxvIbenp*afac))*(1.0+((Vbep-maxvIbenp)*afac)));
      }
      Ibep = ((ibeip_t*(expi-1.0))+(ibenp_t*(expn-1.0)));
    }
    else
    {
      Ibep = 0.0;
    }
    arg = (Vbci/vtv);
    if ((arg<(model_.VmaxExp)))
    {
      expi = exp(arg);
    }
    else
    {
      expi = (exp((model_.VmaxExp))*(1.0+(arg-(model_.VmaxExp))));
    }
    arg = (Vbcx/vtv);
    if ((arg<(model_.VmaxExp)))
    {
      expx = exp(arg);
    }
    else
    {
      expx = (exp((model_.VmaxExp))*(1.0+(arg-(model_.VmaxExp))));
    }
    Kbci = sqrt((1.0+(gamm_t*expi)));
    Kbcx = sqrt((1.0+(gamm_t*expx)));
    Ircx = (Vrcx*Gcx);
    rKp1 = ((Kbci+1.0)/(Kbcx+1.0));
    Iohm = ((Vrci+(vtv*((Kbci-Kbcx)-log(rKp1))))*Gci);
    derf = ((Ivo*Iohm)/(Gci*(1.0+(((0.5*Ivo)*(model_.Ihrcf))*sqrt(((Vrci*Vrci)+0.01))))));
    Irci = (Iohm/sqrt((1+(derf*derf))));
    Irbx = (Vrbx*Gbx);
    Irbi = ((Vrbi*qb)*Gbi);
    Ire = (Vre*Ge);
    Irbp = ((Vrbp*qbp)*Gbp);
    Irs = (Vrs*Gs);
    if (((model_.avc1)>0.0))
    {
      //Begin block igcBlock
      {
        //Block-local variables for block igcBlock
        AdmsFadType vminm;
        AdmsFadType vl;
        AdmsFadType mac1;
        AdmsFadType expi;
        double expl;
        //End of Block-local variables
        vminm = pow((0.02*(avc2_t+1.0)),(1.0/(1.01-(model_.mc))));
        vl = ((0.5*(sqrt(((((pc_t-Vbci)-vminm)*((pc_t-Vbci)-vminm))+0.01))+((pc_t-Vbci)-vminm)))+vminm);
        mac1 = ((-avc2_t)*pow(vl,((model_.mc)-1.0)));
        if ((mac1<(model_.VmaxExp)))
        {
          expi = exp(mac1);
        }
        else
        {
          expl = exp((model_.VmaxExp));
          expi = (expl*(1.0+(mac1-(model_.VmaxExp))));
        }
        avalf = (((model_.avc1)*vl)*expi);
      }
      // End block igcBlock
      Igc = (((Itxf-Itzr)-Ibcj)*avalf);
    }
    else
    {
      Igc = 0.0;
    }
    if (((model_.avcx1)>0.0))
    {
      //Begin block igcxBlock
      {
        //Block-local variables for block igcxBlock
        AdmsFadType vminm;
        AdmsFadType vl;
        AdmsFadType mac1;
        AdmsFadType expi;
        double expl;
        //End of Block-local variables
        vminm = pow((0.02*(avcx2_t+1.0)),(1.0/(1.01-(model_.mcx))));
        vl = ((0.5*(sqrt(((((-Vbxcx)-vminm)*((-Vbxcx)-vminm))+0.01))+((-Vbxcx)-vminm)))+vminm);
        mac1 = ((-avcx2_t)*pow(vl,((model_.mcx)-1.0)));
        if ((mac1<(model_.VmaxExp)))
        {
          expi = exp(mac1);
        }
        else
        {
          expl = exp((model_.VmaxExp));
          expi = (expl*(1.0+(mac1-(model_.VmaxExp))));
        }
        avalf = (((model_.avcx1)*vl)*expi);
      }
      // End block igcxBlock
      Igcx = ((-Ircx)*avalf);
    }
    else
    {
      Igcx = 0.0;
    }
    if ((((model_.bbk)>0.0)&&((model_.ibk0)>0.0)))
    {
      if (((model_.vpte)>0.0))
      {
        VcbFac = ((1.0-(Vbci/(model_.vpte)))-0.1);
        VcbFac = (0.1+(0.5*(VcbFac+sqrt(((VcbFac*VcbFac)+1.0e-4)))));
        Iibk = ((model_.ibk0)*VcbFac);
      }
      else
      {
        Iibk = (model_.ibk0);
      }
      Ibk = ((model_.bbk)*pow(((Itzf/Iibk)-1.0),(model_.abk)));
    }
    else
    {
      Ibk = 0.0;
    }
    Ibc = ((Ibcj-Igc)-Ibk);
    if ((((model_.ibcip)>0.0)||((model_.ibcnp)>0.0)))
    {
      afac = (1.0/((model_.ncip)*vtv));
      if ((Vbcp<maxvIbcip))
      {
        expi = exp((Vbcp*afac));
      }
      else
      {
        expi = (exp((maxvIbcip*afac))*(1.0+((Vbcp-maxvIbcip)*afac)));
      }
      afac = (1.0/((model_.ncnp)*vtv));
      if ((Vbcp<maxvIbcnp))
      {
        expn = exp((Vbcp*afac));
      }
      else
      {
        expn = (exp((maxvIbcnp*afac))*(1.0+((Vbcp-maxvIbcnp)*afac)));
      }
      Ibcp = ((ibcip_t*(expi-1.0))+(ibcnp_t*(expn-1.0)));
    }
    else
    {
      Ibcp = 0.0;
    }
    power = ((((((((((((((Ibe*Vbei)+(Ibc*Vbci))+((Itxf-Itzr)*Vcei))+(Ibex*Vbex))+(Ibep*Vbep))+(Irs*Vrs))+(Ibcp*Vbcp))+(Iccp*Vcep))+(Ircx*Vrcx))+(Irci*Vrci))+(Irbx*Vrbx))+(Irbi*Vrbi))+(Ire*Vre))+(Irbp*Vrbp));
    Ith = ((-sw_et)*power);
    Irth = (dt_et*Gth);
    Ixf1 = (Vxf2-Itzf);
    Ixf2 = (Vxf2-Vxf1);
    Ibe = (Ibe+((model_.gminMod)*Vbei));
    Ibex = (Ibex+((model_.gminMod)*Vbex));
    Ibep = (Ibep+((model_.gminMod)*Vbep));
    Ibc = (Ibc+((model_.gminMod)*Vbci));
    Igcx = (Igcx+((model_.gminMod)*Vbxcx));
    Ibcp = (Ibcp+((model_.gminMod)*Vbcp));
    Ibe = (((model_.VBICtype)*mMod)*Ibe);
    Ibex = (((model_.VBICtype)*mMod)*Ibex);
    Itzf = (((model_.VBICtype)*mMod)*Itzf);
    Itxf = (((model_.VBICtype)*mMod)*Itxf);
    Itzr = (((model_.VBICtype)*mMod)*Itzr);
    Ibc = (((model_.VBICtype)*mMod)*Ibc);
    Igcx = (((model_.VBICtype)*mMod)*Igcx);
    Ibep = (((model_.VBICtype)*mMod)*Ibep);
    Ircx = (mMod*Ircx);
    Irci = (((model_.VBICtype)*mMod)*Irci);
    Irbx = (mMod*Irbx);
    Irbi = (mMod*Irbi);
    Ire = (mMod*Ire);
    Irbp = (mMod*Irbp);
    Ibcp = (((model_.VBICtype)*mMod)*Ibcp);
    Iccp = (((model_.VBICtype)*mMod)*Iccp);
    Irs = (mMod*Irs);
    Ith = (mMod*Ith);
    Irth = (mMod*Irth);
  }
  // End block evaluateStatic
  //Begin block evaluateDynamic
  {
    if (((model_.cjcp)>0.0))
    {
      //Begin block qdbcpBlock
      {
        //Block-local variables for block qdbcpBlock
        AdmsFadType dv0;
        AdmsFadType dvh;
        double pwq;
        AdmsFadType qlo;
        AdmsFadType qhi;
        AdmsFadType mv0;
        AdmsFadType vl0;
        AdmsFadType q0;
        AdmsFadType dv;
        AdmsFadType mv;
        AdmsFadType vl;
        //End of Block-local variables
        dv0 = ((-ps_t)*(model_.fc));
        if (((model_.ajs)<=0.0))
        {
          dvh = (Vbcp+dv0);
          if ((dvh>0.0))
          {
            pwq = pow((1.0-(model_.fc)),(-(model_.ms)));
            qlo = ((ps_t*(1.0-(pwq*(1.0-(model_.fc)))))/(1.0-(model_.ms)));
            qhi = ((dvh*(1.0+(((0.5*(model_.ms))*dvh)/(ps_t*(1.0-(model_.fc))))))*pwq);
          }
          else
          {
            qlo = ((ps_t*(1.0-pow((1.0-(Vbcp/ps_t)),(1.0-(model_.ms)))))/(1.0-(model_.ms)));
            qhi = 0.0;
          }
          qdbcp = (qlo+qhi);
        }
        else
        {
          mv0 = sqrt(((dv0*dv0)+((4.0*(model_.ajs))*(model_.ajs))));
          vl0 = ((-0.5)*(dv0+mv0));
          q0 = (((-ps_t)*pow((1.0-(vl0/ps_t)),(1.0-(model_.ms))))/(1.0-(model_.ms)));
          dv = (Vbcp+dv0);
          mv = sqrt(((dv*dv)+((4.0*(model_.ajs))*(model_.ajs))));
          vl = ((0.5*(dv-mv))-dv0);
          qlo = (((-ps_t)*pow((1.0-(vl/ps_t)),(1.0-(model_.ms))))/(1.0-(model_.ms)));
          qdbcp = ((qlo+((pow((1.0-(model_.fc)),(-(model_.ms)))*((Vbcp-vl)+vl0))*(1.0+(((0.5*(model_.ms))*((Vbcp-vl)+vl0))/(ps_t*(1.0-(model_.fc)))))))-q0);
        }
      }
      // End block qdbcpBlock
    }
    else
    {
      qdbcp = 0.0;
    }
    //Begin block qdbexBlock
    {
      //Block-local variables for block qdbexBlock
      AdmsFadType dv0;
      AdmsFadType dvh;
      double pwq;
      AdmsFadType qlo;
      AdmsFadType qhi;
      AdmsFadType mv0;
      AdmsFadType vl0;
      AdmsFadType q0;
      AdmsFadType dv;
      AdmsFadType mv;
      AdmsFadType vl;
      //End of Block-local variables
      dv0 = ((-pe_t)*(model_.fc));
      if (((model_.aje)<=0.0))
      {
        dvh = (Vbex+dv0);
        if ((dvh>0.0))
        {
          pwq = pow((1.0-(model_.fc)),(-(model_.me)));
          qlo = ((pe_t*(1.0-(pwq*(1.0-(model_.fc)))))/(1.0-(model_.me)));
          qhi = ((dvh*(1.0+(((0.5*(model_.me))*dvh)/(pe_t*(1.0-(model_.fc))))))*pwq);
        }
        else
        {
          qlo = ((pe_t*(1.0-pow((1.0-(Vbex/pe_t)),(1.0-(model_.me)))))/(1.0-(model_.me)));
          qhi = 0.0;
        }
        qdbex = (qlo+qhi);
      }
      else
      {
        mv0 = sqrt(((dv0*dv0)+((4.0*(model_.aje))*(model_.aje))));
        vl0 = ((-0.5)*(dv0+mv0));
        q0 = (((-pe_t)*pow((1.0-(vl0/pe_t)),(1.0-(model_.me))))/(1.0-(model_.me)));
        dv = (Vbex+dv0);
        mv = sqrt(((dv*dv)+((4.0*(model_.aje))*(model_.aje))));
        vl = ((0.5*(dv-mv))-dv0);
        qlo = (((-pe_t)*pow((1.0-(vl/pe_t)),(1.0-(model_.me))))/(1.0-(model_.me)));
        qdbex = ((qlo+((pow((1.0-(model_.fc)),(-(model_.me)))*((Vbex-vl)+vl0))*(1.0+(((0.5*(model_.me))*((Vbex-vl)+vl0))/(pe_t*(1.0-(model_.fc)))))))-q0);
      }
    }
    // End block qdbexBlock
    //Begin block qdbepBlock
    {
      //Block-local variables for block qdbepBlock
      AdmsFadType dv0;
      AdmsFadType dvh;
      double pwq;
      AdmsFadType qlo;
      AdmsFadType qhi;
      AdmsFadType vn0;
      AdmsFadType vnl0;
      AdmsFadType vl0;
      AdmsFadType qlo0;
      AdmsFadType vn;
      AdmsFadType vnl;
      AdmsFadType vl;
      AdmsFadType sel;
      AdmsFadType crt;
      AdmsFadType cmx;
      AdmsFadType cl;
      AdmsFadType ql;
      AdmsFadType mv0;
      AdmsFadType q0;
      AdmsFadType dv;
      AdmsFadType mv;
      //End of Block-local variables
      dv0 = ((-pc_t)*(model_.fc));
      if (((model_.ajc)<=0.0))
      {
        dvh = (Vbep+dv0);
        if ((dvh>0.0))
        {
          pwq = pow((1.0-(model_.fc)),((-1.0)-(model_.mc)));
          qlo = ((pc_t*(1.0-((pwq*(1.0-(model_.fc)))*(1.0-(model_.fc)))))/(1.0-(model_.mc)));
          qhi = ((dvh*((1.0-(model_.fc))+(((0.5*(model_.mc))*dvh)/pc_t)))*pwq);
        }
        else
        {
          if ((((model_.vrt)>0.0)&&(Vbep<(-(model_.vrt)))))
          {
            qlo = ((pc_t*(1.0-(pow((1.0+((model_.vrt)/pc_t)),(1.0-(model_.mc)))*(1.0-(((1.0-(model_.mc))*(Vbep+(model_.vrt)))/(pc_t+(model_.vrt)))))))/(1.0-(model_.mc)));
          }
          else
          {
            qlo = ((pc_t*(1.0-pow((1.0-(Vbep/pc_t)),(1.0-(model_.mc)))))/(1.0-(model_.mc)));
          }
          qhi = 0.0;
        }
        qdbep = (qlo+qhi);
      }
      else
      {
        if ((((model_.vrt)>0.0)&&((model_.art)>0.0)))
        {
          vn0 = (((model_.vrt)+dv0)/((model_.vrt)-dv0));
          vnl0 = ((2.0*vn0)/(sqrt((((vn0-1.0)*(vn0-1))+((4*(model_.ajc))*(model_.ajc))))+sqrt((((vn0+1.0)*(vn0+1))+((4*(model_.art))*(model_.art))))));
          vl0 = (0.5*(((vnl0*((model_.vrt)-dv0))-(model_.vrt))-dv0));
          qlo0 = ((pc_t*(1.0-pow((1.0-(vl0/pc_t)),(1.0-(model_.mc)))))/(1.0-(model_.mc)));
          vn = ((((2*Vbep)+(model_.vrt))+dv0)/((model_.vrt)-dv0));
          vnl = ((2.0*vn)/(sqrt((((vn-1.0)*(vn-1))+((4*(model_.ajc))*(model_.ajc))))+sqrt((((vn+1.0)*(vn+1))+((4*(model_.art))*(model_.art))))));
          vl = (0.5*(((vnl*((model_.vrt)-dv0))-(model_.vrt))-dv0));
          qlo = ((pc_t*(1.0-pow((1.0-(vl/pc_t)),(1.0-(model_.mc)))))/(1.0-(model_.mc)));
          sel = (0.5*(vnl+1.0));
          crt = pow((1.0+((model_.vrt)/pc_t)),(-(model_.mc)));
          cmx = pow((1.0+(dv0/pc_t)),(-(model_.mc)));
          cl = (((1.0-sel)*crt)+(sel*cmx));
          ql = (((Vbep-vl)+vl0)*cl);
          qdbep = ((ql+qlo)-qlo0);
        }
        else
        {
          mv0 = sqrt(((dv0*dv0)+((4*(model_.ajc))*(model_.ajc))));
          vl0 = ((-0.5)*(dv0+mv0));
          q0 = (((-pc_t)*pow((1.0-(vl0/pc_t)),(1.0-(model_.mc))))/(1.0-(model_.mc)));
          dv = (Vbep+dv0);
          mv = sqrt(((dv*dv)+((4*(model_.ajc))*(model_.ajc))));
          vl = ((0.5*(dv-mv))-dv0);
          qlo = (((-pc_t)*pow((1.0-(vl/pc_t)),(1.0-(model_.mc))))/(1.0-(model_.mc)));
          qdbep = ((qlo+(pow((1.0-(model_.fc)),(-(model_.mc)))*((Vbep-vl)+vl0)))-q0);
        }
      }
    }
    // End block qdbepBlock
    sgIf = ((Ifi>0.0)?1.0:0.0);
    rIf = ((Ifi*sgIf)*(model_.Iitf));
    mIf = (rIf/(rIf+1.0));
    arg = ((Vbci*(model_.Ivtf))/1.44);
    if ((arg<(model_.VmaxExp)))
    {
      expi = exp(arg);
    }
    else
    {
      expi = (exp((model_.VmaxExp))*(1.0+(arg-(model_.VmaxExp))));
    }
    tff = (((model_.tf)*(1.0+((model_.qtf)*q1)))*(1.0+((((model_.xtf)*expi)*((model_.sltf)+(mIf*mIf)))*sgIf)));
    Qbe = (((cje_t*qdbe)*(model_.wbe))+((tff*Ifi)/qb));
    Qbex = ((cje_t*qdbex)*(1.0-(model_.wbe)));
    Qbc = (((cjc_t*qdbc)+((model_.tr)*Iri))+((model_.qco)*Kbci));
    Qbcx = ((model_.qco)*Kbcx);
    Qbep = ((cjep_t*qdbep)+((model_.tr)*Ifp));
    Qbcp = ((cjcp_t*qdbcp)+((model_.ccso)*Vbcp));
    Qbeo = (Vbe*(model_.cbeo));
    Qbco = (Vbc*(model_.cbco));
    Qcth = (dt_et*(model_.cth));
    Qxf1 = ((model_.td)*Vxf1);
    Qxf2 = (((model_.td)*Vxf2)*0.3333333333333333);
    Qbe = (((model_.VBICtype)*mMod)*Qbe);
    Qbex = (((model_.VBICtype)*mMod)*Qbex);
    Qbc = (((model_.VBICtype)*mMod)*Qbc);
    Qbcx = (((model_.VBICtype)*mMod)*Qbcx);
    Qbep = (((model_.VBICtype)*mMod)*Qbep);
    Qbeo = (mMod*Qbeo);
    Qbco = (mMod*Qbco);
    Qbcp = (((model_.VBICtype)*mMod)*Qbcp);
    Qcth = (mMod*Qcth);
  }
  // End block evaluateDynamic
  //Begin block loadStatic
  {
    // I(bi,ei) <+ (Ibe)
    {
      AdmsFadType contribTemp;
      contribTemp= Ibe;
      staticContributions[admsNodeID_bi] += contribTemp;
      staticContributions[admsNodeID_ei] -= contribTemp;

      Jdxp_static[admsNodeID_bi] += contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp)+contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND)+contribTemp.dx(admsProbeID_V_bx_ei)*probeDiffs[admsProbeID_V_bx_ei]*probeVars[admsProbeID_V_bx_ei].dx(admsProbeID_V_bx_ei);
      Jdxp_static[admsNodeID_ei] -= contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp)+contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND)+contribTemp.dx(admsProbeID_V_bx_ei)*probeDiffs[admsProbeID_V_bx_ei]*probeVars[admsProbeID_V_bx_ei].dx(admsProbeID_V_bx_ei);
    }
    // I(bx,ei) <+ (Ibex)
    {
      AdmsFadType contribTemp;
      contribTemp= Ibex;
      staticContributions[admsNodeID_bx] += contribTemp;
      staticContributions[admsNodeID_ei] -= contribTemp;

      Jdxp_static[admsNodeID_bx] += contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp)+contribTemp.dx(admsProbeID_V_bx_ei)*probeDiffs[admsProbeID_V_bx_ei]*probeVars[admsProbeID_V_bx_ei].dx(admsProbeID_V_bx_ei)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
      Jdxp_static[admsNodeID_ei] -= contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp)+contribTemp.dx(admsProbeID_V_bx_ei)*probeDiffs[admsProbeID_V_bx_ei]*probeVars[admsProbeID_V_bx_ei].dx(admsProbeID_V_bx_ei)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
    }
    // I(ci,ei) <+ (Itxf)
    staticContributions[admsNodeID_ci] += Itxf;
    staticContributions[admsNodeID_ei] -= Itxf;
    // I(ei,ci) <+ (Itzr)
    {
      AdmsFadType contribTemp;
      contribTemp= Itzr;
      staticContributions[admsNodeID_ei] += contribTemp;
      staticContributions[admsNodeID_ci] -= contribTemp;

      Jdxp_static[admsNodeID_ei] += contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
      Jdxp_static[admsNodeID_ci] -= contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
    }
    // I(bi,ci) <+ (Ibc)
    {
      AdmsFadType contribTemp;
      contribTemp= Ibc;
      staticContributions[admsNodeID_bi] += contribTemp;
      staticContributions[admsNodeID_ci] -= contribTemp;

      Jdxp_static[admsNodeID_bi] += contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp)+contribTemp.dx(admsProbeID_V_bx_ei)*probeDiffs[admsProbeID_V_bx_ei]*probeVars[admsProbeID_V_bx_ei].dx(admsProbeID_V_bx_ei)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
      Jdxp_static[admsNodeID_ci] -= contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp)+contribTemp.dx(admsProbeID_V_bx_ei)*probeDiffs[admsProbeID_V_bx_ei]*probeVars[admsProbeID_V_bx_ei].dx(admsProbeID_V_bx_ei)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
    }
    // I(bx,cx) <+ (Igcx)
    {
      AdmsFadType contribTemp;
      contribTemp= Igcx;
      staticContributions[admsNodeID_bx] += contribTemp;
      staticContributions[admsNodeID_cx] -= contribTemp;

      Jdxp_static[admsNodeID_bx] += contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bx_cx)*probeDiffs[admsProbeID_V_bx_cx]*probeVars[admsProbeID_V_bx_cx].dx(admsProbeID_V_bx_cx)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
      Jdxp_static[admsNodeID_cx] -= contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bx_cx)*probeDiffs[admsProbeID_V_bx_cx]*probeVars[admsProbeID_V_bx_cx].dx(admsProbeID_V_bx_cx)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
    }
    // I(bx,bp) <+ (Ibep)
    {
      AdmsFadType contribTemp;
      contribTemp= Ibep;
      staticContributions[admsNodeID_bx] += contribTemp;
      staticContributions[admsNodeID_bp] -= contribTemp;

      Jdxp_static[admsNodeID_bx] += contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp)+contribTemp.dx(admsProbeID_V_bx_ei)*probeDiffs[admsProbeID_V_bx_ei]*probeVars[admsProbeID_V_bx_ei].dx(admsProbeID_V_bx_ei)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
      Jdxp_static[admsNodeID_bp] -= contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp)+contribTemp.dx(admsProbeID_V_bx_ei)*probeDiffs[admsProbeID_V_bx_ei]*probeVars[admsProbeID_V_bx_ei].dx(admsProbeID_V_bx_ei)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
    }
    // I(c,cx) <+ (Ircx)
    {
      AdmsFadType contribTemp;
      contribTemp= Ircx;
      staticContributions[admsNodeID_c] += contribTemp;
      staticContributions[admsNodeID_cx] -= contribTemp;

      Jdxp_static[admsNodeID_c] += contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
      Jdxp_static[admsNodeID_cx] -= contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
    }
    // I(cx,ci) <+ (Irci)
    {
      AdmsFadType contribTemp;
      contribTemp= Irci;
      staticContributions[admsNodeID_cx] += contribTemp;
      staticContributions[admsNodeID_ci] -= contribTemp;

      Jdxp_static[admsNodeID_cx] += contribTemp.dx(admsProbeID_V_bi_cx)*probeDiffs[admsProbeID_V_bi_cx]*probeVars[admsProbeID_V_bi_cx].dx(admsProbeID_V_bi_cx)+contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp)+contribTemp.dx(admsProbeID_V_bx_ei)*probeDiffs[admsProbeID_V_bx_ei]*probeVars[admsProbeID_V_bx_ei].dx(admsProbeID_V_bx_ei)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
      Jdxp_static[admsNodeID_ci] -= contribTemp.dx(admsProbeID_V_bi_cx)*probeDiffs[admsProbeID_V_bi_cx]*probeVars[admsProbeID_V_bi_cx].dx(admsProbeID_V_bi_cx)+contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp)+contribTemp.dx(admsProbeID_V_bx_ei)*probeDiffs[admsProbeID_V_bx_ei]*probeVars[admsProbeID_V_bx_ei].dx(admsProbeID_V_bx_ei)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
    }
    // I(b,bx) <+ (Irbx)
    {
      AdmsFadType contribTemp;
      contribTemp= Irbx;
      staticContributions[admsNodeID_b] += contribTemp;
      staticContributions[admsNodeID_bx] -= contribTemp;

      Jdxp_static[admsNodeID_b] += contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
      Jdxp_static[admsNodeID_bx] -= contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
    }
    // I(bx,bi) <+ (Irbi)
    {
      AdmsFadType contribTemp;
      contribTemp= Irbi;
      staticContributions[admsNodeID_bx] += contribTemp;
      staticContributions[admsNodeID_bi] -= contribTemp;

      Jdxp_static[admsNodeID_bx] += contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND)+contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei);
      Jdxp_static[admsNodeID_bi] -= contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND)+contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei);
    }
    // I(e,ei) <+ (Ire)
    {
      AdmsFadType contribTemp;
      contribTemp= Ire;
      staticContributions[admsNodeID_e] += contribTemp;
      staticContributions[admsNodeID_ei] -= contribTemp;

      Jdxp_static[admsNodeID_e] += contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
      Jdxp_static[admsNodeID_ei] -= contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
    }
    // I(bp,cx) <+ (Irbp)
    {
      AdmsFadType contribTemp;
      contribTemp= Irbp;
      staticContributions[admsNodeID_bp] += contribTemp;
      staticContributions[admsNodeID_cx] -= contribTemp;

      Jdxp_static[admsNodeID_bp] += contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND)+contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp);
      Jdxp_static[admsNodeID_cx] -= contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND)+contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp);
    }
    // I(si,bp) <+ (Ibcp)
    {
      AdmsFadType contribTemp;
      contribTemp= Ibcp;
      staticContributions[admsNodeID_si] += contribTemp;
      staticContributions[admsNodeID_bp] -= contribTemp;

      Jdxp_static[admsNodeID_si] += contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp)+contribTemp.dx(admsProbeID_V_bx_ei)*probeDiffs[admsProbeID_V_bx_ei]*probeVars[admsProbeID_V_bx_ei].dx(admsProbeID_V_bx_ei)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
      Jdxp_static[admsNodeID_bp] -= contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp)+contribTemp.dx(admsProbeID_V_bx_ei)*probeDiffs[admsProbeID_V_bx_ei]*probeVars[admsProbeID_V_bx_ei].dx(admsProbeID_V_bx_ei)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
    }
    // I(bx,si) <+ (Iccp)
    {
      AdmsFadType contribTemp;
      contribTemp= Iccp;
      staticContributions[admsNodeID_bx] += contribTemp;
      staticContributions[admsNodeID_si] -= contribTemp;

      Jdxp_static[admsNodeID_bx] += contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
      Jdxp_static[admsNodeID_si] -= contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
    }
    // I(s,si) <+ (Irs)
    {
      AdmsFadType contribTemp;
      contribTemp= Irs;
      staticContributions[admsNodeID_s] += contribTemp;
      staticContributions[admsNodeID_si] -= contribTemp;

      Jdxp_static[admsNodeID_s] += contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
      Jdxp_static[admsNodeID_si] -= contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
    }
    // I(xf1,GND) <+ (Ixf1)
    {
      AdmsFadType contribTemp;
      contribTemp= Ixf1;
      staticContributions[admsNodeID_xf1] += contribTemp;

      Jdxp_static[admsNodeID_xf1] += contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
    }
    // I(xf2,GND) <+ (Ixf2)
    staticContributions[admsNodeID_xf2] += Ixf2;
    // Pwr(dt,GND) <+ (Irth)
    {
      AdmsFadType contribTemp;
      contribTemp= Irth;
      staticContributions[admsNodeID_dt] += contribTemp;

      Jdxp_static[admsNodeID_dt] += contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
    }
    // Pwr(dt,GND) <+ (Ith)
    {
      AdmsFadType contribTemp;
      contribTemp= Ith;
      staticContributions[admsNodeID_dt] += contribTemp;

      Jdxp_static[admsNodeID_dt] += contribTemp.dx(admsProbeID_V_bi_cx)*probeDiffs[admsProbeID_V_bi_cx]*probeVars[admsProbeID_V_bi_cx].dx(admsProbeID_V_bi_cx)+contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp)+contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND)+contribTemp.dx(admsProbeID_V_bx_ei)*probeDiffs[admsProbeID_V_bx_ei]*probeVars[admsProbeID_V_bx_ei].dx(admsProbeID_V_bx_ei);
    }
  }
  // End block loadStatic
  //Begin block loadDynamic
  {
    // I(bi,ei) <+ (ddt(Qbe))
    {
      AdmsFadType contribTemp;
      contribTemp= (Qbe);
      dynamicContributions[admsNodeID_bi] += contribTemp;
      dynamicContributions[admsNodeID_ei] -= contribTemp;

      Jdxp_dynamic[admsNodeID_bi] += contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp)+contribTemp.dx(admsProbeID_V_bx_ei)*probeDiffs[admsProbeID_V_bx_ei]*probeVars[admsProbeID_V_bx_ei].dx(admsProbeID_V_bx_ei)+contribTemp.dx(admsProbeID_V_bi_cx)*probeDiffs[admsProbeID_V_bi_cx]*probeVars[admsProbeID_V_bi_cx].dx(admsProbeID_V_bi_cx)+contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
      Jdxp_dynamic[admsNodeID_ei] -= contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp)+contribTemp.dx(admsProbeID_V_bx_ei)*probeDiffs[admsProbeID_V_bx_ei]*probeVars[admsProbeID_V_bx_ei].dx(admsProbeID_V_bx_ei)+contribTemp.dx(admsProbeID_V_bi_cx)*probeDiffs[admsProbeID_V_bi_cx]*probeVars[admsProbeID_V_bi_cx].dx(admsProbeID_V_bi_cx)+contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
    }
    // I(bx,ei) <+ (ddt(Qbex))
    {
      AdmsFadType contribTemp;
      contribTemp= (Qbex);
      dynamicContributions[admsNodeID_bx] += contribTemp;
      dynamicContributions[admsNodeID_ei] -= contribTemp;

      Jdxp_dynamic[admsNodeID_bx] += contribTemp.dx(admsProbeID_V_bx_ei)*probeDiffs[admsProbeID_V_bx_ei]*probeVars[admsProbeID_V_bx_ei].dx(admsProbeID_V_bx_ei)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
      Jdxp_dynamic[admsNodeID_ei] -= contribTemp.dx(admsProbeID_V_bx_ei)*probeDiffs[admsProbeID_V_bx_ei]*probeVars[admsProbeID_V_bx_ei].dx(admsProbeID_V_bx_ei)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
    }
    // I(bi,ci) <+ (ddt(Qbc))
    {
      AdmsFadType contribTemp;
      contribTemp= (Qbc);
      dynamicContributions[admsNodeID_bi] += contribTemp;
      dynamicContributions[admsNodeID_ci] -= contribTemp;

      Jdxp_dynamic[admsNodeID_bi] += contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp)+contribTemp.dx(admsProbeID_V_bx_ei)*probeDiffs[admsProbeID_V_bx_ei]*probeVars[admsProbeID_V_bx_ei].dx(admsProbeID_V_bx_ei)+contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
      Jdxp_dynamic[admsNodeID_ci] -= contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp)+contribTemp.dx(admsProbeID_V_bx_ei)*probeDiffs[admsProbeID_V_bx_ei]*probeVars[admsProbeID_V_bx_ei].dx(admsProbeID_V_bx_ei)+contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
    }
    // I(bi,cx) <+ (ddt(Qbcx))
    {
      AdmsFadType contribTemp;
      contribTemp= (Qbcx);
      dynamicContributions[admsNodeID_bi] += contribTemp;
      dynamicContributions[admsNodeID_cx] -= contribTemp;

      Jdxp_dynamic[admsNodeID_bi] += contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp)+contribTemp.dx(admsProbeID_V_bi_cx)*probeDiffs[admsProbeID_V_bi_cx]*probeVars[admsProbeID_V_bi_cx].dx(admsProbeID_V_bi_cx)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
      Jdxp_dynamic[admsNodeID_cx] -= contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp)+contribTemp.dx(admsProbeID_V_bi_cx)*probeDiffs[admsProbeID_V_bi_cx]*probeVars[admsProbeID_V_bi_cx].dx(admsProbeID_V_bi_cx)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
    }
    // I(bx,bp) <+ (ddt(Qbep))
    {
      AdmsFadType contribTemp;
      contribTemp= (Qbep);
      dynamicContributions[admsNodeID_bx] += contribTemp;
      dynamicContributions[admsNodeID_bp] -= contribTemp;

      Jdxp_dynamic[admsNodeID_bx] += contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
      Jdxp_dynamic[admsNodeID_bp] -= contribTemp.dx(admsProbeID_V_bi_ei)*probeDiffs[admsProbeID_V_bi_ei]*probeVars[admsProbeID_V_bi_ei].dx(admsProbeID_V_bi_ei)+contribTemp.dx(admsProbeID_V_bi_ci)*probeDiffs[admsProbeID_V_bi_ci]*probeVars[admsProbeID_V_bi_ci].dx(admsProbeID_V_bi_ci)+contribTemp.dx(admsProbeID_V_bx_bp)*probeDiffs[admsProbeID_V_bx_bp]*probeVars[admsProbeID_V_bx_bp].dx(admsProbeID_V_bx_bp)+contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
    }
    // I(b,e) <+ (ddt(Qbeo))
    {
      AdmsFadType contribTemp;
      contribTemp= (Qbeo);
      dynamicContributions[admsNodeID_b] += contribTemp;
      dynamicContributions[admsNodeID_e] -= contribTemp;

      Jdxp_dynamic[admsNodeID_b] += contribTemp.dx(admsProbeID_V_b_e)*probeDiffs[admsProbeID_V_b_e]*probeVars[admsProbeID_V_b_e].dx(admsProbeID_V_b_e);
      Jdxp_dynamic[admsNodeID_e] -= contribTemp.dx(admsProbeID_V_b_e)*probeDiffs[admsProbeID_V_b_e]*probeVars[admsProbeID_V_b_e].dx(admsProbeID_V_b_e);
    }
    // I(b,c) <+ (ddt(Qbco))
    dynamicContributions[admsNodeID_b] += (Qbco);
    dynamicContributions[admsNodeID_c] -= (Qbco);
    // I(si,bp) <+ (ddt(Qbcp))
    {
      AdmsFadType contribTemp;
      contribTemp= (Qbcp);
      dynamicContributions[admsNodeID_si] += contribTemp;
      dynamicContributions[admsNodeID_bp] -= contribTemp;

      Jdxp_dynamic[admsNodeID_si] += contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
      Jdxp_dynamic[admsNodeID_bp] -= contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
    }
    // I(xf1,GND) <+ (ddt(Qxf1))
    dynamicContributions[admsNodeID_xf1] += (Qxf1);
    // I(xf2,GND) <+ (ddt(Qxf2))
    dynamicContributions[admsNodeID_xf2] += (Qxf2);
    // Pwr(dt,GND) <+ (ddt(Qcth))
    {
      AdmsFadType contribTemp;
      contribTemp= (Qcth);
      dynamicContributions[admsNodeID_dt] += contribTemp;

      Jdxp_dynamic[admsNodeID_dt] += contribTemp.dx(admsProbeID_Temp_dt_GND)*probeDiffs[admsProbeID_Temp_dt_GND]*probeVars[admsProbeID_Temp_dt_GND].dx(admsProbeID_Temp_dt_GND);
    }
  }
  // End block loadDynamic
  //Begin block noise
  {
    if (sw_noise)
    {
      // I(bi,ei) <+ (white_noise((((mMod*2)*1.602189e-19)*abs(Ibe)),"Ibei shot noise"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[0]= (((mMod*2)*1.602189e-19)*fabs(Ibe.val()));
      }
      // I(bi,ei) <+ (flicker_noise(((mMod*kfn)*pow(abs((Ibe/mMod)),afn)),bfn,"Ibei flicker noise"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[1]= ((mMod*(model_.kfn))*pow(fabs((Ibe.val()/mMod)),(model_.afn)));
        noiseContribsExponent[1]= (model_.bfn);
      }
      // I(bx,ei) <+ (white_noise((((mMod*2)*1.602189e-19)*abs(Ibex)),"Ibex shot noise"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[2]= (((mMod*2)*1.602189e-19)*fabs(Ibex.val()));
      }
      // I(bx,ei) <+ (flicker_noise(((mMod*kfn)*pow(abs((Ibex/mMod)),afn)),bfn,"Ibex flicker noise"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[3]= ((mMod*(model_.kfn))*pow(fabs((Ibex.val()/mMod)),(model_.afn)));
        noiseContribsExponent[3]= (model_.bfn);
      }
      // I(ci,ei) <+ (white_noise((((mMod*2)*1.602189e-19)*abs(Itzf)),"transport current shot noise"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[4]= (((mMod*2)*1.602189e-19)*fabs(Itzf.val()));
      }
      // I(bx,bp) <+ (white_noise((((mMod*2)*1.602189e-19)*abs(Ibep)),"Ibep shot noise"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[5]= (((mMod*2)*1.602189e-19)*fabs(Ibep.val()));
      }
      // I(bx,bp) <+ (flicker_noise((((mMod*mMod)*kfn)*pow(abs((Ibep/mMod)),afn)),bfn,"Ibep flicker noise"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[6]= (((mMod*mMod)*(model_.kfn))*pow(fabs((Ibep.val()/mMod)),(model_.afn)));
        noiseContribsExponent[6]= (model_.bfn);
      }
      // I(c,cx) <+ (white_noise(((((mMod*4)*1.380662e-23)*tdevK)*Gcx),"rcx thermal noise"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[7]= ((((mMod*4)*1.380662e-23)*tdevK.val())*Gcx.val());
      }
      // I(cx,ci) <+ (white_noise(((((mMod*4)*1.380662e-23)*tdevK)*((abs(Irci)+(1.0e-10*Gci))/(abs(Vrci)+1.0e-10))),"rci thermal noise"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[8]= ((((mMod*4)*1.380662e-23)*tdevK.val())*((fabs(Irci.val())+(1.0e-10*Gci.val()))/(fabs(Vrci.val())+1.0e-10)));
      }
      // I(b,bx) <+ (white_noise(((((mMod*4)*1.380662e-23)*tdevK)*Gbx),"rbx thermal noise"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[9]= ((((mMod*4)*1.380662e-23)*tdevK.val())*Gbx.val());
      }
      // I(bx,bi) <+ (white_noise((((((mMod*4)*1.380662e-23)*tdevK)*qb)*Gbi),"rbi thermal noise"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[10]= (((((mMod*4)*1.380662e-23)*tdevK.val())*qb.val())*Gbi.val());
      }
      // I(e,ei) <+ (white_noise(((((mMod*4)*1.380662e-23)*tdevK)*Ge),"re thermal noise"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[11]= ((((mMod*4)*1.380662e-23)*tdevK.val())*Ge.val());
      }
      // I(bp,cx) <+ (white_noise((((((mMod*4)*1.380662e-23)*tdevK)*qbp)*Gbp),"rbp thermal noise"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[12]= (((((mMod*4)*1.380662e-23)*tdevK.val())*qbp.val())*Gbp.val());
      }
      // I(bx,si) <+ (white_noise((((mMod*2)*1.602189e-19)*abs(Iccp)),"parasitic transport current shot noise"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[13]= (((mMod*2)*1.602189e-19)*fabs(Iccp.val()));
      }
      // I(s,si) <+ (white_noise(((((mMod*4)*1.380662e-23)*tdevK)*Gs),"rs thermal noise"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[14]= ((((mMod*4)*1.380662e-23)*tdevK.val())*Gs.val());
      }
    }
  }
  // End block noise


  // -- endcode converted from analog/code block
  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << " probeVars[admsProbeID_V_xf2_GND] =  "
                 <<probeVars[admsProbeID_V_xf2_GND].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_xf1_GND] =  "
                 <<probeVars[admsProbeID_V_xf1_GND].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_s_si] =  "
                 <<probeVars[admsProbeID_V_s_si].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bx_si] =  "
                 <<probeVars[admsProbeID_V_bx_si].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_si_bp] =  "
                 <<probeVars[admsProbeID_V_si_bp].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bp_cx] =  "
                 <<probeVars[admsProbeID_V_bp_cx].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_e_ei] =  "
                 <<probeVars[admsProbeID_V_e_ei].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bx_bi] =  "
                 <<probeVars[admsProbeID_V_bx_bi].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_bx] =  "
                 <<probeVars[admsProbeID_V_b_bx].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_cx_ci] =  "
                 <<probeVars[admsProbeID_V_cx_ci].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_c_cx] =  "
                 <<probeVars[admsProbeID_V_c_cx].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_c] =  "
                 <<probeVars[admsProbeID_V_b_c].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_e] =  "
                 <<probeVars[admsProbeID_V_b_e].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bx_bp] =  "
                 <<probeVars[admsProbeID_V_bx_bp].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_ci_ei] =  "
                 <<probeVars[admsProbeID_V_ci_ei].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bx_cx] =  "
                 <<probeVars[admsProbeID_V_bx_cx].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bi_cx] =  "
                 <<probeVars[admsProbeID_V_bi_cx].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bi_ci] =  "
                 <<probeVars[admsProbeID_V_bi_ci].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bx_ei] =  "
                 <<probeVars[admsProbeID_V_bx_ei].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bi_ei] =  "
                 <<probeVars[admsProbeID_V_bi_ei].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_Temp_dt_GND] =  "
                 <<probeVars[admsProbeID_Temp_dt_GND].val() << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_c] =  "
                 <<staticContributions[admsNodeID_c].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_xf2_GND) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_xf1_GND) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bx_si) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_bx_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_si_bp) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_si_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bp_cx) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_e_ei) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bx_bi) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b_bx) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_c_cx) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bx_bp) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bx_cx) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_bx_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bi_cx) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bx_ei) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_c] =  "
                 <<dynamicContributions[admsNodeID_c].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_xf2_GND) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_xf1_GND) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bx_si) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bx_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_si_bp) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_si_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bp_cx) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_e_ei) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bx_bi) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_bx) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_c_cx) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bx_bp) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bx_cx) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bx_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bi_cx) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bx_ei) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_c] =  "
                 <<Jdxp_static[admsNodeID_c] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_c] =  "
                 <<Jdxp_dynamic[admsNodeID_c] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_b] =  "
                 <<staticContributions[admsNodeID_b].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_xf2_GND) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_xf1_GND) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bx_si) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_bx_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_si_bp) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_si_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bp_cx) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_e_ei) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bx_bi) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_bx) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_c_cx) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bx_bp) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bx_cx) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_bx_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_cx) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bx_ei) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_b] =  "
                 <<dynamicContributions[admsNodeID_b].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_xf2_GND) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_xf1_GND) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bx_si) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bx_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_si_bp) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_si_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bp_cx) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_e_ei) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bx_bi) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_bx) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c_cx) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bx_bp) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bx_cx) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bx_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_cx) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bx_ei) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_b] =  "
                 <<Jdxp_static[admsNodeID_b] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_b] =  "
                 <<Jdxp_dynamic[admsNodeID_b] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_e] =  "
                 <<staticContributions[admsNodeID_e].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_xf2_GND) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_xf1_GND) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bx_si) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_bx_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_si_bp) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_si_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bp_cx) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_e_ei) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bx_bi) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b_bx) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_c_cx) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bx_bp) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bx_cx) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_bx_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bi_cx) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bx_ei) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_e] =  "
                 <<dynamicContributions[admsNodeID_e].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_xf2_GND) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_xf1_GND) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bx_si) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bx_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_si_bp) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_si_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bp_cx) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_ei) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bx_bi) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_bx) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_c_cx) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bx_bp) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bx_cx) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bx_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bi_cx) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bx_ei) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_e] =  "
                 <<Jdxp_static[admsNodeID_e] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_e] =  "
                 <<Jdxp_dynamic[admsNodeID_e] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_s] =  "
                 <<staticContributions[admsNodeID_s].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_xf2_GND) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_xf1_GND) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_bx_si) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_bx_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_si_bp) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_si_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_bp_cx) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_e_ei) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_bx_bi) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_bx) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_c_cx) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_bx_bp) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_bx_cx) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_bx_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_bi_cx) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_bx_ei) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_s] =  "
                 <<dynamicContributions[admsNodeID_s].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_xf2_GND) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_xf1_GND) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bx_si) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bx_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_si_bp) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_si_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bp_cx) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_e_ei) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bx_bi) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_bx) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c_cx) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bx_bp) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bx_cx) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bx_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bi_cx) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bx_ei) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_s] =  "
                 <<Jdxp_static[admsNodeID_s] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_s] =  "
                 <<Jdxp_dynamic[admsNodeID_s] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_dt] =  "
                 <<staticContributions[admsNodeID_dt].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_xf2_GND) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_xf1_GND) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_si) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_si_bp) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_si_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_bp_cx) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_e_ei) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bi) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_bx) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_c_cx) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bp) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_cx) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_cx) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_ei) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_dt] =  "
                 <<dynamicContributions[admsNodeID_dt].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_xf2_GND) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_xf1_GND) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bx_si) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bx_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_si_bp) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_si_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bp_cx) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_e_ei) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bi) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_bx) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_c_cx) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bp) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bx_cx) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bx_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bi_cx) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bx_ei) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_dt] =  "
                 <<Jdxp_static[admsNodeID_dt] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_dt] =  "
                 <<Jdxp_dynamic[admsNodeID_dt] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_cx] =  "
                 <<staticContributions[admsNodeID_cx].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_xf2_GND) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_xf1_GND) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_si) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_si_bp) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_si_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_bp_cx) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_e_ei) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_bi) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_b_bx) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_c_cx) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_bp) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_cx) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_cx) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_ei) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_cx].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_cx].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_cx] =  "
                 <<dynamicContributions[admsNodeID_cx].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_xf2_GND) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_xf1_GND) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bx_si) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bx_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_si_bp) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_si_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bp_cx) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_e_ei) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bx_bi) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_b_bx) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_c_cx) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bx_bp) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bx_cx) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bx_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bi_cx) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bx_ei) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_cx].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_cx].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_cx] =  "
                 <<Jdxp_static[admsNodeID_cx] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_cx] =  "
                 <<Jdxp_dynamic[admsNodeID_cx] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_ci] =  "
                 <<staticContributions[admsNodeID_ci].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_xf2_GND) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_xf1_GND) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bx_si) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_bx_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_si_bp) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_si_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bp_cx) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_e_ei) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bx_bi) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_bx) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_c_cx) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bx_bp) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bx_cx) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_bx_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_cx) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bx_ei) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_ci].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_ci] =  "
                 <<dynamicContributions[admsNodeID_ci].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_xf2_GND) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_xf1_GND) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bx_si) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bx_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_si_bp) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_si_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bp_cx) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_e_ei) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bx_bi) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_bx) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_c_cx) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bx_bp) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bx_cx) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bx_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_cx) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bx_ei) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_ci].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_ci] =  "
                 <<Jdxp_static[admsNodeID_ci] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_ci] =  "
                 <<Jdxp_dynamic[admsNodeID_ci] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_bx] =  "
                 <<staticContributions[admsNodeID_bx].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_xf2_GND) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_xf1_GND) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_si) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_si_bp) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_si_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_bp_cx) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_e_ei) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bi) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_b_bx) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_c_cx) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bp) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_cx) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_bi_cx) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_ei) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bx].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_bx].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_bx] =  "
                 <<dynamicContributions[admsNodeID_bx].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_xf2_GND) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_xf1_GND) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_si) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_si_bp) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_si_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bp_cx) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_e_ei) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bi) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_b_bx) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_c_cx) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bp) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_cx) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bi_cx) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_ei) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bx].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_bx].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_bx] =  "
                 <<Jdxp_static[admsNodeID_bx] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_bx] =  "
                 <<Jdxp_dynamic[admsNodeID_bx] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_bi] =  "
                 <<staticContributions[admsNodeID_bi].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_xf2_GND) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_xf1_GND) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_si) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_si_bp) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_si_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bp_cx) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_e_ei) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bi) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_bx) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_c_cx) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bp) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_cx) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_cx) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_ei) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_bi] =  "
                 <<dynamicContributions[admsNodeID_bi].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_xf2_GND) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_xf1_GND) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bx_si) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bx_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_si_bp) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_si_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bp_cx) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_e_ei) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bi) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_bx) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_c_cx) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bp) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bx_cx) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bx_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_cx) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bx_ei) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_bi] =  "
                 <<Jdxp_static[admsNodeID_bi] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_bi] =  "
                 <<Jdxp_dynamic[admsNodeID_bi] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_ei] =  "
                 <<staticContributions[admsNodeID_ei].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_xf2_GND) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_xf1_GND) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bx_si) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_bx_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_si_bp) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_si_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bp_cx) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_e_ei) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bx_bi) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_bx) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_c_cx) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bx_bp) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bx_cx) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_bx_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_cx) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bx_ei) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_ei].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_ei] =  "
                 <<dynamicContributions[admsNodeID_ei].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_xf2_GND) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_xf1_GND) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bx_si) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bx_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_si_bp) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_si_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bp_cx) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_e_ei) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bx_bi) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_bx) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_c_cx) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bx_bp) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bx_cx) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bx_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_cx) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bx_ei) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_ei].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_ei] =  "
                 <<Jdxp_static[admsNodeID_ei] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_ei] =  "
                 <<Jdxp_dynamic[admsNodeID_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_bp] =  "
                 <<staticContributions[admsNodeID_bp].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_xf2_GND) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_xf1_GND) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_bx_si) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_bx_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_si_bp) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_si_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_bp_cx) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_e_ei) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bi) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_b_bx) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_c_cx) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bp) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_bx_cx) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_bx_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_bi_cx) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_bx_ei) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_bp].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_bp] =  "
                 <<dynamicContributions[admsNodeID_bp].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_xf2_GND) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_xf1_GND) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bx_si) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bx_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_si_bp) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_si_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bp_cx) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_e_ei) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bi) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_b_bx) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_c_cx) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bp) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bx_cx) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bx_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bi_cx) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bx_ei) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_bp].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_bp] =  "
                 <<Jdxp_static[admsNodeID_bp] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_bp] =  "
                 <<Jdxp_dynamic[admsNodeID_bp] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_si] =  "
                 <<staticContributions[admsNodeID_si].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_xf2_GND) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_xf1_GND) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_bx_si) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_bx_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_si_bp) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_si_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_bp_cx) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_e_ei) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_bx_bi) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_b_bx) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_c_cx) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_bx_bp) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_bx_cx) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_bx_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_bi_cx) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_bx_ei) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_si] =  "
                 <<dynamicContributions[admsNodeID_si].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_xf2_GND) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_xf1_GND) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bx_si) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bx_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_bp) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bp_cx) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_e_ei) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bx_bi) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_bx) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_c_cx) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bx_bp) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bx_cx) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bx_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bi_cx) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bx_ei) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_si] =  "
                 <<Jdxp_static[admsNodeID_si] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_si] =  "
                 <<Jdxp_dynamic[admsNodeID_si] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_xf1] =  "
                 <<staticContributions[admsNodeID_xf1].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_xf2_GND) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_xf1_GND) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bx_si) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bx_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_si_bp) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_si_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bp_cx) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_e_ei) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bx_bi) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_b_bx) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_c_cx) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bx_bp) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bx_cx) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bx_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_cx) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bx_ei) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_xf1].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_xf1] =  "
                 <<dynamicContributions[admsNodeID_xf1].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_xf2_GND) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_xf1_GND) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bx_si) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bx_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_si_bp) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_si_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bp_cx) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_e_ei) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bx_bi) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_b_bx) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_c_cx) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bx_bp) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bx_cx) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bx_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_cx) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bx_ei) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_xf1].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_xf1] =  "
                 <<Jdxp_static[admsNodeID_xf1] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_xf1] =  "
                 <<Jdxp_dynamic[admsNodeID_xf1] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_xf2] =  "
                 <<staticContributions[admsNodeID_xf2].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_xf2_GND) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_xf1_GND) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bx_si) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bx_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_si_bp) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_si_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bp_cx) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_e_ei) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bx_bi) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_b_bx) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_cx_ci) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_c_cx) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bx_bp) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_ci_ei) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bx_cx) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bx_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_cx) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ci) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bx_ei) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ei) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_xf2].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_xf2] =  "
                 <<dynamicContributions[admsNodeID_xf2].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_xf2_GND) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_xf2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_xf1_GND) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_xf1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bx_si) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bx_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_si_bp) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_si_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bp_cx) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bp_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_e_ei) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_e_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bx_bi) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bx_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_b_bx) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_b_bx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_cx_ci) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_cx_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_c_cx) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_c_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bx_bp) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bx_bp) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_ci_ei) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_ci_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bx_cx) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bx_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_cx) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_cx) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ci) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ci) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bx_ei) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bx_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ei) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ei) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_xf2].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_xf2] =  "
                 <<Jdxp_static[admsNodeID_xf2] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_xf2] =  "
                 <<Jdxp_dynamic[admsNodeID_xf2] << std::endl;

    if (!origFlag)
      Xyce::dout() << "This step was limited by this device." << std::endl;
  }


  if (loadLeadCurrent)
  {
    // If needed, we must now copy all the data from staticContributions
    // and dynamicContributionsinto the lead current F vector
    // Must make sure all collapsed node contributions get summed into the
    // external nodes properly.
    for ( int unmappedNode=0; unmappedNode < 4 ; unmappedNode++)
    {
      leadCurrentF[unmappedNode] = 0.0;
      leadCurrentQ[unmappedNode] = 0.0;
    }
    for ( int unmappedNode=0; unmappedNode < 14; unmappedNode++)
    {
      if (nodeMap[unmappedNode] < 4 && nodeMap[unmappedNode] != -1 )
      {
        leadCurrentF[nodeMap[unmappedNode]] += staticContributions[unmappedNode].val();
        leadCurrentQ[nodeMap[unmappedNode]] += dynamicContributions[unmappedNode].val();
      }
    }
  }  
  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::getNumNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
int Instance::getNumNoiseSources () const
{
  return 15;
}

//-----------------------------------------------------------------------------
// Function      : Instance::setupNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{
  int numSources=getNumNoiseSources();
  noiseData.numSources = numSources;
  noiseData.resize(numSources);

  noiseData.deviceName = getName().getEncodedName();
  std::string theNoiseName;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_bi_ei")+std::string("_")+std::string("Ibei shot noise");
  noiseData.noiseNames[0]=theNoiseName;
  noiseData.li_Pos[0]=li_bi;
  noiseData.li_Neg[0]=li_ei;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_flicker_bi_ei")+std::string("_")+std::string("Ibei flicker noise");
  noiseData.noiseNames[1]=theNoiseName;
  noiseData.li_Pos[1]=li_bi;
  noiseData.li_Neg[1]=li_ei;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_bx_ei")+std::string("_")+std::string("Ibex shot noise");
  noiseData.noiseNames[2]=theNoiseName;
  noiseData.li_Pos[2]=li_bx;
  noiseData.li_Neg[2]=li_ei;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_flicker_bx_ei")+std::string("_")+std::string("Ibex flicker noise");
  noiseData.noiseNames[3]=theNoiseName;
  noiseData.li_Pos[3]=li_bx;
  noiseData.li_Neg[3]=li_ei;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_ci_ei")+std::string("_")+std::string("transport current shot noise");
  noiseData.noiseNames[4]=theNoiseName;
  noiseData.li_Pos[4]=li_ci;
  noiseData.li_Neg[4]=li_ei;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_bx_bp")+std::string("_")+std::string("Ibep shot noise");
  noiseData.noiseNames[5]=theNoiseName;
  noiseData.li_Pos[5]=li_bx;
  noiseData.li_Neg[5]=li_bp;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_flicker_bx_bp")+std::string("_")+std::string("Ibep flicker noise");
  noiseData.noiseNames[6]=theNoiseName;
  noiseData.li_Pos[6]=li_bx;
  noiseData.li_Neg[6]=li_bp;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_c_cx")+std::string("_")+std::string("rcx thermal noise");
  noiseData.noiseNames[7]=theNoiseName;
  noiseData.li_Pos[7]=li_c;
  noiseData.li_Neg[7]=li_cx;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_cx_ci")+std::string("_")+std::string("rci thermal noise");
  noiseData.noiseNames[8]=theNoiseName;
  noiseData.li_Pos[8]=li_cx;
  noiseData.li_Neg[8]=li_ci;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_b_bx")+std::string("_")+std::string("rbx thermal noise");
  noiseData.noiseNames[9]=theNoiseName;
  noiseData.li_Pos[9]=li_b;
  noiseData.li_Neg[9]=li_bx;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_bx_bi")+std::string("_")+std::string("rbi thermal noise");
  noiseData.noiseNames[10]=theNoiseName;
  noiseData.li_Pos[10]=li_bx;
  noiseData.li_Neg[10]=li_bi;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_e_ei")+std::string("_")+std::string("re thermal noise");
  noiseData.noiseNames[11]=theNoiseName;
  noiseData.li_Pos[11]=li_e;
  noiseData.li_Neg[11]=li_ei;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_bp_cx")+std::string("_")+std::string("rbp thermal noise");
  noiseData.noiseNames[12]=theNoiseName;
  noiseData.li_Pos[12]=li_bp;
  noiseData.li_Neg[12]=li_cx;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_bx_si")+std::string("_")+std::string("parasitic transport current shot noise");
  noiseData.noiseNames[13]=theNoiseName;
  noiseData.li_Pos[13]=li_bx;
  noiseData.li_Neg[13]=li_si;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_s_si")+std::string("_")+std::string("rs thermal noise");
  noiseData.noiseNames[14]=theNoiseName;
  noiseData.li_Pos[14]=li_s;
  noiseData.li_Neg[14]=li_si;


}
//-----------------------------------------------------------------------------
// Function      : Instance::getNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::getNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{noiseData.noiseDens[0] = noiseContribsPower[0];
  noiseData.lnNoiseDens[0] = std::log(std::max(noiseData.noiseDens[0],N_MINLOG));
  noiseData.noiseDens[1] = noiseContribsPower[1];

  noiseData.noiseDens[1] /= pow(noiseData.freq,noiseContribsExponent[1]);noiseData.lnNoiseDens[1] = std::log(std::max(noiseData.noiseDens[1],N_MINLOG));
  noiseData.noiseDens[2] = noiseContribsPower[2];
  noiseData.lnNoiseDens[2] = std::log(std::max(noiseData.noiseDens[2],N_MINLOG));
  noiseData.noiseDens[3] = noiseContribsPower[3];

  noiseData.noiseDens[3] /= pow(noiseData.freq,noiseContribsExponent[3]);noiseData.lnNoiseDens[3] = std::log(std::max(noiseData.noiseDens[3],N_MINLOG));
  noiseData.noiseDens[4] = noiseContribsPower[4];
  noiseData.lnNoiseDens[4] = std::log(std::max(noiseData.noiseDens[4],N_MINLOG));
  noiseData.noiseDens[5] = noiseContribsPower[5];
  noiseData.lnNoiseDens[5] = std::log(std::max(noiseData.noiseDens[5],N_MINLOG));
  noiseData.noiseDens[6] = noiseContribsPower[6];

  noiseData.noiseDens[6] /= pow(noiseData.freq,noiseContribsExponent[6]);noiseData.lnNoiseDens[6] = std::log(std::max(noiseData.noiseDens[6],N_MINLOG));
  noiseData.noiseDens[7] = noiseContribsPower[7];
  noiseData.lnNoiseDens[7] = std::log(std::max(noiseData.noiseDens[7],N_MINLOG));
  noiseData.noiseDens[8] = noiseContribsPower[8];
  noiseData.lnNoiseDens[8] = std::log(std::max(noiseData.noiseDens[8],N_MINLOG));
  noiseData.noiseDens[9] = noiseContribsPower[9];
  noiseData.lnNoiseDens[9] = std::log(std::max(noiseData.noiseDens[9],N_MINLOG));
  noiseData.noiseDens[10] = noiseContribsPower[10];
  noiseData.lnNoiseDens[10] = std::log(std::max(noiseData.noiseDens[10],N_MINLOG));
  noiseData.noiseDens[11] = noiseContribsPower[11];
  noiseData.lnNoiseDens[11] = std::log(std::max(noiseData.noiseDens[11],N_MINLOG));
  noiseData.noiseDens[12] = noiseContribsPower[12];
  noiseData.lnNoiseDens[12] = std::log(std::max(noiseData.noiseDens[12],N_MINLOG));
  noiseData.noiseDens[13] = noiseContribsPower[13];
  noiseData.lnNoiseDens[13] = std::log(std::max(noiseData.noiseDens[13],N_MINLOG));
  noiseData.noiseDens[14] = noiseContribsPower[14];
  noiseData.lnNoiseDens[14] = std::log(std::max(noiseData.noiseDens[14],N_MINLOG));

}  

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdFdx
// Purpose       :
// Special Notes : Load the dFdx ("static jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdFdx()
{
  bool bsuccess = true;
  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*f_bi_Equ_bx_Node_Ptr) +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bi) +staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_ei) +staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bp);
  (*f_bi_Equ_bp_Node_Ptr) +=  -staticContributions[admsNodeID_bi].dx(admsProbeID_V_si_bp) -staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bp);
  (*f_ei_Equ_bx_Node_Ptr) +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_bx_ei) +staticContributions[admsNodeID_ei].dx(admsProbeID_V_bx_bp);
  (*f_ei_Equ_bp_Node_Ptr) +=  -staticContributions[admsNodeID_ei].dx(admsProbeID_V_si_bp) -staticContributions[admsNodeID_ei].dx(admsProbeID_V_bx_bp);
  (*f_bi_Equ_si_Node_Ptr) +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_V_si_bp);
  (*f_ei_Equ_si_Node_Ptr) +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_si_bp);
  (*f_bi_Equ_bi_Node_Ptr) +=  -staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bi) +staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei) +staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci);
  (*f_bi_Equ_ci_Node_Ptr) +=  -staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci);
  (*f_ei_Equ_bi_Node_Ptr) +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei) +staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci);
  (*f_ei_Equ_ci_Node_Ptr) +=  -staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci);
  (*f_bi_Equ_ei_Node_Ptr) +=  -staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_ei) -staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei);
  (*f_ei_Equ_ei_Node_Ptr) +=  -staticContributions[admsNodeID_ei].dx(admsProbeID_V_e_ei) -staticContributions[admsNodeID_ei].dx(admsProbeID_V_bx_ei) -staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei);
  (*f_bi_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_Temp_dt_GND);
  (*f_ei_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_Temp_dt_GND);
  (*f_bx_Equ_bi_Node_Ptr) +=  -staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bi) +staticContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ei);
  (*f_bx_Equ_ei_Node_Ptr) +=  -staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_ei) -staticContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ei);
  (*f_bx_Equ_ci_Node_Ptr) +=  -staticContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ci);
  (*f_bx_Equ_bx_Node_Ptr) +=  +staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bi) -staticContributions[admsNodeID_bx].dx(admsProbeID_V_b_bx) +staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_cx) +staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_ei) +staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bp);
  (*f_bx_Equ_bp_Node_Ptr) +=  -staticContributions[admsNodeID_bx].dx(admsProbeID_V_si_bp) -staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bp);
  (*f_bx_Equ_si_Node_Ptr) +=  +staticContributions[admsNodeID_bx].dx(admsProbeID_V_si_bp);
  (*f_bx_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_bx].dx(admsProbeID_Temp_dt_GND);
  (*f_ci_Equ_xf2_Node_Ptr) +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_xf2_GND);
  (*f_ei_Equ_xf2_Node_Ptr) +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_xf2_GND);
  (*f_ci_Equ_bi_Node_Ptr) +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_cx) +staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei);
  (*f_ci_Equ_ei_Node_Ptr) +=  -staticContributions[admsNodeID_ci].dx(admsProbeID_V_bx_ei) -staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei);
  (*f_ci_Equ_ci_Node_Ptr) +=  -staticContributions[admsNodeID_ci].dx(admsProbeID_V_cx_ci) -staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci);
  (*f_ci_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_Temp_dt_GND);
  (*f_bi_Equ_xf2_Node_Ptr) +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_V_xf2_GND);
  (*f_ci_Equ_bx_Node_Ptr) +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_bx_ei) +staticContributions[admsNodeID_ci].dx(admsProbeID_V_bx_bp);
  (*f_ci_Equ_bp_Node_Ptr) +=  -staticContributions[admsNodeID_ci].dx(admsProbeID_V_si_bp) -staticContributions[admsNodeID_ci].dx(admsProbeID_V_bx_bp);
  (*f_ci_Equ_si_Node_Ptr) +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_si_bp);
  (*f_cx_Equ_bi_Node_Ptr) +=  +staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ei) +staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_cx) +staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ci);
  (*f_cx_Equ_ci_Node_Ptr) +=  -staticContributions[admsNodeID_cx].dx(admsProbeID_V_cx_ci) -staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ci);
  (*f_bx_Equ_cx_Node_Ptr) +=  -staticContributions[admsNodeID_bx].dx(admsProbeID_V_c_cx) -staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_cx);
  (*f_cx_Equ_bx_Node_Ptr) +=  +staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_ei) +staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_bp) +staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_cx);
  (*f_cx_Equ_cx_Node_Ptr) +=  -staticContributions[admsNodeID_cx].dx(admsProbeID_V_bp_cx) +staticContributions[admsNodeID_cx].dx(admsProbeID_V_cx_ci) -staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_cx) -staticContributions[admsNodeID_cx].dx(admsProbeID_V_c_cx) -staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_cx);
  (*f_cx_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_cx].dx(admsProbeID_Temp_dt_GND);
  (*f_bx_Equ_c_Node_Ptr) +=  +staticContributions[admsNodeID_bx].dx(admsProbeID_V_c_cx);
  (*f_cx_Equ_c_Node_Ptr) +=  +staticContributions[admsNodeID_cx].dx(admsProbeID_V_c_cx);
  (*f_bp_Equ_bi_Node_Ptr) +=  +staticContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ei);
  (*f_bp_Equ_ei_Node_Ptr) +=  -staticContributions[admsNodeID_bp].dx(admsProbeID_V_bx_ei) -staticContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ei);
  (*f_bp_Equ_ci_Node_Ptr) +=  -staticContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ci);
  (*f_bp_Equ_bx_Node_Ptr) +=  +staticContributions[admsNodeID_bp].dx(admsProbeID_V_bx_ei) +staticContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bp);
  (*f_bp_Equ_bp_Node_Ptr) +=  +staticContributions[admsNodeID_bp].dx(admsProbeID_V_bp_cx) -staticContributions[admsNodeID_bp].dx(admsProbeID_V_si_bp) -staticContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bp);
  (*f_bp_Equ_si_Node_Ptr) +=  +staticContributions[admsNodeID_bp].dx(admsProbeID_V_si_bp);
  (*f_bp_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_bp].dx(admsProbeID_Temp_dt_GND);
  (*f_c_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_c].dx(admsProbeID_Temp_dt_GND);
  (*f_c_Equ_c_Node_Ptr) +=  +staticContributions[admsNodeID_c].dx(admsProbeID_V_c_cx);
  (*f_c_Equ_cx_Node_Ptr) +=  -staticContributions[admsNodeID_c].dx(admsProbeID_V_c_cx);
  (*f_ci_Equ_cx_Node_Ptr) +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_cx_ci) -staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_cx);
  (*f_cx_Equ_ei_Node_Ptr) +=  -staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_ei) -staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ei);
  (*f_cx_Equ_bp_Node_Ptr) +=  +staticContributions[admsNodeID_cx].dx(admsProbeID_V_bp_cx) -staticContributions[admsNodeID_cx].dx(admsProbeID_V_si_bp) -staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_bp);
  (*f_cx_Equ_si_Node_Ptr) +=  +staticContributions[admsNodeID_cx].dx(admsProbeID_V_si_bp);
  (*f_b_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_b].dx(admsProbeID_Temp_dt_GND);
  (*f_b_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_b_bx);
  (*f_b_Equ_bx_Node_Ptr) +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b_bx);
  (*f_bx_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_bx].dx(admsProbeID_V_b_bx);
  (*f_e_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_e].dx(admsProbeID_Temp_dt_GND);
  (*f_e_Equ_e_Node_Ptr) +=  +staticContributions[admsNodeID_e].dx(admsProbeID_V_e_ei);
  (*f_e_Equ_ei_Node_Ptr) +=  -staticContributions[admsNodeID_e].dx(admsProbeID_V_e_ei);
  (*f_ei_Equ_e_Node_Ptr) +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_e_ei);
  (*f_bp_Equ_cx_Node_Ptr) +=  -staticContributions[admsNodeID_bp].dx(admsProbeID_V_bp_cx);
  (*f_si_Equ_bi_Node_Ptr) +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_si].dx(admsProbeID_V_bi_ei);
  (*f_si_Equ_ei_Node_Ptr) +=  -staticContributions[admsNodeID_si].dx(admsProbeID_V_bx_ei) -staticContributions[admsNodeID_si].dx(admsProbeID_V_bi_ei);
  (*f_si_Equ_ci_Node_Ptr) +=  -staticContributions[admsNodeID_si].dx(admsProbeID_V_bi_ci);
  (*f_si_Equ_bx_Node_Ptr) +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_bx_ei) +staticContributions[admsNodeID_si].dx(admsProbeID_V_bx_bp);
  (*f_si_Equ_bp_Node_Ptr) +=  -staticContributions[admsNodeID_si].dx(admsProbeID_V_si_bp) -staticContributions[admsNodeID_si].dx(admsProbeID_V_bx_bp);
  (*f_si_Equ_si_Node_Ptr) +=  -staticContributions[admsNodeID_si].dx(admsProbeID_V_s_si) +staticContributions[admsNodeID_si].dx(admsProbeID_V_si_bp);
  (*f_si_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_si].dx(admsProbeID_Temp_dt_GND);
  (*f_s_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_s].dx(admsProbeID_Temp_dt_GND);
  (*f_s_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_s_si);
  (*f_s_Equ_si_Node_Ptr) +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_s_si);
  (*f_si_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_s_si);
  (*f_xf1_Equ_bi_Node_Ptr) +=  +staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ei) +staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ci);
  (*f_xf1_Equ_ci_Node_Ptr) +=  -staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ci);
  (*f_xf1_Equ_ei_Node_Ptr) +=  -staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ei);
  (*f_xf1_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_xf1].dx(admsProbeID_Temp_dt_GND);
  (*f_xf1_Equ_xf2_Node_Ptr) +=  +staticContributions[admsNodeID_xf1].dx(admsProbeID_V_xf2_GND);
  (*f_xf2_Equ_xf1_Node_Ptr) +=  +staticContributions[admsNodeID_xf2].dx(admsProbeID_V_xf1_GND);
  (*f_xf2_Equ_xf2_Node_Ptr) +=  +staticContributions[admsNodeID_xf2].dx(admsProbeID_V_xf2_GND);
  (*f_dt_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_Temp_dt_GND);
  (*f_dt_Equ_bp_Node_Ptr) +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_si_bp) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bp) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_bp_cx);
  (*f_dt_Equ_cx_Node_Ptr) +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_c_cx) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_cx_ci) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_cx) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_bp_cx);
  (*f_dt_Equ_e_Node_Ptr) +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_e_ei);
  (*f_dt_Equ_ei_Node_Ptr) +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_ei) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ei) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_ci_ei) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_e_ei);
  (*f_dt_Equ_bx_Node_Ptr) +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_ei) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bp) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_si) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_bx) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bi);
  (*f_dt_Equ_bi_Node_Ptr) +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ei) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_cx) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bi);
  (*f_dt_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_bx);
  (*f_dt_Equ_ci_Node_Ptr) +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_ci_ei) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_cx_ci);
  (*f_dt_Equ_c_Node_Ptr) +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_c_cx);
  (*f_dt_Equ_si_Node_Ptr) +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_si_bp) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_si) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_si);
  (*f_dt_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_si);
  (*f_dt_Equ_xf2_Node_Ptr) +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_xf2_GND);

#else
  //use the offsets instead of pointers
  dFdx[li_bi][A_bi_Equ_bx_NodeOffset] +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bi) +staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_ei) +staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bp);
  dFdx[li_bi][A_bi_Equ_bp_NodeOffset] +=  -staticContributions[admsNodeID_bi].dx(admsProbeID_V_si_bp) -staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bp);
  dFdx[li_ei][A_ei_Equ_bx_NodeOffset] +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_bx_ei) +staticContributions[admsNodeID_ei].dx(admsProbeID_V_bx_bp);
  dFdx[li_ei][A_ei_Equ_bp_NodeOffset] +=  -staticContributions[admsNodeID_ei].dx(admsProbeID_V_si_bp) -staticContributions[admsNodeID_ei].dx(admsProbeID_V_bx_bp);
  dFdx[li_bi][A_bi_Equ_si_NodeOffset] +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_V_si_bp);
  dFdx[li_ei][A_ei_Equ_si_NodeOffset] +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_si_bp);
  dFdx[li_bi][A_bi_Equ_bi_NodeOffset] +=  -staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bi) +staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei) +staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci);
  dFdx[li_bi][A_bi_Equ_ci_NodeOffset] +=  -staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci);
  dFdx[li_ei][A_ei_Equ_bi_NodeOffset] +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei) +staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci);
  dFdx[li_ei][A_ei_Equ_ci_NodeOffset] +=  -staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci);
  dFdx[li_bi][A_bi_Equ_ei_NodeOffset] +=  -staticContributions[admsNodeID_bi].dx(admsProbeID_V_bx_ei) -staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei);
  dFdx[li_ei][A_ei_Equ_ei_NodeOffset] +=  -staticContributions[admsNodeID_ei].dx(admsProbeID_V_e_ei) -staticContributions[admsNodeID_ei].dx(admsProbeID_V_bx_ei) -staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei);
  dFdx[li_bi][A_bi_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_Temp_dt_GND);
  dFdx[li_ei][A_ei_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_Temp_dt_GND);
  dFdx[li_bx][A_bx_Equ_bi_NodeOffset] +=  -staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bi) +staticContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ei);
  dFdx[li_bx][A_bx_Equ_ei_NodeOffset] +=  -staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_ei) -staticContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ei);
  dFdx[li_bx][A_bx_Equ_ci_NodeOffset] +=  -staticContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ci);
  dFdx[li_bx][A_bx_Equ_bx_NodeOffset] +=  +staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bi) -staticContributions[admsNodeID_bx].dx(admsProbeID_V_b_bx) +staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_cx) +staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_ei) +staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bp);
  dFdx[li_bx][A_bx_Equ_bp_NodeOffset] +=  -staticContributions[admsNodeID_bx].dx(admsProbeID_V_si_bp) -staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bp);
  dFdx[li_bx][A_bx_Equ_si_NodeOffset] +=  +staticContributions[admsNodeID_bx].dx(admsProbeID_V_si_bp);
  dFdx[li_bx][A_bx_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_bx].dx(admsProbeID_Temp_dt_GND);
  dFdx[li_ci][A_ci_Equ_xf2_NodeOffset] +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_xf2_GND);
  dFdx[li_ei][A_ei_Equ_xf2_NodeOffset] +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_xf2_GND);
  dFdx[li_ci][A_ci_Equ_bi_NodeOffset] +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_cx) +staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei);
  dFdx[li_ci][A_ci_Equ_ei_NodeOffset] +=  -staticContributions[admsNodeID_ci].dx(admsProbeID_V_bx_ei) -staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei);
  dFdx[li_ci][A_ci_Equ_ci_NodeOffset] +=  -staticContributions[admsNodeID_ci].dx(admsProbeID_V_cx_ci) -staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci);
  dFdx[li_ci][A_ci_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_Temp_dt_GND);
  dFdx[li_bi][A_bi_Equ_xf2_NodeOffset] +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_V_xf2_GND);
  dFdx[li_ci][A_ci_Equ_bx_NodeOffset] +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_bx_ei) +staticContributions[admsNodeID_ci].dx(admsProbeID_V_bx_bp);
  dFdx[li_ci][A_ci_Equ_bp_NodeOffset] +=  -staticContributions[admsNodeID_ci].dx(admsProbeID_V_si_bp) -staticContributions[admsNodeID_ci].dx(admsProbeID_V_bx_bp);
  dFdx[li_ci][A_ci_Equ_si_NodeOffset] +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_si_bp);
  dFdx[li_cx][A_cx_Equ_bi_NodeOffset] +=  +staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ei) +staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_cx) +staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ci);
  dFdx[li_cx][A_cx_Equ_ci_NodeOffset] +=  -staticContributions[admsNodeID_cx].dx(admsProbeID_V_cx_ci) -staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ci);
  dFdx[li_bx][A_bx_Equ_cx_NodeOffset] +=  -staticContributions[admsNodeID_bx].dx(admsProbeID_V_c_cx) -staticContributions[admsNodeID_bx].dx(admsProbeID_V_bx_cx);
  dFdx[li_cx][A_cx_Equ_bx_NodeOffset] +=  +staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_ei) +staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_bp) +staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_cx);
  dFdx[li_cx][A_cx_Equ_cx_NodeOffset] +=  -staticContributions[admsNodeID_cx].dx(admsProbeID_V_bp_cx) +staticContributions[admsNodeID_cx].dx(admsProbeID_V_cx_ci) -staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_cx) -staticContributions[admsNodeID_cx].dx(admsProbeID_V_c_cx) -staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_cx);
  dFdx[li_cx][A_cx_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_cx].dx(admsProbeID_Temp_dt_GND);
  dFdx[li_bx][A_bx_Equ_c_NodeOffset] +=  +staticContributions[admsNodeID_bx].dx(admsProbeID_V_c_cx);
  dFdx[li_cx][A_cx_Equ_c_NodeOffset] +=  +staticContributions[admsNodeID_cx].dx(admsProbeID_V_c_cx);
  dFdx[li_bp][A_bp_Equ_bi_NodeOffset] +=  +staticContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ei);
  dFdx[li_bp][A_bp_Equ_ei_NodeOffset] +=  -staticContributions[admsNodeID_bp].dx(admsProbeID_V_bx_ei) -staticContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ei);
  dFdx[li_bp][A_bp_Equ_ci_NodeOffset] +=  -staticContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ci);
  dFdx[li_bp][A_bp_Equ_bx_NodeOffset] +=  +staticContributions[admsNodeID_bp].dx(admsProbeID_V_bx_ei) +staticContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bp);
  dFdx[li_bp][A_bp_Equ_bp_NodeOffset] +=  +staticContributions[admsNodeID_bp].dx(admsProbeID_V_bp_cx) -staticContributions[admsNodeID_bp].dx(admsProbeID_V_si_bp) -staticContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bp);
  dFdx[li_bp][A_bp_Equ_si_NodeOffset] +=  +staticContributions[admsNodeID_bp].dx(admsProbeID_V_si_bp);
  dFdx[li_bp][A_bp_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_bp].dx(admsProbeID_Temp_dt_GND);
  dFdx[li_c][A_c_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_c].dx(admsProbeID_Temp_dt_GND);
  dFdx[li_c][A_c_Equ_c_NodeOffset] +=  +staticContributions[admsNodeID_c].dx(admsProbeID_V_c_cx);
  dFdx[li_c][A_c_Equ_cx_NodeOffset] +=  -staticContributions[admsNodeID_c].dx(admsProbeID_V_c_cx);
  dFdx[li_ci][A_ci_Equ_cx_NodeOffset] +=  +staticContributions[admsNodeID_ci].dx(admsProbeID_V_cx_ci) -staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_cx);
  dFdx[li_cx][A_cx_Equ_ei_NodeOffset] +=  -staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_ei) -staticContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ei);
  dFdx[li_cx][A_cx_Equ_bp_NodeOffset] +=  +staticContributions[admsNodeID_cx].dx(admsProbeID_V_bp_cx) -staticContributions[admsNodeID_cx].dx(admsProbeID_V_si_bp) -staticContributions[admsNodeID_cx].dx(admsProbeID_V_bx_bp);
  dFdx[li_cx][A_cx_Equ_si_NodeOffset] +=  +staticContributions[admsNodeID_cx].dx(admsProbeID_V_si_bp);
  dFdx[li_b][A_b_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_b].dx(admsProbeID_Temp_dt_GND);
  dFdx[li_b][A_b_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_b_bx);
  dFdx[li_b][A_b_Equ_bx_NodeOffset] +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b_bx);
  dFdx[li_bx][A_bx_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_bx].dx(admsProbeID_V_b_bx);
  dFdx[li_e][A_e_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_e].dx(admsProbeID_Temp_dt_GND);
  dFdx[li_e][A_e_Equ_e_NodeOffset] +=  +staticContributions[admsNodeID_e].dx(admsProbeID_V_e_ei);
  dFdx[li_e][A_e_Equ_ei_NodeOffset] +=  -staticContributions[admsNodeID_e].dx(admsProbeID_V_e_ei);
  dFdx[li_ei][A_ei_Equ_e_NodeOffset] +=  +staticContributions[admsNodeID_ei].dx(admsProbeID_V_e_ei);
  dFdx[li_bp][A_bp_Equ_cx_NodeOffset] +=  -staticContributions[admsNodeID_bp].dx(admsProbeID_V_bp_cx);
  dFdx[li_si][A_si_Equ_bi_NodeOffset] +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_si].dx(admsProbeID_V_bi_ei);
  dFdx[li_si][A_si_Equ_ei_NodeOffset] +=  -staticContributions[admsNodeID_si].dx(admsProbeID_V_bx_ei) -staticContributions[admsNodeID_si].dx(admsProbeID_V_bi_ei);
  dFdx[li_si][A_si_Equ_ci_NodeOffset] +=  -staticContributions[admsNodeID_si].dx(admsProbeID_V_bi_ci);
  dFdx[li_si][A_si_Equ_bx_NodeOffset] +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_bx_ei) +staticContributions[admsNodeID_si].dx(admsProbeID_V_bx_bp);
  dFdx[li_si][A_si_Equ_bp_NodeOffset] +=  -staticContributions[admsNodeID_si].dx(admsProbeID_V_si_bp) -staticContributions[admsNodeID_si].dx(admsProbeID_V_bx_bp);
  dFdx[li_si][A_si_Equ_si_NodeOffset] +=  -staticContributions[admsNodeID_si].dx(admsProbeID_V_s_si) +staticContributions[admsNodeID_si].dx(admsProbeID_V_si_bp);
  dFdx[li_si][A_si_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_si].dx(admsProbeID_Temp_dt_GND);
  dFdx[li_s][A_s_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_s].dx(admsProbeID_Temp_dt_GND);
  dFdx[li_s][A_s_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_s_si);
  dFdx[li_s][A_s_Equ_si_NodeOffset] +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_s_si);
  dFdx[li_si][A_si_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_s_si);
  dFdx[li_xf1][A_xf1_Equ_bi_NodeOffset] +=  +staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ei) +staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ci);
  dFdx[li_xf1][A_xf1_Equ_ci_NodeOffset] +=  -staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ci);
  dFdx[li_xf1][A_xf1_Equ_ei_NodeOffset] +=  -staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ei);
  dFdx[li_xf1][A_xf1_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_xf1].dx(admsProbeID_Temp_dt_GND);
  dFdx[li_xf1][A_xf1_Equ_xf2_NodeOffset] +=  +staticContributions[admsNodeID_xf1].dx(admsProbeID_V_xf2_GND);
  dFdx[li_xf2][A_xf2_Equ_xf1_NodeOffset] +=  +staticContributions[admsNodeID_xf2].dx(admsProbeID_V_xf1_GND);
  dFdx[li_xf2][A_xf2_Equ_xf2_NodeOffset] +=  +staticContributions[admsNodeID_xf2].dx(admsProbeID_V_xf2_GND);
  dFdx[li_dt][A_dt_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_Temp_dt_GND);
  dFdx[li_dt][A_dt_Equ_bp_NodeOffset] +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_si_bp) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bp) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_bp_cx);
  dFdx[li_dt][A_dt_Equ_cx_NodeOffset] +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_c_cx) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_cx_ci) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_cx) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_bp_cx);
  dFdx[li_dt][A_dt_Equ_e_NodeOffset] +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_e_ei);
  dFdx[li_dt][A_dt_Equ_ei_NodeOffset] +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_ei) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ei) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_ci_ei) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_e_ei);
  dFdx[li_dt][A_dt_Equ_bx_NodeOffset] +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_ei) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bp) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_si) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_bx) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bi);
  dFdx[li_dt][A_dt_Equ_bi_NodeOffset] +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ei) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_cx) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_bi);
  dFdx[li_dt][A_dt_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_bx);
  dFdx[li_dt][A_dt_Equ_ci_NodeOffset] +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_bi_ci) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_ci_ei) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_cx_ci);
  dFdx[li_dt][A_dt_Equ_c_NodeOffset] +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_c_cx);
  dFdx[li_dt][A_dt_Equ_si_NodeOffset] +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_si_bp) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_si) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_bx_si);
  dFdx[li_dt][A_dt_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_si);
  dFdx[li_dt][A_dt_Equ_xf2_NodeOffset] +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_xf2_GND);

#endif
  
  return bsuccess;
}


//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdQdx
// Purpose       :
// Special Notes : Load the dQdx ("dynamic jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdQdx()
{
  bool bsuccess = true;
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*q_bi_Equ_bx_Node_Ptr) +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bx_ei) +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bp);
  (*q_bi_Equ_bp_Node_Ptr) +=  -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_si_bp) -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bp);
  (*q_ei_Equ_bx_Node_Ptr) +=  +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bx_ei) +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bx_bp);
  (*q_ei_Equ_bp_Node_Ptr) +=  -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_si_bp) -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bx_bp);
  (*q_bi_Equ_si_Node_Ptr) +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_si_bp);
  (*q_ei_Equ_si_Node_Ptr) +=  +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_si_bp);
  (*q_bi_Equ_bi_Node_Ptr) +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei) +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci) +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_cx);
  (*q_bi_Equ_ci_Node_Ptr) +=  -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci);
  (*q_ei_Equ_bi_Node_Ptr) +=  +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei) +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci) +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_cx);
  (*q_ei_Equ_ci_Node_Ptr) +=  -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci);
  (*q_bi_Equ_ei_Node_Ptr) +=  -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei) -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bx_ei);
  (*q_ei_Equ_ei_Node_Ptr) +=  -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei) -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bx_ei);
  (*q_bi_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_Temp_dt_GND);
  (*q_ei_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_ei].dx(admsProbeID_Temp_dt_GND);
  (*q_bx_Equ_bi_Node_Ptr) +=  +dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ci) +dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ei);
  (*q_bx_Equ_ei_Node_Ptr) +=  -dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ei) -dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_ei);
  (*q_bx_Equ_ci_Node_Ptr) +=  -dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ci);
  (*q_bx_Equ_bx_Node_Ptr) +=  +dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bp) +dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_ei);
  (*q_bx_Equ_bp_Node_Ptr) +=  -dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bp);
  (*q_bx_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_bx].dx(admsProbeID_Temp_dt_GND);
  (*q_ci_Equ_bi_Node_Ptr) +=  +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci) +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei);
  (*q_ci_Equ_ei_Node_Ptr) +=  -dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei) -dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bx_ei);
  (*q_ci_Equ_ci_Node_Ptr) +=  -dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci);
  (*q_ci_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_ci].dx(admsProbeID_Temp_dt_GND);
  (*q_ci_Equ_bx_Node_Ptr) +=  +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bx_ei) +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bx_bp);
  (*q_ci_Equ_bp_Node_Ptr) +=  -dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_si_bp) -dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bx_bp);
  (*q_ci_Equ_si_Node_Ptr) +=  +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_si_bp);
  (*q_cx_Equ_bi_Node_Ptr) +=  +dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bi_cx) +dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ei) +dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ci);
  (*q_cx_Equ_ci_Node_Ptr) +=  -dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ci);
  (*q_cx_Equ_bx_Node_Ptr) +=  +dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bx_bp);
  (*q_cx_Equ_cx_Node_Ptr) +=  -dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bi_cx);
  (*q_cx_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_cx].dx(admsProbeID_Temp_dt_GND);
  (*q_bp_Equ_bi_Node_Ptr) +=  +dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ci) +dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ei);
  (*q_bp_Equ_ei_Node_Ptr) +=  -dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ei);
  (*q_bp_Equ_ci_Node_Ptr) +=  -dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ci);
  (*q_bp_Equ_bx_Node_Ptr) +=  +dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bp);
  (*q_bp_Equ_bp_Node_Ptr) +=  -dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_si_bp) -dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bp);
  (*q_bp_Equ_si_Node_Ptr) +=  +dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_si_bp);
  (*q_bp_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_bp].dx(admsProbeID_Temp_dt_GND);
  (*q_c_Equ_c_Node_Ptr) +=  -dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c);
  (*q_cx_Equ_ei_Node_Ptr) +=  -dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ei);
  (*q_cx_Equ_bp_Node_Ptr) +=  -dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bx_bp);
  (*q_b_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e);
  (*q_e_Equ_e_Node_Ptr) +=  -dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e);
  (*q_si_Equ_bp_Node_Ptr) +=  -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_bp);
  (*q_si_Equ_si_Node_Ptr) +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_bp);
  (*q_si_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_Temp_dt_GND);
  (*q_xf2_Equ_xf2_Node_Ptr) +=  +dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_xf2_GND);
  (*q_dt_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_dt].dx(admsProbeID_Temp_dt_GND);
  (*q_bi_Equ_cx_Node_Ptr) +=  -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_cx);
  (*q_ei_Equ_cx_Node_Ptr) +=  -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_cx);
  (*q_b_Equ_e_Node_Ptr) +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e);
  (*q_e_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e);
  (*q_b_Equ_c_Node_Ptr) +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c);
  (*q_c_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c);
  (*q_xf1_Equ_xf1_Node_Ptr) +=  +dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_xf1_GND);

#else
  //use the offsets instead of pointers
  dQdx[li_bi][A_bi_Equ_bx_NodeOffset] +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bx_ei) +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bp);
  dQdx[li_bi][A_bi_Equ_bp_NodeOffset] +=  -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_si_bp) -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bx_bp);
  dQdx[li_ei][A_ei_Equ_bx_NodeOffset] +=  +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bx_ei) +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bx_bp);
  dQdx[li_ei][A_ei_Equ_bp_NodeOffset] +=  -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_si_bp) -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bx_bp);
  dQdx[li_bi][A_bi_Equ_si_NodeOffset] +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_si_bp);
  dQdx[li_ei][A_ei_Equ_si_NodeOffset] +=  +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_si_bp);
  dQdx[li_bi][A_bi_Equ_bi_NodeOffset] +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei) +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci) +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_cx);
  dQdx[li_bi][A_bi_Equ_ci_NodeOffset] +=  -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci);
  dQdx[li_ei][A_ei_Equ_bi_NodeOffset] +=  +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei) +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci) +dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_cx);
  dQdx[li_ei][A_ei_Equ_ci_NodeOffset] +=  -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci);
  dQdx[li_bi][A_bi_Equ_ei_NodeOffset] +=  -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei) -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bx_ei);
  dQdx[li_ei][A_ei_Equ_ei_NodeOffset] +=  -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei) -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bx_ei);
  dQdx[li_bi][A_bi_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_Temp_dt_GND);
  dQdx[li_ei][A_ei_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_ei].dx(admsProbeID_Temp_dt_GND);
  dQdx[li_bx][A_bx_Equ_bi_NodeOffset] +=  +dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ci) +dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ei);
  dQdx[li_bx][A_bx_Equ_ei_NodeOffset] +=  -dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ei) -dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_ei);
  dQdx[li_bx][A_bx_Equ_ci_NodeOffset] +=  -dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bi_ci);
  dQdx[li_bx][A_bx_Equ_bx_NodeOffset] +=  +dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bp) +dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_ei);
  dQdx[li_bx][A_bx_Equ_bp_NodeOffset] +=  -dynamicContributions[admsNodeID_bx].dx(admsProbeID_V_bx_bp);
  dQdx[li_bx][A_bx_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_bx].dx(admsProbeID_Temp_dt_GND);
  dQdx[li_ci][A_ci_Equ_bi_NodeOffset] +=  +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci) +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei);
  dQdx[li_ci][A_ci_Equ_ei_NodeOffset] +=  -dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei) -dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bx_ei);
  dQdx[li_ci][A_ci_Equ_ci_NodeOffset] +=  -dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci);
  dQdx[li_ci][A_ci_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_ci].dx(admsProbeID_Temp_dt_GND);
  dQdx[li_ci][A_ci_Equ_bx_NodeOffset] +=  +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bx_ei) +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bx_bp);
  dQdx[li_ci][A_ci_Equ_bp_NodeOffset] +=  -dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_si_bp) -dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bx_bp);
  dQdx[li_ci][A_ci_Equ_si_NodeOffset] +=  +dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_si_bp);
  dQdx[li_cx][A_cx_Equ_bi_NodeOffset] +=  +dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bi_cx) +dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ei) +dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ci);
  dQdx[li_cx][A_cx_Equ_ci_NodeOffset] +=  -dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ci);
  dQdx[li_cx][A_cx_Equ_bx_NodeOffset] +=  +dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bx_bp);
  dQdx[li_cx][A_cx_Equ_cx_NodeOffset] +=  -dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bi_cx);
  dQdx[li_cx][A_cx_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_cx].dx(admsProbeID_Temp_dt_GND);
  dQdx[li_bp][A_bp_Equ_bi_NodeOffset] +=  +dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ci) +dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ei);
  dQdx[li_bp][A_bp_Equ_ei_NodeOffset] +=  -dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ei);
  dQdx[li_bp][A_bp_Equ_ci_NodeOffset] +=  -dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ci);
  dQdx[li_bp][A_bp_Equ_bx_NodeOffset] +=  +dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bp);
  dQdx[li_bp][A_bp_Equ_bp_NodeOffset] +=  -dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_si_bp) -dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bx_bp);
  dQdx[li_bp][A_bp_Equ_si_NodeOffset] +=  +dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_si_bp);
  dQdx[li_bp][A_bp_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_bp].dx(admsProbeID_Temp_dt_GND);
  dQdx[li_c][A_c_Equ_c_NodeOffset] +=  -dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c);
  dQdx[li_cx][A_cx_Equ_ei_NodeOffset] +=  -dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bi_ei);
  dQdx[li_cx][A_cx_Equ_bp_NodeOffset] +=  -dynamicContributions[admsNodeID_cx].dx(admsProbeID_V_bx_bp);
  dQdx[li_b][A_b_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e);
  dQdx[li_e][A_e_Equ_e_NodeOffset] +=  -dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e);
  dQdx[li_si][A_si_Equ_bp_NodeOffset] +=  -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_bp);
  dQdx[li_si][A_si_Equ_si_NodeOffset] +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_bp);
  dQdx[li_si][A_si_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_Temp_dt_GND);
  dQdx[li_xf2][A_xf2_Equ_xf2_NodeOffset] +=  +dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_xf2_GND);
  dQdx[li_dt][A_dt_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_dt].dx(admsProbeID_Temp_dt_GND);
  dQdx[li_bi][A_bi_Equ_cx_NodeOffset] +=  -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_cx);
  dQdx[li_ei][A_ei_Equ_cx_NodeOffset] +=  -dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_cx);
  dQdx[li_b][A_b_Equ_e_NodeOffset] +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e);
  dQdx[li_e][A_e_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e);
  dQdx[li_b][A_b_Equ_c_NodeOffset] +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c);
  dQdx[li_c][A_c_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c);
  dQdx[li_xf1][A_xf1_Equ_xf1_NodeOffset] +=  +dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_xf1_GND);

  
#endif
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateTemperature
// Purpose       : Set temperature and update any parameters that depend on it
// Special Notes : In Xyce ADMS, we'll simply copy the temperature, which is
//                 in Kelvin, to our "admsTemperature" variable, which needs
//                 to be in Celsius.
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateTemperature(const double & temperatureTemp)
{

  admsTemperature = temperatureTemp;
  adms_vt_nom = adms_vt(temperatureTemp);

  return true;
}

// Class Model
//-----------------------------------------------------------------------------
// Function      : Model::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Model::processParams()
{

  // Set any non-constant parameter defaults:
  // Set any parameters that were not given and whose defaults depend on other
  // parameters:

  // set internal model type based on model card type
  if (getType() == "pnp" || getType() == "PNP")
    VBICtype = -1;



  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

  //    Parameter type : [ (-1), 1 ]] 0, 0 [
  if ( (!((type >=(-1) && type <=1 )) || (type >0 && type <0 )) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter type value " << type << " out of range [ (-1), 1 ] or  ] 0, 0 [";
  }

  //    Parameter VBICtype : [ (-1), 1 ][ 0, 0 ]
  if ( (!((VBICtype >=(-1) && VBICtype <=1 )) || (VBICtype >=0 && VBICtype <=0 )) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter VBICtype value " << VBICtype << " out of range [ (-1), 1 ] or in excluded range [ 0, 0 ]";
  }

  //    Parameter scale : ] 0.0, 1.0 ]
  if ( (!((scale >0.0 && scale <=1.0 ))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter scale value " << scale << " out of range ] 0.0, 1.0 ]";
  }

  //    Parameter shrink : [ 0.0, 100.0 [
  if ( (!((shrink >=0.0 && shrink <100.0 ))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter shrink value " << shrink << " out of range [ 0.0, 100.0 [";
  }

  //    Parameter tmin : [ (-250.0), 27.0 ]
  if ( (!((tmin >=(-250.0) && tmin <=27.0 ))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter tmin value " << tmin << " out of range [ (-250.0), 27.0 ]";
  }

  //    Parameter tmax : [ 27.0, 1000.0 ]
  if ( (!((tmax >=27.0 && tmax <=1000.0 ))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter tmax value " << tmax << " out of range [ 27.0, 1000.0 ]";
  }

  //    Parameter gmin : [ 0.0,  (+inf) [
  if ( (!((gmin >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter gmin value " << gmin << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter pnjmaxi : ] 0.0,  (+inf) [
  if ( (!((pnjmaxi >0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter pnjmaxi value " << pnjmaxi << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter maxexp : ] 0.0,  (+inf) [
  if ( (!((maxexp >0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter maxexp value " << maxexp << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter tnom : [ (-250.0), 1000.0 ]
  if ( (!((tnom >=(-250.0) && tnom <=1000.0 ))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter tnom value " << tnom << " out of range [ (-250.0), 1000.0 ]";
  }

  //    Parameter tminclip : [ (-250.0), 27.0 ]
  if ( (!((tminclip >=(-250.0) && tminclip <=27.0 ))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter tminclip value " << tminclip << " out of range [ (-250.0), 27.0 ]";
  }

  //    Parameter tmaxclip : [ 27.0, 1000.0 ]
  if ( (!((tmaxclip >=27.0 && tmaxclip <=1000.0 ))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter tmaxclip value " << tmaxclip << " out of range [ 27.0, 1000.0 ]";
  }

  //    Parameter rcx : [ 0.0,  (+inf) [
  if ( (!((rcx >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter rcx value " << rcx << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter rci : [ 0.0,  (+inf) [
  if ( (!((rci >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter rci value " << rci << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter vo : [ 0.0,  (+inf) [
  if ( (!((vo >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter vo value " << vo << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter gamm : [ 0.0,  (+inf) [
  if ( (!((gamm >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter gamm value " << gamm << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter hrcf : [ 0.0,  (+inf) [
  if ( (!((hrcf >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter hrcf value " << hrcf << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter rbx : [ 0.0,  (+inf) [
  if ( (!((rbx >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter rbx value " << rbx << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter rbi : [ 0.0,  (+inf) [
  if ( (!((rbi >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter rbi value " << rbi << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter re : [ 0.0,  (+inf) [
  if ( (!((re >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter re value " << re << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter rs : [ 0.0,  (+inf) [
  if ( (!((rs >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter rs value " << rs << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter rbp : [ 0.0,  (+inf) [
  if ( (!((rbp >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter rbp value " << rbp << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter is : ] 0.0,  (+inf) [
  if ( (!((is >0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter is value " << is << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter isrr : ] 0.0,  (+inf) [
  if ( (!((isrr >0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter isrr value " << isrr << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter nf : ] 0.0,  (+inf) [
  if ( (!((nf >0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter nf value " << nf << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter nr : ] 0.0,  (+inf) [
  if ( (!((nr >0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter nr value " << nr << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter qbm : [ 0, 1 ]
  if ( (!((qbm >=0 && qbm <=1 ))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter qbm value " << qbm << " out of range [ 0, 1 ]";
  }

  //    Parameter isp : [ 0.0,  (+inf) [
  if ( (!((isp >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter isp value " << isp << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter wsp : [ 0.0, 1.0 ]
  if ( (!((wsp >=0.0 && wsp <=1.0 ))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter wsp value " << wsp << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter nfp : ] 0.0,  (+inf) [
  if ( (!((nfp >0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter nfp value " << nfp << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter fc : [ 0.0, 1.0 [
  if ( (!((fc >=0.0 && fc <1.0 ))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter fc value " << fc << " out of range [ 0.0, 1.0 [";
  }

  //    Parameter cbeo : [ 0.0,  (+inf) [
  if ( (!((cbeo >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter cbeo value " << cbeo << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter cje : [ 0.0,  (+inf) [
  if ( (!((cje >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter cje value " << cje << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter pe : ] 0.0,  (+inf) [
  if ( (!((pe >0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter pe value " << pe << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter me : ] 0.0, 1.0 ]
  if ( (!((me >0.0 && me <=1.0 ))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter me value " << me << " out of range ] 0.0, 1.0 ]";
  }

  //    Parameter cbco : [ 0.0,  (+inf) [
  if ( (!((cbco >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter cbco value " << cbco << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter cjc : [ 0.0,  (+inf) [
  if ( (!((cjc >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter cjc value " << cjc << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter pc : ] 0.0,  (+inf) [
  if ( (!((pc >0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter pc value " << pc << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter mc : ] 0.0, 1.0 ]
  if ( (!((mc >0.0 && mc <=1.0 ))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter mc value " << mc << " out of range ] 0.0, 1.0 ]";
  }

  //    Parameter vrt : [ 0.0,  (+inf) [
  if ( (!((vrt >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter vrt value " << vrt << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter art : ] 0.0,  (+inf) [
  if ( (!((art >0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter art value " << art << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter qco : [ 0.0,  (+inf) [
  if ( (!((qco >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter qco value " << qco << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter cjep : [ 0.0,  (+inf) [
  if ( (!((cjep >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter cjep value " << cjep << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter cjcp : [ 0.0,  (+inf) [
  if ( (!((cjcp >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter cjcp value " << cjcp << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter ps : ] 0.0,  (+inf) [
  if ( (!((ps >0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter ps value " << ps << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter ms : ] 0.0, 1.0 ]
  if ( (!((ms >0.0 && ms <=1.0 ))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter ms value " << ms << " out of range ] 0.0, 1.0 ]";
  }

  //    Parameter ccso : [ 0.0,  (+inf) [
  if ( (!((ccso >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter ccso value " << ccso << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter ibei : [ 0.0,  (+inf) [
  if ( (!((ibei >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter ibei value " << ibei << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter wbe : [ 0.0, 1.0 ]
  if ( (!((wbe >=0.0 && wbe <=1.0 ))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter wbe value " << wbe << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter nei : ] 0.0,  (+inf) [
  if ( (!((nei >0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter nei value " << nei << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter qnibeir : [ 0.0, 1.0 ]
  if ( (!((qnibeir >=0.0 && qnibeir <=1.0 ))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter qnibeir value " << qnibeir << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter iben : [ 0.0,  (+inf) [
  if ( (!((iben >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter iben value " << iben << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter nen : ] nei,  (+inf) [
  if ( (!((nen >nei))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter nen value " << nen << " out of range ] nei,  (+inf) [";
  }

  //    Parameter ibci : [ 0.0,  (+inf) [
  if ( (!((ibci >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter ibci value " << ibci << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter nci : ] 0.0,  (+inf) [
  if ( (!((nci >0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter nci value " << nci << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter ibcn : [ 0.0,  (+inf) [
  if ( (!((ibcn >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter ibcn value " << ibcn << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter ncn : ] nci,  (+inf) [
  if ( (!((ncn >nci))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter ncn value " << ncn << " out of range ] nci,  (+inf) [";
  }

  //    Parameter ibeip : [ 0.0,  (+inf) [
  if ( (!((ibeip >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter ibeip value " << ibeip << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter ibenp : [ 0.0,  (+inf) [
  if ( (!((ibenp >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter ibenp value " << ibenp << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter ibcip : [ 0.0,  (+inf) [
  if ( (!((ibcip >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter ibcip value " << ibcip << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter ncip : ] 0.0,  (+inf) [
  if ( (!((ncip >0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter ncip value " << ncip << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter ibcnp : [ 0.0,  (+inf) [
  if ( (!((ibcnp >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter ibcnp value " << ibcnp << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter ncnp : ] ncip,  (+inf) [
  if ( (!((ncnp >ncip))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter ncnp value " << ncnp << " out of range ] ncip,  (+inf) [";
  }

  //    Parameter vef : [ 0.0,  (+inf) [
  if ( (!((vef >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter vef value " << vef << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter ver : [ 0.0,  (+inf) [
  if ( (!((ver >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter ver value " << ver << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter ikf : [ 0.0,  (+inf) [
  if ( (!((ikf >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter ikf value " << ikf << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter nkf : ] 0.0,  (+inf) [
  if ( (!((nkf >0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter nkf value " << nkf << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter ikr : [ 0.0,  (+inf) [
  if ( (!((ikr >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter ikr value " << ikr << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter ikp : [ 0.0,  (+inf) [
  if ( (!((ikp >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter ikp value " << ikp << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter tf : [ 0.0,  (+inf) [
  if ( (!((tf >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter tf value " << tf << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter qtf : [ 0.0,  (+inf) [
  if ( (!((qtf >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter qtf value " << qtf << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter xtf : [ 0.0,  (+inf) [
  if ( (!((xtf >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter xtf value " << xtf << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter vtf : [ 0.0,  (+inf) [
  if ( (!((vtf >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter vtf value " << vtf << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter itf : [ 0.0,  (+inf) [
  if ( (!((itf >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter itf value " << itf << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter tr : [ 0.0,  (+inf) [
  if ( (!((tr >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter tr value " << tr << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter td : [ 0.0,  (+inf) [
  if ( (!((td >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter td value " << td << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter avc1 : [ 0.0,  (+inf) [
  if ( (!((avc1 >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter avc1 value " << avc1 << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter avc2 : [ 0.0,  (+inf) [
  if ( (!((avc2 >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter avc2 value " << avc2 << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter avcx1 : [ 0.0,  (+inf) [
  if ( (!((avcx1 >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter avcx1 value " << avcx1 << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter avcx2 : [ 0.0,  (+inf) [
  if ( (!((avcx2 >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter avcx2 value " << avcx2 << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter mcx : ] 0.0, 1.0 ]
  if ( (!((mcx >0.0 && mcx <=1.0 ))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter mcx value " << mcx << " out of range ] 0.0, 1.0 ]";
  }

  //    Parameter vbbe : [ 0.0,  (+inf) [
  if ( (!((vbbe >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter vbbe value " << vbbe << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter nbbe : ] 0.0,  (+inf) [
  if ( (!((nbbe >0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter nbbe value " << nbbe << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter ibbe : ] 0.0,  (+inf) [
  if ( (!((ibbe >0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter ibbe value " << ibbe << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter vpte : [ 0.0,  (+inf) [
  if ( (!((vpte >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter vpte value " << vpte << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter ibk0 : [ 0.0,  (+inf) [
  if ( (!((ibk0 >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter ibk0 value " << ibk0 << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter abk : ] 0.0,  (+inf) [
  if ( (!((abk >0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter abk value " << abk << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter bbk : [ 0.0,  (+inf) [
  if ( (!((bbk >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter bbk value " << bbk << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter kfn : [ 0.0,  (+inf) [
  if ( (!((kfn >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter kfn value " << kfn << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter afn : ] 0.0,  (+inf) [
  if ( (!((afn >0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter afn value " << afn << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter bfn : ] 0.0,  (+inf) [
  if ( (!((bfn >0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter bfn value " << bfn << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter rth : [ 0.0,  (+inf) [
  if ( (!((rth >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter rth value " << rth << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter cth : [ 0.0,  (+inf) [
  if ( (!((cth >=0.0))) )
  {
    UserError0(*this) << "ADMSvbic13_4t: Parameter cth value " << cth << " out of range [ 0.0,  (+inf) [";
  }

  // and of course, this routine is where we should put the initial_model
  // stuff
  double shrinkL;
  double scaleFac;
  //Begin block initial_model
  {
    scaleFac = scale;
    shrinkL = (1.0-(0.01*shrink));
    if (given("gmin"))
    {
      gminMod = gmin;
    }
    else
    {
      gminMod = getDeviceOptions().gmin;
    }
    if (given("pnjmaxi"))
    {
      imaxMod = pnjmaxi;
    }
    else
    {
      imaxMod = 1.0;
    }
    if (given("npn"))
    {
      VBICtype = 1.0;
    }
    else
    {
      if (given("pnp"))
      {
        VBICtype = (-1.0);
      }
      else
      {
        if (given("type"))
        {
          VBICtype = (-type);
        }
      }
    }
    VmaxExp = log(maxexp);
    Iikr = ((ikr>0.0)?(1.0/ikr):0.0);
    Iikp = ((ikp>0.0)?(1.0/ikp):0.0);
    Ihrcf = ((hrcf>0.0)?(1.0/hrcf):0.0);
    Ivtf = ((vtf>0.0)?(1.0/vtf):0.0);
    Iitf = ((itf>0.0)?(1.0/itf):0.0);
    sltf = ((itf>0.0)?0.0:1.0);
    tiniK = (273.15+tnom);
  }
  // End block initial_model


  return true;
}
//----------------------------------------------------------------------------
// Function      : Model::processInstanceParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//----------------------------------------------------------------------------
bool Model::processInstanceParams()
{

  std::vector<Instance*>::iterator iter;
  std::vector<Instance*>::iterator first = instanceContainer.begin();
  std::vector<Instance*>::iterator last  = instanceContainer.end();

  for (iter=first; iter!=last; ++iter)
  {
    (*iter)->processParams();
  }

  return true;
}

//-----------------------------------------------------------------------------
// Function      : Model::Model
// Purpose       : model block constructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::Model(
   const Configuration & configuration,
   const ModelBlock &    model_block,
   const FactoryBlock &  factory_block)
  : DeviceModel(model_block, configuration.getModelParameters(), factory_block),
    npn(0.0),
    pnp(0.0),
    type((-1)),
    VBICtype(1),
    scale(1.0),
    shrink(0.0),
    tmin((-100.0)),
    tmax(500.0),
    gmin(1.0e-12),
    pnjmaxi(1.0),
    maxexp(1.0e22),
    tnom(27.0),
    tminclip((-100.0)),
    tmaxclip(500.0),
    rcx(0.0),
    rci(0.0),
    vo(0.0),
    gamm(0.0),
    hrcf(0.0),
    rbx(0.0),
    rbi(0.0),
    re(0.0),
    rs(0.0),
    rbp(0.0),
    is(1.0e-16),
    isrr(1.0),
    nf(1.0),
    nr(1.0),
    qbm(0),
    isp(0.0),
    wsp(1.0),
    nfp(1.0),
    fc(0.9),
    cbeo(0.0),
    cje(0.0),
    pe(0.75),
    me(0.33),
    aje((-0.5)),
    cbco(0.0),
    cjc(0.0),
    pc(0.75),
    mc(0.33),
    ajc((-0.5)),
    vrt(0.0),
    art(0.1),
    qco(0.0),
    cjep(0.0),
    cjcp(0.0),
    ps(0.75),
    ms(0.33),
    ajs((-0.5)),
    ccso(0.0),
    ibei(1.0e-18),
    wbe(1.0),
    nei(1.0),
    qnibeir(0.0),
    iben(0.0),
    nen(2.0),
    ibci(1.0e-16),
    nci(1.0),
    ibcn(0.0),
    ncn(2.0),
    ibeip(0.0),
    ibenp(0.0),
    ibcip(0.0),
    ncip(1.0),
    ibcnp(0.0),
    ncnp(2.0),
    vef(0.0),
    ver(0.0),
    ikf(0.0),
    nkf(0.5),
    ikr(0.0),
    ikp(0.0),
    tf(0.0),
    qtf(0.0),
    xtf(0.0),
    vtf(0.0),
    itf(0.0),
    tr(0.0),
    td(0.0),
    avc1(0.0),
    avc2(0.0),
    avcx1(0.0),
    avcx2(0.0),
    mcx(0.33),
    vbbe(0.0),
    nbbe(1.0),
    ibbe(1.0e-06),
    tvbbe1(0.0),
    tvbbe2(0.0),
    tnbbe(0.0),
    vpte(0.0),
    ibk0(0.0),
    abk(1.0),
    bbk(0.0),
    kfn(0.0),
    afn(1.0),
    bfn(1.0),
    rth(0.0),
    cth(0.0),
    xre(0.0),
    xrb(0.0),
    xrbi(0.0),
    xrbx(0.0),
    xrc(0.0),
    xrci(0.0),
    xrcx(0.0),
    xrbp(0.0),
    xrs(0.0),
    xvo(0.0),
    ea(1.12),
    eaie(1.12),
    eaic(1.12),
    eais(1.12),
    eane(1.12),
    eanc(1.12),
    eans(1.12),
    eap(1.12),
    dear(0.0),
    xis(3.0),
    xii(3.0),
    xin(3.0),
    xisr(0.0),
    xikf(0.0),
    tavc(0.0),
    tavcx(0.0),
    tnf(0.0),
    tcvef(0.0),
    tcver(0.0),
    tcrth(0.0),
    tiniK(0.0),
    Iikr(0.0),
    Iikp(0.0),
    Ihrcf(0.0),
    Ivtf(0.0),
    Iitf(0.0),
    sltf(0.0),
    VmaxExp(0.0),
    gminMod(0.0),
    imaxMod(0.0)
{
  // Set params to constant default values (from parTable):
  setDefaultParams();

  // Set params according to .model line and constant defaults from metadata:
  setModParams(model_block.params);

  if (!given("XYCEADMSMODTEMP"))
    admsModTemp=getDeviceOptions().temp.getImmutableValue<double>();

  // Calculate any parameters specified as expressions:

  updateDependentParameters();

  // calculate dependent (ie computed) params and check for errors:
  processParams();
}

//-----------------------------------------------------------------------------
// Function      : Model::~Model
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::~Model()
{
  std::vector<Instance*>::iterator iterI;
  std::vector<Instance*>::iterator firstI = instanceContainer.begin ();
  std::vector<Instance*>::iterator lastI  = instanceContainer.end ();

  // loop over instances:
  for (iterI = firstI; iterI != lastI; ++iterI)
  {
    delete (*iterI);
  }
}

//-----------------------------------------------------------------------------
// Function      : Model::printOutInstances
// Purpose       : debugging tool.
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
std::ostream &Model::printOutInstances(std::ostream &os) const
{
  std::vector<Instance*>::const_iterator iter;
  std::vector<Instance*>::const_iterator first = instanceContainer.begin();
  std::vector<Instance*>::const_iterator last  = instanceContainer.end();

  int i;
  os << std::endl;
  os << "    name     model name  Parameters" << std::endl;
  for (i=0, iter=first; iter!=last; ++iter, ++i)
  {
    os << "  " << i << ": " << (*iter)->getName() << "      ";
    os << getName();

    os << std::endl;
    os << "M  =  " << (*iter)->m << std::endl;
    os << "TRISE  =  " << (*iter)->trise << std::endl;
    os << "SW_NOISE  =  " << (*iter)->sw_noise << std::endl;
    os << "SW_ET  =  " << (*iter)->sw_et << std::endl;
    os << std::endl;
  }

  os << std::endl;

  return os;
}

//-----------------------------------------------------------------------------
// Function      : Model::forEachInstance
// Purpose       : 
// Special Notes :
// Scope         : public
// Creator       : David Baur
// Creation Date : 2/4/2014
//-----------------------------------------------------------------------------
/// Apply a device instance "op" to all instances associated with this
/// model
/// 
/// @param[in] op Operator to apply to all instances.
/// 
/// 
void Model::forEachInstance(DeviceInstanceOp &op) const /* override */ 
{
  for (std::vector<Instance *>::const_iterator it = instanceContainer.begin(); it != instanceContainer.end(); ++it)
    op(*it);
}

Device *Traits::factory(const Configuration &configuration, const FactoryBlock &factory_block)
{
  return new DeviceMaster<Traits>(configuration, factory_block, factory_block.solverState_, factory_block.deviceOptions_);
}

void registerDevice()
{
  Config<Traits>::addConfiguration()
    .registerDevice("q", 12)
    .registerModelType("npn", 12)
    .registerModelType("pnp", 12);
}



#ifdef Xyce_ADMS_SENSITIVITIES
//-----------------------------------------------------------------------------
// Function      : evaluateInitialInstance
// Purpose       : Evaluate the statements in the initial_instance block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
void evaluateInitialInstance(
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_m,
   bool instancePar_given_m,
   AdmsSensFadType & instancePar_trise,
   bool instancePar_given_trise,
   // non-reals(including hidden)
   int instancePar_sw_noise,
   bool instancePar_given_sw_noise,
   int instancePar_sw_et,
   bool instancePar_given_sw_et,
   // instance variables
   // reals
   AdmsSensFadType & instanceVar_is_t,
   AdmsSensFadType & instanceVar_isrr_t,
   AdmsSensFadType & instanceVar_ibei_t,
   AdmsSensFadType & instanceVar_ibci_t,
   AdmsSensFadType & instanceVar_isp_t,
   AdmsSensFadType & instanceVar_iben_t,
   AdmsSensFadType & instanceVar_ibcn_t,
   AdmsSensFadType & instanceVar_ibeip_t,
   AdmsSensFadType & instanceVar_ibenp_t,
   AdmsSensFadType & instanceVar_ibcip_t,
   AdmsSensFadType & instanceVar_ibcnp_t,
   AdmsSensFadType & instanceVar_tdevC,
   AdmsSensFadType & instanceVar_tdevK,
   AdmsSensFadType & instanceVar_rT,
   AdmsSensFadType & instanceVar_Gcx,
   AdmsSensFadType & instanceVar_Gci,
   AdmsSensFadType & instanceVar_Gbx,
   AdmsSensFadType & instanceVar_Gbi,
   AdmsSensFadType & instanceVar_Ge,
   AdmsSensFadType & instanceVar_Gbp,
   AdmsSensFadType & instanceVar_Gs,
   AdmsSensFadType & instanceVar_maxvIfi,
   AdmsSensFadType & instanceVar_maxvIri,
   AdmsSensFadType & instanceVar_maxvIp,
   AdmsSensFadType & instanceVar_maxvIbbe,
   AdmsSensFadType & instanceVar_maxvIbei,
   AdmsSensFadType & instanceVar_maxvIben,
   AdmsSensFadType & instanceVar_maxvIbci,
   AdmsSensFadType & instanceVar_maxvIbcn,
   AdmsSensFadType & instanceVar_maxvIbeip,
   AdmsSensFadType & instanceVar_maxvIbenp,
   AdmsSensFadType & instanceVar_maxvIbcip,
   AdmsSensFadType & instanceVar_maxvIbcnp,
   AdmsSensFadType & instanceVar_vtv,
   AdmsSensFadType & instanceVar_Itzf,
   AdmsSensFadType & instanceVar_qb,
   AdmsSensFadType & instanceVar_Iccp,
   AdmsSensFadType & instanceVar_qbp,
   AdmsSensFadType & instanceVar_Ibe,
   AdmsSensFadType & instanceVar_Ibex,
   AdmsSensFadType & instanceVar_Ibep,
   AdmsSensFadType & instanceVar_Irci,
   AdmsSensFadType & instanceVar_Vrci,
   AdmsSensFadType & instanceVar_mMod,
   AdmsSensFadType & instanceVar_tVCrit,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_npn,
   bool modelPar_given_npn,
   AdmsSensFadType & modelPar_pnp,
   bool modelPar_given_pnp,
   AdmsSensFadType & modelPar_scale,
   bool modelPar_given_scale,
   AdmsSensFadType & modelPar_shrink,
   bool modelPar_given_shrink,
   AdmsSensFadType & modelPar_tmin,
   bool modelPar_given_tmin,
   AdmsSensFadType & modelPar_tmax,
   bool modelPar_given_tmax,
   AdmsSensFadType & modelPar_gmin,
   bool modelPar_given_gmin,
   AdmsSensFadType & modelPar_pnjmaxi,
   bool modelPar_given_pnjmaxi,
   AdmsSensFadType & modelPar_maxexp,
   bool modelPar_given_maxexp,
   AdmsSensFadType & modelPar_tnom,
   bool modelPar_given_tnom,
   AdmsSensFadType & modelPar_tminclip,
   bool modelPar_given_tminclip,
   AdmsSensFadType & modelPar_tmaxclip,
   bool modelPar_given_tmaxclip,
   AdmsSensFadType & modelPar_rcx,
   bool modelPar_given_rcx,
   AdmsSensFadType & modelPar_rci,
   bool modelPar_given_rci,
   AdmsSensFadType & modelPar_vo,
   bool modelPar_given_vo,
   AdmsSensFadType & modelPar_gamm,
   bool modelPar_given_gamm,
   AdmsSensFadType & modelPar_hrcf,
   bool modelPar_given_hrcf,
   AdmsSensFadType & modelPar_rbx,
   bool modelPar_given_rbx,
   AdmsSensFadType & modelPar_rbi,
   bool modelPar_given_rbi,
   AdmsSensFadType & modelPar_re,
   bool modelPar_given_re,
   AdmsSensFadType & modelPar_rs,
   bool modelPar_given_rs,
   AdmsSensFadType & modelPar_rbp,
   bool modelPar_given_rbp,
   AdmsSensFadType & modelPar_is,
   bool modelPar_given_is,
   AdmsSensFadType & modelPar_isrr,
   bool modelPar_given_isrr,
   AdmsSensFadType & modelPar_nf,
   bool modelPar_given_nf,
   AdmsSensFadType & modelPar_nr,
   bool modelPar_given_nr,
   AdmsSensFadType & modelPar_isp,
   bool modelPar_given_isp,
   AdmsSensFadType & modelPar_wsp,
   bool modelPar_given_wsp,
   AdmsSensFadType & modelPar_nfp,
   bool modelPar_given_nfp,
   AdmsSensFadType & modelPar_fc,
   bool modelPar_given_fc,
   AdmsSensFadType & modelPar_cbeo,
   bool modelPar_given_cbeo,
   AdmsSensFadType & modelPar_cje,
   bool modelPar_given_cje,
   AdmsSensFadType & modelPar_pe,
   bool modelPar_given_pe,
   AdmsSensFadType & modelPar_me,
   bool modelPar_given_me,
   AdmsSensFadType & modelPar_aje,
   bool modelPar_given_aje,
   AdmsSensFadType & modelPar_cbco,
   bool modelPar_given_cbco,
   AdmsSensFadType & modelPar_cjc,
   bool modelPar_given_cjc,
   AdmsSensFadType & modelPar_pc,
   bool modelPar_given_pc,
   AdmsSensFadType & modelPar_mc,
   bool modelPar_given_mc,
   AdmsSensFadType & modelPar_ajc,
   bool modelPar_given_ajc,
   AdmsSensFadType & modelPar_vrt,
   bool modelPar_given_vrt,
   AdmsSensFadType & modelPar_art,
   bool modelPar_given_art,
   AdmsSensFadType & modelPar_qco,
   bool modelPar_given_qco,
   AdmsSensFadType & modelPar_cjep,
   bool modelPar_given_cjep,
   AdmsSensFadType & modelPar_cjcp,
   bool modelPar_given_cjcp,
   AdmsSensFadType & modelPar_ps,
   bool modelPar_given_ps,
   AdmsSensFadType & modelPar_ms,
   bool modelPar_given_ms,
   AdmsSensFadType & modelPar_ajs,
   bool modelPar_given_ajs,
   AdmsSensFadType & modelPar_ccso,
   bool modelPar_given_ccso,
   AdmsSensFadType & modelPar_ibei,
   bool modelPar_given_ibei,
   AdmsSensFadType & modelPar_wbe,
   bool modelPar_given_wbe,
   AdmsSensFadType & modelPar_nei,
   bool modelPar_given_nei,
   AdmsSensFadType & modelPar_qnibeir,
   bool modelPar_given_qnibeir,
   AdmsSensFadType & modelPar_iben,
   bool modelPar_given_iben,
   AdmsSensFadType & modelPar_nen,
   bool modelPar_given_nen,
   AdmsSensFadType & modelPar_ibci,
   bool modelPar_given_ibci,
   AdmsSensFadType & modelPar_nci,
   bool modelPar_given_nci,
   AdmsSensFadType & modelPar_ibcn,
   bool modelPar_given_ibcn,
   AdmsSensFadType & modelPar_ncn,
   bool modelPar_given_ncn,
   AdmsSensFadType & modelPar_ibeip,
   bool modelPar_given_ibeip,
   AdmsSensFadType & modelPar_ibenp,
   bool modelPar_given_ibenp,
   AdmsSensFadType & modelPar_ibcip,
   bool modelPar_given_ibcip,
   AdmsSensFadType & modelPar_ncip,
   bool modelPar_given_ncip,
   AdmsSensFadType & modelPar_ibcnp,
   bool modelPar_given_ibcnp,
   AdmsSensFadType & modelPar_ncnp,
   bool modelPar_given_ncnp,
   AdmsSensFadType & modelPar_vef,
   bool modelPar_given_vef,
   AdmsSensFadType & modelPar_ver,
   bool modelPar_given_ver,
   AdmsSensFadType & modelPar_ikf,
   bool modelPar_given_ikf,
   AdmsSensFadType & modelPar_nkf,
   bool modelPar_given_nkf,
   AdmsSensFadType & modelPar_ikr,
   bool modelPar_given_ikr,
   AdmsSensFadType & modelPar_ikp,
   bool modelPar_given_ikp,
   AdmsSensFadType & modelPar_tf,
   bool modelPar_given_tf,
   AdmsSensFadType & modelPar_qtf,
   bool modelPar_given_qtf,
   AdmsSensFadType & modelPar_xtf,
   bool modelPar_given_xtf,
   AdmsSensFadType & modelPar_vtf,
   bool modelPar_given_vtf,
   AdmsSensFadType & modelPar_itf,
   bool modelPar_given_itf,
   AdmsSensFadType & modelPar_tr,
   bool modelPar_given_tr,
   AdmsSensFadType & modelPar_td,
   bool modelPar_given_td,
   AdmsSensFadType & modelPar_avc1,
   bool modelPar_given_avc1,
   AdmsSensFadType & modelPar_avc2,
   bool modelPar_given_avc2,
   AdmsSensFadType & modelPar_avcx1,
   bool modelPar_given_avcx1,
   AdmsSensFadType & modelPar_avcx2,
   bool modelPar_given_avcx2,
   AdmsSensFadType & modelPar_mcx,
   bool modelPar_given_mcx,
   AdmsSensFadType & modelPar_vbbe,
   bool modelPar_given_vbbe,
   AdmsSensFadType & modelPar_nbbe,
   bool modelPar_given_nbbe,
   AdmsSensFadType & modelPar_ibbe,
   bool modelPar_given_ibbe,
   AdmsSensFadType & modelPar_tvbbe1,
   bool modelPar_given_tvbbe1,
   AdmsSensFadType & modelPar_tvbbe2,
   bool modelPar_given_tvbbe2,
   AdmsSensFadType & modelPar_tnbbe,
   bool modelPar_given_tnbbe,
   AdmsSensFadType & modelPar_vpte,
   bool modelPar_given_vpte,
   AdmsSensFadType & modelPar_ibk0,
   bool modelPar_given_ibk0,
   AdmsSensFadType & modelPar_abk,
   bool modelPar_given_abk,
   AdmsSensFadType & modelPar_bbk,
   bool modelPar_given_bbk,
   AdmsSensFadType & modelPar_kfn,
   bool modelPar_given_kfn,
   AdmsSensFadType & modelPar_afn,
   bool modelPar_given_afn,
   AdmsSensFadType & modelPar_bfn,
   bool modelPar_given_bfn,
   AdmsSensFadType & modelPar_rth,
   bool modelPar_given_rth,
   AdmsSensFadType & modelPar_cth,
   bool modelPar_given_cth,
   AdmsSensFadType & modelPar_xre,
   bool modelPar_given_xre,
   AdmsSensFadType & modelPar_xrb,
   bool modelPar_given_xrb,
   AdmsSensFadType & modelPar_xrbi,
   bool modelPar_given_xrbi,
   AdmsSensFadType & modelPar_xrbx,
   bool modelPar_given_xrbx,
   AdmsSensFadType & modelPar_xrc,
   bool modelPar_given_xrc,
   AdmsSensFadType & modelPar_xrci,
   bool modelPar_given_xrci,
   AdmsSensFadType & modelPar_xrcx,
   bool modelPar_given_xrcx,
   AdmsSensFadType & modelPar_xrbp,
   bool modelPar_given_xrbp,
   AdmsSensFadType & modelPar_xrs,
   bool modelPar_given_xrs,
   AdmsSensFadType & modelPar_xvo,
   bool modelPar_given_xvo,
   AdmsSensFadType & modelPar_ea,
   bool modelPar_given_ea,
   AdmsSensFadType & modelPar_eaie,
   bool modelPar_given_eaie,
   AdmsSensFadType & modelPar_eaic,
   bool modelPar_given_eaic,
   AdmsSensFadType & modelPar_eais,
   bool modelPar_given_eais,
   AdmsSensFadType & modelPar_eane,
   bool modelPar_given_eane,
   AdmsSensFadType & modelPar_eanc,
   bool modelPar_given_eanc,
   AdmsSensFadType & modelPar_eans,
   bool modelPar_given_eans,
   AdmsSensFadType & modelPar_eap,
   bool modelPar_given_eap,
   AdmsSensFadType & modelPar_dear,
   bool modelPar_given_dear,
   AdmsSensFadType & modelPar_xis,
   bool modelPar_given_xis,
   AdmsSensFadType & modelPar_xii,
   bool modelPar_given_xii,
   AdmsSensFadType & modelPar_xin,
   bool modelPar_given_xin,
   AdmsSensFadType & modelPar_xisr,
   bool modelPar_given_xisr,
   AdmsSensFadType & modelPar_xikf,
   bool modelPar_given_xikf,
   AdmsSensFadType & modelPar_tavc,
   bool modelPar_given_tavc,
   AdmsSensFadType & modelPar_tavcx,
   bool modelPar_given_tavcx,
   AdmsSensFadType & modelPar_tnf,
   bool modelPar_given_tnf,
   AdmsSensFadType & modelPar_tcvef,
   bool modelPar_given_tcvef,
   AdmsSensFadType & modelPar_tcver,
   bool modelPar_given_tcver,
   AdmsSensFadType & modelPar_tcrth,
   bool modelPar_given_tcrth,
   // non-reals (including hidden)
   int modelPar_type,
   bool modelPar_given_type,
   int modelPar_VBICtype,
   int modelPar_qbm,
   bool modelPar_given_qbm// model variables
   ,
   // reals
   AdmsSensFadType & modelVar_tiniK,
   AdmsSensFadType & modelVar_Iikr,
   AdmsSensFadType & modelVar_Iikp,
   AdmsSensFadType & modelVar_Ihrcf,
   AdmsSensFadType & modelVar_Ivtf,
   AdmsSensFadType & modelVar_Iitf,
   AdmsSensFadType & modelVar_sltf,
   AdmsSensFadType & modelVar_VmaxExp,
   AdmsSensFadType & modelVar_gminMod,
   AdmsSensFadType & modelVar_imaxMod,
   double admsTemperature, double adms_vt_nom, double gmin, const Instance & theInstance)
{
  //Begin block initial_instance
  {
    instanceVar_mMod = instancePar_m;
    instanceVar_tdevC = ((admsTemperature+instancePar_trise)-273.15);
    if ((instanceVar_tdevC<modelPar_tmin))
    {
      std::cerr  << "WARNING: ambient temperature is lower than allowed minimum" <<  std::endl; 
    }
    if ((instanceVar_tdevC>modelPar_tmax))
    {
      std::cerr  << "WARNING: ambient temperature is higher than allowed maximum" <<  std::endl; 
    }
    if ((instanceVar_tdevC<(modelPar_tminclip+1.0)))
    {
      instanceVar_tdevC = (modelPar_tminclip+exp(((instanceVar_tdevC-modelPar_tminclip)-1.0)));
    }
    else
    {
      if ((instanceVar_tdevC>(modelPar_tmaxclip-1.0)))
      {
        instanceVar_tdevC = (modelPar_tmaxclip-exp(((modelPar_tmaxclip-instanceVar_tdevC)-1.0)));
      }
      else
      {
        instanceVar_tdevC = instanceVar_tdevC;
      }
    }
    instanceVar_tdevK = (instanceVar_tdevC+273.15);
    instanceVar_vtv = ((1.380662e-23*instanceVar_tdevK)/1.602189e-19);
    instanceVar_rT = (instanceVar_tdevK/modelVar_tiniK);
    instanceVar_tVCrit = (adms_vt(admsTemperature)*log((adms_vt(admsTemperature)/(1.41421356237309504880*modelPar_is))));
    if ((modelPar_ibbe>0.0))
    {
      instanceVar_maxvIbbe = ((modelPar_nbbe*instanceVar_vtv)*log((exp(((-modelPar_vbbe)/(modelPar_nbbe*instanceVar_vtv)))+(modelVar_imaxMod/modelPar_ibbe))));
    }
    else
    {
      instanceVar_maxvIbbe = 0.0;
    }
    instanceVar_is_t = ((modelPar_is*pow(instanceVar_rT,(modelPar_xis/modelPar_nf)))*exp((((-modelPar_ea)*(1.0-instanceVar_rT))/(instanceVar_vtv*modelPar_nf))));
    if ((instanceVar_is_t>0.0))
    {
      if (((modelPar_ikf>0.0)&&(modelVar_imaxMod>modelPar_ikf)))
      {
        instanceVar_maxvIfi = ((modelPar_nf*instanceVar_vtv)*log((1.0+(pow(((0.5*modelVar_imaxMod)*pow((4.0/modelPar_ikf),modelPar_nkf)),(1.0/(1.0-modelPar_nkf)))/instanceVar_is_t))));
      }
      else
      {
        instanceVar_maxvIfi = ((modelPar_nf*instanceVar_vtv)*log((1.0+(modelVar_imaxMod/instanceVar_is_t))));
      }
    }
    else
    {
      instanceVar_maxvIfi = 0.0;
    }
    instanceVar_isrr_t = ((modelPar_isrr*pow(instanceVar_rT,(modelPar_xisr/modelPar_nr)))*exp((((-modelPar_dear)*(1.0-instanceVar_rT))/(instanceVar_vtv*modelPar_nr))));
    if (((instanceVar_is_t>0.0)&&(instanceVar_isrr_t>0.0)))
    {
      if (((modelPar_ikr>0.0)&&(modelVar_imaxMod>modelPar_ikr)))
      {
        instanceVar_maxvIri = ((modelPar_nr*instanceVar_vtv)*log((1.0+(pow(((0.5*modelVar_imaxMod)*pow((4.0/modelPar_ikr),modelPar_nkf)),(1.0/(1.0-modelPar_nkf)))/(instanceVar_is_t*instanceVar_isrr_t)))));
      }
      else
      {
        instanceVar_maxvIri = ((modelPar_nr*instanceVar_vtv)*log((1.0+(modelVar_imaxMod/(instanceVar_is_t*instanceVar_isrr_t)))));
      }
    }
    else
    {
      instanceVar_maxvIri = 0.0;
    }
    instanceVar_isp_t = ((modelPar_isp*pow(instanceVar_rT,(modelPar_xis/modelPar_nfp)))*exp((((-modelPar_eap)*(1.0-instanceVar_rT))/(instanceVar_vtv*modelPar_nfp))));
    if ((instanceVar_isp_t>0.0))
    {
      if (((modelPar_ikp>0.0)&&(modelVar_imaxMod>modelPar_ikp)))
      {
        instanceVar_maxvIp = ((modelPar_nfp*instanceVar_vtv)*log((1.0+(((modelVar_imaxMod*modelVar_imaxMod)*modelVar_Iikp)/instanceVar_isp_t))));
      }
      else
      {
        instanceVar_maxvIp = ((modelPar_nfp*instanceVar_vtv)*log((1.0+(modelVar_imaxMod/instanceVar_isp_t))));
      }
    }
    else
    {
      instanceVar_maxvIp = 0.0;
    }
    instanceVar_ibei_t = ((modelPar_ibei*pow(instanceVar_rT,(modelPar_xii/modelPar_nei)))*exp((((-modelPar_eaie)*(1.0-instanceVar_rT))/(instanceVar_vtv*modelPar_nei))));
    if ((instanceVar_ibei_t>0.0))
    {
      instanceVar_maxvIbei = ((modelPar_nei*instanceVar_vtv)*log((1.0+(modelVar_imaxMod/instanceVar_ibei_t))));
    }
    else
    {
      instanceVar_maxvIbei = 0.0;
    }
    instanceVar_iben_t = ((modelPar_iben*pow(instanceVar_rT,(modelPar_xin/modelPar_nen)))*exp((((-modelPar_eane)*(1.0-instanceVar_rT))/(instanceVar_vtv*modelPar_nen))));
    if ((instanceVar_iben_t>0.0))
    {
      instanceVar_maxvIben = ((modelPar_nen*instanceVar_vtv)*log((1.0+(modelVar_imaxMod/instanceVar_iben_t))));
    }
    else
    {
      instanceVar_maxvIben = 0.0;
    }
    instanceVar_ibci_t = ((modelPar_ibci*pow(instanceVar_rT,(modelPar_xii/modelPar_nci)))*exp((((-modelPar_eaic)*(1.0-instanceVar_rT))/(instanceVar_vtv*modelPar_nci))));
    if ((instanceVar_ibci_t>0.0))
    {
      instanceVar_maxvIbci = ((modelPar_nci*instanceVar_vtv)*log((1.0+(modelVar_imaxMod/instanceVar_ibci_t))));
    }
    else
    {
      instanceVar_maxvIbci = 0.0;
    }
    instanceVar_ibcn_t = ((modelPar_ibcn*pow(instanceVar_rT,(modelPar_xin/modelPar_ncn)))*exp((((-modelPar_eanc)*(1.0-instanceVar_rT))/(instanceVar_vtv*modelPar_ncn))));
    if ((instanceVar_ibcn_t>0.0))
    {
      instanceVar_maxvIbcn = ((modelPar_ncn*instanceVar_vtv)*log((1.0+(modelVar_imaxMod/instanceVar_ibcn_t))));
    }
    else
    {
      instanceVar_maxvIbcn = 0.0;
    }
    instanceVar_ibeip_t = ((modelPar_ibeip*pow(instanceVar_rT,(modelPar_xii/modelPar_nci)))*exp((((-modelPar_eaic)*(1.0-instanceVar_rT))/(instanceVar_vtv*modelPar_nci))));
    if ((instanceVar_ibeip_t>0.0))
    {
      instanceVar_maxvIbeip = ((modelPar_nci*instanceVar_vtv)*log((1.0+(modelVar_imaxMod/instanceVar_ibeip_t))));
    }
    else
    {
      instanceVar_maxvIbeip = 0.0;
    }
    instanceVar_ibenp_t = ((modelPar_ibenp*pow(instanceVar_rT,(modelPar_xin/modelPar_ncn)))*exp((((-modelPar_eanc)*(1.0-instanceVar_rT))/(instanceVar_vtv*modelPar_ncn))));
    if ((instanceVar_ibenp_t>0.0))
    {
      instanceVar_maxvIbenp = ((modelPar_ncn*instanceVar_vtv)*log((1.0+(modelVar_imaxMod/instanceVar_ibenp_t))));
    }
    else
    {
      instanceVar_maxvIbenp = 0.0;
    }
    instanceVar_ibcip_t = ((modelPar_ibcip*pow(instanceVar_rT,(modelPar_xii/modelPar_ncip)))*exp((((-modelPar_eais)*(1.0-instanceVar_rT))/(instanceVar_vtv*modelPar_ncip))));
    if ((instanceVar_ibcip_t>0.0))
    {
      instanceVar_maxvIbcip = ((modelPar_ncip*instanceVar_vtv)*log((1.0+(modelVar_imaxMod/instanceVar_ibcip_t))));
    }
    else
    {
      instanceVar_maxvIbcip = 0.0;
    }
    instanceVar_ibcnp_t = ((modelPar_ibcnp*pow(instanceVar_rT,(modelPar_xin/modelPar_ncnp)))*exp((((-modelPar_eans)*(1.0-instanceVar_rT))/(instanceVar_vtv*modelPar_ncnp))));
    if ((instanceVar_ibcnp_t>0.0))
    {
      instanceVar_maxvIbcnp = ((modelPar_ncnp*instanceVar_vtv)*log((1.0+(modelVar_imaxMod/instanceVar_ibcnp_t))));
    }
    else
    {
      instanceVar_maxvIbcnp = 0.0;
    }
  }
  // End block initial_instance
}



//-----------------------------------------------------------------------------
// Function      : evaluateInitialModel
// Purpose       : Evaluate the statements in the initial_model block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
void evaluateInitialModel(
   // model parameters
   // reals
   AdmsSensFadType & modelPar_npn,
   bool modelPar_given_npn,
   AdmsSensFadType & modelPar_pnp,
   bool modelPar_given_pnp,
   AdmsSensFadType & modelPar_scale,
   bool modelPar_given_scale,
   AdmsSensFadType & modelPar_shrink,
   bool modelPar_given_shrink,
   AdmsSensFadType & modelPar_tmin,
   bool modelPar_given_tmin,
   AdmsSensFadType & modelPar_tmax,
   bool modelPar_given_tmax,
   AdmsSensFadType & modelPar_gmin,
   bool modelPar_given_gmin,
   AdmsSensFadType & modelPar_pnjmaxi,
   bool modelPar_given_pnjmaxi,
   AdmsSensFadType & modelPar_maxexp,
   bool modelPar_given_maxexp,
   AdmsSensFadType & modelPar_tnom,
   bool modelPar_given_tnom,
   AdmsSensFadType & modelPar_tminclip,
   bool modelPar_given_tminclip,
   AdmsSensFadType & modelPar_tmaxclip,
   bool modelPar_given_tmaxclip,
   AdmsSensFadType & modelPar_rcx,
   bool modelPar_given_rcx,
   AdmsSensFadType & modelPar_rci,
   bool modelPar_given_rci,
   AdmsSensFadType & modelPar_vo,
   bool modelPar_given_vo,
   AdmsSensFadType & modelPar_gamm,
   bool modelPar_given_gamm,
   AdmsSensFadType & modelPar_hrcf,
   bool modelPar_given_hrcf,
   AdmsSensFadType & modelPar_rbx,
   bool modelPar_given_rbx,
   AdmsSensFadType & modelPar_rbi,
   bool modelPar_given_rbi,
   AdmsSensFadType & modelPar_re,
   bool modelPar_given_re,
   AdmsSensFadType & modelPar_rs,
   bool modelPar_given_rs,
   AdmsSensFadType & modelPar_rbp,
   bool modelPar_given_rbp,
   AdmsSensFadType & modelPar_is,
   bool modelPar_given_is,
   AdmsSensFadType & modelPar_isrr,
   bool modelPar_given_isrr,
   AdmsSensFadType & modelPar_nf,
   bool modelPar_given_nf,
   AdmsSensFadType & modelPar_nr,
   bool modelPar_given_nr,
   AdmsSensFadType & modelPar_isp,
   bool modelPar_given_isp,
   AdmsSensFadType & modelPar_wsp,
   bool modelPar_given_wsp,
   AdmsSensFadType & modelPar_nfp,
   bool modelPar_given_nfp,
   AdmsSensFadType & modelPar_fc,
   bool modelPar_given_fc,
   AdmsSensFadType & modelPar_cbeo,
   bool modelPar_given_cbeo,
   AdmsSensFadType & modelPar_cje,
   bool modelPar_given_cje,
   AdmsSensFadType & modelPar_pe,
   bool modelPar_given_pe,
   AdmsSensFadType & modelPar_me,
   bool modelPar_given_me,
   AdmsSensFadType & modelPar_aje,
   bool modelPar_given_aje,
   AdmsSensFadType & modelPar_cbco,
   bool modelPar_given_cbco,
   AdmsSensFadType & modelPar_cjc,
   bool modelPar_given_cjc,
   AdmsSensFadType & modelPar_pc,
   bool modelPar_given_pc,
   AdmsSensFadType & modelPar_mc,
   bool modelPar_given_mc,
   AdmsSensFadType & modelPar_ajc,
   bool modelPar_given_ajc,
   AdmsSensFadType & modelPar_vrt,
   bool modelPar_given_vrt,
   AdmsSensFadType & modelPar_art,
   bool modelPar_given_art,
   AdmsSensFadType & modelPar_qco,
   bool modelPar_given_qco,
   AdmsSensFadType & modelPar_cjep,
   bool modelPar_given_cjep,
   AdmsSensFadType & modelPar_cjcp,
   bool modelPar_given_cjcp,
   AdmsSensFadType & modelPar_ps,
   bool modelPar_given_ps,
   AdmsSensFadType & modelPar_ms,
   bool modelPar_given_ms,
   AdmsSensFadType & modelPar_ajs,
   bool modelPar_given_ajs,
   AdmsSensFadType & modelPar_ccso,
   bool modelPar_given_ccso,
   AdmsSensFadType & modelPar_ibei,
   bool modelPar_given_ibei,
   AdmsSensFadType & modelPar_wbe,
   bool modelPar_given_wbe,
   AdmsSensFadType & modelPar_nei,
   bool modelPar_given_nei,
   AdmsSensFadType & modelPar_qnibeir,
   bool modelPar_given_qnibeir,
   AdmsSensFadType & modelPar_iben,
   bool modelPar_given_iben,
   AdmsSensFadType & modelPar_nen,
   bool modelPar_given_nen,
   AdmsSensFadType & modelPar_ibci,
   bool modelPar_given_ibci,
   AdmsSensFadType & modelPar_nci,
   bool modelPar_given_nci,
   AdmsSensFadType & modelPar_ibcn,
   bool modelPar_given_ibcn,
   AdmsSensFadType & modelPar_ncn,
   bool modelPar_given_ncn,
   AdmsSensFadType & modelPar_ibeip,
   bool modelPar_given_ibeip,
   AdmsSensFadType & modelPar_ibenp,
   bool modelPar_given_ibenp,
   AdmsSensFadType & modelPar_ibcip,
   bool modelPar_given_ibcip,
   AdmsSensFadType & modelPar_ncip,
   bool modelPar_given_ncip,
   AdmsSensFadType & modelPar_ibcnp,
   bool modelPar_given_ibcnp,
   AdmsSensFadType & modelPar_ncnp,
   bool modelPar_given_ncnp,
   AdmsSensFadType & modelPar_vef,
   bool modelPar_given_vef,
   AdmsSensFadType & modelPar_ver,
   bool modelPar_given_ver,
   AdmsSensFadType & modelPar_ikf,
   bool modelPar_given_ikf,
   AdmsSensFadType & modelPar_nkf,
   bool modelPar_given_nkf,
   AdmsSensFadType & modelPar_ikr,
   bool modelPar_given_ikr,
   AdmsSensFadType & modelPar_ikp,
   bool modelPar_given_ikp,
   AdmsSensFadType & modelPar_tf,
   bool modelPar_given_tf,
   AdmsSensFadType & modelPar_qtf,
   bool modelPar_given_qtf,
   AdmsSensFadType & modelPar_xtf,
   bool modelPar_given_xtf,
   AdmsSensFadType & modelPar_vtf,
   bool modelPar_given_vtf,
   AdmsSensFadType & modelPar_itf,
   bool modelPar_given_itf,
   AdmsSensFadType & modelPar_tr,
   bool modelPar_given_tr,
   AdmsSensFadType & modelPar_td,
   bool modelPar_given_td,
   AdmsSensFadType & modelPar_avc1,
   bool modelPar_given_avc1,
   AdmsSensFadType & modelPar_avc2,
   bool modelPar_given_avc2,
   AdmsSensFadType & modelPar_avcx1,
   bool modelPar_given_avcx1,
   AdmsSensFadType & modelPar_avcx2,
   bool modelPar_given_avcx2,
   AdmsSensFadType & modelPar_mcx,
   bool modelPar_given_mcx,
   AdmsSensFadType & modelPar_vbbe,
   bool modelPar_given_vbbe,
   AdmsSensFadType & modelPar_nbbe,
   bool modelPar_given_nbbe,
   AdmsSensFadType & modelPar_ibbe,
   bool modelPar_given_ibbe,
   AdmsSensFadType & modelPar_tvbbe1,
   bool modelPar_given_tvbbe1,
   AdmsSensFadType & modelPar_tvbbe2,
   bool modelPar_given_tvbbe2,
   AdmsSensFadType & modelPar_tnbbe,
   bool modelPar_given_tnbbe,
   AdmsSensFadType & modelPar_vpte,
   bool modelPar_given_vpte,
   AdmsSensFadType & modelPar_ibk0,
   bool modelPar_given_ibk0,
   AdmsSensFadType & modelPar_abk,
   bool modelPar_given_abk,
   AdmsSensFadType & modelPar_bbk,
   bool modelPar_given_bbk,
   AdmsSensFadType & modelPar_kfn,
   bool modelPar_given_kfn,
   AdmsSensFadType & modelPar_afn,
   bool modelPar_given_afn,
   AdmsSensFadType & modelPar_bfn,
   bool modelPar_given_bfn,
   AdmsSensFadType & modelPar_rth,
   bool modelPar_given_rth,
   AdmsSensFadType & modelPar_cth,
   bool modelPar_given_cth,
   AdmsSensFadType & modelPar_xre,
   bool modelPar_given_xre,
   AdmsSensFadType & modelPar_xrb,
   bool modelPar_given_xrb,
   AdmsSensFadType & modelPar_xrbi,
   bool modelPar_given_xrbi,
   AdmsSensFadType & modelPar_xrbx,
   bool modelPar_given_xrbx,
   AdmsSensFadType & modelPar_xrc,
   bool modelPar_given_xrc,
   AdmsSensFadType & modelPar_xrci,
   bool modelPar_given_xrci,
   AdmsSensFadType & modelPar_xrcx,
   bool modelPar_given_xrcx,
   AdmsSensFadType & modelPar_xrbp,
   bool modelPar_given_xrbp,
   AdmsSensFadType & modelPar_xrs,
   bool modelPar_given_xrs,
   AdmsSensFadType & modelPar_xvo,
   bool modelPar_given_xvo,
   AdmsSensFadType & modelPar_ea,
   bool modelPar_given_ea,
   AdmsSensFadType & modelPar_eaie,
   bool modelPar_given_eaie,
   AdmsSensFadType & modelPar_eaic,
   bool modelPar_given_eaic,
   AdmsSensFadType & modelPar_eais,
   bool modelPar_given_eais,
   AdmsSensFadType & modelPar_eane,
   bool modelPar_given_eane,
   AdmsSensFadType & modelPar_eanc,
   bool modelPar_given_eanc,
   AdmsSensFadType & modelPar_eans,
   bool modelPar_given_eans,
   AdmsSensFadType & modelPar_eap,
   bool modelPar_given_eap,
   AdmsSensFadType & modelPar_dear,
   bool modelPar_given_dear,
   AdmsSensFadType & modelPar_xis,
   bool modelPar_given_xis,
   AdmsSensFadType & modelPar_xii,
   bool modelPar_given_xii,
   AdmsSensFadType & modelPar_xin,
   bool modelPar_given_xin,
   AdmsSensFadType & modelPar_xisr,
   bool modelPar_given_xisr,
   AdmsSensFadType & modelPar_xikf,
   bool modelPar_given_xikf,
   AdmsSensFadType & modelPar_tavc,
   bool modelPar_given_tavc,
   AdmsSensFadType & modelPar_tavcx,
   bool modelPar_given_tavcx,
   AdmsSensFadType & modelPar_tnf,
   bool modelPar_given_tnf,
   AdmsSensFadType & modelPar_tcvef,
   bool modelPar_given_tcvef,
   AdmsSensFadType & modelPar_tcver,
   bool modelPar_given_tcver,
   AdmsSensFadType & modelPar_tcrth,
   bool modelPar_given_tcrth,
   // non-reals (including hidden)
   int modelPar_type,
   bool modelPar_given_type,
   int modelPar_VBICtype,
   int modelPar_qbm,
   bool modelPar_given_qbm// model variables
   ,
   // reals
   AdmsSensFadType & modelVar_tiniK,
   AdmsSensFadType & modelVar_Iikr,
   AdmsSensFadType & modelVar_Iikp,
   AdmsSensFadType & modelVar_Ihrcf,
   AdmsSensFadType & modelVar_Ivtf,
   AdmsSensFadType & modelVar_Iitf,
   AdmsSensFadType & modelVar_sltf,
   AdmsSensFadType & modelVar_VmaxExp,
   AdmsSensFadType & modelVar_gminMod,
   AdmsSensFadType & modelVar_imaxMod,
   double admsTemperature, double gmin, const Instance & theInstance)
{
  AdmsSensFadType shrinkL;
  AdmsSensFadType scaleFac;
  //Begin block initial_model
  {
    scaleFac = modelPar_scale;
    shrinkL = (1.0-(0.01*modelPar_shrink));
    if (modelPar_given_gmin)
    {
      modelVar_gminMod = modelPar_gmin;
    }
    else
    {
      modelVar_gminMod = gmin;
    }
    if (modelPar_given_pnjmaxi)
    {
      modelVar_imaxMod = modelPar_pnjmaxi;
    }
    else
    {
      modelVar_imaxMod = 1.0;
    }
    if (modelPar_given_npn)
    {
      modelPar_VBICtype = 1.0;
    }
    else
    {
      if (modelPar_given_pnp)
      {
        modelPar_VBICtype = (-1.0);
      }
      else
      {
        if (modelPar_given_type)
        {
          modelPar_VBICtype = (-modelPar_type);
        }
      }
    }
    modelVar_VmaxExp = log(modelPar_maxexp);
    modelVar_Iikr = adms_ternary_op<AdmsSensFadType>((modelPar_ikr>0.0),(1.0/modelPar_ikr),0.0);
    modelVar_Iikp = adms_ternary_op<AdmsSensFadType>((modelPar_ikp>0.0),(1.0/modelPar_ikp),0.0);
    modelVar_Ihrcf = adms_ternary_op<AdmsSensFadType>((modelPar_hrcf>0.0),(1.0/modelPar_hrcf),0.0);
    modelVar_Ivtf = adms_ternary_op<AdmsSensFadType>((modelPar_vtf>0.0),(1.0/modelPar_vtf),0.0);
    modelVar_Iitf = adms_ternary_op<AdmsSensFadType>((modelPar_itf>0.0),(1.0/modelPar_itf),0.0);
    modelVar_sltf = ((modelPar_itf>0.0)?0.0:1.0);
    modelVar_tiniK = (273.15+modelPar_tnom);
  }
  // End block initial_model
}



//-----------------------------------------------------------------------------
// Function      : evaluateModelEquations
// Purpose       : Evaluate the main module block.  Similar to
//                 updateIntermediateVars, but takes all instance and model
//                 parameters and variables as arguments instead of using
//                 the ones stored in the objects.
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
void evaluateModelEquations(
   std::vector <double> & probeVars,
   // probe constants
   const int admsProbeID_V_xf2_GND,
   const int admsProbeID_V_xf1_GND,
   const int admsProbeID_V_s_si,
   const int admsProbeID_V_bx_si,
   const int admsProbeID_V_si_bp,
   const int admsProbeID_V_bp_cx,
   const int admsProbeID_V_e_ei,
   const int admsProbeID_V_bx_bi,
   const int admsProbeID_V_b_bx,
   const int admsProbeID_V_cx_ci,
   const int admsProbeID_V_c_cx,
   const int admsProbeID_V_b_c,
   const int admsProbeID_V_b_e,
   const int admsProbeID_V_bx_bp,
   const int admsProbeID_V_ci_ei,
   const int admsProbeID_V_bx_cx,
   const int admsProbeID_V_bi_cx,
   const int admsProbeID_V_bi_ci,
   const int admsProbeID_V_bx_ei,
   const int admsProbeID_V_bi_ei,
   const int admsProbeID_Temp_dt_GND,
   // node constants
   const int admsNodeID_c,
   const int admsNodeID_b,
   const int admsNodeID_e,
   const int admsNodeID_s,
   const int admsNodeID_dt,
   const int admsNodeID_cx,
   const int admsNodeID_ci,
   const int admsNodeID_bx,
   const int admsNodeID_bi,
   const int admsNodeID_ei,
   const int admsNodeID_bp,
   const int admsNodeID_si,
   const int admsNodeID_xf1,
   const int admsNodeID_xf2,
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_m,
   bool instancePar_given_m,
   AdmsSensFadType & instancePar_trise,
   bool instancePar_given_trise,
   // non-reals(including hidden)
   int instancePar_sw_noise,
   bool instancePar_given_sw_noise,
   int instancePar_sw_et,
   bool instancePar_given_sw_et,
   // instance variables
   // reals
   AdmsSensFadType & instanceVar_is_t,
   AdmsSensFadType & instanceVar_isrr_t,
   AdmsSensFadType & instanceVar_ibei_t,
   AdmsSensFadType & instanceVar_ibci_t,
   AdmsSensFadType & instanceVar_isp_t,
   AdmsSensFadType & instanceVar_iben_t,
   AdmsSensFadType & instanceVar_ibcn_t,
   AdmsSensFadType & instanceVar_ibeip_t,
   AdmsSensFadType & instanceVar_ibenp_t,
   AdmsSensFadType & instanceVar_ibcip_t,
   AdmsSensFadType & instanceVar_ibcnp_t,
   AdmsSensFadType & instanceVar_tdevC,
   AdmsSensFadType & instanceVar_tdevK,
   AdmsSensFadType & instanceVar_rT,
   AdmsSensFadType & instanceVar_Gcx,
   AdmsSensFadType & instanceVar_Gci,
   AdmsSensFadType & instanceVar_Gbx,
   AdmsSensFadType & instanceVar_Gbi,
   AdmsSensFadType & instanceVar_Ge,
   AdmsSensFadType & instanceVar_Gbp,
   AdmsSensFadType & instanceVar_Gs,
   AdmsSensFadType & instanceVar_maxvIfi,
   AdmsSensFadType & instanceVar_maxvIri,
   AdmsSensFadType & instanceVar_maxvIp,
   AdmsSensFadType & instanceVar_maxvIbbe,
   AdmsSensFadType & instanceVar_maxvIbei,
   AdmsSensFadType & instanceVar_maxvIben,
   AdmsSensFadType & instanceVar_maxvIbci,
   AdmsSensFadType & instanceVar_maxvIbcn,
   AdmsSensFadType & instanceVar_maxvIbeip,
   AdmsSensFadType & instanceVar_maxvIbenp,
   AdmsSensFadType & instanceVar_maxvIbcip,
   AdmsSensFadType & instanceVar_maxvIbcnp,
   AdmsSensFadType & instanceVar_vtv,
   AdmsSensFadType & instanceVar_Itzf,
   AdmsSensFadType & instanceVar_qb,
   AdmsSensFadType & instanceVar_Iccp,
   AdmsSensFadType & instanceVar_qbp,
   AdmsSensFadType & instanceVar_Ibe,
   AdmsSensFadType & instanceVar_Ibex,
   AdmsSensFadType & instanceVar_Ibep,
   AdmsSensFadType & instanceVar_Irci,
   AdmsSensFadType & instanceVar_Vrci,
   AdmsSensFadType & instanceVar_mMod,
   AdmsSensFadType & instanceVar_tVCrit,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_npn,
   bool modelPar_given_npn,
   AdmsSensFadType & modelPar_pnp,
   bool modelPar_given_pnp,
   AdmsSensFadType & modelPar_scale,
   bool modelPar_given_scale,
   AdmsSensFadType & modelPar_shrink,
   bool modelPar_given_shrink,
   AdmsSensFadType & modelPar_tmin,
   bool modelPar_given_tmin,
   AdmsSensFadType & modelPar_tmax,
   bool modelPar_given_tmax,
   AdmsSensFadType & modelPar_gmin,
   bool modelPar_given_gmin,
   AdmsSensFadType & modelPar_pnjmaxi,
   bool modelPar_given_pnjmaxi,
   AdmsSensFadType & modelPar_maxexp,
   bool modelPar_given_maxexp,
   AdmsSensFadType & modelPar_tnom,
   bool modelPar_given_tnom,
   AdmsSensFadType & modelPar_tminclip,
   bool modelPar_given_tminclip,
   AdmsSensFadType & modelPar_tmaxclip,
   bool modelPar_given_tmaxclip,
   AdmsSensFadType & modelPar_rcx,
   bool modelPar_given_rcx,
   AdmsSensFadType & modelPar_rci,
   bool modelPar_given_rci,
   AdmsSensFadType & modelPar_vo,
   bool modelPar_given_vo,
   AdmsSensFadType & modelPar_gamm,
   bool modelPar_given_gamm,
   AdmsSensFadType & modelPar_hrcf,
   bool modelPar_given_hrcf,
   AdmsSensFadType & modelPar_rbx,
   bool modelPar_given_rbx,
   AdmsSensFadType & modelPar_rbi,
   bool modelPar_given_rbi,
   AdmsSensFadType & modelPar_re,
   bool modelPar_given_re,
   AdmsSensFadType & modelPar_rs,
   bool modelPar_given_rs,
   AdmsSensFadType & modelPar_rbp,
   bool modelPar_given_rbp,
   AdmsSensFadType & modelPar_is,
   bool modelPar_given_is,
   AdmsSensFadType & modelPar_isrr,
   bool modelPar_given_isrr,
   AdmsSensFadType & modelPar_nf,
   bool modelPar_given_nf,
   AdmsSensFadType & modelPar_nr,
   bool modelPar_given_nr,
   AdmsSensFadType & modelPar_isp,
   bool modelPar_given_isp,
   AdmsSensFadType & modelPar_wsp,
   bool modelPar_given_wsp,
   AdmsSensFadType & modelPar_nfp,
   bool modelPar_given_nfp,
   AdmsSensFadType & modelPar_fc,
   bool modelPar_given_fc,
   AdmsSensFadType & modelPar_cbeo,
   bool modelPar_given_cbeo,
   AdmsSensFadType & modelPar_cje,
   bool modelPar_given_cje,
   AdmsSensFadType & modelPar_pe,
   bool modelPar_given_pe,
   AdmsSensFadType & modelPar_me,
   bool modelPar_given_me,
   AdmsSensFadType & modelPar_aje,
   bool modelPar_given_aje,
   AdmsSensFadType & modelPar_cbco,
   bool modelPar_given_cbco,
   AdmsSensFadType & modelPar_cjc,
   bool modelPar_given_cjc,
   AdmsSensFadType & modelPar_pc,
   bool modelPar_given_pc,
   AdmsSensFadType & modelPar_mc,
   bool modelPar_given_mc,
   AdmsSensFadType & modelPar_ajc,
   bool modelPar_given_ajc,
   AdmsSensFadType & modelPar_vrt,
   bool modelPar_given_vrt,
   AdmsSensFadType & modelPar_art,
   bool modelPar_given_art,
   AdmsSensFadType & modelPar_qco,
   bool modelPar_given_qco,
   AdmsSensFadType & modelPar_cjep,
   bool modelPar_given_cjep,
   AdmsSensFadType & modelPar_cjcp,
   bool modelPar_given_cjcp,
   AdmsSensFadType & modelPar_ps,
   bool modelPar_given_ps,
   AdmsSensFadType & modelPar_ms,
   bool modelPar_given_ms,
   AdmsSensFadType & modelPar_ajs,
   bool modelPar_given_ajs,
   AdmsSensFadType & modelPar_ccso,
   bool modelPar_given_ccso,
   AdmsSensFadType & modelPar_ibei,
   bool modelPar_given_ibei,
   AdmsSensFadType & modelPar_wbe,
   bool modelPar_given_wbe,
   AdmsSensFadType & modelPar_nei,
   bool modelPar_given_nei,
   AdmsSensFadType & modelPar_qnibeir,
   bool modelPar_given_qnibeir,
   AdmsSensFadType & modelPar_iben,
   bool modelPar_given_iben,
   AdmsSensFadType & modelPar_nen,
   bool modelPar_given_nen,
   AdmsSensFadType & modelPar_ibci,
   bool modelPar_given_ibci,
   AdmsSensFadType & modelPar_nci,
   bool modelPar_given_nci,
   AdmsSensFadType & modelPar_ibcn,
   bool modelPar_given_ibcn,
   AdmsSensFadType & modelPar_ncn,
   bool modelPar_given_ncn,
   AdmsSensFadType & modelPar_ibeip,
   bool modelPar_given_ibeip,
   AdmsSensFadType & modelPar_ibenp,
   bool modelPar_given_ibenp,
   AdmsSensFadType & modelPar_ibcip,
   bool modelPar_given_ibcip,
   AdmsSensFadType & modelPar_ncip,
   bool modelPar_given_ncip,
   AdmsSensFadType & modelPar_ibcnp,
   bool modelPar_given_ibcnp,
   AdmsSensFadType & modelPar_ncnp,
   bool modelPar_given_ncnp,
   AdmsSensFadType & modelPar_vef,
   bool modelPar_given_vef,
   AdmsSensFadType & modelPar_ver,
   bool modelPar_given_ver,
   AdmsSensFadType & modelPar_ikf,
   bool modelPar_given_ikf,
   AdmsSensFadType & modelPar_nkf,
   bool modelPar_given_nkf,
   AdmsSensFadType & modelPar_ikr,
   bool modelPar_given_ikr,
   AdmsSensFadType & modelPar_ikp,
   bool modelPar_given_ikp,
   AdmsSensFadType & modelPar_tf,
   bool modelPar_given_tf,
   AdmsSensFadType & modelPar_qtf,
   bool modelPar_given_qtf,
   AdmsSensFadType & modelPar_xtf,
   bool modelPar_given_xtf,
   AdmsSensFadType & modelPar_vtf,
   bool modelPar_given_vtf,
   AdmsSensFadType & modelPar_itf,
   bool modelPar_given_itf,
   AdmsSensFadType & modelPar_tr,
   bool modelPar_given_tr,
   AdmsSensFadType & modelPar_td,
   bool modelPar_given_td,
   AdmsSensFadType & modelPar_avc1,
   bool modelPar_given_avc1,
   AdmsSensFadType & modelPar_avc2,
   bool modelPar_given_avc2,
   AdmsSensFadType & modelPar_avcx1,
   bool modelPar_given_avcx1,
   AdmsSensFadType & modelPar_avcx2,
   bool modelPar_given_avcx2,
   AdmsSensFadType & modelPar_mcx,
   bool modelPar_given_mcx,
   AdmsSensFadType & modelPar_vbbe,
   bool modelPar_given_vbbe,
   AdmsSensFadType & modelPar_nbbe,
   bool modelPar_given_nbbe,
   AdmsSensFadType & modelPar_ibbe,
   bool modelPar_given_ibbe,
   AdmsSensFadType & modelPar_tvbbe1,
   bool modelPar_given_tvbbe1,
   AdmsSensFadType & modelPar_tvbbe2,
   bool modelPar_given_tvbbe2,
   AdmsSensFadType & modelPar_tnbbe,
   bool modelPar_given_tnbbe,
   AdmsSensFadType & modelPar_vpte,
   bool modelPar_given_vpte,
   AdmsSensFadType & modelPar_ibk0,
   bool modelPar_given_ibk0,
   AdmsSensFadType & modelPar_abk,
   bool modelPar_given_abk,
   AdmsSensFadType & modelPar_bbk,
   bool modelPar_given_bbk,
   AdmsSensFadType & modelPar_kfn,
   bool modelPar_given_kfn,
   AdmsSensFadType & modelPar_afn,
   bool modelPar_given_afn,
   AdmsSensFadType & modelPar_bfn,
   bool modelPar_given_bfn,
   AdmsSensFadType & modelPar_rth,
   bool modelPar_given_rth,
   AdmsSensFadType & modelPar_cth,
   bool modelPar_given_cth,
   AdmsSensFadType & modelPar_xre,
   bool modelPar_given_xre,
   AdmsSensFadType & modelPar_xrb,
   bool modelPar_given_xrb,
   AdmsSensFadType & modelPar_xrbi,
   bool modelPar_given_xrbi,
   AdmsSensFadType & modelPar_xrbx,
   bool modelPar_given_xrbx,
   AdmsSensFadType & modelPar_xrc,
   bool modelPar_given_xrc,
   AdmsSensFadType & modelPar_xrci,
   bool modelPar_given_xrci,
   AdmsSensFadType & modelPar_xrcx,
   bool modelPar_given_xrcx,
   AdmsSensFadType & modelPar_xrbp,
   bool modelPar_given_xrbp,
   AdmsSensFadType & modelPar_xrs,
   bool modelPar_given_xrs,
   AdmsSensFadType & modelPar_xvo,
   bool modelPar_given_xvo,
   AdmsSensFadType & modelPar_ea,
   bool modelPar_given_ea,
   AdmsSensFadType & modelPar_eaie,
   bool modelPar_given_eaie,
   AdmsSensFadType & modelPar_eaic,
   bool modelPar_given_eaic,
   AdmsSensFadType & modelPar_eais,
   bool modelPar_given_eais,
   AdmsSensFadType & modelPar_eane,
   bool modelPar_given_eane,
   AdmsSensFadType & modelPar_eanc,
   bool modelPar_given_eanc,
   AdmsSensFadType & modelPar_eans,
   bool modelPar_given_eans,
   AdmsSensFadType & modelPar_eap,
   bool modelPar_given_eap,
   AdmsSensFadType & modelPar_dear,
   bool modelPar_given_dear,
   AdmsSensFadType & modelPar_xis,
   bool modelPar_given_xis,
   AdmsSensFadType & modelPar_xii,
   bool modelPar_given_xii,
   AdmsSensFadType & modelPar_xin,
   bool modelPar_given_xin,
   AdmsSensFadType & modelPar_xisr,
   bool modelPar_given_xisr,
   AdmsSensFadType & modelPar_xikf,
   bool modelPar_given_xikf,
   AdmsSensFadType & modelPar_tavc,
   bool modelPar_given_tavc,
   AdmsSensFadType & modelPar_tavcx,
   bool modelPar_given_tavcx,
   AdmsSensFadType & modelPar_tnf,
   bool modelPar_given_tnf,
   AdmsSensFadType & modelPar_tcvef,
   bool modelPar_given_tcvef,
   AdmsSensFadType & modelPar_tcver,
   bool modelPar_given_tcver,
   AdmsSensFadType & modelPar_tcrth,
   bool modelPar_given_tcrth,
   // non-reals (including hidden)
   int modelPar_type,
   bool modelPar_given_type,
   int modelPar_VBICtype,
   int modelPar_qbm,
   bool modelPar_given_qbm// model variables
   ,
   // reals
   AdmsSensFadType & modelVar_tiniK,
   AdmsSensFadType & modelVar_Iikr,
   AdmsSensFadType & modelVar_Iikp,
   AdmsSensFadType & modelVar_Ihrcf,
   AdmsSensFadType & modelVar_Ivtf,
   AdmsSensFadType & modelVar_Iitf,
   AdmsSensFadType & modelVar_sltf,
   AdmsSensFadType & modelVar_VmaxExp,
   AdmsSensFadType & modelVar_gminMod,
   AdmsSensFadType & modelVar_imaxMod,
   // basic variables
   double admsTemperature, double adms_vt_nom, double gmin, std::vector <AdmsSensFadType> & staticContributions, std::vector <AdmsSensFadType> & dynamicContributions, const Instance & theInstance)
{

  // Local variables
  AdmsSensFadType qdbcp;
  AdmsSensFadType qdbex;
  AdmsSensFadType qdbep;
  AdmsSensFadType sgIf;
  AdmsSensFadType rIf;
  AdmsSensFadType mIf;
  AdmsSensFadType tff;
  AdmsSensFadType Qbe;
  AdmsSensFadType Qbex;
  AdmsSensFadType Qbc;
  AdmsSensFadType Qbcx;
  AdmsSensFadType Qbep;
  AdmsSensFadType Qbcp;
  AdmsSensFadType Qbeo;
  AdmsSensFadType Qbco;
  AdmsSensFadType Qcth;
  AdmsSensFadType Qxf1;
  AdmsSensFadType Qxf2;
  double dt_et;
  AdmsSensFadType dT;
  AdmsSensFadType ikf_t;
  AdmsSensFadType rcx_t;
  AdmsSensFadType rci_t;
  AdmsSensFadType rbx_t;
  AdmsSensFadType rbi_t;
  AdmsSensFadType re_t;
  AdmsSensFadType rs_t;
  AdmsSensFadType rbp_t;
  AdmsSensFadType rth_t;
  AdmsSensFadType nf_t;
  AdmsSensFadType nr_t;
  AdmsSensFadType avc2_t;
  AdmsSensFadType avcx2_t;
  AdmsSensFadType vbbe_t;
  AdmsSensFadType nbbe_t;
  AdmsSensFadType pe_t;
  AdmsSensFadType pc_t;
  AdmsSensFadType ps_t;
  AdmsSensFadType cje_t;
  AdmsSensFadType cjc_t;
  AdmsSensFadType cjep_t;
  AdmsSensFadType cjcp_t;
  AdmsSensFadType gamm_t;
  AdmsSensFadType vo_t;
  AdmsSensFadType ebbe_t;
  AdmsSensFadType vef_t;
  AdmsSensFadType ver_t;
  AdmsSensFadType Gth;
  AdmsSensFadType Ivef;
  AdmsSensFadType Iver;
  AdmsSensFadType Iikf;
  AdmsSensFadType Ivo;
  AdmsSensFadType Vbei;
  AdmsSensFadType Vbex;
  AdmsSensFadType Vbci;
  AdmsSensFadType Vbcx;
  AdmsSensFadType Vbxcx;
  AdmsSensFadType Vcei;
  AdmsSensFadType Vbep;
  AdmsSensFadType Vbe;
  double Vbc;
  double Vrcx;
  double Vrbx;
  double Vrbi;
  double Vre;
  double Vrbp;
  AdmsSensFadType Vbcp;
  AdmsSensFadType Vcep;
  double Vrs;
  double Vxf1;
  double Vxf2;
  AdmsSensFadType qdbe;
  AdmsSensFadType qdbc;
  AdmsSensFadType afac;
  AdmsSensFadType expi;
  AdmsSensFadType Ifi;
  AdmsSensFadType Iri;
  AdmsSensFadType q1z;
  AdmsSensFadType q1;
  AdmsSensFadType q2;
  AdmsSensFadType arg;
  AdmsSensFadType Itzr;
  AdmsSensFadType Itxf;
  AdmsSensFadType expx;
  AdmsSensFadType Ifp;
  AdmsSensFadType q2p;
  AdmsSensFadType Irp;
  AdmsSensFadType expn;
  AdmsSensFadType Bvbe;
  AdmsSensFadType Ibcj;
  AdmsSensFadType Kbci;
  AdmsSensFadType Kbcx;
  AdmsSensFadType Ircx;
  AdmsSensFadType rKp1;
  AdmsSensFadType Iohm;
  AdmsSensFadType derf;
  AdmsSensFadType Irbx;
  AdmsSensFadType Irbi;
  AdmsSensFadType Ire;
  AdmsSensFadType Irbp;
  AdmsSensFadType Irs;
  AdmsSensFadType avalf;
  AdmsSensFadType Igc;
  AdmsSensFadType Igcx;
  AdmsSensFadType VcbFac;
  AdmsSensFadType Iibk;
  AdmsSensFadType Ibk;
  AdmsSensFadType Ibc;
  AdmsSensFadType Ibcp;
  AdmsSensFadType power;
  AdmsSensFadType Ith;
  AdmsSensFadType Irth;
  AdmsSensFadType Ixf1;
  double Ixf2;


  // -- code converted from analog/code block
  //Begin block evaluateStatic
  {
    dt_et = probeVars[admsProbeID_Temp_dt_GND];

    instanceVar_tdevC = (((admsTemperature+instancePar_trise)+dt_et)-273.15);
    if ((instanceVar_tdevC<(modelPar_tminclip+1.0)))
    {
      instanceVar_tdevC = (modelPar_tminclip+exp(((instanceVar_tdevC-modelPar_tminclip)-1.0)));
    }
    else
    {
      if ((instanceVar_tdevC>(modelPar_tmaxclip-1.0)))
      {
        instanceVar_tdevC = (modelPar_tmaxclip-exp(((modelPar_tmaxclip-instanceVar_tdevC)-1.0)));
      }
      else
      {
        instanceVar_tdevC = instanceVar_tdevC;
      }
    }
    instanceVar_tdevK = (instanceVar_tdevC+273.15);
    instanceVar_vtv = ((1.380662e-23*instanceVar_tdevK)/1.602189e-19);
    instanceVar_rT = (instanceVar_tdevK/modelVar_tiniK);
    dT = (instanceVar_tdevK-modelVar_tiniK);
    ikf_t = (modelPar_ikf*pow(instanceVar_rT,modelPar_xikf));
    if (modelPar_given_xrcx)
    {
      rcx_t = (modelPar_rcx*pow(instanceVar_rT,modelPar_xrcx));
    }
    else
    {
      rcx_t = (modelPar_rcx*pow(instanceVar_rT,modelPar_xrc));
    }
    if (modelPar_given_xrci)
    {
      rci_t = (modelPar_rci*pow(instanceVar_rT,modelPar_xrci));
    }
    else
    {
      rci_t = (modelPar_rci*pow(instanceVar_rT,modelPar_xrc));
    }
    if (modelPar_given_xrbx)
    {
      rbx_t = (modelPar_rbx*pow(instanceVar_rT,modelPar_xrbx));
    }
    else
    {
      rbx_t = (modelPar_rbx*pow(instanceVar_rT,modelPar_xrb));
    }
    if (modelPar_given_xrbi)
    {
      rbi_t = (modelPar_rbi*pow(instanceVar_rT,modelPar_xrbi));
    }
    else
    {
      rbi_t = (modelPar_rbi*pow(instanceVar_rT,modelPar_xrb));
    }
    re_t = (modelPar_re*pow(instanceVar_rT,modelPar_xre));
    rs_t = (modelPar_rs*pow(instanceVar_rT,modelPar_xrs));
    if (modelPar_given_xrbp)
    {
      rbp_t = (modelPar_rbp*pow(instanceVar_rT,modelPar_xrbp));
    }
    else
    {
      rbp_t = (modelPar_rbp*pow(instanceVar_rT,modelPar_xrc));
    }
    rth_t = (modelPar_rth*(1.0+(dT*modelPar_tcrth)));
    instanceVar_is_t = ((modelPar_is*pow(instanceVar_rT,(modelPar_xis/modelPar_nf)))*exp((((-modelPar_ea)*(1.0-instanceVar_rT))/(instanceVar_vtv*modelPar_nf))));
    instanceVar_isrr_t = ((modelPar_isrr*pow(instanceVar_rT,(modelPar_xisr/modelPar_nr)))*exp((((-modelPar_dear)*(1.0-instanceVar_rT))/(instanceVar_vtv*modelPar_nr))));
    instanceVar_isp_t = ((modelPar_isp*pow(instanceVar_rT,(modelPar_xis/modelPar_nfp)))*exp((((-modelPar_eap)*(1.0-instanceVar_rT))/(instanceVar_vtv*modelPar_nfp))));
    instanceVar_ibei_t = ((modelPar_ibei*pow(instanceVar_rT,(modelPar_xii/modelPar_nei)))*exp((((-modelPar_eaie)*(1.0-instanceVar_rT))/(instanceVar_vtv*modelPar_nei))));
    instanceVar_iben_t = ((modelPar_iben*pow(instanceVar_rT,(modelPar_xin/modelPar_nen)))*exp((((-modelPar_eane)*(1.0-instanceVar_rT))/(instanceVar_vtv*modelPar_nen))));
    instanceVar_ibci_t = ((modelPar_ibci*pow(instanceVar_rT,(modelPar_xii/modelPar_nci)))*exp((((-modelPar_eaic)*(1.0-instanceVar_rT))/(instanceVar_vtv*modelPar_nci))));
    instanceVar_ibcn_t = ((modelPar_ibcn*pow(instanceVar_rT,(modelPar_xin/modelPar_ncn)))*exp((((-modelPar_eanc)*(1.0-instanceVar_rT))/(instanceVar_vtv*modelPar_ncn))));
    instanceVar_ibeip_t = ((modelPar_ibeip*pow(instanceVar_rT,(modelPar_xii/modelPar_nci)))*exp((((-modelPar_eaic)*(1.0-instanceVar_rT))/(instanceVar_vtv*modelPar_nci))));
    instanceVar_ibenp_t = ((modelPar_ibenp*pow(instanceVar_rT,(modelPar_xin/modelPar_ncn)))*exp((((-modelPar_eanc)*(1.0-instanceVar_rT))/(instanceVar_vtv*modelPar_ncn))));
    instanceVar_ibcip_t = ((modelPar_ibcip*pow(instanceVar_rT,(modelPar_xii/modelPar_ncip)))*exp((((-modelPar_eais)*(1.0-instanceVar_rT))/(instanceVar_vtv*modelPar_ncip))));
    instanceVar_ibcnp_t = ((modelPar_ibcnp*pow(instanceVar_rT,(modelPar_xin/modelPar_ncnp)))*exp((((-modelPar_eans)*(1.0-instanceVar_rT))/(instanceVar_vtv*modelPar_ncnp))));
    nf_t = (modelPar_nf*(1.0+(dT*modelPar_tnf)));
    nr_t = (modelPar_nr*(1.0+(dT*modelPar_tnf)));
    avc2_t = (modelPar_avc2*(1.0+(dT*modelPar_tavc)));
    avcx2_t = (modelPar_avcx2*(1.0+(dT*modelPar_tavcx)));
    vbbe_t = (modelPar_vbbe*(1.0+(dT*(modelPar_tvbbe1+(dT*modelPar_tvbbe2)))));
    nbbe_t = (modelPar_nbbe*(1.0+(dT*modelPar_tnbbe)));
    //Begin block pePsibiBlock
    {
      //Block-local variables for block pePsibiBlock
      AdmsSensFadType psiio;
      AdmsSensFadType psiin;
      //End of Block-local variables
      psiio = ((2.0*(instanceVar_vtv/instanceVar_rT))*log((exp((((0.5*modelPar_pe)*instanceVar_rT)/instanceVar_vtv))-exp(((((-0.5)*modelPar_pe)*instanceVar_rT)/instanceVar_vtv)))));
      psiin = (((psiio*instanceVar_rT)-((3.0*instanceVar_vtv)*log(instanceVar_rT)))-(modelPar_eaie*(instanceVar_rT-1.0)));
      pe_t = (psiin+((2.0*instanceVar_vtv)*log((0.5*(1.0+sqrt((1.0+(4.0*exp(((-psiin)/instanceVar_vtv))))))))));
    }
    // End block pePsibiBlock
    //Begin block pcPsibiBlock
    {
      //Block-local variables for block pcPsibiBlock
      AdmsSensFadType psiio;
      AdmsSensFadType psiin;
      //End of Block-local variables
      psiio = ((2.0*(instanceVar_vtv/instanceVar_rT))*log((exp((((0.5*modelPar_pc)*instanceVar_rT)/instanceVar_vtv))-exp(((((-0.5)*modelPar_pc)*instanceVar_rT)/instanceVar_vtv)))));
      psiin = (((psiio*instanceVar_rT)-((3.0*instanceVar_vtv)*log(instanceVar_rT)))-(modelPar_eaic*(instanceVar_rT-1.0)));
      pc_t = (psiin+((2.0*instanceVar_vtv)*log((0.5*(1.0+sqrt((1.0+(4.0*exp(((-psiin)/instanceVar_vtv))))))))));
    }
    // End block pcPsibiBlock
    //Begin block psPsibiBlock
    {
      //Block-local variables for block psPsibiBlock
      AdmsSensFadType psiio;
      AdmsSensFadType psiin;
      //End of Block-local variables
      psiio = ((2.0*(instanceVar_vtv/instanceVar_rT))*log((exp((((0.5*modelPar_ps)*instanceVar_rT)/instanceVar_vtv))-exp(((((-0.5)*modelPar_ps)*instanceVar_rT)/instanceVar_vtv)))));
      psiin = (((psiio*instanceVar_rT)-((3.0*instanceVar_vtv)*log(instanceVar_rT)))-(modelPar_eais*(instanceVar_rT-1.0)));
      ps_t = (psiin+((2.0*instanceVar_vtv)*log((0.5*(1.0+sqrt((1.0+(4.0*exp(((-psiin)/instanceVar_vtv))))))))));
    }
    // End block psPsibiBlock
    cje_t = (modelPar_cje*pow((modelPar_pe/pe_t),modelPar_me));
    cjc_t = (modelPar_cjc*pow((modelPar_pc/pc_t),modelPar_mc));
    cjep_t = (modelPar_cjep*pow((modelPar_pc/pc_t),modelPar_mc));
    cjcp_t = (modelPar_cjcp*pow((modelPar_ps/ps_t),modelPar_ms));
    gamm_t = ((modelPar_gamm*pow(instanceVar_rT,modelPar_xis))*exp((((-modelPar_ea)*(1.0-instanceVar_rT))/instanceVar_vtv)));
    vo_t = (modelPar_vo*pow(instanceVar_rT,modelPar_xvo));
    ebbe_t = exp(((-vbbe_t)/(nbbe_t*instanceVar_vtv)));
    vef_t = (modelPar_vef*(1.0+(dT*modelPar_tcvef)));
    ver_t = (modelPar_ver*(1.0+(dT*modelPar_tcver)));
    instanceVar_Gcx = adms_ternary_op<AdmsSensFadType>((rcx_t>1.0e-3),(1.0/rcx_t),1.0e3);
    instanceVar_Gci = adms_ternary_op<AdmsSensFadType>((rci_t>1.0e-3),(1.0/rci_t),1.0e3);
    instanceVar_Gbx = adms_ternary_op<AdmsSensFadType>((rbx_t>1.0e-3),(1.0/rbx_t),1.0e3);
    instanceVar_Gbi = adms_ternary_op<AdmsSensFadType>((rbi_t>1.0e-3),(1.0/rbi_t),1.0e3);
    instanceVar_Ge = adms_ternary_op<AdmsSensFadType>((re_t>1.0e-3),(1.0/re_t),1.0e3);
    instanceVar_Gbp = adms_ternary_op<AdmsSensFadType>((rbp_t>1.0e-3),(1.0/rbp_t),1.0e3);
    instanceVar_Gs = adms_ternary_op<AdmsSensFadType>((rs_t>1.0e-3),(1.0/rs_t),1.0e3);
    Gth = adms_ternary_op<AdmsSensFadType>((rth_t>1.0e-3),(1.0/rth_t),1.0e3);
    Ivef = adms_ternary_op<AdmsSensFadType>((vef_t>0.0),(1.0/vef_t),0.0);
    Iver = adms_ternary_op<AdmsSensFadType>((ver_t>0.0),(1.0/ver_t),0.0);
    Iikf = adms_ternary_op<AdmsSensFadType>((ikf_t>0.0),(1.0/ikf_t),0.0);
    Ivo = adms_ternary_op<AdmsSensFadType>((vo_t>0.0),(1.0/vo_t),0.0);
    Vbei = probeVars[admsProbeID_V_bi_ei];

    Vbex = probeVars[admsProbeID_V_bx_ei];

    Vbci = probeVars[admsProbeID_V_bi_ci];

    Vbcx = probeVars[admsProbeID_V_bi_cx];

    Vbxcx = probeVars[admsProbeID_V_bx_cx];

    Vcei = (modelPar_VBICtype*(probeVars[admsProbeID_V_ci_ei]));
    Vbep = probeVars[admsProbeID_V_bx_bp];

    Vbe = probeVars[admsProbeID_V_b_e];

    Vbc = (probeVars[admsProbeID_V_b_c]);
    Vrcx = (probeVars[admsProbeID_V_c_cx]);
    instanceVar_Vrci = (modelPar_VBICtype*(probeVars[admsProbeID_V_cx_ci]));
    Vrbx = (probeVars[admsProbeID_V_b_bx]);
    Vrbi = (probeVars[admsProbeID_V_bx_bi]);
    Vre = (probeVars[admsProbeID_V_e_ei]);
    Vrbp = (probeVars[admsProbeID_V_bp_cx]);
    Vbcp = (modelPar_VBICtype*(probeVars[admsProbeID_V_si_bp]));
    Vcep = (modelPar_VBICtype*(probeVars[admsProbeID_V_bx_si]));
    Vrs = (probeVars[admsProbeID_V_s_si]);
    Vxf1 = (probeVars[admsProbeID_V_xf1_GND]);
    Vxf2 = (probeVars[admsProbeID_V_xf2_GND]);
    //Begin block qdbeBlock
    {
      //Block-local variables for block qdbeBlock
      AdmsSensFadType dv0;
      AdmsSensFadType dvh;
      AdmsSensFadType pwq;
      AdmsSensFadType qlo;
      AdmsSensFadType qhi;
      AdmsSensFadType mv0;
      AdmsSensFadType vl0;
      AdmsSensFadType q0;
      AdmsSensFadType dv;
      AdmsSensFadType mv;
      AdmsSensFadType vl;
      //End of Block-local variables
      dv0 = ((-pe_t)*modelPar_fc);
      if ((modelPar_aje<=0.0))
      {
        dvh = (Vbei+dv0);
        if ((dvh>0.0))
        {
          pwq = pow((1.0-modelPar_fc),(-modelPar_me));
          qlo = ((pe_t*(1.0-(pwq*(1.0-modelPar_fc))))/(1.0-modelPar_me));
          qhi = ((dvh*(1.0+(((0.5*modelPar_me)*dvh)/(pe_t*(1.0-modelPar_fc)))))*pwq);
        }
        else
        {
          qlo = ((pe_t*(1.0-pow((1.0-(Vbei/pe_t)),(1.0-modelPar_me))))/(1.0-modelPar_me));
          qhi = 0.0;
        }
        qdbe = (qlo+qhi);
      }
      else
      {
        mv0 = sqrt(((dv0*dv0)+((4.0*modelPar_aje)*modelPar_aje)));
        vl0 = ((-0.5)*(dv0+mv0));
        q0 = (((-pe_t)*pow((1.0-(vl0/pe_t)),(1.0-modelPar_me)))/(1.0-modelPar_me));
        dv = (Vbei+dv0);
        mv = sqrt(((dv*dv)+((4.0*modelPar_aje)*modelPar_aje)));
        vl = ((0.5*(dv-mv))-dv0);
        qlo = (((-pe_t)*pow((1.0-(vl/pe_t)),(1.0-modelPar_me)))/(1.0-modelPar_me));
        qdbe = ((qlo+((pow((1.0-modelPar_fc),(-modelPar_me))*((Vbei-vl)+vl0))*(1.0+(((0.5*modelPar_me)*((Vbei-vl)+vl0))/(pe_t*(1.0-modelPar_fc))))))-q0);
      }
    }
    // End block qdbeBlock
    //Begin block qdbcBlock
    {
      //Block-local variables for block qdbcBlock
      AdmsSensFadType dv0;
      AdmsSensFadType dvh;
      AdmsSensFadType pwq;
      AdmsSensFadType qlo;
      AdmsSensFadType qhi;
      AdmsSensFadType vn0;
      AdmsSensFadType vnl0;
      AdmsSensFadType vl0;
      AdmsSensFadType qlo0;
      AdmsSensFadType vn;
      AdmsSensFadType vnl;
      AdmsSensFadType vl;
      AdmsSensFadType sel;
      AdmsSensFadType crt;
      AdmsSensFadType cmx;
      AdmsSensFadType cl;
      AdmsSensFadType ql;
      AdmsSensFadType mv0;
      AdmsSensFadType q0;
      AdmsSensFadType dv;
      AdmsSensFadType mv;
      //End of Block-local variables
      dv0 = ((-pc_t)*modelPar_fc);
      if ((modelPar_ajc<=0.0))
      {
        dvh = (Vbci+dv0);
        if ((dvh>0.0))
        {
          pwq = pow((1.0-modelPar_fc),((-1.0)-modelPar_mc));
          qlo = ((pc_t*(1.0-((pwq*(1.0-modelPar_fc))*(1.0-modelPar_fc))))/(1.0-modelPar_mc));
          qhi = ((dvh*((1.0-modelPar_fc)+(((0.5*modelPar_mc)*dvh)/pc_t)))*pwq);
        }
        else
        {
          if (((modelPar_vrt>0.0)&&(Vbci<(-modelPar_vrt))))
          {
            qlo = ((pc_t*(1.0-(pow((1.0+(modelPar_vrt/pc_t)),(1.0-modelPar_mc))*(1.0-(((1.0-modelPar_mc)*(Vbci+modelPar_vrt))/(pc_t+modelPar_vrt))))))/(1.0-modelPar_mc));
          }
          else
          {
            qlo = ((pc_t*(1.0-pow((1.0-(Vbci/pc_t)),(1.0-modelPar_mc))))/(1.0-modelPar_mc));
          }
          qhi = 0.0;
        }
        qdbc = (qlo+qhi);
      }
      else
      {
        if (((modelPar_vrt>0.0)&&(modelPar_art>0.0)))
        {
          vn0 = ((modelPar_vrt+dv0)/(modelPar_vrt-dv0));
          vnl0 = ((2.0*vn0)/(sqrt((((vn0-1.0)*(vn0-1))+((4*modelPar_ajc)*modelPar_ajc)))+sqrt((((vn0+1.0)*(vn0+1))+((4*modelPar_art)*modelPar_art)))));
          vl0 = (0.5*(((vnl0*(modelPar_vrt-dv0))-modelPar_vrt)-dv0));
          qlo0 = ((pc_t*(1.0-pow((1.0-(vl0/pc_t)),(1.0-modelPar_mc))))/(1.0-modelPar_mc));
          vn = ((((2*Vbci)+modelPar_vrt)+dv0)/(modelPar_vrt-dv0));
          vnl = ((2.0*vn)/(sqrt((((vn-1.0)*(vn-1))+((4*modelPar_ajc)*modelPar_ajc)))+sqrt((((vn+1.0)*(vn+1))+((4*modelPar_art)*modelPar_art)))));
          vl = (0.5*(((vnl*(modelPar_vrt-dv0))-modelPar_vrt)-dv0));
          qlo = ((pc_t*(1.0-pow((1.0-(vl/pc_t)),(1.0-modelPar_mc))))/(1.0-modelPar_mc));
          sel = (0.5*(vnl+1.0));
          crt = pow((1.0+(modelPar_vrt/pc_t)),(-modelPar_mc));
          cmx = pow((1.0+(dv0/pc_t)),(-modelPar_mc));
          cl = (((1.0-sel)*crt)+(sel*cmx));
          ql = (((Vbci-vl)+vl0)*cl);
          qdbc = ((ql+qlo)-qlo0);
        }
        else
        {
          mv0 = sqrt(((dv0*dv0)+((4*modelPar_ajc)*modelPar_ajc)));
          vl0 = ((-0.5)*(dv0+mv0));
          q0 = (((-pc_t)*pow((1.0-(vl0/pc_t)),(1.0-modelPar_mc)))/(1.0-modelPar_mc));
          dv = (Vbci+dv0);
          mv = sqrt(((dv*dv)+((4*modelPar_ajc)*modelPar_ajc)));
          vl = ((0.5*(dv-mv))-dv0);
          qlo = (((-pc_t)*pow((1.0-(vl/pc_t)),(1.0-modelPar_mc)))/(1.0-modelPar_mc));
          qdbc = ((qlo+(pow((1.0-modelPar_fc),(-modelPar_mc))*((Vbci-vl)+vl0)))-q0);
        }
      }
    }
    // End block qdbcBlock
    afac = (1.0/(nf_t*instanceVar_vtv));
    if ((Vbei<instanceVar_maxvIfi))
    {
      expi = exp((Vbei*afac));
    }
    else
    {
      expi = (exp((instanceVar_maxvIfi*afac))*(1.0+((Vbei-instanceVar_maxvIfi)*afac)));
    }
    Ifi = (instanceVar_is_t*(expi-1.0));
    afac = (1.0/(nr_t*instanceVar_vtv));
    if ((Vbci<instanceVar_maxvIri))
    {
      expi = exp((Vbci*afac));
    }
    else
    {
      expi = (exp((instanceVar_maxvIri*afac))*(1.0+((Vbci-instanceVar_maxvIri)*afac)));
    }
    Iri = ((instanceVar_is_t*instanceVar_isrr_t)*(expi-1.0));
    q1z = (((1.0+(qdbe*Iver))+(qdbc*Ivef))-1.0e-4);
    q1 = ((0.5*(sqrt(((q1z*q1z)+1.0e-8))+q1z))+1.0e-4);
    q2 = ((Ifi*Iikf)+(Iri*modelVar_Iikr));
    if ((modelPar_qbm<0.5))
    {
      arg = (pow(q1,(1.0/modelPar_nkf))+(4.0*q2));
      if ((arg>1.0e-8))
      {
        instanceVar_qb = (0.5*(q1+pow(arg,modelPar_nkf)));
      }
      else
      {
        instanceVar_qb = (0.5*(q1+pow(1.0e-8,modelPar_nkf)));
      }
    }
    else
    {
      arg = (1.0+(4.0*q2));
      if ((arg>1.0e-8))
      {
        instanceVar_qb = ((0.5*q1)*(1.0+pow(arg,modelPar_nkf)));
      }
      else
      {
        instanceVar_qb = ((0.5*q1)*(1.0+pow(1.0e-8,modelPar_nkf)));
      }
    }
    Itzr = (Iri/instanceVar_qb);
    instanceVar_Itzf = (Ifi/instanceVar_qb);
    Itxf = Vxf2;
    if ((modelPar_isp>0.0))
    {
      afac = (1.0/(modelPar_nfp*instanceVar_vtv));
      if ((Vbep<instanceVar_maxvIp))
      {
        expi = exp((Vbep*afac));
      }
      else
      {
        expi = (exp((instanceVar_maxvIp*afac))*(1.0+((Vbep-instanceVar_maxvIp)*afac)));
      }
      if ((Vbci<instanceVar_maxvIp))
      {
        expx = exp((Vbci*afac));
      }
      else
      {
        expx = (exp((instanceVar_maxvIp*afac))*(1.0+((Vbci-instanceVar_maxvIp)*afac)));
      }
      Ifp = (instanceVar_isp_t*(((modelPar_wsp*expi)+((1.0-modelPar_wsp)*expx))-1.0));
      q2p = (Ifp*modelVar_Iikp);
      arg = (1.0+(4.0*q2p));
      if ((arg>1.0e-8))
      {
        instanceVar_qbp = (0.5*(1.0+sqrt(arg)));
      }
      else
      {
        instanceVar_qbp = (0.5*(1.0+sqrt(static_cast<double>(1.0e-8))));
      }
      if ((Vbcp<instanceVar_maxvIp))
      {
        expi = exp((Vbcp*afac));
      }
      else
      {
        expi = (exp((instanceVar_maxvIp*afac))*(1.0+((Vbcp-instanceVar_maxvIp)*afac)));
      }
      Irp = (instanceVar_isp_t*(expi-1.0));
      instanceVar_Iccp = ((Ifp-Irp)/instanceVar_qbp);
    }
    else
    {
      Ifp = 0.0;
      instanceVar_qbp = 1.0;
      instanceVar_Iccp = 0.0;
    }
    if ((modelPar_wbe==1.0))
    {
      afac = (1.0/(modelPar_nei*instanceVar_vtv));
      if ((Vbei<instanceVar_maxvIbei))
      {
        expi = exp((Vbei*afac));
      }
      else
      {
        expi = (exp((instanceVar_maxvIbei*afac))*(1.0+((Vbei-instanceVar_maxvIbei)*afac)));
      }
      afac = (1.0/(modelPar_nen*instanceVar_vtv));
      if ((Vbei<instanceVar_maxvIben))
      {
        expn = exp((Vbei*afac));
      }
      else
      {
        expn = (exp((instanceVar_maxvIben*afac))*(1.0+((Vbei-instanceVar_maxvIben)*afac)));
      }
      if ((modelPar_qnibeir>0.0))
      {
        instanceVar_Ibe = (((instanceVar_ibei_t*(1.0+(modelPar_qnibeir*(q1-1.0))))*(expi-1.0))+(instanceVar_iben_t*(expn-1.0)));
      }
      else
      {
        instanceVar_Ibe = ((instanceVar_ibei_t*(expi-1.0))+(instanceVar_iben_t*(expn-1.0)));
      }
      if ((modelPar_vbbe>0.0))
      {
        Bvbe = ((-vbbe_t)-Vbei);
        afac = (1.0/(nbbe_t*instanceVar_vtv));
        if ((Bvbe<instanceVar_maxvIbbe))
        {
          expx = exp((Bvbe*afac));
        }
        else
        {
          expx = (exp((instanceVar_maxvIbbe*afac))*(1.0+((Bvbe-instanceVar_maxvIbbe)*afac)));
        }
        instanceVar_Ibe = (instanceVar_Ibe-(modelPar_ibbe*(expx-ebbe_t)));
      }
      instanceVar_Ibex = 0.0;
    }
    else
    {
      if ((modelPar_wbe==0.0))
      {
        instanceVar_Ibe = 0.0;
        afac = (1.0/(modelPar_nei*instanceVar_vtv));
        if ((Vbex<instanceVar_maxvIbei))
        {
          expi = exp((Vbex*afac));
        }
        else
        {
          expi = (exp((instanceVar_maxvIbei*afac))*(1.0+((Vbex-instanceVar_maxvIbei)*afac)));
        }
        afac = (1.0/(modelPar_nen*instanceVar_vtv));
        if ((Vbex<instanceVar_maxvIben))
        {
          expn = exp((Vbex*afac));
        }
        else
        {
          expn = (exp((instanceVar_maxvIben*afac))*(1.0+((Vbex-instanceVar_maxvIben)*afac)));
        }
        instanceVar_Ibex = ((instanceVar_ibei_t*(expi-1.0))+(instanceVar_iben_t*(expn-1.0)));
        if ((modelPar_vbbe>0.0))
        {
          Bvbe = ((-vbbe_t)-Vbei);
          afac = (1.0/(nbbe_t*instanceVar_vtv));
          if ((Bvbe<instanceVar_maxvIbbe))
          {
            expx = exp((Bvbe*afac));
          }
          else
          {
            expx = (exp((instanceVar_maxvIbbe*afac))*(1.0+((Bvbe-instanceVar_maxvIbbe)*afac)));
          }
          instanceVar_Ibex = (instanceVar_Ibex-(modelPar_ibbe*(expx-ebbe_t)));
        }
      }
      else
      {
        afac = (1.0/(modelPar_nei*instanceVar_vtv));
        if ((Vbei<instanceVar_maxvIbei))
        {
          expi = exp((Vbei*afac));
        }
        else
        {
          expi = (exp((instanceVar_maxvIbei*afac))*(1.0+((Vbei-instanceVar_maxvIbei)*afac)));
        }
        afac = (1.0/(modelPar_nen*instanceVar_vtv));
        if ((Vbei<instanceVar_maxvIben))
        {
          expn = exp((Vbei*afac));
        }
        else
        {
          expn = (exp((instanceVar_maxvIben*afac))*(1.0+((Vbei-instanceVar_maxvIben)*afac)));
        }
        if ((modelPar_qnibeir>0.0))
        {
          instanceVar_Ibe = (modelPar_wbe*(((instanceVar_ibei_t*(1.0+(modelPar_qnibeir*(q1-1.0))))*(expi-1.0))+(instanceVar_iben_t*(expn-1.0))));
        }
        else
        {
          instanceVar_Ibe = (modelPar_wbe*((instanceVar_ibei_t*(expi-1.0))+(instanceVar_iben_t*(expn-1.0))));
        }
        if ((modelPar_vbbe>0.0))
        {
          Bvbe = ((-vbbe_t)-Vbei);
          afac = (1.0/(nbbe_t*instanceVar_vtv));
          if ((Bvbe<instanceVar_maxvIbbe))
          {
            expx = exp((Bvbe*afac));
          }
          else
          {
            expx = (exp((instanceVar_maxvIbbe*afac))*(1.0+((Bvbe-instanceVar_maxvIbbe)*afac)));
          }
          instanceVar_Ibe = (instanceVar_Ibe-((modelPar_wbe*modelPar_ibbe)*(expx-ebbe_t)));
        }
        afac = (1.0/(modelPar_nei*instanceVar_vtv));
        if ((Vbex<instanceVar_maxvIbei))
        {
          expi = exp((Vbex*afac));
        }
        else
        {
          expi = (exp((instanceVar_maxvIbei*afac))*(1.0+((Vbex-instanceVar_maxvIbei)*afac)));
        }
        afac = (1.0/(modelPar_nen*instanceVar_vtv));
        if ((Vbex<instanceVar_maxvIben))
        {
          expn = exp((Vbex*afac));
        }
        else
        {
          expn = (exp((instanceVar_maxvIben*afac))*(1.0+((Vbex-instanceVar_maxvIben)*afac)));
        }
        instanceVar_Ibex = ((1.0-modelPar_wbe)*((instanceVar_ibei_t*(expi-1.0))+(instanceVar_iben_t*(expn-1.0))));
        if ((modelPar_vbbe>0.0))
        {
          Bvbe = ((-vbbe_t)-Vbei);
          afac = (1.0/(nbbe_t*instanceVar_vtv));
          if ((Bvbe<instanceVar_maxvIbbe))
          {
            expx = exp((Bvbe*afac));
          }
          else
          {
            expx = (exp((instanceVar_maxvIbbe*afac))*(1.0+((Bvbe-instanceVar_maxvIbbe)*afac)));
          }
          instanceVar_Ibex = (instanceVar_Ibex-(((1.0-modelPar_wbe)*modelPar_ibbe)*(expx-ebbe_t)));
        }
      }
    }
    afac = (1.0/(modelPar_nci*instanceVar_vtv));
    if ((Vbci<instanceVar_maxvIbci))
    {
      expi = exp((Vbci*afac));
    }
    else
    {
      expi = (exp((instanceVar_maxvIbci*afac))*(1.0+((Vbci-instanceVar_maxvIbci)*afac)));
    }
    afac = (1.0/(modelPar_ncn*instanceVar_vtv));
    if ((Vbci<instanceVar_maxvIbcn))
    {
      expn = exp((Vbci*afac));
    }
    else
    {
      expn = (exp((instanceVar_maxvIbcn*afac))*(1.0+((Vbci-instanceVar_maxvIbcn)*afac)));
    }
    Ibcj = ((instanceVar_ibci_t*(expi-1.0))+(instanceVar_ibcn_t*(expn-1.0)));
    if (((modelPar_ibeip>0.0)||(modelPar_ibenp>0.0)))
    {
      afac = (1.0/(modelPar_nci*instanceVar_vtv));
      if ((Vbep<instanceVar_maxvIbeip))
      {
        expi = exp((Vbep*afac));
      }
      else
      {
        expi = (exp((instanceVar_maxvIbeip*afac))*(1.0+((Vbep-instanceVar_maxvIbeip)*afac)));
      }
      afac = (1.0/(modelPar_ncn*instanceVar_vtv));
      if ((Vbep<instanceVar_maxvIbenp))
      {
        expn = exp((Vbep*afac));
      }
      else
      {
        expn = (exp((instanceVar_maxvIbenp*afac))*(1.0+((Vbep-instanceVar_maxvIbenp)*afac)));
      }
      instanceVar_Ibep = ((instanceVar_ibeip_t*(expi-1.0))+(instanceVar_ibenp_t*(expn-1.0)));
    }
    else
    {
      instanceVar_Ibep = 0.0;
    }
    arg = (Vbci/instanceVar_vtv);
    if ((arg<modelVar_VmaxExp))
    {
      expi = exp(arg);
    }
    else
    {
      expi = (exp(modelVar_VmaxExp)*(1.0+(arg-modelVar_VmaxExp)));
    }
    arg = (Vbcx/instanceVar_vtv);
    if ((arg<modelVar_VmaxExp))
    {
      expx = exp(arg);
    }
    else
    {
      expx = (exp(modelVar_VmaxExp)*(1.0+(arg-modelVar_VmaxExp)));
    }
    Kbci = sqrt((1.0+(gamm_t*expi)));
    Kbcx = sqrt((1.0+(gamm_t*expx)));
    Ircx = (Vrcx*instanceVar_Gcx);
    rKp1 = ((Kbci+1.0)/(Kbcx+1.0));
    Iohm = ((instanceVar_Vrci+(instanceVar_vtv*((Kbci-Kbcx)-log(rKp1))))*instanceVar_Gci);
    derf = ((Ivo*Iohm)/(instanceVar_Gci*(1.0+(((0.5*Ivo)*modelVar_Ihrcf)*sqrt(((instanceVar_Vrci*instanceVar_Vrci)+0.01))))));
    instanceVar_Irci = (Iohm/sqrt((1+(derf*derf))));
    Irbx = (Vrbx*instanceVar_Gbx);
    Irbi = ((Vrbi*instanceVar_qb)*instanceVar_Gbi);
    Ire = (Vre*instanceVar_Ge);
    Irbp = ((Vrbp*instanceVar_qbp)*instanceVar_Gbp);
    Irs = (Vrs*instanceVar_Gs);
    if ((modelPar_avc1>0.0))
    {
      //Begin block igcBlock
      {
        //Block-local variables for block igcBlock
        AdmsSensFadType vminm;
        AdmsSensFadType vl;
        AdmsSensFadType mac1;
        AdmsSensFadType expi;
        AdmsSensFadType expl;
        //End of Block-local variables
        vminm = pow((0.02*(avc2_t+1.0)),(1.0/(1.01-modelPar_mc)));
        vl = ((0.5*(sqrt(((((pc_t-Vbci)-vminm)*((pc_t-Vbci)-vminm))+0.01))+((pc_t-Vbci)-vminm)))+vminm);
        mac1 = ((-avc2_t)*pow(vl,(modelPar_mc-1.0)));
        if ((mac1<modelVar_VmaxExp))
        {
          expi = exp(mac1);
        }
        else
        {
          expl = exp(modelVar_VmaxExp);
          expi = (expl*(1.0+(mac1-modelVar_VmaxExp)));
        }
        avalf = ((modelPar_avc1*vl)*expi);
      }
      // End block igcBlock
      Igc = (((Itxf-Itzr)-Ibcj)*avalf);
    }
    else
    {
      Igc = 0.0;
    }
    if ((modelPar_avcx1>0.0))
    {
      //Begin block igcxBlock
      {
        //Block-local variables for block igcxBlock
        AdmsSensFadType vminm;
        AdmsSensFadType vl;
        AdmsSensFadType mac1;
        AdmsSensFadType expi;
        AdmsSensFadType expl;
        //End of Block-local variables
        vminm = pow((0.02*(avcx2_t+1.0)),(1.0/(1.01-modelPar_mcx)));
        vl = ((0.5*(sqrt(((((-Vbxcx)-vminm)*((-Vbxcx)-vminm))+0.01))+((-Vbxcx)-vminm)))+vminm);
        mac1 = ((-avcx2_t)*pow(vl,(modelPar_mcx-1.0)));
        if ((mac1<modelVar_VmaxExp))
        {
          expi = exp(mac1);
        }
        else
        {
          expl = exp(modelVar_VmaxExp);
          expi = (expl*(1.0+(mac1-modelVar_VmaxExp)));
        }
        avalf = ((modelPar_avcx1*vl)*expi);
      }
      // End block igcxBlock
      Igcx = ((-Ircx)*avalf);
    }
    else
    {
      Igcx = 0.0;
    }
    if (((modelPar_bbk>0.0)&&(modelPar_ibk0>0.0)))
    {
      if ((modelPar_vpte>0.0))
      {
        VcbFac = ((1.0-(Vbci/modelPar_vpte))-0.1);
        VcbFac = (0.1+(0.5*(VcbFac+sqrt(((VcbFac*VcbFac)+1.0e-4)))));
        Iibk = (modelPar_ibk0*VcbFac);
      }
      else
      {
        Iibk = modelPar_ibk0;
      }
      Ibk = (modelPar_bbk*pow(((instanceVar_Itzf/Iibk)-1.0),modelPar_abk));
    }
    else
    {
      Ibk = 0.0;
    }
    Ibc = ((Ibcj-Igc)-Ibk);
    if (((modelPar_ibcip>0.0)||(modelPar_ibcnp>0.0)))
    {
      afac = (1.0/(modelPar_ncip*instanceVar_vtv));
      if ((Vbcp<instanceVar_maxvIbcip))
      {
        expi = exp((Vbcp*afac));
      }
      else
      {
        expi = (exp((instanceVar_maxvIbcip*afac))*(1.0+((Vbcp-instanceVar_maxvIbcip)*afac)));
      }
      afac = (1.0/(modelPar_ncnp*instanceVar_vtv));
      if ((Vbcp<instanceVar_maxvIbcnp))
      {
        expn = exp((Vbcp*afac));
      }
      else
      {
        expn = (exp((instanceVar_maxvIbcnp*afac))*(1.0+((Vbcp-instanceVar_maxvIbcnp)*afac)));
      }
      Ibcp = ((instanceVar_ibcip_t*(expi-1.0))+(instanceVar_ibcnp_t*(expn-1.0)));
    }
    else
    {
      Ibcp = 0.0;
    }
    power = ((((((((((((((instanceVar_Ibe*Vbei)+(Ibc*Vbci))+((Itxf-Itzr)*Vcei))+(instanceVar_Ibex*Vbex))+(instanceVar_Ibep*Vbep))+(Irs*Vrs))+(Ibcp*Vbcp))+(instanceVar_Iccp*Vcep))+(Ircx*Vrcx))+(instanceVar_Irci*instanceVar_Vrci))+(Irbx*Vrbx))+(Irbi*Vrbi))+(Ire*Vre))+(Irbp*Vrbp));
    Ith = ((-instancePar_sw_et)*power);
    Irth = (dt_et*Gth);
    Ixf1 = (Vxf2-instanceVar_Itzf);
    Ixf2 = (Vxf2-Vxf1);
    instanceVar_Ibe = (instanceVar_Ibe+(modelVar_gminMod*Vbei));
    instanceVar_Ibex = (instanceVar_Ibex+(modelVar_gminMod*Vbex));
    instanceVar_Ibep = (instanceVar_Ibep+(modelVar_gminMod*Vbep));
    Ibc = (Ibc+(modelVar_gminMod*Vbci));
    Igcx = (Igcx+(modelVar_gminMod*Vbxcx));
    Ibcp = (Ibcp+(modelVar_gminMod*Vbcp));
    instanceVar_Ibe = ((modelPar_VBICtype*instanceVar_mMod)*instanceVar_Ibe);
    instanceVar_Ibex = ((modelPar_VBICtype*instanceVar_mMod)*instanceVar_Ibex);
    instanceVar_Itzf = ((modelPar_VBICtype*instanceVar_mMod)*instanceVar_Itzf);
    Itxf = ((modelPar_VBICtype*instanceVar_mMod)*Itxf);
    Itzr = ((modelPar_VBICtype*instanceVar_mMod)*Itzr);
    Ibc = ((modelPar_VBICtype*instanceVar_mMod)*Ibc);
    Igcx = ((modelPar_VBICtype*instanceVar_mMod)*Igcx);
    instanceVar_Ibep = ((modelPar_VBICtype*instanceVar_mMod)*instanceVar_Ibep);
    Ircx = (instanceVar_mMod*Ircx);
    instanceVar_Irci = ((modelPar_VBICtype*instanceVar_mMod)*instanceVar_Irci);
    Irbx = (instanceVar_mMod*Irbx);
    Irbi = (instanceVar_mMod*Irbi);
    Ire = (instanceVar_mMod*Ire);
    Irbp = (instanceVar_mMod*Irbp);
    Ibcp = ((modelPar_VBICtype*instanceVar_mMod)*Ibcp);
    instanceVar_Iccp = ((modelPar_VBICtype*instanceVar_mMod)*instanceVar_Iccp);
    Irs = (instanceVar_mMod*Irs);
    Ith = (instanceVar_mMod*Ith);
    Irth = (instanceVar_mMod*Irth);
  }
  // End block evaluateStatic
  //Begin block evaluateDynamic
  {
    if ((modelPar_cjcp>0.0))
    {
      //Begin block qdbcpBlock
      {
        //Block-local variables for block qdbcpBlock
        AdmsSensFadType dv0;
        AdmsSensFadType dvh;
        AdmsSensFadType pwq;
        AdmsSensFadType qlo;
        AdmsSensFadType qhi;
        AdmsSensFadType mv0;
        AdmsSensFadType vl0;
        AdmsSensFadType q0;
        AdmsSensFadType dv;
        AdmsSensFadType mv;
        AdmsSensFadType vl;
        //End of Block-local variables
        dv0 = ((-ps_t)*modelPar_fc);
        if ((modelPar_ajs<=0.0))
        {
          dvh = (Vbcp+dv0);
          if ((dvh>0.0))
          {
            pwq = pow((1.0-modelPar_fc),(-modelPar_ms));
            qlo = ((ps_t*(1.0-(pwq*(1.0-modelPar_fc))))/(1.0-modelPar_ms));
            qhi = ((dvh*(1.0+(((0.5*modelPar_ms)*dvh)/(ps_t*(1.0-modelPar_fc)))))*pwq);
          }
          else
          {
            qlo = ((ps_t*(1.0-pow((1.0-(Vbcp/ps_t)),(1.0-modelPar_ms))))/(1.0-modelPar_ms));
            qhi = 0.0;
          }
          qdbcp = (qlo+qhi);
        }
        else
        {
          mv0 = sqrt(((dv0*dv0)+((4.0*modelPar_ajs)*modelPar_ajs)));
          vl0 = ((-0.5)*(dv0+mv0));
          q0 = (((-ps_t)*pow((1.0-(vl0/ps_t)),(1.0-modelPar_ms)))/(1.0-modelPar_ms));
          dv = (Vbcp+dv0);
          mv = sqrt(((dv*dv)+((4.0*modelPar_ajs)*modelPar_ajs)));
          vl = ((0.5*(dv-mv))-dv0);
          qlo = (((-ps_t)*pow((1.0-(vl/ps_t)),(1.0-modelPar_ms)))/(1.0-modelPar_ms));
          qdbcp = ((qlo+((pow((1.0-modelPar_fc),(-modelPar_ms))*((Vbcp-vl)+vl0))*(1.0+(((0.5*modelPar_ms)*((Vbcp-vl)+vl0))/(ps_t*(1.0-modelPar_fc))))))-q0);
        }
      }
      // End block qdbcpBlock
    }
    else
    {
      qdbcp = 0.0;
    }
    //Begin block qdbexBlock
    {
      //Block-local variables for block qdbexBlock
      AdmsSensFadType dv0;
      AdmsSensFadType dvh;
      AdmsSensFadType pwq;
      AdmsSensFadType qlo;
      AdmsSensFadType qhi;
      AdmsSensFadType mv0;
      AdmsSensFadType vl0;
      AdmsSensFadType q0;
      AdmsSensFadType dv;
      AdmsSensFadType mv;
      AdmsSensFadType vl;
      //End of Block-local variables
      dv0 = ((-pe_t)*modelPar_fc);
      if ((modelPar_aje<=0.0))
      {
        dvh = (Vbex+dv0);
        if ((dvh>0.0))
        {
          pwq = pow((1.0-modelPar_fc),(-modelPar_me));
          qlo = ((pe_t*(1.0-(pwq*(1.0-modelPar_fc))))/(1.0-modelPar_me));
          qhi = ((dvh*(1.0+(((0.5*modelPar_me)*dvh)/(pe_t*(1.0-modelPar_fc)))))*pwq);
        }
        else
        {
          qlo = ((pe_t*(1.0-pow((1.0-(Vbex/pe_t)),(1.0-modelPar_me))))/(1.0-modelPar_me));
          qhi = 0.0;
        }
        qdbex = (qlo+qhi);
      }
      else
      {
        mv0 = sqrt(((dv0*dv0)+((4.0*modelPar_aje)*modelPar_aje)));
        vl0 = ((-0.5)*(dv0+mv0));
        q0 = (((-pe_t)*pow((1.0-(vl0/pe_t)),(1.0-modelPar_me)))/(1.0-modelPar_me));
        dv = (Vbex+dv0);
        mv = sqrt(((dv*dv)+((4.0*modelPar_aje)*modelPar_aje)));
        vl = ((0.5*(dv-mv))-dv0);
        qlo = (((-pe_t)*pow((1.0-(vl/pe_t)),(1.0-modelPar_me)))/(1.0-modelPar_me));
        qdbex = ((qlo+((pow((1.0-modelPar_fc),(-modelPar_me))*((Vbex-vl)+vl0))*(1.0+(((0.5*modelPar_me)*((Vbex-vl)+vl0))/(pe_t*(1.0-modelPar_fc))))))-q0);
      }
    }
    // End block qdbexBlock
    //Begin block qdbepBlock
    {
      //Block-local variables for block qdbepBlock
      AdmsSensFadType dv0;
      AdmsSensFadType dvh;
      AdmsSensFadType pwq;
      AdmsSensFadType qlo;
      AdmsSensFadType qhi;
      AdmsSensFadType vn0;
      AdmsSensFadType vnl0;
      AdmsSensFadType vl0;
      AdmsSensFadType qlo0;
      AdmsSensFadType vn;
      AdmsSensFadType vnl;
      AdmsSensFadType vl;
      AdmsSensFadType sel;
      AdmsSensFadType crt;
      AdmsSensFadType cmx;
      AdmsSensFadType cl;
      AdmsSensFadType ql;
      AdmsSensFadType mv0;
      AdmsSensFadType q0;
      AdmsSensFadType dv;
      AdmsSensFadType mv;
      //End of Block-local variables
      dv0 = ((-pc_t)*modelPar_fc);
      if ((modelPar_ajc<=0.0))
      {
        dvh = (Vbep+dv0);
        if ((dvh>0.0))
        {
          pwq = pow((1.0-modelPar_fc),((-1.0)-modelPar_mc));
          qlo = ((pc_t*(1.0-((pwq*(1.0-modelPar_fc))*(1.0-modelPar_fc))))/(1.0-modelPar_mc));
          qhi = ((dvh*((1.0-modelPar_fc)+(((0.5*modelPar_mc)*dvh)/pc_t)))*pwq);
        }
        else
        {
          if (((modelPar_vrt>0.0)&&(Vbep<(-modelPar_vrt))))
          {
            qlo = ((pc_t*(1.0-(pow((1.0+(modelPar_vrt/pc_t)),(1.0-modelPar_mc))*(1.0-(((1.0-modelPar_mc)*(Vbep+modelPar_vrt))/(pc_t+modelPar_vrt))))))/(1.0-modelPar_mc));
          }
          else
          {
            qlo = ((pc_t*(1.0-pow((1.0-(Vbep/pc_t)),(1.0-modelPar_mc))))/(1.0-modelPar_mc));
          }
          qhi = 0.0;
        }
        qdbep = (qlo+qhi);
      }
      else
      {
        if (((modelPar_vrt>0.0)&&(modelPar_art>0.0)))
        {
          vn0 = ((modelPar_vrt+dv0)/(modelPar_vrt-dv0));
          vnl0 = ((2.0*vn0)/(sqrt((((vn0-1.0)*(vn0-1))+((4*modelPar_ajc)*modelPar_ajc)))+sqrt((((vn0+1.0)*(vn0+1))+((4*modelPar_art)*modelPar_art)))));
          vl0 = (0.5*(((vnl0*(modelPar_vrt-dv0))-modelPar_vrt)-dv0));
          qlo0 = ((pc_t*(1.0-pow((1.0-(vl0/pc_t)),(1.0-modelPar_mc))))/(1.0-modelPar_mc));
          vn = ((((2*Vbep)+modelPar_vrt)+dv0)/(modelPar_vrt-dv0));
          vnl = ((2.0*vn)/(sqrt((((vn-1.0)*(vn-1))+((4*modelPar_ajc)*modelPar_ajc)))+sqrt((((vn+1.0)*(vn+1))+((4*modelPar_art)*modelPar_art)))));
          vl = (0.5*(((vnl*(modelPar_vrt-dv0))-modelPar_vrt)-dv0));
          qlo = ((pc_t*(1.0-pow((1.0-(vl/pc_t)),(1.0-modelPar_mc))))/(1.0-modelPar_mc));
          sel = (0.5*(vnl+1.0));
          crt = pow((1.0+(modelPar_vrt/pc_t)),(-modelPar_mc));
          cmx = pow((1.0+(dv0/pc_t)),(-modelPar_mc));
          cl = (((1.0-sel)*crt)+(sel*cmx));
          ql = (((Vbep-vl)+vl0)*cl);
          qdbep = ((ql+qlo)-qlo0);
        }
        else
        {
          mv0 = sqrt(((dv0*dv0)+((4*modelPar_ajc)*modelPar_ajc)));
          vl0 = ((-0.5)*(dv0+mv0));
          q0 = (((-pc_t)*pow((1.0-(vl0/pc_t)),(1.0-modelPar_mc)))/(1.0-modelPar_mc));
          dv = (Vbep+dv0);
          mv = sqrt(((dv*dv)+((4*modelPar_ajc)*modelPar_ajc)));
          vl = ((0.5*(dv-mv))-dv0);
          qlo = (((-pc_t)*pow((1.0-(vl/pc_t)),(1.0-modelPar_mc)))/(1.0-modelPar_mc));
          qdbep = ((qlo+(pow((1.0-modelPar_fc),(-modelPar_mc))*((Vbep-vl)+vl0)))-q0);
        }
      }
    }
    // End block qdbepBlock
    sgIf = ((Ifi>0.0)?1.0:0.0);
    rIf = ((Ifi*sgIf)*modelVar_Iitf);
    mIf = (rIf/(rIf+1.0));
    arg = ((Vbci*modelVar_Ivtf)/1.44);
    if ((arg<modelVar_VmaxExp))
    {
      expi = exp(arg);
    }
    else
    {
      expi = (exp(modelVar_VmaxExp)*(1.0+(arg-modelVar_VmaxExp)));
    }
    tff = ((modelPar_tf*(1.0+(modelPar_qtf*q1)))*(1.0+(((modelPar_xtf*expi)*(modelVar_sltf+(mIf*mIf)))*sgIf)));
    Qbe = (((cje_t*qdbe)*modelPar_wbe)+((tff*Ifi)/instanceVar_qb));
    Qbex = ((cje_t*qdbex)*(1.0-modelPar_wbe));
    Qbc = (((cjc_t*qdbc)+(modelPar_tr*Iri))+(modelPar_qco*Kbci));
    Qbcx = (modelPar_qco*Kbcx);
    Qbep = ((cjep_t*qdbep)+(modelPar_tr*Ifp));
    Qbcp = ((cjcp_t*qdbcp)+(modelPar_ccso*Vbcp));
    Qbeo = (Vbe*modelPar_cbeo);
    Qbco = (Vbc*modelPar_cbco);
    Qcth = (dt_et*modelPar_cth);
    Qxf1 = (modelPar_td*Vxf1);
    Qxf2 = ((modelPar_td*Vxf2)*0.3333333333333333);
    Qbe = ((modelPar_VBICtype*instanceVar_mMod)*Qbe);
    Qbex = ((modelPar_VBICtype*instanceVar_mMod)*Qbex);
    Qbc = ((modelPar_VBICtype*instanceVar_mMod)*Qbc);
    Qbcx = ((modelPar_VBICtype*instanceVar_mMod)*Qbcx);
    Qbep = ((modelPar_VBICtype*instanceVar_mMod)*Qbep);
    Qbeo = (instanceVar_mMod*Qbeo);
    Qbco = (instanceVar_mMod*Qbco);
    Qbcp = ((modelPar_VBICtype*instanceVar_mMod)*Qbcp);
    Qcth = (instanceVar_mMod*Qcth);
  }
  // End block evaluateDynamic
  //Begin block loadStatic
  {
    // I(bi,ei) <+ (Ibe)
    staticContributions[admsNodeID_bi] += instanceVar_Ibe;
    staticContributions[admsNodeID_ei] -= instanceVar_Ibe;
    // I(bx,ei) <+ (Ibex)
    staticContributions[admsNodeID_bx] += instanceVar_Ibex;
    staticContributions[admsNodeID_ei] -= instanceVar_Ibex;
    // I(ci,ei) <+ (Itxf)
    staticContributions[admsNodeID_ci] += Itxf;
    staticContributions[admsNodeID_ei] -= Itxf;
    // I(ei,ci) <+ (Itzr)
    staticContributions[admsNodeID_ei] += Itzr;
    staticContributions[admsNodeID_ci] -= Itzr;
    // I(bi,ci) <+ (Ibc)
    staticContributions[admsNodeID_bi] += Ibc;
    staticContributions[admsNodeID_ci] -= Ibc;
    // I(bx,cx) <+ (Igcx)
    staticContributions[admsNodeID_bx] += Igcx;
    staticContributions[admsNodeID_cx] -= Igcx;
    // I(bx,bp) <+ (Ibep)
    staticContributions[admsNodeID_bx] += instanceVar_Ibep;
    staticContributions[admsNodeID_bp] -= instanceVar_Ibep;
    // I(c,cx) <+ (Ircx)
    staticContributions[admsNodeID_c] += Ircx;
    staticContributions[admsNodeID_cx] -= Ircx;
    // I(cx,ci) <+ (Irci)
    staticContributions[admsNodeID_cx] += instanceVar_Irci;
    staticContributions[admsNodeID_ci] -= instanceVar_Irci;
    // I(b,bx) <+ (Irbx)
    staticContributions[admsNodeID_b] += Irbx;
    staticContributions[admsNodeID_bx] -= Irbx;
    // I(bx,bi) <+ (Irbi)
    staticContributions[admsNodeID_bx] += Irbi;
    staticContributions[admsNodeID_bi] -= Irbi;
    // I(e,ei) <+ (Ire)
    staticContributions[admsNodeID_e] += Ire;
    staticContributions[admsNodeID_ei] -= Ire;
    // I(bp,cx) <+ (Irbp)
    staticContributions[admsNodeID_bp] += Irbp;
    staticContributions[admsNodeID_cx] -= Irbp;
    // I(si,bp) <+ (Ibcp)
    staticContributions[admsNodeID_si] += Ibcp;
    staticContributions[admsNodeID_bp] -= Ibcp;
    // I(bx,si) <+ (Iccp)
    staticContributions[admsNodeID_bx] += instanceVar_Iccp;
    staticContributions[admsNodeID_si] -= instanceVar_Iccp;
    // I(s,si) <+ (Irs)
    staticContributions[admsNodeID_s] += Irs;
    staticContributions[admsNodeID_si] -= Irs;
    // I(xf1,GND) <+ (Ixf1)
    staticContributions[admsNodeID_xf1] += Ixf1;
    // I(xf2,GND) <+ (Ixf2)
    staticContributions[admsNodeID_xf2] += Ixf2;
    // Pwr(dt,GND) <+ (Irth)
    staticContributions[admsNodeID_dt] += Irth;
    // Pwr(dt,GND) <+ (Ith)
    staticContributions[admsNodeID_dt] += Ith;
  }
  // End block loadStatic
  //Begin block loadDynamic
  {
    // I(bi,ei) <+ (ddt(Qbe))
    dynamicContributions[admsNodeID_bi] += (Qbe);
    dynamicContributions[admsNodeID_ei] -= (Qbe);
    // I(bx,ei) <+ (ddt(Qbex))
    dynamicContributions[admsNodeID_bx] += (Qbex);
    dynamicContributions[admsNodeID_ei] -= (Qbex);
    // I(bi,ci) <+ (ddt(Qbc))
    dynamicContributions[admsNodeID_bi] += (Qbc);
    dynamicContributions[admsNodeID_ci] -= (Qbc);
    // I(bi,cx) <+ (ddt(Qbcx))
    dynamicContributions[admsNodeID_bi] += (Qbcx);
    dynamicContributions[admsNodeID_cx] -= (Qbcx);
    // I(bx,bp) <+ (ddt(Qbep))
    dynamicContributions[admsNodeID_bx] += (Qbep);
    dynamicContributions[admsNodeID_bp] -= (Qbep);
    // I(b,e) <+ (ddt(Qbeo))
    dynamicContributions[admsNodeID_b] += (Qbeo);
    dynamicContributions[admsNodeID_e] -= (Qbeo);
    // I(b,c) <+ (ddt(Qbco))
    dynamicContributions[admsNodeID_b] += (Qbco);
    dynamicContributions[admsNodeID_c] -= (Qbco);
    // I(si,bp) <+ (ddt(Qbcp))
    dynamicContributions[admsNodeID_si] += (Qbcp);
    dynamicContributions[admsNodeID_bp] -= (Qbcp);
    // I(xf1,GND) <+ (ddt(Qxf1))
    dynamicContributions[admsNodeID_xf1] += (Qxf1);
    // I(xf2,GND) <+ (ddt(Qxf2))
    dynamicContributions[admsNodeID_xf2] += (Qxf2);
    // Pwr(dt,GND) <+ (ddt(Qcth))
    dynamicContributions[admsNodeID_dt] += (Qcth);
  }
  // End block loadDynamic
}



//-----------------------------------------------------------------------------
// Function      : InstanceSensitivity::operator()
// Purpose       : return sensitivity for a single instance parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
/// Compute sensitivity of a device instance's outputs to a specified instance
/// parameter
/// 
/// 
/// @param[in] entity  The device entity that owns the parameter 
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
/// 
/// 
void InstanceSensitivity::operator()
  (
     const ParameterBase &entity,
     const std::string &name,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
   ) const
{
  const ParameterBase * e1 = &entity;
  const Instance & in = *(dynamic_cast<const Instance *> (e1));
  const Model & mod =in.model_;

  dfdp.resize(14+0);
  dqdp.resize(14+0);
  Findices.resize(14+0);
  Qindices.resize(14+0);

  std::vector <double> probeVars(21);
  std::vector <AdmsSensFadType> staticContributions(14+0);
  std::vector <AdmsSensFadType> dynamicContributions(14+0);


  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 14+0 ; ++i)
  {
    staticContributions[i]=0;
    dynamicContributions[i]=0;
  }

  // Copy out all the model parameters (doubles) into FAD types
  //reals
  AdmsSensFadType modelPar_npn=mod.npn;
  bool modelPar_given_npn=mod.given("npn");
  AdmsSensFadType modelPar_pnp=mod.pnp;
  bool modelPar_given_pnp=mod.given("pnp");
  AdmsSensFadType modelPar_scale=mod.scale;
  bool modelPar_given_scale=mod.given("scale");
  AdmsSensFadType modelPar_shrink=mod.shrink;
  bool modelPar_given_shrink=mod.given("shrink");
  AdmsSensFadType modelPar_tmin=mod.tmin;
  bool modelPar_given_tmin=mod.given("tmin");
  AdmsSensFadType modelPar_tmax=mod.tmax;
  bool modelPar_given_tmax=mod.given("tmax");
  AdmsSensFadType modelPar_gmin=mod.gmin;
  bool modelPar_given_gmin=mod.given("gmin");
  AdmsSensFadType modelPar_pnjmaxi=mod.pnjmaxi;
  bool modelPar_given_pnjmaxi=mod.given("pnjmaxi");
  AdmsSensFadType modelPar_maxexp=mod.maxexp;
  bool modelPar_given_maxexp=mod.given("maxexp");
  AdmsSensFadType modelPar_tnom=mod.tnom;
  bool modelPar_given_tnom=mod.given("tnom");
  AdmsSensFadType modelPar_tminclip=mod.tminclip;
  bool modelPar_given_tminclip=mod.given("tminclip");
  AdmsSensFadType modelPar_tmaxclip=mod.tmaxclip;
  bool modelPar_given_tmaxclip=mod.given("tmaxclip");
  AdmsSensFadType modelPar_rcx=mod.rcx;
  bool modelPar_given_rcx=mod.given("rcx");
  AdmsSensFadType modelPar_rci=mod.rci;
  bool modelPar_given_rci=mod.given("rci");
  AdmsSensFadType modelPar_vo=mod.vo;
  bool modelPar_given_vo=mod.given("vo");
  AdmsSensFadType modelPar_gamm=mod.gamm;
  bool modelPar_given_gamm=mod.given("gamm");
  AdmsSensFadType modelPar_hrcf=mod.hrcf;
  bool modelPar_given_hrcf=mod.given("hrcf");
  AdmsSensFadType modelPar_rbx=mod.rbx;
  bool modelPar_given_rbx=mod.given("rbx");
  AdmsSensFadType modelPar_rbi=mod.rbi;
  bool modelPar_given_rbi=mod.given("rbi");
  AdmsSensFadType modelPar_re=mod.re;
  bool modelPar_given_re=mod.given("re");
  AdmsSensFadType modelPar_rs=mod.rs;
  bool modelPar_given_rs=mod.given("rs");
  AdmsSensFadType modelPar_rbp=mod.rbp;
  bool modelPar_given_rbp=mod.given("rbp");
  AdmsSensFadType modelPar_is=mod.is;
  bool modelPar_given_is=mod.given("is");
  AdmsSensFadType modelPar_isrr=mod.isrr;
  bool modelPar_given_isrr=mod.given("isrr");
  AdmsSensFadType modelPar_nf=mod.nf;
  bool modelPar_given_nf=mod.given("nf");
  AdmsSensFadType modelPar_nr=mod.nr;
  bool modelPar_given_nr=mod.given("nr");
  AdmsSensFadType modelPar_isp=mod.isp;
  bool modelPar_given_isp=mod.given("isp");
  AdmsSensFadType modelPar_wsp=mod.wsp;
  bool modelPar_given_wsp=mod.given("wsp");
  AdmsSensFadType modelPar_nfp=mod.nfp;
  bool modelPar_given_nfp=mod.given("nfp");
  AdmsSensFadType modelPar_fc=mod.fc;
  bool modelPar_given_fc=mod.given("fc");
  AdmsSensFadType modelPar_cbeo=mod.cbeo;
  bool modelPar_given_cbeo=mod.given("cbeo");
  AdmsSensFadType modelPar_cje=mod.cje;
  bool modelPar_given_cje=mod.given("cje");
  AdmsSensFadType modelPar_pe=mod.pe;
  bool modelPar_given_pe=mod.given("pe");
  AdmsSensFadType modelPar_me=mod.me;
  bool modelPar_given_me=mod.given("me");
  AdmsSensFadType modelPar_aje=mod.aje;
  bool modelPar_given_aje=mod.given("aje");
  AdmsSensFadType modelPar_cbco=mod.cbco;
  bool modelPar_given_cbco=mod.given("cbco");
  AdmsSensFadType modelPar_cjc=mod.cjc;
  bool modelPar_given_cjc=mod.given("cjc");
  AdmsSensFadType modelPar_pc=mod.pc;
  bool modelPar_given_pc=mod.given("pc");
  AdmsSensFadType modelPar_mc=mod.mc;
  bool modelPar_given_mc=mod.given("mc");
  AdmsSensFadType modelPar_ajc=mod.ajc;
  bool modelPar_given_ajc=mod.given("ajc");
  AdmsSensFadType modelPar_vrt=mod.vrt;
  bool modelPar_given_vrt=mod.given("vrt");
  AdmsSensFadType modelPar_art=mod.art;
  bool modelPar_given_art=mod.given("art");
  AdmsSensFadType modelPar_qco=mod.qco;
  bool modelPar_given_qco=mod.given("qco");
  AdmsSensFadType modelPar_cjep=mod.cjep;
  bool modelPar_given_cjep=mod.given("cjep");
  AdmsSensFadType modelPar_cjcp=mod.cjcp;
  bool modelPar_given_cjcp=mod.given("cjcp");
  AdmsSensFadType modelPar_ps=mod.ps;
  bool modelPar_given_ps=mod.given("ps");
  AdmsSensFadType modelPar_ms=mod.ms;
  bool modelPar_given_ms=mod.given("ms");
  AdmsSensFadType modelPar_ajs=mod.ajs;
  bool modelPar_given_ajs=mod.given("ajs");
  AdmsSensFadType modelPar_ccso=mod.ccso;
  bool modelPar_given_ccso=mod.given("ccso");
  AdmsSensFadType modelPar_ibei=mod.ibei;
  bool modelPar_given_ibei=mod.given("ibei");
  AdmsSensFadType modelPar_wbe=mod.wbe;
  bool modelPar_given_wbe=mod.given("wbe");
  AdmsSensFadType modelPar_nei=mod.nei;
  bool modelPar_given_nei=mod.given("nei");
  AdmsSensFadType modelPar_qnibeir=mod.qnibeir;
  bool modelPar_given_qnibeir=mod.given("qnibeir");
  AdmsSensFadType modelPar_iben=mod.iben;
  bool modelPar_given_iben=mod.given("iben");
  AdmsSensFadType modelPar_nen=mod.nen;
  bool modelPar_given_nen=mod.given("nen");
  AdmsSensFadType modelPar_ibci=mod.ibci;
  bool modelPar_given_ibci=mod.given("ibci");
  AdmsSensFadType modelPar_nci=mod.nci;
  bool modelPar_given_nci=mod.given("nci");
  AdmsSensFadType modelPar_ibcn=mod.ibcn;
  bool modelPar_given_ibcn=mod.given("ibcn");
  AdmsSensFadType modelPar_ncn=mod.ncn;
  bool modelPar_given_ncn=mod.given("ncn");
  AdmsSensFadType modelPar_ibeip=mod.ibeip;
  bool modelPar_given_ibeip=mod.given("ibeip");
  AdmsSensFadType modelPar_ibenp=mod.ibenp;
  bool modelPar_given_ibenp=mod.given("ibenp");
  AdmsSensFadType modelPar_ibcip=mod.ibcip;
  bool modelPar_given_ibcip=mod.given("ibcip");
  AdmsSensFadType modelPar_ncip=mod.ncip;
  bool modelPar_given_ncip=mod.given("ncip");
  AdmsSensFadType modelPar_ibcnp=mod.ibcnp;
  bool modelPar_given_ibcnp=mod.given("ibcnp");
  AdmsSensFadType modelPar_ncnp=mod.ncnp;
  bool modelPar_given_ncnp=mod.given("ncnp");
  AdmsSensFadType modelPar_vef=mod.vef;
  bool modelPar_given_vef=mod.given("vef");
  AdmsSensFadType modelPar_ver=mod.ver;
  bool modelPar_given_ver=mod.given("ver");
  AdmsSensFadType modelPar_ikf=mod.ikf;
  bool modelPar_given_ikf=mod.given("ikf");
  AdmsSensFadType modelPar_nkf=mod.nkf;
  bool modelPar_given_nkf=mod.given("nkf");
  AdmsSensFadType modelPar_ikr=mod.ikr;
  bool modelPar_given_ikr=mod.given("ikr");
  AdmsSensFadType modelPar_ikp=mod.ikp;
  bool modelPar_given_ikp=mod.given("ikp");
  AdmsSensFadType modelPar_tf=mod.tf;
  bool modelPar_given_tf=mod.given("tf");
  AdmsSensFadType modelPar_qtf=mod.qtf;
  bool modelPar_given_qtf=mod.given("qtf");
  AdmsSensFadType modelPar_xtf=mod.xtf;
  bool modelPar_given_xtf=mod.given("xtf");
  AdmsSensFadType modelPar_vtf=mod.vtf;
  bool modelPar_given_vtf=mod.given("vtf");
  AdmsSensFadType modelPar_itf=mod.itf;
  bool modelPar_given_itf=mod.given("itf");
  AdmsSensFadType modelPar_tr=mod.tr;
  bool modelPar_given_tr=mod.given("tr");
  AdmsSensFadType modelPar_td=mod.td;
  bool modelPar_given_td=mod.given("td");
  AdmsSensFadType modelPar_avc1=mod.avc1;
  bool modelPar_given_avc1=mod.given("avc1");
  AdmsSensFadType modelPar_avc2=mod.avc2;
  bool modelPar_given_avc2=mod.given("avc2");
  AdmsSensFadType modelPar_avcx1=mod.avcx1;
  bool modelPar_given_avcx1=mod.given("avcx1");
  AdmsSensFadType modelPar_avcx2=mod.avcx2;
  bool modelPar_given_avcx2=mod.given("avcx2");
  AdmsSensFadType modelPar_mcx=mod.mcx;
  bool modelPar_given_mcx=mod.given("mcx");
  AdmsSensFadType modelPar_vbbe=mod.vbbe;
  bool modelPar_given_vbbe=mod.given("vbbe");
  AdmsSensFadType modelPar_nbbe=mod.nbbe;
  bool modelPar_given_nbbe=mod.given("nbbe");
  AdmsSensFadType modelPar_ibbe=mod.ibbe;
  bool modelPar_given_ibbe=mod.given("ibbe");
  AdmsSensFadType modelPar_tvbbe1=mod.tvbbe1;
  bool modelPar_given_tvbbe1=mod.given("tvbbe1");
  AdmsSensFadType modelPar_tvbbe2=mod.tvbbe2;
  bool modelPar_given_tvbbe2=mod.given("tvbbe2");
  AdmsSensFadType modelPar_tnbbe=mod.tnbbe;
  bool modelPar_given_tnbbe=mod.given("tnbbe");
  AdmsSensFadType modelPar_vpte=mod.vpte;
  bool modelPar_given_vpte=mod.given("vpte");
  AdmsSensFadType modelPar_ibk0=mod.ibk0;
  bool modelPar_given_ibk0=mod.given("ibk0");
  AdmsSensFadType modelPar_abk=mod.abk;
  bool modelPar_given_abk=mod.given("abk");
  AdmsSensFadType modelPar_bbk=mod.bbk;
  bool modelPar_given_bbk=mod.given("bbk");
  AdmsSensFadType modelPar_kfn=mod.kfn;
  bool modelPar_given_kfn=mod.given("kfn");
  AdmsSensFadType modelPar_afn=mod.afn;
  bool modelPar_given_afn=mod.given("afn");
  AdmsSensFadType modelPar_bfn=mod.bfn;
  bool modelPar_given_bfn=mod.given("bfn");
  AdmsSensFadType modelPar_rth=mod.rth;
  bool modelPar_given_rth=mod.given("rth");
  AdmsSensFadType modelPar_cth=mod.cth;
  bool modelPar_given_cth=mod.given("cth");
  AdmsSensFadType modelPar_xre=mod.xre;
  bool modelPar_given_xre=mod.given("xre");
  AdmsSensFadType modelPar_xrb=mod.xrb;
  bool modelPar_given_xrb=mod.given("xrb");
  AdmsSensFadType modelPar_xrbi=mod.xrbi;
  bool modelPar_given_xrbi=mod.given("xrbi");
  AdmsSensFadType modelPar_xrbx=mod.xrbx;
  bool modelPar_given_xrbx=mod.given("xrbx");
  AdmsSensFadType modelPar_xrc=mod.xrc;
  bool modelPar_given_xrc=mod.given("xrc");
  AdmsSensFadType modelPar_xrci=mod.xrci;
  bool modelPar_given_xrci=mod.given("xrci");
  AdmsSensFadType modelPar_xrcx=mod.xrcx;
  bool modelPar_given_xrcx=mod.given("xrcx");
  AdmsSensFadType modelPar_xrbp=mod.xrbp;
  bool modelPar_given_xrbp=mod.given("xrbp");
  AdmsSensFadType modelPar_xrs=mod.xrs;
  bool modelPar_given_xrs=mod.given("xrs");
  AdmsSensFadType modelPar_xvo=mod.xvo;
  bool modelPar_given_xvo=mod.given("xvo");
  AdmsSensFadType modelPar_ea=mod.ea;
  bool modelPar_given_ea=mod.given("ea");
  AdmsSensFadType modelPar_eaie=mod.eaie;
  bool modelPar_given_eaie=mod.given("eaie");
  AdmsSensFadType modelPar_eaic=mod.eaic;
  bool modelPar_given_eaic=mod.given("eaic");
  AdmsSensFadType modelPar_eais=mod.eais;
  bool modelPar_given_eais=mod.given("eais");
  AdmsSensFadType modelPar_eane=mod.eane;
  bool modelPar_given_eane=mod.given("eane");
  AdmsSensFadType modelPar_eanc=mod.eanc;
  bool modelPar_given_eanc=mod.given("eanc");
  AdmsSensFadType modelPar_eans=mod.eans;
  bool modelPar_given_eans=mod.given("eans");
  AdmsSensFadType modelPar_eap=mod.eap;
  bool modelPar_given_eap=mod.given("eap");
  AdmsSensFadType modelPar_dear=mod.dear;
  bool modelPar_given_dear=mod.given("dear");
  AdmsSensFadType modelPar_xis=mod.xis;
  bool modelPar_given_xis=mod.given("xis");
  AdmsSensFadType modelPar_xii=mod.xii;
  bool modelPar_given_xii=mod.given("xii");
  AdmsSensFadType modelPar_xin=mod.xin;
  bool modelPar_given_xin=mod.given("xin");
  AdmsSensFadType modelPar_xisr=mod.xisr;
  bool modelPar_given_xisr=mod.given("xisr");
  AdmsSensFadType modelPar_xikf=mod.xikf;
  bool modelPar_given_xikf=mod.given("xikf");
  AdmsSensFadType modelPar_tavc=mod.tavc;
  bool modelPar_given_tavc=mod.given("tavc");
  AdmsSensFadType modelPar_tavcx=mod.tavcx;
  bool modelPar_given_tavcx=mod.given("tavcx");
  AdmsSensFadType modelPar_tnf=mod.tnf;
  bool modelPar_given_tnf=mod.given("tnf");
  AdmsSensFadType modelPar_tcvef=mod.tcvef;
  bool modelPar_given_tcvef=mod.given("tcvef");
  AdmsSensFadType modelPar_tcver=mod.tcver;
  bool modelPar_given_tcver=mod.given("tcver");
  AdmsSensFadType modelPar_tcrth=mod.tcrth;
  bool modelPar_given_tcrth=mod.given("tcrth");


  // hidden reals


  // non-reals (including hiddens)
  int modelPar_type=mod.type;
  bool modelPar_given_type=mod.given("type");
  int modelPar_VBICtype=mod.VBICtype;
  int modelPar_qbm=mod.qbm;
  bool modelPar_given_qbm=mod.given("qbm");



  // Copy out all the instance parameters (doubles) into FAD types
  // Keep a map so we can set the right one to the independent variable
  // We do this solely to avoid a big ugly "if/else" block just to find the
  // one parameter we're doing sensitivities on.
  unordered_map <std::string,AdmsSensFadType*,HashNoCase,EqualNoCase> inParamMap;

  // reals
  AdmsSensFadType instancePar_m=in.m;
  bool instancePar_given_m=in.given("m");
  inParamMap["m"] = &instancePar_m;
  AdmsSensFadType instancePar_trise=in.trise;
  bool instancePar_given_trise=in.given("trise");
  inParamMap["trise"] = &instancePar_trise;


  // Copy all the real hidden instance params into fad types



  // Copy all the non-real instance params into vars of their appropriate type:
  int instancePar_sw_noise=in.sw_noise;
  bool instancePar_given_sw_noise=in.given("sw_noise");
  int instancePar_sw_et=in.sw_et;
  bool instancePar_given_sw_et=in.given("sw_et");


  // Set the one parameter whose name was passed in to be the independent
  // variable for Sacado purposes.  Since we stored variable pointers, this
  // makes sure that that ONE variable gets set right.
  // FIXME: make this check the name first, otherwise segfault on invalid name!
  inParamMap[name]->diff(0,1);

  //make local copies of all instance vars
  //reals
  AdmsSensFadType instanceVar_is_t=in.is_t;
  AdmsSensFadType instanceVar_isrr_t=in.isrr_t;
  AdmsSensFadType instanceVar_ibei_t=in.ibei_t;
  AdmsSensFadType instanceVar_ibci_t=in.ibci_t;
  AdmsSensFadType instanceVar_isp_t=in.isp_t;
  AdmsSensFadType instanceVar_iben_t=in.iben_t;
  AdmsSensFadType instanceVar_ibcn_t=in.ibcn_t;
  AdmsSensFadType instanceVar_ibeip_t=in.ibeip_t;
  AdmsSensFadType instanceVar_ibenp_t=in.ibenp_t;
  AdmsSensFadType instanceVar_ibcip_t=in.ibcip_t;
  AdmsSensFadType instanceVar_ibcnp_t=in.ibcnp_t;
  AdmsSensFadType instanceVar_tdevC=in.tdevC;
  AdmsSensFadType instanceVar_tdevK=in.tdevK;
  AdmsSensFadType instanceVar_rT=in.rT;
  AdmsSensFadType instanceVar_Gcx=in.Gcx;
  AdmsSensFadType instanceVar_Gci=in.Gci;
  AdmsSensFadType instanceVar_Gbx=in.Gbx;
  AdmsSensFadType instanceVar_Gbi=in.Gbi;
  AdmsSensFadType instanceVar_Ge=in.Ge;
  AdmsSensFadType instanceVar_Gbp=in.Gbp;
  AdmsSensFadType instanceVar_Gs=in.Gs;
  AdmsSensFadType instanceVar_maxvIfi=in.maxvIfi;
  AdmsSensFadType instanceVar_maxvIri=in.maxvIri;
  AdmsSensFadType instanceVar_maxvIp=in.maxvIp;
  AdmsSensFadType instanceVar_maxvIbbe=in.maxvIbbe;
  AdmsSensFadType instanceVar_maxvIbei=in.maxvIbei;
  AdmsSensFadType instanceVar_maxvIben=in.maxvIben;
  AdmsSensFadType instanceVar_maxvIbci=in.maxvIbci;
  AdmsSensFadType instanceVar_maxvIbcn=in.maxvIbcn;
  AdmsSensFadType instanceVar_maxvIbeip=in.maxvIbeip;
  AdmsSensFadType instanceVar_maxvIbenp=in.maxvIbenp;
  AdmsSensFadType instanceVar_maxvIbcip=in.maxvIbcip;
  AdmsSensFadType instanceVar_maxvIbcnp=in.maxvIbcnp;
  AdmsSensFadType instanceVar_vtv=in.vtv;
  AdmsSensFadType instanceVar_Itzf=in.Itzf;
  AdmsSensFadType instanceVar_qb=in.qb;
  AdmsSensFadType instanceVar_Iccp=in.Iccp;
  AdmsSensFadType instanceVar_qbp=in.qbp;
  AdmsSensFadType instanceVar_Ibe=in.Ibe;
  AdmsSensFadType instanceVar_Ibex=in.Ibex;
  AdmsSensFadType instanceVar_Ibep=in.Ibep;
  AdmsSensFadType instanceVar_Irci=in.Irci;
  AdmsSensFadType instanceVar_Vrci=in.Vrci;
  AdmsSensFadType instanceVar_mMod=in.mMod;
  AdmsSensFadType instanceVar_tVCrit=in.tVCrit;


  //non-reals


  //make local copies of all model vars
  //reals
  AdmsSensFadType modelVar_tiniK=mod.tiniK;
  AdmsSensFadType modelVar_Iikr=mod.Iikr;
  AdmsSensFadType modelVar_Iikp=mod.Iikp;
  AdmsSensFadType modelVar_Ihrcf=mod.Ihrcf;
  AdmsSensFadType modelVar_Ivtf=mod.Ivtf;
  AdmsSensFadType modelVar_Iitf=mod.Iitf;
  AdmsSensFadType modelVar_sltf=mod.sltf;
  AdmsSensFadType modelVar_VmaxExp=mod.VmaxExp;
  AdmsSensFadType modelVar_gminMod=mod.gminMod;
  AdmsSensFadType modelVar_imaxMod=mod.imaxMod;


  // non-reals



  Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

  // extract solution variables and set as Fad independent variables.
  probeVars[in.admsProbeID_V_xf2_GND] = (*solVectorPtr)[in.li_xf2];
  probeVars[in.admsProbeID_V_xf1_GND] = (*solVectorPtr)[in.li_xf1];
  probeVars[in.admsProbeID_V_s_si] = (*solVectorPtr)[in.li_s]- (*solVectorPtr)[in.li_si];
  probeVars[in.admsProbeID_V_bx_si] = (*solVectorPtr)[in.li_bx]- (*solVectorPtr)[in.li_si];
  probeVars[in.admsProbeID_V_si_bp] = (*solVectorPtr)[in.li_si]- (*solVectorPtr)[in.li_bp];
  probeVars[in.admsProbeID_V_bp_cx] = (*solVectorPtr)[in.li_bp]- (*solVectorPtr)[in.li_cx];
  probeVars[in.admsProbeID_V_e_ei] = (*solVectorPtr)[in.li_e]- (*solVectorPtr)[in.li_ei];
  probeVars[in.admsProbeID_V_bx_bi] = (*solVectorPtr)[in.li_bx]- (*solVectorPtr)[in.li_bi];
  probeVars[in.admsProbeID_V_b_bx] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_bx];
  probeVars[in.admsProbeID_V_cx_ci] = (*solVectorPtr)[in.li_cx]- (*solVectorPtr)[in.li_ci];
  probeVars[in.admsProbeID_V_c_cx] = (*solVectorPtr)[in.li_c]- (*solVectorPtr)[in.li_cx];
  probeVars[in.admsProbeID_V_b_c] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_c];
  probeVars[in.admsProbeID_V_b_e] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_e];
  probeVars[in.admsProbeID_V_bx_bp] = (*solVectorPtr)[in.li_bx]- (*solVectorPtr)[in.li_bp];
  probeVars[in.admsProbeID_V_ci_ei] = (*solVectorPtr)[in.li_ci]- (*solVectorPtr)[in.li_ei];
  probeVars[in.admsProbeID_V_bx_cx] = (*solVectorPtr)[in.li_bx]- (*solVectorPtr)[in.li_cx];
  probeVars[in.admsProbeID_V_bi_cx] = (*solVectorPtr)[in.li_bi]- (*solVectorPtr)[in.li_cx];
  probeVars[in.admsProbeID_V_bi_ci] = (*solVectorPtr)[in.li_bi]- (*solVectorPtr)[in.li_ci];
  probeVars[in.admsProbeID_V_bx_ei] = (*solVectorPtr)[in.li_bx]- (*solVectorPtr)[in.li_ei];
  probeVars[in.admsProbeID_V_bi_ei] = (*solVectorPtr)[in.li_bi]- (*solVectorPtr)[in.li_ei];
  probeVars[in.admsProbeID_Temp_dt_GND] = (*solVectorPtr)[in.li_dt];


  // pre-multiply any "typed" probes (i.e. those limited with "typedpnjlim")
    
  probeVars[in.admsProbeID_V_bx_bp] *= modelPar_VBICtype;
  probeVars[in.admsProbeID_V_bx_cx] *= modelPar_VBICtype;
  probeVars[in.admsProbeID_V_bi_cx] *= modelPar_VBICtype;
  probeVars[in.admsProbeID_V_bi_ci] *= modelPar_VBICtype;
  probeVars[in.admsProbeID_V_bx_ei] *= modelPar_VBICtype;
  probeVars[in.admsProbeID_V_bi_ei] *= modelPar_VBICtype;


  // Need to use processParams-like function to process the
  // initial_model and initial_instance blocks with the LOCAL copies of
  // instance and model vars, and local copies of instance and model
  // params.
  evaluateInitialModel(
     // model parameters
     // reals
     modelPar_npn,
     modelPar_given_npn,
     modelPar_pnp,
     modelPar_given_pnp,
     modelPar_scale,
     modelPar_given_scale,
     modelPar_shrink,
     modelPar_given_shrink,
     modelPar_tmin,
     modelPar_given_tmin,
     modelPar_tmax,
     modelPar_given_tmax,
     modelPar_gmin,
     modelPar_given_gmin,
     modelPar_pnjmaxi,
     modelPar_given_pnjmaxi,
     modelPar_maxexp,
     modelPar_given_maxexp,
     modelPar_tnom,
     modelPar_given_tnom,
     modelPar_tminclip,
     modelPar_given_tminclip,
     modelPar_tmaxclip,
     modelPar_given_tmaxclip,
     modelPar_rcx,
     modelPar_given_rcx,
     modelPar_rci,
     modelPar_given_rci,
     modelPar_vo,
     modelPar_given_vo,
     modelPar_gamm,
     modelPar_given_gamm,
     modelPar_hrcf,
     modelPar_given_hrcf,
     modelPar_rbx,
     modelPar_given_rbx,
     modelPar_rbi,
     modelPar_given_rbi,
     modelPar_re,
     modelPar_given_re,
     modelPar_rs,
     modelPar_given_rs,
     modelPar_rbp,
     modelPar_given_rbp,
     modelPar_is,
     modelPar_given_is,
     modelPar_isrr,
     modelPar_given_isrr,
     modelPar_nf,
     modelPar_given_nf,
     modelPar_nr,
     modelPar_given_nr,
     modelPar_isp,
     modelPar_given_isp,
     modelPar_wsp,
     modelPar_given_wsp,
     modelPar_nfp,
     modelPar_given_nfp,
     modelPar_fc,
     modelPar_given_fc,
     modelPar_cbeo,
     modelPar_given_cbeo,
     modelPar_cje,
     modelPar_given_cje,
     modelPar_pe,
     modelPar_given_pe,
     modelPar_me,
     modelPar_given_me,
     modelPar_aje,
     modelPar_given_aje,
     modelPar_cbco,
     modelPar_given_cbco,
     modelPar_cjc,
     modelPar_given_cjc,
     modelPar_pc,
     modelPar_given_pc,
     modelPar_mc,
     modelPar_given_mc,
     modelPar_ajc,
     modelPar_given_ajc,
     modelPar_vrt,
     modelPar_given_vrt,
     modelPar_art,
     modelPar_given_art,
     modelPar_qco,
     modelPar_given_qco,
     modelPar_cjep,
     modelPar_given_cjep,
     modelPar_cjcp,
     modelPar_given_cjcp,
     modelPar_ps,
     modelPar_given_ps,
     modelPar_ms,
     modelPar_given_ms,
     modelPar_ajs,
     modelPar_given_ajs,
     modelPar_ccso,
     modelPar_given_ccso,
     modelPar_ibei,
     modelPar_given_ibei,
     modelPar_wbe,
     modelPar_given_wbe,
     modelPar_nei,
     modelPar_given_nei,
     modelPar_qnibeir,
     modelPar_given_qnibeir,
     modelPar_iben,
     modelPar_given_iben,
     modelPar_nen,
     modelPar_given_nen,
     modelPar_ibci,
     modelPar_given_ibci,
     modelPar_nci,
     modelPar_given_nci,
     modelPar_ibcn,
     modelPar_given_ibcn,
     modelPar_ncn,
     modelPar_given_ncn,
     modelPar_ibeip,
     modelPar_given_ibeip,
     modelPar_ibenp,
     modelPar_given_ibenp,
     modelPar_ibcip,
     modelPar_given_ibcip,
     modelPar_ncip,
     modelPar_given_ncip,
     modelPar_ibcnp,
     modelPar_given_ibcnp,
     modelPar_ncnp,
     modelPar_given_ncnp,
     modelPar_vef,
     modelPar_given_vef,
     modelPar_ver,
     modelPar_given_ver,
     modelPar_ikf,
     modelPar_given_ikf,
     modelPar_nkf,
     modelPar_given_nkf,
     modelPar_ikr,
     modelPar_given_ikr,
     modelPar_ikp,
     modelPar_given_ikp,
     modelPar_tf,
     modelPar_given_tf,
     modelPar_qtf,
     modelPar_given_qtf,
     modelPar_xtf,
     modelPar_given_xtf,
     modelPar_vtf,
     modelPar_given_vtf,
     modelPar_itf,
     modelPar_given_itf,
     modelPar_tr,
     modelPar_given_tr,
     modelPar_td,
     modelPar_given_td,
     modelPar_avc1,
     modelPar_given_avc1,
     modelPar_avc2,
     modelPar_given_avc2,
     modelPar_avcx1,
     modelPar_given_avcx1,
     modelPar_avcx2,
     modelPar_given_avcx2,
     modelPar_mcx,
     modelPar_given_mcx,
     modelPar_vbbe,
     modelPar_given_vbbe,
     modelPar_nbbe,
     modelPar_given_nbbe,
     modelPar_ibbe,
     modelPar_given_ibbe,
     modelPar_tvbbe1,
     modelPar_given_tvbbe1,
     modelPar_tvbbe2,
     modelPar_given_tvbbe2,
     modelPar_tnbbe,
     modelPar_given_tnbbe,
     modelPar_vpte,
     modelPar_given_vpte,
     modelPar_ibk0,
     modelPar_given_ibk0,
     modelPar_abk,
     modelPar_given_abk,
     modelPar_bbk,
     modelPar_given_bbk,
     modelPar_kfn,
     modelPar_given_kfn,
     modelPar_afn,
     modelPar_given_afn,
     modelPar_bfn,
     modelPar_given_bfn,
     modelPar_rth,
     modelPar_given_rth,
     modelPar_cth,
     modelPar_given_cth,
     modelPar_xre,
     modelPar_given_xre,
     modelPar_xrb,
     modelPar_given_xrb,
     modelPar_xrbi,
     modelPar_given_xrbi,
     modelPar_xrbx,
     modelPar_given_xrbx,
     modelPar_xrc,
     modelPar_given_xrc,
     modelPar_xrci,
     modelPar_given_xrci,
     modelPar_xrcx,
     modelPar_given_xrcx,
     modelPar_xrbp,
     modelPar_given_xrbp,
     modelPar_xrs,
     modelPar_given_xrs,
     modelPar_xvo,
     modelPar_given_xvo,
     modelPar_ea,
     modelPar_given_ea,
     modelPar_eaie,
     modelPar_given_eaie,
     modelPar_eaic,
     modelPar_given_eaic,
     modelPar_eais,
     modelPar_given_eais,
     modelPar_eane,
     modelPar_given_eane,
     modelPar_eanc,
     modelPar_given_eanc,
     modelPar_eans,
     modelPar_given_eans,
     modelPar_eap,
     modelPar_given_eap,
     modelPar_dear,
     modelPar_given_dear,
     modelPar_xis,
     modelPar_given_xis,
     modelPar_xii,
     modelPar_given_xii,
     modelPar_xin,
     modelPar_given_xin,
     modelPar_xisr,
     modelPar_given_xisr,
     modelPar_xikf,
     modelPar_given_xikf,
     modelPar_tavc,
     modelPar_given_tavc,
     modelPar_tavcx,
     modelPar_given_tavcx,
     modelPar_tnf,
     modelPar_given_tnf,
     modelPar_tcvef,
     modelPar_given_tcvef,
     modelPar_tcver,
     modelPar_given_tcver,
     modelPar_tcrth,
     modelPar_given_tcrth,
     // non-reals (including hidden)
     modelPar_type,
     modelPar_given_type,
     modelPar_VBICtype,
     modelPar_qbm,
     modelPar_given_qbm// model variables
     ,
     // reals
     modelVar_tiniK,
     modelVar_Iikr,
     modelVar_Iikp,
     modelVar_Ihrcf,
     modelVar_Ivtf,
     modelVar_Iitf,
     modelVar_sltf,
     modelVar_VmaxExp,
     modelVar_gminMod,
     modelVar_imaxMod,
     mod.admsModTemp,in.getDeviceOptions().gmin,in);
  evaluateInitialInstance(
     // instance parameters
     // reals
     instancePar_m,
     instancePar_given_m,
     instancePar_trise,
     instancePar_given_trise,
     // non-reals(including hidden)
     instancePar_sw_noise,
     instancePar_given_sw_noise,
     instancePar_sw_et,
     instancePar_given_sw_et,
     // instance variables
     // reals
     instanceVar_is_t,
     instanceVar_isrr_t,
     instanceVar_ibei_t,
     instanceVar_ibci_t,
     instanceVar_isp_t,
     instanceVar_iben_t,
     instanceVar_ibcn_t,
     instanceVar_ibeip_t,
     instanceVar_ibenp_t,
     instanceVar_ibcip_t,
     instanceVar_ibcnp_t,
     instanceVar_tdevC,
     instanceVar_tdevK,
     instanceVar_rT,
     instanceVar_Gcx,
     instanceVar_Gci,
     instanceVar_Gbx,
     instanceVar_Gbi,
     instanceVar_Ge,
     instanceVar_Gbp,
     instanceVar_Gs,
     instanceVar_maxvIfi,
     instanceVar_maxvIri,
     instanceVar_maxvIp,
     instanceVar_maxvIbbe,
     instanceVar_maxvIbei,
     instanceVar_maxvIben,
     instanceVar_maxvIbci,
     instanceVar_maxvIbcn,
     instanceVar_maxvIbeip,
     instanceVar_maxvIbenp,
     instanceVar_maxvIbcip,
     instanceVar_maxvIbcnp,
     instanceVar_vtv,
     instanceVar_Itzf,
     instanceVar_qb,
     instanceVar_Iccp,
     instanceVar_qbp,
     instanceVar_Ibe,
     instanceVar_Ibex,
     instanceVar_Ibep,
     instanceVar_Irci,
     instanceVar_Vrci,
     instanceVar_mMod,
     instanceVar_tVCrit,
     // model parameters
     // reals
     modelPar_npn,
     modelPar_given_npn,
     modelPar_pnp,
     modelPar_given_pnp,
     modelPar_scale,
     modelPar_given_scale,
     modelPar_shrink,
     modelPar_given_shrink,
     modelPar_tmin,
     modelPar_given_tmin,
     modelPar_tmax,
     modelPar_given_tmax,
     modelPar_gmin,
     modelPar_given_gmin,
     modelPar_pnjmaxi,
     modelPar_given_pnjmaxi,
     modelPar_maxexp,
     modelPar_given_maxexp,
     modelPar_tnom,
     modelPar_given_tnom,
     modelPar_tminclip,
     modelPar_given_tminclip,
     modelPar_tmaxclip,
     modelPar_given_tmaxclip,
     modelPar_rcx,
     modelPar_given_rcx,
     modelPar_rci,
     modelPar_given_rci,
     modelPar_vo,
     modelPar_given_vo,
     modelPar_gamm,
     modelPar_given_gamm,
     modelPar_hrcf,
     modelPar_given_hrcf,
     modelPar_rbx,
     modelPar_given_rbx,
     modelPar_rbi,
     modelPar_given_rbi,
     modelPar_re,
     modelPar_given_re,
     modelPar_rs,
     modelPar_given_rs,
     modelPar_rbp,
     modelPar_given_rbp,
     modelPar_is,
     modelPar_given_is,
     modelPar_isrr,
     modelPar_given_isrr,
     modelPar_nf,
     modelPar_given_nf,
     modelPar_nr,
     modelPar_given_nr,
     modelPar_isp,
     modelPar_given_isp,
     modelPar_wsp,
     modelPar_given_wsp,
     modelPar_nfp,
     modelPar_given_nfp,
     modelPar_fc,
     modelPar_given_fc,
     modelPar_cbeo,
     modelPar_given_cbeo,
     modelPar_cje,
     modelPar_given_cje,
     modelPar_pe,
     modelPar_given_pe,
     modelPar_me,
     modelPar_given_me,
     modelPar_aje,
     modelPar_given_aje,
     modelPar_cbco,
     modelPar_given_cbco,
     modelPar_cjc,
     modelPar_given_cjc,
     modelPar_pc,
     modelPar_given_pc,
     modelPar_mc,
     modelPar_given_mc,
     modelPar_ajc,
     modelPar_given_ajc,
     modelPar_vrt,
     modelPar_given_vrt,
     modelPar_art,
     modelPar_given_art,
     modelPar_qco,
     modelPar_given_qco,
     modelPar_cjep,
     modelPar_given_cjep,
     modelPar_cjcp,
     modelPar_given_cjcp,
     modelPar_ps,
     modelPar_given_ps,
     modelPar_ms,
     modelPar_given_ms,
     modelPar_ajs,
     modelPar_given_ajs,
     modelPar_ccso,
     modelPar_given_ccso,
     modelPar_ibei,
     modelPar_given_ibei,
     modelPar_wbe,
     modelPar_given_wbe,
     modelPar_nei,
     modelPar_given_nei,
     modelPar_qnibeir,
     modelPar_given_qnibeir,
     modelPar_iben,
     modelPar_given_iben,
     modelPar_nen,
     modelPar_given_nen,
     modelPar_ibci,
     modelPar_given_ibci,
     modelPar_nci,
     modelPar_given_nci,
     modelPar_ibcn,
     modelPar_given_ibcn,
     modelPar_ncn,
     modelPar_given_ncn,
     modelPar_ibeip,
     modelPar_given_ibeip,
     modelPar_ibenp,
     modelPar_given_ibenp,
     modelPar_ibcip,
     modelPar_given_ibcip,
     modelPar_ncip,
     modelPar_given_ncip,
     modelPar_ibcnp,
     modelPar_given_ibcnp,
     modelPar_ncnp,
     modelPar_given_ncnp,
     modelPar_vef,
     modelPar_given_vef,
     modelPar_ver,
     modelPar_given_ver,
     modelPar_ikf,
     modelPar_given_ikf,
     modelPar_nkf,
     modelPar_given_nkf,
     modelPar_ikr,
     modelPar_given_ikr,
     modelPar_ikp,
     modelPar_given_ikp,
     modelPar_tf,
     modelPar_given_tf,
     modelPar_qtf,
     modelPar_given_qtf,
     modelPar_xtf,
     modelPar_given_xtf,
     modelPar_vtf,
     modelPar_given_vtf,
     modelPar_itf,
     modelPar_given_itf,
     modelPar_tr,
     modelPar_given_tr,
     modelPar_td,
     modelPar_given_td,
     modelPar_avc1,
     modelPar_given_avc1,
     modelPar_avc2,
     modelPar_given_avc2,
     modelPar_avcx1,
     modelPar_given_avcx1,
     modelPar_avcx2,
     modelPar_given_avcx2,
     modelPar_mcx,
     modelPar_given_mcx,
     modelPar_vbbe,
     modelPar_given_vbbe,
     modelPar_nbbe,
     modelPar_given_nbbe,
     modelPar_ibbe,
     modelPar_given_ibbe,
     modelPar_tvbbe1,
     modelPar_given_tvbbe1,
     modelPar_tvbbe2,
     modelPar_given_tvbbe2,
     modelPar_tnbbe,
     modelPar_given_tnbbe,
     modelPar_vpte,
     modelPar_given_vpte,
     modelPar_ibk0,
     modelPar_given_ibk0,
     modelPar_abk,
     modelPar_given_abk,
     modelPar_bbk,
     modelPar_given_bbk,
     modelPar_kfn,
     modelPar_given_kfn,
     modelPar_afn,
     modelPar_given_afn,
     modelPar_bfn,
     modelPar_given_bfn,
     modelPar_rth,
     modelPar_given_rth,
     modelPar_cth,
     modelPar_given_cth,
     modelPar_xre,
     modelPar_given_xre,
     modelPar_xrb,
     modelPar_given_xrb,
     modelPar_xrbi,
     modelPar_given_xrbi,
     modelPar_xrbx,
     modelPar_given_xrbx,
     modelPar_xrc,
     modelPar_given_xrc,
     modelPar_xrci,
     modelPar_given_xrci,
     modelPar_xrcx,
     modelPar_given_xrcx,
     modelPar_xrbp,
     modelPar_given_xrbp,
     modelPar_xrs,
     modelPar_given_xrs,
     modelPar_xvo,
     modelPar_given_xvo,
     modelPar_ea,
     modelPar_given_ea,
     modelPar_eaie,
     modelPar_given_eaie,
     modelPar_eaic,
     modelPar_given_eaic,
     modelPar_eais,
     modelPar_given_eais,
     modelPar_eane,
     modelPar_given_eane,
     modelPar_eanc,
     modelPar_given_eanc,
     modelPar_eans,
     modelPar_given_eans,
     modelPar_eap,
     modelPar_given_eap,
     modelPar_dear,
     modelPar_given_dear,
     modelPar_xis,
     modelPar_given_xis,
     modelPar_xii,
     modelPar_given_xii,
     modelPar_xin,
     modelPar_given_xin,
     modelPar_xisr,
     modelPar_given_xisr,
     modelPar_xikf,
     modelPar_given_xikf,
     modelPar_tavc,
     modelPar_given_tavc,
     modelPar_tavcx,
     modelPar_given_tavcx,
     modelPar_tnf,
     modelPar_given_tnf,
     modelPar_tcvef,
     modelPar_given_tcvef,
     modelPar_tcver,
     modelPar_given_tcver,
     modelPar_tcrth,
     modelPar_given_tcrth,
     // non-reals (including hidden)
     modelPar_type,
     modelPar_given_type,
     modelPar_VBICtype,
     modelPar_qbm,
     modelPar_given_qbm// model variables
     ,
     // reals
     modelVar_tiniK,
     modelVar_Iikr,
     modelVar_Iikp,
     modelVar_Ihrcf,
     modelVar_Ivtf,
     modelVar_Iitf,
     modelVar_sltf,
     modelVar_VmaxExp,
     modelVar_gminMod,
     modelVar_imaxMod,
     in.admsTemperature,in.adms_vt_nom,in.getDeviceOptions().gmin,in);


  // Now call  the function that does the heavy lifting.
  evaluateModelEquations(
     probeVars,
     // probe constants
     in.admsProbeID_V_xf2_GND,
     in.admsProbeID_V_xf1_GND,
     in.admsProbeID_V_s_si,
     in.admsProbeID_V_bx_si,
     in.admsProbeID_V_si_bp,
     in.admsProbeID_V_bp_cx,
     in.admsProbeID_V_e_ei,
     in.admsProbeID_V_bx_bi,
     in.admsProbeID_V_b_bx,
     in.admsProbeID_V_cx_ci,
     in.admsProbeID_V_c_cx,
     in.admsProbeID_V_b_c,
     in.admsProbeID_V_b_e,
     in.admsProbeID_V_bx_bp,
     in.admsProbeID_V_ci_ei,
     in.admsProbeID_V_bx_cx,
     in.admsProbeID_V_bi_cx,
     in.admsProbeID_V_bi_ci,
     in.admsProbeID_V_bx_ei,
     in.admsProbeID_V_bi_ei,
     in.admsProbeID_Temp_dt_GND,

     // node constants
     in.admsNodeID_c,
     in.admsNodeID_b,
     in.admsNodeID_e,
     in.admsNodeID_s,
     in.admsNodeID_dt,
     in.admsNodeID_cx,
     in.admsNodeID_ci,
     in.admsNodeID_bx,
     in.admsNodeID_bi,
     in.admsNodeID_ei,
     in.admsNodeID_bp,
     in.admsNodeID_si,
     in.admsNodeID_xf1,
     in.admsNodeID_xf2,
     // instance parameters
     // reals
     instancePar_m,
     instancePar_given_m,
     instancePar_trise,
     instancePar_given_trise,
     // non-reals(including hidden)
     instancePar_sw_noise,
     instancePar_given_sw_noise,
     instancePar_sw_et,
     instancePar_given_sw_et,
     // instance variables
     // reals
     instanceVar_is_t,
     instanceVar_isrr_t,
     instanceVar_ibei_t,
     instanceVar_ibci_t,
     instanceVar_isp_t,
     instanceVar_iben_t,
     instanceVar_ibcn_t,
     instanceVar_ibeip_t,
     instanceVar_ibenp_t,
     instanceVar_ibcip_t,
     instanceVar_ibcnp_t,
     instanceVar_tdevC,
     instanceVar_tdevK,
     instanceVar_rT,
     instanceVar_Gcx,
     instanceVar_Gci,
     instanceVar_Gbx,
     instanceVar_Gbi,
     instanceVar_Ge,
     instanceVar_Gbp,
     instanceVar_Gs,
     instanceVar_maxvIfi,
     instanceVar_maxvIri,
     instanceVar_maxvIp,
     instanceVar_maxvIbbe,
     instanceVar_maxvIbei,
     instanceVar_maxvIben,
     instanceVar_maxvIbci,
     instanceVar_maxvIbcn,
     instanceVar_maxvIbeip,
     instanceVar_maxvIbenp,
     instanceVar_maxvIbcip,
     instanceVar_maxvIbcnp,
     instanceVar_vtv,
     instanceVar_Itzf,
     instanceVar_qb,
     instanceVar_Iccp,
     instanceVar_qbp,
     instanceVar_Ibe,
     instanceVar_Ibex,
     instanceVar_Ibep,
     instanceVar_Irci,
     instanceVar_Vrci,
     instanceVar_mMod,
     instanceVar_tVCrit,
     // model parameters
     // reals
     modelPar_npn,
     modelPar_given_npn,
     modelPar_pnp,
     modelPar_given_pnp,
     modelPar_scale,
     modelPar_given_scale,
     modelPar_shrink,
     modelPar_given_shrink,
     modelPar_tmin,
     modelPar_given_tmin,
     modelPar_tmax,
     modelPar_given_tmax,
     modelPar_gmin,
     modelPar_given_gmin,
     modelPar_pnjmaxi,
     modelPar_given_pnjmaxi,
     modelPar_maxexp,
     modelPar_given_maxexp,
     modelPar_tnom,
     modelPar_given_tnom,
     modelPar_tminclip,
     modelPar_given_tminclip,
     modelPar_tmaxclip,
     modelPar_given_tmaxclip,
     modelPar_rcx,
     modelPar_given_rcx,
     modelPar_rci,
     modelPar_given_rci,
     modelPar_vo,
     modelPar_given_vo,
     modelPar_gamm,
     modelPar_given_gamm,
     modelPar_hrcf,
     modelPar_given_hrcf,
     modelPar_rbx,
     modelPar_given_rbx,
     modelPar_rbi,
     modelPar_given_rbi,
     modelPar_re,
     modelPar_given_re,
     modelPar_rs,
     modelPar_given_rs,
     modelPar_rbp,
     modelPar_given_rbp,
     modelPar_is,
     modelPar_given_is,
     modelPar_isrr,
     modelPar_given_isrr,
     modelPar_nf,
     modelPar_given_nf,
     modelPar_nr,
     modelPar_given_nr,
     modelPar_isp,
     modelPar_given_isp,
     modelPar_wsp,
     modelPar_given_wsp,
     modelPar_nfp,
     modelPar_given_nfp,
     modelPar_fc,
     modelPar_given_fc,
     modelPar_cbeo,
     modelPar_given_cbeo,
     modelPar_cje,
     modelPar_given_cje,
     modelPar_pe,
     modelPar_given_pe,
     modelPar_me,
     modelPar_given_me,
     modelPar_aje,
     modelPar_given_aje,
     modelPar_cbco,
     modelPar_given_cbco,
     modelPar_cjc,
     modelPar_given_cjc,
     modelPar_pc,
     modelPar_given_pc,
     modelPar_mc,
     modelPar_given_mc,
     modelPar_ajc,
     modelPar_given_ajc,
     modelPar_vrt,
     modelPar_given_vrt,
     modelPar_art,
     modelPar_given_art,
     modelPar_qco,
     modelPar_given_qco,
     modelPar_cjep,
     modelPar_given_cjep,
     modelPar_cjcp,
     modelPar_given_cjcp,
     modelPar_ps,
     modelPar_given_ps,
     modelPar_ms,
     modelPar_given_ms,
     modelPar_ajs,
     modelPar_given_ajs,
     modelPar_ccso,
     modelPar_given_ccso,
     modelPar_ibei,
     modelPar_given_ibei,
     modelPar_wbe,
     modelPar_given_wbe,
     modelPar_nei,
     modelPar_given_nei,
     modelPar_qnibeir,
     modelPar_given_qnibeir,
     modelPar_iben,
     modelPar_given_iben,
     modelPar_nen,
     modelPar_given_nen,
     modelPar_ibci,
     modelPar_given_ibci,
     modelPar_nci,
     modelPar_given_nci,
     modelPar_ibcn,
     modelPar_given_ibcn,
     modelPar_ncn,
     modelPar_given_ncn,
     modelPar_ibeip,
     modelPar_given_ibeip,
     modelPar_ibenp,
     modelPar_given_ibenp,
     modelPar_ibcip,
     modelPar_given_ibcip,
     modelPar_ncip,
     modelPar_given_ncip,
     modelPar_ibcnp,
     modelPar_given_ibcnp,
     modelPar_ncnp,
     modelPar_given_ncnp,
     modelPar_vef,
     modelPar_given_vef,
     modelPar_ver,
     modelPar_given_ver,
     modelPar_ikf,
     modelPar_given_ikf,
     modelPar_nkf,
     modelPar_given_nkf,
     modelPar_ikr,
     modelPar_given_ikr,
     modelPar_ikp,
     modelPar_given_ikp,
     modelPar_tf,
     modelPar_given_tf,
     modelPar_qtf,
     modelPar_given_qtf,
     modelPar_xtf,
     modelPar_given_xtf,
     modelPar_vtf,
     modelPar_given_vtf,
     modelPar_itf,
     modelPar_given_itf,
     modelPar_tr,
     modelPar_given_tr,
     modelPar_td,
     modelPar_given_td,
     modelPar_avc1,
     modelPar_given_avc1,
     modelPar_avc2,
     modelPar_given_avc2,
     modelPar_avcx1,
     modelPar_given_avcx1,
     modelPar_avcx2,
     modelPar_given_avcx2,
     modelPar_mcx,
     modelPar_given_mcx,
     modelPar_vbbe,
     modelPar_given_vbbe,
     modelPar_nbbe,
     modelPar_given_nbbe,
     modelPar_ibbe,
     modelPar_given_ibbe,
     modelPar_tvbbe1,
     modelPar_given_tvbbe1,
     modelPar_tvbbe2,
     modelPar_given_tvbbe2,
     modelPar_tnbbe,
     modelPar_given_tnbbe,
     modelPar_vpte,
     modelPar_given_vpte,
     modelPar_ibk0,
     modelPar_given_ibk0,
     modelPar_abk,
     modelPar_given_abk,
     modelPar_bbk,
     modelPar_given_bbk,
     modelPar_kfn,
     modelPar_given_kfn,
     modelPar_afn,
     modelPar_given_afn,
     modelPar_bfn,
     modelPar_given_bfn,
     modelPar_rth,
     modelPar_given_rth,
     modelPar_cth,
     modelPar_given_cth,
     modelPar_xre,
     modelPar_given_xre,
     modelPar_xrb,
     modelPar_given_xrb,
     modelPar_xrbi,
     modelPar_given_xrbi,
     modelPar_xrbx,
     modelPar_given_xrbx,
     modelPar_xrc,
     modelPar_given_xrc,
     modelPar_xrci,
     modelPar_given_xrci,
     modelPar_xrcx,
     modelPar_given_xrcx,
     modelPar_xrbp,
     modelPar_given_xrbp,
     modelPar_xrs,
     modelPar_given_xrs,
     modelPar_xvo,
     modelPar_given_xvo,
     modelPar_ea,
     modelPar_given_ea,
     modelPar_eaie,
     modelPar_given_eaie,
     modelPar_eaic,
     modelPar_given_eaic,
     modelPar_eais,
     modelPar_given_eais,
     modelPar_eane,
     modelPar_given_eane,
     modelPar_eanc,
     modelPar_given_eanc,
     modelPar_eans,
     modelPar_given_eans,
     modelPar_eap,
     modelPar_given_eap,
     modelPar_dear,
     modelPar_given_dear,
     modelPar_xis,
     modelPar_given_xis,
     modelPar_xii,
     modelPar_given_xii,
     modelPar_xin,
     modelPar_given_xin,
     modelPar_xisr,
     modelPar_given_xisr,
     modelPar_xikf,
     modelPar_given_xikf,
     modelPar_tavc,
     modelPar_given_tavc,
     modelPar_tavcx,
     modelPar_given_tavcx,
     modelPar_tnf,
     modelPar_given_tnf,
     modelPar_tcvef,
     modelPar_given_tcvef,
     modelPar_tcver,
     modelPar_given_tcver,
     modelPar_tcrth,
     modelPar_given_tcrth,
     // non-reals (including hidden)
     modelPar_type,
     modelPar_given_type,
     modelPar_VBICtype,
     modelPar_qbm,
     modelPar_given_qbm// model variables
     ,
     // reals
     modelVar_tiniK,
     modelVar_Iikr,
     modelVar_Iikp,
     modelVar_Ihrcf,
     modelVar_Ivtf,
     modelVar_Iitf,
     modelVar_sltf,
     modelVar_VmaxExp,
     modelVar_gminMod,
     modelVar_imaxMod,
     in.admsTemperature,
     in.adms_vt_nom,
     in.getDeviceOptions().gmin,
     staticContributions,
     dynamicContributions,
     in);


  // We now have the F and Q vector stuff, populate the dependencies:

  dfdp[in.admsNodeID_c] += staticContributions[in.admsNodeID_c].dx(0);
  dqdp[in.admsNodeID_c] += dynamicContributions[in.admsNodeID_c].dx(0);
  Findices[in.admsNodeID_c] = in.li_c;
  Qindices[in.admsNodeID_c] = in.li_c;
  dfdp[in.admsNodeID_b] += staticContributions[in.admsNodeID_b].dx(0);
  dqdp[in.admsNodeID_b] += dynamicContributions[in.admsNodeID_b].dx(0);
  Findices[in.admsNodeID_b] = in.li_b;
  Qindices[in.admsNodeID_b] = in.li_b;
  dfdp[in.admsNodeID_e] += staticContributions[in.admsNodeID_e].dx(0);
  dqdp[in.admsNodeID_e] += dynamicContributions[in.admsNodeID_e].dx(0);
  Findices[in.admsNodeID_e] = in.li_e;
  Qindices[in.admsNodeID_e] = in.li_e;
  dfdp[in.admsNodeID_s] += staticContributions[in.admsNodeID_s].dx(0);
  dqdp[in.admsNodeID_s] += dynamicContributions[in.admsNodeID_s].dx(0);
  Findices[in.admsNodeID_s] = in.li_s;
  Qindices[in.admsNodeID_s] = in.li_s;
  dfdp[in.admsNodeID_dt] += staticContributions[in.admsNodeID_dt].dx(0);
  dqdp[in.admsNodeID_dt] += dynamicContributions[in.admsNodeID_dt].dx(0);
  Findices[in.admsNodeID_dt] = in.li_dt;
  Qindices[in.admsNodeID_dt] = in.li_dt;
  dfdp[in.admsNodeID_cx] += staticContributions[in.admsNodeID_cx].dx(0);
  dqdp[in.admsNodeID_cx] += dynamicContributions[in.admsNodeID_cx].dx(0);
  Findices[in.admsNodeID_cx] = in.li_cx;
  Qindices[in.admsNodeID_cx] = in.li_cx;
  dfdp[in.admsNodeID_ci] += staticContributions[in.admsNodeID_ci].dx(0);
  dqdp[in.admsNodeID_ci] += dynamicContributions[in.admsNodeID_ci].dx(0);
  Findices[in.admsNodeID_ci] = in.li_ci;
  Qindices[in.admsNodeID_ci] = in.li_ci;
  dfdp[in.admsNodeID_bx] += staticContributions[in.admsNodeID_bx].dx(0);
  dqdp[in.admsNodeID_bx] += dynamicContributions[in.admsNodeID_bx].dx(0);
  Findices[in.admsNodeID_bx] = in.li_bx;
  Qindices[in.admsNodeID_bx] = in.li_bx;
  dfdp[in.admsNodeID_bi] += staticContributions[in.admsNodeID_bi].dx(0);
  dqdp[in.admsNodeID_bi] += dynamicContributions[in.admsNodeID_bi].dx(0);
  Findices[in.admsNodeID_bi] = in.li_bi;
  Qindices[in.admsNodeID_bi] = in.li_bi;
  dfdp[in.admsNodeID_ei] += staticContributions[in.admsNodeID_ei].dx(0);
  dqdp[in.admsNodeID_ei] += dynamicContributions[in.admsNodeID_ei].dx(0);
  Findices[in.admsNodeID_ei] = in.li_ei;
  Qindices[in.admsNodeID_ei] = in.li_ei;
  dfdp[in.admsNodeID_bp] += staticContributions[in.admsNodeID_bp].dx(0);
  dqdp[in.admsNodeID_bp] += dynamicContributions[in.admsNodeID_bp].dx(0);
  Findices[in.admsNodeID_bp] = in.li_bp;
  Qindices[in.admsNodeID_bp] = in.li_bp;
  dfdp[in.admsNodeID_si] += staticContributions[in.admsNodeID_si].dx(0);
  dqdp[in.admsNodeID_si] += dynamicContributions[in.admsNodeID_si].dx(0);
  Findices[in.admsNodeID_si] = in.li_si;
  Qindices[in.admsNodeID_si] = in.li_si;
  dfdp[in.admsNodeID_xf1] += staticContributions[in.admsNodeID_xf1].dx(0);
  dqdp[in.admsNodeID_xf1] += dynamicContributions[in.admsNodeID_xf1].dx(0);
  Findices[in.admsNodeID_xf1] = in.li_xf1;
  Qindices[in.admsNodeID_xf1] = in.li_xf1;
  dfdp[in.admsNodeID_xf2] += staticContributions[in.admsNodeID_xf2].dx(0);
  dqdp[in.admsNodeID_xf2] += dynamicContributions[in.admsNodeID_xf2].dx(0);
  Findices[in.admsNodeID_xf2] = in.li_xf2;
  Qindices[in.admsNodeID_xf2] = in.li_xf2;


}

//-----------------------------------------------------------------------------
// Function      : ModelSensitivity::operator()
// Purpose       : return sensitivity for a single model parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
/// Compute sensitivity to a specified model
/// parameter of all device instances of that model's outputs
/// 
/// 
/// @param[in] entity  The device entity that owns the parameter 
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
/// 
/// 
void ModelSensitivity::operator()
  (
     const ParameterBase &entity,
     const std::string &name,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
   ) const
{
  const ParameterBase * e1 = &entity;
  const Model & mod = *(dynamic_cast<const Model *> (e1));
  int sizeInstance = mod.instanceContainer.size();

  dfdp.resize((14+0)*sizeInstance);
  dqdp.resize((14+0)*sizeInstance);
  Findices.resize((14+0)*sizeInstance);
  Qindices.resize((14+0)*sizeInstance);

  std::vector <double> probeVars(21);
  std::vector <AdmsSensFadType> staticContributions(14+0);
  std::vector <AdmsSensFadType> dynamicContributions(14+0);


  // Copy out all the model parameters (doubles) into FAD types
  // Keep a map so we can set the right one to the independent variable
  // We do this solely to avoid a big ugly "if/else" block just to find the
  // one parameter we're doing sensitivities on.
  unordered_map <std::string,AdmsSensFadType*,HashNoCase,EqualNoCase> modParamMap;

  // reals
  AdmsSensFadType modelPar_npn=mod.npn;
  bool modelPar_given_npn=mod.given("npn");
  modParamMap["npn"] = &modelPar_npn;
  AdmsSensFadType modelPar_pnp=mod.pnp;
  bool modelPar_given_pnp=mod.given("pnp");
  modParamMap["pnp"] = &modelPar_pnp;
  AdmsSensFadType modelPar_scale=mod.scale;
  bool modelPar_given_scale=mod.given("scale");
  modParamMap["scale"] = &modelPar_scale;
  AdmsSensFadType modelPar_shrink=mod.shrink;
  bool modelPar_given_shrink=mod.given("shrink");
  modParamMap["shrink"] = &modelPar_shrink;
  AdmsSensFadType modelPar_tmin=mod.tmin;
  bool modelPar_given_tmin=mod.given("tmin");
  modParamMap["tmin"] = &modelPar_tmin;
  AdmsSensFadType modelPar_tmax=mod.tmax;
  bool modelPar_given_tmax=mod.given("tmax");
  modParamMap["tmax"] = &modelPar_tmax;
  AdmsSensFadType modelPar_gmin=mod.gmin;
  bool modelPar_given_gmin=mod.given("gmin");
  modParamMap["gmin"] = &modelPar_gmin;
  AdmsSensFadType modelPar_pnjmaxi=mod.pnjmaxi;
  bool modelPar_given_pnjmaxi=mod.given("pnjmaxi");
  modParamMap["pnjmaxi"] = &modelPar_pnjmaxi;
  AdmsSensFadType modelPar_maxexp=mod.maxexp;
  bool modelPar_given_maxexp=mod.given("maxexp");
  modParamMap["maxexp"] = &modelPar_maxexp;
  AdmsSensFadType modelPar_tnom=mod.tnom;
  bool modelPar_given_tnom=mod.given("tnom");
  modParamMap["tnom"] = &modelPar_tnom;
  AdmsSensFadType modelPar_tminclip=mod.tminclip;
  bool modelPar_given_tminclip=mod.given("tminclip");
  modParamMap["tminclip"] = &modelPar_tminclip;
  AdmsSensFadType modelPar_tmaxclip=mod.tmaxclip;
  bool modelPar_given_tmaxclip=mod.given("tmaxclip");
  modParamMap["tmaxclip"] = &modelPar_tmaxclip;
  AdmsSensFadType modelPar_rcx=mod.rcx;
  bool modelPar_given_rcx=mod.given("rcx");
  modParamMap["rcx"] = &modelPar_rcx;
  AdmsSensFadType modelPar_rci=mod.rci;
  bool modelPar_given_rci=mod.given("rci");
  modParamMap["rci"] = &modelPar_rci;
  AdmsSensFadType modelPar_vo=mod.vo;
  bool modelPar_given_vo=mod.given("vo");
  modParamMap["vo"] = &modelPar_vo;
  AdmsSensFadType modelPar_gamm=mod.gamm;
  bool modelPar_given_gamm=mod.given("gamm");
  modParamMap["gamm"] = &modelPar_gamm;
  AdmsSensFadType modelPar_hrcf=mod.hrcf;
  bool modelPar_given_hrcf=mod.given("hrcf");
  modParamMap["hrcf"] = &modelPar_hrcf;
  AdmsSensFadType modelPar_rbx=mod.rbx;
  bool modelPar_given_rbx=mod.given("rbx");
  modParamMap["rbx"] = &modelPar_rbx;
  AdmsSensFadType modelPar_rbi=mod.rbi;
  bool modelPar_given_rbi=mod.given("rbi");
  modParamMap["rbi"] = &modelPar_rbi;
  AdmsSensFadType modelPar_re=mod.re;
  bool modelPar_given_re=mod.given("re");
  modParamMap["re"] = &modelPar_re;
  AdmsSensFadType modelPar_rs=mod.rs;
  bool modelPar_given_rs=mod.given("rs");
  modParamMap["rs"] = &modelPar_rs;
  AdmsSensFadType modelPar_rbp=mod.rbp;
  bool modelPar_given_rbp=mod.given("rbp");
  modParamMap["rbp"] = &modelPar_rbp;
  AdmsSensFadType modelPar_is=mod.is;
  bool modelPar_given_is=mod.given("is");
  modParamMap["is"] = &modelPar_is;
  AdmsSensFadType modelPar_isrr=mod.isrr;
  bool modelPar_given_isrr=mod.given("isrr");
  modParamMap["isrr"] = &modelPar_isrr;
  AdmsSensFadType modelPar_nf=mod.nf;
  bool modelPar_given_nf=mod.given("nf");
  modParamMap["nf"] = &modelPar_nf;
  AdmsSensFadType modelPar_nr=mod.nr;
  bool modelPar_given_nr=mod.given("nr");
  modParamMap["nr"] = &modelPar_nr;
  AdmsSensFadType modelPar_isp=mod.isp;
  bool modelPar_given_isp=mod.given("isp");
  modParamMap["isp"] = &modelPar_isp;
  AdmsSensFadType modelPar_wsp=mod.wsp;
  bool modelPar_given_wsp=mod.given("wsp");
  modParamMap["wsp"] = &modelPar_wsp;
  AdmsSensFadType modelPar_nfp=mod.nfp;
  bool modelPar_given_nfp=mod.given("nfp");
  modParamMap["nfp"] = &modelPar_nfp;
  AdmsSensFadType modelPar_fc=mod.fc;
  bool modelPar_given_fc=mod.given("fc");
  modParamMap["fc"] = &modelPar_fc;
  AdmsSensFadType modelPar_cbeo=mod.cbeo;
  bool modelPar_given_cbeo=mod.given("cbeo");
  modParamMap["cbeo"] = &modelPar_cbeo;
  AdmsSensFadType modelPar_cje=mod.cje;
  bool modelPar_given_cje=mod.given("cje");
  modParamMap["cje"] = &modelPar_cje;
  AdmsSensFadType modelPar_pe=mod.pe;
  bool modelPar_given_pe=mod.given("pe");
  modParamMap["pe"] = &modelPar_pe;
  AdmsSensFadType modelPar_me=mod.me;
  bool modelPar_given_me=mod.given("me");
  modParamMap["me"] = &modelPar_me;
  AdmsSensFadType modelPar_aje=mod.aje;
  bool modelPar_given_aje=mod.given("aje");
  modParamMap["aje"] = &modelPar_aje;
  AdmsSensFadType modelPar_cbco=mod.cbco;
  bool modelPar_given_cbco=mod.given("cbco");
  modParamMap["cbco"] = &modelPar_cbco;
  AdmsSensFadType modelPar_cjc=mod.cjc;
  bool modelPar_given_cjc=mod.given("cjc");
  modParamMap["cjc"] = &modelPar_cjc;
  AdmsSensFadType modelPar_pc=mod.pc;
  bool modelPar_given_pc=mod.given("pc");
  modParamMap["pc"] = &modelPar_pc;
  AdmsSensFadType modelPar_mc=mod.mc;
  bool modelPar_given_mc=mod.given("mc");
  modParamMap["mc"] = &modelPar_mc;
  AdmsSensFadType modelPar_ajc=mod.ajc;
  bool modelPar_given_ajc=mod.given("ajc");
  modParamMap["ajc"] = &modelPar_ajc;
  AdmsSensFadType modelPar_vrt=mod.vrt;
  bool modelPar_given_vrt=mod.given("vrt");
  modParamMap["vrt"] = &modelPar_vrt;
  AdmsSensFadType modelPar_art=mod.art;
  bool modelPar_given_art=mod.given("art");
  modParamMap["art"] = &modelPar_art;
  AdmsSensFadType modelPar_qco=mod.qco;
  bool modelPar_given_qco=mod.given("qco");
  modParamMap["qco"] = &modelPar_qco;
  AdmsSensFadType modelPar_cjep=mod.cjep;
  bool modelPar_given_cjep=mod.given("cjep");
  modParamMap["cjep"] = &modelPar_cjep;
  AdmsSensFadType modelPar_cjcp=mod.cjcp;
  bool modelPar_given_cjcp=mod.given("cjcp");
  modParamMap["cjcp"] = &modelPar_cjcp;
  AdmsSensFadType modelPar_ps=mod.ps;
  bool modelPar_given_ps=mod.given("ps");
  modParamMap["ps"] = &modelPar_ps;
  AdmsSensFadType modelPar_ms=mod.ms;
  bool modelPar_given_ms=mod.given("ms");
  modParamMap["ms"] = &modelPar_ms;
  AdmsSensFadType modelPar_ajs=mod.ajs;
  bool modelPar_given_ajs=mod.given("ajs");
  modParamMap["ajs"] = &modelPar_ajs;
  AdmsSensFadType modelPar_ccso=mod.ccso;
  bool modelPar_given_ccso=mod.given("ccso");
  modParamMap["ccso"] = &modelPar_ccso;
  AdmsSensFadType modelPar_ibei=mod.ibei;
  bool modelPar_given_ibei=mod.given("ibei");
  modParamMap["ibei"] = &modelPar_ibei;
  AdmsSensFadType modelPar_wbe=mod.wbe;
  bool modelPar_given_wbe=mod.given("wbe");
  modParamMap["wbe"] = &modelPar_wbe;
  AdmsSensFadType modelPar_nei=mod.nei;
  bool modelPar_given_nei=mod.given("nei");
  modParamMap["nei"] = &modelPar_nei;
  AdmsSensFadType modelPar_qnibeir=mod.qnibeir;
  bool modelPar_given_qnibeir=mod.given("qnibeir");
  modParamMap["qnibeir"] = &modelPar_qnibeir;
  AdmsSensFadType modelPar_iben=mod.iben;
  bool modelPar_given_iben=mod.given("iben");
  modParamMap["iben"] = &modelPar_iben;
  AdmsSensFadType modelPar_nen=mod.nen;
  bool modelPar_given_nen=mod.given("nen");
  modParamMap["nen"] = &modelPar_nen;
  AdmsSensFadType modelPar_ibci=mod.ibci;
  bool modelPar_given_ibci=mod.given("ibci");
  modParamMap["ibci"] = &modelPar_ibci;
  AdmsSensFadType modelPar_nci=mod.nci;
  bool modelPar_given_nci=mod.given("nci");
  modParamMap["nci"] = &modelPar_nci;
  AdmsSensFadType modelPar_ibcn=mod.ibcn;
  bool modelPar_given_ibcn=mod.given("ibcn");
  modParamMap["ibcn"] = &modelPar_ibcn;
  AdmsSensFadType modelPar_ncn=mod.ncn;
  bool modelPar_given_ncn=mod.given("ncn");
  modParamMap["ncn"] = &modelPar_ncn;
  AdmsSensFadType modelPar_ibeip=mod.ibeip;
  bool modelPar_given_ibeip=mod.given("ibeip");
  modParamMap["ibeip"] = &modelPar_ibeip;
  AdmsSensFadType modelPar_ibenp=mod.ibenp;
  bool modelPar_given_ibenp=mod.given("ibenp");
  modParamMap["ibenp"] = &modelPar_ibenp;
  AdmsSensFadType modelPar_ibcip=mod.ibcip;
  bool modelPar_given_ibcip=mod.given("ibcip");
  modParamMap["ibcip"] = &modelPar_ibcip;
  AdmsSensFadType modelPar_ncip=mod.ncip;
  bool modelPar_given_ncip=mod.given("ncip");
  modParamMap["ncip"] = &modelPar_ncip;
  AdmsSensFadType modelPar_ibcnp=mod.ibcnp;
  bool modelPar_given_ibcnp=mod.given("ibcnp");
  modParamMap["ibcnp"] = &modelPar_ibcnp;
  AdmsSensFadType modelPar_ncnp=mod.ncnp;
  bool modelPar_given_ncnp=mod.given("ncnp");
  modParamMap["ncnp"] = &modelPar_ncnp;
  AdmsSensFadType modelPar_vef=mod.vef;
  bool modelPar_given_vef=mod.given("vef");
  modParamMap["vef"] = &modelPar_vef;
  AdmsSensFadType modelPar_ver=mod.ver;
  bool modelPar_given_ver=mod.given("ver");
  modParamMap["ver"] = &modelPar_ver;
  AdmsSensFadType modelPar_ikf=mod.ikf;
  bool modelPar_given_ikf=mod.given("ikf");
  modParamMap["ikf"] = &modelPar_ikf;
  AdmsSensFadType modelPar_nkf=mod.nkf;
  bool modelPar_given_nkf=mod.given("nkf");
  modParamMap["nkf"] = &modelPar_nkf;
  AdmsSensFadType modelPar_ikr=mod.ikr;
  bool modelPar_given_ikr=mod.given("ikr");
  modParamMap["ikr"] = &modelPar_ikr;
  AdmsSensFadType modelPar_ikp=mod.ikp;
  bool modelPar_given_ikp=mod.given("ikp");
  modParamMap["ikp"] = &modelPar_ikp;
  AdmsSensFadType modelPar_tf=mod.tf;
  bool modelPar_given_tf=mod.given("tf");
  modParamMap["tf"] = &modelPar_tf;
  AdmsSensFadType modelPar_qtf=mod.qtf;
  bool modelPar_given_qtf=mod.given("qtf");
  modParamMap["qtf"] = &modelPar_qtf;
  AdmsSensFadType modelPar_xtf=mod.xtf;
  bool modelPar_given_xtf=mod.given("xtf");
  modParamMap["xtf"] = &modelPar_xtf;
  AdmsSensFadType modelPar_vtf=mod.vtf;
  bool modelPar_given_vtf=mod.given("vtf");
  modParamMap["vtf"] = &modelPar_vtf;
  AdmsSensFadType modelPar_itf=mod.itf;
  bool modelPar_given_itf=mod.given("itf");
  modParamMap["itf"] = &modelPar_itf;
  AdmsSensFadType modelPar_tr=mod.tr;
  bool modelPar_given_tr=mod.given("tr");
  modParamMap["tr"] = &modelPar_tr;
  AdmsSensFadType modelPar_td=mod.td;
  bool modelPar_given_td=mod.given("td");
  modParamMap["td"] = &modelPar_td;
  AdmsSensFadType modelPar_avc1=mod.avc1;
  bool modelPar_given_avc1=mod.given("avc1");
  modParamMap["avc1"] = &modelPar_avc1;
  AdmsSensFadType modelPar_avc2=mod.avc2;
  bool modelPar_given_avc2=mod.given("avc2");
  modParamMap["avc2"] = &modelPar_avc2;
  AdmsSensFadType modelPar_avcx1=mod.avcx1;
  bool modelPar_given_avcx1=mod.given("avcx1");
  modParamMap["avcx1"] = &modelPar_avcx1;
  AdmsSensFadType modelPar_avcx2=mod.avcx2;
  bool modelPar_given_avcx2=mod.given("avcx2");
  modParamMap["avcx2"] = &modelPar_avcx2;
  AdmsSensFadType modelPar_mcx=mod.mcx;
  bool modelPar_given_mcx=mod.given("mcx");
  modParamMap["mcx"] = &modelPar_mcx;
  AdmsSensFadType modelPar_vbbe=mod.vbbe;
  bool modelPar_given_vbbe=mod.given("vbbe");
  modParamMap["vbbe"] = &modelPar_vbbe;
  AdmsSensFadType modelPar_nbbe=mod.nbbe;
  bool modelPar_given_nbbe=mod.given("nbbe");
  modParamMap["nbbe"] = &modelPar_nbbe;
  AdmsSensFadType modelPar_ibbe=mod.ibbe;
  bool modelPar_given_ibbe=mod.given("ibbe");
  modParamMap["ibbe"] = &modelPar_ibbe;
  AdmsSensFadType modelPar_tvbbe1=mod.tvbbe1;
  bool modelPar_given_tvbbe1=mod.given("tvbbe1");
  modParamMap["tvbbe1"] = &modelPar_tvbbe1;
  AdmsSensFadType modelPar_tvbbe2=mod.tvbbe2;
  bool modelPar_given_tvbbe2=mod.given("tvbbe2");
  modParamMap["tvbbe2"] = &modelPar_tvbbe2;
  AdmsSensFadType modelPar_tnbbe=mod.tnbbe;
  bool modelPar_given_tnbbe=mod.given("tnbbe");
  modParamMap["tnbbe"] = &modelPar_tnbbe;
  AdmsSensFadType modelPar_vpte=mod.vpte;
  bool modelPar_given_vpte=mod.given("vpte");
  modParamMap["vpte"] = &modelPar_vpte;
  AdmsSensFadType modelPar_ibk0=mod.ibk0;
  bool modelPar_given_ibk0=mod.given("ibk0");
  modParamMap["ibk0"] = &modelPar_ibk0;
  AdmsSensFadType modelPar_abk=mod.abk;
  bool modelPar_given_abk=mod.given("abk");
  modParamMap["abk"] = &modelPar_abk;
  AdmsSensFadType modelPar_bbk=mod.bbk;
  bool modelPar_given_bbk=mod.given("bbk");
  modParamMap["bbk"] = &modelPar_bbk;
  AdmsSensFadType modelPar_kfn=mod.kfn;
  bool modelPar_given_kfn=mod.given("kfn");
  modParamMap["kfn"] = &modelPar_kfn;
  AdmsSensFadType modelPar_afn=mod.afn;
  bool modelPar_given_afn=mod.given("afn");
  modParamMap["afn"] = &modelPar_afn;
  AdmsSensFadType modelPar_bfn=mod.bfn;
  bool modelPar_given_bfn=mod.given("bfn");
  modParamMap["bfn"] = &modelPar_bfn;
  AdmsSensFadType modelPar_rth=mod.rth;
  bool modelPar_given_rth=mod.given("rth");
  modParamMap["rth"] = &modelPar_rth;
  AdmsSensFadType modelPar_cth=mod.cth;
  bool modelPar_given_cth=mod.given("cth");
  modParamMap["cth"] = &modelPar_cth;
  AdmsSensFadType modelPar_xre=mod.xre;
  bool modelPar_given_xre=mod.given("xre");
  modParamMap["xre"] = &modelPar_xre;
  AdmsSensFadType modelPar_xrb=mod.xrb;
  bool modelPar_given_xrb=mod.given("xrb");
  modParamMap["xrb"] = &modelPar_xrb;
  AdmsSensFadType modelPar_xrbi=mod.xrbi;
  bool modelPar_given_xrbi=mod.given("xrbi");
  modParamMap["xrbi"] = &modelPar_xrbi;
  AdmsSensFadType modelPar_xrbx=mod.xrbx;
  bool modelPar_given_xrbx=mod.given("xrbx");
  modParamMap["xrbx"] = &modelPar_xrbx;
  AdmsSensFadType modelPar_xrc=mod.xrc;
  bool modelPar_given_xrc=mod.given("xrc");
  modParamMap["xrc"] = &modelPar_xrc;
  AdmsSensFadType modelPar_xrci=mod.xrci;
  bool modelPar_given_xrci=mod.given("xrci");
  modParamMap["xrci"] = &modelPar_xrci;
  AdmsSensFadType modelPar_xrcx=mod.xrcx;
  bool modelPar_given_xrcx=mod.given("xrcx");
  modParamMap["xrcx"] = &modelPar_xrcx;
  AdmsSensFadType modelPar_xrbp=mod.xrbp;
  bool modelPar_given_xrbp=mod.given("xrbp");
  modParamMap["xrbp"] = &modelPar_xrbp;
  AdmsSensFadType modelPar_xrs=mod.xrs;
  bool modelPar_given_xrs=mod.given("xrs");
  modParamMap["xrs"] = &modelPar_xrs;
  AdmsSensFadType modelPar_xvo=mod.xvo;
  bool modelPar_given_xvo=mod.given("xvo");
  modParamMap["xvo"] = &modelPar_xvo;
  AdmsSensFadType modelPar_ea=mod.ea;
  bool modelPar_given_ea=mod.given("ea");
  modParamMap["ea"] = &modelPar_ea;
  AdmsSensFadType modelPar_eaie=mod.eaie;
  bool modelPar_given_eaie=mod.given("eaie");
  modParamMap["eaie"] = &modelPar_eaie;
  AdmsSensFadType modelPar_eaic=mod.eaic;
  bool modelPar_given_eaic=mod.given("eaic");
  modParamMap["eaic"] = &modelPar_eaic;
  AdmsSensFadType modelPar_eais=mod.eais;
  bool modelPar_given_eais=mod.given("eais");
  modParamMap["eais"] = &modelPar_eais;
  AdmsSensFadType modelPar_eane=mod.eane;
  bool modelPar_given_eane=mod.given("eane");
  modParamMap["eane"] = &modelPar_eane;
  AdmsSensFadType modelPar_eanc=mod.eanc;
  bool modelPar_given_eanc=mod.given("eanc");
  modParamMap["eanc"] = &modelPar_eanc;
  AdmsSensFadType modelPar_eans=mod.eans;
  bool modelPar_given_eans=mod.given("eans");
  modParamMap["eans"] = &modelPar_eans;
  AdmsSensFadType modelPar_eap=mod.eap;
  bool modelPar_given_eap=mod.given("eap");
  modParamMap["eap"] = &modelPar_eap;
  AdmsSensFadType modelPar_dear=mod.dear;
  bool modelPar_given_dear=mod.given("dear");
  modParamMap["dear"] = &modelPar_dear;
  AdmsSensFadType modelPar_xis=mod.xis;
  bool modelPar_given_xis=mod.given("xis");
  modParamMap["xis"] = &modelPar_xis;
  AdmsSensFadType modelPar_xii=mod.xii;
  bool modelPar_given_xii=mod.given("xii");
  modParamMap["xii"] = &modelPar_xii;
  AdmsSensFadType modelPar_xin=mod.xin;
  bool modelPar_given_xin=mod.given("xin");
  modParamMap["xin"] = &modelPar_xin;
  AdmsSensFadType modelPar_xisr=mod.xisr;
  bool modelPar_given_xisr=mod.given("xisr");
  modParamMap["xisr"] = &modelPar_xisr;
  AdmsSensFadType modelPar_xikf=mod.xikf;
  bool modelPar_given_xikf=mod.given("xikf");
  modParamMap["xikf"] = &modelPar_xikf;
  AdmsSensFadType modelPar_tavc=mod.tavc;
  bool modelPar_given_tavc=mod.given("tavc");
  modParamMap["tavc"] = &modelPar_tavc;
  AdmsSensFadType modelPar_tavcx=mod.tavcx;
  bool modelPar_given_tavcx=mod.given("tavcx");
  modParamMap["tavcx"] = &modelPar_tavcx;
  AdmsSensFadType modelPar_tnf=mod.tnf;
  bool modelPar_given_tnf=mod.given("tnf");
  modParamMap["tnf"] = &modelPar_tnf;
  AdmsSensFadType modelPar_tcvef=mod.tcvef;
  bool modelPar_given_tcvef=mod.given("tcvef");
  modParamMap["tcvef"] = &modelPar_tcvef;
  AdmsSensFadType modelPar_tcver=mod.tcver;
  bool modelPar_given_tcver=mod.given("tcver");
  modParamMap["tcver"] = &modelPar_tcver;
  AdmsSensFadType modelPar_tcrth=mod.tcrth;
  bool modelPar_given_tcrth=mod.given("tcrth");
  modParamMap["tcrth"] = &modelPar_tcrth;


  // hidden reals


  // non-reals (including hiddens)
  int modelPar_type=mod.type;
  bool modelPar_given_type=mod.given("type");
  int modelPar_VBICtype=mod.VBICtype;
  int modelPar_qbm=mod.qbm;
  bool modelPar_given_qbm=mod.given("qbm");


  // Set the one parameter whose name was passed in to be the independent
  // variable for Sacado purposes.  Since we stored variable pointers, this
  // makes sure that that ONE variable gets set right.
  // FIXME: make this check name for presence first!  Segfault on invalid.
  modParamMap[name]->diff(0,1);

  //make local copies of all model vars
  //reals
  AdmsSensFadType modelVar_tiniK=mod.tiniK;
  AdmsSensFadType modelVar_Iikr=mod.Iikr;
  AdmsSensFadType modelVar_Iikp=mod.Iikp;
  AdmsSensFadType modelVar_Ihrcf=mod.Ihrcf;
  AdmsSensFadType modelVar_Ivtf=mod.Ivtf;
  AdmsSensFadType modelVar_Iitf=mod.Iitf;
  AdmsSensFadType modelVar_sltf=mod.sltf;
  AdmsSensFadType modelVar_VmaxExp=mod.VmaxExp;
  AdmsSensFadType modelVar_gminMod=mod.gminMod;
  AdmsSensFadType modelVar_imaxMod=mod.imaxMod;


  // non-reals



  // Now loop over all instances and do the deed
  int inst=0;
  for (std::vector<Instance*>::const_iterator in_it=mod.instanceContainer.begin(); in_it != mod.instanceContainer.end(); ++in_it,++inst)
  {

    Instance & in=*(*in_it);
    // initialize contributions to zero (automatically sets derivatives to zero)
    for (int i=0; i < 14+0 ; ++i)
    {
      staticContributions[i]=0;
      dynamicContributions[i]=0;
    }



    // Copy out all the instance parameters (doubles) into FAD types
    // reals
    AdmsSensFadType instancePar_m=in.m;
    bool instancePar_given_m=in.given("m");
    AdmsSensFadType instancePar_trise=in.trise;
    bool instancePar_given_trise=in.given("trise");


    // real hidden instance


    // Copy all the non-real instance params into vars of their appropriate type:
    int instancePar_sw_noise=in.sw_noise;
    bool instancePar_given_sw_noise=in.given("sw_noise");
    int instancePar_sw_et=in.sw_et;
    bool instancePar_given_sw_et=in.given("sw_et");




    // If there are any instance parameters that were not given, and have
    // corresponding model params, copy the model param into the instance.
    // This was already done by the instance constructor, but we do it again
    // because now we're propagating derivatives, and the user could be trying
    // to get sensitivity to the model parameter.
  

    //make local copies of all instance vars
    //reals
    AdmsSensFadType instanceVar_is_t=in.is_t;
    AdmsSensFadType instanceVar_isrr_t=in.isrr_t;
    AdmsSensFadType instanceVar_ibei_t=in.ibei_t;
    AdmsSensFadType instanceVar_ibci_t=in.ibci_t;
    AdmsSensFadType instanceVar_isp_t=in.isp_t;
    AdmsSensFadType instanceVar_iben_t=in.iben_t;
    AdmsSensFadType instanceVar_ibcn_t=in.ibcn_t;
    AdmsSensFadType instanceVar_ibeip_t=in.ibeip_t;
    AdmsSensFadType instanceVar_ibenp_t=in.ibenp_t;
    AdmsSensFadType instanceVar_ibcip_t=in.ibcip_t;
    AdmsSensFadType instanceVar_ibcnp_t=in.ibcnp_t;
    AdmsSensFadType instanceVar_tdevC=in.tdevC;
    AdmsSensFadType instanceVar_tdevK=in.tdevK;
    AdmsSensFadType instanceVar_rT=in.rT;
    AdmsSensFadType instanceVar_Gcx=in.Gcx;
    AdmsSensFadType instanceVar_Gci=in.Gci;
    AdmsSensFadType instanceVar_Gbx=in.Gbx;
    AdmsSensFadType instanceVar_Gbi=in.Gbi;
    AdmsSensFadType instanceVar_Ge=in.Ge;
    AdmsSensFadType instanceVar_Gbp=in.Gbp;
    AdmsSensFadType instanceVar_Gs=in.Gs;
    AdmsSensFadType instanceVar_maxvIfi=in.maxvIfi;
    AdmsSensFadType instanceVar_maxvIri=in.maxvIri;
    AdmsSensFadType instanceVar_maxvIp=in.maxvIp;
    AdmsSensFadType instanceVar_maxvIbbe=in.maxvIbbe;
    AdmsSensFadType instanceVar_maxvIbei=in.maxvIbei;
    AdmsSensFadType instanceVar_maxvIben=in.maxvIben;
    AdmsSensFadType instanceVar_maxvIbci=in.maxvIbci;
    AdmsSensFadType instanceVar_maxvIbcn=in.maxvIbcn;
    AdmsSensFadType instanceVar_maxvIbeip=in.maxvIbeip;
    AdmsSensFadType instanceVar_maxvIbenp=in.maxvIbenp;
    AdmsSensFadType instanceVar_maxvIbcip=in.maxvIbcip;
    AdmsSensFadType instanceVar_maxvIbcnp=in.maxvIbcnp;
    AdmsSensFadType instanceVar_vtv=in.vtv;
    AdmsSensFadType instanceVar_Itzf=in.Itzf;
    AdmsSensFadType instanceVar_qb=in.qb;
    AdmsSensFadType instanceVar_Iccp=in.Iccp;
    AdmsSensFadType instanceVar_qbp=in.qbp;
    AdmsSensFadType instanceVar_Ibe=in.Ibe;
    AdmsSensFadType instanceVar_Ibex=in.Ibex;
    AdmsSensFadType instanceVar_Ibep=in.Ibep;
    AdmsSensFadType instanceVar_Irci=in.Irci;
    AdmsSensFadType instanceVar_Vrci=in.Vrci;
    AdmsSensFadType instanceVar_mMod=in.mMod;
    AdmsSensFadType instanceVar_tVCrit=in.tVCrit;

  
    //non-reals
  
  
  
    Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

    // extract solution variables and set as Fad independent variables.
    probeVars[in.admsProbeID_V_xf2_GND] = (*solVectorPtr)[in.li_xf2];
    probeVars[in.admsProbeID_V_xf1_GND] = (*solVectorPtr)[in.li_xf1];
    probeVars[in.admsProbeID_V_s_si] = (*solVectorPtr)[in.li_s] - (*solVectorPtr)[in.li_si];
    probeVars[in.admsProbeID_V_bx_si] = (*solVectorPtr)[in.li_bx] - (*solVectorPtr)[in.li_si];
    probeVars[in.admsProbeID_V_si_bp] = (*solVectorPtr)[in.li_si] - (*solVectorPtr)[in.li_bp];
    probeVars[in.admsProbeID_V_bp_cx] = (*solVectorPtr)[in.li_bp] - (*solVectorPtr)[in.li_cx];
    probeVars[in.admsProbeID_V_e_ei] = (*solVectorPtr)[in.li_e] - (*solVectorPtr)[in.li_ei];
    probeVars[in.admsProbeID_V_bx_bi] = (*solVectorPtr)[in.li_bx] - (*solVectorPtr)[in.li_bi];
    probeVars[in.admsProbeID_V_b_bx] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_bx];
    probeVars[in.admsProbeID_V_cx_ci] = (*solVectorPtr)[in.li_cx] - (*solVectorPtr)[in.li_ci];
    probeVars[in.admsProbeID_V_c_cx] = (*solVectorPtr)[in.li_c] - (*solVectorPtr)[in.li_cx];
    probeVars[in.admsProbeID_V_b_c] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_c];
    probeVars[in.admsProbeID_V_b_e] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_e];
    probeVars[in.admsProbeID_V_bx_bp] = (*solVectorPtr)[in.li_bx] - (*solVectorPtr)[in.li_bp];
    probeVars[in.admsProbeID_V_ci_ei] = (*solVectorPtr)[in.li_ci] - (*solVectorPtr)[in.li_ei];
    probeVars[in.admsProbeID_V_bx_cx] = (*solVectorPtr)[in.li_bx] - (*solVectorPtr)[in.li_cx];
    probeVars[in.admsProbeID_V_bi_cx] = (*solVectorPtr)[in.li_bi] - (*solVectorPtr)[in.li_cx];
    probeVars[in.admsProbeID_V_bi_ci] = (*solVectorPtr)[in.li_bi] - (*solVectorPtr)[in.li_ci];
    probeVars[in.admsProbeID_V_bx_ei] = (*solVectorPtr)[in.li_bx] - (*solVectorPtr)[in.li_ei];
    probeVars[in.admsProbeID_V_bi_ei] = (*solVectorPtr)[in.li_bi] - (*solVectorPtr)[in.li_ei];
    probeVars[in.admsProbeID_Temp_dt_GND] = (*solVectorPtr)[in.li_dt];

    
    // pre-multiply any "typed" probes (i.e. those limited with "typedpnjlim")
    probeVars[in.admsProbeID_V_bx_bp] *= modelPar_VBICtype;
    probeVars[in.admsProbeID_V_bx_cx] *= modelPar_VBICtype;
    probeVars[in.admsProbeID_V_bi_cx] *= modelPar_VBICtype;
    probeVars[in.admsProbeID_V_bi_ci] *= modelPar_VBICtype;
    probeVars[in.admsProbeID_V_bx_ei] *= modelPar_VBICtype;
    probeVars[in.admsProbeID_V_bi_ei] *= modelPar_VBICtype;



    // Need to use processParams-like function to process the
    // initial_model block with the LOCAL copies of
    //  model vars, and local copies of model
    // params.
    evaluateInitialModel(
       // model parameters
       // reals
       modelPar_npn,
       modelPar_given_npn,
       modelPar_pnp,
       modelPar_given_pnp,
       modelPar_scale,
       modelPar_given_scale,
       modelPar_shrink,
       modelPar_given_shrink,
       modelPar_tmin,
       modelPar_given_tmin,
       modelPar_tmax,
       modelPar_given_tmax,
       modelPar_gmin,
       modelPar_given_gmin,
       modelPar_pnjmaxi,
       modelPar_given_pnjmaxi,
       modelPar_maxexp,
       modelPar_given_maxexp,
       modelPar_tnom,
       modelPar_given_tnom,
       modelPar_tminclip,
       modelPar_given_tminclip,
       modelPar_tmaxclip,
       modelPar_given_tmaxclip,
       modelPar_rcx,
       modelPar_given_rcx,
       modelPar_rci,
       modelPar_given_rci,
       modelPar_vo,
       modelPar_given_vo,
       modelPar_gamm,
       modelPar_given_gamm,
       modelPar_hrcf,
       modelPar_given_hrcf,
       modelPar_rbx,
       modelPar_given_rbx,
       modelPar_rbi,
       modelPar_given_rbi,
       modelPar_re,
       modelPar_given_re,
       modelPar_rs,
       modelPar_given_rs,
       modelPar_rbp,
       modelPar_given_rbp,
       modelPar_is,
       modelPar_given_is,
       modelPar_isrr,
       modelPar_given_isrr,
       modelPar_nf,
       modelPar_given_nf,
       modelPar_nr,
       modelPar_given_nr,
       modelPar_isp,
       modelPar_given_isp,
       modelPar_wsp,
       modelPar_given_wsp,
       modelPar_nfp,
       modelPar_given_nfp,
       modelPar_fc,
       modelPar_given_fc,
       modelPar_cbeo,
       modelPar_given_cbeo,
       modelPar_cje,
       modelPar_given_cje,
       modelPar_pe,
       modelPar_given_pe,
       modelPar_me,
       modelPar_given_me,
       modelPar_aje,
       modelPar_given_aje,
       modelPar_cbco,
       modelPar_given_cbco,
       modelPar_cjc,
       modelPar_given_cjc,
       modelPar_pc,
       modelPar_given_pc,
       modelPar_mc,
       modelPar_given_mc,
       modelPar_ajc,
       modelPar_given_ajc,
       modelPar_vrt,
       modelPar_given_vrt,
       modelPar_art,
       modelPar_given_art,
       modelPar_qco,
       modelPar_given_qco,
       modelPar_cjep,
       modelPar_given_cjep,
       modelPar_cjcp,
       modelPar_given_cjcp,
       modelPar_ps,
       modelPar_given_ps,
       modelPar_ms,
       modelPar_given_ms,
       modelPar_ajs,
       modelPar_given_ajs,
       modelPar_ccso,
       modelPar_given_ccso,
       modelPar_ibei,
       modelPar_given_ibei,
       modelPar_wbe,
       modelPar_given_wbe,
       modelPar_nei,
       modelPar_given_nei,
       modelPar_qnibeir,
       modelPar_given_qnibeir,
       modelPar_iben,
       modelPar_given_iben,
       modelPar_nen,
       modelPar_given_nen,
       modelPar_ibci,
       modelPar_given_ibci,
       modelPar_nci,
       modelPar_given_nci,
       modelPar_ibcn,
       modelPar_given_ibcn,
       modelPar_ncn,
       modelPar_given_ncn,
       modelPar_ibeip,
       modelPar_given_ibeip,
       modelPar_ibenp,
       modelPar_given_ibenp,
       modelPar_ibcip,
       modelPar_given_ibcip,
       modelPar_ncip,
       modelPar_given_ncip,
       modelPar_ibcnp,
       modelPar_given_ibcnp,
       modelPar_ncnp,
       modelPar_given_ncnp,
       modelPar_vef,
       modelPar_given_vef,
       modelPar_ver,
       modelPar_given_ver,
       modelPar_ikf,
       modelPar_given_ikf,
       modelPar_nkf,
       modelPar_given_nkf,
       modelPar_ikr,
       modelPar_given_ikr,
       modelPar_ikp,
       modelPar_given_ikp,
       modelPar_tf,
       modelPar_given_tf,
       modelPar_qtf,
       modelPar_given_qtf,
       modelPar_xtf,
       modelPar_given_xtf,
       modelPar_vtf,
       modelPar_given_vtf,
       modelPar_itf,
       modelPar_given_itf,
       modelPar_tr,
       modelPar_given_tr,
       modelPar_td,
       modelPar_given_td,
       modelPar_avc1,
       modelPar_given_avc1,
       modelPar_avc2,
       modelPar_given_avc2,
       modelPar_avcx1,
       modelPar_given_avcx1,
       modelPar_avcx2,
       modelPar_given_avcx2,
       modelPar_mcx,
       modelPar_given_mcx,
       modelPar_vbbe,
       modelPar_given_vbbe,
       modelPar_nbbe,
       modelPar_given_nbbe,
       modelPar_ibbe,
       modelPar_given_ibbe,
       modelPar_tvbbe1,
       modelPar_given_tvbbe1,
       modelPar_tvbbe2,
       modelPar_given_tvbbe2,
       modelPar_tnbbe,
       modelPar_given_tnbbe,
       modelPar_vpte,
       modelPar_given_vpte,
       modelPar_ibk0,
       modelPar_given_ibk0,
       modelPar_abk,
       modelPar_given_abk,
       modelPar_bbk,
       modelPar_given_bbk,
       modelPar_kfn,
       modelPar_given_kfn,
       modelPar_afn,
       modelPar_given_afn,
       modelPar_bfn,
       modelPar_given_bfn,
       modelPar_rth,
       modelPar_given_rth,
       modelPar_cth,
       modelPar_given_cth,
       modelPar_xre,
       modelPar_given_xre,
       modelPar_xrb,
       modelPar_given_xrb,
       modelPar_xrbi,
       modelPar_given_xrbi,
       modelPar_xrbx,
       modelPar_given_xrbx,
       modelPar_xrc,
       modelPar_given_xrc,
       modelPar_xrci,
       modelPar_given_xrci,
       modelPar_xrcx,
       modelPar_given_xrcx,
       modelPar_xrbp,
       modelPar_given_xrbp,
       modelPar_xrs,
       modelPar_given_xrs,
       modelPar_xvo,
       modelPar_given_xvo,
       modelPar_ea,
       modelPar_given_ea,
       modelPar_eaie,
       modelPar_given_eaie,
       modelPar_eaic,
       modelPar_given_eaic,
       modelPar_eais,
       modelPar_given_eais,
       modelPar_eane,
       modelPar_given_eane,
       modelPar_eanc,
       modelPar_given_eanc,
       modelPar_eans,
       modelPar_given_eans,
       modelPar_eap,
       modelPar_given_eap,
       modelPar_dear,
       modelPar_given_dear,
       modelPar_xis,
       modelPar_given_xis,
       modelPar_xii,
       modelPar_given_xii,
       modelPar_xin,
       modelPar_given_xin,
       modelPar_xisr,
       modelPar_given_xisr,
       modelPar_xikf,
       modelPar_given_xikf,
       modelPar_tavc,
       modelPar_given_tavc,
       modelPar_tavcx,
       modelPar_given_tavcx,
       modelPar_tnf,
       modelPar_given_tnf,
       modelPar_tcvef,
       modelPar_given_tcvef,
       modelPar_tcver,
       modelPar_given_tcver,
       modelPar_tcrth,
       modelPar_given_tcrth,
       // non-reals (including hidden)
       modelPar_type,
       modelPar_given_type,
       modelPar_VBICtype,
       modelPar_qbm,
       modelPar_given_qbm// model variables
       ,
       // reals
       modelVar_tiniK,
       modelVar_Iikr,
       modelVar_Iikp,
       modelVar_Ihrcf,
       modelVar_Ivtf,
       modelVar_Iitf,
       modelVar_sltf,
       modelVar_VmaxExp,
       modelVar_gminMod,
       modelVar_imaxMod,
       mod.admsModTemp,in.getDeviceOptions().gmin,in);
    evaluateInitialInstance(
       // instance parameters
       // reals
       instancePar_m,
       instancePar_given_m,
       instancePar_trise,
       instancePar_given_trise,
       // non-reals(including hidden)
       instancePar_sw_noise,
       instancePar_given_sw_noise,
       instancePar_sw_et,
       instancePar_given_sw_et,
       // instance variables
       // reals
       instanceVar_is_t,
       instanceVar_isrr_t,
       instanceVar_ibei_t,
       instanceVar_ibci_t,
       instanceVar_isp_t,
       instanceVar_iben_t,
       instanceVar_ibcn_t,
       instanceVar_ibeip_t,
       instanceVar_ibenp_t,
       instanceVar_ibcip_t,
       instanceVar_ibcnp_t,
       instanceVar_tdevC,
       instanceVar_tdevK,
       instanceVar_rT,
       instanceVar_Gcx,
       instanceVar_Gci,
       instanceVar_Gbx,
       instanceVar_Gbi,
       instanceVar_Ge,
       instanceVar_Gbp,
       instanceVar_Gs,
       instanceVar_maxvIfi,
       instanceVar_maxvIri,
       instanceVar_maxvIp,
       instanceVar_maxvIbbe,
       instanceVar_maxvIbei,
       instanceVar_maxvIben,
       instanceVar_maxvIbci,
       instanceVar_maxvIbcn,
       instanceVar_maxvIbeip,
       instanceVar_maxvIbenp,
       instanceVar_maxvIbcip,
       instanceVar_maxvIbcnp,
       instanceVar_vtv,
       instanceVar_Itzf,
       instanceVar_qb,
       instanceVar_Iccp,
       instanceVar_qbp,
       instanceVar_Ibe,
       instanceVar_Ibex,
       instanceVar_Ibep,
       instanceVar_Irci,
       instanceVar_Vrci,
       instanceVar_mMod,
       instanceVar_tVCrit,
       // model parameters
       // reals
       modelPar_npn,
       modelPar_given_npn,
       modelPar_pnp,
       modelPar_given_pnp,
       modelPar_scale,
       modelPar_given_scale,
       modelPar_shrink,
       modelPar_given_shrink,
       modelPar_tmin,
       modelPar_given_tmin,
       modelPar_tmax,
       modelPar_given_tmax,
       modelPar_gmin,
       modelPar_given_gmin,
       modelPar_pnjmaxi,
       modelPar_given_pnjmaxi,
       modelPar_maxexp,
       modelPar_given_maxexp,
       modelPar_tnom,
       modelPar_given_tnom,
       modelPar_tminclip,
       modelPar_given_tminclip,
       modelPar_tmaxclip,
       modelPar_given_tmaxclip,
       modelPar_rcx,
       modelPar_given_rcx,
       modelPar_rci,
       modelPar_given_rci,
       modelPar_vo,
       modelPar_given_vo,
       modelPar_gamm,
       modelPar_given_gamm,
       modelPar_hrcf,
       modelPar_given_hrcf,
       modelPar_rbx,
       modelPar_given_rbx,
       modelPar_rbi,
       modelPar_given_rbi,
       modelPar_re,
       modelPar_given_re,
       modelPar_rs,
       modelPar_given_rs,
       modelPar_rbp,
       modelPar_given_rbp,
       modelPar_is,
       modelPar_given_is,
       modelPar_isrr,
       modelPar_given_isrr,
       modelPar_nf,
       modelPar_given_nf,
       modelPar_nr,
       modelPar_given_nr,
       modelPar_isp,
       modelPar_given_isp,
       modelPar_wsp,
       modelPar_given_wsp,
       modelPar_nfp,
       modelPar_given_nfp,
       modelPar_fc,
       modelPar_given_fc,
       modelPar_cbeo,
       modelPar_given_cbeo,
       modelPar_cje,
       modelPar_given_cje,
       modelPar_pe,
       modelPar_given_pe,
       modelPar_me,
       modelPar_given_me,
       modelPar_aje,
       modelPar_given_aje,
       modelPar_cbco,
       modelPar_given_cbco,
       modelPar_cjc,
       modelPar_given_cjc,
       modelPar_pc,
       modelPar_given_pc,
       modelPar_mc,
       modelPar_given_mc,
       modelPar_ajc,
       modelPar_given_ajc,
       modelPar_vrt,
       modelPar_given_vrt,
       modelPar_art,
       modelPar_given_art,
       modelPar_qco,
       modelPar_given_qco,
       modelPar_cjep,
       modelPar_given_cjep,
       modelPar_cjcp,
       modelPar_given_cjcp,
       modelPar_ps,
       modelPar_given_ps,
       modelPar_ms,
       modelPar_given_ms,
       modelPar_ajs,
       modelPar_given_ajs,
       modelPar_ccso,
       modelPar_given_ccso,
       modelPar_ibei,
       modelPar_given_ibei,
       modelPar_wbe,
       modelPar_given_wbe,
       modelPar_nei,
       modelPar_given_nei,
       modelPar_qnibeir,
       modelPar_given_qnibeir,
       modelPar_iben,
       modelPar_given_iben,
       modelPar_nen,
       modelPar_given_nen,
       modelPar_ibci,
       modelPar_given_ibci,
       modelPar_nci,
       modelPar_given_nci,
       modelPar_ibcn,
       modelPar_given_ibcn,
       modelPar_ncn,
       modelPar_given_ncn,
       modelPar_ibeip,
       modelPar_given_ibeip,
       modelPar_ibenp,
       modelPar_given_ibenp,
       modelPar_ibcip,
       modelPar_given_ibcip,
       modelPar_ncip,
       modelPar_given_ncip,
       modelPar_ibcnp,
       modelPar_given_ibcnp,
       modelPar_ncnp,
       modelPar_given_ncnp,
       modelPar_vef,
       modelPar_given_vef,
       modelPar_ver,
       modelPar_given_ver,
       modelPar_ikf,
       modelPar_given_ikf,
       modelPar_nkf,
       modelPar_given_nkf,
       modelPar_ikr,
       modelPar_given_ikr,
       modelPar_ikp,
       modelPar_given_ikp,
       modelPar_tf,
       modelPar_given_tf,
       modelPar_qtf,
       modelPar_given_qtf,
       modelPar_xtf,
       modelPar_given_xtf,
       modelPar_vtf,
       modelPar_given_vtf,
       modelPar_itf,
       modelPar_given_itf,
       modelPar_tr,
       modelPar_given_tr,
       modelPar_td,
       modelPar_given_td,
       modelPar_avc1,
       modelPar_given_avc1,
       modelPar_avc2,
       modelPar_given_avc2,
       modelPar_avcx1,
       modelPar_given_avcx1,
       modelPar_avcx2,
       modelPar_given_avcx2,
       modelPar_mcx,
       modelPar_given_mcx,
       modelPar_vbbe,
       modelPar_given_vbbe,
       modelPar_nbbe,
       modelPar_given_nbbe,
       modelPar_ibbe,
       modelPar_given_ibbe,
       modelPar_tvbbe1,
       modelPar_given_tvbbe1,
       modelPar_tvbbe2,
       modelPar_given_tvbbe2,
       modelPar_tnbbe,
       modelPar_given_tnbbe,
       modelPar_vpte,
       modelPar_given_vpte,
       modelPar_ibk0,
       modelPar_given_ibk0,
       modelPar_abk,
       modelPar_given_abk,
       modelPar_bbk,
       modelPar_given_bbk,
       modelPar_kfn,
       modelPar_given_kfn,
       modelPar_afn,
       modelPar_given_afn,
       modelPar_bfn,
       modelPar_given_bfn,
       modelPar_rth,
       modelPar_given_rth,
       modelPar_cth,
       modelPar_given_cth,
       modelPar_xre,
       modelPar_given_xre,
       modelPar_xrb,
       modelPar_given_xrb,
       modelPar_xrbi,
       modelPar_given_xrbi,
       modelPar_xrbx,
       modelPar_given_xrbx,
       modelPar_xrc,
       modelPar_given_xrc,
       modelPar_xrci,
       modelPar_given_xrci,
       modelPar_xrcx,
       modelPar_given_xrcx,
       modelPar_xrbp,
       modelPar_given_xrbp,
       modelPar_xrs,
       modelPar_given_xrs,
       modelPar_xvo,
       modelPar_given_xvo,
       modelPar_ea,
       modelPar_given_ea,
       modelPar_eaie,
       modelPar_given_eaie,
       modelPar_eaic,
       modelPar_given_eaic,
       modelPar_eais,
       modelPar_given_eais,
       modelPar_eane,
       modelPar_given_eane,
       modelPar_eanc,
       modelPar_given_eanc,
       modelPar_eans,
       modelPar_given_eans,
       modelPar_eap,
       modelPar_given_eap,
       modelPar_dear,
       modelPar_given_dear,
       modelPar_xis,
       modelPar_given_xis,
       modelPar_xii,
       modelPar_given_xii,
       modelPar_xin,
       modelPar_given_xin,
       modelPar_xisr,
       modelPar_given_xisr,
       modelPar_xikf,
       modelPar_given_xikf,
       modelPar_tavc,
       modelPar_given_tavc,
       modelPar_tavcx,
       modelPar_given_tavcx,
       modelPar_tnf,
       modelPar_given_tnf,
       modelPar_tcvef,
       modelPar_given_tcvef,
       modelPar_tcver,
       modelPar_given_tcver,
       modelPar_tcrth,
       modelPar_given_tcrth,
       // non-reals (including hidden)
       modelPar_type,
       modelPar_given_type,
       modelPar_VBICtype,
       modelPar_qbm,
       modelPar_given_qbm// model variables
       ,
       // reals
       modelVar_tiniK,
       modelVar_Iikr,
       modelVar_Iikp,
       modelVar_Ihrcf,
       modelVar_Ivtf,
       modelVar_Iitf,
       modelVar_sltf,
       modelVar_VmaxExp,
       modelVar_gminMod,
       modelVar_imaxMod,
       in.admsTemperature, in.adms_vt_nom,in.getDeviceOptions().gmin,in);


    // Now call  the function that does the heavy lifting.

    evaluateModelEquations(
       probeVars,
       // probe constants
       in.admsProbeID_V_xf2_GND,
       in.admsProbeID_V_xf1_GND,
       in.admsProbeID_V_s_si,
       in.admsProbeID_V_bx_si,
       in.admsProbeID_V_si_bp,
       in.admsProbeID_V_bp_cx,
       in.admsProbeID_V_e_ei,
       in.admsProbeID_V_bx_bi,
       in.admsProbeID_V_b_bx,
       in.admsProbeID_V_cx_ci,
       in.admsProbeID_V_c_cx,
       in.admsProbeID_V_b_c,
       in.admsProbeID_V_b_e,
       in.admsProbeID_V_bx_bp,
       in.admsProbeID_V_ci_ei,
       in.admsProbeID_V_bx_cx,
       in.admsProbeID_V_bi_cx,
       in.admsProbeID_V_bi_ci,
       in.admsProbeID_V_bx_ei,
       in.admsProbeID_V_bi_ei,
       in.admsProbeID_Temp_dt_GND,

       // node constants
       in.admsNodeID_c,
       in.admsNodeID_b,
       in.admsNodeID_e,
       in.admsNodeID_s,
       in.admsNodeID_dt,
       in.admsNodeID_cx,
       in.admsNodeID_ci,
       in.admsNodeID_bx,
       in.admsNodeID_bi,
       in.admsNodeID_ei,
       in.admsNodeID_bp,
       in.admsNodeID_si,
       in.admsNodeID_xf1,
       in.admsNodeID_xf2,
       // instance parameters
       // reals
       instancePar_m,
       instancePar_given_m,
       instancePar_trise,
       instancePar_given_trise,
       // non-reals(including hidden)
       instancePar_sw_noise,
       instancePar_given_sw_noise,
       instancePar_sw_et,
       instancePar_given_sw_et,
       // instance variables
       // reals
       instanceVar_is_t,
       instanceVar_isrr_t,
       instanceVar_ibei_t,
       instanceVar_ibci_t,
       instanceVar_isp_t,
       instanceVar_iben_t,
       instanceVar_ibcn_t,
       instanceVar_ibeip_t,
       instanceVar_ibenp_t,
       instanceVar_ibcip_t,
       instanceVar_ibcnp_t,
       instanceVar_tdevC,
       instanceVar_tdevK,
       instanceVar_rT,
       instanceVar_Gcx,
       instanceVar_Gci,
       instanceVar_Gbx,
       instanceVar_Gbi,
       instanceVar_Ge,
       instanceVar_Gbp,
       instanceVar_Gs,
       instanceVar_maxvIfi,
       instanceVar_maxvIri,
       instanceVar_maxvIp,
       instanceVar_maxvIbbe,
       instanceVar_maxvIbei,
       instanceVar_maxvIben,
       instanceVar_maxvIbci,
       instanceVar_maxvIbcn,
       instanceVar_maxvIbeip,
       instanceVar_maxvIbenp,
       instanceVar_maxvIbcip,
       instanceVar_maxvIbcnp,
       instanceVar_vtv,
       instanceVar_Itzf,
       instanceVar_qb,
       instanceVar_Iccp,
       instanceVar_qbp,
       instanceVar_Ibe,
       instanceVar_Ibex,
       instanceVar_Ibep,
       instanceVar_Irci,
       instanceVar_Vrci,
       instanceVar_mMod,
       instanceVar_tVCrit,
       // model parameters
       // reals
       modelPar_npn,
       modelPar_given_npn,
       modelPar_pnp,
       modelPar_given_pnp,
       modelPar_scale,
       modelPar_given_scale,
       modelPar_shrink,
       modelPar_given_shrink,
       modelPar_tmin,
       modelPar_given_tmin,
       modelPar_tmax,
       modelPar_given_tmax,
       modelPar_gmin,
       modelPar_given_gmin,
       modelPar_pnjmaxi,
       modelPar_given_pnjmaxi,
       modelPar_maxexp,
       modelPar_given_maxexp,
       modelPar_tnom,
       modelPar_given_tnom,
       modelPar_tminclip,
       modelPar_given_tminclip,
       modelPar_tmaxclip,
       modelPar_given_tmaxclip,
       modelPar_rcx,
       modelPar_given_rcx,
       modelPar_rci,
       modelPar_given_rci,
       modelPar_vo,
       modelPar_given_vo,
       modelPar_gamm,
       modelPar_given_gamm,
       modelPar_hrcf,
       modelPar_given_hrcf,
       modelPar_rbx,
       modelPar_given_rbx,
       modelPar_rbi,
       modelPar_given_rbi,
       modelPar_re,
       modelPar_given_re,
       modelPar_rs,
       modelPar_given_rs,
       modelPar_rbp,
       modelPar_given_rbp,
       modelPar_is,
       modelPar_given_is,
       modelPar_isrr,
       modelPar_given_isrr,
       modelPar_nf,
       modelPar_given_nf,
       modelPar_nr,
       modelPar_given_nr,
       modelPar_isp,
       modelPar_given_isp,
       modelPar_wsp,
       modelPar_given_wsp,
       modelPar_nfp,
       modelPar_given_nfp,
       modelPar_fc,
       modelPar_given_fc,
       modelPar_cbeo,
       modelPar_given_cbeo,
       modelPar_cje,
       modelPar_given_cje,
       modelPar_pe,
       modelPar_given_pe,
       modelPar_me,
       modelPar_given_me,
       modelPar_aje,
       modelPar_given_aje,
       modelPar_cbco,
       modelPar_given_cbco,
       modelPar_cjc,
       modelPar_given_cjc,
       modelPar_pc,
       modelPar_given_pc,
       modelPar_mc,
       modelPar_given_mc,
       modelPar_ajc,
       modelPar_given_ajc,
       modelPar_vrt,
       modelPar_given_vrt,
       modelPar_art,
       modelPar_given_art,
       modelPar_qco,
       modelPar_given_qco,
       modelPar_cjep,
       modelPar_given_cjep,
       modelPar_cjcp,
       modelPar_given_cjcp,
       modelPar_ps,
       modelPar_given_ps,
       modelPar_ms,
       modelPar_given_ms,
       modelPar_ajs,
       modelPar_given_ajs,
       modelPar_ccso,
       modelPar_given_ccso,
       modelPar_ibei,
       modelPar_given_ibei,
       modelPar_wbe,
       modelPar_given_wbe,
       modelPar_nei,
       modelPar_given_nei,
       modelPar_qnibeir,
       modelPar_given_qnibeir,
       modelPar_iben,
       modelPar_given_iben,
       modelPar_nen,
       modelPar_given_nen,
       modelPar_ibci,
       modelPar_given_ibci,
       modelPar_nci,
       modelPar_given_nci,
       modelPar_ibcn,
       modelPar_given_ibcn,
       modelPar_ncn,
       modelPar_given_ncn,
       modelPar_ibeip,
       modelPar_given_ibeip,
       modelPar_ibenp,
       modelPar_given_ibenp,
       modelPar_ibcip,
       modelPar_given_ibcip,
       modelPar_ncip,
       modelPar_given_ncip,
       modelPar_ibcnp,
       modelPar_given_ibcnp,
       modelPar_ncnp,
       modelPar_given_ncnp,
       modelPar_vef,
       modelPar_given_vef,
       modelPar_ver,
       modelPar_given_ver,
       modelPar_ikf,
       modelPar_given_ikf,
       modelPar_nkf,
       modelPar_given_nkf,
       modelPar_ikr,
       modelPar_given_ikr,
       modelPar_ikp,
       modelPar_given_ikp,
       modelPar_tf,
       modelPar_given_tf,
       modelPar_qtf,
       modelPar_given_qtf,
       modelPar_xtf,
       modelPar_given_xtf,
       modelPar_vtf,
       modelPar_given_vtf,
       modelPar_itf,
       modelPar_given_itf,
       modelPar_tr,
       modelPar_given_tr,
       modelPar_td,
       modelPar_given_td,
       modelPar_avc1,
       modelPar_given_avc1,
       modelPar_avc2,
       modelPar_given_avc2,
       modelPar_avcx1,
       modelPar_given_avcx1,
       modelPar_avcx2,
       modelPar_given_avcx2,
       modelPar_mcx,
       modelPar_given_mcx,
       modelPar_vbbe,
       modelPar_given_vbbe,
       modelPar_nbbe,
       modelPar_given_nbbe,
       modelPar_ibbe,
       modelPar_given_ibbe,
       modelPar_tvbbe1,
       modelPar_given_tvbbe1,
       modelPar_tvbbe2,
       modelPar_given_tvbbe2,
       modelPar_tnbbe,
       modelPar_given_tnbbe,
       modelPar_vpte,
       modelPar_given_vpte,
       modelPar_ibk0,
       modelPar_given_ibk0,
       modelPar_abk,
       modelPar_given_abk,
       modelPar_bbk,
       modelPar_given_bbk,
       modelPar_kfn,
       modelPar_given_kfn,
       modelPar_afn,
       modelPar_given_afn,
       modelPar_bfn,
       modelPar_given_bfn,
       modelPar_rth,
       modelPar_given_rth,
       modelPar_cth,
       modelPar_given_cth,
       modelPar_xre,
       modelPar_given_xre,
       modelPar_xrb,
       modelPar_given_xrb,
       modelPar_xrbi,
       modelPar_given_xrbi,
       modelPar_xrbx,
       modelPar_given_xrbx,
       modelPar_xrc,
       modelPar_given_xrc,
       modelPar_xrci,
       modelPar_given_xrci,
       modelPar_xrcx,
       modelPar_given_xrcx,
       modelPar_xrbp,
       modelPar_given_xrbp,
       modelPar_xrs,
       modelPar_given_xrs,
       modelPar_xvo,
       modelPar_given_xvo,
       modelPar_ea,
       modelPar_given_ea,
       modelPar_eaie,
       modelPar_given_eaie,
       modelPar_eaic,
       modelPar_given_eaic,
       modelPar_eais,
       modelPar_given_eais,
       modelPar_eane,
       modelPar_given_eane,
       modelPar_eanc,
       modelPar_given_eanc,
       modelPar_eans,
       modelPar_given_eans,
       modelPar_eap,
       modelPar_given_eap,
       modelPar_dear,
       modelPar_given_dear,
       modelPar_xis,
       modelPar_given_xis,
       modelPar_xii,
       modelPar_given_xii,
       modelPar_xin,
       modelPar_given_xin,
       modelPar_xisr,
       modelPar_given_xisr,
       modelPar_xikf,
       modelPar_given_xikf,
       modelPar_tavc,
       modelPar_given_tavc,
       modelPar_tavcx,
       modelPar_given_tavcx,
       modelPar_tnf,
       modelPar_given_tnf,
       modelPar_tcvef,
       modelPar_given_tcvef,
       modelPar_tcver,
       modelPar_given_tcver,
       modelPar_tcrth,
       modelPar_given_tcrth,
       // non-reals (including hidden)
       modelPar_type,
       modelPar_given_type,
       modelPar_VBICtype,
       modelPar_qbm,
       modelPar_given_qbm// model variables
       ,
       // reals
       modelVar_tiniK,
       modelVar_Iikr,
       modelVar_Iikp,
       modelVar_Ihrcf,
       modelVar_Ivtf,
       modelVar_Iitf,
       modelVar_sltf,
       modelVar_VmaxExp,
       modelVar_gminMod,
       modelVar_imaxMod,
       in.admsTemperature,
       in.adms_vt_nom,
       in.getDeviceOptions().gmin,
       staticContributions,
       dynamicContributions,
       in);

  
    // We now have the F and Q vector stuff, populate the dependencies:
  
    dfdp[in.admsNodeID_c+inst*(14+0)] += staticContributions[in.admsNodeID_c].dx(0);
    dqdp[in.admsNodeID_c+inst*(14+0)] += dynamicContributions[in.admsNodeID_c].dx(0);
    Findices[in.admsNodeID_c+inst*(14+0)] = in.li_c;
    Qindices[in.admsNodeID_c+inst*(14+0)] = in.li_c;
    dfdp[in.admsNodeID_b+inst*(14+0)] += staticContributions[in.admsNodeID_b].dx(0);
    dqdp[in.admsNodeID_b+inst*(14+0)] += dynamicContributions[in.admsNodeID_b].dx(0);
    Findices[in.admsNodeID_b+inst*(14+0)] = in.li_b;
    Qindices[in.admsNodeID_b+inst*(14+0)] = in.li_b;
    dfdp[in.admsNodeID_e+inst*(14+0)] += staticContributions[in.admsNodeID_e].dx(0);
    dqdp[in.admsNodeID_e+inst*(14+0)] += dynamicContributions[in.admsNodeID_e].dx(0);
    Findices[in.admsNodeID_e+inst*(14+0)] = in.li_e;
    Qindices[in.admsNodeID_e+inst*(14+0)] = in.li_e;
    dfdp[in.admsNodeID_s+inst*(14+0)] += staticContributions[in.admsNodeID_s].dx(0);
    dqdp[in.admsNodeID_s+inst*(14+0)] += dynamicContributions[in.admsNodeID_s].dx(0);
    Findices[in.admsNodeID_s+inst*(14+0)] = in.li_s;
    Qindices[in.admsNodeID_s+inst*(14+0)] = in.li_s;
    dfdp[in.admsNodeID_dt+inst*(14+0)] += staticContributions[in.admsNodeID_dt].dx(0);
    dqdp[in.admsNodeID_dt+inst*(14+0)] += dynamicContributions[in.admsNodeID_dt].dx(0);
    Findices[in.admsNodeID_dt+inst*(14+0)] = in.li_dt;
    Qindices[in.admsNodeID_dt+inst*(14+0)] = in.li_dt;
    dfdp[in.admsNodeID_cx+inst*(14+0)] += staticContributions[in.admsNodeID_cx].dx(0);
    dqdp[in.admsNodeID_cx+inst*(14+0)] += dynamicContributions[in.admsNodeID_cx].dx(0);
    Findices[in.admsNodeID_cx+inst*(14+0)] = in.li_cx;
    Qindices[in.admsNodeID_cx+inst*(14+0)] = in.li_cx;
    dfdp[in.admsNodeID_ci+inst*(14+0)] += staticContributions[in.admsNodeID_ci].dx(0);
    dqdp[in.admsNodeID_ci+inst*(14+0)] += dynamicContributions[in.admsNodeID_ci].dx(0);
    Findices[in.admsNodeID_ci+inst*(14+0)] = in.li_ci;
    Qindices[in.admsNodeID_ci+inst*(14+0)] = in.li_ci;
    dfdp[in.admsNodeID_bx+inst*(14+0)] += staticContributions[in.admsNodeID_bx].dx(0);
    dqdp[in.admsNodeID_bx+inst*(14+0)] += dynamicContributions[in.admsNodeID_bx].dx(0);
    Findices[in.admsNodeID_bx+inst*(14+0)] = in.li_bx;
    Qindices[in.admsNodeID_bx+inst*(14+0)] = in.li_bx;
    dfdp[in.admsNodeID_bi+inst*(14+0)] += staticContributions[in.admsNodeID_bi].dx(0);
    dqdp[in.admsNodeID_bi+inst*(14+0)] += dynamicContributions[in.admsNodeID_bi].dx(0);
    Findices[in.admsNodeID_bi+inst*(14+0)] = in.li_bi;
    Qindices[in.admsNodeID_bi+inst*(14+0)] = in.li_bi;
    dfdp[in.admsNodeID_ei+inst*(14+0)] += staticContributions[in.admsNodeID_ei].dx(0);
    dqdp[in.admsNodeID_ei+inst*(14+0)] += dynamicContributions[in.admsNodeID_ei].dx(0);
    Findices[in.admsNodeID_ei+inst*(14+0)] = in.li_ei;
    Qindices[in.admsNodeID_ei+inst*(14+0)] = in.li_ei;
    dfdp[in.admsNodeID_bp+inst*(14+0)] += staticContributions[in.admsNodeID_bp].dx(0);
    dqdp[in.admsNodeID_bp+inst*(14+0)] += dynamicContributions[in.admsNodeID_bp].dx(0);
    Findices[in.admsNodeID_bp+inst*(14+0)] = in.li_bp;
    Qindices[in.admsNodeID_bp+inst*(14+0)] = in.li_bp;
    dfdp[in.admsNodeID_si+inst*(14+0)] += staticContributions[in.admsNodeID_si].dx(0);
    dqdp[in.admsNodeID_si+inst*(14+0)] += dynamicContributions[in.admsNodeID_si].dx(0);
    Findices[in.admsNodeID_si+inst*(14+0)] = in.li_si;
    Qindices[in.admsNodeID_si+inst*(14+0)] = in.li_si;
    dfdp[in.admsNodeID_xf1+inst*(14+0)] += staticContributions[in.admsNodeID_xf1].dx(0);
    dqdp[in.admsNodeID_xf1+inst*(14+0)] += dynamicContributions[in.admsNodeID_xf1].dx(0);
    Findices[in.admsNodeID_xf1+inst*(14+0)] = in.li_xf1;
    Qindices[in.admsNodeID_xf1+inst*(14+0)] = in.li_xf1;
    dfdp[in.admsNodeID_xf2+inst*(14+0)] += staticContributions[in.admsNodeID_xf2].dx(0);
    dqdp[in.admsNodeID_xf2+inst*(14+0)] += dynamicContributions[in.admsNodeID_xf2].dx(0);
    Findices[in.admsNodeID_xf2+inst*(14+0)] = in.li_xf2;
    Qindices[in.admsNodeID_xf2+inst*(14+0)] = in.li_xf2;
  }

}

#endif // Xyce_ADMS_SENSITIVITIES

} // namespace ADMSvbic13_4t
} // namespace Device
} // namespace Xyce
